fof(mp_greater_transitivity,axiom,
    ! [X,Y,Z] :
      ( greater(X,Z)
     <= ( greater(X,Y)
        & greater(Y,Z) ) ) ).

fof(mp1_high_growth_rates,axiom,
    ! [E,S1,S2,T] :
      ( selection_favors(S2,S1,T)
     <= ( greater(growth_rate(S2,T),growth_rate(S1,T))
        & subpopulations(S1,S2,E,T)
        & environment(E) ) ) ).

fof(mp_subpopulations,axiom,
    ! [E,T] :
      ( ( in_environment(E,T)
        & environment(E) )
     => ( subpopulation(first_movers,E,T)
        & subpopulation(efficient_producers,E,T) ) ) ).

fof(t6,hypothesis,
    ! [E,T] :
      ( greater(cardinality_at_time(efficient_producers,T),zero)
     <= ( greater_or_equal(T,appear(efficient_producers,E))
        & in_environment(E,T)
        & environment(E) ) ) ).

fof(mp_first_movers_exist,axiom,
    ! [E,T] :
      ( ( in_environment(E,T)
        & environment(E) )
     => greater_or_equal(cardinality_at_time(first_movers,T),zero) ) ).

fof(d1,hypothesis,
    ! [E,Tc] :
      ( ( ! [T] :
            ( greater(growth_rate(efficient_producers,T),growth_rate(first_movers,T))
           <= ( subpopulations(first_movers,efficient_producers,E,T)
              & greater(T,Tc) ) )
        & ~ greater(growth_rate(efficient_producers,Tc),growth_rate(first_movers,Tc)) )
     <= ( environment(E)
        & critical_point(E) = Tc ) ) ).

fof(mp_time_in_environment,axiom,
    ! [E,T] :
      ( ( greater_or_equal(end_time(E),T)
        & greater_or_equal(T,start_time(E))
        & environment(E) )
     => in_environment(E,T) ) ).

fof(mp_contains_FM_and_EP,axiom,
    ! [E,T] :
      ( subpopulations(first_movers,efficient_producers,E,T)
     <= ( environment(E)
        & greater(cardinality_at_time(first_movers,T),zero)
        & greater(cardinality_at_time(efficient_producers,T),zero)
        & in_environment(E,T) ) ) ).

fof(mp_critical_point_after_EP,axiom,
    ! [E] :
      ( environment(E)
     => greater_or_equal(critical_point(E),appear(efficient_producers,E)) ) ).

fof(mp_organizational_sets2,axiom,
    propagation_strategy(efficient_producers) ).

fof(mp_environment_end_point,axiom,
    ! [E,T] :
      ( greater_or_equal(end_time(E),T)
     <= ( environment(E)
        & in_environment(E,T) ) ) ).

fof(mp_greater_or_equal,axiom,
    ! [X,Y] :
      ( ( greater(X,Y)
        | Y = X )
    <=> greater_or_equal(X,Y) ) ).

fof(mp4_critical_point,axiom,
    ! [P] :
      ( ( observational_period(P)
        & slow_change(P) )
     => ! [E] :
          ( ? [T] :
              ( in_environment(E,T)
              & greater(T,critical_point(E)) )
         <= ( in_environment(P,E)
            & environment(E) ) ) ) ).

fof(mp_organizational_sets1,axiom,
    propagation_strategy(first_movers) ).

fof(mp_time_of_critical_point,axiom,
    ! [E] :
      ( environment(E)
     => greater_or_equal(critical_point(E),start_time(E)) ) ).

fof(mp3_favoured_trategy,axiom,
    ! [P] :
      ( selection_favors(efficient_producers,first_movers,P)
     <= ( observational_period(P)
        & propagation_strategy(first_movers)
        & ! [E] :
            ( selection_favors(efficient_producers,first_movers,end_time(E))
           <= ( in_environment(P,E)
              & environment(E) ) )
        & propagation_strategy(efficient_producers) ) ) ).

fof(prove_t8,conjecture,
    ! [P] :
      ( selection_favors(efficient_producers,first_movers,P)
     <= ( slow_change(P)
        & observational_period(P) ) ) ).

fof(mp2_favour_members,axiom,
    ! [E,S1,S2,T] :
      ( selection_favors(S1,S2,T)
     <= ( environment(E)
        & subpopulation(S1,E,T)
        & subpopulation(S2,E,T)
        & zero = cardinality_at_time(S2,T)
        & greater(cardinality_at_time(S1,T),zero) ) ) ).

fof(mp_beginning_and_ending,axiom,
    ! [E,T] :
      ( greater_or_equal(end_time(E),T)
     <= ( environment(E)
        & greater(T,start_time(E))
        & ~ greater(T,end_time(E)) ) ) ).

