fof(encrypt_equation,axiom,
    ! [E1,E2] :
      ( knows(E1)
     <= ( knows(encrypt(E1,E2))
        & knows(inverse(E2)) ) ) ).

fof(sign_axiom,axiom,
    ! [E,K] : E = extract(sign(E,inverse(K)),K) ).

fof(attack,conjecture,
    knows(secret) ).

fof(symmac_axiom,axiom,
    ! [X,Y] :
      ( knows(mac(X,Y))
     <= ( knows(Y)
        & knows(X) ) ) ).

fof(head_axiom,axiom,
    ! [X,Y] : head(concatenate(X,Y)) = X ).

fof(previous_knowledge,axiom,
    ( knows(k_ca)
    & knows(inverse(k_a))
    & knows(k_a) ) ).

fof(tail_axiom,axiom,
    ! [X,Y] : tail(concatenate(X,Y)) = Y ).

fof(symmetric_encrypt_equation,axiom,
    ! [E1,E2] :
      ( knows(E1)
     <= ( knows(symmetric_encrypt(E1,E2))
        & knows(E2) ) ) ).

fof(symmetric_decrypt_axiom,axiom,
    ! [E,K] : symmetric_decrypt(symmetric_encrypt(E,K),K) = E ).

fof(third_axiom,axiom,
    ! [X] : third(X) = head(tail(tail(X))) ).

fof(construct_message_2,axiom,
    ! [E1,E2] :
      ( knows(concatenate(E1,E2))
     => ( knows(E2)
        & knows(E1) ) ) ).

fof(construct_message_1,axiom,
    ! [E1,E2] :
      ( ( knows(concatenate(E1,E2))
        & knows(encrypt(E1,E2))
        & knows(symmetric_encrypt(E1,E2))
        & knows(symmetric_decrypt(E1,E2))
        & knows(sign(E1,E2))
        & knows(extract(E1,E2))
        & knows(decrypt(E1,E2)) )
     <= ( knows(E2)
        & knows(E1) ) ) ).

fof(protocol,axiom,
    ! [Init_1,Init_2,Init_3,Resp_1,Resp_2] :
      ( ( ( knows(Init_1)
          & knows(Init_2)
          & second(extract(Init_3,Init_2)) = Init_2
          & knows(Init_3) )
       => knows(concatenate(encrypt(sign(concatenate(kgen(Init_2),concatenate(Init_1,eol)),inverse(k_s)),Init_2),sign(concatenate(s,concatenate(k_s,eol)),inverse(k_ca)))) )
      & ( ( knows(Resp_1)
          & knows(Resp_2)
          & s = first(extract(Resp_2,k_ca))
          & second(extract(decrypt(Resp_1,inverse(k_c)),second(extract(Resp_2,k_ca)))) = n )
       => knows(symmetric_encrypt(secret,first(extract(decrypt(Resp_1,inverse(k_c)),second(extract(Resp_2,k_ca)))))) )
      & knows(concatenate(n,concatenate(k_c,sign(concatenate(c,concatenate(k_c,eol)),inverse(k_c))))) ) ).

fof(decrypt_axiom,axiom,
    ! [E,K] : E = decrypt(encrypt(E,K),inverse(K)) ).

fof(construct_message_3,axiom,
    ! [E] :
      ( ( knows(head(E))
        & knows(hash(E))
        & knows(tail(E)) )
     <= knows(E) ) ).

fof(fourth_axiom,axiom,
    ! [X] : head(tail(tail(tail(X)))) = fourth(X) ).

fof(first_axiom,axiom,
    ! [X] : head(X) = first(X) ).

fof(sign_equation,axiom,
    ! [E,K] :
      ( ( knows(K)
        & knows(sign(E,inverse(K))) )
     => knows(E) ) ).

fof(second_axiom,axiom,
    ! [X] : second(X) = head(tail(X)) ).

