%------------------------------------------------------------------------------
% File     : SLH107^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer NthRoot_Impl problem prob_267__3275916_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : NthRoot_Impl/prob_267__3275916_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  366 (   0 unit;  20 type;   0 defn)
%            Number of atoms       : 3795 ( 241 equality;2551 variable)
%            Maximal formula depth :   18 (   8 average)
%            Number of connectives : 3113 ( 146   ~;  38   |;  55   &;2205   @)
%                                         (   0 <=>; 669  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  157 ( 157   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   22 (  20   :;   0   =)
%            Number of variables   : 1157 (   0 sgn;1015   !;  88   ?;  54   ^)
%                                         (1157   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:41:18.145
%------------------------------------------------------------------------------
% Could-be-implicit typings (3)
thf(ty_n_t__Real__Oreal,type,(
    real: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

thf(ty_n_t__Int__Oint,type,(
    int: $tType )).

% Explicit typings (17)
thf(sy_c_Groups_Oone__class_Oone_001t__Nat__Onat,type,(
    one_one_nat: nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Int__Oint,type,(
    zero_zero_int: int )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Real__Oreal,type,(
    zero_zero_real: real )).

thf(sy_c_NthRoot__Impl__Mirabelle__bcfbdygymo_Ostart__value,type,(
    nthRoo1503232983_value: int > nat > int )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Int__Oint,type,(
    ord_less_int: int > int > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Real__Oreal,type,(
    ord_less_real: real > real > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Int__Oint,type,(
    ord_less_eq_int: int > int > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Real__Oreal,type,(
    ord_less_eq_real: real > real > $o )).

thf(sy_c_Power_Opower__class_Opower_001t__Int__Oint,type,(
    power_power_int: int > nat > int )).

thf(sy_c_Power_Opower__class_Opower_001t__Nat__Onat,type,(
    power_power_nat: nat > nat > nat )).

thf(sy_c_Power_Opower__class_Opower_001t__Real__Oreal,type,(
    power_power_real: real > nat > real )).

thf(sy_v_na____,type,(
    na: int )).

thf(sy_v_p,type,(
    p: nat )).

thf(sy_v_xa____,type,(
    xa: int )).

% Relevant facts (345)
thf(fact_0_not,axiom,(
    ~ ( ( ord_less_int @ xa @ zero_zero_int )
      | ( ord_less_int @ na @ zero_zero_int ) ) )).

% not
thf(fact_1_d_I3_J,axiom,(
    ~ ( ( ord_less_int @ xa @ zero_zero_int )
      | ( ord_less_int @ na @ zero_zero_int ) ) )).

% d(3)
thf(fact_2__C1_Oprems_C_I1_J,axiom,(
    ord_less_eq_int @ zero_zero_int @ xa )).

% "1.prems"(1)
thf(fact_3_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_4__C1_Oprems_C_I2_J,axiom,(
    ord_less_eq_int @ zero_zero_int @ na )).

% "1.prems"(2)
thf(fact_5_less__int__code_I1_J,axiom,(
    ~ ( ord_less_int @ zero_zero_int @ zero_zero_int ) )).

% less_int_code(1)
thf(fact_6_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_int @ zero_zero_int @ zero_zero_int ) )).

% less_numeral_extra(3)
thf(fact_7_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_nat @ zero_zero_nat @ zero_zero_nat ) )).

% less_numeral_extra(3)
thf(fact_8_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_real @ zero_zero_real @ zero_zero_real ) )).

% less_numeral_extra(3)
thf(fact_9_field__lbound__gt__zero,axiom,(
    ! [D1: real,D2: real] :
      ( ( ord_less_real @ zero_zero_real @ D1 )
     => ( ( ord_less_real @ zero_zero_real @ D2 )
       => ? [E: real] :
            ( ( ord_less_real @ zero_zero_real @ E )
            & ( ord_less_real @ E @ D1 )
            & ( ord_less_real @ E @ D2 ) ) ) ) )).

% field_lbound_gt_zero
thf(fact_10_gr__zeroI,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_zeroI
thf(fact_11_not__less__zero,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less_zero
thf(fact_12_gr__implies__not__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not_zero
thf(fact_13_zero__less__iff__neq__zero,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( N != zero_zero_nat ) ) )).

% zero_less_iff_neq_zero
thf(fact_14_zero__integer_Orsp,axiom,(
    zero_zero_int = zero_zero_int )).

% zero_integer.rsp
thf(fact_15_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_16_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_17_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_int @ zero_zero_int @ zero_zero_int )).

% le_numeral_extra(3)
thf(fact_18_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ zero_zero_nat )).

% le_numeral_extra(3)
thf(fact_19_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_real @ zero_zero_real @ zero_zero_real )).

% le_numeral_extra(3)
thf(fact_20_pinf_I6_J,axiom,(
    ! [T: int] :
    ? [Z: int] :
    ! [X2: int] :
      ( ( ord_less_int @ Z @ X2 )
     => ~ ( ord_less_eq_int @ X2 @ T ) ) )).

% pinf(6)
thf(fact_21_pinf_I6_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ Z @ X2 )
     => ~ ( ord_less_eq_nat @ X2 @ T ) ) )).

% pinf(6)
thf(fact_22_pinf_I6_J,axiom,(
    ! [T: real] :
    ? [Z: real] :
    ! [X2: real] :
      ( ( ord_less_real @ Z @ X2 )
     => ~ ( ord_less_eq_real @ X2 @ T ) ) )).

% pinf(6)
thf(fact_23_pinf_I8_J,axiom,(
    ! [T: int] :
    ? [Z: int] :
    ! [X2: int] :
      ( ( ord_less_int @ Z @ X2 )
     => ( ord_less_eq_int @ T @ X2 ) ) )).

% pinf(8)
thf(fact_24_pinf_I8_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ Z @ X2 )
     => ( ord_less_eq_nat @ T @ X2 ) ) )).

% pinf(8)
thf(fact_25_pinf_I8_J,axiom,(
    ! [T: real] :
    ? [Z: real] :
    ! [X2: real] :
      ( ( ord_less_real @ Z @ X2 )
     => ( ord_less_eq_real @ T @ X2 ) ) )).

% pinf(8)
thf(fact_26_minf_I6_J,axiom,(
    ! [T: int] :
    ? [Z: int] :
    ! [X2: int] :
      ( ( ord_less_int @ X2 @ Z )
     => ( ord_less_eq_int @ X2 @ T ) ) )).

% minf(6)
thf(fact_27_minf_I6_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ X2 @ Z )
     => ( ord_less_eq_nat @ X2 @ T ) ) )).

% minf(6)
thf(fact_28_minf_I6_J,axiom,(
    ! [T: real] :
    ? [Z: real] :
    ! [X2: real] :
      ( ( ord_less_real @ X2 @ Z )
     => ( ord_less_eq_real @ X2 @ T ) ) )).

% minf(6)
thf(fact_29_minf_I8_J,axiom,(
    ! [T: int] :
    ? [Z: int] :
    ! [X2: int] :
      ( ( ord_less_int @ X2 @ Z )
     => ~ ( ord_less_eq_int @ T @ X2 ) ) )).

% minf(8)
thf(fact_30_minf_I8_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ X2 @ Z )
     => ~ ( ord_less_eq_nat @ T @ X2 ) ) )).

% minf(8)
thf(fact_31_minf_I8_J,axiom,(
    ! [T: real] :
    ? [Z: real] :
    ! [X2: real] :
      ( ( ord_less_real @ X2 @ Z )
     => ~ ( ord_less_eq_real @ T @ X2 ) ) )).

% minf(8)
thf(fact_32_conj__le__cong,axiom,(
    ! [X: int,X3: int,P: $o,P2: $o] :
      ( ( X = X3 )
     => ( ( ( ord_less_eq_int @ zero_zero_int @ X3 )
         => ( P = P2 ) )
       => ( ( ( ord_less_eq_int @ zero_zero_int @ X )
            & P )
          = ( ( ord_less_eq_int @ zero_zero_int @ X3 )
            & P2 ) ) ) ) )).

% conj_le_cong
thf(fact_33_imp__le__cong,axiom,(
    ! [X: int,X3: int,P: $o,P2: $o] :
      ( ( X = X3 )
     => ( ( ( ord_less_eq_int @ zero_zero_int @ X3 )
         => ( P = P2 ) )
       => ( ( ( ord_less_eq_int @ zero_zero_int @ X )
           => P )
          = ( ( ord_less_eq_int @ zero_zero_int @ X3 )
           => P2 ) ) ) ) )).

% imp_le_cong
thf(fact_34_less__eq__int__code_I1_J,axiom,(
    ord_less_eq_int @ zero_zero_int @ zero_zero_int )).

% less_eq_int_code(1)
thf(fact_35_zero__reorient,axiom,(
    ! [X: int] :
      ( ( zero_zero_int = X )
      = ( X = zero_zero_int ) ) )).

% zero_reorient
thf(fact_36_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_37_zero__reorient,axiom,(
    ! [X: real] :
      ( ( zero_zero_real = X )
      = ( X = zero_zero_real ) ) )).

% zero_reorient
thf(fact_38_pinf_I1_J,axiom,(
    ! [P: int > $o,P2: int > $o,Q: int > $o,Q2: int > $o] :
      ( ? [Z2: int] :
        ! [X4: int] :
          ( ( ord_less_int @ Z2 @ X4 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z2: int] :
          ! [X4: int] :
            ( ( ord_less_int @ Z2 @ X4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z: int] :
          ! [X2: int] :
            ( ( ord_less_int @ Z @ X2 )
           => ( ( ( P @ X2 )
                & ( Q @ X2 ) )
              = ( ( P2 @ X2 )
                & ( Q2 @ X2 ) ) ) ) ) ) )).

% pinf(1)
thf(fact_39_pinf_I1_J,axiom,(
    ! [P: nat > $o,P2: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z2: nat] :
        ! [X4: nat] :
          ( ( ord_less_nat @ Z2 @ X4 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z2: nat] :
          ! [X4: nat] :
            ( ( ord_less_nat @ Z2 @ X4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ Z @ X2 )
           => ( ( ( P @ X2 )
                & ( Q @ X2 ) )
              = ( ( P2 @ X2 )
                & ( Q2 @ X2 ) ) ) ) ) ) )).

% pinf(1)
thf(fact_40_pinf_I1_J,axiom,(
    ! [P: real > $o,P2: real > $o,Q: real > $o,Q2: real > $o] :
      ( ? [Z2: real] :
        ! [X4: real] :
          ( ( ord_less_real @ Z2 @ X4 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z2: real] :
          ! [X4: real] :
            ( ( ord_less_real @ Z2 @ X4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z: real] :
          ! [X2: real] :
            ( ( ord_less_real @ Z @ X2 )
           => ( ( ( P @ X2 )
                & ( Q @ X2 ) )
              = ( ( P2 @ X2 )
                & ( Q2 @ X2 ) ) ) ) ) ) )).

% pinf(1)
thf(fact_41_pinf_I2_J,axiom,(
    ! [P: int > $o,P2: int > $o,Q: int > $o,Q2: int > $o] :
      ( ? [Z2: int] :
        ! [X4: int] :
          ( ( ord_less_int @ Z2 @ X4 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z2: int] :
          ! [X4: int] :
            ( ( ord_less_int @ Z2 @ X4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z: int] :
          ! [X2: int] :
            ( ( ord_less_int @ Z @ X2 )
           => ( ( ( P @ X2 )
                | ( Q @ X2 ) )
              = ( ( P2 @ X2 )
                | ( Q2 @ X2 ) ) ) ) ) ) )).

% pinf(2)
thf(fact_42_pinf_I2_J,axiom,(
    ! [P: nat > $o,P2: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z2: nat] :
        ! [X4: nat] :
          ( ( ord_less_nat @ Z2 @ X4 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z2: nat] :
          ! [X4: nat] :
            ( ( ord_less_nat @ Z2 @ X4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ Z @ X2 )
           => ( ( ( P @ X2 )
                | ( Q @ X2 ) )
              = ( ( P2 @ X2 )
                | ( Q2 @ X2 ) ) ) ) ) ) )).

% pinf(2)
thf(fact_43_pinf_I2_J,axiom,(
    ! [P: real > $o,P2: real > $o,Q: real > $o,Q2: real > $o] :
      ( ? [Z2: real] :
        ! [X4: real] :
          ( ( ord_less_real @ Z2 @ X4 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z2: real] :
          ! [X4: real] :
            ( ( ord_less_real @ Z2 @ X4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z: real] :
          ! [X2: real] :
            ( ( ord_less_real @ Z @ X2 )
           => ( ( ( P @ X2 )
                | ( Q @ X2 ) )
              = ( ( P2 @ X2 )
                | ( Q2 @ X2 ) ) ) ) ) ) )).

% pinf(2)
thf(fact_44_pinf_I3_J,axiom,(
    ! [T: int] :
    ? [Z: int] :
    ! [X2: int] :
      ( ( ord_less_int @ Z @ X2 )
     => ( X2 != T ) ) )).

% pinf(3)
thf(fact_45_pinf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ Z @ X2 )
     => ( X2 != T ) ) )).

% pinf(3)
thf(fact_46_pinf_I3_J,axiom,(
    ! [T: real] :
    ? [Z: real] :
    ! [X2: real] :
      ( ( ord_less_real @ Z @ X2 )
     => ( X2 != T ) ) )).

% pinf(3)
thf(fact_47_pinf_I4_J,axiom,(
    ! [T: int] :
    ? [Z: int] :
    ! [X2: int] :
      ( ( ord_less_int @ Z @ X2 )
     => ( X2 != T ) ) )).

% pinf(4)
thf(fact_48_pinf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ Z @ X2 )
     => ( X2 != T ) ) )).

% pinf(4)
thf(fact_49_pinf_I4_J,axiom,(
    ! [T: real] :
    ? [Z: real] :
    ! [X2: real] :
      ( ( ord_less_real @ Z @ X2 )
     => ( X2 != T ) ) )).

% pinf(4)
thf(fact_50_pinf_I5_J,axiom,(
    ! [T: int] :
    ? [Z: int] :
    ! [X2: int] :
      ( ( ord_less_int @ Z @ X2 )
     => ~ ( ord_less_int @ X2 @ T ) ) )).

% pinf(5)
thf(fact_51_pinf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ Z @ X2 )
     => ~ ( ord_less_nat @ X2 @ T ) ) )).

% pinf(5)
thf(fact_52_pinf_I5_J,axiom,(
    ! [T: real] :
    ? [Z: real] :
    ! [X2: real] :
      ( ( ord_less_real @ Z @ X2 )
     => ~ ( ord_less_real @ X2 @ T ) ) )).

% pinf(5)
thf(fact_53_pinf_I7_J,axiom,(
    ! [T: int] :
    ? [Z: int] :
    ! [X2: int] :
      ( ( ord_less_int @ Z @ X2 )
     => ( ord_less_int @ T @ X2 ) ) )).

% pinf(7)
thf(fact_54_pinf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ Z @ X2 )
     => ( ord_less_nat @ T @ X2 ) ) )).

% pinf(7)
thf(fact_55_pinf_I7_J,axiom,(
    ! [T: real] :
    ? [Z: real] :
    ! [X2: real] :
      ( ( ord_less_real @ Z @ X2 )
     => ( ord_less_real @ T @ X2 ) ) )).

% pinf(7)
thf(fact_56_minf_I1_J,axiom,(
    ! [P: int > $o,P2: int > $o,Q: int > $o,Q2: int > $o] :
      ( ? [Z2: int] :
        ! [X4: int] :
          ( ( ord_less_int @ X4 @ Z2 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z2: int] :
          ! [X4: int] :
            ( ( ord_less_int @ X4 @ Z2 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z: int] :
          ! [X2: int] :
            ( ( ord_less_int @ X2 @ Z )
           => ( ( ( P @ X2 )
                & ( Q @ X2 ) )
              = ( ( P2 @ X2 )
                & ( Q2 @ X2 ) ) ) ) ) ) )).

% minf(1)
thf(fact_57_minf_I1_J,axiom,(
    ! [P: nat > $o,P2: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z2: nat] :
        ! [X4: nat] :
          ( ( ord_less_nat @ X4 @ Z2 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z2: nat] :
          ! [X4: nat] :
            ( ( ord_less_nat @ X4 @ Z2 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ X2 @ Z )
           => ( ( ( P @ X2 )
                & ( Q @ X2 ) )
              = ( ( P2 @ X2 )
                & ( Q2 @ X2 ) ) ) ) ) ) )).

% minf(1)
thf(fact_58_minf_I1_J,axiom,(
    ! [P: real > $o,P2: real > $o,Q: real > $o,Q2: real > $o] :
      ( ? [Z2: real] :
        ! [X4: real] :
          ( ( ord_less_real @ X4 @ Z2 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z2: real] :
          ! [X4: real] :
            ( ( ord_less_real @ X4 @ Z2 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z: real] :
          ! [X2: real] :
            ( ( ord_less_real @ X2 @ Z )
           => ( ( ( P @ X2 )
                & ( Q @ X2 ) )
              = ( ( P2 @ X2 )
                & ( Q2 @ X2 ) ) ) ) ) ) )).

% minf(1)
thf(fact_59_minf_I2_J,axiom,(
    ! [P: int > $o,P2: int > $o,Q: int > $o,Q2: int > $o] :
      ( ? [Z2: int] :
        ! [X4: int] :
          ( ( ord_less_int @ X4 @ Z2 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z2: int] :
          ! [X4: int] :
            ( ( ord_less_int @ X4 @ Z2 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z: int] :
          ! [X2: int] :
            ( ( ord_less_int @ X2 @ Z )
           => ( ( ( P @ X2 )
                | ( Q @ X2 ) )
              = ( ( P2 @ X2 )
                | ( Q2 @ X2 ) ) ) ) ) ) )).

% minf(2)
thf(fact_60_minf_I2_J,axiom,(
    ! [P: nat > $o,P2: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z2: nat] :
        ! [X4: nat] :
          ( ( ord_less_nat @ X4 @ Z2 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z2: nat] :
          ! [X4: nat] :
            ( ( ord_less_nat @ X4 @ Z2 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ X2 @ Z )
           => ( ( ( P @ X2 )
                | ( Q @ X2 ) )
              = ( ( P2 @ X2 )
                | ( Q2 @ X2 ) ) ) ) ) ) )).

% minf(2)
thf(fact_61_minf_I2_J,axiom,(
    ! [P: real > $o,P2: real > $o,Q: real > $o,Q2: real > $o] :
      ( ? [Z2: real] :
        ! [X4: real] :
          ( ( ord_less_real @ X4 @ Z2 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z2: real] :
          ! [X4: real] :
            ( ( ord_less_real @ X4 @ Z2 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z: real] :
          ! [X2: real] :
            ( ( ord_less_real @ X2 @ Z )
           => ( ( ( P @ X2 )
                | ( Q @ X2 ) )
              = ( ( P2 @ X2 )
                | ( Q2 @ X2 ) ) ) ) ) ) )).

% minf(2)
thf(fact_62_minf_I3_J,axiom,(
    ! [T: int] :
    ? [Z: int] :
    ! [X2: int] :
      ( ( ord_less_int @ X2 @ Z )
     => ( X2 != T ) ) )).

% minf(3)
thf(fact_63_minf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ X2 @ Z )
     => ( X2 != T ) ) )).

% minf(3)
thf(fact_64_minf_I3_J,axiom,(
    ! [T: real] :
    ? [Z: real] :
    ! [X2: real] :
      ( ( ord_less_real @ X2 @ Z )
     => ( X2 != T ) ) )).

% minf(3)
thf(fact_65_minf_I4_J,axiom,(
    ! [T: int] :
    ? [Z: int] :
    ! [X2: int] :
      ( ( ord_less_int @ X2 @ Z )
     => ( X2 != T ) ) )).

% minf(4)
thf(fact_66_minf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ X2 @ Z )
     => ( X2 != T ) ) )).

% minf(4)
thf(fact_67_minf_I4_J,axiom,(
    ! [T: real] :
    ? [Z: real] :
    ! [X2: real] :
      ( ( ord_less_real @ X2 @ Z )
     => ( X2 != T ) ) )).

% minf(4)
thf(fact_68_minf_I5_J,axiom,(
    ! [T: int] :
    ? [Z: int] :
    ! [X2: int] :
      ( ( ord_less_int @ X2 @ Z )
     => ( ord_less_int @ X2 @ T ) ) )).

% minf(5)
thf(fact_69_minf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ X2 @ Z )
     => ( ord_less_nat @ X2 @ T ) ) )).

% minf(5)
thf(fact_70_minf_I5_J,axiom,(
    ! [T: real] :
    ? [Z: real] :
    ! [X2: real] :
      ( ( ord_less_real @ X2 @ Z )
     => ( ord_less_real @ X2 @ T ) ) )).

% minf(5)
thf(fact_71_minf_I7_J,axiom,(
    ! [T: int] :
    ? [Z: int] :
    ! [X2: int] :
      ( ( ord_less_int @ X2 @ Z )
     => ~ ( ord_less_int @ T @ X2 ) ) )).

% minf(7)
thf(fact_72_minf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X2: nat] :
      ( ( ord_less_nat @ X2 @ Z )
     => ~ ( ord_less_nat @ T @ X2 ) ) )).

% minf(7)
thf(fact_73_minf_I7_J,axiom,(
    ! [T: real] :
    ? [Z: real] :
    ! [X2: real] :
      ( ( ord_less_real @ X2 @ Z )
     => ~ ( ord_less_real @ T @ X2 ) ) )).

% minf(7)
thf(fact_74_order__refl,axiom,(
    ! [X: int] :
      ( ord_less_eq_int @ X @ X ) )).

% order_refl
thf(fact_75_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_76_order__refl,axiom,(
    ! [X: real] :
      ( ord_less_eq_real @ X @ X ) )).

% order_refl
thf(fact_77_complete__interval,axiom,(
    ! [A: int,B: int,P: int > $o] :
      ( ( ord_less_int @ A @ B )
     => ( ( P @ A )
       => ( ~ ( P @ B )
         => ? [C: int] :
              ( ( ord_less_eq_int @ A @ C )
              & ( ord_less_eq_int @ C @ B )
              & ! [X2: int] :
                  ( ( ( ord_less_eq_int @ A @ X2 )
                    & ( ord_less_int @ X2 @ C ) )
                 => ( P @ X2 ) )
              & ! [D: int] :
                  ( ! [X4: int] :
                      ( ( ( ord_less_eq_int @ A @ X4 )
                        & ( ord_less_int @ X4 @ D ) )
                     => ( P @ X4 ) )
                 => ( ord_less_eq_int @ D @ C ) ) ) ) ) ) )).

% complete_interval
thf(fact_78_complete__interval,axiom,(
    ! [A: nat,B: nat,P: nat > $o] :
      ( ( ord_less_nat @ A @ B )
     => ( ( P @ A )
       => ( ~ ( P @ B )
         => ? [C: nat] :
              ( ( ord_less_eq_nat @ A @ C )
              & ( ord_less_eq_nat @ C @ B )
              & ! [X2: nat] :
                  ( ( ( ord_less_eq_nat @ A @ X2 )
                    & ( ord_less_nat @ X2 @ C ) )
                 => ( P @ X2 ) )
              & ! [D: nat] :
                  ( ! [X4: nat] :
                      ( ( ( ord_less_eq_nat @ A @ X4 )
                        & ( ord_less_nat @ X4 @ D ) )
                     => ( P @ X4 ) )
                 => ( ord_less_eq_nat @ D @ C ) ) ) ) ) ) )).

% complete_interval
thf(fact_79_complete__interval,axiom,(
    ! [A: real,B: real,P: real > $o] :
      ( ( ord_less_real @ A @ B )
     => ( ( P @ A )
       => ( ~ ( P @ B )
         => ? [C: real] :
              ( ( ord_less_eq_real @ A @ C )
              & ( ord_less_eq_real @ C @ B )
              & ! [X2: real] :
                  ( ( ( ord_less_eq_real @ A @ X2 )
                    & ( ord_less_real @ X2 @ C ) )
                 => ( P @ X2 ) )
              & ! [D: real] :
                  ( ! [X4: real] :
                      ( ( ( ord_less_eq_real @ A @ X4 )
                        & ( ord_less_real @ X4 @ D ) )
                     => ( P @ X4 ) )
                 => ( ord_less_eq_real @ D @ C ) ) ) ) ) ) )).

% complete_interval
thf(fact_80_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: int,B: int] :
      ( ( A != B )
     => ( ( ord_less_eq_int @ A @ B )
       => ( ord_less_int @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_81_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_82_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: real,B: real] :
      ( ( A != B )
     => ( ( ord_less_eq_real @ A @ B )
       => ( ord_less_real @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_83_dual__order_Ostrict__implies__order,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_int @ B @ A )
     => ( ord_less_eq_int @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_84_dual__order_Ostrict__implies__order,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ord_less_eq_nat @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_85_dual__order_Ostrict__implies__order,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_real @ B @ A )
     => ( ord_less_eq_real @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_86_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_int
    = ( ^ [B2: int,A2: int] :
          ( ( ord_less_eq_int @ B2 @ A2 )
          & ( A2 != B2 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_87_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( A2 != B2 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_88_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_real
    = ( ^ [B2: real,A2: real] :
          ( ( ord_less_eq_real @ B2 @ A2 )
          & ( A2 != B2 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_89_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_int
    = ( ^ [B2: int,A2: int] :
          ( ( ord_less_int @ B2 @ A2 )
          | ( A2 = B2 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_90_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_less_nat @ B2 @ A2 )
          | ( A2 = B2 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_91_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_real
    = ( ^ [B2: real,A2: real] :
          ( ( ord_less_real @ B2 @ A2 )
          | ( A2 = B2 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_92_order_Ostrict__implies__order,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ( ord_less_eq_int @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_93_order_Ostrict__implies__order,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_94_order_Ostrict__implies__order,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ B )
     => ( ord_less_eq_real @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_95_dense__le__bounded,axiom,(
    ! [X: real,Y: real,Z3: real] :
      ( ( ord_less_real @ X @ Y )
     => ( ! [W: real] :
            ( ( ord_less_real @ X @ W )
           => ( ( ord_less_real @ W @ Y )
             => ( ord_less_eq_real @ W @ Z3 ) ) )
       => ( ord_less_eq_real @ Y @ Z3 ) ) ) )).

% dense_le_bounded
thf(fact_96_dense__ge__bounded,axiom,(
    ! [Z3: real,X: real,Y: real] :
      ( ( ord_less_real @ Z3 @ X )
     => ( ! [W: real] :
            ( ( ord_less_real @ Z3 @ W )
           => ( ( ord_less_real @ W @ X )
             => ( ord_less_eq_real @ Y @ W ) ) )
       => ( ord_less_eq_real @ Y @ Z3 ) ) ) )).

% dense_ge_bounded
thf(fact_97_dual__order_Ostrict__trans2,axiom,(
    ! [B: int,A: int,C2: int] :
      ( ( ord_less_int @ B @ A )
     => ( ( ord_less_eq_int @ C2 @ B )
       => ( ord_less_int @ C2 @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_98_dual__order_Ostrict__trans2,axiom,(
    ! [B: nat,A: nat,C2: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C2 @ B )
       => ( ord_less_nat @ C2 @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_99_dual__order_Ostrict__trans2,axiom,(
    ! [B: real,A: real,C2: real] :
      ( ( ord_less_real @ B @ A )
     => ( ( ord_less_eq_real @ C2 @ B )
       => ( ord_less_real @ C2 @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_100_dual__order_Oantisym,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_eq_int @ B @ A )
     => ( ( ord_less_eq_int @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_101_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_102_dual__order_Oantisym,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_103_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y2: int,Z4: int] : ( Y2 = Z4 ) )
    = ( ^ [A2: int,B2: int] :
          ( ( ord_less_eq_int @ B2 @ A2 )
          & ( ord_less_eq_int @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_104_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y2: nat,Z4: nat] : ( Y2 = Z4 ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( ord_less_eq_nat @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_105_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y2: real,Z4: real] : ( Y2 = Z4 ) )
    = ( ^ [A2: real,B2: real] :
          ( ( ord_less_eq_real @ B2 @ A2 )
          & ( ord_less_eq_real @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_106_dual__order_Otrans,axiom,(
    ! [B: int,A: int,C2: int] :
      ( ( ord_less_eq_int @ B @ A )
     => ( ( ord_less_eq_int @ C2 @ B )
       => ( ord_less_eq_int @ C2 @ A ) ) ) )).

% dual_order.trans
thf(fact_107_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C2: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C2 @ B )
       => ( ord_less_eq_nat @ C2 @ A ) ) ) )).

% dual_order.trans
thf(fact_108_dual__order_Otrans,axiom,(
    ! [B: real,A: real,C2: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ C2 @ B )
       => ( ord_less_eq_real @ C2 @ A ) ) ) )).

% dual_order.trans
thf(fact_109_linorder__wlog,axiom,(
    ! [P: int > int > $o,A: int,B: int] :
      ( ! [A3: int,B3: int] :
          ( ( ord_less_eq_int @ A3 @ B3 )
         => ( P @ A3 @ B3 ) )
     => ( ! [A3: int,B3: int] :
            ( ( P @ B3 @ A3 )
           => ( P @ A3 @ B3 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_110_linorder__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A3 @ B3 )
         => ( P @ A3 @ B3 ) )
     => ( ! [A3: nat,B3: nat] :
            ( ( P @ B3 @ A3 )
           => ( P @ A3 @ B3 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_111_linorder__wlog,axiom,(
    ! [P: real > real > $o,A: real,B: real] :
      ( ! [A3: real,B3: real] :
          ( ( ord_less_eq_real @ A3 @ B3 )
         => ( P @ A3 @ B3 ) )
     => ( ! [A3: real,B3: real] :
            ( ( P @ B3 @ A3 )
           => ( P @ A3 @ B3 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_112_dual__order_Orefl,axiom,(
    ! [A: int] :
      ( ord_less_eq_int @ A @ A ) )).

% dual_order.refl
thf(fact_113_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_114_dual__order_Orefl,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ A @ A ) )).

% dual_order.refl
thf(fact_115_order__trans,axiom,(
    ! [X: int,Y: int,Z3: int] :
      ( ( ord_less_eq_int @ X @ Y )
     => ( ( ord_less_eq_int @ Y @ Z3 )
       => ( ord_less_eq_int @ X @ Z3 ) ) ) )).

% order_trans
thf(fact_116_order__trans,axiom,(
    ! [X: nat,Y: nat,Z3: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z3 )
       => ( ord_less_eq_nat @ X @ Z3 ) ) ) )).

% order_trans
thf(fact_117_order__trans,axiom,(
    ! [X: real,Y: real,Z3: real] :
      ( ( ord_less_eq_real @ X @ Y )
     => ( ( ord_less_eq_real @ Y @ Z3 )
       => ( ord_less_eq_real @ X @ Z3 ) ) ) )).

% order_trans
thf(fact_118_order__class_Oorder_Oantisym,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_119_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_120_order__class_Oorder_Oantisym,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_121_ord__le__eq__trans,axiom,(
    ! [A: int,B: int,C2: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( B = C2 )
       => ( ord_less_eq_int @ A @ C2 ) ) ) )).

% ord_le_eq_trans
thf(fact_122_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C2 )
       => ( ord_less_eq_nat @ A @ C2 ) ) ) )).

% ord_le_eq_trans
thf(fact_123_ord__le__eq__trans,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( B = C2 )
       => ( ord_less_eq_real @ A @ C2 ) ) ) )).

% ord_le_eq_trans
thf(fact_124_ord__eq__le__trans,axiom,(
    ! [A: int,B: int,C2: int] :
      ( ( A = B )
     => ( ( ord_less_eq_int @ B @ C2 )
       => ( ord_less_eq_int @ A @ C2 ) ) ) )).

% ord_eq_le_trans
thf(fact_125_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C2 )
       => ( ord_less_eq_nat @ A @ C2 ) ) ) )).

% ord_eq_le_trans
thf(fact_126_ord__eq__le__trans,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( A = B )
     => ( ( ord_less_eq_real @ B @ C2 )
       => ( ord_less_eq_real @ A @ C2 ) ) ) )).

% ord_eq_le_trans
thf(fact_127_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y2: int,Z4: int] : ( Y2 = Z4 ) )
    = ( ^ [A2: int,B2: int] :
          ( ( ord_less_eq_int @ A2 @ B2 )
          & ( ord_less_eq_int @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_128_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y2: nat,Z4: nat] : ( Y2 = Z4 ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( ord_less_eq_nat @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_129_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y2: real,Z4: real] : ( Y2 = Z4 ) )
    = ( ^ [A2: real,B2: real] :
          ( ( ord_less_eq_real @ A2 @ B2 )
          & ( ord_less_eq_real @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_130_antisym__conv,axiom,(
    ! [Y: int,X: int] :
      ( ( ord_less_eq_int @ Y @ X )
     => ( ( ord_less_eq_int @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_131_antisym__conv,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_132_antisym__conv,axiom,(
    ! [Y: real,X: real] :
      ( ( ord_less_eq_real @ Y @ X )
     => ( ( ord_less_eq_real @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_133_le__cases3,axiom,(
    ! [X: int,Y: int,Z3: int] :
      ( ( ( ord_less_eq_int @ X @ Y )
       => ~ ( ord_less_eq_int @ Y @ Z3 ) )
     => ( ( ( ord_less_eq_int @ Y @ X )
         => ~ ( ord_less_eq_int @ X @ Z3 ) )
       => ( ( ( ord_less_eq_int @ X @ Z3 )
           => ~ ( ord_less_eq_int @ Z3 @ Y ) )
         => ( ( ( ord_less_eq_int @ Z3 @ Y )
             => ~ ( ord_less_eq_int @ Y @ X ) )
           => ( ( ( ord_less_eq_int @ Y @ Z3 )
               => ~ ( ord_less_eq_int @ Z3 @ X ) )
             => ~ ( ( ord_less_eq_int @ Z3 @ X )
                 => ~ ( ord_less_eq_int @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_134_le__cases3,axiom,(
    ! [X: nat,Y: nat,Z3: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y )
       => ~ ( ord_less_eq_nat @ Y @ Z3 ) )
     => ( ( ( ord_less_eq_nat @ Y @ X )
         => ~ ( ord_less_eq_nat @ X @ Z3 ) )
       => ( ( ( ord_less_eq_nat @ X @ Z3 )
           => ~ ( ord_less_eq_nat @ Z3 @ Y ) )
         => ( ( ( ord_less_eq_nat @ Z3 @ Y )
             => ~ ( ord_less_eq_nat @ Y @ X ) )
           => ( ( ( ord_less_eq_nat @ Y @ Z3 )
               => ~ ( ord_less_eq_nat @ Z3 @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z3 @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_135_le__cases3,axiom,(
    ! [X: real,Y: real,Z3: real] :
      ( ( ( ord_less_eq_real @ X @ Y )
       => ~ ( ord_less_eq_real @ Y @ Z3 ) )
     => ( ( ( ord_less_eq_real @ Y @ X )
         => ~ ( ord_less_eq_real @ X @ Z3 ) )
       => ( ( ( ord_less_eq_real @ X @ Z3 )
           => ~ ( ord_less_eq_real @ Z3 @ Y ) )
         => ( ( ( ord_less_eq_real @ Z3 @ Y )
             => ~ ( ord_less_eq_real @ Y @ X ) )
           => ( ( ( ord_less_eq_real @ Y @ Z3 )
               => ~ ( ord_less_eq_real @ Z3 @ X ) )
             => ~ ( ( ord_less_eq_real @ Z3 @ X )
                 => ~ ( ord_less_eq_real @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_136_order_Otrans,axiom,(
    ! [A: int,B: int,C2: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ B @ C2 )
       => ( ord_less_eq_int @ A @ C2 ) ) ) )).

% order.trans
thf(fact_137_order_Otrans,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C2 )
       => ( ord_less_eq_nat @ A @ C2 ) ) ) )).

% order.trans
thf(fact_138_order_Otrans,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ B @ C2 )
       => ( ord_less_eq_real @ A @ C2 ) ) ) )).

% order.trans
thf(fact_139_le__cases,axiom,(
    ! [X: int,Y: int] :
      ( ~ ( ord_less_eq_int @ X @ Y )
     => ( ord_less_eq_int @ Y @ X ) ) )).

% le_cases
thf(fact_140_le__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% le_cases
thf(fact_141_le__cases,axiom,(
    ! [X: real,Y: real] :
      ( ~ ( ord_less_eq_real @ X @ Y )
     => ( ord_less_eq_real @ Y @ X ) ) )).

% le_cases
thf(fact_142_eq__refl,axiom,(
    ! [X: int,Y: int] :
      ( ( X = Y )
     => ( ord_less_eq_int @ X @ Y ) ) )).

% eq_refl
thf(fact_143_eq__refl,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X = Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% eq_refl
thf(fact_144_eq__refl,axiom,(
    ! [X: real,Y: real] :
      ( ( X = Y )
     => ( ord_less_eq_real @ X @ Y ) ) )).

% eq_refl
thf(fact_145_linear,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_eq_int @ X @ Y )
      | ( ord_less_eq_int @ Y @ X ) ) )).

% linear
thf(fact_146_linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_eq_nat @ Y @ X ) ) )).

% linear
thf(fact_147_linear,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ X @ Y )
      | ( ord_less_eq_real @ Y @ X ) ) )).

% linear
thf(fact_148_antisym,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_eq_int @ X @ Y )
     => ( ( ord_less_eq_int @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_149_antisym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_150_antisym,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ X @ Y )
     => ( ( ord_less_eq_real @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_151_eq__iff,axiom,
    ( ( ^ [Y2: int,Z4: int] : ( Y2 = Z4 ) )
    = ( ^ [X5: int,Y3: int] :
          ( ( ord_less_eq_int @ X5 @ Y3 )
          & ( ord_less_eq_int @ Y3 @ X5 ) ) ) )).

% eq_iff
thf(fact_152_eq__iff,axiom,
    ( ( ^ [Y2: nat,Z4: nat] : ( Y2 = Z4 ) )
    = ( ^ [X5: nat,Y3: nat] :
          ( ( ord_less_eq_nat @ X5 @ Y3 )
          & ( ord_less_eq_nat @ Y3 @ X5 ) ) ) )).

% eq_iff
thf(fact_153_eq__iff,axiom,
    ( ( ^ [Y2: real,Z4: real] : ( Y2 = Z4 ) )
    = ( ^ [X5: real,Y3: real] :
          ( ( ord_less_eq_real @ X5 @ Y3 )
          & ( ord_less_eq_real @ Y3 @ X5 ) ) ) )).

% eq_iff
thf(fact_154_ord__le__eq__subst,axiom,(
    ! [A: int,B: int,F: int > int,C2: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_le_eq_subst
thf(fact_155_ord__le__eq__subst,axiom,(
    ! [A: int,B: int,F: int > nat,C2: nat] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_le_eq_subst
thf(fact_156_ord__le__eq__subst,axiom,(
    ! [A: int,B: int,F: int > real,C2: real] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_le_eq_subst
thf(fact_157_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > int,C2: int] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_le_eq_subst
thf(fact_158_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C2: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_le_eq_subst
thf(fact_159_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > real,C2: real] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_le_eq_subst
thf(fact_160_ord__le__eq__subst,axiom,(
    ! [A: real,B: real,F: real > int,C2: int] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_eq_real @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_le_eq_subst
thf(fact_161_ord__le__eq__subst,axiom,(
    ! [A: real,B: real,F: real > nat,C2: nat] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_eq_real @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_le_eq_subst
thf(fact_162_ord__le__eq__subst,axiom,(
    ! [A: real,B: real,F: real > real,C2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_eq_real @ X4 @ Y4 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_le_eq_subst
thf(fact_163_ord__eq__le__subst,axiom,(
    ! [A: int,F: int > int,B: int,C2: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_164_ord__eq__le__subst,axiom,(
    ! [A: nat,F: int > nat,B: int,C2: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_165_ord__eq__le__subst,axiom,(
    ! [A: real,F: int > real,B: int,C2: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_166_ord__eq__le__subst,axiom,(
    ! [A: int,F: nat > int,B: nat,C2: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_167_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C2: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_168_ord__eq__le__subst,axiom,(
    ! [A: real,F: nat > real,B: nat,C2: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_169_ord__eq__le__subst,axiom,(
    ! [A: int,F: real > int,B: real,C2: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_eq_real @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_170_ord__eq__le__subst,axiom,(
    ! [A: nat,F: real > nat,B: real,C2: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_eq_real @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_171_ord__eq__le__subst,axiom,(
    ! [A: real,F: real > real,B: real,C2: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_eq_real @ X4 @ Y4 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_172_order__subst2,axiom,(
    ! [A: int,B: int,F: int > int,C2: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C2 ) ) ) ) )).

% order_subst2
thf(fact_173_order__subst2,axiom,(
    ! [A: int,B: int,F: int > nat,C2: nat] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% order_subst2
thf(fact_174_order__subst2,axiom,(
    ! [A: int,B: int,F: int > real,C2: real] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_real @ ( F @ B ) @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C2 ) ) ) ) )).

% order_subst2
thf(fact_175_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > int,C2: int] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C2 ) ) ) ) )).

% order_subst2
thf(fact_176_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C2: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% order_subst2
thf(fact_177_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > real,C2: real] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_real @ ( F @ B ) @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C2 ) ) ) ) )).

% order_subst2
thf(fact_178_order__subst2,axiom,(
    ! [A: real,B: real,F: real > int,C2: int] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_eq_real @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C2 ) ) ) ) )).

% order_subst2
thf(fact_179_order__subst2,axiom,(
    ! [A: real,B: real,F: real > nat,C2: nat] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_eq_real @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% order_subst2
thf(fact_180_order__subst2,axiom,(
    ! [A: real,B: real,F: real > real,C2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ ( F @ B ) @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_eq_real @ X4 @ Y4 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C2 ) ) ) ) )).

% order_subst2
thf(fact_181_order__subst1,axiom,(
    ! [A: int,F: int > int,B: int,C2: int] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C2 ) ) ) ) ) )).

% order_subst1
thf(fact_182_order__subst1,axiom,(
    ! [A: int,F: nat > int,B: nat,C2: nat] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C2 ) ) ) ) ) )).

% order_subst1
thf(fact_183_order__subst1,axiom,(
    ! [A: int,F: real > int,B: real,C2: real] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_eq_real @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C2 ) ) ) ) ) )).

% order_subst1
thf(fact_184_order__subst1,axiom,(
    ! [A: nat,F: int > nat,B: int,C2: int] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% order_subst1
thf(fact_185_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C2: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% order_subst1
thf(fact_186_order__subst1,axiom,(
    ! [A: nat,F: real > nat,B: real,C2: real] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_eq_real @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% order_subst1
thf(fact_187_order__subst1,axiom,(
    ! [A: real,F: int > real,B: int,C2: int] :
      ( ( ord_less_eq_real @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C2 ) ) ) ) ) )).

% order_subst1
thf(fact_188_order__subst1,axiom,(
    ! [A: real,F: nat > real,B: nat,C2: nat] :
      ( ( ord_less_eq_real @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C2 ) ) ) ) ) )).

% order_subst1
thf(fact_189_order__subst1,axiom,(
    ! [A: real,F: real > real,B: real,C2: real] :
      ( ( ord_less_eq_real @ A @ ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_eq_real @ X4 @ Y4 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C2 ) ) ) ) ) )).

% order_subst1
thf(fact_190_ord__eq__less__subst,axiom,(
    ! [A: int,F: int > int,B: int,C2: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_int @ B @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_191_ord__eq__less__subst,axiom,(
    ! [A: nat,F: int > nat,B: int,C2: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_int @ B @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_192_ord__eq__less__subst,axiom,(
    ! [A: real,F: int > real,B: int,C2: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_int @ B @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_real @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_193_ord__eq__less__subst,axiom,(
    ! [A: int,F: nat > int,B: nat,C2: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_194_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C2: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_195_ord__eq__less__subst,axiom,(
    ! [A: real,F: nat > real,B: nat,C2: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_real @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_196_ord__eq__less__subst,axiom,(
    ! [A: int,F: real > int,B: real,C2: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_real @ B @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_real @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_197_ord__eq__less__subst,axiom,(
    ! [A: nat,F: real > nat,B: real,C2: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_real @ B @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_real @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_198_ord__eq__less__subst,axiom,(
    ! [A: real,F: real > real,B: real,C2: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_real @ B @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_real @ X4 @ Y4 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_real @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_199_ord__less__eq__subst,axiom,(
    ! [A: int,B: int,F: int > int,C2: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_less_eq_subst
thf(fact_200_ord__less__eq__subst,axiom,(
    ! [A: int,B: int,F: int > nat,C2: nat] :
      ( ( ord_less_int @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_less_eq_subst
thf(fact_201_ord__less__eq__subst,axiom,(
    ! [A: int,B: int,F: int > real,C2: real] :
      ( ( ord_less_int @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_less_eq_subst
thf(fact_202_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > int,C2: int] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_less_eq_subst
thf(fact_203_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C2: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_less_eq_subst
thf(fact_204_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > real,C2: real] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_less_eq_subst
thf(fact_205_ord__less__eq__subst,axiom,(
    ! [A: real,B: real,F: real > int,C2: int] :
      ( ( ord_less_real @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_real @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_less_eq_subst
thf(fact_206_ord__less__eq__subst,axiom,(
    ! [A: real,B: real,F: real > nat,C2: nat] :
      ( ( ord_less_real @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_real @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_less_eq_subst
thf(fact_207_ord__less__eq__subst,axiom,(
    ! [A: real,B: real,F: real > real,C2: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_real @ X4 @ Y4 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_less_eq_subst
thf(fact_208_order__less__subst1,axiom,(
    ! [A: int,F: int > int,B: int,C2: int] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ A @ ( F @ C2 ) ) ) ) ) )).

% order_less_subst1
thf(fact_209_order__less__subst1,axiom,(
    ! [A: int,F: nat > int,B: nat,C2: nat] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ A @ ( F @ C2 ) ) ) ) ) )).

% order_less_subst1
thf(fact_210_order__less__subst1,axiom,(
    ! [A: int,F: real > int,B: real,C2: real] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_real @ B @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_real @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ A @ ( F @ C2 ) ) ) ) ) )).

% order_less_subst1
thf(fact_211_order__less__subst1,axiom,(
    ! [A: nat,F: int > nat,B: int,C2: int] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% order_less_subst1
thf(fact_212_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C2: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% order_less_subst1
thf(fact_213_order__less__subst1,axiom,(
    ! [A: nat,F: real > nat,B: real,C2: real] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_real @ B @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_real @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C2 ) ) ) ) ) )).

% order_less_subst1
thf(fact_214_order__less__subst1,axiom,(
    ! [A: real,F: int > real,B: int,C2: int] :
      ( ( ord_less_real @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_real @ A @ ( F @ C2 ) ) ) ) ) )).

% order_less_subst1
thf(fact_215_order__less__subst1,axiom,(
    ! [A: real,F: nat > real,B: nat,C2: nat] :
      ( ( ord_less_real @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_real @ A @ ( F @ C2 ) ) ) ) ) )).

% order_less_subst1
thf(fact_216_order__less__subst1,axiom,(
    ! [A: real,F: real > real,B: real,C2: real] :
      ( ( ord_less_real @ A @ ( F @ B ) )
     => ( ( ord_less_real @ B @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_real @ X4 @ Y4 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_real @ A @ ( F @ C2 ) ) ) ) ) )).

% order_less_subst1
thf(fact_217_order__less__subst2,axiom,(
    ! [A: int,B: int,F: int > int,C2: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C2 ) ) ) ) )).

% order_less_subst2
thf(fact_218_order__less__subst2,axiom,(
    ! [A: int,B: int,F: int > nat,C2: nat] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% order_less_subst2
thf(fact_219_order__less__subst2,axiom,(
    ! [A: int,B: int,F: int > real,C2: real] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_real @ ( F @ B ) @ C2 )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C2 ) ) ) ) )).

% order_less_subst2
thf(fact_220_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > int,C2: int] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C2 ) ) ) ) )).

% order_less_subst2
thf(fact_221_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C2: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% order_less_subst2
thf(fact_222_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > real,C2: real] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_real @ ( F @ B ) @ C2 )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C2 ) ) ) ) )).

% order_less_subst2
thf(fact_223_order__less__subst2,axiom,(
    ! [A: real,B: real,F: real > int,C2: int] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_real @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C2 ) ) ) ) )).

% order_less_subst2
thf(fact_224_order__less__subst2,axiom,(
    ! [A: real,B: real,F: real > nat,C2: nat] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_real @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C2 ) ) ) ) )).

% order_less_subst2
thf(fact_225_order__less__subst2,axiom,(
    ! [A: real,B: real,F: real > real,C2: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_real @ ( F @ B ) @ C2 )
       => ( ! [X4: real,Y4: real] :
              ( ( ord_less_real @ X4 @ Y4 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C2 ) ) ) ) )).

% order_less_subst2
thf(fact_226_lt__ex,axiom,(
    ! [X: int] :
    ? [Y4: int] :
      ( ord_less_int @ Y4 @ X ) )).

% lt_ex
thf(fact_227_lt__ex,axiom,(
    ! [X: real] :
    ? [Y4: real] :
      ( ord_less_real @ Y4 @ X ) )).

% lt_ex
thf(fact_228_gt__ex,axiom,(
    ! [X: int] :
    ? [X_1: int] :
      ( ord_less_int @ X @ X_1 ) )).

% gt_ex
thf(fact_229_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_230_gt__ex,axiom,(
    ! [X: real] :
    ? [X_1: real] :
      ( ord_less_real @ X @ X_1 ) )).

% gt_ex
thf(fact_231_neqE,axiom,(
    ! [X: int,Y: int] :
      ( ( X != Y )
     => ( ~ ( ord_less_int @ X @ Y )
       => ( ord_less_int @ Y @ X ) ) ) )).

% neqE
thf(fact_232_neqE,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% neqE
thf(fact_233_neqE,axiom,(
    ! [X: real,Y: real] :
      ( ( X != Y )
     => ( ~ ( ord_less_real @ X @ Y )
       => ( ord_less_real @ Y @ X ) ) ) )).

% neqE
thf(fact_234_neq__iff,axiom,(
    ! [X: int,Y: int] :
      ( ( X != Y )
      = ( ( ord_less_int @ X @ Y )
        | ( ord_less_int @ Y @ X ) ) ) )).

% neq_iff
thf(fact_235_neq__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
      = ( ( ord_less_nat @ X @ Y )
        | ( ord_less_nat @ Y @ X ) ) ) )).

% neq_iff
thf(fact_236_neq__iff,axiom,(
    ! [X: real,Y: real] :
      ( ( X != Y )
      = ( ( ord_less_real @ X @ Y )
        | ( ord_less_real @ Y @ X ) ) ) )).

% neq_iff
thf(fact_237_order_Oasym,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ~ ( ord_less_int @ B @ A ) ) )).

% order.asym
thf(fact_238_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_239_order_Oasym,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ B )
     => ~ ( ord_less_real @ B @ A ) ) )).

% order.asym
thf(fact_240_dense,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_real @ X @ Y )
     => ? [Z: real] :
          ( ( ord_less_real @ X @ Z )
          & ( ord_less_real @ Z @ Y ) ) ) )).

% dense
thf(fact_241_less__imp__neq,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_242_less__imp__neq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_243_less__imp__neq,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_real @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_244_less__asym,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ~ ( ord_less_int @ Y @ X ) ) )).

% less_asym
thf(fact_245_less__asym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_asym
thf(fact_246_less__asym,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_real @ X @ Y )
     => ~ ( ord_less_real @ Y @ X ) ) )).

% less_asym
thf(fact_247_less__asym_H,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ~ ( ord_less_int @ B @ A ) ) )).

% less_asym'
thf(fact_248_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_249_less__asym_H,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ B )
     => ~ ( ord_less_real @ B @ A ) ) )).

% less_asym'
thf(fact_250_less__trans,axiom,(
    ! [X: int,Y: int,Z3: int] :
      ( ( ord_less_int @ X @ Y )
     => ( ( ord_less_int @ Y @ Z3 )
       => ( ord_less_int @ X @ Z3 ) ) ) )).

% less_trans
thf(fact_251_less__trans,axiom,(
    ! [X: nat,Y: nat,Z3: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z3 )
       => ( ord_less_nat @ X @ Z3 ) ) ) )).

% less_trans
thf(fact_252_less__trans,axiom,(
    ! [X: real,Y: real,Z3: real] :
      ( ( ord_less_real @ X @ Y )
     => ( ( ord_less_real @ Y @ Z3 )
       => ( ord_less_real @ X @ Z3 ) ) ) )).

% less_trans
thf(fact_253_less__linear,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
      | ( X = Y )
      | ( ord_less_int @ Y @ X ) ) )).

% less_linear
thf(fact_254_less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
      | ( X = Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% less_linear
thf(fact_255_less__linear,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_real @ X @ Y )
      | ( X = Y )
      | ( ord_less_real @ Y @ X ) ) )).

% less_linear
thf(fact_256_less__irrefl,axiom,(
    ! [X: int] :
      ~ ( ord_less_int @ X @ X ) )).

% less_irrefl
thf(fact_257_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_258_less__irrefl,axiom,(
    ! [X: real] :
      ~ ( ord_less_real @ X @ X ) )).

% less_irrefl
thf(fact_259_ord__eq__less__trans,axiom,(
    ! [A: int,B: int,C2: int] :
      ( ( A = B )
     => ( ( ord_less_int @ B @ C2 )
       => ( ord_less_int @ A @ C2 ) ) ) )).

% ord_eq_less_trans
thf(fact_260_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C2 )
       => ( ord_less_nat @ A @ C2 ) ) ) )).

% ord_eq_less_trans
thf(fact_261_ord__eq__less__trans,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( A = B )
     => ( ( ord_less_real @ B @ C2 )
       => ( ord_less_real @ A @ C2 ) ) ) )).

% ord_eq_less_trans
thf(fact_262_ord__less__eq__trans,axiom,(
    ! [A: int,B: int,C2: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( B = C2 )
       => ( ord_less_int @ A @ C2 ) ) ) )).

% ord_less_eq_trans
thf(fact_263_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C2 )
       => ( ord_less_nat @ A @ C2 ) ) ) )).

% ord_less_eq_trans
thf(fact_264_ord__less__eq__trans,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( B = C2 )
       => ( ord_less_real @ A @ C2 ) ) ) )).

% ord_less_eq_trans
thf(fact_265_dual__order_Oasym,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_int @ B @ A )
     => ~ ( ord_less_int @ A @ B ) ) )).

% dual_order.asym
thf(fact_266_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_267_dual__order_Oasym,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_real @ B @ A )
     => ~ ( ord_less_real @ A @ B ) ) )).

% dual_order.asym
thf(fact_268_less__imp__not__eq,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_269_less__imp__not__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_270_less__imp__not__eq,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_real @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_271_less__not__sym,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ~ ( ord_less_int @ Y @ X ) ) )).

% less_not_sym
thf(fact_272_less__not__sym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_not_sym
thf(fact_273_less__not__sym,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_real @ X @ Y )
     => ~ ( ord_less_real @ Y @ X ) ) )).

% less_not_sym
thf(fact_274_less__induct,axiom,(
    ! [P: nat > $o,A: nat] :
      ( ! [X4: nat] :
          ( ! [Y5: nat] :
              ( ( ord_less_nat @ Y5 @ X4 )
             => ( P @ Y5 ) )
         => ( P @ X4 ) )
     => ( P @ A ) ) )).

% less_induct
thf(fact_275_antisym__conv3,axiom,(
    ! [Y: int,X: int] :
      ( ~ ( ord_less_int @ Y @ X )
     => ( ( ~ ( ord_less_int @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_276_antisym__conv3,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_277_antisym__conv3,axiom,(
    ! [Y: real,X: real] :
      ( ~ ( ord_less_real @ Y @ X )
     => ( ( ~ ( ord_less_real @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_278_less__imp__not__eq2,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_279_less__imp__not__eq2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_280_less__imp__not__eq2,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_real @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_281_less__imp__triv,axiom,(
    ! [X: int,Y: int,P: $o] :
      ( ( ord_less_int @ X @ Y )
     => ( ( ord_less_int @ Y @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_282_less__imp__triv,axiom,(
    ! [X: nat,Y: nat,P: $o] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_283_less__imp__triv,axiom,(
    ! [X: real,Y: real,P: $o] :
      ( ( ord_less_real @ X @ Y )
     => ( ( ord_less_real @ Y @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_284_linorder__cases,axiom,(
    ! [X: int,Y: int] :
      ( ~ ( ord_less_int @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_int @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_285_linorder__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_286_linorder__cases,axiom,(
    ! [X: real,Y: real] :
      ( ~ ( ord_less_real @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_real @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_287_dual__order_Oirrefl,axiom,(
    ! [A: int] :
      ~ ( ord_less_int @ A @ A ) )).

% dual_order.irrefl
thf(fact_288_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_289_dual__order_Oirrefl,axiom,(
    ! [A: real] :
      ~ ( ord_less_real @ A @ A ) )).

% dual_order.irrefl
thf(fact_290_order_Ostrict__trans,axiom,(
    ! [A: int,B: int,C2: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_int @ B @ C2 )
       => ( ord_less_int @ A @ C2 ) ) ) )).

% order.strict_trans
thf(fact_291_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C2: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C2 )
       => ( ord_less_nat @ A @ C2 ) ) ) )).

% order.strict_trans
thf(fact_292_order_Ostrict__trans,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_real @ B @ C2 )
       => ( ord_less_real @ A @ C2 ) ) ) )).

% order.strict_trans
thf(fact_293_start__value_I2_J,axiom,(
    ! [X: int,P3: nat] :
      ( ( ord_less_eq_int @ zero_zero_int @ X )
     => ( ( ord_less_nat @ zero_zero_nat @ P3 )
       => ( ord_less_eq_int @ zero_zero_int @ ( nthRoo1503232983_value @ X @ P3 ) ) ) ) )).

% start_value(2)
thf(fact_294_zero__natural_Orsp,axiom,(
    zero_zero_nat = zero_zero_nat )).

% zero_natural.rsp
thf(fact_295_verit__la__generic,axiom,(
    ! [A: int,X: int] :
      ( ( ord_less_eq_int @ A @ X )
      | ( A = X )
      | ( ord_less_eq_int @ X @ A ) ) )).

% verit_la_generic
thf(fact_296_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_297_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_298_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_299_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_300_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_301_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI
thf(fact_302_bot__nat__0_Oextremum__unique,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
      = ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique
thf(fact_303_le__0__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_0_eq
thf(fact_304_less__eq__nat_Osimps_I1_J,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% less_eq_nat.simps(1)
thf(fact_305_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_306_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_307_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_308_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_309_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_310_nat__less__induct,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ( P @ M2 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) )).

% nat_less_induct
thf(fact_311_infinite__descent,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P @ N2 )
         => ? [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
              & ~ ( P @ M2 ) ) )
     => ( P @ N ) ) )).

% infinite_descent
thf(fact_312_linorder__neqE__nat,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_313_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_nat @ I2 @ J2 )
         => ( ord_less_nat @ ( F @ I2 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I @ J )
       => ( ord_less_eq_nat @ ( F @ I ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_314_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_315_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_316_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M3: nat,N3: nat] :
          ( ( ord_less_nat @ M3 @ N3 )
          | ( M3 = N3 ) ) ) )).

% le_eq_less_or_eq
thf(fact_317_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_318_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M3: nat,N3: nat] :
          ( ( ord_less_eq_nat @ M3 @ N3 )
          & ( M3 != N3 ) ) ) )).

% nat_less_le
thf(fact_319_gr0I,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr0I
thf(fact_320_not__gr0,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr0
thf(fact_321_not__less0,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less0
thf(fact_322_less__zeroE,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_zeroE
thf(fact_323_gr__implies__not0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not0
thf(fact_324_infinite__descent0,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ zero_zero_nat )
     => ( ! [N2: nat] :
            ( ( ord_less_nat @ zero_zero_nat @ N2 )
           => ( ~ ( P @ N2 )
             => ? [M2: nat] :
                  ( ( ord_less_nat @ M2 @ N2 )
                  & ~ ( P @ M2 ) ) ) )
       => ( P @ N ) ) ) )).

% infinite_descent0
thf(fact_325_bot__nat__0_Oextremum__strict,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ zero_zero_nat ) )).

% bot_nat_0.extremum_strict
thf(fact_326_ex__least__nat__le,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ zero_zero_nat )
       => ? [K: nat] :
            ( ( ord_less_eq_nat @ K @ N )
            & ! [I3: nat] :
                ( ( ord_less_nat @ I3 @ K )
               => ~ ( P @ I3 ) )
            & ( P @ K ) ) ) ) )).

% ex_least_nat_le
thf(fact_327_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_328_le__trans,axiom,(
    ! [I: nat,J: nat,K2: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K2 )
       => ( ord_less_eq_nat @ I @ K2 ) ) ) )).

% le_trans
thf(fact_329_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_330_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_331_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_332_Nat_Oex__has__greatest__nat,axiom,(
    ! [P: nat > $o,K2: nat,B: nat] :
      ( ( P @ K2 )
     => ( ! [Y4: nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq_nat @ Y4 @ B ) )
       => ? [X4: nat] :
            ( ( P @ X4 )
            & ! [Y5: nat] :
                ( ( P @ Y5 )
               => ( ord_less_eq_nat @ Y5 @ X4 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_333_nat__descend__induct,axiom,(
    ! [N: nat,P: nat > $o,M: nat] :
      ( ! [K: nat] :
          ( ( ord_less_nat @ N @ K )
         => ( P @ K ) )
     => ( ! [K: nat] :
            ( ( ord_less_eq_nat @ K @ N )
           => ( ! [I3: nat] :
                  ( ( ord_less_nat @ K @ I3 )
                 => ( P @ I3 ) )
             => ( P @ K ) ) )
       => ( P @ M ) ) ) )).

% nat_descend_induct
thf(fact_334_start__value__main,axiom,(
    ! [X: int,P3: nat] :
      ( ( ord_less_eq_int @ zero_zero_int @ X )
     => ( ( ord_less_nat @ zero_zero_nat @ P3 )
       => ( ( ord_less_eq_int @ X @ ( power_power_int @ ( nthRoo1503232983_value @ X @ P3 ) @ P3 ) )
          & ( ord_less_eq_int @ zero_zero_int @ ( nthRoo1503232983_value @ X @ P3 ) ) ) ) ) )).

% start_value_main
thf(fact_335_start__value_I1_J,axiom,(
    ! [X: int,P3: nat] :
      ( ( ord_less_eq_int @ zero_zero_int @ X )
     => ( ( ord_less_nat @ zero_zero_nat @ P3 )
       => ( ord_less_eq_int @ X @ ( power_power_int @ ( nthRoo1503232983_value @ X @ P3 ) @ P3 ) ) ) ) )).

% start_value(1)
thf(fact_336_nat__zero__less__power__iff,axiom,(
    ! [X: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( power_power_nat @ X @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ X )
        | ( N = zero_zero_nat ) ) ) )).

% nat_zero_less_power_iff
thf(fact_337_nat__power__less__imp__less,axiom,(
    ! [I: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ I )
     => ( ( ord_less_nat @ ( power_power_nat @ I @ M ) @ ( power_power_nat @ I @ N ) )
       => ( ord_less_nat @ M @ N ) ) ) )).

% nat_power_less_imp_less
thf(fact_338_False,axiom,(
    ~ ( ord_less_eq_int @ ( power_power_int @ xa @ p ) @ na ) )).

% False
thf(fact_339_p0,axiom,(
    p != zero_zero_nat )).

% p0
thf(fact_340_id,axiom,(
    ~ ( ord_less_eq_int @ ( power_power_int @ xa @ p ) @ na ) )).

% id
thf(fact_341_realpow__pos__nth,axiom,(
    ! [N: nat,A: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_real @ zero_zero_real @ A )
       => ? [R: real] :
            ( ( ord_less_real @ zero_zero_real @ R )
            & ( ( power_power_real @ R @ N )
              = A ) ) ) ) )).

% realpow_pos_nth
thf(fact_342_realpow__pos__nth__unique,axiom,(
    ! [N: nat,A: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_real @ zero_zero_real @ A )
       => ? [X4: real] :
            ( ( ord_less_real @ zero_zero_real @ X4 )
            & ( ( power_power_real @ X4 @ N )
              = A )
            & ! [Y5: real] :
                ( ( ( ord_less_real @ zero_zero_real @ Y5 )
                  & ( ( power_power_real @ Y5 @ N )
                    = A ) )
               => ( Y5 = X4 ) ) ) ) ) )).

% realpow_pos_nth_unique
thf(fact_343_less__eq__real__def,axiom,
    ( ord_less_eq_real
    = ( ^ [X5: real,Y3: real] :
          ( ( ord_less_real @ X5 @ Y3 )
          | ( X5 = Y3 ) ) ) )).

% less_eq_real_def
thf(fact_344_less__one,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ N @ one_one_nat )
      = ( N = zero_zero_nat ) ) )).

% less_one

% Conjectures (1)
thf(conj_0,conjecture,
    ( ( ord_less_int @ zero_zero_int @ xa )
    | ( xa = zero_zero_int ) )).

%------------------------------------------------------------------------------
