%------------------------------------------------------------------------------
% File     : SLH108^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer NthRoot_Impl problem prob_100__3272388_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : NthRoot_Impl/prob_100__3272388_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  377 (   0 unit;  31 type;   0 defn)
%            Number of atoms       : 3502 ( 257 equality;2159 variable)
%            Maximal formula depth :   14 (   8 average)
%            Number of connectives : 2769 ( 127   ~;  21   |;  24   &;2040   @)
%                                         (   0 <=>; 557  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  107 ( 107   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   33 (  31   :;   0   =)
%            Number of variables   :  963 (   0 sgn; 890   !;  16   ?;  57   ^)
%                                         ( 963   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:40:44.855
%------------------------------------------------------------------------------
% Could-be-implicit typings (5)
thf(ty_n_t__Set__Oset_It__Real__Oreal_J,type,(
    set_real: $tType )).

thf(ty_n_t__Real__Oreal,type,(
    real: $tType )).

thf(ty_n_t__Rat__Orat,type,(
    rat: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

thf(ty_n_t__Int__Oint,type,(
    int: $tType )).

% Explicit typings (26)
thf(sy_c_Groups_Oone__class_Oone_001t__Int__Oint,type,(
    one_one_int: int )).

thf(sy_c_Groups_Oone__class_Oone_001t__Nat__Onat,type,(
    one_one_nat: nat )).

thf(sy_c_Groups_Oone__class_Oone_001t__Real__Oreal,type,(
    one_one_real: real )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Int__Oint,type,(
    zero_zero_int: int )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Rat__Orat,type,(
    zero_zero_rat: rat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Real__Oreal,type,(
    zero_zero_real: real )).

thf(sy_c_Int_Oring__1__class_Oof__int_001t__Int__Oint,type,(
    ring_1_of_int_int: int > int )).

thf(sy_c_Int_Oring__1__class_Oof__int_001t__Rat__Orat,type,(
    ring_1_of_int_rat: int > rat )).

thf(sy_c_Int_Oring__1__class_Oof__int_001t__Real__Oreal,type,(
    ring_1_of_int_real: int > real )).

thf(sy_c_NthRoot_Oroot,type,(
    root: nat > real > real )).

thf(sy_c_NthRoot__Impl__Mirabelle__bcfbdygymo_Ostart__value,type,(
    nthRoo1503232983_value: int > nat > int )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Int__Oint,type,(
    ord_less_int: int > int > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Rat__Orat,type,(
    ord_less_rat: rat > rat > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Real__Oreal,type,(
    ord_less_real: real > real > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Int__Oint,type,(
    ord_less_eq_int: int > int > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Rat__Orat,type,(
    ord_less_eq_rat: rat > rat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Real__Oreal,type,(
    ord_less_eq_real: real > real > $o )).

thf(sy_c_Rat_Ofield__char__0__class_Oof__rat_001t__Real__Oreal,type,(
    field_240844524t_real: rat > real )).

thf(sy_c_Set_OCollect_001t__Real__Oreal,type,(
    collect_real: ( real > $o ) > set_real )).

thf(sy_c_member_001t__Real__Oreal,type,(
    member_real: real > set_real > $o )).

thf(sy_v_l2x____,type,(
    l2x: int )).

thf(sy_v_p,type,(
    p: nat )).

thf(sy_v_x,type,(
    x: int )).

% Relevant facts (345)
thf(fact_0_p,axiom,(
    ord_less_nat @ zero_zero_nat @ p )).

% p
thf(fact_1_x,axiom,(
    ord_less_int @ zero_zero_int @ x )).

% x
thf(fact_2_False,axiom,(
    x != zero_zero_int )).

% False
thf(fact_3_less,axiom,(
    ord_less_eq_real @ ( root @ p @ ( ring_1_of_int_real @ x ) ) @ ( ring_1_of_int_real @ ( nthRoo1503232983_value @ x @ p ) ) )).

% less
thf(fact_4_assms_I1_J,axiom,(
    ord_less_eq_int @ zero_zero_int @ x )).

% assms(1)
thf(fact_5_of__int__0__le__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_rat @ zero_zero_rat @ ( ring_1_of_int_rat @ Z ) )
      = ( ord_less_eq_int @ zero_zero_int @ Z ) ) )).

% of_int_0_le_iff
thf(fact_6_of__int__0__le__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( ring_1_of_int_real @ Z ) )
      = ( ord_less_eq_int @ zero_zero_int @ Z ) ) )).

% of_int_0_le_iff
thf(fact_7_of__int__0__le__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_int @ zero_zero_int @ ( ring_1_of_int_int @ Z ) )
      = ( ord_less_eq_int @ zero_zero_int @ Z ) ) )).

% of_int_0_le_iff
thf(fact_8_of__int__le__0__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_rat @ ( ring_1_of_int_rat @ Z ) @ zero_zero_rat )
      = ( ord_less_eq_int @ Z @ zero_zero_int ) ) )).

% of_int_le_0_iff
thf(fact_9_of__int__le__0__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_real @ ( ring_1_of_int_real @ Z ) @ zero_zero_real )
      = ( ord_less_eq_int @ Z @ zero_zero_int ) ) )).

% of_int_le_0_iff
thf(fact_10_of__int__le__0__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_int @ ( ring_1_of_int_int @ Z ) @ zero_zero_int )
      = ( ord_less_eq_int @ Z @ zero_zero_int ) ) )).

% of_int_le_0_iff
thf(fact_11_real__root__zero,axiom,(
    ! [N: nat] :
      ( ( root @ N @ zero_zero_real )
      = zero_zero_real ) )).

% real_root_zero
thf(fact_12_of__int__0,axiom,
    ( ( ring_1_of_int_int @ zero_zero_int )
    = zero_zero_int )).

% of_int_0
thf(fact_13_of__int__0,axiom,
    ( ( ring_1_of_int_real @ zero_zero_int )
    = zero_zero_real )).

% of_int_0
thf(fact_14_of__int__0,axiom,
    ( ( ring_1_of_int_rat @ zero_zero_int )
    = zero_zero_rat )).

% of_int_0
thf(fact_15_of__int__0__eq__iff,axiom,(
    ! [Z: int] :
      ( ( zero_zero_int
        = ( ring_1_of_int_int @ Z ) )
      = ( Z = zero_zero_int ) ) )).

% of_int_0_eq_iff
thf(fact_16_of__int__0__eq__iff,axiom,(
    ! [Z: int] :
      ( ( zero_zero_real
        = ( ring_1_of_int_real @ Z ) )
      = ( Z = zero_zero_int ) ) )).

% of_int_0_eq_iff
thf(fact_17_of__int__0__eq__iff,axiom,(
    ! [Z: int] :
      ( ( zero_zero_rat
        = ( ring_1_of_int_rat @ Z ) )
      = ( Z = zero_zero_int ) ) )).

% of_int_0_eq_iff
thf(fact_18_of__int__eq__0__iff,axiom,(
    ! [Z: int] :
      ( ( ( ring_1_of_int_real @ Z )
        = zero_zero_real )
      = ( Z = zero_zero_int ) ) )).

% of_int_eq_0_iff
thf(fact_19_of__int__eq__0__iff,axiom,(
    ! [Z: int] :
      ( ( ( ring_1_of_int_rat @ Z )
        = zero_zero_rat )
      = ( Z = zero_zero_int ) ) )).

% of_int_eq_0_iff
thf(fact_20_of__int__eq__0__iff,axiom,(
    ! [Z: int] :
      ( ( ( ring_1_of_int_int @ Z )
        = zero_zero_int )
      = ( Z = zero_zero_int ) ) )).

% of_int_eq_0_iff
thf(fact_21_of__int__le__iff,axiom,(
    ! [W: int,Z: int] :
      ( ( ord_less_eq_real @ ( ring_1_of_int_real @ W ) @ ( ring_1_of_int_real @ Z ) )
      = ( ord_less_eq_int @ W @ Z ) ) )).

% of_int_le_iff
thf(fact_22_of__int__le__iff,axiom,(
    ! [W: int,Z: int] :
      ( ( ord_less_eq_int @ ( ring_1_of_int_int @ W ) @ ( ring_1_of_int_int @ Z ) )
      = ( ord_less_eq_int @ W @ Z ) ) )).

% of_int_le_iff
thf(fact_23_of__int__le__iff,axiom,(
    ! [W: int,Z: int] :
      ( ( ord_less_eq_rat @ ( ring_1_of_int_rat @ W ) @ ( ring_1_of_int_rat @ Z ) )
      = ( ord_less_eq_int @ W @ Z ) ) )).

% of_int_le_iff
thf(fact_24_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_25_real__root__pos__pos__le,axiom,(
    ! [X: real,N: nat] :
      ( ( ord_less_eq_real @ zero_zero_real @ X )
     => ( ord_less_eq_real @ zero_zero_real @ ( root @ N @ X ) ) ) )).

% real_root_pos_pos_le
thf(fact_26_of__int__nonneg,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_int @ zero_zero_int @ Z )
     => ( ord_less_eq_real @ zero_zero_real @ ( ring_1_of_int_real @ Z ) ) ) )).

% of_int_nonneg
thf(fact_27_of__int__nonneg,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_int @ zero_zero_int @ Z )
     => ( ord_less_eq_int @ zero_zero_int @ ( ring_1_of_int_int @ Z ) ) ) )).

% of_int_nonneg
thf(fact_28_of__int__nonneg,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_int @ zero_zero_int @ Z )
     => ( ord_less_eq_rat @ zero_zero_rat @ ( ring_1_of_int_rat @ Z ) ) ) )).

% of_int_nonneg
thf(fact_29_of__int__eq__iff,axiom,(
    ! [W: int,Z: int] :
      ( ( ( ring_1_of_int_real @ W )
        = ( ring_1_of_int_real @ Z ) )
      = ( W = Z ) ) )).

% of_int_eq_iff
thf(fact_30_of__int__eq__iff,axiom,(
    ! [W: int,Z: int] :
      ( ( ( ring_1_of_int_rat @ W )
        = ( ring_1_of_int_rat @ Z ) )
      = ( W = Z ) ) )).

% of_int_eq_iff
thf(fact_31_of__int__eq__iff,axiom,(
    ! [W: int,Z: int] :
      ( ( ( ring_1_of_int_int @ W )
        = ( ring_1_of_int_int @ Z ) )
      = ( W = Z ) ) )).

% of_int_eq_iff
thf(fact_32_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_33_of__int__less__iff,axiom,(
    ! [W: int,Z: int] :
      ( ( ord_less_rat @ ( ring_1_of_int_rat @ W ) @ ( ring_1_of_int_rat @ Z ) )
      = ( ord_less_int @ W @ Z ) ) )).

% of_int_less_iff
thf(fact_34_of__int__less__iff,axiom,(
    ! [W: int,Z: int] :
      ( ( ord_less_int @ ( ring_1_of_int_int @ W ) @ ( ring_1_of_int_int @ Z ) )
      = ( ord_less_int @ W @ Z ) ) )).

% of_int_less_iff
thf(fact_35_of__int__less__iff,axiom,(
    ! [W: int,Z: int] :
      ( ( ord_less_real @ ( ring_1_of_int_real @ W ) @ ( ring_1_of_int_real @ Z ) )
      = ( ord_less_int @ W @ Z ) ) )).

% of_int_less_iff
thf(fact_36_root__0,axiom,(
    ! [X: real] :
      ( ( root @ zero_zero_nat @ X )
      = zero_zero_real ) )).

% root_0
thf(fact_37_real__root__eq__iff,axiom,(
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ( root @ N @ X )
          = ( root @ N @ Y ) )
        = ( X = Y ) ) ) )).

% real_root_eq_iff
thf(fact_38_real__root__eq__0__iff,axiom,(
    ! [N: nat,X: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ( root @ N @ X )
          = zero_zero_real )
        = ( X = zero_zero_real ) ) ) )).

% real_root_eq_0_iff
thf(fact_39_real__root__le__iff,axiom,(
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_eq_real @ ( root @ N @ X ) @ ( root @ N @ Y ) )
        = ( ord_less_eq_real @ X @ Y ) ) ) )).

% real_root_le_iff
thf(fact_40_of__int__less__0__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_rat @ ( ring_1_of_int_rat @ Z ) @ zero_zero_rat )
      = ( ord_less_int @ Z @ zero_zero_int ) ) )).

% of_int_less_0_iff
thf(fact_41_of__int__less__0__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_int @ ( ring_1_of_int_int @ Z ) @ zero_zero_int )
      = ( ord_less_int @ Z @ zero_zero_int ) ) )).

% of_int_less_0_iff
thf(fact_42_of__int__less__0__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_real @ ( ring_1_of_int_real @ Z ) @ zero_zero_real )
      = ( ord_less_int @ Z @ zero_zero_int ) ) )).

% of_int_less_0_iff
thf(fact_43_of__int__0__less__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_rat @ zero_zero_rat @ ( ring_1_of_int_rat @ Z ) )
      = ( ord_less_int @ zero_zero_int @ Z ) ) )).

% of_int_0_less_iff
thf(fact_44_of__int__0__less__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_int @ zero_zero_int @ ( ring_1_of_int_int @ Z ) )
      = ( ord_less_int @ zero_zero_int @ Z ) ) )).

% of_int_0_less_iff
thf(fact_45_of__int__0__less__iff,axiom,(
    ! [Z: int] :
      ( ( ord_less_real @ zero_zero_real @ ( ring_1_of_int_real @ Z ) )
      = ( ord_less_int @ zero_zero_int @ Z ) ) )).

% of_int_0_less_iff
thf(fact_46_real__root__le__0__iff,axiom,(
    ! [N: nat,X: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_eq_real @ ( root @ N @ X ) @ zero_zero_real )
        = ( ord_less_eq_real @ X @ zero_zero_real ) ) ) )).

% real_root_le_0_iff
thf(fact_47_real__root__ge__0__iff,axiom,(
    ! [N: nat,Y: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_eq_real @ zero_zero_real @ ( root @ N @ Y ) )
        = ( ord_less_eq_real @ zero_zero_real @ Y ) ) ) )).

% real_root_ge_0_iff
thf(fact_48_less__int__code_I1_J,axiom,(
    ~ ( ord_less_int @ zero_zero_int @ zero_zero_int ) )).

% less_int_code(1)
thf(fact_49_less__eq__int__code_I1_J,axiom,(
    ord_less_eq_int @ zero_zero_int @ zero_zero_int )).

% less_eq_int_code(1)
thf(fact_50_zero__less__iff__neq__zero,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( N != zero_zero_nat ) ) )).

% zero_less_iff_neq_zero
thf(fact_51_gr__implies__not__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not_zero
thf(fact_52_not__less__zero,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less_zero
thf(fact_53_gr__zeroI,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_zeroI
thf(fact_54_of__int__pos,axiom,(
    ! [Z: int] :
      ( ( ord_less_int @ zero_zero_int @ Z )
     => ( ord_less_rat @ zero_zero_rat @ ( ring_1_of_int_rat @ Z ) ) ) )).

% of_int_pos
thf(fact_55_of__int__pos,axiom,(
    ! [Z: int] :
      ( ( ord_less_int @ zero_zero_int @ Z )
     => ( ord_less_int @ zero_zero_int @ ( ring_1_of_int_int @ Z ) ) ) )).

% of_int_pos
thf(fact_56_of__int__pos,axiom,(
    ! [Z: int] :
      ( ( ord_less_int @ zero_zero_int @ Z )
     => ( ord_less_real @ zero_zero_real @ ( ring_1_of_int_real @ Z ) ) ) )).

% of_int_pos
thf(fact_57_real__root__le__mono,axiom,(
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_eq_real @ X @ Y )
       => ( ord_less_eq_real @ ( root @ N @ X ) @ ( root @ N @ Y ) ) ) ) )).

% real_root_le_mono
thf(fact_58_zero__reorient,axiom,(
    ! [X: real] :
      ( ( zero_zero_real = X )
      = ( X = zero_zero_real ) ) )).

% zero_reorient
thf(fact_59_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_60_zero__reorient,axiom,(
    ! [X: int] :
      ( ( zero_zero_int = X )
      = ( X = zero_zero_int ) ) )).

% zero_reorient
thf(fact_61_zero__reorient,axiom,(
    ! [X: rat] :
      ( ( zero_zero_rat = X )
      = ( X = zero_zero_rat ) ) )).

% zero_reorient
thf(fact_62_real__root__commute,axiom,(
    ! [M: nat,N: nat,X: real] :
      ( ( root @ M @ ( root @ N @ X ) )
      = ( root @ N @ ( root @ M @ X ) ) ) )).

% real_root_commute
thf(fact_63_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_64_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_65_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_66_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_67_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_68_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_69_order__refl,axiom,(
    ! [X: real] :
      ( ord_less_eq_real @ X @ X ) )).

% order_refl
thf(fact_70_order__refl,axiom,(
    ! [X: int] :
      ( ord_less_eq_int @ X @ X ) )).

% order_refl
thf(fact_71_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_72_order__refl,axiom,(
    ! [X: rat] :
      ( ord_less_eq_rat @ X @ X ) )).

% order_refl
thf(fact_73_imp__le__cong,axiom,(
    ! [X: int,X2: int,P: $o,P2: $o] :
      ( ( X = X2 )
     => ( ( ( ord_less_eq_int @ zero_zero_int @ X2 )
         => ( P = P2 ) )
       => ( ( ( ord_less_eq_int @ zero_zero_int @ X )
           => P )
          = ( ( ord_less_eq_int @ zero_zero_int @ X2 )
           => P2 ) ) ) ) )).

% imp_le_cong
thf(fact_74_mem__Collect__eq,axiom,(
    ! [A: real,P: real > $o] :
      ( ( member_real @ A @ ( collect_real @ P ) )
      = ( P @ A ) ) )).

% mem_Collect_eq
thf(fact_75_Collect__mem__eq,axiom,(
    ! [A2: set_real] :
      ( ( collect_real
        @ ^ [X3: real] :
            ( member_real @ X3 @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_76_conj__le__cong,axiom,(
    ! [X: int,X2: int,P: $o,P2: $o] :
      ( ( X = X2 )
     => ( ( ( ord_less_eq_int @ zero_zero_int @ X2 )
         => ( P = P2 ) )
       => ( ( ( ord_less_eq_int @ zero_zero_int @ X )
            & P )
          = ( ( ord_less_eq_int @ zero_zero_int @ X2 )
            & P2 ) ) ) ) )).

% conj_le_cong
thf(fact_77_gr0I,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr0I
thf(fact_78_not__gr0,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr0
thf(fact_79_real__root__less__iff,axiom,(
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_real @ ( root @ N @ X ) @ ( root @ N @ Y ) )
        = ( ord_less_real @ X @ Y ) ) ) )).

% real_root_less_iff
thf(fact_80_real__root__gt__0__iff,axiom,(
    ! [N: nat,Y: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_real @ zero_zero_real @ ( root @ N @ Y ) )
        = ( ord_less_real @ zero_zero_real @ Y ) ) ) )).

% real_root_gt_0_iff
thf(fact_81_real__root__lt__0__iff,axiom,(
    ! [N: nat,X: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_real @ ( root @ N @ X ) @ zero_zero_real )
        = ( ord_less_real @ X @ zero_zero_real ) ) ) )).

% real_root_lt_0_iff
thf(fact_82_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_83_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_84_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_85_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_86_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_87_Nat_Oex__has__greatest__nat,axiom,(
    ! [P: nat > $o,K: nat,B: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq_nat @ Y2 @ B ) )
       => ? [X4: nat] :
            ( ( P @ X4 )
            & ! [Y3: nat] :
                ( ( P @ Y3 )
               => ( ord_less_eq_nat @ Y3 @ X4 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_88_order__subst1,axiom,(
    ! [A: real,F: real > real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_89_order__subst1,axiom,(
    ! [A: real,F: int > real,B: int,C: int] :
      ( ( ord_less_eq_real @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_eq_int @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_90_order__subst1,axiom,(
    ! [A: real,F: nat > real,B: nat,C: nat] :
      ( ( ord_less_eq_real @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_91_order__subst1,axiom,(
    ! [A: real,F: rat > real,B: rat,C: rat] :
      ( ( ord_less_eq_real @ A @ ( F @ B ) )
     => ( ( ord_less_eq_rat @ B @ C )
       => ( ! [X4: rat,Y2: rat] :
              ( ( ord_less_eq_rat @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_92_order__subst1,axiom,(
    ! [A: int,F: real > int,B: real,C: real] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_93_order__subst1,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_eq_int @ X4 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_94_order__subst1,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_95_order__subst1,axiom,(
    ! [A: int,F: rat > int,B: rat,C: rat] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_rat @ B @ C )
       => ( ! [X4: rat,Y2: rat] :
              ( ( ord_less_eq_rat @ X4 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_96_order__subst1,axiom,(
    ! [A: nat,F: real > nat,B: real,C: real] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_97_order__subst1,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_eq_int @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_98_order__subst2,axiom,(
    ! [A: real,B: real,F: real > real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ ( F @ B ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_99_order__subst2,axiom,(
    ! [A: real,B: real,F: real > int,C: int] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_100_order__subst2,axiom,(
    ! [A: real,B: real,F: real > nat,C: nat] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_101_order__subst2,axiom,(
    ! [A: real,B: real,F: real > rat,C: rat] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_rat @ ( F @ B ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_rat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_rat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_102_order__subst2,axiom,(
    ! [A: int,B: int,F: int > real,C: real] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_real @ ( F @ B ) @ C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_eq_int @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_103_order__subst2,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_eq_int @ X4 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_104_order__subst2,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_eq_int @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_105_order__subst2,axiom,(
    ! [A: int,B: int,F: int > rat,C: rat] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_rat @ ( F @ B ) @ C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_eq_int @ X4 @ Y2 )
             => ( ord_less_eq_rat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_rat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_106_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > real,C: real] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_real @ ( F @ B ) @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_107_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_108_ord__eq__le__subst,axiom,(
    ! [A: real,F: real > real,B: real,C: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_109_ord__eq__le__subst,axiom,(
    ! [A: int,F: real > int,B: real,C: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_110_ord__eq__le__subst,axiom,(
    ! [A: nat,F: real > nat,B: real,C: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_111_ord__eq__le__subst,axiom,(
    ! [A: rat,F: real > rat,B: real,C: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_rat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_rat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_112_ord__eq__le__subst,axiom,(
    ! [A: real,F: int > real,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_eq_int @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_113_ord__eq__le__subst,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_eq_int @ X4 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_114_ord__eq__le__subst,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_eq_int @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_115_ord__eq__le__subst,axiom,(
    ! [A: rat,F: int > rat,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_eq_int @ X4 @ Y2 )
             => ( ord_less_eq_rat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_rat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_116_ord__eq__le__subst,axiom,(
    ! [A: real,F: nat > real,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_117_ord__eq__le__subst,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_118_ord__le__eq__subst,axiom,(
    ! [A: real,B: real,F: real > real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_119_ord__le__eq__subst,axiom,(
    ! [A: real,B: real,F: real > int,C: int] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_120_ord__le__eq__subst,axiom,(
    ! [A: real,B: real,F: real > nat,C: nat] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_121_ord__le__eq__subst,axiom,(
    ! [A: real,B: real,F: real > rat,C: rat] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_rat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_rat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_122_ord__le__eq__subst,axiom,(
    ! [A: int,B: int,F: int > real,C: real] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_eq_int @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_123_ord__le__eq__subst,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_eq_int @ X4 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_124_ord__le__eq__subst,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_eq_int @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_125_ord__le__eq__subst,axiom,(
    ! [A: int,B: int,F: int > rat,C: rat] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_eq_int @ X4 @ Y2 )
             => ( ord_less_eq_rat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_rat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_126_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > real,C: real] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_127_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_128_eq__iff,axiom,
    ( ( ^ [Y4: real,Z2: real] : ( Y4 = Z2 ) )
    = ( ^ [X3: real,Y5: real] :
          ( ( ord_less_eq_real @ X3 @ Y5 )
          & ( ord_less_eq_real @ Y5 @ X3 ) ) ) )).

% eq_iff
thf(fact_129_eq__iff,axiom,
    ( ( ^ [Y4: int,Z2: int] : ( Y4 = Z2 ) )
    = ( ^ [X3: int,Y5: int] :
          ( ( ord_less_eq_int @ X3 @ Y5 )
          & ( ord_less_eq_int @ Y5 @ X3 ) ) ) )).

% eq_iff
thf(fact_130_eq__iff,axiom,
    ( ( ^ [Y4: nat,Z2: nat] : ( Y4 = Z2 ) )
    = ( ^ [X3: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X3 @ Y5 )
          & ( ord_less_eq_nat @ Y5 @ X3 ) ) ) )).

% eq_iff
thf(fact_131_eq__iff,axiom,
    ( ( ^ [Y4: rat,Z2: rat] : ( Y4 = Z2 ) )
    = ( ^ [X3: rat,Y5: rat] :
          ( ( ord_less_eq_rat @ X3 @ Y5 )
          & ( ord_less_eq_rat @ Y5 @ X3 ) ) ) )).

% eq_iff
thf(fact_132_antisym,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ X @ Y )
     => ( ( ord_less_eq_real @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_133_antisym,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_eq_int @ X @ Y )
     => ( ( ord_less_eq_int @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_134_antisym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_135_antisym,axiom,(
    ! [X: rat,Y: rat] :
      ( ( ord_less_eq_rat @ X @ Y )
     => ( ( ord_less_eq_rat @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_136_linear,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ X @ Y )
      | ( ord_less_eq_real @ Y @ X ) ) )).

% linear
thf(fact_137_linear,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_eq_int @ X @ Y )
      | ( ord_less_eq_int @ Y @ X ) ) )).

% linear
thf(fact_138_linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_eq_nat @ Y @ X ) ) )).

% linear
thf(fact_139_linear,axiom,(
    ! [X: rat,Y: rat] :
      ( ( ord_less_eq_rat @ X @ Y )
      | ( ord_less_eq_rat @ Y @ X ) ) )).

% linear
thf(fact_140_eq__refl,axiom,(
    ! [X: real,Y: real] :
      ( ( X = Y )
     => ( ord_less_eq_real @ X @ Y ) ) )).

% eq_refl
thf(fact_141_eq__refl,axiom,(
    ! [X: int,Y: int] :
      ( ( X = Y )
     => ( ord_less_eq_int @ X @ Y ) ) )).

% eq_refl
thf(fact_142_eq__refl,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X = Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% eq_refl
thf(fact_143_eq__refl,axiom,(
    ! [X: rat,Y: rat] :
      ( ( X = Y )
     => ( ord_less_eq_rat @ X @ Y ) ) )).

% eq_refl
thf(fact_144_le__cases,axiom,(
    ! [X: real,Y: real] :
      ( ~ ( ord_less_eq_real @ X @ Y )
     => ( ord_less_eq_real @ Y @ X ) ) )).

% le_cases
thf(fact_145_le__cases,axiom,(
    ! [X: int,Y: int] :
      ( ~ ( ord_less_eq_int @ X @ Y )
     => ( ord_less_eq_int @ Y @ X ) ) )).

% le_cases
thf(fact_146_le__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% le_cases
thf(fact_147_le__cases,axiom,(
    ! [X: rat,Y: rat] :
      ( ~ ( ord_less_eq_rat @ X @ Y )
     => ( ord_less_eq_rat @ Y @ X ) ) )).

% le_cases
thf(fact_148_order_Otrans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ord_less_eq_real @ A @ C ) ) ) )).

% order.trans
thf(fact_149_order_Otrans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ord_less_eq_int @ A @ C ) ) ) )).

% order.trans
thf(fact_150_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_151_order_Otrans,axiom,(
    ! [A: rat,B: rat,C: rat] :
      ( ( ord_less_eq_rat @ A @ B )
     => ( ( ord_less_eq_rat @ B @ C )
       => ( ord_less_eq_rat @ A @ C ) ) ) )).

% order.trans
thf(fact_152_le__cases3,axiom,(
    ! [X: real,Y: real,Z: real] :
      ( ( ( ord_less_eq_real @ X @ Y )
       => ~ ( ord_less_eq_real @ Y @ Z ) )
     => ( ( ( ord_less_eq_real @ Y @ X )
         => ~ ( ord_less_eq_real @ X @ Z ) )
       => ( ( ( ord_less_eq_real @ X @ Z )
           => ~ ( ord_less_eq_real @ Z @ Y ) )
         => ( ( ( ord_less_eq_real @ Z @ Y )
             => ~ ( ord_less_eq_real @ Y @ X ) )
           => ( ( ( ord_less_eq_real @ Y @ Z )
               => ~ ( ord_less_eq_real @ Z @ X ) )
             => ~ ( ( ord_less_eq_real @ Z @ X )
                 => ~ ( ord_less_eq_real @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_153_le__cases3,axiom,(
    ! [X: int,Y: int,Z: int] :
      ( ( ( ord_less_eq_int @ X @ Y )
       => ~ ( ord_less_eq_int @ Y @ Z ) )
     => ( ( ( ord_less_eq_int @ Y @ X )
         => ~ ( ord_less_eq_int @ X @ Z ) )
       => ( ( ( ord_less_eq_int @ X @ Z )
           => ~ ( ord_less_eq_int @ Z @ Y ) )
         => ( ( ( ord_less_eq_int @ Z @ Y )
             => ~ ( ord_less_eq_int @ Y @ X ) )
           => ( ( ( ord_less_eq_int @ Y @ Z )
               => ~ ( ord_less_eq_int @ Z @ X ) )
             => ~ ( ( ord_less_eq_int @ Z @ X )
                 => ~ ( ord_less_eq_int @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_154_le__cases3,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y )
       => ~ ( ord_less_eq_nat @ Y @ Z ) )
     => ( ( ( ord_less_eq_nat @ Y @ X )
         => ~ ( ord_less_eq_nat @ X @ Z ) )
       => ( ( ( ord_less_eq_nat @ X @ Z )
           => ~ ( ord_less_eq_nat @ Z @ Y ) )
         => ( ( ( ord_less_eq_nat @ Z @ Y )
             => ~ ( ord_less_eq_nat @ Y @ X ) )
           => ( ( ( ord_less_eq_nat @ Y @ Z )
               => ~ ( ord_less_eq_nat @ Z @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_155_le__cases3,axiom,(
    ! [X: rat,Y: rat,Z: rat] :
      ( ( ( ord_less_eq_rat @ X @ Y )
       => ~ ( ord_less_eq_rat @ Y @ Z ) )
     => ( ( ( ord_less_eq_rat @ Y @ X )
         => ~ ( ord_less_eq_rat @ X @ Z ) )
       => ( ( ( ord_less_eq_rat @ X @ Z )
           => ~ ( ord_less_eq_rat @ Z @ Y ) )
         => ( ( ( ord_less_eq_rat @ Z @ Y )
             => ~ ( ord_less_eq_rat @ Y @ X ) )
           => ( ( ( ord_less_eq_rat @ Y @ Z )
               => ~ ( ord_less_eq_rat @ Z @ X ) )
             => ~ ( ( ord_less_eq_rat @ Z @ X )
                 => ~ ( ord_less_eq_rat @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_156_antisym__conv,axiom,(
    ! [Y: real,X: real] :
      ( ( ord_less_eq_real @ Y @ X )
     => ( ( ord_less_eq_real @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_157_antisym__conv,axiom,(
    ! [Y: int,X: int] :
      ( ( ord_less_eq_int @ Y @ X )
     => ( ( ord_less_eq_int @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_158_antisym__conv,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_159_antisym__conv,axiom,(
    ! [Y: rat,X: rat] :
      ( ( ord_less_eq_rat @ Y @ X )
     => ( ( ord_less_eq_rat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_160_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: real,Z2: real] : ( Y4 = Z2 ) )
    = ( ^ [A3: real,B2: real] :
          ( ( ord_less_eq_real @ A3 @ B2 )
          & ( ord_less_eq_real @ B2 @ A3 ) ) ) )).

% order_class.order.eq_iff
thf(fact_161_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: int,Z2: int] : ( Y4 = Z2 ) )
    = ( ^ [A3: int,B2: int] :
          ( ( ord_less_eq_int @ A3 @ B2 )
          & ( ord_less_eq_int @ B2 @ A3 ) ) ) )).

% order_class.order.eq_iff
thf(fact_162_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: nat,Z2: nat] : ( Y4 = Z2 ) )
    = ( ^ [A3: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A3 @ B2 )
          & ( ord_less_eq_nat @ B2 @ A3 ) ) ) )).

% order_class.order.eq_iff
thf(fact_163_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: rat,Z2: rat] : ( Y4 = Z2 ) )
    = ( ^ [A3: rat,B2: rat] :
          ( ( ord_less_eq_rat @ A3 @ B2 )
          & ( ord_less_eq_rat @ B2 @ A3 ) ) ) )).

% order_class.order.eq_iff
thf(fact_164_ord__eq__le__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( A = B )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ord_less_eq_real @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_165_ord__eq__le__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( A = B )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ord_less_eq_int @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_166_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_167_ord__eq__le__trans,axiom,(
    ! [A: rat,B: rat,C: rat] :
      ( ( A = B )
     => ( ( ord_less_eq_rat @ B @ C )
       => ( ord_less_eq_rat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_168_ord__le__eq__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_real @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_169_ord__le__eq__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_int @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_170_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_171_ord__le__eq__trans,axiom,(
    ! [A: rat,B: rat,C: rat] :
      ( ( ord_less_eq_rat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_rat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_172_order__class_Oorder_Oantisym,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_173_order__class_Oorder_Oantisym,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_174_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_175_order__class_Oorder_Oantisym,axiom,(
    ! [A: rat,B: rat] :
      ( ( ord_less_eq_rat @ A @ B )
     => ( ( ord_less_eq_rat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_176_order__trans,axiom,(
    ! [X: real,Y: real,Z: real] :
      ( ( ord_less_eq_real @ X @ Y )
     => ( ( ord_less_eq_real @ Y @ Z )
       => ( ord_less_eq_real @ X @ Z ) ) ) )).

% order_trans
thf(fact_177_order__trans,axiom,(
    ! [X: int,Y: int,Z: int] :
      ( ( ord_less_eq_int @ X @ Y )
     => ( ( ord_less_eq_int @ Y @ Z )
       => ( ord_less_eq_int @ X @ Z ) ) ) )).

% order_trans
thf(fact_178_order__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z )
       => ( ord_less_eq_nat @ X @ Z ) ) ) )).

% order_trans
thf(fact_179_order__trans,axiom,(
    ! [X: rat,Y: rat,Z: rat] :
      ( ( ord_less_eq_rat @ X @ Y )
     => ( ( ord_less_eq_rat @ Y @ Z )
       => ( ord_less_eq_rat @ X @ Z ) ) ) )).

% order_trans
thf(fact_180_dual__order_Orefl,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ A @ A ) )).

% dual_order.refl
thf(fact_181_dual__order_Orefl,axiom,(
    ! [A: int] :
      ( ord_less_eq_int @ A @ A ) )).

% dual_order.refl
thf(fact_182_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_183_dual__order_Orefl,axiom,(
    ! [A: rat] :
      ( ord_less_eq_rat @ A @ A ) )).

% dual_order.refl
thf(fact_184_linorder__wlog,axiom,(
    ! [P: real > real > $o,A: real,B: real] :
      ( ! [A4: real,B3: real] :
          ( ( ord_less_eq_real @ A4 @ B3 )
         => ( P @ A4 @ B3 ) )
     => ( ! [A4: real,B3: real] :
            ( ( P @ B3 @ A4 )
           => ( P @ A4 @ B3 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_185_linorder__wlog,axiom,(
    ! [P: int > int > $o,A: int,B: int] :
      ( ! [A4: int,B3: int] :
          ( ( ord_less_eq_int @ A4 @ B3 )
         => ( P @ A4 @ B3 ) )
     => ( ! [A4: int,B3: int] :
            ( ( P @ B3 @ A4 )
           => ( P @ A4 @ B3 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_186_linorder__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A4: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A4 @ B3 )
         => ( P @ A4 @ B3 ) )
     => ( ! [A4: nat,B3: nat] :
            ( ( P @ B3 @ A4 )
           => ( P @ A4 @ B3 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_187_linorder__wlog,axiom,(
    ! [P: rat > rat > $o,A: rat,B: rat] :
      ( ! [A4: rat,B3: rat] :
          ( ( ord_less_eq_rat @ A4 @ B3 )
         => ( P @ A4 @ B3 ) )
     => ( ! [A4: rat,B3: rat] :
            ( ( P @ B3 @ A4 )
           => ( P @ A4 @ B3 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_188_dual__order_Otrans,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ C @ B )
       => ( ord_less_eq_real @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_189_dual__order_Otrans,axiom,(
    ! [B: int,A: int,C: int] :
      ( ( ord_less_eq_int @ B @ A )
     => ( ( ord_less_eq_int @ C @ B )
       => ( ord_less_eq_int @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_190_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_191_dual__order_Otrans,axiom,(
    ! [B: rat,A: rat,C: rat] :
      ( ( ord_less_eq_rat @ B @ A )
     => ( ( ord_less_eq_rat @ C @ B )
       => ( ord_less_eq_rat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_192_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: real,Z2: real] : ( Y4 = Z2 ) )
    = ( ^ [A3: real,B2: real] :
          ( ( ord_less_eq_real @ B2 @ A3 )
          & ( ord_less_eq_real @ A3 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_193_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: int,Z2: int] : ( Y4 = Z2 ) )
    = ( ^ [A3: int,B2: int] :
          ( ( ord_less_eq_int @ B2 @ A3 )
          & ( ord_less_eq_int @ A3 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_194_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: nat,Z2: nat] : ( Y4 = Z2 ) )
    = ( ^ [A3: nat,B2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A3 )
          & ( ord_less_eq_nat @ A3 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_195_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: rat,Z2: rat] : ( Y4 = Z2 ) )
    = ( ^ [A3: rat,B2: rat] :
          ( ( ord_less_eq_rat @ B2 @ A3 )
          & ( ord_less_eq_rat @ A3 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_196_dual__order_Oantisym,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_197_dual__order_Oantisym,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_eq_int @ B @ A )
     => ( ( ord_less_eq_int @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_198_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_199_dual__order_Oantisym,axiom,(
    ! [B: rat,A: rat] :
      ( ( ord_less_eq_rat @ B @ A )
     => ( ( ord_less_eq_rat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_200_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_201_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_int @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_202_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_real @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_203_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_204_order_Ostrict__implies__not__eq,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_205_order_Ostrict__implies__not__eq,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_206_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ( ord_less_nat @ Y @ X )
        | ( X = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_207_not__less__iff__gr__or__eq,axiom,(
    ! [X: int,Y: int] :
      ( ( ~ ( ord_less_int @ X @ Y ) )
      = ( ( ord_less_int @ Y @ X )
        | ( X = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_208_not__less__iff__gr__or__eq,axiom,(
    ! [X: real,Y: real] :
      ( ( ~ ( ord_less_real @ X @ Y ) )
      = ( ( ord_less_real @ Y @ X )
        | ( X = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_209_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_210_dual__order_Ostrict__trans,axiom,(
    ! [B: int,A: int,C: int] :
      ( ( ord_less_int @ B @ A )
     => ( ( ord_less_int @ C @ B )
       => ( ord_less_int @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_211_dual__order_Ostrict__trans,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_real @ B @ A )
     => ( ( ord_less_real @ C @ B )
       => ( ord_less_real @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_212_linorder__less__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A4: nat,B3: nat] :
          ( ( ord_less_nat @ A4 @ B3 )
         => ( P @ A4 @ B3 ) )
     => ( ! [A4: nat] :
            ( P @ A4 @ A4 )
       => ( ! [A4: nat,B3: nat] :
              ( ( P @ B3 @ A4 )
             => ( P @ A4 @ B3 ) )
         => ( P @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_213_linorder__less__wlog,axiom,(
    ! [P: int > int > $o,A: int,B: int] :
      ( ! [A4: int,B3: int] :
          ( ( ord_less_int @ A4 @ B3 )
         => ( P @ A4 @ B3 ) )
     => ( ! [A4: int] :
            ( P @ A4 @ A4 )
       => ( ! [A4: int,B3: int] :
              ( ( P @ B3 @ A4 )
             => ( P @ A4 @ B3 ) )
         => ( P @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_214_linorder__less__wlog,axiom,(
    ! [P: real > real > $o,A: real,B: real] :
      ( ! [A4: real,B3: real] :
          ( ( ord_less_real @ A4 @ B3 )
         => ( P @ A4 @ B3 ) )
     => ( ! [A4: real] :
            ( P @ A4 @ A4 )
       => ( ! [A4: real,B3: real] :
              ( ( P @ B3 @ A4 )
             => ( P @ A4 @ B3 ) )
         => ( P @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_215_exists__least__iff,axiom,
    ( ( ^ [P3: nat > $o] :
        ? [X5: nat] :
          ( P3 @ X5 ) )
    = ( ^ [P4: nat > $o] :
        ? [N2: nat] :
          ( ( P4 @ N2 )
          & ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ~ ( P4 @ M2 ) ) ) ) )).

% exists_least_iff
thf(fact_216_less__imp__not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_imp_not_less
thf(fact_217_less__imp__not__less,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ~ ( ord_less_int @ Y @ X ) ) )).

% less_imp_not_less
thf(fact_218_less__imp__not__less,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_real @ X @ Y )
     => ~ ( ord_less_real @ Y @ X ) ) )).

% less_imp_not_less
thf(fact_219_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_220_order_Ostrict__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_int @ B @ C )
       => ( ord_less_int @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_221_order_Ostrict__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_real @ B @ C )
       => ( ord_less_real @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_222_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_223_dual__order_Oirrefl,axiom,(
    ! [A: int] :
      ~ ( ord_less_int @ A @ A ) )).

% dual_order.irrefl
thf(fact_224_dual__order_Oirrefl,axiom,(
    ! [A: real] :
      ~ ( ord_less_real @ A @ A ) )).

% dual_order.irrefl
thf(fact_225_linorder__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_226_linorder__cases,axiom,(
    ! [X: int,Y: int] :
      ( ~ ( ord_less_int @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_int @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_227_linorder__cases,axiom,(
    ! [X: real,Y: real] :
      ( ~ ( ord_less_real @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_real @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_228_less__imp__triv,axiom,(
    ! [X: nat,Y: nat,P: $o] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_229_less__imp__triv,axiom,(
    ! [X: int,Y: int,P: $o] :
      ( ( ord_less_int @ X @ Y )
     => ( ( ord_less_int @ Y @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_230_less__imp__triv,axiom,(
    ! [X: real,Y: real,P: $o] :
      ( ( ord_less_real @ X @ Y )
     => ( ( ord_less_real @ Y @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_231_less__imp__not__eq2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_232_less__imp__not__eq2,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_233_less__imp__not__eq2,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_real @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_234_antisym__conv3,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_235_antisym__conv3,axiom,(
    ! [Y: int,X: int] :
      ( ~ ( ord_less_int @ Y @ X )
     => ( ( ~ ( ord_less_int @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_236_antisym__conv3,axiom,(
    ! [Y: real,X: real] :
      ( ~ ( ord_less_real @ Y @ X )
     => ( ( ~ ( ord_less_real @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_237_less__induct,axiom,(
    ! [P: nat > $o,A: nat] :
      ( ! [X4: nat] :
          ( ! [Y3: nat] :
              ( ( ord_less_nat @ Y3 @ X4 )
             => ( P @ Y3 ) )
         => ( P @ X4 ) )
     => ( P @ A ) ) )).

% less_induct
thf(fact_238_less__not__sym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_not_sym
thf(fact_239_less__not__sym,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ~ ( ord_less_int @ Y @ X ) ) )).

% less_not_sym
thf(fact_240_less__not__sym,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_real @ X @ Y )
     => ~ ( ord_less_real @ Y @ X ) ) )).

% less_not_sym
thf(fact_241_less__imp__not__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_242_less__imp__not__eq,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_243_less__imp__not__eq,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_real @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_244_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_245_dual__order_Oasym,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_int @ B @ A )
     => ~ ( ord_less_int @ A @ B ) ) )).

% dual_order.asym
thf(fact_246_dual__order_Oasym,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_real @ B @ A )
     => ~ ( ord_less_real @ A @ B ) ) )).

% dual_order.asym
thf(fact_247_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_248_ord__less__eq__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( B = C )
       => ( ord_less_int @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_249_ord__less__eq__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( B = C )
       => ( ord_less_real @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_250_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_251_ord__eq__less__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( A = B )
     => ( ( ord_less_int @ B @ C )
       => ( ord_less_int @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_252_ord__eq__less__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( A = B )
     => ( ( ord_less_real @ B @ C )
       => ( ord_less_real @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_253_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_254_less__irrefl,axiom,(
    ! [X: int] :
      ~ ( ord_less_int @ X @ X ) )).

% less_irrefl
thf(fact_255_less__irrefl,axiom,(
    ! [X: real] :
      ~ ( ord_less_real @ X @ X ) )).

% less_irrefl
thf(fact_256_less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
      | ( X = Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% less_linear
thf(fact_257_less__linear,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
      | ( X = Y )
      | ( ord_less_int @ Y @ X ) ) )).

% less_linear
thf(fact_258_less__linear,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_real @ X @ Y )
      | ( X = Y )
      | ( ord_less_real @ Y @ X ) ) )).

% less_linear
thf(fact_259_less__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% less_trans
thf(fact_260_less__trans,axiom,(
    ! [X: int,Y: int,Z: int] :
      ( ( ord_less_int @ X @ Y )
     => ( ( ord_less_int @ Y @ Z )
       => ( ord_less_int @ X @ Z ) ) ) )).

% less_trans
thf(fact_261_less__trans,axiom,(
    ! [X: real,Y: real,Z: real] :
      ( ( ord_less_real @ X @ Y )
     => ( ( ord_less_real @ Y @ Z )
       => ( ord_less_real @ X @ Z ) ) ) )).

% less_trans
thf(fact_262_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_263_less__asym_H,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ~ ( ord_less_int @ B @ A ) ) )).

% less_asym'
thf(fact_264_less__asym_H,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ B )
     => ~ ( ord_less_real @ B @ A ) ) )).

% less_asym'
thf(fact_265_less__asym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_asym
thf(fact_266_less__asym,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ~ ( ord_less_int @ Y @ X ) ) )).

% less_asym
thf(fact_267_less__asym,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_real @ X @ Y )
     => ~ ( ord_less_real @ Y @ X ) ) )).

% less_asym
thf(fact_268_less__imp__neq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_269_less__imp__neq,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_270_less__imp__neq,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_real @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_271_dense,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_real @ X @ Y )
     => ? [Z3: real] :
          ( ( ord_less_real @ X @ Z3 )
          & ( ord_less_real @ Z3 @ Y ) ) ) )).

% dense
thf(fact_272_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_273_order_Oasym,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ~ ( ord_less_int @ B @ A ) ) )).

% order.asym
thf(fact_274_order_Oasym,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ B )
     => ~ ( ord_less_real @ B @ A ) ) )).

% order.asym
thf(fact_275_neq__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
      = ( ( ord_less_nat @ X @ Y )
        | ( ord_less_nat @ Y @ X ) ) ) )).

% neq_iff
thf(fact_276_neq__iff,axiom,(
    ! [X: int,Y: int] :
      ( ( X != Y )
      = ( ( ord_less_int @ X @ Y )
        | ( ord_less_int @ Y @ X ) ) ) )).

% neq_iff
thf(fact_277_neq__iff,axiom,(
    ! [X: real,Y: real] :
      ( ( X != Y )
      = ( ( ord_less_real @ X @ Y )
        | ( ord_less_real @ Y @ X ) ) ) )).

% neq_iff
thf(fact_278_neqE,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% neqE
thf(fact_279_neqE,axiom,(
    ! [X: int,Y: int] :
      ( ( X != Y )
     => ( ~ ( ord_less_int @ X @ Y )
       => ( ord_less_int @ Y @ X ) ) ) )).

% neqE
thf(fact_280_neqE,axiom,(
    ! [X: real,Y: real] :
      ( ( X != Y )
     => ( ~ ( ord_less_real @ X @ Y )
       => ( ord_less_real @ Y @ X ) ) ) )).

% neqE
thf(fact_281_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_282_gt__ex,axiom,(
    ! [X: int] :
    ? [X_1: int] :
      ( ord_less_int @ X @ X_1 ) )).

% gt_ex
thf(fact_283_gt__ex,axiom,(
    ! [X: real] :
    ? [X_1: real] :
      ( ord_less_real @ X @ X_1 ) )).

% gt_ex
thf(fact_284_lt__ex,axiom,(
    ! [X: int] :
    ? [Y2: int] :
      ( ord_less_int @ Y2 @ X ) )).

% lt_ex
thf(fact_285_lt__ex,axiom,(
    ! [X: real] :
    ? [Y2: real] :
      ( ord_less_real @ Y2 @ X ) )).

% lt_ex
thf(fact_286_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_287_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_288_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > real,C: real] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_real @ ( F @ B ) @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_289_order__less__subst2,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_int @ X4 @ Y2 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_290_order__less__subst2,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_int @ X4 @ Y2 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_291_order__less__subst2,axiom,(
    ! [A: int,B: int,F: int > real,C: real] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_real @ ( F @ B ) @ C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_int @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_292_order__less__subst2,axiom,(
    ! [A: real,B: real,F: real > nat,C: nat] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_293_order__less__subst2,axiom,(
    ! [A: real,B: real,F: real > int,C: int] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_294_order__less__subst2,axiom,(
    ! [A: real,B: real,F: real > real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_real @ ( F @ B ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_295_order__less__subst1,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_int @ X4 @ Y2 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_296_order__less__subst1,axiom,(
    ! [A: int,F: real > int,B: real,C: real] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_real @ B @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_297_order__less__subst1,axiom,(
    ! [A: real,F: nat > real,B: nat,C: nat] :
      ( ( ord_less_real @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_298_order__less__subst1,axiom,(
    ! [A: real,F: int > real,B: int,C: int] :
      ( ( ord_less_real @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X4: int,Y2: int] :
              ( ( ord_less_int @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_299_order__less__subst1,axiom,(
    ! [A: real,F: real > real,B: real,C: real] :
      ( ( ord_less_real @ A @ ( F @ B ) )
     => ( ( ord_less_real @ B @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_300_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI
thf(fact_301_bot__nat__0_Oextremum__unique,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
      = ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique
thf(fact_302_le__0__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_0_eq
thf(fact_303_less__eq__nat_Osimps_I1_J,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% less_eq_nat.simps(1)
thf(fact_304_real__root__less__mono,axiom,(
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_real @ X @ Y )
       => ( ord_less_real @ ( root @ N @ X ) @ ( root @ N @ Y ) ) ) ) )).

% real_root_less_mono
thf(fact_305_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_nat @ I2 @ J2 )
         => ( ord_less_nat @ ( F @ I2 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I @ J )
       => ( ord_less_eq_nat @ ( F @ I ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_306_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_307_linorder__neqE__nat,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_308_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_309_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M2: nat,N2: nat] :
          ( ( ord_less_nat @ M2 @ N2 )
          | ( M2 = N2 ) ) ) )).

% le_eq_less_or_eq
thf(fact_310_infinite__descent,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ~ ( P @ N3 )
         => ? [M3: nat] :
              ( ( ord_less_nat @ M3 @ N3 )
              & ~ ( P @ M3 ) ) )
     => ( P @ N ) ) )).

% infinite_descent
thf(fact_311_nat__less__induct,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M3: nat] :
              ( ( ord_less_nat @ M3 @ N3 )
             => ( P @ M3 ) )
         => ( P @ N3 ) )
     => ( P @ N ) ) )).

% nat_less_induct
thf(fact_312_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_313_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_314_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_315_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_316_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_317_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_318_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M2: nat,N2: nat] :
          ( ( ord_less_eq_nat @ M2 @ N2 )
          & ( M2 != N2 ) ) ) )).

% nat_less_le
thf(fact_319_real__root__gt__zero,axiom,(
    ! [N: nat,X: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_real @ zero_zero_real @ X )
       => ( ord_less_real @ zero_zero_real @ ( root @ N @ X ) ) ) ) )).

% real_root_gt_zero
thf(fact_320_real__root__pos__pos,axiom,(
    ! [N: nat,X: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_real @ zero_zero_real @ X )
       => ( ord_less_eq_real @ zero_zero_real @ ( root @ N @ X ) ) ) ) )).

% real_root_pos_pos
thf(fact_321_bot__nat__0_Oextremum__strict,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ zero_zero_nat ) )).

% bot_nat_0.extremum_strict
thf(fact_322_infinite__descent0,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ zero_zero_nat )
     => ( ! [N3: nat] :
            ( ( ord_less_nat @ zero_zero_nat @ N3 )
           => ( ~ ( P @ N3 )
             => ? [M3: nat] :
                  ( ( ord_less_nat @ M3 @ N3 )
                  & ~ ( P @ M3 ) ) ) )
       => ( P @ N ) ) ) )).

% infinite_descent0
thf(fact_323_gr__implies__not0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not0
thf(fact_324_ex__least__nat__le,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ zero_zero_nat )
       => ? [K2: nat] :
            ( ( ord_less_eq_nat @ K2 @ N )
            & ! [I3: nat] :
                ( ( ord_less_nat @ I3 @ K2 )
               => ~ ( P @ I3 ) )
            & ( P @ K2 ) ) ) ) )).

% ex_least_nat_le
thf(fact_325_less__zeroE,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_zeroE
thf(fact_326_not__less0,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less0
thf(fact_327_nat__descend__induct,axiom,(
    ! [N: nat,P: nat > $o,M: nat] :
      ( ! [K2: nat] :
          ( ( ord_less_nat @ N @ K2 )
         => ( P @ K2 ) )
     => ( ! [K2: nat] :
            ( ( ord_less_eq_nat @ K2 @ N )
           => ( ! [I3: nat] :
                  ( ( ord_less_nat @ K2 @ I3 )
                 => ( P @ I3 ) )
             => ( P @ K2 ) ) )
       => ( P @ M ) ) ) )).

% nat_descend_induct
thf(fact_328_l2pos,axiom,(
    ord_less_eq_int @ zero_zero_int @ l2x )).

% l2pos
thf(fact_329_real__root__increasing,axiom,(
    ! [N: nat,N4: nat,X: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_eq_nat @ N @ N4 )
       => ( ( ord_less_eq_real @ zero_zero_real @ X )
         => ( ( ord_less_eq_real @ X @ one_one_real )
           => ( ord_less_eq_real @ ( root @ N @ X ) @ ( root @ N4 @ X ) ) ) ) ) ) )).

% real_root_increasing
thf(fact_330_real__root__eq__1__iff,axiom,(
    ! [N: nat,X: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ( root @ N @ X )
          = one_one_real )
        = ( X = one_one_real ) ) ) )).

% real_root_eq_1_iff
thf(fact_331_real__root__one,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( root @ N @ one_one_real )
        = one_one_real ) ) )).

% real_root_one
thf(fact_332_real__root__gt__1__iff,axiom,(
    ! [N: nat,Y: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_real @ one_one_real @ ( root @ N @ Y ) )
        = ( ord_less_real @ one_one_real @ Y ) ) ) )).

% real_root_gt_1_iff
thf(fact_333_real__root__lt__1__iff,axiom,(
    ! [N: nat,X: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_real @ ( root @ N @ X ) @ one_one_real )
        = ( ord_less_real @ X @ one_one_real ) ) ) )).

% real_root_lt_1_iff
thf(fact_334_real__root__le__1__iff,axiom,(
    ! [N: nat,X: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_eq_real @ ( root @ N @ X ) @ one_one_real )
        = ( ord_less_eq_real @ X @ one_one_real ) ) ) )).

% real_root_le_1_iff
thf(fact_335_real__root__ge__1__iff,axiom,(
    ! [N: nat,Y: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_eq_real @ one_one_real @ ( root @ N @ Y ) )
        = ( ord_less_eq_real @ one_one_real @ Y ) ) ) )).

% real_root_ge_1_iff
thf(fact_336_real__root__strict__decreasing,axiom,(
    ! [N: nat,N4: nat,X: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_nat @ N @ N4 )
       => ( ( ord_less_real @ one_one_real @ X )
         => ( ord_less_real @ ( root @ N4 @ X ) @ ( root @ N @ X ) ) ) ) ) )).

% real_root_strict_decreasing
thf(fact_337_real__root__strict__increasing,axiom,(
    ! [N: nat,N4: nat,X: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_nat @ N @ N4 )
       => ( ( ord_less_real @ zero_zero_real @ X )
         => ( ( ord_less_real @ X @ one_one_real )
           => ( ord_less_real @ ( root @ N @ X ) @ ( root @ N4 @ X ) ) ) ) ) ) )).

% real_root_strict_increasing
thf(fact_338_real__root__decreasing,axiom,(
    ! [N: nat,N4: nat,X: real] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_eq_nat @ N @ N4 )
       => ( ( ord_less_eq_real @ one_one_real @ X )
         => ( ord_less_eq_real @ ( root @ N4 @ X ) @ ( root @ N @ X ) ) ) ) ) )).

% real_root_decreasing
thf(fact_339_less__one,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ N @ one_one_nat )
      = ( N = zero_zero_nat ) ) )).

% less_one
thf(fact_340_int__one__le__iff__zero__less,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq_int @ one_one_int @ Z )
      = ( ord_less_int @ zero_zero_int @ Z ) ) )).

% int_one_le_iff_zero_less
thf(fact_341__092_060open_062real__of__int_Al2x_A_061_Areal__of__rat_A_Irat__of__int_Al2x_J_092_060close_062,axiom,
    ( ( ring_1_of_int_real @ l2x )
    = ( field_240844524t_real @ ( ring_1_of_int_rat @ l2x ) ) )).

% \<open>real_of_int l2x = real_of_rat (rat_of_int l2x)\<close>
thf(fact_342_less__eq__real__def,axiom,
    ( ord_less_eq_real
    = ( ^ [X3: real,Y5: real] :
          ( ( ord_less_real @ X3 @ Y5 )
          | ( X3 = Y5 ) ) ) )).

% less_eq_real_def
thf(fact_343_of__rat__dense,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_real @ X @ Y )
     => ? [Q: rat] :
          ( ( ord_less_real @ X @ ( field_240844524t_real @ Q ) )
          & ( ord_less_real @ ( field_240844524t_real @ Q ) @ Y ) ) ) )).

% of_rat_dense
thf(fact_344_complete__real,axiom,(
    ! [S2: set_real] :
      ( ? [X6: real] :
          ( member_real @ X6 @ S2 )
     => ( ? [Z4: real] :
          ! [X4: real] :
            ( ( member_real @ X4 @ S2 )
           => ( ord_less_eq_real @ X4 @ Z4 ) )
       => ? [Y2: real] :
            ( ! [X6: real] :
                ( ( member_real @ X6 @ S2 )
               => ( ord_less_eq_real @ X6 @ Y2 ) )
            & ! [Z4: real] :
                ( ! [X4: real] :
                    ( ( member_real @ X4 @ S2 )
                   => ( ord_less_eq_real @ X4 @ Z4 ) )
               => ( ord_less_eq_real @ Y2 @ Z4 ) ) ) ) ) )).

% complete_real

% Conjectures (1)
thf(conj_0,conjecture,(
    ord_less_eq_real @ zero_zero_real @ ( root @ p @ ( ring_1_of_int_real @ x ) ) )).

%------------------------------------------------------------------------------
