%------------------------------------------------------------------------------
% File     : SLH219^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Descartes_Sign_Rule problem prob_464__5869374_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Descartes_Sign_Rule/prob_464__5869374_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  247 (   0 unit;  16 type;   0 defn)
%            Number of atoms       : 2561 ( 198 equality;1338 variable)
%            Maximal formula depth :   14 (   8 average)
%            Number of connectives : 1988 (  54   ~;  21   |;  39   &;1603   @)
%                                         (   0 <=>; 271  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   26 (  26   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   18 (  16   :;   0   =)
%            Number of variables   :  602 (   1 sgn; 578   !;   6   ?;  18   ^)
%                                         ( 602   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:41:27.188
%------------------------------------------------------------------------------
% Could-be-implicit typings (2)
thf(ty_n_t__List__Olist_Itf__a_J,type,(
    list_a: $tType )).

thf(ty_n_tf__a,type,(
    a: $tType )).

% Explicit typings (14)
thf(sy_c_Groups_Oplus__class_Oplus_001tf__a,type,(
    plus_plus_a: a > a > a )).

thf(sy_c_Groups_Otimes__class_Otimes_001tf__a,type,(
    times_times_a: a > a > a )).

thf(sy_c_Groups_Ozero__class_Ozero_001tf__a,type,(
    zero_zero_a: a )).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list_001tf__a,type,(
    groups1792256535list_a: list_a > a )).

thf(sy_c_List_Olast_001tf__a,type,(
    last_a: list_a > a )).

thf(sy_c_List_Olist_ONil_001tf__a,type,(
    nil_a: list_a )).

thf(sy_c_Orderings_Oord__class_Oless_001tf__a,type,(
    ord_less_a: a > a > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001tf__a,type,(
    ord_less_eq_a: a > a > $o )).

thf(sy_v_x,type,(
    x: a )).

thf(sy_v_xa____,type,(
    xa: a )).

thf(sy_v_xs,type,(
    xs: list_a )).

thf(sy_v_xsa____,type,(
    xsa: list_a )).

thf(sy_v_y,type,(
    y: a )).

thf(sy_v_ya____,type,(
    ya: a )).

% Relevant facts (230)
thf(fact_0_add__left__cancel,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ( plus_plus_a @ A @ B )
        = ( plus_plus_a @ A @ C ) )
      = ( B = C ) ) )).

% add_left_cancel
thf(fact_1_add__right__cancel,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( ( plus_plus_a @ B @ A )
        = ( plus_plus_a @ C @ A ) )
      = ( B = C ) ) )).

% add_right_cancel
thf(fact_2_xy,axiom,(
    ord_less_a @ zero_zero_a @ ( plus_plus_a @ xa @ ya ) )).

% xy
thf(fact_3_y,axiom,(
    ord_less_a @ ya @ zero_zero_a )).

% y
thf(fact_4_nonneg_Ohyps_I4_J,axiom,(
    ord_less_eq_a @ zero_zero_a @ xa )).

% nonneg.hyps(4)
thf(fact_5_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( plus_plus_a @ ( plus_plus_a @ A @ B ) @ C )
      = ( plus_plus_a @ A @ ( plus_plus_a @ B @ C ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_6_is__num__normalize_I1_J,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( plus_plus_a @ ( plus_plus_a @ A @ B ) @ C )
      = ( plus_plus_a @ A @ ( plus_plus_a @ B @ C ) ) ) )).

% is_num_normalize(1)
thf(fact_7_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( I = J )
        & ( K = L ) )
     => ( ( plus_plus_a @ I @ K )
        = ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_8_group__cancel_Oadd1,axiom,(
    ! [A2: a,K: a,A: a,B: a] :
      ( ( A2
        = ( plus_plus_a @ K @ A ) )
     => ( ( plus_plus_a @ A2 @ B )
        = ( plus_plus_a @ K @ ( plus_plus_a @ A @ B ) ) ) ) )).

% group_cancel.add1
thf(fact_9_group__cancel_Oadd2,axiom,(
    ! [B2: a,K: a,B: a,A: a] :
      ( ( B2
        = ( plus_plus_a @ K @ B ) )
     => ( ( plus_plus_a @ A @ B2 )
        = ( plus_plus_a @ K @ ( plus_plus_a @ A @ B ) ) ) ) )).

% group_cancel.add2
thf(fact_10_add_Oassoc,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( plus_plus_a @ ( plus_plus_a @ A @ B ) @ C )
      = ( plus_plus_a @ A @ ( plus_plus_a @ B @ C ) ) ) )).

% add.assoc
thf(fact_11_add_Oleft__cancel,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ( plus_plus_a @ A @ B )
        = ( plus_plus_a @ A @ C ) )
      = ( B = C ) ) )).

% add.left_cancel
thf(fact_12_x,axiom,(
    ord_less_a @ zero_zero_a @ xa )).

% x
thf(fact_13_add__cancel__right__right,axiom,(
    ! [A: a,B: a] :
      ( ( A
        = ( plus_plus_a @ A @ B ) )
      = ( B = zero_zero_a ) ) )).

% add_cancel_right_right
thf(fact_14_add__cancel__right__left,axiom,(
    ! [A: a,B: a] :
      ( ( A
        = ( plus_plus_a @ B @ A ) )
      = ( B = zero_zero_a ) ) )).

% add_cancel_right_left
thf(fact_15_add__cancel__left__right,axiom,(
    ! [A: a,B: a] :
      ( ( ( plus_plus_a @ A @ B )
        = A )
      = ( B = zero_zero_a ) ) )).

% add_cancel_left_right
thf(fact_16_add__cancel__left__left,axiom,(
    ! [B: a,A: a] :
      ( ( ( plus_plus_a @ B @ A )
        = A )
      = ( B = zero_zero_a ) ) )).

% add_cancel_left_left
thf(fact_17_double__zero__sym,axiom,(
    ! [A: a] :
      ( ( zero_zero_a
        = ( plus_plus_a @ A @ A ) )
      = ( A = zero_zero_a ) ) )).

% double_zero_sym
thf(fact_18_double__zero,axiom,(
    ! [A: a] :
      ( ( ( plus_plus_a @ A @ A )
        = zero_zero_a )
      = ( A = zero_zero_a ) ) )).

% double_zero
thf(fact_19_add_Oright__neutral,axiom,(
    ! [A: a] :
      ( ( plus_plus_a @ A @ zero_zero_a )
      = A ) )).

% add.right_neutral
thf(fact_20_add_Oleft__neutral,axiom,(
    ! [A: a] :
      ( ( plus_plus_a @ zero_zero_a @ A )
      = A ) )).

% add.left_neutral
thf(fact_21_add__le__cancel__right,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_eq_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ C ) )
      = ( ord_less_eq_a @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_22_add__le__cancel__left,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_eq_a @ ( plus_plus_a @ C @ A ) @ ( plus_plus_a @ C @ B ) )
      = ( ord_less_eq_a @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_23_add__less__cancel__right,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ C ) )
      = ( ord_less_a @ A @ B ) ) )).

% add_less_cancel_right
thf(fact_24_add__less__cancel__left,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ ( plus_plus_a @ C @ A ) @ ( plus_plus_a @ C @ B ) )
      = ( ord_less_a @ A @ B ) ) )).

% add_less_cancel_left
thf(fact_25_add__le__same__cancel1,axiom,(
    ! [B: a,A: a] :
      ( ( ord_less_eq_a @ ( plus_plus_a @ B @ A ) @ B )
      = ( ord_less_eq_a @ A @ zero_zero_a ) ) )).

% add_le_same_cancel1
thf(fact_26_add__le__same__cancel2,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ ( plus_plus_a @ A @ B ) @ B )
      = ( ord_less_eq_a @ A @ zero_zero_a ) ) )).

% add_le_same_cancel2
thf(fact_27_le__add__same__cancel1,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ A @ ( plus_plus_a @ A @ B ) )
      = ( ord_less_eq_a @ zero_zero_a @ B ) ) )).

% le_add_same_cancel1
thf(fact_28_le__add__same__cancel2,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ A @ ( plus_plus_a @ B @ A ) )
      = ( ord_less_eq_a @ zero_zero_a @ B ) ) )).

% le_add_same_cancel2
thf(fact_29_double__add__le__zero__iff__single__add__le__zero,axiom,(
    ! [A: a] :
      ( ( ord_less_eq_a @ ( plus_plus_a @ A @ A ) @ zero_zero_a )
      = ( ord_less_eq_a @ A @ zero_zero_a ) ) )).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_30_zero__le__double__add__iff__zero__le__single__add,axiom,(
    ! [A: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ ( plus_plus_a @ A @ A ) )
      = ( ord_less_eq_a @ zero_zero_a @ A ) ) )).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_31_add__less__same__cancel1,axiom,(
    ! [B: a,A: a] :
      ( ( ord_less_a @ ( plus_plus_a @ B @ A ) @ B )
      = ( ord_less_a @ A @ zero_zero_a ) ) )).

% add_less_same_cancel1
thf(fact_32_add__less__same__cancel2,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ ( plus_plus_a @ A @ B ) @ B )
      = ( ord_less_a @ A @ zero_zero_a ) ) )).

% add_less_same_cancel2
thf(fact_33_less__add__same__cancel1,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ A @ ( plus_plus_a @ A @ B ) )
      = ( ord_less_a @ zero_zero_a @ B ) ) )).

% less_add_same_cancel1
thf(fact_34_less__add__same__cancel2,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ A @ ( plus_plus_a @ B @ A ) )
      = ( ord_less_a @ zero_zero_a @ B ) ) )).

% less_add_same_cancel2
thf(fact_35_double__add__less__zero__iff__single__add__less__zero,axiom,(
    ! [A: a] :
      ( ( ord_less_a @ ( plus_plus_a @ A @ A ) @ zero_zero_a )
      = ( ord_less_a @ A @ zero_zero_a ) ) )).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_36_zero__less__double__add__iff__zero__less__single__add,axiom,(
    ! [A: a] :
      ( ( ord_less_a @ zero_zero_a @ ( plus_plus_a @ A @ A ) )
      = ( ord_less_a @ zero_zero_a @ A ) ) )).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_37_add__mono__thms__linordered__field_I4_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( ord_less_eq_a @ I @ J )
        & ( ord_less_a @ K @ L ) )
     => ( ord_less_a @ ( plus_plus_a @ I @ K ) @ ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(4)
thf(fact_38_add__mono__thms__linordered__field_I3_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( ord_less_a @ I @ J )
        & ( ord_less_eq_a @ K @ L ) )
     => ( ord_less_a @ ( plus_plus_a @ I @ K ) @ ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(3)
thf(fact_39_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_a @ zero_zero_a @ zero_zero_a )).

% le_numeral_extra(3)
thf(fact_40_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_a @ zero_zero_a @ zero_zero_a ) )).

% less_numeral_extra(3)
thf(fact_41_zero__reorient,axiom,(
    ! [X: a] :
      ( ( zero_zero_a = X )
      = ( X = zero_zero_a ) ) )).

% zero_reorient
thf(fact_42_add__neg__neg,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ A @ zero_zero_a )
     => ( ( ord_less_a @ B @ zero_zero_a )
       => ( ord_less_a @ ( plus_plus_a @ A @ B ) @ zero_zero_a ) ) ) )).

% add_neg_neg
thf(fact_43_add__pos__pos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ A )
     => ( ( ord_less_a @ zero_zero_a @ B )
       => ( ord_less_a @ zero_zero_a @ ( plus_plus_a @ A @ B ) ) ) ) )).

% add_pos_pos
thf(fact_44_add__decreasing,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_eq_a @ A @ zero_zero_a )
     => ( ( ord_less_eq_a @ C @ B )
       => ( ord_less_eq_a @ ( plus_plus_a @ A @ C ) @ B ) ) ) )).

% add_decreasing
thf(fact_45_add__increasing,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ A )
     => ( ( ord_less_eq_a @ B @ C )
       => ( ord_less_eq_a @ B @ ( plus_plus_a @ A @ C ) ) ) ) )).

% add_increasing
thf(fact_46_add__neg__nonpos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ A @ zero_zero_a )
     => ( ( ord_less_eq_a @ B @ zero_zero_a )
       => ( ord_less_a @ ( plus_plus_a @ A @ B ) @ zero_zero_a ) ) ) )).

% add_neg_nonpos
thf(fact_47_add__nonneg__pos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ A )
     => ( ( ord_less_a @ zero_zero_a @ B )
       => ( ord_less_a @ zero_zero_a @ ( plus_plus_a @ A @ B ) ) ) ) )).

% add_nonneg_pos
thf(fact_48_add__nonpos__neg,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ A @ zero_zero_a )
     => ( ( ord_less_a @ B @ zero_zero_a )
       => ( ord_less_a @ ( plus_plus_a @ A @ B ) @ zero_zero_a ) ) ) )).

% add_nonpos_neg
thf(fact_49_add__pos__nonneg,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ A )
     => ( ( ord_less_eq_a @ zero_zero_a @ B )
       => ( ord_less_a @ zero_zero_a @ ( plus_plus_a @ A @ B ) ) ) ) )).

% add_pos_nonneg
thf(fact_50_add__decreasing2,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_eq_a @ C @ zero_zero_a )
     => ( ( ord_less_eq_a @ A @ B )
       => ( ord_less_eq_a @ ( plus_plus_a @ A @ C ) @ B ) ) ) )).

% add_decreasing2
thf(fact_51_add__increasing2,axiom,(
    ! [C: a,B: a,A: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ C )
     => ( ( ord_less_eq_a @ B @ A )
       => ( ord_less_eq_a @ B @ ( plus_plus_a @ A @ C ) ) ) ) )).

% add_increasing2
thf(fact_52_add__nonneg__nonneg,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ A )
     => ( ( ord_less_eq_a @ zero_zero_a @ B )
       => ( ord_less_eq_a @ zero_zero_a @ ( plus_plus_a @ A @ B ) ) ) ) )).

% add_nonneg_nonneg
thf(fact_53_add__nonpos__nonpos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ A @ zero_zero_a )
     => ( ( ord_less_eq_a @ B @ zero_zero_a )
       => ( ord_less_eq_a @ ( plus_plus_a @ A @ B ) @ zero_zero_a ) ) ) )).

% add_nonpos_nonpos
thf(fact_54_add__nonneg__eq__0__iff,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ X )
     => ( ( ord_less_eq_a @ zero_zero_a @ Y )
       => ( ( ( plus_plus_a @ X @ Y )
            = zero_zero_a )
          = ( ( X = zero_zero_a )
            & ( Y = zero_zero_a ) ) ) ) ) )).

% add_nonneg_eq_0_iff
thf(fact_55_add__nonpos__eq__0__iff,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_eq_a @ X @ zero_zero_a )
     => ( ( ord_less_eq_a @ Y @ zero_zero_a )
       => ( ( ( plus_plus_a @ X @ Y )
            = zero_zero_a )
          = ( ( X = zero_zero_a )
            & ( Y = zero_zero_a ) ) ) ) ) )).

% add_nonpos_eq_0_iff
thf(fact_56_pos__add__strict,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_a @ zero_zero_a @ A )
     => ( ( ord_less_a @ B @ C )
       => ( ord_less_a @ B @ ( plus_plus_a @ A @ C ) ) ) ) )).

% pos_add_strict
thf(fact_57_add__le__less__mono,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_a @ C @ D )
       => ( ord_less_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ D ) ) ) ) )).

% add_le_less_mono
thf(fact_58_add__less__le__mono,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_eq_a @ C @ D )
       => ( ord_less_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ D ) ) ) ) )).

% add_less_le_mono
thf(fact_59_add__strict__increasing,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_a @ zero_zero_a @ A )
     => ( ( ord_less_eq_a @ B @ C )
       => ( ord_less_a @ B @ ( plus_plus_a @ A @ C ) ) ) ) )).

% add_strict_increasing
thf(fact_60_add__strict__increasing2,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ A )
     => ( ( ord_less_a @ B @ C )
       => ( ord_less_a @ B @ ( plus_plus_a @ A @ C ) ) ) ) )).

% add_strict_increasing2
thf(fact_61_add__less__imp__less__right,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ C ) )
     => ( ord_less_a @ A @ B ) ) )).

% add_less_imp_less_right
thf(fact_62_add__less__imp__less__left,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ ( plus_plus_a @ C @ A ) @ ( plus_plus_a @ C @ B ) )
     => ( ord_less_a @ A @ B ) ) )).

% add_less_imp_less_left
thf(fact_63_add__strict__right__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_a @ A @ B )
     => ( ord_less_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ C ) ) ) )).

% add_strict_right_mono
thf(fact_64_add__strict__left__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_a @ A @ B )
     => ( ord_less_a @ ( plus_plus_a @ C @ A ) @ ( plus_plus_a @ C @ B ) ) ) )).

% add_strict_left_mono
thf(fact_65_add__strict__mono,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_a @ C @ D )
       => ( ord_less_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ D ) ) ) ) )).

% add_strict_mono
thf(fact_66_add__mono__thms__linordered__field_I1_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( ord_less_a @ I @ J )
        & ( K = L ) )
     => ( ord_less_a @ ( plus_plus_a @ I @ K ) @ ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(1)
thf(fact_67_add__mono__thms__linordered__field_I2_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( I = J )
        & ( ord_less_a @ K @ L ) )
     => ( ord_less_a @ ( plus_plus_a @ I @ K ) @ ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(2)
thf(fact_68_add__mono__thms__linordered__field_I5_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( ord_less_a @ I @ J )
        & ( ord_less_a @ K @ L ) )
     => ( ord_less_a @ ( plus_plus_a @ I @ K ) @ ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(5)
thf(fact_69_add__le__imp__le__right,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_eq_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ C ) )
     => ( ord_less_eq_a @ A @ B ) ) )).

% add_le_imp_le_right
thf(fact_70_add__le__imp__le__left,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_eq_a @ ( plus_plus_a @ C @ A ) @ ( plus_plus_a @ C @ B ) )
     => ( ord_less_eq_a @ A @ B ) ) )).

% add_le_imp_le_left
thf(fact_71_add__right__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ord_less_eq_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ C ) ) ) )).

% add_right_mono
thf(fact_72_add__left__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ord_less_eq_a @ ( plus_plus_a @ C @ A ) @ ( plus_plus_a @ C @ B ) ) ) )).

% add_left_mono
thf(fact_73_add__mono,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_eq_a @ C @ D )
       => ( ord_less_eq_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ D ) ) ) ) )).

% add_mono
thf(fact_74_add__mono__thms__linordered__semiring_I1_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( ord_less_eq_a @ I @ J )
        & ( ord_less_eq_a @ K @ L ) )
     => ( ord_less_eq_a @ ( plus_plus_a @ I @ K ) @ ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(1)
thf(fact_75_add__mono__thms__linordered__semiring_I2_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( I = J )
        & ( ord_less_eq_a @ K @ L ) )
     => ( ord_less_eq_a @ ( plus_plus_a @ I @ K ) @ ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(2)
thf(fact_76_add__mono__thms__linordered__semiring_I3_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( ord_less_eq_a @ I @ J )
        & ( K = L ) )
     => ( ord_less_eq_a @ ( plus_plus_a @ I @ K ) @ ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(3)
thf(fact_77_add_Ogroup__left__neutral,axiom,(
    ! [A: a] :
      ( ( plus_plus_a @ zero_zero_a @ A )
      = A ) )).

% add.group_left_neutral
thf(fact_78_add_Ocomm__neutral,axiom,(
    ! [A: a] :
      ( ( plus_plus_a @ A @ zero_zero_a )
      = A ) )).

% add.comm_neutral
thf(fact_79_comm__monoid__add__class_Oadd__0,axiom,(
    ! [A: a] :
      ( ( plus_plus_a @ zero_zero_a @ A )
      = A ) )).

% comm_monoid_add_class.add_0
thf(fact_80_add__right__imp__eq,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( ( plus_plus_a @ B @ A )
        = ( plus_plus_a @ C @ A ) )
     => ( B = C ) ) )).

% add_right_imp_eq
thf(fact_81_add__left__imp__eq,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ( plus_plus_a @ A @ B )
        = ( plus_plus_a @ A @ C ) )
     => ( B = C ) ) )).

% add_left_imp_eq
thf(fact_82_add_Oleft__commute,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( plus_plus_a @ B @ ( plus_plus_a @ A @ C ) )
      = ( plus_plus_a @ A @ ( plus_plus_a @ B @ C ) ) ) )).

% add.left_commute
thf(fact_83_add_Ocommute,axiom,
    ( plus_plus_a
    = ( ^ [A3: a,B3: a] :
          ( plus_plus_a @ B3 @ A3 ) ) )).

% add.commute
thf(fact_84_add_Oright__cancel,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( ( plus_plus_a @ B @ A )
        = ( plus_plus_a @ C @ A ) )
      = ( B = C ) ) )).

% add.right_cancel
thf(fact_85_same,axiom,(
    ord_less_a @ zero_zero_a @ ( times_times_a @ xa @ ( plus_plus_a @ xa @ ya ) ) )).

% same
thf(fact_86_different,axiom,(
    ord_less_a @ ( times_times_a @ xa @ ya ) @ zero_zero_a )).

% different
thf(fact_87_add__less__zeroD,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_a @ ( plus_plus_a @ X @ Y ) @ zero_zero_a )
     => ( ( ord_less_a @ X @ zero_zero_a )
        | ( ord_less_a @ Y @ zero_zero_a ) ) ) )).

% add_less_zeroD
thf(fact_88_order__refl,axiom,(
    ! [X: a] :
      ( ord_less_eq_a @ X @ X ) )).

% order_refl
thf(fact_89_nonneg_Ohyps_I3_J,axiom,
    ( ( plus_plus_a @ ( plus_plus_a @ xa @ ya ) @ ( groups1792256535list_a @ xsa ) )
    = zero_zero_a )).

% nonneg.hyps(3)
thf(fact_90_add__0__iff,axiom,(
    ! [B: a,A: a] :
      ( ( B
        = ( plus_plus_a @ B @ A ) )
      = ( A = zero_zero_a ) ) )).

% add_0_iff
thf(fact_91_verit__sum__simplify,axiom,(
    ! [A: a] :
      ( ( plus_plus_a @ A @ zero_zero_a )
      = A ) )).

% verit_sum_simplify
thf(fact_92_minf_I8_J,axiom,(
    ! [T: a] :
    ? [Z: a] :
    ! [X2: a] :
      ( ( ord_less_a @ X2 @ Z )
     => ~ ( ord_less_eq_a @ T @ X2 ) ) )).

% minf(8)
thf(fact_93_minf_I6_J,axiom,(
    ! [T: a] :
    ? [Z: a] :
    ! [X2: a] :
      ( ( ord_less_a @ X2 @ Z )
     => ( ord_less_eq_a @ X2 @ T ) ) )).

% minf(6)
thf(fact_94_pinf_I8_J,axiom,(
    ! [T: a] :
    ? [Z: a] :
    ! [X2: a] :
      ( ( ord_less_a @ Z @ X2 )
     => ( ord_less_eq_a @ T @ X2 ) ) )).

% pinf(8)
thf(fact_95_nonneg_Ohyps_I1_J,axiom,(
    xsa != nil_a )).

% nonneg.hyps(1)
thf(fact_96_mult__cancel__right,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ( times_times_a @ A @ C )
        = ( times_times_a @ B @ C ) )
      = ( ( C = zero_zero_a )
        | ( A = B ) ) ) )).

% mult_cancel_right
thf(fact_97_mult__cancel__left,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ( times_times_a @ C @ A )
        = ( times_times_a @ C @ B ) )
      = ( ( C = zero_zero_a )
        | ( A = B ) ) ) )).

% mult_cancel_left
thf(fact_98_mult__eq__0__iff,axiom,(
    ! [A: a,B: a] :
      ( ( ( times_times_a @ A @ B )
        = zero_zero_a )
      = ( ( A = zero_zero_a )
        | ( B = zero_zero_a ) ) ) )).

% mult_eq_0_iff
thf(fact_99_mult__zero__right,axiom,(
    ! [A: a] :
      ( ( times_times_a @ A @ zero_zero_a )
      = zero_zero_a ) )).

% mult_zero_right
thf(fact_100_mult__zero__left,axiom,(
    ! [A: a] :
      ( ( times_times_a @ zero_zero_a @ A )
      = zero_zero_a ) )).

% mult_zero_left
thf(fact_101_nonneg_Ohyps_I2_J,axiom,(
    ( last_a @ xsa )
 != zero_zero_a )).

% nonneg.hyps(2)
thf(fact_102_assms_I3_J,axiom,
    ( ( plus_plus_a @ ( plus_plus_a @ x @ y ) @ ( groups1792256535list_a @ xs ) )
    = zero_zero_a )).

% assms(3)
thf(fact_103_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( times_times_a @ ( times_times_a @ A @ B ) @ C )
      = ( times_times_a @ A @ ( times_times_a @ B @ C ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_104_mult_Oassoc,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( times_times_a @ ( times_times_a @ A @ B ) @ C )
      = ( times_times_a @ A @ ( times_times_a @ B @ C ) ) ) )).

% mult.assoc
thf(fact_105_mult_Ocommute,axiom,
    ( times_times_a
    = ( ^ [A3: a,B3: a] :
          ( times_times_a @ B3 @ A3 ) ) )).

% mult.commute
thf(fact_106_mult_Oleft__commute,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( times_times_a @ B @ ( times_times_a @ A @ C ) )
      = ( times_times_a @ A @ ( times_times_a @ B @ C ) ) ) )).

% mult.left_commute
thf(fact_107_mult__right__cancel,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( C != zero_zero_a )
     => ( ( ( times_times_a @ A @ C )
          = ( times_times_a @ B @ C ) )
        = ( A = B ) ) ) )).

% mult_right_cancel
thf(fact_108_mult__left__cancel,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( C != zero_zero_a )
     => ( ( ( times_times_a @ C @ A )
          = ( times_times_a @ C @ B ) )
        = ( A = B ) ) ) )).

% mult_left_cancel
thf(fact_109_no__zero__divisors,axiom,(
    ! [A: a,B: a] :
      ( ( A != zero_zero_a )
     => ( ( B != zero_zero_a )
       => ( ( times_times_a @ A @ B )
         != zero_zero_a ) ) ) )).

% no_zero_divisors
thf(fact_110_divisors__zero,axiom,(
    ! [A: a,B: a] :
      ( ( ( times_times_a @ A @ B )
        = zero_zero_a )
     => ( ( A = zero_zero_a )
        | ( B = zero_zero_a ) ) ) )).

% divisors_zero
thf(fact_111_mult__not__zero,axiom,(
    ! [A: a,B: a] :
      ( ( ( times_times_a @ A @ B )
       != zero_zero_a )
     => ( ( A != zero_zero_a )
        & ( B != zero_zero_a ) ) ) )).

% mult_not_zero
thf(fact_112_ring__class_Oring__distribs_I2_J,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( times_times_a @ ( plus_plus_a @ A @ B ) @ C )
      = ( plus_plus_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) ) ) )).

% ring_class.ring_distribs(2)
thf(fact_113_ring__class_Oring__distribs_I1_J,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( times_times_a @ A @ ( plus_plus_a @ B @ C ) )
      = ( plus_plus_a @ ( times_times_a @ A @ B ) @ ( times_times_a @ A @ C ) ) ) )).

% ring_class.ring_distribs(1)
thf(fact_114_comm__semiring__class_Odistrib,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( times_times_a @ ( plus_plus_a @ A @ B ) @ C )
      = ( plus_plus_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) ) ) )).

% comm_semiring_class.distrib
thf(fact_115_distrib__left,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( times_times_a @ A @ ( plus_plus_a @ B @ C ) )
      = ( plus_plus_a @ ( times_times_a @ A @ B ) @ ( times_times_a @ A @ C ) ) ) )).

% distrib_left
thf(fact_116_distrib__right,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( times_times_a @ ( plus_plus_a @ A @ B ) @ C )
      = ( plus_plus_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) ) ) )).

% distrib_right
thf(fact_117_combine__common__factor,axiom,(
    ! [A: a,E: a,B: a,C: a] :
      ( ( plus_plus_a @ ( times_times_a @ A @ E ) @ ( plus_plus_a @ ( times_times_a @ B @ E ) @ C ) )
      = ( plus_plus_a @ ( times_times_a @ ( plus_plus_a @ A @ B ) @ E ) @ C ) ) )).

% combine_common_factor
thf(fact_118_crossproduct__eq,axiom,(
    ! [W: a,Y: a,X: a,Z2: a] :
      ( ( ( plus_plus_a @ ( times_times_a @ W @ Y ) @ ( times_times_a @ X @ Z2 ) )
        = ( plus_plus_a @ ( times_times_a @ W @ Z2 ) @ ( times_times_a @ X @ Y ) ) )
      = ( ( W = X )
        | ( Y = Z2 ) ) ) )).

% crossproduct_eq
thf(fact_119_crossproduct__noteq,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ( A != B )
        & ( C != D ) )
      = ( ( plus_plus_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ D ) )
       != ( plus_plus_a @ ( times_times_a @ A @ D ) @ ( times_times_a @ B @ C ) ) ) ) )).

% crossproduct_noteq
thf(fact_120_lambda__zero,axiom,
    ( ( ^ [H: a] : zero_zero_a )
    = ( times_times_a @ zero_zero_a ) )).

% lambda_zero
thf(fact_121_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_eq_a @ zero_zero_a @ C )
       => ( ord_less_eq_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) ) ) ) )).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_122_zero__le__mult__iff,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ ( times_times_a @ A @ B ) )
      = ( ( ( ord_less_eq_a @ zero_zero_a @ A )
          & ( ord_less_eq_a @ zero_zero_a @ B ) )
        | ( ( ord_less_eq_a @ A @ zero_zero_a )
          & ( ord_less_eq_a @ B @ zero_zero_a ) ) ) ) )).

% zero_le_mult_iff
thf(fact_123_mult__nonneg__nonpos2,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ A )
     => ( ( ord_less_eq_a @ B @ zero_zero_a )
       => ( ord_less_eq_a @ ( times_times_a @ B @ A ) @ zero_zero_a ) ) ) )).

% mult_nonneg_nonpos2
thf(fact_124_mult__nonpos__nonneg,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ A @ zero_zero_a )
     => ( ( ord_less_eq_a @ zero_zero_a @ B )
       => ( ord_less_eq_a @ ( times_times_a @ A @ B ) @ zero_zero_a ) ) ) )).

% mult_nonpos_nonneg
thf(fact_125_mult__nonneg__nonpos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ A )
     => ( ( ord_less_eq_a @ B @ zero_zero_a )
       => ( ord_less_eq_a @ ( times_times_a @ A @ B ) @ zero_zero_a ) ) ) )).

% mult_nonneg_nonpos
thf(fact_126_mult__nonneg__nonneg,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ A )
     => ( ( ord_less_eq_a @ zero_zero_a @ B )
       => ( ord_less_eq_a @ zero_zero_a @ ( times_times_a @ A @ B ) ) ) ) )).

% mult_nonneg_nonneg
thf(fact_127_split__mult__neg__le,axiom,(
    ! [A: a,B: a] :
      ( ( ( ( ord_less_eq_a @ zero_zero_a @ A )
          & ( ord_less_eq_a @ B @ zero_zero_a ) )
        | ( ( ord_less_eq_a @ A @ zero_zero_a )
          & ( ord_less_eq_a @ zero_zero_a @ B ) ) )
     => ( ord_less_eq_a @ ( times_times_a @ A @ B ) @ zero_zero_a ) ) )).

% split_mult_neg_le
thf(fact_128_mult__le__0__iff,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ ( times_times_a @ A @ B ) @ zero_zero_a )
      = ( ( ( ord_less_eq_a @ zero_zero_a @ A )
          & ( ord_less_eq_a @ B @ zero_zero_a ) )
        | ( ( ord_less_eq_a @ A @ zero_zero_a )
          & ( ord_less_eq_a @ zero_zero_a @ B ) ) ) ) )).

% mult_le_0_iff
thf(fact_129_mult__right__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_eq_a @ zero_zero_a @ C )
       => ( ord_less_eq_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) ) ) ) )).

% mult_right_mono
thf(fact_130_mult__right__mono__neg,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( ord_less_eq_a @ B @ A )
     => ( ( ord_less_eq_a @ C @ zero_zero_a )
       => ( ord_less_eq_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) ) ) ) )).

% mult_right_mono_neg
thf(fact_131_mult__left__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_eq_a @ zero_zero_a @ C )
       => ( ord_less_eq_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) ) ) ) )).

% mult_left_mono
thf(fact_132_mult__nonpos__nonpos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ A @ zero_zero_a )
     => ( ( ord_less_eq_a @ B @ zero_zero_a )
       => ( ord_less_eq_a @ zero_zero_a @ ( times_times_a @ A @ B ) ) ) ) )).

% mult_nonpos_nonpos
thf(fact_133_mult__left__mono__neg,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( ord_less_eq_a @ B @ A )
     => ( ( ord_less_eq_a @ C @ zero_zero_a )
       => ( ord_less_eq_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) ) ) ) )).

% mult_left_mono_neg
thf(fact_134_split__mult__pos__le,axiom,(
    ! [A: a,B: a] :
      ( ( ( ( ord_less_eq_a @ zero_zero_a @ A )
          & ( ord_less_eq_a @ zero_zero_a @ B ) )
        | ( ( ord_less_eq_a @ A @ zero_zero_a )
          & ( ord_less_eq_a @ B @ zero_zero_a ) ) )
     => ( ord_less_eq_a @ zero_zero_a @ ( times_times_a @ A @ B ) ) ) )).

% split_mult_pos_le
thf(fact_135_zero__le__square,axiom,(
    ! [A: a] :
      ( ord_less_eq_a @ zero_zero_a @ ( times_times_a @ A @ A ) ) )).

% zero_le_square
thf(fact_136_mult__mono_H,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_eq_a @ C @ D )
       => ( ( ord_less_eq_a @ zero_zero_a @ A )
         => ( ( ord_less_eq_a @ zero_zero_a @ C )
           => ( ord_less_eq_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ D ) ) ) ) ) ) )).

% mult_mono'
thf(fact_137_mult__mono,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_eq_a @ C @ D )
       => ( ( ord_less_eq_a @ zero_zero_a @ B )
         => ( ( ord_less_eq_a @ zero_zero_a @ C )
           => ( ord_less_eq_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ D ) ) ) ) ) ) )).

% mult_mono
thf(fact_138_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_a @ zero_zero_a @ C )
       => ( ord_less_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) ) ) ) )).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_139_mult__less__cancel__right__disj,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) )
      = ( ( ( ord_less_a @ zero_zero_a @ C )
          & ( ord_less_a @ A @ B ) )
        | ( ( ord_less_a @ C @ zero_zero_a )
          & ( ord_less_a @ B @ A ) ) ) ) )).

% mult_less_cancel_right_disj
thf(fact_140_mult__strict__right__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_a @ zero_zero_a @ C )
       => ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) ) ) ) )).

% mult_strict_right_mono
thf(fact_141_mult__strict__right__mono__neg,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( ord_less_a @ B @ A )
     => ( ( ord_less_a @ C @ zero_zero_a )
       => ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) ) ) ) )).

% mult_strict_right_mono_neg
thf(fact_142_mult__less__cancel__left__disj,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
      = ( ( ( ord_less_a @ zero_zero_a @ C )
          & ( ord_less_a @ A @ B ) )
        | ( ( ord_less_a @ C @ zero_zero_a )
          & ( ord_less_a @ B @ A ) ) ) ) )).

% mult_less_cancel_left_disj
thf(fact_143_mult__strict__left__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_a @ zero_zero_a @ C )
       => ( ord_less_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) ) ) ) )).

% mult_strict_left_mono
thf(fact_144_mult__strict__left__mono__neg,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( ord_less_a @ B @ A )
     => ( ( ord_less_a @ C @ zero_zero_a )
       => ( ord_less_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) ) ) ) )).

% mult_strict_left_mono_neg
thf(fact_145_mult__less__cancel__left__pos,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ C )
     => ( ( ord_less_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
        = ( ord_less_a @ A @ B ) ) ) )).

% mult_less_cancel_left_pos
thf(fact_146_mult__less__cancel__left__neg,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ C @ zero_zero_a )
     => ( ( ord_less_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
        = ( ord_less_a @ B @ A ) ) ) )).

% mult_less_cancel_left_neg
thf(fact_147_zero__less__mult__pos2,axiom,(
    ! [B: a,A: a] :
      ( ( ord_less_a @ zero_zero_a @ ( times_times_a @ B @ A ) )
     => ( ( ord_less_a @ zero_zero_a @ A )
       => ( ord_less_a @ zero_zero_a @ B ) ) ) )).

% zero_less_mult_pos2
thf(fact_148_zero__less__mult__pos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ ( times_times_a @ A @ B ) )
     => ( ( ord_less_a @ zero_zero_a @ A )
       => ( ord_less_a @ zero_zero_a @ B ) ) ) )).

% zero_less_mult_pos
thf(fact_149_zero__less__mult__iff,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ ( times_times_a @ A @ B ) )
      = ( ( ( ord_less_a @ zero_zero_a @ A )
          & ( ord_less_a @ zero_zero_a @ B ) )
        | ( ( ord_less_a @ A @ zero_zero_a )
          & ( ord_less_a @ B @ zero_zero_a ) ) ) ) )).

% zero_less_mult_iff
thf(fact_150_mult__pos__neg2,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ A )
     => ( ( ord_less_a @ B @ zero_zero_a )
       => ( ord_less_a @ ( times_times_a @ B @ A ) @ zero_zero_a ) ) ) )).

% mult_pos_neg2
thf(fact_151_mult__pos__pos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ A )
     => ( ( ord_less_a @ zero_zero_a @ B )
       => ( ord_less_a @ zero_zero_a @ ( times_times_a @ A @ B ) ) ) ) )).

% mult_pos_pos
thf(fact_152_mult__pos__neg,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ A )
     => ( ( ord_less_a @ B @ zero_zero_a )
       => ( ord_less_a @ ( times_times_a @ A @ B ) @ zero_zero_a ) ) ) )).

% mult_pos_neg
thf(fact_153_mult__neg__pos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ A @ zero_zero_a )
     => ( ( ord_less_a @ zero_zero_a @ B )
       => ( ord_less_a @ ( times_times_a @ A @ B ) @ zero_zero_a ) ) ) )).

% mult_neg_pos
thf(fact_154_mult__less__0__iff,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ ( times_times_a @ A @ B ) @ zero_zero_a )
      = ( ( ( ord_less_a @ zero_zero_a @ A )
          & ( ord_less_a @ B @ zero_zero_a ) )
        | ( ( ord_less_a @ A @ zero_zero_a )
          & ( ord_less_a @ zero_zero_a @ B ) ) ) ) )).

% mult_less_0_iff
thf(fact_155_not__square__less__zero,axiom,(
    ! [A: a] :
      ~ ( ord_less_a @ ( times_times_a @ A @ A ) @ zero_zero_a ) )).

% not_square_less_zero
thf(fact_156_mult__neg__neg,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ A @ zero_zero_a )
     => ( ( ord_less_a @ B @ zero_zero_a )
       => ( ord_less_a @ zero_zero_a @ ( times_times_a @ A @ B ) ) ) ) )).

% mult_neg_neg
thf(fact_157_add__scale__eq__noteq,axiom,(
    ! [R: a,A: a,B: a,C: a,D: a] :
      ( ( R != zero_zero_a )
     => ( ( ( A = B )
          & ( C != D ) )
       => ( ( plus_plus_a @ A @ ( times_times_a @ R @ C ) )
         != ( plus_plus_a @ B @ ( times_times_a @ R @ D ) ) ) ) ) )).

% add_scale_eq_noteq
thf(fact_158_mult__less__le__imp__less,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_eq_a @ C @ D )
       => ( ( ord_less_eq_a @ zero_zero_a @ A )
         => ( ( ord_less_a @ zero_zero_a @ C )
           => ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ D ) ) ) ) ) ) )).

% mult_less_le_imp_less
thf(fact_159_mult__le__less__imp__less,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_a @ C @ D )
       => ( ( ord_less_a @ zero_zero_a @ A )
         => ( ( ord_less_eq_a @ zero_zero_a @ C )
           => ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ D ) ) ) ) ) ) )).

% mult_le_less_imp_less
thf(fact_160_mult__right__le__imp__le,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_eq_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) )
     => ( ( ord_less_a @ zero_zero_a @ C )
       => ( ord_less_eq_a @ A @ B ) ) ) )).

% mult_right_le_imp_le
thf(fact_161_mult__left__le__imp__le,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_eq_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
     => ( ( ord_less_a @ zero_zero_a @ C )
       => ( ord_less_eq_a @ A @ B ) ) ) )).

% mult_left_le_imp_le
thf(fact_162_mult__le__cancel__left__pos,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ C )
     => ( ( ord_less_eq_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
        = ( ord_less_eq_a @ A @ B ) ) ) )).

% mult_le_cancel_left_pos
thf(fact_163_mult__le__cancel__left__neg,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ C @ zero_zero_a )
     => ( ( ord_less_eq_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
        = ( ord_less_eq_a @ B @ A ) ) ) )).

% mult_le_cancel_left_neg
thf(fact_164_mult__less__cancel__right,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) )
      = ( ( ( ord_less_eq_a @ zero_zero_a @ C )
         => ( ord_less_a @ A @ B ) )
        & ( ( ord_less_eq_a @ C @ zero_zero_a )
         => ( ord_less_a @ B @ A ) ) ) ) )).

% mult_less_cancel_right
thf(fact_165_mult__strict__mono_H,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_a @ C @ D )
       => ( ( ord_less_eq_a @ zero_zero_a @ A )
         => ( ( ord_less_eq_a @ zero_zero_a @ C )
           => ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ D ) ) ) ) ) ) )).

% mult_strict_mono'
thf(fact_166_mult__right__less__imp__less,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) )
     => ( ( ord_less_eq_a @ zero_zero_a @ C )
       => ( ord_less_a @ A @ B ) ) ) )).

% mult_right_less_imp_less
thf(fact_167_mult__less__cancel__left,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
      = ( ( ( ord_less_eq_a @ zero_zero_a @ C )
         => ( ord_less_a @ A @ B ) )
        & ( ( ord_less_eq_a @ C @ zero_zero_a )
         => ( ord_less_a @ B @ A ) ) ) ) )).

% mult_less_cancel_left
thf(fact_168_mult__strict__mono,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_a @ C @ D )
       => ( ( ord_less_a @ zero_zero_a @ B )
         => ( ( ord_less_eq_a @ zero_zero_a @ C )
           => ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ D ) ) ) ) ) ) )).

% mult_strict_mono
thf(fact_169_mult__left__less__imp__less,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
     => ( ( ord_less_eq_a @ zero_zero_a @ C )
       => ( ord_less_a @ A @ B ) ) ) )).

% mult_left_less_imp_less
thf(fact_170_mult__le__cancel__right,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_eq_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) )
      = ( ( ( ord_less_a @ zero_zero_a @ C )
         => ( ord_less_eq_a @ A @ B ) )
        & ( ( ord_less_a @ C @ zero_zero_a )
         => ( ord_less_eq_a @ B @ A ) ) ) ) )).

% mult_le_cancel_right
thf(fact_171_mult__le__cancel__left,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_eq_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
      = ( ( ( ord_less_a @ zero_zero_a @ C )
         => ( ord_less_eq_a @ A @ B ) )
        & ( ( ord_less_a @ C @ zero_zero_a )
         => ( ord_less_eq_a @ B @ A ) ) ) ) )).

% mult_le_cancel_left
thf(fact_172_sum__squares__ge__zero,axiom,(
    ! [X: a,Y: a] :
      ( ord_less_eq_a @ zero_zero_a @ ( plus_plus_a @ ( times_times_a @ X @ X ) @ ( times_times_a @ Y @ Y ) ) ) )).

% sum_squares_ge_zero
thf(fact_173_not__sum__squares__lt__zero,axiom,(
    ! [X: a,Y: a] :
      ~ ( ord_less_a @ ( plus_plus_a @ ( times_times_a @ X @ X ) @ ( times_times_a @ Y @ Y ) ) @ zero_zero_a ) )).

% not_sum_squares_lt_zero
thf(fact_174_dual__order_Oantisym,axiom,(
    ! [B: a,A: a] :
      ( ( ord_less_eq_a @ B @ A )
     => ( ( ord_less_eq_a @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_175_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y2: a,Z3: a] : ( Y2 = Z3 ) )
    = ( ^ [A3: a,B3: a] :
          ( ( ord_less_eq_a @ B3 @ A3 )
          & ( ord_less_eq_a @ A3 @ B3 ) ) ) )).

% dual_order.eq_iff
thf(fact_176_dual__order_Otrans,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( ord_less_eq_a @ B @ A )
     => ( ( ord_less_eq_a @ C @ B )
       => ( ord_less_eq_a @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_177_linorder__wlog,axiom,(
    ! [P: a > a > $o,A: a,B: a] :
      ( ! [A4: a,B4: a] :
          ( ( ord_less_eq_a @ A4 @ B4 )
         => ( P @ A4 @ B4 ) )
     => ( ! [A4: a,B4: a] :
            ( ( P @ B4 @ A4 )
           => ( P @ A4 @ B4 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_178_dual__order_Orefl,axiom,(
    ! [A: a] :
      ( ord_less_eq_a @ A @ A ) )).

% dual_order.refl
thf(fact_179_order__trans,axiom,(
    ! [X: a,Y: a,Z2: a] :
      ( ( ord_less_eq_a @ X @ Y )
     => ( ( ord_less_eq_a @ Y @ Z2 )
       => ( ord_less_eq_a @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_180_order__class_Oorder_Oantisym,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_eq_a @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_181_ord__le__eq__trans,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_a @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_182_ord__eq__le__trans,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( A = B )
     => ( ( ord_less_eq_a @ B @ C )
       => ( ord_less_eq_a @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_183_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y2: a,Z3: a] : ( Y2 = Z3 ) )
    = ( ^ [A3: a,B3: a] :
          ( ( ord_less_eq_a @ A3 @ B3 )
          & ( ord_less_eq_a @ B3 @ A3 ) ) ) )).

% order_class.order.eq_iff
thf(fact_184_antisym__conv,axiom,(
    ! [Y: a,X: a] :
      ( ( ord_less_eq_a @ Y @ X )
     => ( ( ord_less_eq_a @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_185_le__cases3,axiom,(
    ! [X: a,Y: a,Z2: a] :
      ( ( ( ord_less_eq_a @ X @ Y )
       => ~ ( ord_less_eq_a @ Y @ Z2 ) )
     => ( ( ( ord_less_eq_a @ Y @ X )
         => ~ ( ord_less_eq_a @ X @ Z2 ) )
       => ( ( ( ord_less_eq_a @ X @ Z2 )
           => ~ ( ord_less_eq_a @ Z2 @ Y ) )
         => ( ( ( ord_less_eq_a @ Z2 @ Y )
             => ~ ( ord_less_eq_a @ Y @ X ) )
           => ( ( ( ord_less_eq_a @ Y @ Z2 )
               => ~ ( ord_less_eq_a @ Z2 @ X ) )
             => ~ ( ( ord_less_eq_a @ Z2 @ X )
                 => ~ ( ord_less_eq_a @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_186_order_Otrans,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_eq_a @ B @ C )
       => ( ord_less_eq_a @ A @ C ) ) ) )).

% order.trans
thf(fact_187_le__cases,axiom,(
    ! [X: a,Y: a] :
      ( ~ ( ord_less_eq_a @ X @ Y )
     => ( ord_less_eq_a @ Y @ X ) ) )).

% le_cases
thf(fact_188_eq__refl,axiom,(
    ! [X: a,Y: a] :
      ( ( X = Y )
     => ( ord_less_eq_a @ X @ Y ) ) )).

% eq_refl
thf(fact_189_linear,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_eq_a @ X @ Y )
      | ( ord_less_eq_a @ Y @ X ) ) )).

% linear
thf(fact_190_antisym,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_eq_a @ X @ Y )
     => ( ( ord_less_eq_a @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_191_eq__iff,axiom,
    ( ( ^ [Y2: a,Z3: a] : ( Y2 = Z3 ) )
    = ( ^ [X3: a,Y3: a] :
          ( ( ord_less_eq_a @ X3 @ Y3 )
          & ( ord_less_eq_a @ Y3 @ X3 ) ) ) )).

% eq_iff
thf(fact_192_ord__le__eq__subst,axiom,(
    ! [A: a,B: a,F: a > a,C: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: a,Y4: a] :
              ( ( ord_less_eq_a @ X4 @ Y4 )
             => ( ord_less_eq_a @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_a @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_193_ord__eq__le__subst,axiom,(
    ! [A: a,F: a > a,B: a,C: a] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_a @ B @ C )
       => ( ! [X4: a,Y4: a] :
              ( ( ord_less_eq_a @ X4 @ Y4 )
             => ( ord_less_eq_a @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_a @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_194_verit__la__disequality,axiom,(
    ! [A: a,B: a] :
      ( ( A = B )
      | ~ ( ord_less_eq_a @ A @ B )
      | ~ ( ord_less_eq_a @ B @ A ) ) )).

% verit_la_disequality
thf(fact_195_order__subst2,axiom,(
    ! [A: a,B: a,F: a > a,C: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_eq_a @ ( F @ B ) @ C )
       => ( ! [X4: a,Y4: a] :
              ( ( ord_less_eq_a @ X4 @ Y4 )
             => ( ord_less_eq_a @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_a @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_196_order__subst1,axiom,(
    ! [A: a,F: a > a,B: a,C: a] :
      ( ( ord_less_eq_a @ A @ ( F @ B ) )
     => ( ( ord_less_eq_a @ B @ C )
       => ( ! [X4: a,Y4: a] :
              ( ( ord_less_eq_a @ X4 @ Y4 )
             => ( ord_less_eq_a @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_a @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_197_linorder__neqE__linordered__idom,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
     => ( ~ ( ord_less_a @ X @ Y )
       => ( ord_less_a @ Y @ X ) ) ) )).

% linorder_neqE_linordered_idom
thf(fact_198_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: a,A: a] :
      ( ( ord_less_a @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_199_order_Ostrict__implies__not__eq,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_200_not__less__iff__gr__or__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( ~ ( ord_less_a @ X @ Y ) )
      = ( ( ord_less_a @ Y @ X )
        | ( X = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_201_dual__order_Ostrict__trans,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( ord_less_a @ B @ A )
     => ( ( ord_less_a @ C @ B )
       => ( ord_less_a @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_202_linorder__less__wlog,axiom,(
    ! [P: a > a > $o,A: a,B: a] :
      ( ! [A4: a,B4: a] :
          ( ( ord_less_a @ A4 @ B4 )
         => ( P @ A4 @ B4 ) )
     => ( ! [A4: a] :
            ( P @ A4 @ A4 )
       => ( ! [A4: a,B4: a] :
              ( ( P @ B4 @ A4 )
             => ( P @ A4 @ B4 ) )
         => ( P @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_203_less__imp__not__less,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_a @ X @ Y )
     => ~ ( ord_less_a @ Y @ X ) ) )).

% less_imp_not_less
thf(fact_204_order_Ostrict__trans,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_a @ B @ C )
       => ( ord_less_a @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_205_dual__order_Oirrefl,axiom,(
    ! [A: a] :
      ~ ( ord_less_a @ A @ A ) )).

% dual_order.irrefl
thf(fact_206_linorder__cases,axiom,(
    ! [X: a,Y: a] :
      ( ~ ( ord_less_a @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_a @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_207_less__imp__triv,axiom,(
    ! [X: a,Y: a,P: $o] :
      ( ( ord_less_a @ X @ Y )
     => ( ( ord_less_a @ Y @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_208_less__imp__not__eq2,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_a @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_209_antisym__conv3,axiom,(
    ! [Y: a,X: a] :
      ( ~ ( ord_less_a @ Y @ X )
     => ( ( ~ ( ord_less_a @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_210_less__not__sym,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_a @ X @ Y )
     => ~ ( ord_less_a @ Y @ X ) ) )).

% less_not_sym
thf(fact_211_less__imp__not__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_a @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_212_dual__order_Oasym,axiom,(
    ! [B: a,A: a] :
      ( ( ord_less_a @ B @ A )
     => ~ ( ord_less_a @ A @ B ) ) )).

% dual_order.asym
thf(fact_213_ord__less__eq__trans,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( B = C )
       => ( ord_less_a @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_214_ord__eq__less__trans,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( A = B )
     => ( ( ord_less_a @ B @ C )
       => ( ord_less_a @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_215_less__irrefl,axiom,(
    ! [X: a] :
      ~ ( ord_less_a @ X @ X ) )).

% less_irrefl
thf(fact_216_less__linear,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_a @ X @ Y )
      | ( X = Y )
      | ( ord_less_a @ Y @ X ) ) )).

% less_linear
thf(fact_217_less__trans,axiom,(
    ! [X: a,Y: a,Z2: a] :
      ( ( ord_less_a @ X @ Y )
     => ( ( ord_less_a @ Y @ Z2 )
       => ( ord_less_a @ X @ Z2 ) ) ) )).

% less_trans
thf(fact_218_less__asym_H,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ A @ B )
     => ~ ( ord_less_a @ B @ A ) ) )).

% less_asym'
thf(fact_219_less__asym,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_a @ X @ Y )
     => ~ ( ord_less_a @ Y @ X ) ) )).

% less_asym
thf(fact_220_less__imp__neq,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_a @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_221_order_Oasym,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ A @ B )
     => ~ ( ord_less_a @ B @ A ) ) )).

% order.asym
thf(fact_222_neq__iff,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
      = ( ( ord_less_a @ X @ Y )
        | ( ord_less_a @ Y @ X ) ) ) )).

% neq_iff
thf(fact_223_neqE,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
     => ( ~ ( ord_less_a @ X @ Y )
       => ( ord_less_a @ Y @ X ) ) ) )).

% neqE
thf(fact_224_order__less__subst2,axiom,(
    ! [A: a,B: a,F: a > a,C: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_a @ ( F @ B ) @ C )
       => ( ! [X4: a,Y4: a] :
              ( ( ord_less_a @ X4 @ Y4 )
             => ( ord_less_a @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_a @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_225_order__less__subst1,axiom,(
    ! [A: a,F: a > a,B: a,C: a] :
      ( ( ord_less_a @ A @ ( F @ B ) )
     => ( ( ord_less_a @ B @ C )
       => ( ! [X4: a,Y4: a] :
              ( ( ord_less_a @ X4 @ Y4 )
             => ( ord_less_a @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_a @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_226_ord__less__eq__subst,axiom,(
    ! [A: a,B: a,F: a > a,C: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: a,Y4: a] :
              ( ( ord_less_a @ X4 @ Y4 )
             => ( ord_less_a @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_a @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_227_ord__eq__less__subst,axiom,(
    ! [A: a,F: a > a,B: a,C: a] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_a @ B @ C )
       => ( ! [X4: a,Y4: a] :
              ( ( ord_less_a @ X4 @ Y4 )
             => ( ord_less_a @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_a @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_228_verit__comp__simplify1_I1_J,axiom,(
    ! [A: a] :
      ~ ( ord_less_a @ A @ A ) )).

% verit_comp_simplify1(1)
thf(fact_229_pinf_I1_J,axiom,(
    ! [P: a > $o,P2: a > $o,Q: a > $o,Q2: a > $o] :
      ( ? [Z4: a] :
        ! [X4: a] :
          ( ( ord_less_a @ Z4 @ X4 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z4: a] :
          ! [X4: a] :
            ( ( ord_less_a @ Z4 @ X4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z: a] :
          ! [X2: a] :
            ( ( ord_less_a @ Z @ X2 )
           => ( ( ( P @ X2 )
                & ( Q @ X2 ) )
              = ( ( P2 @ X2 )
                & ( Q2 @ X2 ) ) ) ) ) ) )).

% pinf(1)

% Conjectures (1)
thf(conj_0,conjecture,
    ( ( ^ [T2: a] :
          ( plus_plus_a @ T2 @ ( plus_plus_a @ xa @ ya ) ) )
    = ( plus_plus_a @ ( plus_plus_a @ xa @ ya ) ) )).

%------------------------------------------------------------------------------
