%------------------------------------------------------------------------------
% File     : SLH220^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Descartes_Sign_Rule problem prob_462__5869346_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Descartes_Sign_Rule/prob_462__5869346_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  384 (   0 unit;  30 type;   0 defn)
%            Number of atoms       : 3874 ( 336 equality;1850 variable)
%            Maximal formula depth :   13 (   8 average)
%            Number of connectives : 2895 (  47   ~;  24   |;  57   &;2433   @)
%                                         (   0 <=>; 334  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   26 (  26   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   32 (  30   :;   0   =)
%            Number of variables   :  867 (   0 sgn; 851   !;   4   ?;  12   ^)
%                                         ( 867   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:41:25.071
%------------------------------------------------------------------------------
% Could-be-implicit typings (4)
thf(ty_n_t__List__Olist_It__Nat__Onat_J,type,(
    list_nat: $tType )).

thf(ty_n_t__List__Olist_Itf__a_J,type,(
    list_a: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

thf(ty_n_tf__a,type,(
    a: $tType )).

% Explicit typings (26)
thf(sy_c_Groups_Oplus__class_Oplus_001t__Nat__Onat,type,(
    plus_plus_nat: nat > nat > nat )).

thf(sy_c_Groups_Oplus__class_Oplus_001tf__a,type,(
    plus_plus_a: a > a > a )).

thf(sy_c_Groups_Otimes__class_Otimes_001t__Nat__Onat,type,(
    times_times_nat: nat > nat > nat )).

thf(sy_c_Groups_Otimes__class_Otimes_001tf__a,type,(
    times_times_a: a > a > a )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001tf__a,type,(
    zero_zero_a: a )).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list_001t__Nat__Onat,type,(
    groups921905271st_nat: list_nat > nat )).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list_001tf__a,type,(
    groups1792256535list_a: list_a > a )).

thf(sy_c_List_Olast_001tf__a,type,(
    last_a: list_a > a )).

thf(sy_c_List_Olist_ONil_001t__Nat__Onat,type,(
    nil_nat: list_nat )).

thf(sy_c_List_Olist_ONil_001tf__a,type,(
    nil_a: list_a )).

thf(sy_c_List_Onth_001t__Nat__Onat,type,(
    nth_nat: list_nat > nat > nat )).

thf(sy_c_List_Onth_001tf__a,type,(
    nth_a: list_a > nat > a )).

thf(sy_c_Nat_Osize__class_Osize_001t__List__Olist_It__Nat__Onat_J,type,(
    size_size_list_nat: list_nat > nat )).

thf(sy_c_Nat_Osize__class_Osize_001t__List__Olist_Itf__a_J,type,(
    size_size_list_a: list_a > nat )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001tf__a,type,(
    ord_less_a: a > a > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001tf__a,type,(
    ord_less_eq_a: a > a > $o )).

thf(sy_v_p____,type,(
    p: nat )).

thf(sy_v_x,type,(
    x: a )).

thf(sy_v_xa____,type,(
    xa: a )).

thf(sy_v_xs,type,(
    xs: list_a )).

thf(sy_v_xsa____,type,(
    xsa: list_a )).

thf(sy_v_y,type,(
    y: a )).

thf(sy_v_ya____,type,(
    ya: a )).

% Relevant facts (353)
thf(fact_0_x,axiom,(
    ord_less_a @ zero_zero_a @ xa )).

% x
thf(fact_1_y,axiom,(
    ord_less_a @ ya @ zero_zero_a )).

% y
thf(fact_2_p,axiom,(
    ord_less_a @ ( nth_a @ xsa @ p ) @ zero_zero_a )).

% p
thf(fact_3_xy,axiom,(
    ord_less_a @ zero_zero_a @ ( plus_plus_a @ xa @ ya ) )).

% xy
thf(fact_4__092_060open_062_092_060not_062_A_I0_058_058_Ha_J_A_060_Axs_A_B_Ap_092_060close_062,axiom,(
    ~ ( ord_less_a @ zero_zero_a @ ( nth_a @ xsa @ p ) ) )).

% \<open>\<not> (0::'a) < xs ! p\<close>
thf(fact_5_nonneg_Ohyps_I1_J,axiom,(
    xsa != nil_a )).

% nonneg.hyps(1)
thf(fact_6_p__nz,axiom,(
    ( nth_a @ xsa @ p )
 != zero_zero_a )).

% p_nz
thf(fact_7_different,axiom,(
    ord_less_a @ ( times_times_a @ xa @ ya ) @ zero_zero_a )).

% different
thf(fact_8_same,axiom,(
    ord_less_a @ zero_zero_a @ ( times_times_a @ xa @ ( plus_plus_a @ xa @ ya ) ) )).

% same
thf(fact_9_nonneg_Ohyps_I2_J,axiom,(
    ( last_a @ xsa )
 != zero_zero_a )).

% nonneg.hyps(2)
thf(fact_10_nonneg_Ohyps_I4_J,axiom,(
    ord_less_eq_a @ zero_zero_a @ xa )).

% nonneg.hyps(4)
thf(fact_11_nonneg_Ohyps_I3_J,axiom,
    ( ( plus_plus_a @ ( plus_plus_a @ xa @ ya ) @ ( groups1792256535list_a @ xsa ) )
    = zero_zero_a )).

% nonneg.hyps(3)
thf(fact_12_sum__squares__eq__zero__iff,axiom,(
    ! [X: a,Y: a] :
      ( ( ( plus_plus_a @ ( times_times_a @ X @ X ) @ ( times_times_a @ Y @ Y ) )
        = zero_zero_a )
      = ( ( X = zero_zero_a )
        & ( Y = zero_zero_a ) ) ) )).

% sum_squares_eq_zero_iff
thf(fact_13_add__less__same__cancel1,axiom,(
    ! [B: a,A: a] :
      ( ( ord_less_a @ ( plus_plus_a @ B @ A ) @ B )
      = ( ord_less_a @ A @ zero_zero_a ) ) )).

% add_less_same_cancel1
thf(fact_14_add__less__same__cancel1,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ B @ A ) @ B )
      = ( ord_less_nat @ A @ zero_zero_nat ) ) )).

% add_less_same_cancel1
thf(fact_15_add__less__same__cancel2,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ ( plus_plus_a @ A @ B ) @ B )
      = ( ord_less_a @ A @ zero_zero_a ) ) )).

% add_less_same_cancel2
thf(fact_16_add__less__same__cancel2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ A @ B ) @ B )
      = ( ord_less_nat @ A @ zero_zero_nat ) ) )).

% add_less_same_cancel2
thf(fact_17_less__add__same__cancel1,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ A @ ( plus_plus_a @ A @ B ) )
      = ( ord_less_a @ zero_zero_a @ B ) ) )).

% less_add_same_cancel1
thf(fact_18_less__add__same__cancel1,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ ( plus_plus_nat @ A @ B ) )
      = ( ord_less_nat @ zero_zero_nat @ B ) ) )).

% less_add_same_cancel1
thf(fact_19_less__add__same__cancel2,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ A @ ( plus_plus_a @ B @ A ) )
      = ( ord_less_a @ zero_zero_a @ B ) ) )).

% less_add_same_cancel2
thf(fact_20_less__add__same__cancel2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ ( plus_plus_nat @ B @ A ) )
      = ( ord_less_nat @ zero_zero_nat @ B ) ) )).

% less_add_same_cancel2
thf(fact_21_double__add__less__zero__iff__single__add__less__zero,axiom,(
    ! [A: a] :
      ( ( ord_less_a @ ( plus_plus_a @ A @ A ) @ zero_zero_a )
      = ( ord_less_a @ A @ zero_zero_a ) ) )).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_22_zero__less__double__add__iff__zero__less__single__add,axiom,(
    ! [A: a] :
      ( ( ord_less_a @ zero_zero_a @ ( plus_plus_a @ A @ A ) )
      = ( ord_less_a @ zero_zero_a @ A ) ) )).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_23_less__p__zero,axiom,(
    ! [Q: nat] :
      ( ( ord_less_nat @ Q @ p )
     => ( ( nth_a @ xsa @ Q )
        = zero_zero_a ) ) )).

% less_p_zero
thf(fact_24_add__less__cancel__left,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ ( plus_plus_a @ C @ A ) @ ( plus_plus_a @ C @ B ) )
      = ( ord_less_a @ A @ B ) ) )).

% add_less_cancel_left
thf(fact_25_add__less__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( ord_less_nat @ A @ B ) ) )).

% add_less_cancel_left
thf(fact_26_add__less__cancel__right,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ C ) )
      = ( ord_less_a @ A @ B ) ) )).

% add_less_cancel_right
thf(fact_27_add__less__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( ord_less_nat @ A @ B ) ) )).

% add_less_cancel_right
thf(fact_28_add_Oleft__neutral,axiom,(
    ! [A: a] :
      ( ( plus_plus_a @ zero_zero_a @ A )
      = A ) )).

% add.left_neutral
thf(fact_29_add_Oleft__neutral,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ zero_zero_nat @ A )
      = A ) )).

% add.left_neutral
thf(fact_30_add_Oright__neutral,axiom,(
    ! [A: a] :
      ( ( plus_plus_a @ A @ zero_zero_a )
      = A ) )).

% add.right_neutral
thf(fact_31_add_Oright__neutral,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ A @ zero_zero_nat )
      = A ) )).

% add.right_neutral
thf(fact_32_assms_I1_J,axiom,(
    xs != nil_a )).

% assms(1)
thf(fact_33_assms_I2_J,axiom,(
    ( last_a @ xs )
 != zero_zero_a )).

% assms(2)
thf(fact_34_add__right__cancel,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( ( plus_plus_a @ B @ A )
        = ( plus_plus_a @ C @ A ) )
      = ( B = C ) ) )).

% add_right_cancel
thf(fact_35_add__right__cancel,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
      = ( B = C ) ) )).

% add_right_cancel
thf(fact_36_add__left__cancel,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ( plus_plus_a @ A @ B )
        = ( plus_plus_a @ A @ C ) )
      = ( B = C ) ) )).

% add_left_cancel
thf(fact_37_add__left__cancel,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
      = ( B = C ) ) )).

% add_left_cancel
thf(fact_38_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_39_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_40_zero__eq__add__iff__both__eq__0,axiom,(
    ! [X: nat,Y: nat] :
      ( ( zero_zero_nat
        = ( plus_plus_nat @ X @ Y ) )
      = ( ( X = zero_zero_nat )
        & ( Y = zero_zero_nat ) ) ) )).

% zero_eq_add_iff_both_eq_0
thf(fact_41_add__eq__0__iff__both__eq__0,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ( plus_plus_nat @ X @ Y )
        = zero_zero_nat )
      = ( ( X = zero_zero_nat )
        & ( Y = zero_zero_nat ) ) ) )).

% add_eq_0_iff_both_eq_0
thf(fact_42_add__cancel__right__right,axiom,(
    ! [A: a,B: a] :
      ( ( A
        = ( plus_plus_a @ A @ B ) )
      = ( B = zero_zero_a ) ) )).

% add_cancel_right_right
thf(fact_43_add__cancel__right__right,axiom,(
    ! [A: nat,B: nat] :
      ( ( A
        = ( plus_plus_nat @ A @ B ) )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_right_right
thf(fact_44_add__cancel__right__left,axiom,(
    ! [A: a,B: a] :
      ( ( A
        = ( plus_plus_a @ B @ A ) )
      = ( B = zero_zero_a ) ) )).

% add_cancel_right_left
thf(fact_45_add__cancel__right__left,axiom,(
    ! [A: nat,B: nat] :
      ( ( A
        = ( plus_plus_nat @ B @ A ) )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_right_left
thf(fact_46_add__cancel__left__right,axiom,(
    ! [A: a,B: a] :
      ( ( ( plus_plus_a @ A @ B )
        = A )
      = ( B = zero_zero_a ) ) )).

% add_cancel_left_right
thf(fact_47_add__cancel__left__right,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = A )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_left_right
thf(fact_48_add__cancel__left__left,axiom,(
    ! [B: a,A: a] :
      ( ( ( plus_plus_a @ B @ A )
        = A )
      = ( B = zero_zero_a ) ) )).

% add_cancel_left_left
thf(fact_49_add__cancel__left__left,axiom,(
    ! [B: nat,A: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = A )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_left_left
thf(fact_50_double__zero__sym,axiom,(
    ! [A: a] :
      ( ( zero_zero_a
        = ( plus_plus_a @ A @ A ) )
      = ( A = zero_zero_a ) ) )).

% double_zero_sym
thf(fact_51_double__zero,axiom,(
    ! [A: a] :
      ( ( ( plus_plus_a @ A @ A )
        = zero_zero_a )
      = ( A = zero_zero_a ) ) )).

% double_zero
thf(fact_52_add__le__cancel__right,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_eq_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ C ) )
      = ( ord_less_eq_a @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_53_add__le__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_54_add__le__cancel__left,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_eq_a @ ( plus_plus_a @ C @ A ) @ ( plus_plus_a @ C @ B ) )
      = ( ord_less_eq_a @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_55_add__le__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_56_zero__le__double__add__iff__zero__le__single__add,axiom,(
    ! [A: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ ( plus_plus_a @ A @ A ) )
      = ( ord_less_eq_a @ zero_zero_a @ A ) ) )).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_57_double__add__le__zero__iff__single__add__le__zero,axiom,(
    ! [A: a] :
      ( ( ord_less_eq_a @ ( plus_plus_a @ A @ A ) @ zero_zero_a )
      = ( ord_less_eq_a @ A @ zero_zero_a ) ) )).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_58_le__add__same__cancel2,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ A @ ( plus_plus_a @ B @ A ) )
      = ( ord_less_eq_a @ zero_zero_a @ B ) ) )).

% le_add_same_cancel2
thf(fact_59_le__add__same__cancel2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ ( plus_plus_nat @ B @ A ) )
      = ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )).

% le_add_same_cancel2
thf(fact_60_le__add__same__cancel1,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ A @ ( plus_plus_a @ A @ B ) )
      = ( ord_less_eq_a @ zero_zero_a @ B ) ) )).

% le_add_same_cancel1
thf(fact_61_le__add__same__cancel1,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ ( plus_plus_nat @ A @ B ) )
      = ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )).

% le_add_same_cancel1
thf(fact_62_add__le__same__cancel2,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ ( plus_plus_a @ A @ B ) @ B )
      = ( ord_less_eq_a @ A @ zero_zero_a ) ) )).

% add_le_same_cancel2
thf(fact_63_add__le__same__cancel2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ B ) @ B )
      = ( ord_less_eq_nat @ A @ zero_zero_nat ) ) )).

% add_le_same_cancel2
thf(fact_64_add__le__same__cancel1,axiom,(
    ! [B: a,A: a] :
      ( ( ord_less_eq_a @ ( plus_plus_a @ B @ A ) @ B )
      = ( ord_less_eq_a @ A @ zero_zero_a ) ) )).

% add_le_same_cancel1
thf(fact_65_add__le__same__cancel1,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ B @ A ) @ B )
      = ( ord_less_eq_nat @ A @ zero_zero_nat ) ) )).

% add_le_same_cancel1
thf(fact_66_assms_I3_J,axiom,
    ( ( plus_plus_a @ ( plus_plus_a @ x @ y ) @ ( groups1792256535list_a @ xs ) )
    = zero_zero_a )).

% assms(3)
thf(fact_67_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_68_add__le__imp__le__right,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_eq_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ C ) )
     => ( ord_less_eq_a @ A @ B ) ) )).

% add_le_imp_le_right
thf(fact_69_add__le__imp__le__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_right
thf(fact_70_add__le__imp__le__left,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_eq_a @ ( plus_plus_a @ C @ A ) @ ( plus_plus_a @ C @ B ) )
     => ( ord_less_eq_a @ A @ B ) ) )).

% add_le_imp_le_left
thf(fact_71_add__le__imp__le__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_left
thf(fact_72_le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
        ? [C2: nat] :
          ( B2
          = ( plus_plus_nat @ A2 @ C2 ) ) ) )).

% le_iff_add
thf(fact_73_add__right__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ord_less_eq_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ C ) ) ) )).

% add_right_mono
thf(fact_74_add__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) ) ) )).

% add_right_mono
thf(fact_75_less__eqE,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ~ ! [C3: nat] :
            ( B
           != ( plus_plus_nat @ A @ C3 ) ) ) )).

% less_eqE
thf(fact_76_add__left__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ord_less_eq_a @ ( plus_plus_a @ C @ A ) @ ( plus_plus_a @ C @ B ) ) ) )).

% add_left_mono
thf(fact_77_add__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) ) ) )).

% add_left_mono
thf(fact_78_add__mono,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_eq_a @ C @ D )
       => ( ord_less_eq_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ D ) ) ) ) )).

% add_mono
thf(fact_79_add__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_mono
thf(fact_80_add__mono__thms__linordered__semiring_I1_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( ord_less_eq_a @ I @ J )
        & ( ord_less_eq_a @ K @ L ) )
     => ( ord_less_eq_a @ ( plus_plus_a @ I @ K ) @ ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(1)
thf(fact_81_add__mono__thms__linordered__semiring_I1_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(1)
thf(fact_82_add__mono__thms__linordered__semiring_I2_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( I = J )
        & ( ord_less_eq_a @ K @ L ) )
     => ( ord_less_eq_a @ ( plus_plus_a @ I @ K ) @ ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(2)
thf(fact_83_add__mono__thms__linordered__semiring_I2_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(2)
thf(fact_84_add__mono__thms__linordered__semiring_I3_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( ord_less_eq_a @ I @ J )
        & ( K = L ) )
     => ( ord_less_eq_a @ ( plus_plus_a @ I @ K ) @ ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(3)
thf(fact_85_add__mono__thms__linordered__semiring_I3_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( K = L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(3)
thf(fact_86_add__nonpos__eq__0__iff,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_eq_a @ X @ zero_zero_a )
     => ( ( ord_less_eq_a @ Y @ zero_zero_a )
       => ( ( ( plus_plus_a @ X @ Y )
            = zero_zero_a )
          = ( ( X = zero_zero_a )
            & ( Y = zero_zero_a ) ) ) ) ) )).

% add_nonpos_eq_0_iff
thf(fact_87_add__nonpos__eq__0__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ Y @ zero_zero_nat )
       => ( ( ( plus_plus_nat @ X @ Y )
            = zero_zero_nat )
          = ( ( X = zero_zero_nat )
            & ( Y = zero_zero_nat ) ) ) ) ) )).

% add_nonpos_eq_0_iff
thf(fact_88_add__nonneg__eq__0__iff,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ X )
     => ( ( ord_less_eq_a @ zero_zero_a @ Y )
       => ( ( ( plus_plus_a @ X @ Y )
            = zero_zero_a )
          = ( ( X = zero_zero_a )
            & ( Y = zero_zero_a ) ) ) ) ) )).

% add_nonneg_eq_0_iff
thf(fact_89_add__nonneg__eq__0__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ X )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ Y )
       => ( ( ( plus_plus_nat @ X @ Y )
            = zero_zero_nat )
          = ( ( X = zero_zero_nat )
            & ( Y = zero_zero_nat ) ) ) ) ) )).

% add_nonneg_eq_0_iff
thf(fact_90_add__nonpos__nonpos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ A @ zero_zero_a )
     => ( ( ord_less_eq_a @ B @ zero_zero_a )
       => ( ord_less_eq_a @ ( plus_plus_a @ A @ B ) @ zero_zero_a ) ) ) )).

% add_nonpos_nonpos
thf(fact_91_add__nonpos__nonpos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% add_nonpos_nonpos
thf(fact_92_add__nonneg__nonneg,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ A )
     => ( ( ord_less_eq_a @ zero_zero_a @ B )
       => ( ord_less_eq_a @ zero_zero_a @ ( plus_plus_a @ A @ B ) ) ) ) )).

% add_nonneg_nonneg
thf(fact_93_add__nonneg__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ zero_zero_nat @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% add_nonneg_nonneg
thf(fact_94_add__increasing2,axiom,(
    ! [C: a,B: a,A: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ C )
     => ( ( ord_less_eq_a @ B @ A )
       => ( ord_less_eq_a @ B @ ( plus_plus_a @ A @ C ) ) ) ) )).

% add_increasing2
thf(fact_95_add__increasing2,axiom,(
    ! [C: nat,B: nat,A: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ C )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( ord_less_eq_nat @ B @ ( plus_plus_nat @ A @ C ) ) ) ) )).

% add_increasing2
thf(fact_96_add__decreasing2,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_eq_a @ C @ zero_zero_a )
     => ( ( ord_less_eq_a @ A @ B )
       => ( ord_less_eq_a @ ( plus_plus_a @ A @ C ) @ B ) ) ) )).

% add_decreasing2
thf(fact_97_add__decreasing2,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ C @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ B ) ) ) )).

% add_decreasing2
thf(fact_98_add__increasing,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ A )
     => ( ( ord_less_eq_a @ B @ C )
       => ( ord_less_eq_a @ B @ ( plus_plus_a @ A @ C ) ) ) ) )).

% add_increasing
thf(fact_99_add__increasing,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ B @ ( plus_plus_nat @ A @ C ) ) ) ) )).

% add_increasing
thf(fact_100_add__decreasing,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_eq_a @ A @ zero_zero_a )
     => ( ( ord_less_eq_a @ C @ B )
       => ( ord_less_eq_a @ ( plus_plus_a @ A @ C ) @ B ) ) ) )).

% add_decreasing
thf(fact_101_add__decreasing,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ B ) ) ) )).

% add_decreasing
thf(fact_102_add__less__le__mono,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_eq_a @ C @ D )
       => ( ord_less_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ D ) ) ) ) )).

% add_less_le_mono
thf(fact_103_add__less__le__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_less_le_mono
thf(fact_104_add__le__less__mono,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_a @ C @ D )
       => ( ord_less_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ D ) ) ) ) )).

% add_le_less_mono
thf(fact_105_add__le__less__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ C @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_le_less_mono
thf(fact_106_add__mono__thms__linordered__field_I3_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( ord_less_a @ I @ J )
        & ( ord_less_eq_a @ K @ L ) )
     => ( ord_less_a @ ( plus_plus_a @ I @ K ) @ ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(3)
thf(fact_107_add__mono__thms__linordered__field_I3_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(3)
thf(fact_108_add__mono__thms__linordered__field_I4_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( ord_less_eq_a @ I @ J )
        & ( ord_less_a @ K @ L ) )
     => ( ord_less_a @ ( plus_plus_a @ I @ K ) @ ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(4)
thf(fact_109_add__mono__thms__linordered__field_I4_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(4)
thf(fact_110_add__strict__increasing2,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ A )
     => ( ( ord_less_a @ B @ C )
       => ( ord_less_a @ B @ ( plus_plus_a @ A @ C ) ) ) ) )).

% add_strict_increasing2
thf(fact_111_add__strict__increasing2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ B @ ( plus_plus_nat @ A @ C ) ) ) ) )).

% add_strict_increasing2
thf(fact_112_add__strict__increasing,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_a @ zero_zero_a @ A )
     => ( ( ord_less_eq_a @ B @ C )
       => ( ord_less_a @ B @ ( plus_plus_a @ A @ C ) ) ) ) )).

% add_strict_increasing
thf(fact_113_add__strict__increasing,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_nat @ B @ ( plus_plus_nat @ A @ C ) ) ) ) )).

% add_strict_increasing
thf(fact_114_add__pos__nonneg,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ A )
     => ( ( ord_less_eq_a @ zero_zero_a @ B )
       => ( ord_less_a @ zero_zero_a @ ( plus_plus_a @ A @ B ) ) ) ) )).

% add_pos_nonneg
thf(fact_115_add__pos__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_nat @ zero_zero_nat @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% add_pos_nonneg
thf(fact_116_add__nonpos__neg,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ A @ zero_zero_a )
     => ( ( ord_less_a @ B @ zero_zero_a )
       => ( ord_less_a @ ( plus_plus_a @ A @ B ) @ zero_zero_a ) ) ) )).

% add_nonpos_neg
thf(fact_117_add__nonpos__neg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_nat @ B @ zero_zero_nat )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% add_nonpos_neg
thf(fact_118_add__nonneg__pos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ A )
     => ( ( ord_less_a @ zero_zero_a @ B )
       => ( ord_less_a @ zero_zero_a @ ( plus_plus_a @ A @ B ) ) ) ) )).

% add_nonneg_pos
thf(fact_119_add__nonneg__pos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ zero_zero_nat @ B )
       => ( ord_less_nat @ zero_zero_nat @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% add_nonneg_pos
thf(fact_120_add__neg__nonpos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ A @ zero_zero_a )
     => ( ( ord_less_eq_a @ B @ zero_zero_a )
       => ( ord_less_a @ ( plus_plus_a @ A @ B ) @ zero_zero_a ) ) ) )).

% add_neg_nonpos
thf(fact_121_add__neg__nonpos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% add_neg_nonpos
thf(fact_122_sum__squares__le__zero__iff,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_eq_a @ ( plus_plus_a @ ( times_times_a @ X @ X ) @ ( times_times_a @ Y @ Y ) ) @ zero_zero_a )
      = ( ( X = zero_zero_a )
        & ( Y = zero_zero_a ) ) ) )).

% sum_squares_le_zero_iff
thf(fact_123_zero__reorient,axiom,(
    ! [X: a] :
      ( ( zero_zero_a = X )
      = ( X = zero_zero_a ) ) )).

% zero_reorient
thf(fact_124_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_125_mult_Oleft__commute,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( times_times_a @ B @ ( times_times_a @ A @ C ) )
      = ( times_times_a @ A @ ( times_times_a @ B @ C ) ) ) )).

% mult.left_commute
thf(fact_126_mult_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( times_times_nat @ B @ ( times_times_nat @ A @ C ) )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.left_commute
thf(fact_127_mult_Ocommute,axiom,
    ( times_times_a
    = ( ^ [A2: a,B2: a] :
          ( times_times_a @ B2 @ A2 ) ) )).

% mult.commute
thf(fact_128_mult_Ocommute,axiom,
    ( times_times_nat
    = ( ^ [A2: nat,B2: nat] :
          ( times_times_nat @ B2 @ A2 ) ) )).

% mult.commute
thf(fact_129_mult_Oassoc,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( times_times_a @ ( times_times_a @ A @ B ) @ C )
      = ( times_times_a @ A @ ( times_times_a @ B @ C ) ) ) )).

% mult.assoc
thf(fact_130_mult_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.assoc
thf(fact_131_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( times_times_a @ ( times_times_a @ A @ B ) @ C )
      = ( times_times_a @ A @ ( times_times_a @ B @ C ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_132_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_133_add__right__imp__eq,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( ( plus_plus_a @ B @ A )
        = ( plus_plus_a @ C @ A ) )
     => ( B = C ) ) )).

% add_right_imp_eq
thf(fact_134_add__right__imp__eq,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
     => ( B = C ) ) )).

% add_right_imp_eq
thf(fact_135_add__left__imp__eq,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ( plus_plus_a @ A @ B )
        = ( plus_plus_a @ A @ C ) )
     => ( B = C ) ) )).

% add_left_imp_eq
thf(fact_136_add__left__imp__eq,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
     => ( B = C ) ) )).

% add_left_imp_eq
thf(fact_137_add_Oleft__commute,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( plus_plus_a @ B @ ( plus_plus_a @ A @ C ) )
      = ( plus_plus_a @ A @ ( plus_plus_a @ B @ C ) ) ) )).

% add.left_commute
thf(fact_138_add_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( plus_plus_nat @ B @ ( plus_plus_nat @ A @ C ) )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.left_commute
thf(fact_139_add_Ocommute,axiom,
    ( plus_plus_a
    = ( ^ [A2: a,B2: a] :
          ( plus_plus_a @ B2 @ A2 ) ) )).

% add.commute
thf(fact_140_add_Ocommute,axiom,
    ( plus_plus_nat
    = ( ^ [A2: nat,B2: nat] :
          ( plus_plus_nat @ B2 @ A2 ) ) )).

% add.commute
thf(fact_141_add_Oright__cancel,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( ( plus_plus_a @ B @ A )
        = ( plus_plus_a @ C @ A ) )
      = ( B = C ) ) )).

% add.right_cancel
thf(fact_142_add_Oleft__cancel,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ( plus_plus_a @ A @ B )
        = ( plus_plus_a @ A @ C ) )
      = ( B = C ) ) )).

% add.left_cancel
thf(fact_143_add_Oassoc,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( plus_plus_a @ ( plus_plus_a @ A @ B ) @ C )
      = ( plus_plus_a @ A @ ( plus_plus_a @ B @ C ) ) ) )).

% add.assoc
thf(fact_144_add_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.assoc
thf(fact_145_group__cancel_Oadd2,axiom,(
    ! [B3: a,K: a,B: a,A: a] :
      ( ( B3
        = ( plus_plus_a @ K @ B ) )
     => ( ( plus_plus_a @ A @ B3 )
        = ( plus_plus_a @ K @ ( plus_plus_a @ A @ B ) ) ) ) )).

% group_cancel.add2
thf(fact_146_group__cancel_Oadd2,axiom,(
    ! [B3: nat,K: nat,B: nat,A: nat] :
      ( ( B3
        = ( plus_plus_nat @ K @ B ) )
     => ( ( plus_plus_nat @ A @ B3 )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add2
thf(fact_147_group__cancel_Oadd1,axiom,(
    ! [A3: a,K: a,A: a,B: a] :
      ( ( A3
        = ( plus_plus_a @ K @ A ) )
     => ( ( plus_plus_a @ A3 @ B )
        = ( plus_plus_a @ K @ ( plus_plus_a @ A @ B ) ) ) ) )).

% group_cancel.add1
thf(fact_148_group__cancel_Oadd1,axiom,(
    ! [A3: nat,K: nat,A: nat,B: nat] :
      ( ( A3
        = ( plus_plus_nat @ K @ A ) )
     => ( ( plus_plus_nat @ A3 @ B )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add1
thf(fact_149_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( I = J )
        & ( K = L ) )
     => ( ( plus_plus_a @ I @ K )
        = ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_150_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( K = L ) )
     => ( ( plus_plus_nat @ I @ K )
        = ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_151_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( plus_plus_a @ ( plus_plus_a @ A @ B ) @ C )
      = ( plus_plus_a @ A @ ( plus_plus_a @ B @ C ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_152_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_153_zero__less__iff__neq__zero,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( N != zero_zero_nat ) ) )).

% zero_less_iff_neq_zero
thf(fact_154_gr__implies__not__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not_zero
thf(fact_155_not__less__zero,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less_zero
thf(fact_156_gr__zeroI,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_zeroI
thf(fact_157_add_Ogroup__left__neutral,axiom,(
    ! [A: a] :
      ( ( plus_plus_a @ zero_zero_a @ A )
      = A ) )).

% add.group_left_neutral
thf(fact_158_add_Ocomm__neutral,axiom,(
    ! [A: a] :
      ( ( plus_plus_a @ A @ zero_zero_a )
      = A ) )).

% add.comm_neutral
thf(fact_159_add_Ocomm__neutral,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ A @ zero_zero_nat )
      = A ) )).

% add.comm_neutral
thf(fact_160_comm__monoid__add__class_Oadd__0,axiom,(
    ! [A: a] :
      ( ( plus_plus_a @ zero_zero_a @ A )
      = A ) )).

% comm_monoid_add_class.add_0
thf(fact_161_comm__monoid__add__class_Oadd__0,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ zero_zero_nat @ A )
      = A ) )).

% comm_monoid_add_class.add_0
thf(fact_162_add__less__imp__less__right,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ C ) )
     => ( ord_less_a @ A @ B ) ) )).

% add_less_imp_less_right
thf(fact_163_add__less__imp__less__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
     => ( ord_less_nat @ A @ B ) ) )).

% add_less_imp_less_right
thf(fact_164_add__less__imp__less__left,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ ( plus_plus_a @ C @ A ) @ ( plus_plus_a @ C @ B ) )
     => ( ord_less_a @ A @ B ) ) )).

% add_less_imp_less_left
thf(fact_165_add__less__imp__less__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
     => ( ord_less_nat @ A @ B ) ) )).

% add_less_imp_less_left
thf(fact_166_add__strict__right__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_a @ A @ B )
     => ( ord_less_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ C ) ) ) )).

% add_strict_right_mono
thf(fact_167_add__strict__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) ) ) )).

% add_strict_right_mono
thf(fact_168_add__strict__left__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_a @ A @ B )
     => ( ord_less_a @ ( plus_plus_a @ C @ A ) @ ( plus_plus_a @ C @ B ) ) ) )).

% add_strict_left_mono
thf(fact_169_add__strict__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) ) ) )).

% add_strict_left_mono
thf(fact_170_add__strict__mono,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_a @ C @ D )
       => ( ord_less_a @ ( plus_plus_a @ A @ C ) @ ( plus_plus_a @ B @ D ) ) ) ) )).

% add_strict_mono
thf(fact_171_add__strict__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ C @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_strict_mono
thf(fact_172_add__mono__thms__linordered__field_I1_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( ord_less_a @ I @ J )
        & ( K = L ) )
     => ( ord_less_a @ ( plus_plus_a @ I @ K ) @ ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(1)
thf(fact_173_add__mono__thms__linordered__field_I1_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( K = L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(1)
thf(fact_174_add__mono__thms__linordered__field_I2_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( I = J )
        & ( ord_less_a @ K @ L ) )
     => ( ord_less_a @ ( plus_plus_a @ I @ K ) @ ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(2)
thf(fact_175_add__mono__thms__linordered__field_I2_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(2)
thf(fact_176_add__mono__thms__linordered__field_I5_J,axiom,(
    ! [I: a,J: a,K: a,L: a] :
      ( ( ( ord_less_a @ I @ J )
        & ( ord_less_a @ K @ L ) )
     => ( ord_less_a @ ( plus_plus_a @ I @ K ) @ ( plus_plus_a @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(5)
thf(fact_177_add__mono__thms__linordered__field_I5_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(5)
thf(fact_178_pos__add__strict,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_a @ zero_zero_a @ A )
     => ( ( ord_less_a @ B @ C )
       => ( ord_less_a @ B @ ( plus_plus_a @ A @ C ) ) ) ) )).

% pos_add_strict
thf(fact_179_pos__add__strict,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ B @ ( plus_plus_nat @ A @ C ) ) ) ) )).

% pos_add_strict
thf(fact_180_canonically__ordered__monoid__add__class_OlessE,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ! [C3: nat] :
            ( ( B
              = ( plus_plus_nat @ A @ C3 ) )
           => ( C3 = zero_zero_nat ) ) ) )).

% canonically_ordered_monoid_add_class.lessE
thf(fact_181_add__pos__pos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ A )
     => ( ( ord_less_a @ zero_zero_a @ B )
       => ( ord_less_a @ zero_zero_a @ ( plus_plus_a @ A @ B ) ) ) ) )).

% add_pos_pos
thf(fact_182_add__pos__pos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ zero_zero_nat @ B )
       => ( ord_less_nat @ zero_zero_nat @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% add_pos_pos
thf(fact_183_add__neg__neg,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ A @ zero_zero_a )
     => ( ( ord_less_a @ B @ zero_zero_a )
       => ( ord_less_a @ ( plus_plus_a @ A @ B ) @ zero_zero_a ) ) ) )).

% add_neg_neg
thf(fact_184_add__neg__neg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ zero_zero_nat )
     => ( ( ord_less_nat @ B @ zero_zero_nat )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% add_neg_neg
thf(fact_185_sum__squares__gt__zero__iff,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_a @ zero_zero_a @ ( plus_plus_a @ ( times_times_a @ X @ X ) @ ( times_times_a @ Y @ Y ) ) )
      = ( ( X != zero_zero_a )
        | ( Y != zero_zero_a ) ) ) )).

% sum_squares_gt_zero_iff
thf(fact_186_sum__list_ONil,axiom,
    ( ( groups921905271st_nat @ nil_nat )
    = zero_zero_nat )).

% sum_list.Nil
thf(fact_187_sum__list_ONil,axiom,
    ( ( groups1792256535list_a @ nil_a )
    = zero_zero_a )).

% sum_list.Nil
thf(fact_188_mult__cancel__right,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ( times_times_a @ A @ C )
        = ( times_times_a @ B @ C ) )
      = ( ( C = zero_zero_a )
        | ( A = B ) ) ) )).

% mult_cancel_right
thf(fact_189_mult__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ( times_times_nat @ A @ C )
        = ( times_times_nat @ B @ C ) )
      = ( ( C = zero_zero_nat )
        | ( A = B ) ) ) )).

% mult_cancel_right
thf(fact_190_mult__cancel__left,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ( times_times_a @ C @ A )
        = ( times_times_a @ C @ B ) )
      = ( ( C = zero_zero_a )
        | ( A = B ) ) ) )).

% mult_cancel_left
thf(fact_191_mult__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ( times_times_nat @ C @ A )
        = ( times_times_nat @ C @ B ) )
      = ( ( C = zero_zero_nat )
        | ( A = B ) ) ) )).

% mult_cancel_left
thf(fact_192_mult__eq__0__iff,axiom,(
    ! [A: a,B: a] :
      ( ( ( times_times_a @ A @ B )
        = zero_zero_a )
      = ( ( A = zero_zero_a )
        | ( B = zero_zero_a ) ) ) )).

% mult_eq_0_iff
thf(fact_193_mult__eq__0__iff,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
        = zero_zero_nat )
      = ( ( A = zero_zero_nat )
        | ( B = zero_zero_nat ) ) ) )).

% mult_eq_0_iff
thf(fact_194_mult__zero__right,axiom,(
    ! [A: a] :
      ( ( times_times_a @ A @ zero_zero_a )
      = zero_zero_a ) )).

% mult_zero_right
thf(fact_195_mult__zero__right,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ zero_zero_nat )
      = zero_zero_nat ) )).

% mult_zero_right
thf(fact_196_mult__zero__left,axiom,(
    ! [A: a] :
      ( ( times_times_a @ zero_zero_a @ A )
      = zero_zero_a ) )).

% mult_zero_left
thf(fact_197_mult__zero__left,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% mult_zero_left
thf(fact_198_not__sum__squares__lt__zero,axiom,(
    ! [X: a,Y: a] :
      ~ ( ord_less_a @ ( plus_plus_a @ ( times_times_a @ X @ X ) @ ( times_times_a @ Y @ Y ) ) @ zero_zero_a ) )).

% not_sum_squares_lt_zero
thf(fact_199_sum__squares__ge__zero,axiom,(
    ! [X: a,Y: a] :
      ( ord_less_eq_a @ zero_zero_a @ ( plus_plus_a @ ( times_times_a @ X @ X ) @ ( times_times_a @ Y @ Y ) ) ) )).

% sum_squares_ge_zero
thf(fact_200_mult__less__le__imp__less,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_eq_a @ C @ D )
       => ( ( ord_less_eq_a @ zero_zero_a @ A )
         => ( ( ord_less_a @ zero_zero_a @ C )
           => ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ D ) ) ) ) ) ) )).

% mult_less_le_imp_less
thf(fact_201_mult__less__le__imp__less,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
         => ( ( ord_less_nat @ zero_zero_nat @ C )
           => ( ord_less_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_less_le_imp_less
thf(fact_202_linorder__neqE__linordered__idom,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
     => ( ~ ( ord_less_a @ X @ Y )
       => ( ord_less_a @ Y @ X ) ) ) )).

% linorder_neqE_linordered_idom
thf(fact_203_mult__not__zero,axiom,(
    ! [A: a,B: a] :
      ( ( ( times_times_a @ A @ B )
       != zero_zero_a )
     => ( ( A != zero_zero_a )
        & ( B != zero_zero_a ) ) ) )).

% mult_not_zero
thf(fact_204_mult__not__zero,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
       != zero_zero_nat )
     => ( ( A != zero_zero_nat )
        & ( B != zero_zero_nat ) ) ) )).

% mult_not_zero
thf(fact_205_divisors__zero,axiom,(
    ! [A: a,B: a] :
      ( ( ( times_times_a @ A @ B )
        = zero_zero_a )
     => ( ( A = zero_zero_a )
        | ( B = zero_zero_a ) ) ) )).

% divisors_zero
thf(fact_206_divisors__zero,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
        = zero_zero_nat )
     => ( ( A = zero_zero_nat )
        | ( B = zero_zero_nat ) ) ) )).

% divisors_zero
thf(fact_207_no__zero__divisors,axiom,(
    ! [A: a,B: a] :
      ( ( A != zero_zero_a )
     => ( ( B != zero_zero_a )
       => ( ( times_times_a @ A @ B )
         != zero_zero_a ) ) ) )).

% no_zero_divisors
thf(fact_208_no__zero__divisors,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != zero_zero_nat )
     => ( ( B != zero_zero_nat )
       => ( ( times_times_nat @ A @ B )
         != zero_zero_nat ) ) ) )).

% no_zero_divisors
thf(fact_209_mult__left__cancel,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( C != zero_zero_a )
     => ( ( ( times_times_a @ C @ A )
          = ( times_times_a @ C @ B ) )
        = ( A = B ) ) ) )).

% mult_left_cancel
thf(fact_210_mult__left__cancel,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( ( times_times_nat @ C @ A )
          = ( times_times_nat @ C @ B ) )
        = ( A = B ) ) ) )).

% mult_left_cancel
thf(fact_211_mult__right__cancel,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( C != zero_zero_a )
     => ( ( ( times_times_a @ A @ C )
          = ( times_times_a @ B @ C ) )
        = ( A = B ) ) ) )).

% mult_right_cancel
thf(fact_212_mult__right__cancel,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( ( times_times_nat @ A @ C )
          = ( times_times_nat @ B @ C ) )
        = ( A = B ) ) ) )).

% mult_right_cancel
thf(fact_213_ring__class_Oring__distribs_I2_J,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( times_times_a @ ( plus_plus_a @ A @ B ) @ C )
      = ( plus_plus_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) ) ) )).

% ring_class.ring_distribs(2)
thf(fact_214_ring__class_Oring__distribs_I1_J,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( times_times_a @ A @ ( plus_plus_a @ B @ C ) )
      = ( plus_plus_a @ ( times_times_a @ A @ B ) @ ( times_times_a @ A @ C ) ) ) )).

% ring_class.ring_distribs(1)
thf(fact_215_comm__semiring__class_Odistrib,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( times_times_a @ ( plus_plus_a @ A @ B ) @ C )
      = ( plus_plus_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) ) ) )).

% comm_semiring_class.distrib
thf(fact_216_comm__semiring__class_Odistrib,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) )).

% comm_semiring_class.distrib
thf(fact_217_distrib__left,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( times_times_a @ A @ ( plus_plus_a @ B @ C ) )
      = ( plus_plus_a @ ( times_times_a @ A @ B ) @ ( times_times_a @ A @ C ) ) ) )).

% distrib_left
thf(fact_218_distrib__left,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ A @ ( plus_plus_nat @ B @ C ) )
      = ( plus_plus_nat @ ( times_times_nat @ A @ B ) @ ( times_times_nat @ A @ C ) ) ) )).

% distrib_left
thf(fact_219_distrib__right,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( times_times_a @ ( plus_plus_a @ A @ B ) @ C )
      = ( plus_plus_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) ) ) )).

% distrib_right
thf(fact_220_distrib__right,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) )).

% distrib_right
thf(fact_221_combine__common__factor,axiom,(
    ! [A: a,E: a,B: a,C: a] :
      ( ( plus_plus_a @ ( times_times_a @ A @ E ) @ ( plus_plus_a @ ( times_times_a @ B @ E ) @ C ) )
      = ( plus_plus_a @ ( times_times_a @ ( plus_plus_a @ A @ B ) @ E ) @ C ) ) )).

% combine_common_factor
thf(fact_222_combine__common__factor,axiom,(
    ! [A: nat,E: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( times_times_nat @ A @ E ) @ ( plus_plus_nat @ ( times_times_nat @ B @ E ) @ C ) )
      = ( plus_plus_nat @ ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ E ) @ C ) ) )).

% combine_common_factor
thf(fact_223_mult__mono,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_eq_a @ C @ D )
       => ( ( ord_less_eq_a @ zero_zero_a @ B )
         => ( ( ord_less_eq_a @ zero_zero_a @ C )
           => ( ord_less_eq_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ D ) ) ) ) ) ) )).

% mult_mono
thf(fact_224_mult__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_mono
thf(fact_225_mult__mono_H,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_eq_a @ C @ D )
       => ( ( ord_less_eq_a @ zero_zero_a @ A )
         => ( ( ord_less_eq_a @ zero_zero_a @ C )
           => ( ord_less_eq_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ D ) ) ) ) ) ) )).

% mult_mono'
thf(fact_226_mult__mono_H,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_mono'
thf(fact_227_zero__le__square,axiom,(
    ! [A: a] :
      ( ord_less_eq_a @ zero_zero_a @ ( times_times_a @ A @ A ) ) )).

% zero_le_square
thf(fact_228_split__mult__pos__le,axiom,(
    ! [A: a,B: a] :
      ( ( ( ( ord_less_eq_a @ zero_zero_a @ A )
          & ( ord_less_eq_a @ zero_zero_a @ B ) )
        | ( ( ord_less_eq_a @ A @ zero_zero_a )
          & ( ord_less_eq_a @ B @ zero_zero_a ) ) )
     => ( ord_less_eq_a @ zero_zero_a @ ( times_times_a @ A @ B ) ) ) )).

% split_mult_pos_le
thf(fact_229_mult__left__mono__neg,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( ord_less_eq_a @ B @ A )
     => ( ( ord_less_eq_a @ C @ zero_zero_a )
       => ( ord_less_eq_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) ) ) ) )).

% mult_left_mono_neg
thf(fact_230_mult__nonpos__nonpos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ A @ zero_zero_a )
     => ( ( ord_less_eq_a @ B @ zero_zero_a )
       => ( ord_less_eq_a @ zero_zero_a @ ( times_times_a @ A @ B ) ) ) ) )).

% mult_nonpos_nonpos
thf(fact_231_mult__left__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_eq_a @ zero_zero_a @ C )
       => ( ord_less_eq_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) ) ) ) )).

% mult_left_mono
thf(fact_232_mult__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% mult_left_mono
thf(fact_233_mult__right__mono__neg,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( ord_less_eq_a @ B @ A )
     => ( ( ord_less_eq_a @ C @ zero_zero_a )
       => ( ord_less_eq_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) ) ) ) )).

% mult_right_mono_neg
thf(fact_234_mult__right__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_eq_a @ zero_zero_a @ C )
       => ( ord_less_eq_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) ) ) ) )).

% mult_right_mono
thf(fact_235_mult__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) ) )).

% mult_right_mono
thf(fact_236_mult__le__0__iff,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ ( times_times_a @ A @ B ) @ zero_zero_a )
      = ( ( ( ord_less_eq_a @ zero_zero_a @ A )
          & ( ord_less_eq_a @ B @ zero_zero_a ) )
        | ( ( ord_less_eq_a @ A @ zero_zero_a )
          & ( ord_less_eq_a @ zero_zero_a @ B ) ) ) ) )).

% mult_le_0_iff
thf(fact_237_split__mult__neg__le,axiom,(
    ! [A: a,B: a] :
      ( ( ( ( ord_less_eq_a @ zero_zero_a @ A )
          & ( ord_less_eq_a @ B @ zero_zero_a ) )
        | ( ( ord_less_eq_a @ A @ zero_zero_a )
          & ( ord_less_eq_a @ zero_zero_a @ B ) ) )
     => ( ord_less_eq_a @ ( times_times_a @ A @ B ) @ zero_zero_a ) ) )).

% split_mult_neg_le
thf(fact_238_split__mult__neg__le,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( ( ord_less_eq_nat @ zero_zero_nat @ A )
          & ( ord_less_eq_nat @ B @ zero_zero_nat ) )
        | ( ( ord_less_eq_nat @ A @ zero_zero_nat )
          & ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )
     => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) )).

% split_mult_neg_le
thf(fact_239_mult__nonneg__nonneg,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ A )
     => ( ( ord_less_eq_a @ zero_zero_a @ B )
       => ( ord_less_eq_a @ zero_zero_a @ ( times_times_a @ A @ B ) ) ) ) )).

% mult_nonneg_nonneg
thf(fact_240_mult__nonneg__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ zero_zero_nat @ ( times_times_nat @ A @ B ) ) ) ) )).

% mult_nonneg_nonneg
thf(fact_241_mult__nonneg__nonpos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ A )
     => ( ( ord_less_eq_a @ B @ zero_zero_a )
       => ( ord_less_eq_a @ ( times_times_a @ A @ B ) @ zero_zero_a ) ) ) )).

% mult_nonneg_nonpos
thf(fact_242_mult__nonneg__nonpos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_nonneg_nonpos
thf(fact_243_mult__nonpos__nonneg,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ A @ zero_zero_a )
     => ( ( ord_less_eq_a @ zero_zero_a @ B )
       => ( ord_less_eq_a @ ( times_times_a @ A @ B ) @ zero_zero_a ) ) ) )).

% mult_nonpos_nonneg
thf(fact_244_mult__nonpos__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_nonpos_nonneg
thf(fact_245_mult__nonneg__nonpos2,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ A )
     => ( ( ord_less_eq_a @ B @ zero_zero_a )
       => ( ord_less_eq_a @ ( times_times_a @ B @ A ) @ zero_zero_a ) ) ) )).

% mult_nonneg_nonpos2
thf(fact_246_mult__nonneg__nonpos2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( times_times_nat @ B @ A ) @ zero_zero_nat ) ) ) )).

% mult_nonneg_nonpos2
thf(fact_247_zero__le__mult__iff,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_eq_a @ zero_zero_a @ ( times_times_a @ A @ B ) )
      = ( ( ( ord_less_eq_a @ zero_zero_a @ A )
          & ( ord_less_eq_a @ zero_zero_a @ B ) )
        | ( ( ord_less_eq_a @ A @ zero_zero_a )
          & ( ord_less_eq_a @ B @ zero_zero_a ) ) ) ) )).

% zero_le_mult_iff
thf(fact_248_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_eq_a @ zero_zero_a @ C )
       => ( ord_less_eq_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) ) ) ) )).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_249_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_250_mult__neg__neg,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ A @ zero_zero_a )
     => ( ( ord_less_a @ B @ zero_zero_a )
       => ( ord_less_a @ zero_zero_a @ ( times_times_a @ A @ B ) ) ) ) )).

% mult_neg_neg
thf(fact_251_not__square__less__zero,axiom,(
    ! [A: a] :
      ~ ( ord_less_a @ ( times_times_a @ A @ A ) @ zero_zero_a ) )).

% not_square_less_zero
thf(fact_252_mult__less__0__iff,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ ( times_times_a @ A @ B ) @ zero_zero_a )
      = ( ( ( ord_less_a @ zero_zero_a @ A )
          & ( ord_less_a @ B @ zero_zero_a ) )
        | ( ( ord_less_a @ A @ zero_zero_a )
          & ( ord_less_a @ zero_zero_a @ B ) ) ) ) )).

% mult_less_0_iff
thf(fact_253_mult__neg__pos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ A @ zero_zero_a )
     => ( ( ord_less_a @ zero_zero_a @ B )
       => ( ord_less_a @ ( times_times_a @ A @ B ) @ zero_zero_a ) ) ) )).

% mult_neg_pos
thf(fact_254_mult__neg__pos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ zero_zero_nat )
     => ( ( ord_less_nat @ zero_zero_nat @ B )
       => ( ord_less_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_neg_pos
thf(fact_255_mult__pos__neg,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ A )
     => ( ( ord_less_a @ B @ zero_zero_a )
       => ( ord_less_a @ ( times_times_a @ A @ B ) @ zero_zero_a ) ) ) )).

% mult_pos_neg
thf(fact_256_mult__pos__neg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ B @ zero_zero_nat )
       => ( ord_less_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_pos_neg
thf(fact_257_mult__pos__pos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ A )
     => ( ( ord_less_a @ zero_zero_a @ B )
       => ( ord_less_a @ zero_zero_a @ ( times_times_a @ A @ B ) ) ) ) )).

% mult_pos_pos
thf(fact_258_mult__pos__pos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ zero_zero_nat @ B )
       => ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ A @ B ) ) ) ) )).

% mult_pos_pos
thf(fact_259_mult__pos__neg2,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ A )
     => ( ( ord_less_a @ B @ zero_zero_a )
       => ( ord_less_a @ ( times_times_a @ B @ A ) @ zero_zero_a ) ) ) )).

% mult_pos_neg2
thf(fact_260_mult__pos__neg2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ B @ zero_zero_nat )
       => ( ord_less_nat @ ( times_times_nat @ B @ A ) @ zero_zero_nat ) ) ) )).

% mult_pos_neg2
thf(fact_261_zero__less__mult__iff,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ ( times_times_a @ A @ B ) )
      = ( ( ( ord_less_a @ zero_zero_a @ A )
          & ( ord_less_a @ zero_zero_a @ B ) )
        | ( ( ord_less_a @ A @ zero_zero_a )
          & ( ord_less_a @ B @ zero_zero_a ) ) ) ) )).

% zero_less_mult_iff
thf(fact_262_zero__less__mult__pos,axiom,(
    ! [A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ ( times_times_a @ A @ B ) )
     => ( ( ord_less_a @ zero_zero_a @ A )
       => ( ord_less_a @ zero_zero_a @ B ) ) ) )).

% zero_less_mult_pos
thf(fact_263_zero__less__mult__pos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ A @ B ) )
     => ( ( ord_less_nat @ zero_zero_nat @ A )
       => ( ord_less_nat @ zero_zero_nat @ B ) ) ) )).

% zero_less_mult_pos
thf(fact_264_zero__less__mult__pos2,axiom,(
    ! [B: a,A: a] :
      ( ( ord_less_a @ zero_zero_a @ ( times_times_a @ B @ A ) )
     => ( ( ord_less_a @ zero_zero_a @ A )
       => ( ord_less_a @ zero_zero_a @ B ) ) ) )).

% zero_less_mult_pos2
thf(fact_265_zero__less__mult__pos2,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ B @ A ) )
     => ( ( ord_less_nat @ zero_zero_nat @ A )
       => ( ord_less_nat @ zero_zero_nat @ B ) ) ) )).

% zero_less_mult_pos2
thf(fact_266_mult__less__cancel__left__neg,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ C @ zero_zero_a )
     => ( ( ord_less_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
        = ( ord_less_a @ B @ A ) ) ) )).

% mult_less_cancel_left_neg
thf(fact_267_mult__less__cancel__left__pos,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ C )
     => ( ( ord_less_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
        = ( ord_less_a @ A @ B ) ) ) )).

% mult_less_cancel_left_pos
thf(fact_268_mult__strict__left__mono__neg,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( ord_less_a @ B @ A )
     => ( ( ord_less_a @ C @ zero_zero_a )
       => ( ord_less_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) ) ) ) )).

% mult_strict_left_mono_neg
thf(fact_269_mult__strict__left__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_a @ zero_zero_a @ C )
       => ( ord_less_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) ) ) ) )).

% mult_strict_left_mono
thf(fact_270_mult__strict__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ zero_zero_nat @ C )
       => ( ord_less_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% mult_strict_left_mono
thf(fact_271_mult__less__cancel__left__disj,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
      = ( ( ( ord_less_a @ zero_zero_a @ C )
          & ( ord_less_a @ A @ B ) )
        | ( ( ord_less_a @ C @ zero_zero_a )
          & ( ord_less_a @ B @ A ) ) ) ) )).

% mult_less_cancel_left_disj
thf(fact_272_mult__strict__right__mono__neg,axiom,(
    ! [B: a,A: a,C: a] :
      ( ( ord_less_a @ B @ A )
     => ( ( ord_less_a @ C @ zero_zero_a )
       => ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) ) ) ) )).

% mult_strict_right_mono_neg
thf(fact_273_mult__strict__right__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_a @ zero_zero_a @ C )
       => ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) ) ) ) )).

% mult_strict_right_mono
thf(fact_274_mult__strict__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ zero_zero_nat @ C )
       => ( ord_less_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) ) )).

% mult_strict_right_mono
thf(fact_275_mult__less__cancel__right__disj,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) )
      = ( ( ( ord_less_a @ zero_zero_a @ C )
          & ( ord_less_a @ A @ B ) )
        | ( ( ord_less_a @ C @ zero_zero_a )
          & ( ord_less_a @ B @ A ) ) ) ) )).

% mult_less_cancel_right_disj
thf(fact_276_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,(
    ! [A: a,B: a,C: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_a @ zero_zero_a @ C )
       => ( ord_less_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) ) ) ) )).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_277_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ zero_zero_nat @ C )
       => ( ord_less_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_278_add__less__zeroD,axiom,(
    ! [X: a,Y: a] :
      ( ( ord_less_a @ ( plus_plus_a @ X @ Y ) @ zero_zero_a )
     => ( ( ord_less_a @ X @ zero_zero_a )
        | ( ord_less_a @ Y @ zero_zero_a ) ) ) )).

% add_less_zeroD
thf(fact_279_mult__le__cancel__left,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_eq_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
      = ( ( ( ord_less_a @ zero_zero_a @ C )
         => ( ord_less_eq_a @ A @ B ) )
        & ( ( ord_less_a @ C @ zero_zero_a )
         => ( ord_less_eq_a @ B @ A ) ) ) ) )).

% mult_le_cancel_left
thf(fact_280_mult__le__cancel__right,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_eq_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) )
      = ( ( ( ord_less_a @ zero_zero_a @ C )
         => ( ord_less_eq_a @ A @ B ) )
        & ( ( ord_less_a @ C @ zero_zero_a )
         => ( ord_less_eq_a @ B @ A ) ) ) ) )).

% mult_le_cancel_right
thf(fact_281_mult__left__less__imp__less,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
     => ( ( ord_less_eq_a @ zero_zero_a @ C )
       => ( ord_less_a @ A @ B ) ) ) )).

% mult_left_less_imp_less
thf(fact_282_mult__left__less__imp__less,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_nat @ A @ B ) ) ) )).

% mult_left_less_imp_less
thf(fact_283_mult__strict__mono,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_a @ C @ D )
       => ( ( ord_less_a @ zero_zero_a @ B )
         => ( ( ord_less_eq_a @ zero_zero_a @ C )
           => ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ D ) ) ) ) ) ) )).

% mult_strict_mono
thf(fact_284_mult__strict__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ C @ D )
       => ( ( ord_less_nat @ zero_zero_nat @ B )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_strict_mono
thf(fact_285_mult__less__cancel__left,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
      = ( ( ( ord_less_eq_a @ zero_zero_a @ C )
         => ( ord_less_a @ A @ B ) )
        & ( ( ord_less_eq_a @ C @ zero_zero_a )
         => ( ord_less_a @ B @ A ) ) ) ) )).

% mult_less_cancel_left
thf(fact_286_mult__right__less__imp__less,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) )
     => ( ( ord_less_eq_a @ zero_zero_a @ C )
       => ( ord_less_a @ A @ B ) ) ) )).

% mult_right_less_imp_less
thf(fact_287_mult__right__less__imp__less,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_nat @ A @ B ) ) ) )).

% mult_right_less_imp_less
thf(fact_288_mult__strict__mono_H,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_a @ A @ B )
     => ( ( ord_less_a @ C @ D )
       => ( ( ord_less_eq_a @ zero_zero_a @ A )
         => ( ( ord_less_eq_a @ zero_zero_a @ C )
           => ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ D ) ) ) ) ) ) )).

% mult_strict_mono'
thf(fact_289_mult__strict__mono_H,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_strict_mono'
thf(fact_290_mult__less__cancel__right,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) )
      = ( ( ( ord_less_eq_a @ zero_zero_a @ C )
         => ( ord_less_a @ A @ B ) )
        & ( ( ord_less_eq_a @ C @ zero_zero_a )
         => ( ord_less_a @ B @ A ) ) ) ) )).

% mult_less_cancel_right
thf(fact_291_mult__le__cancel__left__neg,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ C @ zero_zero_a )
     => ( ( ord_less_eq_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
        = ( ord_less_eq_a @ B @ A ) ) ) )).

% mult_le_cancel_left_neg
thf(fact_292_mult__le__cancel__left__pos,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_a @ zero_zero_a @ C )
     => ( ( ord_less_eq_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
        = ( ord_less_eq_a @ A @ B ) ) ) )).

% mult_le_cancel_left_pos
thf(fact_293_mult__left__le__imp__le,axiom,(
    ! [C: a,A: a,B: a] :
      ( ( ord_less_eq_a @ ( times_times_a @ C @ A ) @ ( times_times_a @ C @ B ) )
     => ( ( ord_less_a @ zero_zero_a @ C )
       => ( ord_less_eq_a @ A @ B ) ) ) )).

% mult_left_le_imp_le
thf(fact_294_mult__left__le__imp__le,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) )
     => ( ( ord_less_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ A @ B ) ) ) )).

% mult_left_le_imp_le
thf(fact_295_mult__right__le__imp__le,axiom,(
    ! [A: a,C: a,B: a] :
      ( ( ord_less_eq_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ C ) )
     => ( ( ord_less_a @ zero_zero_a @ C )
       => ( ord_less_eq_a @ A @ B ) ) ) )).

% mult_right_le_imp_le
thf(fact_296_mult__right__le__imp__le,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) )
     => ( ( ord_less_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ A @ B ) ) ) )).

% mult_right_le_imp_le
thf(fact_297_mult__le__less__imp__less,axiom,(
    ! [A: a,B: a,C: a,D: a] :
      ( ( ord_less_eq_a @ A @ B )
     => ( ( ord_less_a @ C @ D )
       => ( ( ord_less_a @ zero_zero_a @ A )
         => ( ( ord_less_eq_a @ zero_zero_a @ C )
           => ( ord_less_a @ ( times_times_a @ A @ C ) @ ( times_times_a @ B @ D ) ) ) ) ) ) )).

% mult_le_less_imp_less
thf(fact_298_mult__le__less__imp__less,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ C @ D )
       => ( ( ord_less_nat @ zero_zero_nat @ A )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_le_less_imp_less
thf(fact_299_mult__le__cancel__iff1,axiom,(
    ! [Z: a,X: a,Y: a] :
      ( ( ord_less_a @ zero_zero_a @ Z )
     => ( ( ord_less_eq_a @ ( times_times_a @ X @ Z ) @ ( times_times_a @ Y @ Z ) )
        = ( ord_less_eq_a @ X @ Y ) ) ) )).

% mult_le_cancel_iff1
thf(fact_300_mult__le__cancel__iff2,axiom,(
    ! [Z: a,X: a,Y: a] :
      ( ( ord_less_a @ zero_zero_a @ Z )
     => ( ( ord_less_eq_a @ ( times_times_a @ Z @ X ) @ ( times_times_a @ Z @ Y ) )
        = ( ord_less_eq_a @ X @ Y ) ) ) )).

% mult_le_cancel_iff2
thf(fact_301_p__less__length,axiom,(
    ord_less_nat @ p @ ( size_size_list_a @ xsa ) )).

% p_less_length
thf(fact_302_add__scale__eq__noteq,axiom,(
    ! [R: a,A: a,B: a,C: a,D: a] :
      ( ( R != zero_zero_a )
     => ( ( ( A = B )
          & ( C != D ) )
       => ( ( plus_plus_a @ A @ ( times_times_a @ R @ C ) )
         != ( plus_plus_a @ B @ ( times_times_a @ R @ D ) ) ) ) ) )).

% add_scale_eq_noteq
thf(fact_303_add__scale__eq__noteq,axiom,(
    ! [R: nat,A: nat,B: nat,C: nat,D: nat] :
      ( ( R != zero_zero_nat )
     => ( ( ( A = B )
          & ( C != D ) )
       => ( ( plus_plus_nat @ A @ ( times_times_nat @ R @ C ) )
         != ( plus_plus_nat @ B @ ( times_times_nat @ R @ D ) ) ) ) ) )).

% add_scale_eq_noteq
thf(fact_304_elem__le__sum__list,axiom,(
    ! [K: nat,Ns: list_nat] :
      ( ( ord_less_nat @ K @ ( size_size_list_nat @ Ns ) )
     => ( ord_less_eq_nat @ ( nth_nat @ Ns @ K ) @ ( groups921905271st_nat @ Ns ) ) ) )).

% elem_le_sum_list
thf(fact_305_add__0__iff,axiom,(
    ! [B: nat,A: nat] :
      ( ( B
        = ( plus_plus_nat @ B @ A ) )
      = ( A = zero_zero_nat ) ) )).

% add_0_iff
thf(fact_306_nat__mult__le__cancel__disj,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% nat_mult_le_cancel_disj
thf(fact_307_mult__le__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% mult_le_cancel2
thf(fact_308_Nat_Oadd__0__right,axiom,(
    ! [M: nat] :
      ( ( plus_plus_nat @ M @ zero_zero_nat )
      = M ) )).

% Nat.add_0_right
thf(fact_309_add__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus_nat @ M @ N )
        = zero_zero_nat )
      = ( ( M = zero_zero_nat )
        & ( N = zero_zero_nat ) ) ) )).

% add_is_0
thf(fact_310_nat__add__left__cancel__less,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_nat @ M @ N ) ) )).

% nat_add_left_cancel_less
thf(fact_311_nat__add__left__cancel__le,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% nat_add_left_cancel_le
thf(fact_312_add__gr__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( plus_plus_nat @ M @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ M )
        | ( ord_less_nat @ zero_zero_nat @ N ) ) ) )).

% add_gr_0
thf(fact_313_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_314_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_315_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_316_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_317_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_318_mult__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( times_times_nat @ M @ K )
        = ( times_times_nat @ N @ K ) )
      = ( ( M = N )
        | ( K = zero_zero_nat ) ) ) )).

% mult_cancel2
thf(fact_319_mult__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times_nat @ K @ M )
        = ( times_times_nat @ K @ N ) )
      = ( ( M = N )
        | ( K = zero_zero_nat ) ) ) )).

% mult_cancel1
thf(fact_320_mult__0__right,axiom,(
    ! [M: nat] :
      ( ( times_times_nat @ M @ zero_zero_nat )
      = zero_zero_nat ) )).

% mult_0_right
thf(fact_321_mult__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times_nat @ M @ N )
        = zero_zero_nat )
      = ( ( M = zero_zero_nat )
        | ( N = zero_zero_nat ) ) ) )).

% mult_is_0
thf(fact_322_mult__less__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
        & ( ord_less_nat @ M @ N ) ) ) )).

% mult_less_cancel2
thf(fact_323_nat__0__less__mult__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ M @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ M )
        & ( ord_less_nat @ zero_zero_nat @ N ) ) ) )).

% nat_0_less_mult_iff
thf(fact_324_nat__mult__less__cancel__disj,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
        & ( ord_less_nat @ M @ N ) ) ) )).

% nat_mult_less_cancel_disj
thf(fact_325_add__leE,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq_nat @ M @ N )
         => ~ ( ord_less_eq_nat @ K @ N ) ) ) )).

% add_leE
thf(fact_326_le__add1,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ N @ ( plus_plus_nat @ N @ M ) ) )).

% le_add1
thf(fact_327_le__add2,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ N @ ( plus_plus_nat @ M @ N ) ) )).

% le_add2
thf(fact_328_le__cube,axiom,(
    ! [M: nat] :
      ( ord_less_eq_nat @ M @ ( times_times_nat @ M @ ( times_times_nat @ M @ M ) ) ) )).

% le_cube
thf(fact_329_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_330_add__leD1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% add_leD1
thf(fact_331_add__leD2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ( ord_less_eq_nat @ K @ N ) ) )).

% add_leD2
thf(fact_332_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_333_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_334_le__Suc__ex,axiom,(
    ! [K: nat,L: nat] :
      ( ( ord_less_eq_nat @ K @ L )
     => ? [N2: nat] :
          ( L
          = ( plus_plus_nat @ K @ N2 ) ) ) )).

% le_Suc_ex
thf(fact_335_le__square,axiom,(
    ! [M: nat] :
      ( ord_less_eq_nat @ M @ ( times_times_nat @ M @ M ) ) )).

% le_square
thf(fact_336_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_337_add__le__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) ) )).

% add_le_mono
thf(fact_338_add__le__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ K ) ) ) )).

% add_le_mono1
thf(fact_339_mult__le__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( times_times_nat @ I @ K ) @ ( times_times_nat @ J @ L ) ) ) ) )).

% mult_le_mono
thf(fact_340_mult__le__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ I @ K ) @ ( times_times_nat @ J @ K ) ) ) )).

% mult_le_mono1
thf(fact_341_mult__le__mono2,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ K @ I ) @ ( times_times_nat @ K @ J ) ) ) )).

% mult_le_mono2
thf(fact_342_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_343_trans__le__add1,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ I @ ( plus_plus_nat @ J @ M ) ) ) )).

% trans_le_add1
thf(fact_344_trans__le__add2,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ I @ ( plus_plus_nat @ M @ J ) ) ) )).

% trans_le_add2
thf(fact_345_nat__le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [M2: nat,N3: nat] :
        ? [K2: nat] :
          ( N3
          = ( plus_plus_nat @ M2 @ K2 ) ) ) )).

% nat_le_iff_add
thf(fact_346_Nat_Oex__has__greatest__nat,axiom,(
    ! [P: nat > $o,K: nat,B: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq_nat @ Y2 @ B ) )
       => ? [X2: nat] :
            ( ( P @ X2 )
            & ! [Y3: nat] :
                ( ( P @ Y3 )
               => ( ord_less_eq_nat @ Y3 @ X2 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_347_left__add__mult__distrib,axiom,(
    ! [I: nat,U: nat,J: nat,K: nat] :
      ( ( plus_plus_nat @ ( times_times_nat @ I @ U ) @ ( plus_plus_nat @ ( times_times_nat @ J @ U ) @ K ) )
      = ( plus_plus_nat @ ( times_times_nat @ ( plus_plus_nat @ I @ J ) @ U ) @ K ) ) )).

% left_add_mult_distrib
thf(fact_348_add__mult__distrib2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times_nat @ K @ ( plus_plus_nat @ M @ N ) )
      = ( plus_plus_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) ) ) )).

% add_mult_distrib2
thf(fact_349_add__mult__distrib,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times_nat @ ( plus_plus_nat @ M @ N ) @ K )
      = ( plus_plus_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) ) ) )).

% add_mult_distrib
thf(fact_350_less__eq__nat_Osimps_I1_J,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% less_eq_nat.simps(1)
thf(fact_351_le__0__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_0_eq
thf(fact_352_bot__nat__0_Oextremum__unique,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
      = ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique

% Conjectures (1)
thf(conj_0,conjecture,(
    ord_less_a @ ( times_times_a @ ( plus_plus_a @ xa @ ya ) @ ( nth_a @ xsa @ p ) ) @ zero_zero_a )).

%------------------------------------------------------------------------------
