%------------------------------------------------------------------------------
% File     : SLH241^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Cartan problem prob_44__6531050_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Cartan/prob_44__6531050_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  380 (   0 unit;  33 type;   0 defn)
%            Number of atoms       : 3714 ( 229 equality;2440 variable)
%            Maximal formula depth :   14 (   8 average)
%            Number of connectives : 3030 ( 121   ~;  27   |;  35   &;2235   @)
%                                         (   0 <=>; 612  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  154 ( 154   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   35 (  33   :;   0   =)
%            Number of variables   : 1100 (   0 sgn;1006   !;  20   ?;  74   ^)
%                                         (1100   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:38:36.916
%------------------------------------------------------------------------------
% Could-be-implicit typings (5)
thf(ty_n_t__Set__Oset_It__Complex__Ocomplex_J,type,(
    set_complex: $tType )).

thf(ty_n_t__Set__Oset_It__Real__Oreal_J,type,(
    set_real: $tType )).

thf(ty_n_t__Complex__Ocomplex,type,(
    complex: $tType )).

thf(ty_n_t__Real__Oreal,type,(
    real: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (28)
thf(sy_c_Complex__Analysis__Basics_Oholomorphic__on,type,(
    comple372758642hic_on: ( complex > complex ) > set_complex > $o )).

thf(sy_c_Elementary__Metric__Spaces_Oball_001t__Complex__Ocomplex,type,(
    elemen1708546467omplex: complex > real > set_complex )).

thf(sy_c_Elementary__Metric__Spaces_Oball_001t__Real__Oreal,type,(
    elemen341675809l_real: real > real > set_real )).

thf(sy_c_Elementary__Metric__Spaces_Ocball_001t__Complex__Ocomplex,type,(
    elemen59756956omplex: complex > real > set_complex )).

thf(sy_c_Elementary__Metric__Spaces_Ocball_001t__Real__Oreal,type,(
    elemen1140313242l_real: real > real > set_real )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Real__Oreal,type,(
    zero_zero_real: real )).

thf(sy_c_Orderings_Obot__class_Obot_001_062_It__Complex__Ocomplex_M_Eo_J,type,(
    bot_bot_complex_o: complex > $o )).

thf(sy_c_Orderings_Obot__class_Obot_001t__Nat__Onat,type,(
    bot_bot_nat: nat )).

thf(sy_c_Orderings_Obot__class_Obot_001t__Set__Oset_It__Complex__Ocomplex_J,type,(
    bot_bot_set_complex: set_complex )).

thf(sy_c_Orderings_Obot__class_Obot_001t__Set__Oset_It__Real__Oreal_J,type,(
    bot_bot_set_real: set_real )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Real__Oreal,type,(
    ord_less_real: real > real > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Set__Oset_It__Complex__Ocomplex_J,type,(
    ord_less_set_complex: set_complex > set_complex > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Real__Oreal,type,(
    ord_less_eq_real: real > real > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Set__Oset_It__Complex__Ocomplex_J,type,(
    ord_le701908932omplex: set_complex > set_complex > $o )).

thf(sy_c_Set_OCollect_001t__Complex__Ocomplex,type,(
    collect_complex: ( complex > $o ) > set_complex )).

thf(sy_c_Set_OCollect_001t__Real__Oreal,type,(
    collect_real: ( real > $o ) > set_real )).

thf(sy_c_Topological__Spaces_Ocontinuous__on_001t__Complex__Ocomplex_001t__Complex__Ocomplex,type,(
    topolo722937564omplex: set_complex > ( complex > complex ) > $o )).

thf(sy_c_member_001t__Complex__Ocomplex,type,(
    member_complex: complex > set_complex > $o )).

thf(sy_c_member_001t__Real__Oreal,type,(
    member_real: real > set_real > $o )).

thf(sy_v_B0,type,(
    b0: real )).

thf(sy_v_f,type,(
    f: complex > complex )).

thf(sy_v_n,type,(
    n: nat )).

thf(sy_v_r,type,(
    r: real )).

thf(sy_v_y,type,(
    y: complex )).

thf(sy_v_z,type,(
    z: complex )).

% Relevant facts (346)
thf(fact_0_assms_I3_J,axiom,(
    ord_less_real @ zero_zero_real @ r )).

% assms(3)
thf(fact_1__092_060open_062z_A_092_060in_062_Aball_Az_Ar_A_092_060Longrightarrow_062_Af_Az_A_092_060in_062_Aball_Ay_AB0_092_060close_062,axiom,
    ( ( member_complex @ z @ ( elemen1708546467omplex @ z @ r ) )
   => ( member_complex @ ( f @ z ) @ ( elemen1708546467omplex @ y @ b0 ) ) )).

% \<open>z \<in> ball z r \<Longrightarrow> f z \<in> ball y B0\<close>
thf(fact_2_fin,axiom,(
    ! [W: complex] :
      ( ( member_complex @ W @ ( elemen1708546467omplex @ z @ r ) )
     => ( member_complex @ ( f @ W ) @ ( elemen1708546467omplex @ y @ b0 ) ) ) )).

% fin
thf(fact_3_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_4_bgauge__existence__lemma,axiom,(
    ! [S: set_complex,Q: real > complex > $o] :
      ( ( ! [X: complex] :
            ( ( member_complex @ X @ S )
           => ? [D: real] :
                ( ( ord_less_real @ zero_zero_real @ D )
                & ( Q @ D @ X ) ) ) )
      = ( ! [X: complex] :
          ? [D: real] :
            ( ( ord_less_real @ zero_zero_real @ D )
            & ( ( member_complex @ X @ S )
             => ( Q @ D @ X ) ) ) ) ) )).

% bgauge_existence_lemma
thf(fact_5_bgauge__existence__lemma,axiom,(
    ! [S: set_real,Q: real > real > $o] :
      ( ( ! [X: real] :
            ( ( member_real @ X @ S )
           => ? [D: real] :
                ( ( ord_less_real @ zero_zero_real @ D )
                & ( Q @ D @ X ) ) ) )
      = ( ! [X: real] :
          ? [D: real] :
            ( ( ord_less_real @ zero_zero_real @ D )
            & ( ( member_real @ X @ S )
             => ( Q @ D @ X ) ) ) ) ) )).

% bgauge_existence_lemma
thf(fact_6_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_real @ zero_zero_real @ zero_zero_real ) )).

% less_numeral_extra(3)
thf(fact_7_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_nat @ zero_zero_nat @ zero_zero_nat ) )).

% less_numeral_extra(3)
thf(fact_8_field__lbound__gt__zero,axiom,(
    ! [D1: real,D2: real] :
      ( ( ord_less_real @ zero_zero_real @ D1 )
     => ( ( ord_less_real @ zero_zero_real @ D2 )
       => ? [E: real] :
            ( ( ord_less_real @ zero_zero_real @ E )
            & ( ord_less_real @ E @ D1 )
            & ( ord_less_real @ E @ D2 ) ) ) ) )).

% field_lbound_gt_zero
thf(fact_9_gr__zeroI,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_zeroI
thf(fact_10_not__less__zero,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less_zero
thf(fact_11_gr__implies__not__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not_zero
thf(fact_12_zero__less__iff__neq__zero,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( N != zero_zero_nat ) ) )).

% zero_less_iff_neq_zero
thf(fact_13_centre__in__ball,axiom,(
    ! [X2: real,E2: real] :
      ( ( member_real @ X2 @ ( elemen341675809l_real @ X2 @ E2 ) )
      = ( ord_less_real @ zero_zero_real @ E2 ) ) )).

% centre_in_ball
thf(fact_14_centre__in__ball,axiom,(
    ! [X2: complex,E2: real] :
      ( ( member_complex @ X2 @ ( elemen1708546467omplex @ X2 @ E2 ) )
      = ( ord_less_real @ zero_zero_real @ E2 ) ) )).

% centre_in_ball
thf(fact_15_holf,axiom,(
    comple372758642hic_on @ f @ ( elemen1708546467omplex @ z @ r ) )).

% holf
thf(fact_16_zero__reorient,axiom,(
    ! [X2: real] :
      ( ( zero_zero_real = X2 )
      = ( X2 = zero_zero_real ) ) )).

% zero_reorient
thf(fact_17_zero__reorient,axiom,(
    ! [X2: nat] :
      ( ( zero_zero_nat = X2 )
      = ( X2 = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_18_contf,axiom,(
    topolo722937564omplex @ ( elemen59756956omplex @ z @ r ) @ f )).

% contf
thf(fact_19_ex__gt__or__lt,axiom,(
    ! [A: real] :
    ? [B: real] :
      ( ( ord_less_real @ A @ B )
      | ( ord_less_real @ B @ A ) ) )).

% ex_gt_or_lt
thf(fact_20_linorder__neqE__linordered__idom,axiom,(
    ! [X2: real,Y: real] :
      ( ( X2 != Y )
     => ( ~ ( ord_less_real @ X2 @ Y )
       => ( ord_less_real @ Y @ X2 ) ) ) )).

% linorder_neqE_linordered_idom
thf(fact_21_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B2: real,A: real] :
      ( ( ord_less_real @ B2 @ A )
     => ( A != B2 ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_22_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B2: nat,A: nat] :
      ( ( ord_less_nat @ B2 @ A )
     => ( A != B2 ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_23_linordered__field__no__ub,axiom,(
    ! [X3: real] :
    ? [X_1: real] :
      ( ord_less_real @ X3 @ X_1 ) )).

% linordered_field_no_ub
thf(fact_24_linordered__field__no__lb,axiom,(
    ! [X3: real] :
    ? [Y2: real] :
      ( ord_less_real @ Y2 @ X3 ) )).

% linordered_field_no_lb
thf(fact_25_order_Ostrict__implies__not__eq,axiom,(
    ! [A: real,B2: real] :
      ( ( ord_less_real @ A @ B2 )
     => ( A != B2 ) ) )).

% order.strict_implies_not_eq
thf(fact_26_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B2: nat] :
      ( ( ord_less_nat @ A @ B2 )
     => ( A != B2 ) ) )).

% order.strict_implies_not_eq
thf(fact_27_not__less__iff__gr__or__eq,axiom,(
    ! [X2: real,Y: real] :
      ( ( ~ ( ord_less_real @ X2 @ Y ) )
      = ( ( ord_less_real @ Y @ X2 )
        | ( X2 = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_28_not__less__iff__gr__or__eq,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X2 @ Y ) )
      = ( ( ord_less_nat @ Y @ X2 )
        | ( X2 = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_29_dual__order_Ostrict__trans,axiom,(
    ! [B2: real,A: real,C: real] :
      ( ( ord_less_real @ B2 @ A )
     => ( ( ord_less_real @ C @ B2 )
       => ( ord_less_real @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_30_dual__order_Ostrict__trans,axiom,(
    ! [B2: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B2 @ A )
     => ( ( ord_less_nat @ C @ B2 )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_31_linorder__less__wlog,axiom,(
    ! [P: real > real > $o,A: real,B2: real] :
      ( ! [A2: real,B: real] :
          ( ( ord_less_real @ A2 @ B )
         => ( P @ A2 @ B ) )
     => ( ! [A2: real] :
            ( P @ A2 @ A2 )
       => ( ! [A2: real,B: real] :
              ( ( P @ B @ A2 )
             => ( P @ A2 @ B ) )
         => ( P @ A @ B2 ) ) ) ) )).

% linorder_less_wlog
thf(fact_32_linorder__less__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B2: nat] :
      ( ! [A2: nat,B: nat] :
          ( ( ord_less_nat @ A2 @ B )
         => ( P @ A2 @ B ) )
     => ( ! [A2: nat] :
            ( P @ A2 @ A2 )
       => ( ! [A2: nat,B: nat] :
              ( ( P @ B @ A2 )
             => ( P @ A2 @ B ) )
         => ( P @ A @ B2 ) ) ) ) )).

% linorder_less_wlog
thf(fact_33_mem__ball__imp__mem__cball,axiom,(
    ! [X2: real,Y: real,E2: real] :
      ( ( member_real @ X2 @ ( elemen341675809l_real @ Y @ E2 ) )
     => ( member_real @ X2 @ ( elemen1140313242l_real @ Y @ E2 ) ) ) )).

% mem_ball_imp_mem_cball
thf(fact_34_mem__ball__imp__mem__cball,axiom,(
    ! [X2: complex,Y: complex,E2: real] :
      ( ( member_complex @ X2 @ ( elemen1708546467omplex @ Y @ E2 ) )
     => ( member_complex @ X2 @ ( elemen59756956omplex @ Y @ E2 ) ) ) )).

% mem_ball_imp_mem_cball
thf(fact_35_ord__eq__less__subst,axiom,(
    ! [A: real,F: real > real,B2: real,C: real] :
      ( ( A
        = ( F @ B2 ) )
     => ( ( ord_less_real @ B2 @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_36_ord__eq__less__subst,axiom,(
    ! [A: nat,F: real > nat,B2: real,C: real] :
      ( ( A
        = ( F @ B2 ) )
     => ( ( ord_less_real @ B2 @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_37_ord__eq__less__subst,axiom,(
    ! [A: real,F: nat > real,B2: nat,C: nat] :
      ( ( A
        = ( F @ B2 ) )
     => ( ( ord_less_nat @ B2 @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_38_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B2: nat,C: nat] :
      ( ( A
        = ( F @ B2 ) )
     => ( ( ord_less_nat @ B2 @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_39_ord__less__eq__subst,axiom,(
    ! [A: real,B2: real,F: real > real,C: real] :
      ( ( ord_less_real @ A @ B2 )
     => ( ( ( F @ B2 )
          = C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_40_ord__less__eq__subst,axiom,(
    ! [A: real,B2: real,F: real > nat,C: nat] :
      ( ( ord_less_real @ A @ B2 )
     => ( ( ( F @ B2 )
          = C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_41_ord__less__eq__subst,axiom,(
    ! [A: nat,B2: nat,F: nat > real,C: real] :
      ( ( ord_less_nat @ A @ B2 )
     => ( ( ( F @ B2 )
          = C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_42_ord__less__eq__subst,axiom,(
    ! [A: nat,B2: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B2 )
     => ( ( ( F @ B2 )
          = C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_43_order__less__subst1,axiom,(
    ! [A: real,F: real > real,B2: real,C: real] :
      ( ( ord_less_real @ A @ ( F @ B2 ) )
     => ( ( ord_less_real @ B2 @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_44_order__less__subst1,axiom,(
    ! [A: real,F: nat > real,B2: nat,C: nat] :
      ( ( ord_less_real @ A @ ( F @ B2 ) )
     => ( ( ord_less_nat @ B2 @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_45_order__less__subst1,axiom,(
    ! [A: nat,F: real > nat,B2: real,C: real] :
      ( ( ord_less_nat @ A @ ( F @ B2 ) )
     => ( ( ord_less_real @ B2 @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_46_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B2: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B2 ) )
     => ( ( ord_less_nat @ B2 @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_47_order__less__subst2,axiom,(
    ! [A: real,B2: real,F: real > real,C: real] :
      ( ( ord_less_real @ A @ B2 )
     => ( ( ord_less_real @ ( F @ B2 ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_48_order__less__subst2,axiom,(
    ! [A: real,B2: real,F: real > nat,C: nat] :
      ( ( ord_less_real @ A @ B2 )
     => ( ( ord_less_nat @ ( F @ B2 ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_49_order__less__subst2,axiom,(
    ! [A: nat,B2: nat,F: nat > real,C: real] :
      ( ( ord_less_nat @ A @ B2 )
     => ( ( ord_less_real @ ( F @ B2 ) @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_50_order__less__subst2,axiom,(
    ! [A: nat,B2: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B2 )
     => ( ( ord_less_nat @ ( F @ B2 ) @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_51_lt__ex,axiom,(
    ! [X2: real] :
    ? [Y2: real] :
      ( ord_less_real @ Y2 @ X2 ) )).

% lt_ex
thf(fact_52_gt__ex,axiom,(
    ! [X2: real] :
    ? [X_1: real] :
      ( ord_less_real @ X2 @ X_1 ) )).

% gt_ex
thf(fact_53_gt__ex,axiom,(
    ! [X2: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X2 @ X_1 ) )).

% gt_ex
thf(fact_54_neqE,axiom,(
    ! [X2: real,Y: real] :
      ( ( X2 != Y )
     => ( ~ ( ord_less_real @ X2 @ Y )
       => ( ord_less_real @ Y @ X2 ) ) ) )).

% neqE
thf(fact_55_neqE,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( X2 != Y )
     => ( ~ ( ord_less_nat @ X2 @ Y )
       => ( ord_less_nat @ Y @ X2 ) ) ) )).

% neqE
thf(fact_56_neq__iff,axiom,(
    ! [X2: real,Y: real] :
      ( ( X2 != Y )
      = ( ( ord_less_real @ X2 @ Y )
        | ( ord_less_real @ Y @ X2 ) ) ) )).

% neq_iff
thf(fact_57_neq__iff,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( X2 != Y )
      = ( ( ord_less_nat @ X2 @ Y )
        | ( ord_less_nat @ Y @ X2 ) ) ) )).

% neq_iff
thf(fact_58_order_Oasym,axiom,(
    ! [A: real,B2: real] :
      ( ( ord_less_real @ A @ B2 )
     => ~ ( ord_less_real @ B2 @ A ) ) )).

% order.asym
thf(fact_59_order_Oasym,axiom,(
    ! [A: nat,B2: nat] :
      ( ( ord_less_nat @ A @ B2 )
     => ~ ( ord_less_nat @ B2 @ A ) ) )).

% order.asym
thf(fact_60_dense,axiom,(
    ! [X2: real,Y: real] :
      ( ( ord_less_real @ X2 @ Y )
     => ? [Z: real] :
          ( ( ord_less_real @ X2 @ Z )
          & ( ord_less_real @ Z @ Y ) ) ) )).

% dense
thf(fact_61_less__imp__neq,axiom,(
    ! [X2: real,Y: real] :
      ( ( ord_less_real @ X2 @ Y )
     => ( X2 != Y ) ) )).

% less_imp_neq
thf(fact_62_less__imp__neq,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ord_less_nat @ X2 @ Y )
     => ( X2 != Y ) ) )).

% less_imp_neq
thf(fact_63_less__asym,axiom,(
    ! [X2: real,Y: real] :
      ( ( ord_less_real @ X2 @ Y )
     => ~ ( ord_less_real @ Y @ X2 ) ) )).

% less_asym
thf(fact_64_less__asym,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ord_less_nat @ X2 @ Y )
     => ~ ( ord_less_nat @ Y @ X2 ) ) )).

% less_asym
thf(fact_65_less__asym_H,axiom,(
    ! [A: real,B2: real] :
      ( ( ord_less_real @ A @ B2 )
     => ~ ( ord_less_real @ B2 @ A ) ) )).

% less_asym'
thf(fact_66_less__asym_H,axiom,(
    ! [A: nat,B2: nat] :
      ( ( ord_less_nat @ A @ B2 )
     => ~ ( ord_less_nat @ B2 @ A ) ) )).

% less_asym'
thf(fact_67_less__trans,axiom,(
    ! [X2: real,Y: real,Z2: real] :
      ( ( ord_less_real @ X2 @ Y )
     => ( ( ord_less_real @ Y @ Z2 )
       => ( ord_less_real @ X2 @ Z2 ) ) ) )).

% less_trans
thf(fact_68_less__trans,axiom,(
    ! [X2: nat,Y: nat,Z2: nat] :
      ( ( ord_less_nat @ X2 @ Y )
     => ( ( ord_less_nat @ Y @ Z2 )
       => ( ord_less_nat @ X2 @ Z2 ) ) ) )).

% less_trans
thf(fact_69_less__linear,axiom,(
    ! [X2: real,Y: real] :
      ( ( ord_less_real @ X2 @ Y )
      | ( X2 = Y )
      | ( ord_less_real @ Y @ X2 ) ) )).

% less_linear
thf(fact_70_less__linear,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ord_less_nat @ X2 @ Y )
      | ( X2 = Y )
      | ( ord_less_nat @ Y @ X2 ) ) )).

% less_linear
thf(fact_71_less__irrefl,axiom,(
    ! [X2: real] :
      ~ ( ord_less_real @ X2 @ X2 ) )).

% less_irrefl
thf(fact_72_less__irrefl,axiom,(
    ! [X2: nat] :
      ~ ( ord_less_nat @ X2 @ X2 ) )).

% less_irrefl
thf(fact_73_ord__eq__less__trans,axiom,(
    ! [A: real,B2: real,C: real] :
      ( ( A = B2 )
     => ( ( ord_less_real @ B2 @ C )
       => ( ord_less_real @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_74_ord__eq__less__trans,axiom,(
    ! [A: nat,B2: nat,C: nat] :
      ( ( A = B2 )
     => ( ( ord_less_nat @ B2 @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_75_mem__Collect__eq,axiom,(
    ! [A: complex,P: complex > $o] :
      ( ( member_complex @ A @ ( collect_complex @ P ) )
      = ( P @ A ) ) )).

% mem_Collect_eq
thf(fact_76_mem__Collect__eq,axiom,(
    ! [A: real,P: real > $o] :
      ( ( member_real @ A @ ( collect_real @ P ) )
      = ( P @ A ) ) )).

% mem_Collect_eq
thf(fact_77_Collect__mem__eq,axiom,(
    ! [A3: set_complex] :
      ( ( collect_complex
        @ ^ [X: complex] :
            ( member_complex @ X @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_78_Collect__mem__eq,axiom,(
    ! [A3: set_real] :
      ( ( collect_real
        @ ^ [X: real] :
            ( member_real @ X @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_79_ord__less__eq__trans,axiom,(
    ! [A: real,B2: real,C: real] :
      ( ( ord_less_real @ A @ B2 )
     => ( ( B2 = C )
       => ( ord_less_real @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_80_ord__less__eq__trans,axiom,(
    ! [A: nat,B2: nat,C: nat] :
      ( ( ord_less_nat @ A @ B2 )
     => ( ( B2 = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_81_dual__order_Oasym,axiom,(
    ! [B2: real,A: real] :
      ( ( ord_less_real @ B2 @ A )
     => ~ ( ord_less_real @ A @ B2 ) ) )).

% dual_order.asym
thf(fact_82_dual__order_Oasym,axiom,(
    ! [B2: nat,A: nat] :
      ( ( ord_less_nat @ B2 @ A )
     => ~ ( ord_less_nat @ A @ B2 ) ) )).

% dual_order.asym
thf(fact_83_less__imp__not__eq,axiom,(
    ! [X2: real,Y: real] :
      ( ( ord_less_real @ X2 @ Y )
     => ( X2 != Y ) ) )).

% less_imp_not_eq
thf(fact_84_less__imp__not__eq,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ord_less_nat @ X2 @ Y )
     => ( X2 != Y ) ) )).

% less_imp_not_eq
thf(fact_85_less__not__sym,axiom,(
    ! [X2: real,Y: real] :
      ( ( ord_less_real @ X2 @ Y )
     => ~ ( ord_less_real @ Y @ X2 ) ) )).

% less_not_sym
thf(fact_86_less__not__sym,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ord_less_nat @ X2 @ Y )
     => ~ ( ord_less_nat @ Y @ X2 ) ) )).

% less_not_sym
thf(fact_87_less__induct,axiom,(
    ! [P: nat > $o,A: nat] :
      ( ! [X4: nat] :
          ( ! [Y3: nat] :
              ( ( ord_less_nat @ Y3 @ X4 )
             => ( P @ Y3 ) )
         => ( P @ X4 ) )
     => ( P @ A ) ) )).

% less_induct
thf(fact_88_antisym__conv3,axiom,(
    ! [Y: real,X2: real] :
      ( ~ ( ord_less_real @ Y @ X2 )
     => ( ( ~ ( ord_less_real @ X2 @ Y ) )
        = ( X2 = Y ) ) ) )).

% antisym_conv3
thf(fact_89_antisym__conv3,axiom,(
    ! [Y: nat,X2: nat] :
      ( ~ ( ord_less_nat @ Y @ X2 )
     => ( ( ~ ( ord_less_nat @ X2 @ Y ) )
        = ( X2 = Y ) ) ) )).

% antisym_conv3
thf(fact_90_less__imp__not__eq2,axiom,(
    ! [X2: real,Y: real] :
      ( ( ord_less_real @ X2 @ Y )
     => ( Y != X2 ) ) )).

% less_imp_not_eq2
thf(fact_91_less__imp__not__eq2,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ord_less_nat @ X2 @ Y )
     => ( Y != X2 ) ) )).

% less_imp_not_eq2
thf(fact_92_less__imp__triv,axiom,(
    ! [X2: real,Y: real,P: $o] :
      ( ( ord_less_real @ X2 @ Y )
     => ( ( ord_less_real @ Y @ X2 )
       => P ) ) )).

% less_imp_triv
thf(fact_93_less__imp__triv,axiom,(
    ! [X2: nat,Y: nat,P: $o] :
      ( ( ord_less_nat @ X2 @ Y )
     => ( ( ord_less_nat @ Y @ X2 )
       => P ) ) )).

% less_imp_triv
thf(fact_94_linorder__cases,axiom,(
    ! [X2: real,Y: real] :
      ( ~ ( ord_less_real @ X2 @ Y )
     => ( ( X2 != Y )
       => ( ord_less_real @ Y @ X2 ) ) ) )).

% linorder_cases
thf(fact_95_linorder__cases,axiom,(
    ! [X2: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X2 @ Y )
     => ( ( X2 != Y )
       => ( ord_less_nat @ Y @ X2 ) ) ) )).

% linorder_cases
thf(fact_96_dual__order_Oirrefl,axiom,(
    ! [A: real] :
      ~ ( ord_less_real @ A @ A ) )).

% dual_order.irrefl
thf(fact_97_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_98_order_Ostrict__trans,axiom,(
    ! [A: real,B2: real,C: real] :
      ( ( ord_less_real @ A @ B2 )
     => ( ( ord_less_real @ B2 @ C )
       => ( ord_less_real @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_99_order_Ostrict__trans,axiom,(
    ! [A: nat,B2: nat,C: nat] :
      ( ( ord_less_nat @ A @ B2 )
     => ( ( ord_less_nat @ B2 @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_100_less__imp__not__less,axiom,(
    ! [X2: real,Y: real] :
      ( ( ord_less_real @ X2 @ Y )
     => ~ ( ord_less_real @ Y @ X2 ) ) )).

% less_imp_not_less
thf(fact_101_less__imp__not__less,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ord_less_nat @ X2 @ Y )
     => ~ ( ord_less_nat @ Y @ X2 ) ) )).

% less_imp_not_less
thf(fact_102_exists__least__iff,axiom,
    ( ( ^ [P2: nat > $o] :
        ? [X5: nat] :
          ( P2 @ X5 ) )
    = ( ^ [P3: nat > $o] :
        ? [N2: nat] :
          ( ( P3 @ N2 )
          & ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ~ ( P3 @ M2 ) ) ) ) )).

% exists_least_iff
thf(fact_103_holomorphic__on__balls__imp__entire_H,axiom,(
    ! [F: complex > complex,C: complex,B3: set_complex] :
      ( ! [R: real] :
          ( ( ord_less_real @ zero_zero_real @ R )
         => ( comple372758642hic_on @ F @ ( elemen1708546467omplex @ C @ R ) ) )
     => ( comple372758642hic_on @ F @ B3 ) ) )).

% holomorphic_on_balls_imp_entire'
thf(fact_104_cball__eq__cball__iff,axiom,(
    ! [X2: complex,D3: real,Y: complex,E2: real] :
      ( ( ( elemen59756956omplex @ X2 @ D3 )
        = ( elemen59756956omplex @ Y @ E2 ) )
      = ( ( ( ord_less_real @ D3 @ zero_zero_real )
          & ( ord_less_real @ E2 @ zero_zero_real ) )
        | ( ( X2 = Y )
          & ( D3 = E2 ) ) ) ) )).

% cball_eq_cball_iff
thf(fact_105_holomorphic__on__imp__continuous__on,axiom,(
    ! [F: complex > complex,S: set_complex] :
      ( ( comple372758642hic_on @ F @ S )
     => ( topolo722937564omplex @ S @ F ) ) )).

% holomorphic_on_imp_continuous_on
thf(fact_106_cball__empty,axiom,(
    ! [E2: real,X2: complex] :
      ( ( ord_less_real @ E2 @ zero_zero_real )
     => ( ( elemen59756956omplex @ X2 @ E2 )
        = bot_bot_set_complex ) ) )).

% cball_empty
thf(fact_107_cball__eq__empty,axiom,(
    ! [X2: complex,E2: real] :
      ( ( ( elemen59756956omplex @ X2 @ E2 )
        = bot_bot_set_complex )
      = ( ord_less_real @ E2 @ zero_zero_real ) ) )).

% cball_eq_empty
thf(fact_108_holomorphic__transform,axiom,(
    ! [F: complex > complex,S: set_complex,G: complex > complex] :
      ( ( comple372758642hic_on @ F @ S )
     => ( ! [X4: complex] :
            ( ( member_complex @ X4 @ S )
           => ( ( F @ X4 )
              = ( G @ X4 ) ) )
       => ( comple372758642hic_on @ G @ S ) ) ) )).

% holomorphic_transform
thf(fact_109_holomorphic__cong,axiom,(
    ! [S: set_complex,T: set_complex,F: complex > complex,G: complex > complex] :
      ( ( S = T )
     => ( ! [X4: complex] :
            ( ( member_complex @ X4 @ S )
           => ( ( F @ X4 )
              = ( G @ X4 ) ) )
       => ( ( comple372758642hic_on @ F @ S )
          = ( comple372758642hic_on @ G @ T ) ) ) ) )).

% holomorphic_cong
thf(fact_110_continuous__on__cong,axiom,(
    ! [S: set_complex,T: set_complex,F: complex > complex,G: complex > complex] :
      ( ( S = T )
     => ( ! [X4: complex] :
            ( ( member_complex @ X4 @ T )
           => ( ( F @ X4 )
              = ( G @ X4 ) ) )
       => ( ( topolo722937564omplex @ S @ F )
          = ( topolo722937564omplex @ T @ G ) ) ) ) )).

% continuous_on_cong
thf(fact_111_ball__trivial,axiom,(
    ! [X2: complex] :
      ( ( elemen1708546467omplex @ X2 @ zero_zero_real )
      = bot_bot_set_complex ) )).

% ball_trivial
thf(fact_112_continuous__on__empty,axiom,(
    ! [F: complex > complex] :
      ( topolo722937564omplex @ bot_bot_set_complex @ F ) )).

% continuous_on_empty
thf(fact_113_holomorphic__on__empty,axiom,(
    ! [F: complex > complex] :
      ( comple372758642hic_on @ F @ bot_bot_set_complex ) )).

% holomorphic_on_empty
thf(fact_114_bot_Onot__eq__extremum,axiom,(
    ! [A: set_complex] :
      ( ( A != bot_bot_set_complex )
      = ( ord_less_set_complex @ bot_bot_set_complex @ A ) ) )).

% bot.not_eq_extremum
thf(fact_115_bot_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != bot_bot_nat )
      = ( ord_less_nat @ bot_bot_nat @ A ) ) )).

% bot.not_eq_extremum
thf(fact_116_bot_Oextremum__strict,axiom,(
    ! [A: set_complex] :
      ~ ( ord_less_set_complex @ A @ bot_bot_set_complex ) )).

% bot.extremum_strict
thf(fact_117_bot_Oextremum__strict,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ bot_bot_nat ) )).

% bot.extremum_strict
thf(fact_118_empty__iff,axiom,(
    ! [C: real] :
      ~ ( member_real @ C @ bot_bot_set_real ) )).

% empty_iff
thf(fact_119_empty__iff,axiom,(
    ! [C: complex] :
      ~ ( member_complex @ C @ bot_bot_set_complex ) )).

% empty_iff
thf(fact_120_all__not__in__conv,axiom,(
    ! [A3: set_real] :
      ( ( ! [X: real] :
            ~ ( member_real @ X @ A3 ) )
      = ( A3 = bot_bot_set_real ) ) )).

% all_not_in_conv
thf(fact_121_all__not__in__conv,axiom,(
    ! [A3: set_complex] :
      ( ( ! [X: complex] :
            ~ ( member_complex @ X @ A3 ) )
      = ( A3 = bot_bot_set_complex ) ) )).

% all_not_in_conv
thf(fact_122_Collect__empty__eq,axiom,(
    ! [P: complex > $o] :
      ( ( ( collect_complex @ P )
        = bot_bot_set_complex )
      = ( ! [X: complex] :
            ~ ( P @ X ) ) ) )).

% Collect_empty_eq
thf(fact_123_empty__Collect__eq,axiom,(
    ! [P: complex > $o] :
      ( ( bot_bot_set_complex
        = ( collect_complex @ P ) )
      = ( ! [X: complex] :
            ~ ( P @ X ) ) ) )).

% empty_Collect_eq
thf(fact_124_cball__eq__ball__iff,axiom,(
    ! [X2: complex,D3: real,Y: complex,E2: real] :
      ( ( ( elemen59756956omplex @ X2 @ D3 )
        = ( elemen1708546467omplex @ Y @ E2 ) )
      = ( ( ord_less_real @ D3 @ zero_zero_real )
        & ( ord_less_eq_real @ E2 @ zero_zero_real ) ) ) )).

% cball_eq_ball_iff
thf(fact_125_ball__eq__cball__iff,axiom,(
    ! [X2: complex,D3: real,Y: complex,E2: real] :
      ( ( ( elemen1708546467omplex @ X2 @ D3 )
        = ( elemen59756956omplex @ Y @ E2 ) )
      = ( ( ord_less_eq_real @ D3 @ zero_zero_real )
        & ( ord_less_real @ E2 @ zero_zero_real ) ) ) )).

% ball_eq_cball_iff
thf(fact_126_ball__eq__empty,axiom,(
    ! [X2: complex,E2: real] :
      ( ( ( elemen1708546467omplex @ X2 @ E2 )
        = bot_bot_set_complex )
      = ( ord_less_eq_real @ E2 @ zero_zero_real ) ) )).

% ball_eq_empty
thf(fact_127_order__refl,axiom,(
    ! [X2: real] :
      ( ord_less_eq_real @ X2 @ X2 ) )).

% order_refl
thf(fact_128_order__refl,axiom,(
    ! [X2: set_complex] :
      ( ord_le701908932omplex @ X2 @ X2 ) )).

% order_refl
thf(fact_129_order__refl,axiom,(
    ! [X2: nat] :
      ( ord_less_eq_nat @ X2 @ X2 ) )).

% order_refl
thf(fact_130_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_131_centre__in__cball,axiom,(
    ! [X2: real,E2: real] :
      ( ( member_real @ X2 @ ( elemen1140313242l_real @ X2 @ E2 ) )
      = ( ord_less_eq_real @ zero_zero_real @ E2 ) ) )).

% centre_in_cball
thf(fact_132_centre__in__cball,axiom,(
    ! [X2: complex,E2: real] :
      ( ( member_complex @ X2 @ ( elemen59756956omplex @ X2 @ E2 ) )
      = ( ord_less_eq_real @ zero_zero_real @ E2 ) ) )).

% centre_in_cball
thf(fact_133_bot__set__def,axiom,
    ( bot_bot_set_complex
    = ( collect_complex @ bot_bot_complex_o ) )).

% bot_set_def
thf(fact_134_complete__real,axiom,(
    ! [S2: set_real] :
      ( ? [X3: real] :
          ( member_real @ X3 @ S2 )
     => ( ? [Z3: real] :
          ! [X4: real] :
            ( ( member_real @ X4 @ S2 )
           => ( ord_less_eq_real @ X4 @ Z3 ) )
       => ? [Y2: real] :
            ( ! [X3: real] :
                ( ( member_real @ X3 @ S2 )
               => ( ord_less_eq_real @ X3 @ Y2 ) )
            & ! [Z3: real] :
                ( ! [X4: real] :
                    ( ( member_real @ X4 @ S2 )
                   => ( ord_less_eq_real @ X4 @ Z3 ) )
               => ( ord_less_eq_real @ Y2 @ Z3 ) ) ) ) ) )).

% complete_real
thf(fact_135_order__subst1,axiom,(
    ! [A: real,F: real > real,B2: real,C: real] :
      ( ( ord_less_eq_real @ A @ ( F @ B2 ) )
     => ( ( ord_less_eq_real @ B2 @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_136_order__subst1,axiom,(
    ! [A: real,F: set_complex > real,B2: set_complex,C: set_complex] :
      ( ( ord_less_eq_real @ A @ ( F @ B2 ) )
     => ( ( ord_le701908932omplex @ B2 @ C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_137_order__subst1,axiom,(
    ! [A: real,F: nat > real,B2: nat,C: nat] :
      ( ( ord_less_eq_real @ A @ ( F @ B2 ) )
     => ( ( ord_less_eq_nat @ B2 @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_138_order__subst1,axiom,(
    ! [A: set_complex,F: real > set_complex,B2: real,C: real] :
      ( ( ord_le701908932omplex @ A @ ( F @ B2 ) )
     => ( ( ord_less_eq_real @ B2 @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_le701908932omplex @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_139_order__subst1,axiom,(
    ! [A: set_complex,F: set_complex > set_complex,B2: set_complex,C: set_complex] :
      ( ( ord_le701908932omplex @ A @ ( F @ B2 ) )
     => ( ( ord_le701908932omplex @ B2 @ C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_le701908932omplex @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_140_order__subst1,axiom,(
    ! [A: set_complex,F: nat > set_complex,B2: nat,C: nat] :
      ( ( ord_le701908932omplex @ A @ ( F @ B2 ) )
     => ( ( ord_less_eq_nat @ B2 @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_le701908932omplex @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_141_order__subst1,axiom,(
    ! [A: nat,F: real > nat,B2: real,C: real] :
      ( ( ord_less_eq_nat @ A @ ( F @ B2 ) )
     => ( ( ord_less_eq_real @ B2 @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_142_order__subst1,axiom,(
    ! [A: nat,F: set_complex > nat,B2: set_complex,C: set_complex] :
      ( ( ord_less_eq_nat @ A @ ( F @ B2 ) )
     => ( ( ord_le701908932omplex @ B2 @ C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_143_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B2: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B2 ) )
     => ( ( ord_less_eq_nat @ B2 @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_144_order__subst2,axiom,(
    ! [A: real,B2: real,F: real > real,C: real] :
      ( ( ord_less_eq_real @ A @ B2 )
     => ( ( ord_less_eq_real @ ( F @ B2 ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_145_order__subst2,axiom,(
    ! [A: real,B2: real,F: real > set_complex,C: set_complex] :
      ( ( ord_less_eq_real @ A @ B2 )
     => ( ( ord_le701908932omplex @ ( F @ B2 ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_le701908932omplex @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_146_order__subst2,axiom,(
    ! [A: real,B2: real,F: real > nat,C: nat] :
      ( ( ord_less_eq_real @ A @ B2 )
     => ( ( ord_less_eq_nat @ ( F @ B2 ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_147_order__subst2,axiom,(
    ! [A: set_complex,B2: set_complex,F: set_complex > real,C: real] :
      ( ( ord_le701908932omplex @ A @ B2 )
     => ( ( ord_less_eq_real @ ( F @ B2 ) @ C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_148_order__subst2,axiom,(
    ! [A: set_complex,B2: set_complex,F: set_complex > set_complex,C: set_complex] :
      ( ( ord_le701908932omplex @ A @ B2 )
     => ( ( ord_le701908932omplex @ ( F @ B2 ) @ C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_le701908932omplex @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_149_order__subst2,axiom,(
    ! [A: set_complex,B2: set_complex,F: set_complex > nat,C: nat] :
      ( ( ord_le701908932omplex @ A @ B2 )
     => ( ( ord_less_eq_nat @ ( F @ B2 ) @ C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_150_order__subst2,axiom,(
    ! [A: nat,B2: nat,F: nat > real,C: real] :
      ( ( ord_less_eq_nat @ A @ B2 )
     => ( ( ord_less_eq_real @ ( F @ B2 ) @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_151_order__subst2,axiom,(
    ! [A: nat,B2: nat,F: nat > set_complex,C: set_complex] :
      ( ( ord_less_eq_nat @ A @ B2 )
     => ( ( ord_le701908932omplex @ ( F @ B2 ) @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_le701908932omplex @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_152_order__subst2,axiom,(
    ! [A: nat,B2: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B2 )
     => ( ( ord_less_eq_nat @ ( F @ B2 ) @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_153_ord__eq__le__subst,axiom,(
    ! [A: real,F: real > real,B2: real,C: real] :
      ( ( A
        = ( F @ B2 ) )
     => ( ( ord_less_eq_real @ B2 @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_154_ord__eq__le__subst,axiom,(
    ! [A: set_complex,F: real > set_complex,B2: real,C: real] :
      ( ( A
        = ( F @ B2 ) )
     => ( ( ord_less_eq_real @ B2 @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_le701908932omplex @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_155_ord__eq__le__subst,axiom,(
    ! [A: nat,F: real > nat,B2: real,C: real] :
      ( ( A
        = ( F @ B2 ) )
     => ( ( ord_less_eq_real @ B2 @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_156_ord__eq__le__subst,axiom,(
    ! [A: real,F: set_complex > real,B2: set_complex,C: set_complex] :
      ( ( A
        = ( F @ B2 ) )
     => ( ( ord_le701908932omplex @ B2 @ C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_157_ord__eq__le__subst,axiom,(
    ! [A: set_complex,F: set_complex > set_complex,B2: set_complex,C: set_complex] :
      ( ( A
        = ( F @ B2 ) )
     => ( ( ord_le701908932omplex @ B2 @ C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_le701908932omplex @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_158_ord__eq__le__subst,axiom,(
    ! [A: nat,F: set_complex > nat,B2: set_complex,C: set_complex] :
      ( ( A
        = ( F @ B2 ) )
     => ( ( ord_le701908932omplex @ B2 @ C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_159_ord__eq__le__subst,axiom,(
    ! [A: real,F: nat > real,B2: nat,C: nat] :
      ( ( A
        = ( F @ B2 ) )
     => ( ( ord_less_eq_nat @ B2 @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_160_ord__eq__le__subst,axiom,(
    ! [A: set_complex,F: nat > set_complex,B2: nat,C: nat] :
      ( ( A
        = ( F @ B2 ) )
     => ( ( ord_less_eq_nat @ B2 @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_le701908932omplex @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_161_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B2: nat,C: nat] :
      ( ( A
        = ( F @ B2 ) )
     => ( ( ord_less_eq_nat @ B2 @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_162_ord__le__eq__subst,axiom,(
    ! [A: real,B2: real,F: real > real,C: real] :
      ( ( ord_less_eq_real @ A @ B2 )
     => ( ( ( F @ B2 )
          = C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_163_ord__le__eq__subst,axiom,(
    ! [A: real,B2: real,F: real > set_complex,C: set_complex] :
      ( ( ord_less_eq_real @ A @ B2 )
     => ( ( ( F @ B2 )
          = C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_le701908932omplex @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_164_ord__le__eq__subst,axiom,(
    ! [A: real,B2: real,F: real > nat,C: nat] :
      ( ( ord_less_eq_real @ A @ B2 )
     => ( ( ( F @ B2 )
          = C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_165_ord__le__eq__subst,axiom,(
    ! [A: set_complex,B2: set_complex,F: set_complex > real,C: real] :
      ( ( ord_le701908932omplex @ A @ B2 )
     => ( ( ( F @ B2 )
          = C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_166_ord__le__eq__subst,axiom,(
    ! [A: set_complex,B2: set_complex,F: set_complex > set_complex,C: set_complex] :
      ( ( ord_le701908932omplex @ A @ B2 )
     => ( ( ( F @ B2 )
          = C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_le701908932omplex @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_167_ord__le__eq__subst,axiom,(
    ! [A: set_complex,B2: set_complex,F: set_complex > nat,C: nat] :
      ( ( ord_le701908932omplex @ A @ B2 )
     => ( ( ( F @ B2 )
          = C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_168_ord__le__eq__subst,axiom,(
    ! [A: nat,B2: nat,F: nat > real,C: real] :
      ( ( ord_less_eq_nat @ A @ B2 )
     => ( ( ( F @ B2 )
          = C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_169_ord__le__eq__subst,axiom,(
    ! [A: nat,B2: nat,F: nat > set_complex,C: set_complex] :
      ( ( ord_less_eq_nat @ A @ B2 )
     => ( ( ( F @ B2 )
          = C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_le701908932omplex @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_170_ord__le__eq__subst,axiom,(
    ! [A: nat,B2: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B2 )
     => ( ( ( F @ B2 )
          = C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_171_eq__iff,axiom,
    ( ( ^ [Y4: real,Z4: real] : ( Y4 = Z4 ) )
    = ( ^ [X: real,Y5: real] :
          ( ( ord_less_eq_real @ X @ Y5 )
          & ( ord_less_eq_real @ Y5 @ X ) ) ) )).

% eq_iff
thf(fact_172_eq__iff,axiom,
    ( ( ^ [Y4: set_complex,Z4: set_complex] : ( Y4 = Z4 ) )
    = ( ^ [X: set_complex,Y5: set_complex] :
          ( ( ord_le701908932omplex @ X @ Y5 )
          & ( ord_le701908932omplex @ Y5 @ X ) ) ) )).

% eq_iff
thf(fact_173_eq__iff,axiom,
    ( ( ^ [Y4: nat,Z4: nat] : ( Y4 = Z4 ) )
    = ( ^ [X: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X @ Y5 )
          & ( ord_less_eq_nat @ Y5 @ X ) ) ) )).

% eq_iff
thf(fact_174_antisym,axiom,(
    ! [X2: real,Y: real] :
      ( ( ord_less_eq_real @ X2 @ Y )
     => ( ( ord_less_eq_real @ Y @ X2 )
       => ( X2 = Y ) ) ) )).

% antisym
thf(fact_175_antisym,axiom,(
    ! [X2: set_complex,Y: set_complex] :
      ( ( ord_le701908932omplex @ X2 @ Y )
     => ( ( ord_le701908932omplex @ Y @ X2 )
       => ( X2 = Y ) ) ) )).

% antisym
thf(fact_176_antisym,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X2 @ Y )
     => ( ( ord_less_eq_nat @ Y @ X2 )
       => ( X2 = Y ) ) ) )).

% antisym
thf(fact_177_linear,axiom,(
    ! [X2: real,Y: real] :
      ( ( ord_less_eq_real @ X2 @ Y )
      | ( ord_less_eq_real @ Y @ X2 ) ) )).

% linear
thf(fact_178_linear,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X2 @ Y )
      | ( ord_less_eq_nat @ Y @ X2 ) ) )).

% linear
thf(fact_179_eq__refl,axiom,(
    ! [X2: real,Y: real] :
      ( ( X2 = Y )
     => ( ord_less_eq_real @ X2 @ Y ) ) )).

% eq_refl
thf(fact_180_eq__refl,axiom,(
    ! [X2: set_complex,Y: set_complex] :
      ( ( X2 = Y )
     => ( ord_le701908932omplex @ X2 @ Y ) ) )).

% eq_refl
thf(fact_181_eq__refl,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( X2 = Y )
     => ( ord_less_eq_nat @ X2 @ Y ) ) )).

% eq_refl
thf(fact_182_le__cases,axiom,(
    ! [X2: real,Y: real] :
      ( ~ ( ord_less_eq_real @ X2 @ Y )
     => ( ord_less_eq_real @ Y @ X2 ) ) )).

% le_cases
thf(fact_183_le__cases,axiom,(
    ! [X2: nat,Y: nat] :
      ( ~ ( ord_less_eq_nat @ X2 @ Y )
     => ( ord_less_eq_nat @ Y @ X2 ) ) )).

% le_cases
thf(fact_184_order_Otrans,axiom,(
    ! [A: real,B2: real,C: real] :
      ( ( ord_less_eq_real @ A @ B2 )
     => ( ( ord_less_eq_real @ B2 @ C )
       => ( ord_less_eq_real @ A @ C ) ) ) )).

% order.trans
thf(fact_185_order_Otrans,axiom,(
    ! [A: set_complex,B2: set_complex,C: set_complex] :
      ( ( ord_le701908932omplex @ A @ B2 )
     => ( ( ord_le701908932omplex @ B2 @ C )
       => ( ord_le701908932omplex @ A @ C ) ) ) )).

% order.trans
thf(fact_186_order_Otrans,axiom,(
    ! [A: nat,B2: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B2 )
     => ( ( ord_less_eq_nat @ B2 @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_187_le__cases3,axiom,(
    ! [X2: real,Y: real,Z2: real] :
      ( ( ( ord_less_eq_real @ X2 @ Y )
       => ~ ( ord_less_eq_real @ Y @ Z2 ) )
     => ( ( ( ord_less_eq_real @ Y @ X2 )
         => ~ ( ord_less_eq_real @ X2 @ Z2 ) )
       => ( ( ( ord_less_eq_real @ X2 @ Z2 )
           => ~ ( ord_less_eq_real @ Z2 @ Y ) )
         => ( ( ( ord_less_eq_real @ Z2 @ Y )
             => ~ ( ord_less_eq_real @ Y @ X2 ) )
           => ( ( ( ord_less_eq_real @ Y @ Z2 )
               => ~ ( ord_less_eq_real @ Z2 @ X2 ) )
             => ~ ( ( ord_less_eq_real @ Z2 @ X2 )
                 => ~ ( ord_less_eq_real @ X2 @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_188_le__cases3,axiom,(
    ! [X2: nat,Y: nat,Z2: nat] :
      ( ( ( ord_less_eq_nat @ X2 @ Y )
       => ~ ( ord_less_eq_nat @ Y @ Z2 ) )
     => ( ( ( ord_less_eq_nat @ Y @ X2 )
         => ~ ( ord_less_eq_nat @ X2 @ Z2 ) )
       => ( ( ( ord_less_eq_nat @ X2 @ Z2 )
           => ~ ( ord_less_eq_nat @ Z2 @ Y ) )
         => ( ( ( ord_less_eq_nat @ Z2 @ Y )
             => ~ ( ord_less_eq_nat @ Y @ X2 ) )
           => ( ( ( ord_less_eq_nat @ Y @ Z2 )
               => ~ ( ord_less_eq_nat @ Z2 @ X2 ) )
             => ~ ( ( ord_less_eq_nat @ Z2 @ X2 )
                 => ~ ( ord_less_eq_nat @ X2 @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_189_antisym__conv,axiom,(
    ! [Y: real,X2: real] :
      ( ( ord_less_eq_real @ Y @ X2 )
     => ( ( ord_less_eq_real @ X2 @ Y )
        = ( X2 = Y ) ) ) )).

% antisym_conv
thf(fact_190_antisym__conv,axiom,(
    ! [Y: set_complex,X2: set_complex] :
      ( ( ord_le701908932omplex @ Y @ X2 )
     => ( ( ord_le701908932omplex @ X2 @ Y )
        = ( X2 = Y ) ) ) )).

% antisym_conv
thf(fact_191_antisym__conv,axiom,(
    ! [Y: nat,X2: nat] :
      ( ( ord_less_eq_nat @ Y @ X2 )
     => ( ( ord_less_eq_nat @ X2 @ Y )
        = ( X2 = Y ) ) ) )).

% antisym_conv
thf(fact_192_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: real,Z4: real] : ( Y4 = Z4 ) )
    = ( ^ [A4: real,B4: real] :
          ( ( ord_less_eq_real @ A4 @ B4 )
          & ( ord_less_eq_real @ B4 @ A4 ) ) ) )).

% order_class.order.eq_iff
thf(fact_193_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: set_complex,Z4: set_complex] : ( Y4 = Z4 ) )
    = ( ^ [A4: set_complex,B4: set_complex] :
          ( ( ord_le701908932omplex @ A4 @ B4 )
          & ( ord_le701908932omplex @ B4 @ A4 ) ) ) )).

% order_class.order.eq_iff
thf(fact_194_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: nat,Z4: nat] : ( Y4 = Z4 ) )
    = ( ^ [A4: nat,B4: nat] :
          ( ( ord_less_eq_nat @ A4 @ B4 )
          & ( ord_less_eq_nat @ B4 @ A4 ) ) ) )).

% order_class.order.eq_iff
thf(fact_195_ord__eq__le__trans,axiom,(
    ! [A: real,B2: real,C: real] :
      ( ( A = B2 )
     => ( ( ord_less_eq_real @ B2 @ C )
       => ( ord_less_eq_real @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_196_ord__eq__le__trans,axiom,(
    ! [A: set_complex,B2: set_complex,C: set_complex] :
      ( ( A = B2 )
     => ( ( ord_le701908932omplex @ B2 @ C )
       => ( ord_le701908932omplex @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_197_ord__eq__le__trans,axiom,(
    ! [A: nat,B2: nat,C: nat] :
      ( ( A = B2 )
     => ( ( ord_less_eq_nat @ B2 @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_198_ord__le__eq__trans,axiom,(
    ! [A: real,B2: real,C: real] :
      ( ( ord_less_eq_real @ A @ B2 )
     => ( ( B2 = C )
       => ( ord_less_eq_real @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_199_ord__le__eq__trans,axiom,(
    ! [A: set_complex,B2: set_complex,C: set_complex] :
      ( ( ord_le701908932omplex @ A @ B2 )
     => ( ( B2 = C )
       => ( ord_le701908932omplex @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_200_ord__le__eq__trans,axiom,(
    ! [A: nat,B2: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B2 )
     => ( ( B2 = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_201_order__class_Oorder_Oantisym,axiom,(
    ! [A: real,B2: real] :
      ( ( ord_less_eq_real @ A @ B2 )
     => ( ( ord_less_eq_real @ B2 @ A )
       => ( A = B2 ) ) ) )).

% order_class.order.antisym
thf(fact_202_order__class_Oorder_Oantisym,axiom,(
    ! [A: set_complex,B2: set_complex] :
      ( ( ord_le701908932omplex @ A @ B2 )
     => ( ( ord_le701908932omplex @ B2 @ A )
       => ( A = B2 ) ) ) )).

% order_class.order.antisym
thf(fact_203_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B2: nat] :
      ( ( ord_less_eq_nat @ A @ B2 )
     => ( ( ord_less_eq_nat @ B2 @ A )
       => ( A = B2 ) ) ) )).

% order_class.order.antisym
thf(fact_204_order__trans,axiom,(
    ! [X2: real,Y: real,Z2: real] :
      ( ( ord_less_eq_real @ X2 @ Y )
     => ( ( ord_less_eq_real @ Y @ Z2 )
       => ( ord_less_eq_real @ X2 @ Z2 ) ) ) )).

% order_trans
thf(fact_205_order__trans,axiom,(
    ! [X2: set_complex,Y: set_complex,Z2: set_complex] :
      ( ( ord_le701908932omplex @ X2 @ Y )
     => ( ( ord_le701908932omplex @ Y @ Z2 )
       => ( ord_le701908932omplex @ X2 @ Z2 ) ) ) )).

% order_trans
thf(fact_206_order__trans,axiom,(
    ! [X2: nat,Y: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X2 @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z2 )
       => ( ord_less_eq_nat @ X2 @ Z2 ) ) ) )).

% order_trans
thf(fact_207_dual__order_Orefl,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ A @ A ) )).

% dual_order.refl
thf(fact_208_dual__order_Orefl,axiom,(
    ! [A: set_complex] :
      ( ord_le701908932omplex @ A @ A ) )).

% dual_order.refl
thf(fact_209_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_210_linorder__wlog,axiom,(
    ! [P: real > real > $o,A: real,B2: real] :
      ( ! [A2: real,B: real] :
          ( ( ord_less_eq_real @ A2 @ B )
         => ( P @ A2 @ B ) )
     => ( ! [A2: real,B: real] :
            ( ( P @ B @ A2 )
           => ( P @ A2 @ B ) )
       => ( P @ A @ B2 ) ) ) )).

% linorder_wlog
thf(fact_211_linorder__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B2: nat] :
      ( ! [A2: nat,B: nat] :
          ( ( ord_less_eq_nat @ A2 @ B )
         => ( P @ A2 @ B ) )
     => ( ! [A2: nat,B: nat] :
            ( ( P @ B @ A2 )
           => ( P @ A2 @ B ) )
       => ( P @ A @ B2 ) ) ) )).

% linorder_wlog
thf(fact_212_dual__order_Otrans,axiom,(
    ! [B2: real,A: real,C: real] :
      ( ( ord_less_eq_real @ B2 @ A )
     => ( ( ord_less_eq_real @ C @ B2 )
       => ( ord_less_eq_real @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_213_dual__order_Otrans,axiom,(
    ! [B2: set_complex,A: set_complex,C: set_complex] :
      ( ( ord_le701908932omplex @ B2 @ A )
     => ( ( ord_le701908932omplex @ C @ B2 )
       => ( ord_le701908932omplex @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_214_dual__order_Otrans,axiom,(
    ! [B2: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B2 @ A )
     => ( ( ord_less_eq_nat @ C @ B2 )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_215_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: real,Z4: real] : ( Y4 = Z4 ) )
    = ( ^ [A4: real,B4: real] :
          ( ( ord_less_eq_real @ B4 @ A4 )
          & ( ord_less_eq_real @ A4 @ B4 ) ) ) )).

% dual_order.eq_iff
thf(fact_216_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: set_complex,Z4: set_complex] : ( Y4 = Z4 ) )
    = ( ^ [A4: set_complex,B4: set_complex] :
          ( ( ord_le701908932omplex @ B4 @ A4 )
          & ( ord_le701908932omplex @ A4 @ B4 ) ) ) )).

% dual_order.eq_iff
thf(fact_217_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: nat,Z4: nat] : ( Y4 = Z4 ) )
    = ( ^ [A4: nat,B4: nat] :
          ( ( ord_less_eq_nat @ B4 @ A4 )
          & ( ord_less_eq_nat @ A4 @ B4 ) ) ) )).

% dual_order.eq_iff
thf(fact_218_dual__order_Oantisym,axiom,(
    ! [B2: real,A: real] :
      ( ( ord_less_eq_real @ B2 @ A )
     => ( ( ord_less_eq_real @ A @ B2 )
       => ( A = B2 ) ) ) )).

% dual_order.antisym
thf(fact_219_dual__order_Oantisym,axiom,(
    ! [B2: set_complex,A: set_complex] :
      ( ( ord_le701908932omplex @ B2 @ A )
     => ( ( ord_le701908932omplex @ A @ B2 )
       => ( A = B2 ) ) ) )).

% dual_order.antisym
thf(fact_220_dual__order_Oantisym,axiom,(
    ! [B2: nat,A: nat] :
      ( ( ord_less_eq_nat @ B2 @ A )
     => ( ( ord_less_eq_nat @ A @ B2 )
       => ( A = B2 ) ) ) )).

% dual_order.antisym
thf(fact_221_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_real @ zero_zero_real @ zero_zero_real )).

% le_numeral_extra(3)
thf(fact_222_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ zero_zero_nat )).

% le_numeral_extra(3)
thf(fact_223_zero__le,axiom,(
    ! [X2: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X2 ) )).

% zero_le
thf(fact_224_leD,axiom,(
    ! [Y: real,X2: real] :
      ( ( ord_less_eq_real @ Y @ X2 )
     => ~ ( ord_less_real @ X2 @ Y ) ) )).

% leD
thf(fact_225_leD,axiom,(
    ! [Y: set_complex,X2: set_complex] :
      ( ( ord_le701908932omplex @ Y @ X2 )
     => ~ ( ord_less_set_complex @ X2 @ Y ) ) )).

% leD
thf(fact_226_leD,axiom,(
    ! [Y: nat,X2: nat] :
      ( ( ord_less_eq_nat @ Y @ X2 )
     => ~ ( ord_less_nat @ X2 @ Y ) ) )).

% leD
thf(fact_227_leI,axiom,(
    ! [X2: real,Y: real] :
      ( ~ ( ord_less_real @ X2 @ Y )
     => ( ord_less_eq_real @ Y @ X2 ) ) )).

% leI
thf(fact_228_leI,axiom,(
    ! [X2: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X2 @ Y )
     => ( ord_less_eq_nat @ Y @ X2 ) ) )).

% leI
thf(fact_229_le__less,axiom,
    ( ord_less_eq_real
    = ( ^ [X: real,Y5: real] :
          ( ( ord_less_real @ X @ Y5 )
          | ( X = Y5 ) ) ) )).

% le_less
thf(fact_230_le__less,axiom,
    ( ord_le701908932omplex
    = ( ^ [X: set_complex,Y5: set_complex] :
          ( ( ord_less_set_complex @ X @ Y5 )
          | ( X = Y5 ) ) ) )).

% le_less
thf(fact_231_le__less,axiom,
    ( ord_less_eq_nat
    = ( ^ [X: nat,Y5: nat] :
          ( ( ord_less_nat @ X @ Y5 )
          | ( X = Y5 ) ) ) )).

% le_less
thf(fact_232_less__le,axiom,
    ( ord_less_real
    = ( ^ [X: real,Y5: real] :
          ( ( ord_less_eq_real @ X @ Y5 )
          & ( X != Y5 ) ) ) )).

% less_le
thf(fact_233_less__le,axiom,
    ( ord_less_set_complex
    = ( ^ [X: set_complex,Y5: set_complex] :
          ( ( ord_le701908932omplex @ X @ Y5 )
          & ( X != Y5 ) ) ) )).

% less_le
thf(fact_234_less__le,axiom,
    ( ord_less_nat
    = ( ^ [X: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X @ Y5 )
          & ( X != Y5 ) ) ) )).

% less_le
thf(fact_235_order__le__less__subst1,axiom,(
    ! [A: real,F: real > real,B2: real,C: real] :
      ( ( ord_less_eq_real @ A @ ( F @ B2 ) )
     => ( ( ord_less_real @ B2 @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_236_order__le__less__subst1,axiom,(
    ! [A: real,F: nat > real,B2: nat,C: nat] :
      ( ( ord_less_eq_real @ A @ ( F @ B2 ) )
     => ( ( ord_less_nat @ B2 @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_237_order__le__less__subst1,axiom,(
    ! [A: set_complex,F: real > set_complex,B2: real,C: real] :
      ( ( ord_le701908932omplex @ A @ ( F @ B2 ) )
     => ( ( ord_less_real @ B2 @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_set_complex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_set_complex @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_238_order__le__less__subst1,axiom,(
    ! [A: set_complex,F: nat > set_complex,B2: nat,C: nat] :
      ( ( ord_le701908932omplex @ A @ ( F @ B2 ) )
     => ( ( ord_less_nat @ B2 @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_set_complex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_set_complex @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_239_order__le__less__subst1,axiom,(
    ! [A: nat,F: real > nat,B2: real,C: real] :
      ( ( ord_less_eq_nat @ A @ ( F @ B2 ) )
     => ( ( ord_less_real @ B2 @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_240_order__le__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B2: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B2 ) )
     => ( ( ord_less_nat @ B2 @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_241_order__le__less__subst2,axiom,(
    ! [A: real,B2: real,F: real > real,C: real] :
      ( ( ord_less_eq_real @ A @ B2 )
     => ( ( ord_less_real @ ( F @ B2 ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_242_order__le__less__subst2,axiom,(
    ! [A: real,B2: real,F: real > set_complex,C: set_complex] :
      ( ( ord_less_eq_real @ A @ B2 )
     => ( ( ord_less_set_complex @ ( F @ B2 ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_set_complex @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_243_order__le__less__subst2,axiom,(
    ! [A: real,B2: real,F: real > nat,C: nat] :
      ( ( ord_less_eq_real @ A @ B2 )
     => ( ( ord_less_nat @ ( F @ B2 ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_244_order__le__less__subst2,axiom,(
    ! [A: set_complex,B2: set_complex,F: set_complex > real,C: real] :
      ( ( ord_le701908932omplex @ A @ B2 )
     => ( ( ord_less_real @ ( F @ B2 ) @ C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_245_order__le__less__subst2,axiom,(
    ! [A: set_complex,B2: set_complex,F: set_complex > set_complex,C: set_complex] :
      ( ( ord_le701908932omplex @ A @ B2 )
     => ( ( ord_less_set_complex @ ( F @ B2 ) @ C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_set_complex @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_246_order__le__less__subst2,axiom,(
    ! [A: set_complex,B2: set_complex,F: set_complex > nat,C: nat] :
      ( ( ord_le701908932omplex @ A @ B2 )
     => ( ( ord_less_nat @ ( F @ B2 ) @ C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_247_order__le__less__subst2,axiom,(
    ! [A: nat,B2: nat,F: nat > real,C: real] :
      ( ( ord_less_eq_nat @ A @ B2 )
     => ( ( ord_less_real @ ( F @ B2 ) @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_248_order__le__less__subst2,axiom,(
    ! [A: nat,B2: nat,F: nat > set_complex,C: set_complex] :
      ( ( ord_less_eq_nat @ A @ B2 )
     => ( ( ord_less_set_complex @ ( F @ B2 ) @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_set_complex @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_249_order__le__less__subst2,axiom,(
    ! [A: nat,B2: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B2 )
     => ( ( ord_less_nat @ ( F @ B2 ) @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_250_order__less__le__subst1,axiom,(
    ! [A: real,F: real > real,B2: real,C: real] :
      ( ( ord_less_real @ A @ ( F @ B2 ) )
     => ( ( ord_less_eq_real @ B2 @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_251_order__less__le__subst1,axiom,(
    ! [A: set_complex,F: real > set_complex,B2: real,C: real] :
      ( ( ord_less_set_complex @ A @ ( F @ B2 ) )
     => ( ( ord_less_eq_real @ B2 @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_set_complex @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_252_order__less__le__subst1,axiom,(
    ! [A: nat,F: real > nat,B2: real,C: real] :
      ( ( ord_less_nat @ A @ ( F @ B2 ) )
     => ( ( ord_less_eq_real @ B2 @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_eq_real @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_253_order__less__le__subst1,axiom,(
    ! [A: real,F: set_complex > real,B2: set_complex,C: set_complex] :
      ( ( ord_less_real @ A @ ( F @ B2 ) )
     => ( ( ord_le701908932omplex @ B2 @ C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_254_order__less__le__subst1,axiom,(
    ! [A: set_complex,F: set_complex > set_complex,B2: set_complex,C: set_complex] :
      ( ( ord_less_set_complex @ A @ ( F @ B2 ) )
     => ( ( ord_le701908932omplex @ B2 @ C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_set_complex @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_255_order__less__le__subst1,axiom,(
    ! [A: nat,F: set_complex > nat,B2: set_complex,C: set_complex] :
      ( ( ord_less_nat @ A @ ( F @ B2 ) )
     => ( ( ord_le701908932omplex @ B2 @ C )
       => ( ! [X4: set_complex,Y2: set_complex] :
              ( ( ord_le701908932omplex @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_256_order__less__le__subst1,axiom,(
    ! [A: real,F: nat > real,B2: nat,C: nat] :
      ( ( ord_less_real @ A @ ( F @ B2 ) )
     => ( ( ord_less_eq_nat @ B2 @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_257_order__less__le__subst1,axiom,(
    ! [A: set_complex,F: nat > set_complex,B2: nat,C: nat] :
      ( ( ord_less_set_complex @ A @ ( F @ B2 ) )
     => ( ( ord_less_eq_nat @ B2 @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_le701908932omplex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_set_complex @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_258_order__less__le__subst1,axiom,(
    ! [A: nat,F: nat > nat,B2: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B2 ) )
     => ( ( ord_less_eq_nat @ B2 @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_259_order__less__le__subst2,axiom,(
    ! [A: real,B2: real,F: real > real,C: real] :
      ( ( ord_less_real @ A @ B2 )
     => ( ( ord_less_eq_real @ ( F @ B2 ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_260_order__less__le__subst2,axiom,(
    ! [A: nat,B2: nat,F: nat > real,C: real] :
      ( ( ord_less_nat @ A @ B2 )
     => ( ( ord_less_eq_real @ ( F @ B2 ) @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_real @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_real @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_261_order__less__le__subst2,axiom,(
    ! [A: real,B2: real,F: real > set_complex,C: set_complex] :
      ( ( ord_less_real @ A @ B2 )
     => ( ( ord_le701908932omplex @ ( F @ B2 ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_set_complex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_set_complex @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_262_order__less__le__subst2,axiom,(
    ! [A: nat,B2: nat,F: nat > set_complex,C: set_complex] :
      ( ( ord_less_nat @ A @ B2 )
     => ( ( ord_le701908932omplex @ ( F @ B2 ) @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_set_complex @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_set_complex @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_263_order__less__le__subst2,axiom,(
    ! [A: real,B2: real,F: real > nat,C: nat] :
      ( ( ord_less_real @ A @ B2 )
     => ( ( ord_less_eq_nat @ ( F @ B2 ) @ C )
       => ( ! [X4: real,Y2: real] :
              ( ( ord_less_real @ X4 @ Y2 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_264_order__less__le__subst2,axiom,(
    ! [A: nat,B2: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B2 )
     => ( ( ord_less_eq_nat @ ( F @ B2 ) @ C )
       => ( ! [X4: nat,Y2: nat] :
              ( ( ord_less_nat @ X4 @ Y2 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_265_not__le,axiom,(
    ! [X2: real,Y: real] :
      ( ( ~ ( ord_less_eq_real @ X2 @ Y ) )
      = ( ord_less_real @ Y @ X2 ) ) )).

% not_le
thf(fact_266_not__le,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ~ ( ord_less_eq_nat @ X2 @ Y ) )
      = ( ord_less_nat @ Y @ X2 ) ) )).

% not_le
thf(fact_267_not__less,axiom,(
    ! [X2: real,Y: real] :
      ( ( ~ ( ord_less_real @ X2 @ Y ) )
      = ( ord_less_eq_real @ Y @ X2 ) ) )).

% not_less
thf(fact_268_not__less,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X2 @ Y ) )
      = ( ord_less_eq_nat @ Y @ X2 ) ) )).

% not_less
thf(fact_269_le__neq__trans,axiom,(
    ! [A: real,B2: real] :
      ( ( ord_less_eq_real @ A @ B2 )
     => ( ( A != B2 )
       => ( ord_less_real @ A @ B2 ) ) ) )).

% le_neq_trans
thf(fact_270_le__neq__trans,axiom,(
    ! [A: set_complex,B2: set_complex] :
      ( ( ord_le701908932omplex @ A @ B2 )
     => ( ( A != B2 )
       => ( ord_less_set_complex @ A @ B2 ) ) ) )).

% le_neq_trans
thf(fact_271_le__neq__trans,axiom,(
    ! [A: nat,B2: nat] :
      ( ( ord_less_eq_nat @ A @ B2 )
     => ( ( A != B2 )
       => ( ord_less_nat @ A @ B2 ) ) ) )).

% le_neq_trans
thf(fact_272_antisym__conv1,axiom,(
    ! [X2: real,Y: real] :
      ( ~ ( ord_less_real @ X2 @ Y )
     => ( ( ord_less_eq_real @ X2 @ Y )
        = ( X2 = Y ) ) ) )).

% antisym_conv1
thf(fact_273_antisym__conv1,axiom,(
    ! [X2: set_complex,Y: set_complex] :
      ( ~ ( ord_less_set_complex @ X2 @ Y )
     => ( ( ord_le701908932omplex @ X2 @ Y )
        = ( X2 = Y ) ) ) )).

% antisym_conv1
thf(fact_274_antisym__conv1,axiom,(
    ! [X2: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X2 @ Y )
     => ( ( ord_less_eq_nat @ X2 @ Y )
        = ( X2 = Y ) ) ) )).

% antisym_conv1
thf(fact_275_antisym__conv2,axiom,(
    ! [X2: real,Y: real] :
      ( ( ord_less_eq_real @ X2 @ Y )
     => ( ( ~ ( ord_less_real @ X2 @ Y ) )
        = ( X2 = Y ) ) ) )).

% antisym_conv2
thf(fact_276_antisym__conv2,axiom,(
    ! [X2: set_complex,Y: set_complex] :
      ( ( ord_le701908932omplex @ X2 @ Y )
     => ( ( ~ ( ord_less_set_complex @ X2 @ Y ) )
        = ( X2 = Y ) ) ) )).

% antisym_conv2
thf(fact_277_antisym__conv2,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X2 @ Y )
     => ( ( ~ ( ord_less_nat @ X2 @ Y ) )
        = ( X2 = Y ) ) ) )).

% antisym_conv2
thf(fact_278_less__imp__le,axiom,(
    ! [X2: real,Y: real] :
      ( ( ord_less_real @ X2 @ Y )
     => ( ord_less_eq_real @ X2 @ Y ) ) )).

% less_imp_le
thf(fact_279_less__imp__le,axiom,(
    ! [X2: set_complex,Y: set_complex] :
      ( ( ord_less_set_complex @ X2 @ Y )
     => ( ord_le701908932omplex @ X2 @ Y ) ) )).

% less_imp_le
thf(fact_280_less__imp__le,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ord_less_nat @ X2 @ Y )
     => ( ord_less_eq_nat @ X2 @ Y ) ) )).

% less_imp_le
thf(fact_281_le__less__trans,axiom,(
    ! [X2: real,Y: real,Z2: real] :
      ( ( ord_less_eq_real @ X2 @ Y )
     => ( ( ord_less_real @ Y @ Z2 )
       => ( ord_less_real @ X2 @ Z2 ) ) ) )).

% le_less_trans
thf(fact_282_le__less__trans,axiom,(
    ! [X2: set_complex,Y: set_complex,Z2: set_complex] :
      ( ( ord_le701908932omplex @ X2 @ Y )
     => ( ( ord_less_set_complex @ Y @ Z2 )
       => ( ord_less_set_complex @ X2 @ Z2 ) ) ) )).

% le_less_trans
thf(fact_283_le__less__trans,axiom,(
    ! [X2: nat,Y: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X2 @ Y )
     => ( ( ord_less_nat @ Y @ Z2 )
       => ( ord_less_nat @ X2 @ Z2 ) ) ) )).

% le_less_trans
thf(fact_284_less__le__trans,axiom,(
    ! [X2: real,Y: real,Z2: real] :
      ( ( ord_less_real @ X2 @ Y )
     => ( ( ord_less_eq_real @ Y @ Z2 )
       => ( ord_less_real @ X2 @ Z2 ) ) ) )).

% less_le_trans
thf(fact_285_less__le__trans,axiom,(
    ! [X2: set_complex,Y: set_complex,Z2: set_complex] :
      ( ( ord_less_set_complex @ X2 @ Y )
     => ( ( ord_le701908932omplex @ Y @ Z2 )
       => ( ord_less_set_complex @ X2 @ Z2 ) ) ) )).

% less_le_trans
thf(fact_286_less__le__trans,axiom,(
    ! [X2: nat,Y: nat,Z2: nat] :
      ( ( ord_less_nat @ X2 @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z2 )
       => ( ord_less_nat @ X2 @ Z2 ) ) ) )).

% less_le_trans
thf(fact_287_dense__ge,axiom,(
    ! [Z2: real,Y: real] :
      ( ! [X4: real] :
          ( ( ord_less_real @ Z2 @ X4 )
         => ( ord_less_eq_real @ Y @ X4 ) )
     => ( ord_less_eq_real @ Y @ Z2 ) ) )).

% dense_ge
thf(fact_288_dense__le,axiom,(
    ! [Y: real,Z2: real] :
      ( ! [X4: real] :
          ( ( ord_less_real @ X4 @ Y )
         => ( ord_less_eq_real @ X4 @ Z2 ) )
     => ( ord_less_eq_real @ Y @ Z2 ) ) )).

% dense_le
thf(fact_289_le__less__linear,axiom,(
    ! [X2: real,Y: real] :
      ( ( ord_less_eq_real @ X2 @ Y )
      | ( ord_less_real @ Y @ X2 ) ) )).

% le_less_linear
thf(fact_290_le__less__linear,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X2 @ Y )
      | ( ord_less_nat @ Y @ X2 ) ) )).

% le_less_linear
thf(fact_291_le__imp__less__or__eq,axiom,(
    ! [X2: real,Y: real] :
      ( ( ord_less_eq_real @ X2 @ Y )
     => ( ( ord_less_real @ X2 @ Y )
        | ( X2 = Y ) ) ) )).

% le_imp_less_or_eq
thf(fact_292_le__imp__less__or__eq,axiom,(
    ! [X2: set_complex,Y: set_complex] :
      ( ( ord_le701908932omplex @ X2 @ Y )
     => ( ( ord_less_set_complex @ X2 @ Y )
        | ( X2 = Y ) ) ) )).

% le_imp_less_or_eq
thf(fact_293_le__imp__less__or__eq,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X2 @ Y )
     => ( ( ord_less_nat @ X2 @ Y )
        | ( X2 = Y ) ) ) )).

% le_imp_less_or_eq
thf(fact_294_less__le__not__le,axiom,
    ( ord_less_real
    = ( ^ [X: real,Y5: real] :
          ( ( ord_less_eq_real @ X @ Y5 )
          & ~ ( ord_less_eq_real @ Y5 @ X ) ) ) )).

% less_le_not_le
thf(fact_295_less__le__not__le,axiom,
    ( ord_less_set_complex
    = ( ^ [X: set_complex,Y5: set_complex] :
          ( ( ord_le701908932omplex @ X @ Y5 )
          & ~ ( ord_le701908932omplex @ Y5 @ X ) ) ) )).

% less_le_not_le
thf(fact_296_less__le__not__le,axiom,
    ( ord_less_nat
    = ( ^ [X: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X @ Y5 )
          & ~ ( ord_less_eq_nat @ Y5 @ X ) ) ) )).

% less_le_not_le
thf(fact_297_not__le__imp__less,axiom,(
    ! [Y: real,X2: real] :
      ( ~ ( ord_less_eq_real @ Y @ X2 )
     => ( ord_less_real @ X2 @ Y ) ) )).

% not_le_imp_less
thf(fact_298_not__le__imp__less,axiom,(
    ! [Y: nat,X2: nat] :
      ( ~ ( ord_less_eq_nat @ Y @ X2 )
     => ( ord_less_nat @ X2 @ Y ) ) )).

% not_le_imp_less
thf(fact_299_order_Ostrict__trans1,axiom,(
    ! [A: real,B2: real,C: real] :
      ( ( ord_less_eq_real @ A @ B2 )
     => ( ( ord_less_real @ B2 @ C )
       => ( ord_less_real @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_300_order_Ostrict__trans1,axiom,(
    ! [A: set_complex,B2: set_complex,C: set_complex] :
      ( ( ord_le701908932omplex @ A @ B2 )
     => ( ( ord_less_set_complex @ B2 @ C )
       => ( ord_less_set_complex @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_301_order_Ostrict__trans1,axiom,(
    ! [A: nat,B2: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B2 )
     => ( ( ord_less_nat @ B2 @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_302_order_Ostrict__trans2,axiom,(
    ! [A: real,B2: real,C: real] :
      ( ( ord_less_real @ A @ B2 )
     => ( ( ord_less_eq_real @ B2 @ C )
       => ( ord_less_real @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_303_order_Ostrict__trans2,axiom,(
    ! [A: set_complex,B2: set_complex,C: set_complex] :
      ( ( ord_less_set_complex @ A @ B2 )
     => ( ( ord_le701908932omplex @ B2 @ C )
       => ( ord_less_set_complex @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_304_order_Ostrict__trans2,axiom,(
    ! [A: nat,B2: nat,C: nat] :
      ( ( ord_less_nat @ A @ B2 )
     => ( ( ord_less_eq_nat @ B2 @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_305_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_real
    = ( ^ [A4: real,B4: real] :
          ( ( ord_less_real @ A4 @ B4 )
          | ( A4 = B4 ) ) ) )).

% order.order_iff_strict
thf(fact_306_order_Oorder__iff__strict,axiom,
    ( ord_le701908932omplex
    = ( ^ [A4: set_complex,B4: set_complex] :
          ( ( ord_less_set_complex @ A4 @ B4 )
          | ( A4 = B4 ) ) ) )).

% order.order_iff_strict
thf(fact_307_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [A4: nat,B4: nat] :
          ( ( ord_less_nat @ A4 @ B4 )
          | ( A4 = B4 ) ) ) )).

% order.order_iff_strict
thf(fact_308_order_Ostrict__iff__order,axiom,
    ( ord_less_real
    = ( ^ [A4: real,B4: real] :
          ( ( ord_less_eq_real @ A4 @ B4 )
          & ( A4 != B4 ) ) ) )).

% order.strict_iff_order
thf(fact_309_order_Ostrict__iff__order,axiom,
    ( ord_less_set_complex
    = ( ^ [A4: set_complex,B4: set_complex] :
          ( ( ord_le701908932omplex @ A4 @ B4 )
          & ( A4 != B4 ) ) ) )).

% order.strict_iff_order
thf(fact_310_order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [A4: nat,B4: nat] :
          ( ( ord_less_eq_nat @ A4 @ B4 )
          & ( A4 != B4 ) ) ) )).

% order.strict_iff_order
thf(fact_311_dual__order_Ostrict__trans1,axiom,(
    ! [B2: real,A: real,C: real] :
      ( ( ord_less_eq_real @ B2 @ A )
     => ( ( ord_less_real @ C @ B2 )
       => ( ord_less_real @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_312_dual__order_Ostrict__trans1,axiom,(
    ! [B2: set_complex,A: set_complex,C: set_complex] :
      ( ( ord_le701908932omplex @ B2 @ A )
     => ( ( ord_less_set_complex @ C @ B2 )
       => ( ord_less_set_complex @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_313_dual__order_Ostrict__trans1,axiom,(
    ! [B2: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B2 @ A )
     => ( ( ord_less_nat @ C @ B2 )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_314_dual__order_Ostrict__trans2,axiom,(
    ! [B2: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B2 @ A )
     => ( ( ord_less_eq_nat @ C @ B2 )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_315_less__eq__real__def,axiom,
    ( ord_less_eq_real
    = ( ^ [X: real,Y5: real] :
          ( ( ord_less_real @ X @ Y5 )
          | ( X = Y5 ) ) ) )).

% less_eq_real_def
thf(fact_316_holomorphic__on__subset,axiom,(
    ! [F: complex > complex,S: set_complex,T: set_complex] :
      ( ( comple372758642hic_on @ F @ S )
     => ( ( ord_le701908932omplex @ T @ S )
       => ( comple372758642hic_on @ F @ T ) ) ) )).

% holomorphic_on_subset
thf(fact_317_seq__mono__lemma,axiom,(
    ! [M: nat,D3: nat > real,E2: nat > real] :
      ( ! [N3: nat] :
          ( ( ord_less_eq_nat @ M @ N3 )
         => ( ord_less_real @ ( D3 @ N3 ) @ ( E2 @ N3 ) ) )
     => ( ! [N3: nat] :
            ( ( ord_less_eq_nat @ M @ N3 )
           => ( ord_less_eq_real @ ( E2 @ N3 ) @ ( E2 @ M ) ) )
       => ! [N4: nat] :
            ( ( ord_less_eq_nat @ M @ N4 )
           => ( ord_less_real @ ( D3 @ N4 ) @ ( E2 @ M ) ) ) ) ) )).

% seq_mono_lemma
thf(fact_318_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_319_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_320_assms_I4_J,axiom,(
    ord_less_nat @ zero_zero_nat @ n )).

% assms(4)
thf(fact_321_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_322_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_323_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_324_bot__nat__0_Oextremum__strict,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ zero_zero_nat ) )).

% bot_nat_0.extremum_strict
thf(fact_325_infinite__descent0,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ zero_zero_nat )
     => ( ! [N3: nat] :
            ( ( ord_less_nat @ zero_zero_nat @ N3 )
           => ( ~ ( P @ N3 )
             => ? [M3: nat] :
                  ( ( ord_less_nat @ M3 @ N3 )
                  & ~ ( P @ M3 ) ) ) )
       => ( P @ N ) ) ) )).

% infinite_descent0
thf(fact_326_gr__implies__not0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not0
thf(fact_327_less__zeroE,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_zeroE
thf(fact_328_not__less0,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less0
thf(fact_329_not__gr0,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr0
thf(fact_330_gr0I,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr0I
thf(fact_331_bot__nat__def,axiom,(
    bot_bot_nat = zero_zero_nat )).

% bot_nat_def
thf(fact_332_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_333_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_334_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_335_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_336_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_337_Nat_Oex__has__greatest__nat,axiom,(
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq_nat @ Y2 @ B2 ) )
       => ? [X4: nat] :
            ( ( P @ X4 )
            & ! [Y3: nat] :
                ( ( P @ Y3 )
               => ( ord_less_eq_nat @ Y3 @ X4 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_338_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI
thf(fact_339_bot__nat__0_Oextremum__unique,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
      = ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique
thf(fact_340_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_nat @ I2 @ J2 )
         => ( ord_less_nat @ ( F @ I2 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I @ J )
       => ( ord_less_eq_nat @ ( F @ I ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_341_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_342_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_343_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M2: nat,N2: nat] :
          ( ( ord_less_nat @ M2 @ N2 )
          | ( M2 = N2 ) ) ) )).

% le_eq_less_or_eq
thf(fact_344_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_345_ex__least__nat__le,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ zero_zero_nat )
       => ? [K2: nat] :
            ( ( ord_less_eq_nat @ K2 @ N )
            & ! [I3: nat] :
                ( ( ord_less_nat @ I3 @ K2 )
               => ~ ( P @ I3 ) )
            & ( P @ K2 ) ) ) ) )).

% ex_least_nat_le

% Conjectures (1)
thf(conj_0,conjecture,(
    ord_less_real @ zero_zero_real @ b0 )).

%------------------------------------------------------------------------------
