%------------------------------------------------------------------------------
% File     : SLH323^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Polynomial_Expression problem prob_347__8347926_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Polynomial_Expression/prob_347__8347926_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  258 (   0 unit;  20 type;   0 defn)
%            Number of atoms       : 2130 ( 187 equality;1262 variable)
%            Maximal formula depth :   18 (   7 average)
%            Number of connectives : 1630 ( 112   ~;  27   |;  32   &;1189   @)
%                                         (   0 <=>; 270  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   74 (  74   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   24 (  20   :;   0   =)
%            Number of variables   :  595 (   0 sgn; 519   !;  43   ?;  33   ^)
%                                         ( 595   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:30:51.261
%------------------------------------------------------------------------------
% Could-be-implicit typings (2)
thf(ty_n_t__Polynomial____Expression____Mirabelle____dwjuveeage__Opoly_Itf__a_J,type,(
    polyno727731844poly_a: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (18)
thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_If_001t__Nat__Onat,type,(
    if_nat: $o > nat > nat > nat )).

thf(sy_c_Nat_OSuc,type,(
    suc: nat > nat )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Omin_001t__Nat__Onat,type,(
    ord_min_nat: nat > nat > nat )).

thf(sy_c_Polynomial__Expression__Mirabelle__dwjuveeage_Oisnpoly_001tf__a,type,(
    polyno190918219poly_a: polyno727731844poly_a > $o )).

thf(sy_c_Polynomial__Expression__Mirabelle__dwjuveeage_Oisnpolyh_001tf__a,type,(
    polyno1372495879olyh_a: polyno727731844poly_a > nat > $o )).

thf(sy_c_Polynomial__Expression__Mirabelle__dwjuveeage_Opoly_OCN_001tf__a,type,(
    polyno1057396216e_CN_a: polyno727731844poly_a > nat > polyno727731844poly_a > polyno727731844poly_a )).

thf(sy_c_Polynomial__Expression__Mirabelle__dwjuveeage_Opolyadd_001tf__a,type,(
    polyno2065957734yadd_a: polyno727731844poly_a > polyno727731844poly_a > polyno727731844poly_a )).

thf(sy_v_c_H____,type,(
    c: polyno727731844poly_a )).

thf(sy_v_c____,type,(
    c2: polyno727731844poly_a )).

thf(sy_v_n0a____,type,(
    n0a: nat )).

thf(sy_v_n1a____,type,(
    n1a: nat )).

thf(sy_v_n_H____,type,(
    n: nat )).

thf(sy_v_n____,type,(
    n2: nat )).

thf(sy_v_p_H____,type,(
    p: polyno727731844poly_a )).

thf(sy_v_pa____,type,(
    pa: polyno727731844poly_a )).

% Relevant facts (234)
thf(fact_0_lt,axiom,(
    ord_less_nat @ n2 @ n )).

% lt
thf(fact_1__092_060open_062_092_060And_062thesis_O_A_092_060lbrakk_062n_A_061_An_H_A_092_060Longrightarrow_062_Athesis_059_An_A_060_An_H_A_092_060Longrightarrow_062_Athesis_059_An_H_A_060_An_A_092_060Longrightarrow_062_Athesis_092_060rbrakk_062_A_092_060Longrightarrow_062_Athesis_092_060close_062,axiom,
    ( ( n2 != n )
   => ( ~ ( ord_less_nat @ n2 @ n )
     => ( ord_less_nat @ n @ n2 ) ) )).

% \<open>\<And>thesis. \<lbrakk>n = n' \<Longrightarrow> thesis; n < n' \<Longrightarrow> thesis; n' < n \<Longrightarrow> thesis\<rbrakk> \<Longrightarrow> thesis\<close>
thf(fact_2_min__Suc__Suc,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_min_nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( suc @ ( ord_min_nat @ M @ N ) ) ) )).

% min_Suc_Suc
thf(fact_3_min_Oidem,axiom,(
    ! [A: nat] :
      ( ( ord_min_nat @ A @ A )
      = A ) )).

% min.idem
thf(fact_4_min_Oleft__idem,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_min_nat @ A @ ( ord_min_nat @ A @ B ) )
      = ( ord_min_nat @ A @ B ) ) )).

% min.left_idem
thf(fact_5_min_Oright__idem,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_min_nat @ ( ord_min_nat @ A @ B ) @ B )
      = ( ord_min_nat @ A @ B ) ) )).

% min.right_idem
thf(fact_6_nat_Oinject,axiom,(
    ! [X2: nat,Y2: nat] :
      ( ( ( suc @ X2 )
        = ( suc @ Y2 ) )
      = ( X2 = Y2 ) ) )).

% nat.inject
thf(fact_7_old_Onat_Oinject,axiom,(
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) )).

% old.nat.inject
thf(fact_8_min_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_min_nat @ ( ord_min_nat @ A @ B ) @ C )
      = ( ord_min_nat @ A @ ( ord_min_nat @ B @ C ) ) ) )).

% min.assoc
thf(fact_9_min_Ocommute,axiom,
    ( ord_min_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ord_min_nat @ B2 @ A2 ) ) )).

% min.commute
thf(fact_10_min_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_min_nat @ B @ ( ord_min_nat @ A @ C ) )
      = ( ord_min_nat @ A @ ( ord_min_nat @ B @ C ) ) ) )).

% min.left_commute
thf(fact_11_Suc__inject,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ( suc @ X )
        = ( suc @ Y ) )
     => ( X = Y ) ) )).

% Suc_inject
thf(fact_12_n__not__Suc__n,axiom,(
    ! [N: nat] :
      ( N
     != ( suc @ N ) ) )).

% n_not_Suc_n
thf(fact_13_Suc__less__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( ord_less_nat @ M @ N ) ) )).

% Suc_less_eq
thf(fact_14_Suc__mono,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_nat @ ( suc @ M ) @ ( suc @ N ) ) ) )).

% Suc_mono
thf(fact_15_lessI,axiom,(
    ! [N: nat] :
      ( ord_less_nat @ N @ ( suc @ N ) ) )).

% lessI
thf(fact_16_min__less__iff__conj,axiom,(
    ! [Z: nat,X: nat,Y: nat] :
      ( ( ord_less_nat @ Z @ ( ord_min_nat @ X @ Y ) )
      = ( ( ord_less_nat @ Z @ X )
        & ( ord_less_nat @ Z @ Y ) ) ) )).

% min_less_iff_conj
thf(fact_17_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_18_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_19_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_20_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_21_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_22_nat__less__induct,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ( P @ M2 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) )).

% nat_less_induct
thf(fact_23_infinite__descent,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P @ N2 )
         => ? [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
              & ~ ( P @ M2 ) ) )
     => ( P @ N ) ) )).

% infinite_descent
thf(fact_24_linorder__neqE__nat,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_25_lift__Suc__mono__less__iff,axiom,(
    ! [F: nat > nat,N: nat,M: nat] :
      ( ! [N2: nat] :
          ( ord_less_nat @ ( F @ N2 ) @ ( F @ ( suc @ N2 ) ) )
     => ( ( ord_less_nat @ ( F @ N ) @ ( F @ M ) )
        = ( ord_less_nat @ N @ M ) ) ) )).

% lift_Suc_mono_less_iff
thf(fact_26_lift__Suc__mono__less,axiom,(
    ! [F: nat > nat,N: nat,N3: nat] :
      ( ! [N2: nat] :
          ( ord_less_nat @ ( F @ N2 ) @ ( F @ ( suc @ N2 ) ) )
     => ( ( ord_less_nat @ N @ N3 )
       => ( ord_less_nat @ ( F @ N ) @ ( F @ N3 ) ) ) ) )).

% lift_Suc_mono_less
thf(fact_27_not__less__less__Suc__eq,axiom,(
    ! [N: nat,M: nat] :
      ( ~ ( ord_less_nat @ N @ M )
     => ( ( ord_less_nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) )).

% not_less_less_Suc_eq
thf(fact_28_strict__inc__induct,axiom,(
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less_nat @ I @ J )
     => ( ! [I2: nat] :
            ( ( J
              = ( suc @ I2 ) )
           => ( P @ I2 ) )
       => ( ! [I2: nat] :
              ( ( ord_less_nat @ I2 @ J )
             => ( ( P @ ( suc @ I2 ) )
               => ( P @ I2 ) ) )
         => ( P @ I ) ) ) ) )).

% strict_inc_induct
thf(fact_29_less__Suc__induct,axiom,(
    ! [I: nat,J: nat,P: nat > nat > $o] :
      ( ( ord_less_nat @ I @ J )
     => ( ! [I2: nat] :
            ( P @ I2 @ ( suc @ I2 ) )
       => ( ! [I2: nat,J2: nat,K: nat] :
              ( ( ord_less_nat @ I2 @ J2 )
             => ( ( ord_less_nat @ J2 @ K )
               => ( ( P @ I2 @ J2 )
                 => ( ( P @ J2 @ K )
                   => ( P @ I2 @ K ) ) ) ) )
         => ( P @ I @ J ) ) ) ) )).

% less_Suc_induct
thf(fact_30_less__trans__Suc,axiom,(
    ! [I: nat,J: nat,K2: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ( ord_less_nat @ J @ K2 )
       => ( ord_less_nat @ ( suc @ I ) @ K2 ) ) ) )).

% less_trans_Suc
thf(fact_31_Suc__less__SucD,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ ( suc @ M ) @ ( suc @ N ) )
     => ( ord_less_nat @ M @ N ) ) )).

% Suc_less_SucD
thf(fact_32_less__antisym,axiom,(
    ! [N: nat,M: nat] :
      ( ~ ( ord_less_nat @ N @ M )
     => ( ( ord_less_nat @ N @ ( suc @ M ) )
       => ( M = N ) ) ) )).

% less_antisym
thf(fact_33_Suc__less__eq2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ ( suc @ N ) @ M )
      = ( ? [M3: nat] :
            ( ( M
              = ( suc @ M3 ) )
            & ( ord_less_nat @ N @ M3 ) ) ) ) )).

% Suc_less_eq2
thf(fact_34_All__less__Suc,axiom,(
    ! [N: nat,P: nat > $o] :
      ( ( ! [I3: nat] :
            ( ( ord_less_nat @ I3 @ ( suc @ N ) )
           => ( P @ I3 ) ) )
      = ( ( P @ N )
        & ! [I3: nat] :
            ( ( ord_less_nat @ I3 @ N )
           => ( P @ I3 ) ) ) ) )).

% All_less_Suc
thf(fact_35_not__less__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less_nat @ M @ N ) )
      = ( ord_less_nat @ N @ ( suc @ M ) ) ) )).

% not_less_eq
thf(fact_36_less__Suc__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ ( suc @ N ) )
      = ( ( ord_less_nat @ M @ N )
        | ( M = N ) ) ) )).

% less_Suc_eq
thf(fact_37_Ex__less__Suc,axiom,(
    ! [N: nat,P: nat > $o] :
      ( ( ? [I3: nat] :
            ( ( ord_less_nat @ I3 @ ( suc @ N ) )
            & ( P @ I3 ) ) )
      = ( ( P @ N )
        | ? [I3: nat] :
            ( ( ord_less_nat @ I3 @ N )
            & ( P @ I3 ) ) ) ) )).

% Ex_less_Suc
thf(fact_38_less__SucI,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_nat @ M @ ( suc @ N ) ) ) )).

% less_SucI
thf(fact_39_less__SucE,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less_nat @ M @ N )
       => ( M = N ) ) ) )).

% less_SucE
thf(fact_40_Suc__lessI,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ( ( suc @ M )
         != N )
       => ( ord_less_nat @ ( suc @ M ) @ N ) ) ) )).

% Suc_lessI
thf(fact_41_Suc__lessE,axiom,(
    ! [I: nat,K2: nat] :
      ( ( ord_less_nat @ ( suc @ I ) @ K2 )
     => ~ ! [J2: nat] :
            ( ( ord_less_nat @ I @ J2 )
           => ( K2
             != ( suc @ J2 ) ) ) ) )).

% Suc_lessE
thf(fact_42_Suc__lessD,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ ( suc @ M ) @ N )
     => ( ord_less_nat @ M @ N ) ) )).

% Suc_lessD
thf(fact_43_Nat_OlessE,axiom,(
    ! [I: nat,K2: nat] :
      ( ( ord_less_nat @ I @ K2 )
     => ( ( K2
         != ( suc @ I ) )
       => ~ ! [J2: nat] :
              ( ( ord_less_nat @ I @ J2 )
             => ( K2
               != ( suc @ J2 ) ) ) ) ) )).

% Nat.lessE
thf(fact_44_min_Ostrict__coboundedI2,axiom,(
    ! [B: nat,C: nat,A: nat] :
      ( ( ord_less_nat @ B @ C )
     => ( ord_less_nat @ ( ord_min_nat @ A @ B ) @ C ) ) )).

% min.strict_coboundedI2
thf(fact_45_min_Ostrict__coboundedI1,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_nat @ A @ C )
     => ( ord_less_nat @ ( ord_min_nat @ A @ B ) @ C ) ) )).

% min.strict_coboundedI1
thf(fact_46_min_Ostrict__order__iff,axiom,
    ( ord_less_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( A2
            = ( ord_min_nat @ A2 @ B2 ) )
          & ( A2 != B2 ) ) ) )).

% min.strict_order_iff
thf(fact_47_min_Ostrict__boundedE,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( ord_min_nat @ B @ C ) )
     => ~ ( ( ord_less_nat @ A @ B )
         => ~ ( ord_less_nat @ A @ C ) ) ) )).

% min.strict_boundedE
thf(fact_48_min__less__iff__disj,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_nat @ ( ord_min_nat @ X @ Y ) @ Z )
      = ( ( ord_less_nat @ X @ Z )
        | ( ord_less_nat @ Y @ Z ) ) ) )).

% min_less_iff_disj
thf(fact_49_minf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z2: nat] :
    ! [X3: nat] :
      ( ( ord_less_nat @ X3 @ Z2 )
     => ~ ( ord_less_nat @ T @ X3 ) ) )).

% minf(7)
thf(fact_50_minf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z2: nat] :
    ! [X3: nat] :
      ( ( ord_less_nat @ X3 @ Z2 )
     => ( ord_less_nat @ X3 @ T ) ) )).

% minf(5)
thf(fact_51_minf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z2: nat] :
    ! [X3: nat] :
      ( ( ord_less_nat @ X3 @ Z2 )
     => ( X3 != T ) ) )).

% minf(4)
thf(fact_52_minf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z2: nat] :
    ! [X3: nat] :
      ( ( ord_less_nat @ X3 @ Z2 )
     => ( X3 != T ) ) )).

% minf(3)
thf(fact_53_minf_I2_J,axiom,(
    ! [P: nat > $o,P2: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z3: nat] :
        ! [X4: nat] :
          ( ( ord_less_nat @ X4 @ Z3 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z3: nat] :
          ! [X4: nat] :
            ( ( ord_less_nat @ X4 @ Z3 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z2: nat] :
          ! [X3: nat] :
            ( ( ord_less_nat @ X3 @ Z2 )
           => ( ( ( P @ X3 )
                | ( Q @ X3 ) )
              = ( ( P2 @ X3 )
                | ( Q2 @ X3 ) ) ) ) ) ) )).

% minf(2)
thf(fact_54_minf_I1_J,axiom,(
    ! [P: nat > $o,P2: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z3: nat] :
        ! [X4: nat] :
          ( ( ord_less_nat @ X4 @ Z3 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z3: nat] :
          ! [X4: nat] :
            ( ( ord_less_nat @ X4 @ Z3 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z2: nat] :
          ! [X3: nat] :
            ( ( ord_less_nat @ X3 @ Z2 )
           => ( ( ( P @ X3 )
                & ( Q @ X3 ) )
              = ( ( P2 @ X3 )
                & ( Q2 @ X3 ) ) ) ) ) ) )).

% minf(1)
thf(fact_55_pinf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z2: nat] :
    ! [X3: nat] :
      ( ( ord_less_nat @ Z2 @ X3 )
     => ( ord_less_nat @ T @ X3 ) ) )).

% pinf(7)
thf(fact_56_pinf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z2: nat] :
    ! [X3: nat] :
      ( ( ord_less_nat @ Z2 @ X3 )
     => ~ ( ord_less_nat @ X3 @ T ) ) )).

% pinf(5)
thf(fact_57_pinf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z2: nat] :
    ! [X3: nat] :
      ( ( ord_less_nat @ Z2 @ X3 )
     => ( X3 != T ) ) )).

% pinf(4)
thf(fact_58_pinf_I1_J,axiom,(
    ! [P: nat > $o,P2: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z3: nat] :
        ! [X4: nat] :
          ( ( ord_less_nat @ Z3 @ X4 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z3: nat] :
          ! [X4: nat] :
            ( ( ord_less_nat @ Z3 @ X4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z2: nat] :
          ! [X3: nat] :
            ( ( ord_less_nat @ Z2 @ X3 )
           => ( ( ( P @ X3 )
                & ( Q @ X3 ) )
              = ( ( P2 @ X3 )
                & ( Q2 @ X3 ) ) ) ) ) ) )).

% pinf(1)
thf(fact_59_pinf_I2_J,axiom,(
    ! [P: nat > $o,P2: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z3: nat] :
        ! [X4: nat] :
          ( ( ord_less_nat @ Z3 @ X4 )
         => ( ( P @ X4 )
            = ( P2 @ X4 ) ) )
     => ( ? [Z3: nat] :
          ! [X4: nat] :
            ( ( ord_less_nat @ Z3 @ X4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z2: nat] :
          ! [X3: nat] :
            ( ( ord_less_nat @ Z2 @ X3 )
           => ( ( ( P @ X3 )
                | ( Q @ X3 ) )
              = ( ( P2 @ X3 )
                | ( Q2 @ X3 ) ) ) ) ) ) )).

% pinf(2)
thf(fact_60_pinf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z2: nat] :
    ! [X3: nat] :
      ( ( ord_less_nat @ Z2 @ X3 )
     => ( X3 != T ) ) )).

% pinf(3)
thf(fact_61_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_62_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_63_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X4: nat,Y3: nat] :
              ( ( ord_less_nat @ X4 @ Y3 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_64_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: nat,Y3: nat] :
              ( ( ord_less_nat @ X4 @ Y3 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_65_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X4: nat,Y3: nat] :
              ( ( ord_less_nat @ X4 @ Y3 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_66_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X4: nat,Y3: nat] :
              ( ( ord_less_nat @ X4 @ Y3 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_67_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_68_neqE,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% neqE
thf(fact_69_neq__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
      = ( ( ord_less_nat @ X @ Y )
        | ( ord_less_nat @ Y @ X ) ) ) )).

% neq_iff
thf(fact_70_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_71_less__imp__neq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_72_less__asym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_asym
thf(fact_73_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_74_less__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% less_trans
thf(fact_75_less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
      | ( X = Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% less_linear
thf(fact_76_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_77_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_78_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_79_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_80_less__imp__not__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_81_less__not__sym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_not_sym
thf(fact_82_less__induct,axiom,(
    ! [P: nat > $o,A: nat] :
      ( ! [X4: nat] :
          ( ! [Y4: nat] :
              ( ( ord_less_nat @ Y4 @ X4 )
             => ( P @ Y4 ) )
         => ( P @ X4 ) )
     => ( P @ A ) ) )).

% less_induct
thf(fact_83_antisym__conv3,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_84_less__imp__not__eq2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_85_less__imp__triv,axiom,(
    ! [X: nat,Y: nat,P: $o] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_86_linorder__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_87_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_88_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_89_less__imp__not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_imp_not_less
thf(fact_90_exists__least__iff,axiom,
    ( ( ^ [P3: nat > $o] :
        ? [X5: nat] :
          ( P3 @ X5 ) )
    = ( ^ [P4: nat > $o] :
        ? [N4: nat] :
          ( ( P4 @ N4 )
          & ! [M4: nat] :
              ( ( ord_less_nat @ M4 @ N4 )
             => ~ ( P4 @ M4 ) ) ) ) )).

% exists_least_iff
thf(fact_91_linorder__less__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( ord_less_nat @ A3 @ B3 )
         => ( P @ A3 @ B3 ) )
     => ( ! [A3: nat] :
            ( P @ A3 @ A3 )
       => ( ! [A3: nat,B3: nat] :
              ( ( P @ B3 @ A3 )
             => ( P @ A3 @ B3 ) )
         => ( P @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_92_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_93_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ( ord_less_nat @ Y @ X )
        | ( X = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_94_verit__comp__simplify1_I1_J,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% verit_comp_simplify1(1)
thf(fact_95_th21,axiom,(
    polyno1372495879olyh_a @ c2 @ ( suc @ n2 ) )).

% th21
thf(fact_96_nc_H,axiom,(
    polyno1372495879olyh_a @ c @ ( suc @ n ) )).

% nc'
thf(fact_97_zero__less__Suc,axiom,(
    ! [N: nat] :
      ( ord_less_nat @ zero_zero_nat @ ( suc @ N ) ) )).

% zero_less_Suc
thf(fact_98_less__Suc0,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ N @ ( suc @ zero_zero_nat ) )
      = ( N = zero_zero_nat ) ) )).

% less_Suc0
thf(fact_99_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_100_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_101_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_102_min__0L,axiom,(
    ! [N: nat] :
      ( ( ord_min_nat @ zero_zero_nat @ N )
      = zero_zero_nat ) )).

% min_0L
thf(fact_103_min__0R,axiom,(
    ! [N: nat] :
      ( ( ord_min_nat @ N @ zero_zero_nat )
      = zero_zero_nat ) )).

% min_0R
thf(fact_104_polypow_Ocases,axiom,(
    ! [X: nat] :
      ( ( X != zero_zero_nat )
     => ~ ! [V: nat] :
            ( X
           != ( suc @ V ) ) ) )).

% polypow.cases
thf(fact_105_nat_Odistinct_I1_J,axiom,(
    ! [X2: nat] :
      ( zero_zero_nat
     != ( suc @ X2 ) ) )).

% nat.distinct(1)
thf(fact_106_old_Onat_Odistinct_I2_J,axiom,(
    ! [Nat2: nat] :
      ( ( suc @ Nat2 )
     != zero_zero_nat ) )).

% old.nat.distinct(2)
thf(fact_107_old_Onat_Odistinct_I1_J,axiom,(
    ! [Nat2: nat] :
      ( zero_zero_nat
     != ( suc @ Nat2 ) ) )).

% old.nat.distinct(1)
thf(fact_108_nat_OdiscI,axiom,(
    ! [Nat: nat,X2: nat] :
      ( ( Nat
        = ( suc @ X2 ) )
     => ( Nat != zero_zero_nat ) ) )).

% nat.discI
thf(fact_109_nat__induct,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ zero_zero_nat )
     => ( ! [N2: nat] :
            ( ( P @ N2 )
           => ( P @ ( suc @ N2 ) ) )
       => ( P @ N ) ) ) )).

% nat_induct
thf(fact_110_diff__induct,axiom,(
    ! [P: nat > nat > $o,M: nat,N: nat] :
      ( ! [X4: nat] :
          ( P @ X4 @ zero_zero_nat )
     => ( ! [Y3: nat] :
            ( P @ zero_zero_nat @ ( suc @ Y3 ) )
       => ( ! [X4: nat,Y3: nat] :
              ( ( P @ X4 @ Y3 )
             => ( P @ ( suc @ X4 ) @ ( suc @ Y3 ) ) )
         => ( P @ M @ N ) ) ) ) )).

% diff_induct
thf(fact_111_zero__induct,axiom,(
    ! [P: nat > $o,K2: nat] :
      ( ( P @ K2 )
     => ( ! [N2: nat] :
            ( ( P @ ( suc @ N2 ) )
           => ( P @ N2 ) )
       => ( P @ zero_zero_nat ) ) ) )).

% zero_induct
thf(fact_112_Suc__neq__Zero,axiom,(
    ! [M: nat] :
      ( ( suc @ M )
     != zero_zero_nat ) )).

% Suc_neq_Zero
thf(fact_113_Zero__neq__Suc,axiom,(
    ! [M: nat] :
      ( zero_zero_nat
     != ( suc @ M ) ) )).

% Zero_neq_Suc
thf(fact_114_Zero__not__Suc,axiom,(
    ! [M: nat] :
      ( zero_zero_nat
     != ( suc @ M ) ) )).

% Zero_not_Suc
thf(fact_115_old_Onat_Oexhaust,axiom,(
    ! [Y: nat] :
      ( ( Y != zero_zero_nat )
     => ~ ! [Nat3: nat] :
            ( Y
           != ( suc @ Nat3 ) ) ) )).

% old.nat.exhaust
thf(fact_116_old_Onat_Oinducts,axiom,(
    ! [P: nat > $o,Nat: nat] :
      ( ( P @ zero_zero_nat )
     => ( ! [Nat3: nat] :
            ( ( P @ Nat3 )
           => ( P @ ( suc @ Nat3 ) ) )
       => ( P @ Nat ) ) ) )).

% old.nat.inducts
thf(fact_117_not0__implies__Suc,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ? [M5: nat] :
          ( N
          = ( suc @ M5 ) ) ) )).

% not0_implies_Suc
thf(fact_118_bot__nat__0_Oextremum__strict,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ zero_zero_nat ) )).

% bot_nat_0.extremum_strict
thf(fact_119_infinite__descent0,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ zero_zero_nat )
     => ( ! [N2: nat] :
            ( ( ord_less_nat @ zero_zero_nat @ N2 )
           => ( ~ ( P @ N2 )
             => ? [M2: nat] :
                  ( ( ord_less_nat @ M2 @ N2 )
                  & ~ ( P @ M2 ) ) ) )
       => ( P @ N ) ) ) )).

% infinite_descent0
thf(fact_120_gr__implies__not0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not0
thf(fact_121_less__zeroE,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_zeroE
thf(fact_122_not__less0,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less0
thf(fact_123_not__gr0,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr0
thf(fact_124_gr0I,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr0I
thf(fact_125_Ex__less__Suc2,axiom,(
    ! [N: nat,P: nat > $o] :
      ( ( ? [I3: nat] :
            ( ( ord_less_nat @ I3 @ ( suc @ N ) )
            & ( P @ I3 ) ) )
      = ( ( P @ zero_zero_nat )
        | ? [I3: nat] :
            ( ( ord_less_nat @ I3 @ N )
            & ( P @ ( suc @ I3 ) ) ) ) ) )).

% Ex_less_Suc2
thf(fact_126_gr0__conv__Suc,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( ? [M4: nat] :
            ( N
            = ( suc @ M4 ) ) ) ) )).

% gr0_conv_Suc
thf(fact_127_All__less__Suc2,axiom,(
    ! [N: nat,P: nat > $o] :
      ( ( ! [I3: nat] :
            ( ( ord_less_nat @ I3 @ ( suc @ N ) )
           => ( P @ I3 ) ) )
      = ( ( P @ zero_zero_nat )
        & ! [I3: nat] :
            ( ( ord_less_nat @ I3 @ N )
           => ( P @ ( suc @ I3 ) ) ) ) ) )).

% All_less_Suc2
thf(fact_128_gr0__implies__Suc,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ? [M5: nat] :
          ( N
          = ( suc @ M5 ) ) ) )).

% gr0_implies_Suc
thf(fact_129_less__Suc__eq__0__disj,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ ( suc @ N ) )
      = ( ( M = zero_zero_nat )
        | ? [J3: nat] :
            ( ( M
              = ( suc @ J3 ) )
            & ( ord_less_nat @ J3 @ N ) ) ) ) )).

% less_Suc_eq_0_disj
thf(fact_130_np,axiom,(
    polyno1372495879olyh_a @ pa @ n2 )).

% np
thf(fact_131_np_H,axiom,(
    polyno1372495879olyh_a @ p @ n )).

% np'
thf(fact_132__C4_Ohyps_C_I3_J,axiom,(
    ! [N0: nat,N1: nat] :
      ( ( polyno1372495879olyh_a @ c2 @ N0 )
     => ( ( polyno1372495879olyh_a @ c @ N1 )
       => ( polyno1372495879olyh_a @ ( polyno2065957734yadd_a @ c2 @ c ) @ ( ord_min_nat @ N0 @ N1 ) ) ) ) )).

% "4.hyps"(3)
thf(fact_133_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_134__C4_Ohyps_C_I4_J,axiom,(
    ! [N0: nat,N1: nat] :
      ( ( polyno1372495879olyh_a @ pa @ N0 )
     => ( ( polyno1372495879olyh_a @ p @ N1 )
       => ( polyno1372495879olyh_a @ ( polyno2065957734yadd_a @ pa @ p ) @ ( ord_min_nat @ N0 @ N1 ) ) ) ) )).

% "4.hyps"(4)
thf(fact_135_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_136_zero__less__iff__neq__zero,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( N != zero_zero_nat ) ) )).

% zero_less_iff_neq_zero
thf(fact_137_gr__implies__not__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not_zero
thf(fact_138_not__less__zero,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less_zero
thf(fact_139_gr__zeroI,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_zeroI
thf(fact_140__C4_Ohyps_C_I2_J,axiom,(
    ! [N0: nat,N1: nat] :
      ( ( polyno1372495879olyh_a @ ( polyno1057396216e_CN_a @ c2 @ n2 @ pa ) @ N0 )
     => ( ( polyno1372495879olyh_a @ c @ N1 )
       => ( polyno1372495879olyh_a @ ( polyno2065957734yadd_a @ ( polyno1057396216e_CN_a @ c2 @ n2 @ pa ) @ c ) @ ( ord_min_nat @ N0 @ N1 ) ) ) ) )).

% "4.hyps"(2)
thf(fact_141__C4_Ohyps_C_I1_J,axiom,(
    ! [N0: nat,N1: nat] :
      ( ( polyno1372495879olyh_a @ c2 @ N0 )
     => ( ( polyno1372495879olyh_a @ ( polyno1057396216e_CN_a @ c @ n @ p ) @ N1 )
       => ( polyno1372495879olyh_a @ ( polyno2065957734yadd_a @ c2 @ ( polyno1057396216e_CN_a @ c @ n @ p ) ) @ ( ord_min_nat @ N0 @ N1 ) ) ) ) )).

% "4.hyps"(1)
thf(fact_142__C4_Oprems_C_I2_J,axiom,(
    polyno1372495879olyh_a @ ( polyno1057396216e_CN_a @ c @ n @ p ) @ n1a )).

% "4.prems"(2)
thf(fact_143_poly_Oinject_I8_J,axiom,(
    ! [X81: polyno727731844poly_a,X82: nat,X83: polyno727731844poly_a,Y81: polyno727731844poly_a,Y82: nat,Y83: polyno727731844poly_a] :
      ( ( ( polyno1057396216e_CN_a @ X81 @ X82 @ X83 )
        = ( polyno1057396216e_CN_a @ Y81 @ Y82 @ Y83 ) )
      = ( ( X81 = Y81 )
        & ( X82 = Y82 )
        & ( X83 = Y83 ) ) ) )).

% poly.inject(8)
thf(fact_144_th22,axiom,(
    polyno1372495879olyh_a @ ( polyno1057396216e_CN_a @ c @ n @ p ) @ n )).

% th22
thf(fact_145__C4_Oprems_C_I1_J,axiom,(
    polyno1372495879olyh_a @ ( polyno1057396216e_CN_a @ c2 @ n2 @ pa ) @ n0a )).

% "4.prems"(1)
thf(fact_146_isnpoly__def,axiom,
    ( polyno190918219poly_a
    = ( ^ [P5: polyno727731844poly_a] :
          ( polyno1372495879olyh_a @ P5 @ zero_zero_nat ) ) )).

% isnpoly_def
thf(fact_147_n_Hgen1,axiom,(
    ord_less_eq_nat @ n1a @ n )).

% n'gen1
thf(fact_148_exists__least__lemma,axiom,(
    ! [P: nat > $o] :
      ( ~ ( P @ zero_zero_nat )
     => ( ? [X_12: nat] :
            ( P @ X_12 )
       => ? [N2: nat] :
            ( ~ ( P @ N2 )
            & ( P @ ( suc @ N2 ) ) ) ) ) )).

% exists_least_lemma
thf(fact_149_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_150_ngen0,axiom,(
    ord_less_eq_nat @ n0a @ n2 )).

% ngen0
thf(fact_151__092_060open_062min_An0_An1_A_092_060le_062_An0_092_060close_062,axiom,(
    ord_less_eq_nat @ ( ord_min_nat @ n0a @ n1a ) @ n0a )).

% \<open>min n0 n1 \<le> n0\<close>
thf(fact_152_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_153_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_154_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_155_Suc__le__mono,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_eq_nat @ ( suc @ N ) @ ( suc @ M ) )
      = ( ord_less_eq_nat @ N @ M ) ) )).

% Suc_le_mono
thf(fact_156_min_Obounded__iff,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( ord_min_nat @ B @ C ) )
      = ( ( ord_less_eq_nat @ A @ B )
        & ( ord_less_eq_nat @ A @ C ) ) ) )).

% min.bounded_iff
thf(fact_157_th1,axiom,(
    ord_less_eq_nat @ ( ord_min_nat @ n0a @ n1a ) @ n2 )).

% th1
thf(fact_158_verit__la__disequality,axiom,(
    ! [A: nat,B: nat] :
      ( ( A = B )
      | ~ ( ord_less_eq_nat @ A @ B )
      | ~ ( ord_less_eq_nat @ B @ A ) ) )).

% verit_la_disequality
thf(fact_159_verit__comp__simplify1_I3_J,axiom,(
    ! [B4: nat,A4: nat] :
      ( ( ~ ( ord_less_eq_nat @ B4 @ A4 ) )
      = ( ord_less_nat @ A4 @ B4 ) ) )).

% verit_comp_simplify1(3)
thf(fact_160_pinf_I6_J,axiom,(
    ! [T: nat] :
    ? [Z2: nat] :
    ! [X3: nat] :
      ( ( ord_less_nat @ Z2 @ X3 )
     => ~ ( ord_less_eq_nat @ X3 @ T ) ) )).

% pinf(6)
thf(fact_161_pinf_I8_J,axiom,(
    ! [T: nat] :
    ? [Z2: nat] :
    ! [X3: nat] :
      ( ( ord_less_nat @ Z2 @ X3 )
     => ( ord_less_eq_nat @ T @ X3 ) ) )).

% pinf(8)
thf(fact_162_minf_I6_J,axiom,(
    ! [T: nat] :
    ? [Z2: nat] :
    ! [X3: nat] :
      ( ( ord_less_nat @ X3 @ Z2 )
     => ( ord_less_eq_nat @ X3 @ T ) ) )).

% minf(6)
thf(fact_163_minf_I8_J,axiom,(
    ! [T: nat] :
    ? [Z2: nat] :
    ! [X3: nat] :
      ( ( ord_less_nat @ X3 @ Z2 )
     => ~ ( ord_less_eq_nat @ T @ X3 ) ) )).

% minf(8)
thf(fact_164_leD,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ~ ( ord_less_nat @ X @ Y ) ) )).

% leD
thf(fact_165_leI,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% leI
thf(fact_166_le__less,axiom,
    ( ord_less_eq_nat
    = ( ^ [X6: nat,Y5: nat] :
          ( ( ord_less_nat @ X6 @ Y5 )
          | ( X6 = Y5 ) ) ) )).

% le_less
thf(fact_167_less__le,axiom,
    ( ord_less_nat
    = ( ^ [X6: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X6 @ Y5 )
          & ( X6 != Y5 ) ) ) )).

% less_le
thf(fact_168_order__le__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X4: nat,Y3: nat] :
              ( ( ord_less_nat @ X4 @ Y3 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_169_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X4: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_170_order__less__le__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X4: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_171_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X4: nat,Y3: nat] :
              ( ( ord_less_nat @ X4 @ Y3 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_172_not__le,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_eq_nat @ X @ Y ) )
      = ( ord_less_nat @ Y @ X ) ) )).

% not_le
thf(fact_173_not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ord_less_eq_nat @ Y @ X ) ) )).

% not_less
thf(fact_174_le__neq__trans,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( A != B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_175_antisym__conv1,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv1
thf(fact_176_antisym__conv2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv2
thf(fact_177_less__imp__le,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% less_imp_le
thf(fact_178_le__less__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% le_less_trans
thf(fact_179_less__le__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% less_le_trans
thf(fact_180_le__less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% le_less_linear
thf(fact_181_le__imp__less__or__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_nat @ X @ Y )
        | ( X = Y ) ) ) )).

% le_imp_less_or_eq
thf(fact_182_less__le__not__le,axiom,
    ( ord_less_nat
    = ( ^ [X6: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X6 @ Y5 )
          & ~ ( ord_less_eq_nat @ Y5 @ X6 ) ) ) )).

% less_le_not_le
thf(fact_183_not__le__imp__less,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_eq_nat @ Y @ X )
     => ( ord_less_nat @ X @ Y ) ) )).

% not_le_imp_less
thf(fact_184_order_Ostrict__trans1,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_185_order_Ostrict__trans2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_186_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_nat @ A2 @ B2 )
          | ( A2 = B2 ) ) ) )).

% order.order_iff_strict
thf(fact_187_order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( A2 != B2 ) ) ) )).

% order.strict_iff_order
thf(fact_188_dual__order_Ostrict__trans1,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_189_dual__order_Ostrict__trans2,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_190_order_Ostrict__implies__order,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_191_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_less_nat @ B2 @ A2 )
          | ( A2 = B2 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_192_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( A2 != B2 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_193_dual__order_Ostrict__implies__order,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ord_less_eq_nat @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_194_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_195_complete__interval,axiom,(
    ! [A: nat,B: nat,P: nat > $o] :
      ( ( ord_less_nat @ A @ B )
     => ( ( P @ A )
       => ( ~ ( P @ B )
         => ? [C2: nat] :
              ( ( ord_less_eq_nat @ A @ C2 )
              & ( ord_less_eq_nat @ C2 @ B )
              & ! [X3: nat] :
                  ( ( ( ord_less_eq_nat @ A @ X3 )
                    & ( ord_less_nat @ X3 @ C2 ) )
                 => ( P @ X3 ) )
              & ! [D: nat] :
                  ( ! [X4: nat] :
                      ( ( ( ord_less_eq_nat @ A @ X4 )
                        & ( ord_less_nat @ X4 @ D ) )
                     => ( P @ X4 ) )
                 => ( ord_less_eq_nat @ D @ C2 ) ) ) ) ) ) )).

% complete_interval
thf(fact_196_Suc__leD,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( suc @ M ) @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% Suc_leD
thf(fact_197_le__SucE,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less_eq_nat @ M @ N )
       => ( M
          = ( suc @ N ) ) ) ) )).

% le_SucE
thf(fact_198_le__SucI,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ ( suc @ N ) ) ) )).

% le_SucI
thf(fact_199_Suc__le__D,axiom,(
    ! [N: nat,M6: nat] :
      ( ( ord_less_eq_nat @ ( suc @ N ) @ M6 )
     => ? [M5: nat] :
          ( M6
          = ( suc @ M5 ) ) ) )).

% Suc_le_D
thf(fact_200_le__Suc__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ ( suc @ N ) )
      = ( ( ord_less_eq_nat @ M @ N )
        | ( M
          = ( suc @ N ) ) ) ) )).

% le_Suc_eq
thf(fact_201_Suc__n__not__le__n,axiom,(
    ! [N: nat] :
      ~ ( ord_less_eq_nat @ ( suc @ N ) @ N ) )).

% Suc_n_not_le_n
thf(fact_202_not__less__eq__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less_eq_nat @ M @ N ) )
      = ( ord_less_eq_nat @ ( suc @ N ) @ M ) ) )).

% not_less_eq_eq
thf(fact_203_full__nat__induct,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_eq_nat @ ( suc @ M2 ) @ N2 )
             => ( P @ M2 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) )).

% full_nat_induct
thf(fact_204_nat__induct__at__least,axiom,(
    ! [M: nat,N: nat,P: nat > $o] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( P @ M )
       => ( ! [N2: nat] :
              ( ( ord_less_eq_nat @ M @ N2 )
             => ( ( P @ N2 )
               => ( P @ ( suc @ N2 ) ) ) )
         => ( P @ N ) ) ) ) )).

% nat_induct_at_least
thf(fact_205_transitive__stepwise__le,axiom,(
    ! [M: nat,N: nat,R: nat > nat > $o] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ! [X4: nat] :
            ( R @ X4 @ X4 )
       => ( ! [X4: nat,Y3: nat,Z2: nat] :
              ( ( R @ X4 @ Y3 )
             => ( ( R @ Y3 @ Z2 )
               => ( R @ X4 @ Z2 ) ) )
         => ( ! [N2: nat] :
                ( R @ N2 @ ( suc @ N2 ) )
           => ( R @ M @ N ) ) ) ) ) )).

% transitive_stepwise_le
thf(fact_206_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_nat @ I2 @ J2 )
         => ( ord_less_nat @ ( F @ I2 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I @ J )
       => ( ord_less_eq_nat @ ( F @ I ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_207_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_208_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_209_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M4: nat,N4: nat] :
          ( ( ord_less_nat @ M4 @ N4 )
          | ( M4 = N4 ) ) ) )).

% le_eq_less_or_eq
thf(fact_210_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_211_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M4: nat,N4: nat] :
          ( ( ord_less_eq_nat @ M4 @ N4 )
          & ( M4 != N4 ) ) ) )).

% nat_less_le
thf(fact_212_min_Omono,axiom,(
    ! [A: nat,C: nat,B: nat,D2: nat] :
      ( ( ord_less_eq_nat @ A @ C )
     => ( ( ord_less_eq_nat @ B @ D2 )
       => ( ord_less_eq_nat @ ( ord_min_nat @ A @ B ) @ ( ord_min_nat @ C @ D2 ) ) ) ) )).

% min.mono
thf(fact_213_min_OorderE,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( A
        = ( ord_min_nat @ A @ B ) ) ) )).

% min.orderE
thf(fact_214_min_OorderI,axiom,(
    ! [A: nat,B: nat] :
      ( ( A
        = ( ord_min_nat @ A @ B ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% min.orderI
thf(fact_215_min_Oabsorb1,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_min_nat @ A @ B )
        = A ) ) )).

% min.absorb1
thf(fact_216_min_Oabsorb2,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_min_nat @ A @ B )
        = B ) ) )).

% min.absorb2
thf(fact_217_min_OboundedE,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( ord_min_nat @ B @ C ) )
     => ~ ( ( ord_less_eq_nat @ A @ B )
         => ~ ( ord_less_eq_nat @ A @ C ) ) ) )).

% min.boundedE
thf(fact_218_min_OboundedI,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ A @ C )
       => ( ord_less_eq_nat @ A @ ( ord_min_nat @ B @ C ) ) ) ) )).

% min.boundedI
thf(fact_219_min_Oorder__iff,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
          ( A2
          = ( ord_min_nat @ A2 @ B2 ) ) ) )).

% min.order_iff
thf(fact_220_min_Ocobounded1,axiom,(
    ! [A: nat,B: nat] :
      ( ord_less_eq_nat @ ( ord_min_nat @ A @ B ) @ A ) )).

% min.cobounded1
thf(fact_221_min_Ocobounded2,axiom,(
    ! [A: nat,B: nat] :
      ( ord_less_eq_nat @ ( ord_min_nat @ A @ B ) @ B ) )).

% min.cobounded2
thf(fact_222_min_Oabsorb__iff1,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_min_nat @ A2 @ B2 )
          = A2 ) ) )).

% min.absorb_iff1
thf(fact_223_min_Oabsorb__iff2,axiom,
    ( ord_less_eq_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_min_nat @ A2 @ B2 )
          = B2 ) ) )).

% min.absorb_iff2
thf(fact_224_min_OcoboundedI1,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ C )
     => ( ord_less_eq_nat @ ( ord_min_nat @ A @ B ) @ C ) ) )).

% min.coboundedI1
thf(fact_225_min_OcoboundedI2,axiom,(
    ! [B: nat,C: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ C )
     => ( ord_less_eq_nat @ ( ord_min_nat @ A @ B ) @ C ) ) )).

% min.coboundedI2
thf(fact_226_min__le__iff__disj,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_eq_nat @ ( ord_min_nat @ X @ Y ) @ Z )
      = ( ( ord_less_eq_nat @ X @ Z )
        | ( ord_less_eq_nat @ Y @ Z ) ) ) )).

% min_le_iff_disj
thf(fact_227_min__def,axiom,
    ( ord_min_nat
    = ( ^ [A2: nat,B2: nat] :
          ( if_nat @ ( ord_less_eq_nat @ A2 @ B2 ) @ A2 @ B2 ) ) )).

% min_def
thf(fact_228_min__absorb2,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ( ( ord_min_nat @ X @ Y )
        = Y ) ) )).

% min_absorb2
thf(fact_229_min__absorb1,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_min_nat @ X @ Y )
        = X ) ) )).

% min_absorb1
thf(fact_230_lift__Suc__antimono__le,axiom,(
    ! [F: nat > nat,N: nat,N3: nat] :
      ( ! [N2: nat] :
          ( ord_less_eq_nat @ ( F @ ( suc @ N2 ) ) @ ( F @ N2 ) )
     => ( ( ord_less_eq_nat @ N @ N3 )
       => ( ord_less_eq_nat @ ( F @ N3 ) @ ( F @ N ) ) ) ) )).

% lift_Suc_antimono_le
thf(fact_231_lift__Suc__mono__le,axiom,(
    ! [F: nat > nat,N: nat,N3: nat] :
      ( ! [N2: nat] :
          ( ord_less_eq_nat @ ( F @ N2 ) @ ( F @ ( suc @ N2 ) ) )
     => ( ( ord_less_eq_nat @ N @ N3 )
       => ( ord_less_eq_nat @ ( F @ N ) @ ( F @ N3 ) ) ) ) )).

% lift_Suc_mono_le
thf(fact_232_Nat_Oex__has__greatest__nat,axiom,(
    ! [P: nat > $o,K2: nat,B: nat] :
      ( ( P @ K2 )
     => ( ! [Y3: nat] :
            ( ( P @ Y3 )
           => ( ord_less_eq_nat @ Y3 @ B ) )
       => ? [X4: nat] :
            ( ( P @ X4 )
            & ! [Y4: nat] :
                ( ( P @ Y4 )
               => ( ord_less_eq_nat @ Y4 @ X4 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_233_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear

% Helper facts (3)
thf(help_If_3_1_If_001t__Nat__Onat_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_If_001t__Nat__Onat_T,axiom,(
    ! [X: nat,Y: nat] :
      ( ( if_nat @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_If_001t__Nat__Onat_T,axiom,(
    ! [X: nat,Y: nat] :
      ( ( if_nat @ $true @ X @ Y )
      = X ) )).

% Conjectures (1)
thf(conj_0,conjecture,
    ( ( ord_min_nat @ ( suc @ n2 ) @ n )
    = ( suc @ n2 ) )).

%------------------------------------------------------------------------------
