%------------------------------------------------------------------------------
% File     : SLH349^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer NthRoot_Impl problem prob_235__3275334_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : NthRoot_Impl/prob_235__3275334_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  365 (   0 unit;  17 type;   0 defn)
%            Number of atoms       : 3574 ( 261 equality;2234 variable)
%            Maximal formula depth :   16 (   8 average)
%            Number of connectives : 2851 ( 147   ~;  28   |;  28   &;2062   @)
%                                         (   0 <=>; 586  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  126 ( 126   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   19 (  17   :;   0   =)
%            Number of variables   : 1024 (   0 sgn; 924   !;  59   ?;  41   ^)
%                                         (1024   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:41:12.477
%------------------------------------------------------------------------------
% Could-be-implicit typings (2)
thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

thf(ty_n_t__Int__Oint,type,(
    int: $tType )).

% Explicit typings (15)
thf(sy_c_Groups_Ozero__class_Ozero_001t__Int__Oint,type,(
    zero_zero_int: int )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Nat_OSuc,type,(
    suc: nat > nat )).

thf(sy_c_NthRoot__Impl__Mirabelle__bcfbdygymo_Ofixed__root,type,(
    nthRoo1352626670d_root: nat > nat > $o )).

thf(sy_c_NthRoot__Impl__Mirabelle__bcfbdygymo_Ostart__value,type,(
    nthRoo1503232983_value: int > nat > int )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Int__Oint,type,(
    ord_less_int: int > int > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Int__Oint,type,(
    ord_less_eq_int: int > int > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Power_Opower__class_Opower_001t__Int__Oint,type,(
    power_power_int: int > nat > int )).

thf(sy_c_Power_Opower__class_Opower_001t__Nat__Onat,type,(
    power_power_nat: nat > nat > nat )).

thf(sy_v_n____,type,(
    n: int )).

thf(sy_v_p,type,(
    p: nat )).

thf(sy_v_pm,type,(
    pm: nat )).

thf(sy_v_x____,type,(
    x: int )).

% Relevant facts (347)
thf(fact_0_x__n_I2_J,axiom,(
    ord_less_eq_int @ zero_zero_int @ n )).

% x_n(2)
thf(fact_1_x__n_I1_J,axiom,(
    ord_less_eq_int @ zero_zero_int @ x )).

% x_n(1)
thf(fact_2_x,axiom,(
    ord_less_int @ n @ ( power_power_int @ x @ p ) )).

% x
thf(fact_3__092_060open_062_092_060not_062_A_Ix_A_060_A0_A_092_060or_062_An_A_060_A0_J_092_060close_062,axiom,(
    ~ ( ( ord_less_int @ x @ zero_zero_int )
      | ( ord_less_int @ n @ zero_zero_int ) ) )).

% \<open>\<not> (x < 0 \<or> n < 0)\<close>
thf(fact_4__092_060open_062_092_060not_062_Ax_A_094_Ap_A_092_060le_062_An_092_060close_062,axiom,(
    ~ ( ord_less_eq_int @ ( power_power_int @ x @ p ) @ n ) )).

% \<open>\<not> x ^ p \<le> n\<close>
thf(fact_5_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_6_fixed__root__axioms,axiom,(
    nthRoo1352626670d_root @ p @ pm )).

% fixed_root_axioms
thf(fact_7_less__int__code_I1_J,axiom,(
    ~ ( ord_less_int @ zero_zero_int @ zero_zero_int ) )).

% less_int_code(1)
thf(fact_8_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_int @ zero_zero_int @ zero_zero_int ) )).

% less_numeral_extra(3)
thf(fact_9_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_nat @ zero_zero_nat @ zero_zero_nat ) )).

% less_numeral_extra(3)
thf(fact_10_gr__zeroI,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_zeroI
thf(fact_11_not__less__zero,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less_zero
thf(fact_12_gr__implies__not__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not_zero
thf(fact_13_zero__less__iff__neq__zero,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( N != zero_zero_nat ) ) )).

% zero_less_iff_neq_zero
thf(fact_14_zero__integer_Orsp,axiom,(
    zero_zero_int = zero_zero_int )).

% zero_integer.rsp
thf(fact_15_zero__less__power,axiom,(
    ! [A: int,N: nat] :
      ( ( ord_less_int @ zero_zero_int @ A )
     => ( ord_less_int @ zero_zero_int @ ( power_power_int @ A @ N ) ) ) )).

% zero_less_power
thf(fact_16_zero__less__power,axiom,(
    ! [A: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ord_less_nat @ zero_zero_nat @ ( power_power_nat @ A @ N ) ) ) )).

% zero_less_power
thf(fact_17_p,axiom,
    ( p
    = ( suc @ pm ) )).

% p
thf(fact_18_p0,axiom,(
    p != zero_zero_nat )).

% p0
thf(fact_19_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_20_power__eq__0__iff,axiom,(
    ! [A: int,N: nat] :
      ( ( ( power_power_int @ A @ N )
        = zero_zero_int )
      = ( ( A = zero_zero_int )
        & ( ord_less_nat @ zero_zero_nat @ N ) ) ) )).

% power_eq_0_iff
thf(fact_21_power__eq__0__iff,axiom,(
    ! [A: nat,N: nat] :
      ( ( ( power_power_nat @ A @ N )
        = zero_zero_nat )
      = ( ( A = zero_zero_nat )
        & ( ord_less_nat @ zero_zero_nat @ N ) ) ) )).

% power_eq_0_iff
thf(fact_22_power__mono__iff,axiom,(
    ! [A: int,B: int,N: nat] :
      ( ( ord_less_eq_int @ zero_zero_int @ A )
     => ( ( ord_less_eq_int @ zero_zero_int @ B )
       => ( ( ord_less_nat @ zero_zero_nat @ N )
         => ( ( ord_less_eq_int @ ( power_power_int @ A @ N ) @ ( power_power_int @ B @ N ) )
            = ( ord_less_eq_int @ A @ B ) ) ) ) ) )).

% power_mono_iff
thf(fact_23_power__mono__iff,axiom,(
    ! [A: nat,B: nat,N: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ( ord_less_nat @ zero_zero_nat @ N )
         => ( ( ord_less_eq_nat @ ( power_power_nat @ A @ N ) @ ( power_power_nat @ B @ N ) )
            = ( ord_less_eq_nat @ A @ B ) ) ) ) ) )).

% power_mono_iff
thf(fact_24_fixed__root_Op0,axiom,(
    ! [P: nat,Pm: nat] :
      ( ( nthRoo1352626670d_root @ P @ Pm )
     => ( P != zero_zero_nat ) ) )).

% fixed_root.p0
thf(fact_25_power__eq__iff__eq__base,axiom,(
    ! [N: nat,A: int,B: int] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_eq_int @ zero_zero_int @ A )
       => ( ( ord_less_eq_int @ zero_zero_int @ B )
         => ( ( ( power_power_int @ A @ N )
              = ( power_power_int @ B @ N ) )
            = ( A = B ) ) ) ) ) )).

% power_eq_iff_eq_base
thf(fact_26_power__eq__iff__eq__base,axiom,(
    ! [N: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
         => ( ( ( power_power_nat @ A @ N )
              = ( power_power_nat @ B @ N ) )
            = ( A = B ) ) ) ) ) )).

% power_eq_iff_eq_base
thf(fact_27_power__eq__imp__eq__base,axiom,(
    ! [A: int,N: nat,B: int] :
      ( ( ( power_power_int @ A @ N )
        = ( power_power_int @ B @ N ) )
     => ( ( ord_less_eq_int @ zero_zero_int @ A )
       => ( ( ord_less_eq_int @ zero_zero_int @ B )
         => ( ( ord_less_nat @ zero_zero_nat @ N )
           => ( A = B ) ) ) ) ) )).

% power_eq_imp_eq_base
thf(fact_28_power__eq__imp__eq__base,axiom,(
    ! [A: nat,N: nat,B: nat] :
      ( ( ( power_power_nat @ A @ N )
        = ( power_power_nat @ B @ N ) )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
         => ( ( ord_less_nat @ zero_zero_nat @ N )
           => ( A = B ) ) ) ) ) )).

% power_eq_imp_eq_base
thf(fact_29_zero__power,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( power_power_int @ zero_zero_int @ N )
        = zero_zero_int ) ) )).

% zero_power
thf(fact_30_zero__power,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( power_power_nat @ zero_zero_nat @ N )
        = zero_zero_nat ) ) )).

% zero_power
thf(fact_31_zero__le__power,axiom,(
    ! [A: int,N: nat] :
      ( ( ord_less_eq_int @ zero_zero_int @ A )
     => ( ord_less_eq_int @ zero_zero_int @ ( power_power_int @ A @ N ) ) ) )).

% zero_le_power
thf(fact_32_zero__le__power,axiom,(
    ! [A: nat,N: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ord_less_eq_nat @ zero_zero_nat @ ( power_power_nat @ A @ N ) ) ) )).

% zero_le_power
thf(fact_33_power__mono,axiom,(
    ! [A: int,B: int,N: nat] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ zero_zero_int @ A )
       => ( ord_less_eq_int @ ( power_power_int @ A @ N ) @ ( power_power_int @ B @ N ) ) ) ) )).

% power_mono
thf(fact_34_power__mono,axiom,(
    ! [A: nat,B: nat,N: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
       => ( ord_less_eq_nat @ ( power_power_nat @ A @ N ) @ ( power_power_nat @ B @ N ) ) ) ) )).

% power_mono
thf(fact_35_power__not__zero,axiom,(
    ! [A: int,N: nat] :
      ( ( A != zero_zero_int )
     => ( ( power_power_int @ A @ N )
       != zero_zero_int ) ) )).

% power_not_zero
thf(fact_36_power__not__zero,axiom,(
    ! [A: nat,N: nat] :
      ( ( A != zero_zero_nat )
     => ( ( power_power_nat @ A @ N )
       != zero_zero_nat ) ) )).

% power_not_zero
thf(fact_37_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_38_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_int @ zero_zero_int @ zero_zero_int )).

% le_numeral_extra(3)
thf(fact_39_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ zero_zero_nat )).

% le_numeral_extra(3)
thf(fact_40_less__eq__int__code_I1_J,axiom,(
    ord_less_eq_int @ zero_zero_int @ zero_zero_int )).

% less_eq_int_code(1)
thf(fact_41_power__less__imp__less__base,axiom,(
    ! [A: int,N: nat,B: int] :
      ( ( ord_less_int @ ( power_power_int @ A @ N ) @ ( power_power_int @ B @ N ) )
     => ( ( ord_less_eq_int @ zero_zero_int @ B )
       => ( ord_less_int @ A @ B ) ) ) )).

% power_less_imp_less_base
thf(fact_42_power__less__imp__less__base,axiom,(
    ! [A: nat,N: nat,B: nat] :
      ( ( ord_less_nat @ ( power_power_nat @ A @ N ) @ ( power_power_nat @ B @ N ) )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% power_less_imp_less_base
thf(fact_43_power__strict__mono,axiom,(
    ! [A: int,B: int,N: nat] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_eq_int @ zero_zero_int @ A )
       => ( ( ord_less_nat @ zero_zero_nat @ N )
         => ( ord_less_int @ ( power_power_int @ A @ N ) @ ( power_power_int @ B @ N ) ) ) ) ) )).

% power_strict_mono
thf(fact_44_power__strict__mono,axiom,(
    ! [A: nat,B: nat,N: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
       => ( ( ord_less_nat @ zero_zero_nat @ N )
         => ( ord_less_nat @ ( power_power_nat @ A @ N ) @ ( power_power_nat @ B @ N ) ) ) ) ) )).

% power_strict_mono
thf(fact_45_zero__reorient,axiom,(
    ! [X: int] :
      ( ( zero_zero_int = X )
      = ( X = zero_zero_int ) ) )).

% zero_reorient
thf(fact_46_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_47_power__0__Suc,axiom,(
    ! [N: nat] :
      ( ( power_power_int @ zero_zero_int @ ( suc @ N ) )
      = zero_zero_int ) )).

% power_0_Suc
thf(fact_48_power__0__Suc,axiom,(
    ! [N: nat] :
      ( ( power_power_nat @ zero_zero_nat @ ( suc @ N ) )
      = zero_zero_nat ) )).

% power_0_Suc
thf(fact_49_power__Suc0__right,axiom,(
    ! [A: int] :
      ( ( power_power_int @ A @ ( suc @ zero_zero_nat ) )
      = A ) )).

% power_Suc0_right
thf(fact_50_power__Suc0__right,axiom,(
    ! [A: nat] :
      ( ( power_power_nat @ A @ ( suc @ zero_zero_nat ) )
      = A ) )).

% power_Suc0_right
thf(fact_51_compare__pow__less__iff,axiom,(
    ! [P: nat,X: int,Y: int] :
      ( ( ord_less_nat @ zero_zero_nat @ P )
     => ( ( ord_less_eq_int @ zero_zero_int @ X )
       => ( ( ord_less_eq_int @ zero_zero_int @ Y )
         => ( ( ord_less_int @ ( power_power_int @ X @ P ) @ ( power_power_int @ Y @ P ) )
            = ( ord_less_int @ X @ Y ) ) ) ) ) )).

% compare_pow_less_iff
thf(fact_52_power__le__imp__le__base,axiom,(
    ! [A: int,N: nat,B: int] :
      ( ( ord_less_eq_int @ ( power_power_int @ A @ ( suc @ N ) ) @ ( power_power_int @ B @ ( suc @ N ) ) )
     => ( ( ord_less_eq_int @ zero_zero_int @ B )
       => ( ord_less_eq_int @ A @ B ) ) ) )).

% power_le_imp_le_base
thf(fact_53_power__le__imp__le__base,axiom,(
    ! [A: nat,N: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( power_power_nat @ A @ ( suc @ N ) ) @ ( power_power_nat @ B @ ( suc @ N ) ) )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ A @ B ) ) ) )).

% power_le_imp_le_base
thf(fact_54_power__inject__base,axiom,(
    ! [A: int,N: nat,B: int] :
      ( ( ( power_power_int @ A @ ( suc @ N ) )
        = ( power_power_int @ B @ ( suc @ N ) ) )
     => ( ( ord_less_eq_int @ zero_zero_int @ A )
       => ( ( ord_less_eq_int @ zero_zero_int @ B )
         => ( A = B ) ) ) ) )).

% power_inject_base
thf(fact_55_power__inject__base,axiom,(
    ! [A: nat,N: nat,B: nat] :
      ( ( ( power_power_nat @ A @ ( suc @ N ) )
        = ( power_power_nat @ B @ ( suc @ N ) ) )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
         => ( A = B ) ) ) ) )).

% power_inject_base
thf(fact_56_compare__pow__le__iff,axiom,(
    ! [P: nat,X: int,Y: int] :
      ( ( ord_less_nat @ zero_zero_nat @ P )
     => ( ( ord_less_eq_int @ zero_zero_int @ X )
       => ( ( ord_less_eq_int @ zero_zero_int @ Y )
         => ( ( ord_less_eq_int @ ( power_power_int @ X @ P ) @ ( power_power_int @ Y @ P ) )
            = ( ord_less_eq_int @ X @ Y ) ) ) ) ) )).

% compare_pow_le_iff
thf(fact_57_order__refl,axiom,(
    ! [X: int] :
      ( ord_less_eq_int @ X @ X ) )).

% order_refl
thf(fact_58_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_59_start__value_I1_J,axiom,(
    ! [X: int,P: nat] :
      ( ( ord_less_eq_int @ zero_zero_int @ X )
     => ( ( ord_less_nat @ zero_zero_nat @ P )
       => ( ord_less_eq_int @ X @ ( power_power_int @ ( nthRoo1503232983_value @ X @ P ) @ P ) ) ) ) )).

% start_value(1)
thf(fact_60_start__value__main,axiom,(
    ! [X: int,P: nat] :
      ( ( ord_less_eq_int @ zero_zero_int @ X )
     => ( ( ord_less_nat @ zero_zero_nat @ P )
       => ( ( ord_less_eq_int @ X @ ( power_power_int @ ( nthRoo1503232983_value @ X @ P ) @ P ) )
          & ( ord_less_eq_int @ zero_zero_int @ ( nthRoo1503232983_value @ X @ P ) ) ) ) ) )).

% start_value_main
thf(fact_61_conj__le__cong,axiom,(
    ! [X: int,X2: int,P2: $o,P3: $o] :
      ( ( X = X2 )
     => ( ( ( ord_less_eq_int @ zero_zero_int @ X2 )
         => ( P2 = P3 ) )
       => ( ( ( ord_less_eq_int @ zero_zero_int @ X )
            & P2 )
          = ( ( ord_less_eq_int @ zero_zero_int @ X2 )
            & P3 ) ) ) ) )).

% conj_le_cong
thf(fact_62_nat__power__eq__Suc__0__iff,axiom,(
    ! [X: nat,M: nat] :
      ( ( ( power_power_nat @ X @ M )
        = ( suc @ zero_zero_nat ) )
      = ( ( M = zero_zero_nat )
        | ( X
          = ( suc @ zero_zero_nat ) ) ) ) )).

% nat_power_eq_Suc_0_iff
thf(fact_63_power__Suc__0,axiom,(
    ! [N: nat] :
      ( ( power_power_nat @ ( suc @ zero_zero_nat ) @ N )
      = ( suc @ zero_zero_nat ) ) )).

% power_Suc_0
thf(fact_64_nat__zero__less__power__iff,axiom,(
    ! [X: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( power_power_nat @ X @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ X )
        | ( N = zero_zero_nat ) ) ) )).

% nat_zero_less_power_iff
thf(fact_65_nat__one__le__power,axiom,(
    ! [I: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( suc @ zero_zero_nat ) @ I )
     => ( ord_less_eq_nat @ ( suc @ zero_zero_nat ) @ ( power_power_nat @ I @ N ) ) ) )).

% nat_one_le_power
thf(fact_66_zero__natural_Orsp,axiom,(
    zero_zero_nat = zero_zero_nat )).

% zero_natural.rsp
thf(fact_67_nat__power__less__imp__less,axiom,(
    ! [I: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ I )
     => ( ( ord_less_nat @ ( power_power_nat @ I @ M ) @ ( power_power_nat @ I @ N ) )
       => ( ord_less_nat @ M @ N ) ) ) )).

% nat_power_less_imp_less
thf(fact_68_power__gt__expt,axiom,(
    ! [N: nat,K: nat] :
      ( ( ord_less_nat @ ( suc @ zero_zero_nat ) @ N )
     => ( ord_less_nat @ K @ ( power_power_nat @ N @ K ) ) ) )).

% power_gt_expt
thf(fact_69_dual__order_Oantisym,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_eq_int @ B @ A )
     => ( ( ord_less_eq_int @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_70_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_71_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y2: int,Z: int] : ( Y2 = Z ) )
    = ( ^ [A2: int,B2: int] :
          ( ( ord_less_eq_int @ B2 @ A2 )
          & ( ord_less_eq_int @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_72_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y2: nat,Z: nat] : ( Y2 = Z ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( ord_less_eq_nat @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_73_dual__order_Otrans,axiom,(
    ! [B: int,A: int,C: int] :
      ( ( ord_less_eq_int @ B @ A )
     => ( ( ord_less_eq_int @ C @ B )
       => ( ord_less_eq_int @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_74_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_75_linorder__wlog,axiom,(
    ! [P2: int > int > $o,A: int,B: int] :
      ( ! [A3: int,B3: int] :
          ( ( ord_less_eq_int @ A3 @ B3 )
         => ( P2 @ A3 @ B3 ) )
     => ( ! [A3: int,B3: int] :
            ( ( P2 @ B3 @ A3 )
           => ( P2 @ A3 @ B3 ) )
       => ( P2 @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_76_linorder__wlog,axiom,(
    ! [P2: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A3 @ B3 )
         => ( P2 @ A3 @ B3 ) )
     => ( ! [A3: nat,B3: nat] :
            ( ( P2 @ B3 @ A3 )
           => ( P2 @ A3 @ B3 ) )
       => ( P2 @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_77_dual__order_Orefl,axiom,(
    ! [A: int] :
      ( ord_less_eq_int @ A @ A ) )).

% dual_order.refl
thf(fact_78_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_79_order__trans,axiom,(
    ! [X: int,Y: int,Z2: int] :
      ( ( ord_less_eq_int @ X @ Y )
     => ( ( ord_less_eq_int @ Y @ Z2 )
       => ( ord_less_eq_int @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_80_order__trans,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z2 )
       => ( ord_less_eq_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_81_order__class_Oorder_Oantisym,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_82_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_83_ord__le__eq__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_int @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_84_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_85_ord__eq__le__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( A = B )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ord_less_eq_int @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_86_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_87_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y2: int,Z: int] : ( Y2 = Z ) )
    = ( ^ [A2: int,B2: int] :
          ( ( ord_less_eq_int @ A2 @ B2 )
          & ( ord_less_eq_int @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_88_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y2: nat,Z: nat] : ( Y2 = Z ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( ord_less_eq_nat @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_89_antisym__conv,axiom,(
    ! [Y: int,X: int] :
      ( ( ord_less_eq_int @ Y @ X )
     => ( ( ord_less_eq_int @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_90_antisym__conv,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_91_le__cases3,axiom,(
    ! [X: int,Y: int,Z2: int] :
      ( ( ( ord_less_eq_int @ X @ Y )
       => ~ ( ord_less_eq_int @ Y @ Z2 ) )
     => ( ( ( ord_less_eq_int @ Y @ X )
         => ~ ( ord_less_eq_int @ X @ Z2 ) )
       => ( ( ( ord_less_eq_int @ X @ Z2 )
           => ~ ( ord_less_eq_int @ Z2 @ Y ) )
         => ( ( ( ord_less_eq_int @ Z2 @ Y )
             => ~ ( ord_less_eq_int @ Y @ X ) )
           => ( ( ( ord_less_eq_int @ Y @ Z2 )
               => ~ ( ord_less_eq_int @ Z2 @ X ) )
             => ~ ( ( ord_less_eq_int @ Z2 @ X )
                 => ~ ( ord_less_eq_int @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_92_le__cases3,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y )
       => ~ ( ord_less_eq_nat @ Y @ Z2 ) )
     => ( ( ( ord_less_eq_nat @ Y @ X )
         => ~ ( ord_less_eq_nat @ X @ Z2 ) )
       => ( ( ( ord_less_eq_nat @ X @ Z2 )
           => ~ ( ord_less_eq_nat @ Z2 @ Y ) )
         => ( ( ( ord_less_eq_nat @ Z2 @ Y )
             => ~ ( ord_less_eq_nat @ Y @ X ) )
           => ( ( ( ord_less_eq_nat @ Y @ Z2 )
               => ~ ( ord_less_eq_nat @ Z2 @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z2 @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_93_order_Otrans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ord_less_eq_int @ A @ C ) ) ) )).

% order.trans
thf(fact_94_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_95_le__cases,axiom,(
    ! [X: int,Y: int] :
      ( ~ ( ord_less_eq_int @ X @ Y )
     => ( ord_less_eq_int @ Y @ X ) ) )).

% le_cases
thf(fact_96_le__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% le_cases
thf(fact_97_eq__refl,axiom,(
    ! [X: int,Y: int] :
      ( ( X = Y )
     => ( ord_less_eq_int @ X @ Y ) ) )).

% eq_refl
thf(fact_98_eq__refl,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X = Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% eq_refl
thf(fact_99_linear,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_eq_int @ X @ Y )
      | ( ord_less_eq_int @ Y @ X ) ) )).

% linear
thf(fact_100_linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_eq_nat @ Y @ X ) ) )).

% linear
thf(fact_101_antisym,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_eq_int @ X @ Y )
     => ( ( ord_less_eq_int @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_102_antisym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_103_eq__iff,axiom,
    ( ( ^ [Y2: int,Z: int] : ( Y2 = Z ) )
    = ( ^ [X3: int,Y3: int] :
          ( ( ord_less_eq_int @ X3 @ Y3 )
          & ( ord_less_eq_int @ Y3 @ X3 ) ) ) )).

% eq_iff
thf(fact_104_eq__iff,axiom,
    ( ( ^ [Y2: nat,Z: nat] : ( Y2 = Z ) )
    = ( ^ [X3: nat,Y3: nat] :
          ( ( ord_less_eq_nat @ X3 @ Y3 )
          & ( ord_less_eq_nat @ Y3 @ X3 ) ) ) )).

% eq_iff
thf(fact_105_ord__le__eq__subst,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_106_ord__le__eq__subst,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_107_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_108_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_109_ord__eq__le__subst,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_110_ord__eq__le__subst,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_111_ord__eq__le__subst,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_112_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_113_order__subst2,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_114_order__subst2,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_115_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_116_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_117_order__subst1,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_118_order__subst1,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_119_order__subst1,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_120_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_121_minf_I7_J,axiom,(
    ! [T: int] :
    ? [Z3: int] :
    ! [X5: int] :
      ( ( ord_less_int @ X5 @ Z3 )
     => ~ ( ord_less_int @ T @ X5 ) ) )).

% minf(7)
thf(fact_122_minf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z3 )
     => ~ ( ord_less_nat @ T @ X5 ) ) )).

% minf(7)
thf(fact_123_minf_I5_J,axiom,(
    ! [T: int] :
    ? [Z3: int] :
    ! [X5: int] :
      ( ( ord_less_int @ X5 @ Z3 )
     => ( ord_less_int @ X5 @ T ) ) )).

% minf(5)
thf(fact_124_minf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z3 )
     => ( ord_less_nat @ X5 @ T ) ) )).

% minf(5)
thf(fact_125_minf_I4_J,axiom,(
    ! [T: int] :
    ? [Z3: int] :
    ! [X5: int] :
      ( ( ord_less_int @ X5 @ Z3 )
     => ( X5 != T ) ) )).

% minf(4)
thf(fact_126_minf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z3 )
     => ( X5 != T ) ) )).

% minf(4)
thf(fact_127_minf_I3_J,axiom,(
    ! [T: int] :
    ? [Z3: int] :
    ! [X5: int] :
      ( ( ord_less_int @ X5 @ Z3 )
     => ( X5 != T ) ) )).

% minf(3)
thf(fact_128_minf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z3 )
     => ( X5 != T ) ) )).

% minf(3)
thf(fact_129_minf_I2_J,axiom,(
    ! [P2: int > $o,P3: int > $o,Q: int > $o,Q2: int > $o] :
      ( ? [Z4: int] :
        ! [X4: int] :
          ( ( ord_less_int @ X4 @ Z4 )
         => ( ( P2 @ X4 )
            = ( P3 @ X4 ) ) )
     => ( ? [Z4: int] :
          ! [X4: int] :
            ( ( ord_less_int @ X4 @ Z4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z3: int] :
          ! [X5: int] :
            ( ( ord_less_int @ X5 @ Z3 )
           => ( ( ( P2 @ X5 )
                | ( Q @ X5 ) )
              = ( ( P3 @ X5 )
                | ( Q2 @ X5 ) ) ) ) ) ) )).

% minf(2)
thf(fact_130_minf_I2_J,axiom,(
    ! [P2: nat > $o,P3: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X4: nat] :
          ( ( ord_less_nat @ X4 @ Z4 )
         => ( ( P2 @ X4 )
            = ( P3 @ X4 ) ) )
     => ( ? [Z4: nat] :
          ! [X4: nat] :
            ( ( ord_less_nat @ X4 @ Z4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z3: nat] :
          ! [X5: nat] :
            ( ( ord_less_nat @ X5 @ Z3 )
           => ( ( ( P2 @ X5 )
                | ( Q @ X5 ) )
              = ( ( P3 @ X5 )
                | ( Q2 @ X5 ) ) ) ) ) ) )).

% minf(2)
thf(fact_131_minf_I1_J,axiom,(
    ! [P2: int > $o,P3: int > $o,Q: int > $o,Q2: int > $o] :
      ( ? [Z4: int] :
        ! [X4: int] :
          ( ( ord_less_int @ X4 @ Z4 )
         => ( ( P2 @ X4 )
            = ( P3 @ X4 ) ) )
     => ( ? [Z4: int] :
          ! [X4: int] :
            ( ( ord_less_int @ X4 @ Z4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z3: int] :
          ! [X5: int] :
            ( ( ord_less_int @ X5 @ Z3 )
           => ( ( ( P2 @ X5 )
                & ( Q @ X5 ) )
              = ( ( P3 @ X5 )
                & ( Q2 @ X5 ) ) ) ) ) ) )).

% minf(1)
thf(fact_132_minf_I1_J,axiom,(
    ! [P2: nat > $o,P3: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X4: nat] :
          ( ( ord_less_nat @ X4 @ Z4 )
         => ( ( P2 @ X4 )
            = ( P3 @ X4 ) ) )
     => ( ? [Z4: nat] :
          ! [X4: nat] :
            ( ( ord_less_nat @ X4 @ Z4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z3: nat] :
          ! [X5: nat] :
            ( ( ord_less_nat @ X5 @ Z3 )
           => ( ( ( P2 @ X5 )
                & ( Q @ X5 ) )
              = ( ( P3 @ X5 )
                & ( Q2 @ X5 ) ) ) ) ) ) )).

% minf(1)
thf(fact_133_pinf_I7_J,axiom,(
    ! [T: int] :
    ? [Z3: int] :
    ! [X5: int] :
      ( ( ord_less_int @ Z3 @ X5 )
     => ( ord_less_int @ T @ X5 ) ) )).

% pinf(7)
thf(fact_134_pinf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ( ord_less_nat @ T @ X5 ) ) )).

% pinf(7)
thf(fact_135_pinf_I5_J,axiom,(
    ! [T: int] :
    ? [Z3: int] :
    ! [X5: int] :
      ( ( ord_less_int @ Z3 @ X5 )
     => ~ ( ord_less_int @ X5 @ T ) ) )).

% pinf(5)
thf(fact_136_pinf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ~ ( ord_less_nat @ X5 @ T ) ) )).

% pinf(5)
thf(fact_137_pinf_I4_J,axiom,(
    ! [T: int] :
    ? [Z3: int] :
    ! [X5: int] :
      ( ( ord_less_int @ Z3 @ X5 )
     => ( X5 != T ) ) )).

% pinf(4)
thf(fact_138_pinf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ( X5 != T ) ) )).

% pinf(4)
thf(fact_139_pinf_I3_J,axiom,(
    ! [T: int] :
    ? [Z3: int] :
    ! [X5: int] :
      ( ( ord_less_int @ Z3 @ X5 )
     => ( X5 != T ) ) )).

% pinf(3)
thf(fact_140_pinf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ( X5 != T ) ) )).

% pinf(3)
thf(fact_141_pinf_I2_J,axiom,(
    ! [P2: int > $o,P3: int > $o,Q: int > $o,Q2: int > $o] :
      ( ? [Z4: int] :
        ! [X4: int] :
          ( ( ord_less_int @ Z4 @ X4 )
         => ( ( P2 @ X4 )
            = ( P3 @ X4 ) ) )
     => ( ? [Z4: int] :
          ! [X4: int] :
            ( ( ord_less_int @ Z4 @ X4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z3: int] :
          ! [X5: int] :
            ( ( ord_less_int @ Z3 @ X5 )
           => ( ( ( P2 @ X5 )
                | ( Q @ X5 ) )
              = ( ( P3 @ X5 )
                | ( Q2 @ X5 ) ) ) ) ) ) )).

% pinf(2)
thf(fact_142_pinf_I2_J,axiom,(
    ! [P2: nat > $o,P3: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X4: nat] :
          ( ( ord_less_nat @ Z4 @ X4 )
         => ( ( P2 @ X4 )
            = ( P3 @ X4 ) ) )
     => ( ? [Z4: nat] :
          ! [X4: nat] :
            ( ( ord_less_nat @ Z4 @ X4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z3: nat] :
          ! [X5: nat] :
            ( ( ord_less_nat @ Z3 @ X5 )
           => ( ( ( P2 @ X5 )
                | ( Q @ X5 ) )
              = ( ( P3 @ X5 )
                | ( Q2 @ X5 ) ) ) ) ) ) )).

% pinf(2)
thf(fact_143_pinf_I1_J,axiom,(
    ! [P2: int > $o,P3: int > $o,Q: int > $o,Q2: int > $o] :
      ( ? [Z4: int] :
        ! [X4: int] :
          ( ( ord_less_int @ Z4 @ X4 )
         => ( ( P2 @ X4 )
            = ( P3 @ X4 ) ) )
     => ( ? [Z4: int] :
          ! [X4: int] :
            ( ( ord_less_int @ Z4 @ X4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z3: int] :
          ! [X5: int] :
            ( ( ord_less_int @ Z3 @ X5 )
           => ( ( ( P2 @ X5 )
                & ( Q @ X5 ) )
              = ( ( P3 @ X5 )
                & ( Q2 @ X5 ) ) ) ) ) ) )).

% pinf(1)
thf(fact_144_pinf_I1_J,axiom,(
    ! [P2: nat > $o,P3: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X4: nat] :
          ( ( ord_less_nat @ Z4 @ X4 )
         => ( ( P2 @ X4 )
            = ( P3 @ X4 ) ) )
     => ( ? [Z4: nat] :
          ! [X4: nat] :
            ( ( ord_less_nat @ Z4 @ X4 )
           => ( ( Q @ X4 )
              = ( Q2 @ X4 ) ) )
       => ? [Z3: nat] :
          ! [X5: nat] :
            ( ( ord_less_nat @ Z3 @ X5 )
           => ( ( ( P2 @ X5 )
                & ( Q @ X5 ) )
              = ( ( P3 @ X5 )
                & ( Q2 @ X5 ) ) ) ) ) ) )).

% pinf(1)
thf(fact_145_ord__eq__less__subst,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_146_ord__eq__less__subst,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_147_ord__eq__less__subst,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_148_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_149_ord__less__eq__subst,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_150_ord__less__eq__subst,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_151_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_152_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_153_order__less__subst1,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_154_order__less__subst1,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_155_order__less__subst1,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_156_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_157_order__less__subst2,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_158_order__less__subst2,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_159_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_160_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_161_lt__ex,axiom,(
    ! [X: int] :
    ? [Y4: int] :
      ( ord_less_int @ Y4 @ X ) )).

% lt_ex
thf(fact_162_gt__ex,axiom,(
    ! [X: int] :
    ? [X_1: int] :
      ( ord_less_int @ X @ X_1 ) )).

% gt_ex
thf(fact_163_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_164_neqE,axiom,(
    ! [X: int,Y: int] :
      ( ( X != Y )
     => ( ~ ( ord_less_int @ X @ Y )
       => ( ord_less_int @ Y @ X ) ) ) )).

% neqE
thf(fact_165_neqE,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% neqE
thf(fact_166_neq__iff,axiom,(
    ! [X: int,Y: int] :
      ( ( X != Y )
      = ( ( ord_less_int @ X @ Y )
        | ( ord_less_int @ Y @ X ) ) ) )).

% neq_iff
thf(fact_167_neq__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
      = ( ( ord_less_nat @ X @ Y )
        | ( ord_less_nat @ Y @ X ) ) ) )).

% neq_iff
thf(fact_168_order_Oasym,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ~ ( ord_less_int @ B @ A ) ) )).

% order.asym
thf(fact_169_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_170_less__imp__neq,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_171_less__imp__neq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_172_less__asym,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ~ ( ord_less_int @ Y @ X ) ) )).

% less_asym
thf(fact_173_less__asym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_asym
thf(fact_174_less__asym_H,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ~ ( ord_less_int @ B @ A ) ) )).

% less_asym'
thf(fact_175_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_176_less__trans,axiom,(
    ! [X: int,Y: int,Z2: int] :
      ( ( ord_less_int @ X @ Y )
     => ( ( ord_less_int @ Y @ Z2 )
       => ( ord_less_int @ X @ Z2 ) ) ) )).

% less_trans
thf(fact_177_less__trans,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_trans
thf(fact_178_less__linear,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
      | ( X = Y )
      | ( ord_less_int @ Y @ X ) ) )).

% less_linear
thf(fact_179_less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
      | ( X = Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% less_linear
thf(fact_180_less__irrefl,axiom,(
    ! [X: int] :
      ~ ( ord_less_int @ X @ X ) )).

% less_irrefl
thf(fact_181_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_182_ord__eq__less__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( A = B )
     => ( ( ord_less_int @ B @ C )
       => ( ord_less_int @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_183_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_184_ord__less__eq__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( B = C )
       => ( ord_less_int @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_185_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_186_dual__order_Oasym,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_int @ B @ A )
     => ~ ( ord_less_int @ A @ B ) ) )).

% dual_order.asym
thf(fact_187_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_188_less__imp__not__eq,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_189_less__imp__not__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_190_less__not__sym,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ~ ( ord_less_int @ Y @ X ) ) )).

% less_not_sym
thf(fact_191_less__not__sym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_not_sym
thf(fact_192_less__induct,axiom,(
    ! [P2: nat > $o,A: nat] :
      ( ! [X4: nat] :
          ( ! [Y5: nat] :
              ( ( ord_less_nat @ Y5 @ X4 )
             => ( P2 @ Y5 ) )
         => ( P2 @ X4 ) )
     => ( P2 @ A ) ) )).

% less_induct
thf(fact_193_antisym__conv3,axiom,(
    ! [Y: int,X: int] :
      ( ~ ( ord_less_int @ Y @ X )
     => ( ( ~ ( ord_less_int @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_194_antisym__conv3,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_195_less__imp__not__eq2,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_196_less__imp__not__eq2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_197_less__imp__triv,axiom,(
    ! [X: int,Y: int,P2: $o] :
      ( ( ord_less_int @ X @ Y )
     => ( ( ord_less_int @ Y @ X )
       => P2 ) ) )).

% less_imp_triv
thf(fact_198_less__imp__triv,axiom,(
    ! [X: nat,Y: nat,P2: $o] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ X )
       => P2 ) ) )).

% less_imp_triv
thf(fact_199_linorder__cases,axiom,(
    ! [X: int,Y: int] :
      ( ~ ( ord_less_int @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_int @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_200_linorder__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_201_dual__order_Oirrefl,axiom,(
    ! [A: int] :
      ~ ( ord_less_int @ A @ A ) )).

% dual_order.irrefl
thf(fact_202_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_203_order_Ostrict__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_int @ B @ C )
       => ( ord_less_int @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_204_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_205_less__imp__not__less,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ~ ( ord_less_int @ Y @ X ) ) )).

% less_imp_not_less
thf(fact_206_less__imp__not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_imp_not_less
thf(fact_207_exists__least__iff,axiom,
    ( ( ^ [P4: nat > $o] :
        ? [X6: nat] :
          ( P4 @ X6 ) )
    = ( ^ [P5: nat > $o] :
        ? [N2: nat] :
          ( ( P5 @ N2 )
          & ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ~ ( P5 @ M2 ) ) ) ) )).

% exists_least_iff
thf(fact_208_linorder__less__wlog,axiom,(
    ! [P2: int > int > $o,A: int,B: int] :
      ( ! [A3: int,B3: int] :
          ( ( ord_less_int @ A3 @ B3 )
         => ( P2 @ A3 @ B3 ) )
     => ( ! [A3: int] :
            ( P2 @ A3 @ A3 )
       => ( ! [A3: int,B3: int] :
              ( ( P2 @ B3 @ A3 )
             => ( P2 @ A3 @ B3 ) )
         => ( P2 @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_209_linorder__less__wlog,axiom,(
    ! [P2: nat > nat > $o,A: nat,B: nat] :
      ( ! [A3: nat,B3: nat] :
          ( ( ord_less_nat @ A3 @ B3 )
         => ( P2 @ A3 @ B3 ) )
     => ( ! [A3: nat] :
            ( P2 @ A3 @ A3 )
       => ( ! [A3: nat,B3: nat] :
              ( ( P2 @ B3 @ A3 )
             => ( P2 @ A3 @ B3 ) )
         => ( P2 @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_210_dual__order_Ostrict__trans,axiom,(
    ! [B: int,A: int,C: int] :
      ( ( ord_less_int @ B @ A )
     => ( ( ord_less_int @ C @ B )
       => ( ord_less_int @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_211_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_212_not__less__iff__gr__or__eq,axiom,(
    ! [X: int,Y: int] :
      ( ( ~ ( ord_less_int @ X @ Y ) )
      = ( ( ord_less_int @ Y @ X )
        | ( X = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_213_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ( ord_less_nat @ Y @ X )
        | ( X = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_214_order_Ostrict__implies__not__eq,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_215_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_216_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_int @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_217_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_218_start__value_I2_J,axiom,(
    ! [X: int,P: nat] :
      ( ( ord_less_eq_int @ zero_zero_int @ X )
     => ( ( ord_less_nat @ zero_zero_nat @ P )
       => ( ord_less_eq_int @ zero_zero_int @ ( nthRoo1503232983_value @ X @ P ) ) ) ) )).

% start_value(2)
thf(fact_219_minf_I8_J,axiom,(
    ! [T: int] :
    ? [Z3: int] :
    ! [X5: int] :
      ( ( ord_less_int @ X5 @ Z3 )
     => ~ ( ord_less_eq_int @ T @ X5 ) ) )).

% minf(8)
thf(fact_220_minf_I8_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z3 )
     => ~ ( ord_less_eq_nat @ T @ X5 ) ) )).

% minf(8)
thf(fact_221_minf_I6_J,axiom,(
    ! [T: int] :
    ? [Z3: int] :
    ! [X5: int] :
      ( ( ord_less_int @ X5 @ Z3 )
     => ( ord_less_eq_int @ X5 @ T ) ) )).

% minf(6)
thf(fact_222_minf_I6_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z3 )
     => ( ord_less_eq_nat @ X5 @ T ) ) )).

% minf(6)
thf(fact_223_pinf_I8_J,axiom,(
    ! [T: int] :
    ? [Z3: int] :
    ! [X5: int] :
      ( ( ord_less_int @ Z3 @ X5 )
     => ( ord_less_eq_int @ T @ X5 ) ) )).

% pinf(8)
thf(fact_224_pinf_I8_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ( ord_less_eq_nat @ T @ X5 ) ) )).

% pinf(8)
thf(fact_225_pinf_I6_J,axiom,(
    ! [T: int] :
    ? [Z3: int] :
    ! [X5: int] :
      ( ( ord_less_int @ Z3 @ X5 )
     => ~ ( ord_less_eq_int @ X5 @ T ) ) )).

% pinf(6)
thf(fact_226_pinf_I6_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ~ ( ord_less_eq_nat @ X5 @ T ) ) )).

% pinf(6)
thf(fact_227_leD,axiom,(
    ! [Y: int,X: int] :
      ( ( ord_less_eq_int @ Y @ X )
     => ~ ( ord_less_int @ X @ Y ) ) )).

% leD
thf(fact_228_leD,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ~ ( ord_less_nat @ X @ Y ) ) )).

% leD
thf(fact_229_leI,axiom,(
    ! [X: int,Y: int] :
      ( ~ ( ord_less_int @ X @ Y )
     => ( ord_less_eq_int @ Y @ X ) ) )).

% leI
thf(fact_230_leI,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% leI
thf(fact_231_le__less,axiom,
    ( ord_less_eq_int
    = ( ^ [X3: int,Y3: int] :
          ( ( ord_less_int @ X3 @ Y3 )
          | ( X3 = Y3 ) ) ) )).

% le_less
thf(fact_232_le__less,axiom,
    ( ord_less_eq_nat
    = ( ^ [X3: nat,Y3: nat] :
          ( ( ord_less_nat @ X3 @ Y3 )
          | ( X3 = Y3 ) ) ) )).

% le_less
thf(fact_233_less__le,axiom,
    ( ord_less_int
    = ( ^ [X3: int,Y3: int] :
          ( ( ord_less_eq_int @ X3 @ Y3 )
          & ( X3 != Y3 ) ) ) )).

% less_le
thf(fact_234_less__le,axiom,
    ( ord_less_nat
    = ( ^ [X3: nat,Y3: nat] :
          ( ( ord_less_eq_nat @ X3 @ Y3 )
          & ( X3 != Y3 ) ) ) )).

% less_le
thf(fact_235_order__le__less__subst1,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_236_order__le__less__subst1,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_237_order__le__less__subst1,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_238_order__le__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_239_order__le__less__subst2,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_240_order__le__less__subst2,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_241_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_242_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_243_order__less__le__subst1,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_244_order__less__le__subst1,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_eq_int @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_245_order__less__le__subst1,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_246_order__less__le__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X4 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_247_order__less__le__subst2,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_248_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_int @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_249_order__less__le__subst2,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X4: int,Y4: int] :
              ( ( ord_less_int @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_250_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X4: nat,Y4: nat] :
              ( ( ord_less_nat @ X4 @ Y4 )
             => ( ord_less_nat @ ( F @ X4 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_251_not__le,axiom,(
    ! [X: int,Y: int] :
      ( ( ~ ( ord_less_eq_int @ X @ Y ) )
      = ( ord_less_int @ Y @ X ) ) )).

% not_le
thf(fact_252_not__le,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_eq_nat @ X @ Y ) )
      = ( ord_less_nat @ Y @ X ) ) )).

% not_le
thf(fact_253_not__less,axiom,(
    ! [X: int,Y: int] :
      ( ( ~ ( ord_less_int @ X @ Y ) )
      = ( ord_less_eq_int @ Y @ X ) ) )).

% not_less
thf(fact_254_not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ord_less_eq_nat @ Y @ X ) ) )).

% not_less
thf(fact_255_le__neq__trans,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( A != B )
       => ( ord_less_int @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_256_le__neq__trans,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( A != B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_257_antisym__conv1,axiom,(
    ! [X: int,Y: int] :
      ( ~ ( ord_less_int @ X @ Y )
     => ( ( ord_less_eq_int @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv1
thf(fact_258_antisym__conv1,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv1
thf(fact_259_antisym__conv2,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_eq_int @ X @ Y )
     => ( ( ~ ( ord_less_int @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv2
thf(fact_260_antisym__conv2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv2
thf(fact_261_less__imp__le,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( ord_less_eq_int @ X @ Y ) ) )).

% less_imp_le
thf(fact_262_less__imp__le,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% less_imp_le
thf(fact_263_le__less__trans,axiom,(
    ! [X: int,Y: int,Z2: int] :
      ( ( ord_less_eq_int @ X @ Y )
     => ( ( ord_less_int @ Y @ Z2 )
       => ( ord_less_int @ X @ Z2 ) ) ) )).

% le_less_trans
thf(fact_264_le__less__trans,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% le_less_trans
thf(fact_265_less__le__trans,axiom,(
    ! [X: int,Y: int,Z2: int] :
      ( ( ord_less_int @ X @ Y )
     => ( ( ord_less_eq_int @ Y @ Z2 )
       => ( ord_less_int @ X @ Z2 ) ) ) )).

% less_le_trans
thf(fact_266_less__le__trans,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_le_trans
thf(fact_267_fixed__root_Ointro,axiom,(
    ! [P: nat,Pm: nat] :
      ( ( P
        = ( suc @ Pm ) )
     => ( nthRoo1352626670d_root @ P @ Pm ) ) )).

% fixed_root.intro
thf(fact_268_fixed__root__def,axiom,
    ( nthRoo1352626670d_root
    = ( ^ [P6: nat,Pm2: nat] :
          ( P6
          = ( suc @ Pm2 ) ) ) )).

% fixed_root_def
thf(fact_269_fixed__root_Op,axiom,(
    ! [P: nat,Pm: nat] :
      ( ( nthRoo1352626670d_root @ P @ Pm )
     => ( P
        = ( suc @ Pm ) ) ) )).

% fixed_root.p
thf(fact_270_imp__le__cong,axiom,(
    ! [X: int,X2: int,P2: $o,P3: $o] :
      ( ( X = X2 )
     => ( ( ( ord_less_eq_int @ zero_zero_int @ X2 )
         => ( P2 = P3 ) )
       => ( ( ( ord_less_eq_int @ zero_zero_int @ X )
           => P2 )
          = ( ( ord_less_eq_int @ zero_zero_int @ X2 )
           => P3 ) ) ) ) )).

% imp_le_cong
thf(fact_271_less__Suc0,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ N @ ( suc @ zero_zero_nat ) )
      = ( N = zero_zero_nat ) ) )).

% less_Suc0
thf(fact_272_zero__less__Suc,axiom,(
    ! [N: nat] :
      ( ord_less_nat @ zero_zero_nat @ ( suc @ N ) ) )).

% zero_less_Suc
thf(fact_273_lessI,axiom,(
    ! [N: nat] :
      ( ord_less_nat @ N @ ( suc @ N ) ) )).

% lessI
thf(fact_274_Suc__mono,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_nat @ ( suc @ M ) @ ( suc @ N ) ) ) )).

% Suc_mono
thf(fact_275_Suc__less__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( ord_less_nat @ M @ N ) ) )).

% Suc_less_eq
thf(fact_276_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_277_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_278_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_279_nat_Oinject,axiom,(
    ! [X22: nat,Y22: nat] :
      ( ( ( suc @ X22 )
        = ( suc @ Y22 ) )
      = ( X22 = Y22 ) ) )).

% nat.inject
thf(fact_280_old_Onat_Oinject,axiom,(
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) )).

% old.nat.inject
thf(fact_281_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_282_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_283_Suc__le__mono,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_eq_nat @ ( suc @ N ) @ ( suc @ M ) )
      = ( ord_less_eq_nat @ N @ M ) ) )).

% Suc_le_mono
thf(fact_284_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_285_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_286_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_287_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_288_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_289_Nat_Oex__has__greatest__nat,axiom,(
    ! [P2: nat > $o,K: nat,B: nat] :
      ( ( P2 @ K )
     => ( ! [Y4: nat] :
            ( ( P2 @ Y4 )
           => ( ord_less_eq_nat @ Y4 @ B ) )
       => ? [X4: nat] :
            ( ( P2 @ X4 )
            & ! [Y5: nat] :
                ( ( P2 @ Y5 )
               => ( ord_less_eq_nat @ Y5 @ X4 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_290_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI
thf(fact_291_bot__nat__0_Oextremum__unique,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
      = ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique
thf(fact_292_le__0__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_0_eq
thf(fact_293_less__eq__nat_Osimps_I1_J,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% less_eq_nat.simps(1)
thf(fact_294_Suc__inject,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ( suc @ X )
        = ( suc @ Y ) )
     => ( X = Y ) ) )).

% Suc_inject
thf(fact_295_n__not__Suc__n,axiom,(
    ! [N: nat] :
      ( N
     != ( suc @ N ) ) )).

% n_not_Suc_n
thf(fact_296_transitive__stepwise__le,axiom,(
    ! [M: nat,N: nat,R: nat > nat > $o] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ! [X4: nat] :
            ( R @ X4 @ X4 )
       => ( ! [X4: nat,Y4: nat,Z3: nat] :
              ( ( R @ X4 @ Y4 )
             => ( ( R @ Y4 @ Z3 )
               => ( R @ X4 @ Z3 ) ) )
         => ( ! [N3: nat] :
                ( R @ N3 @ ( suc @ N3 ) )
           => ( R @ M @ N ) ) ) ) ) )).

% transitive_stepwise_le
thf(fact_297_nat__induct__at__least,axiom,(
    ! [M: nat,N: nat,P2: nat > $o] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( P2 @ M )
       => ( ! [N3: nat] :
              ( ( ord_less_eq_nat @ M @ N3 )
             => ( ( P2 @ N3 )
               => ( P2 @ ( suc @ N3 ) ) ) )
         => ( P2 @ N ) ) ) ) )).

% nat_induct_at_least
thf(fact_298_full__nat__induct,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M3: nat] :
              ( ( ord_less_eq_nat @ ( suc @ M3 ) @ N3 )
             => ( P2 @ M3 ) )
         => ( P2 @ N3 ) )
     => ( P2 @ N ) ) )).

% full_nat_induct
thf(fact_299_not__less__eq__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less_eq_nat @ M @ N ) )
      = ( ord_less_eq_nat @ ( suc @ N ) @ M ) ) )).

% not_less_eq_eq
thf(fact_300_Suc__n__not__le__n,axiom,(
    ! [N: nat] :
      ~ ( ord_less_eq_nat @ ( suc @ N ) @ N ) )).

% Suc_n_not_le_n
thf(fact_301_le__Suc__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ ( suc @ N ) )
      = ( ( ord_less_eq_nat @ M @ N )
        | ( M
          = ( suc @ N ) ) ) ) )).

% le_Suc_eq
thf(fact_302_Suc__le__D,axiom,(
    ! [N: nat,M4: nat] :
      ( ( ord_less_eq_nat @ ( suc @ N ) @ M4 )
     => ? [M5: nat] :
          ( M4
          = ( suc @ M5 ) ) ) )).

% Suc_le_D
thf(fact_303_le__SucI,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ ( suc @ N ) ) ) )).

% le_SucI
thf(fact_304_le__SucE,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less_eq_nat @ M @ N )
       => ( M
          = ( suc @ N ) ) ) ) )).

% le_SucE
thf(fact_305_Suc__leD,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( suc @ M ) @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% Suc_leD
thf(fact_306_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_nat @ I2 @ J2 )
         => ( ord_less_nat @ ( F @ I2 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I @ J )
       => ( ord_less_eq_nat @ ( F @ I ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_307_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_308_linorder__neqE__nat,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_309_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_310_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M2: nat,N2: nat] :
          ( ( ord_less_nat @ M2 @ N2 )
          | ( M2 = N2 ) ) ) )).

% le_eq_less_or_eq
thf(fact_311_infinite__descent,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ~ ( P2 @ N3 )
         => ? [M3: nat] :
              ( ( ord_less_nat @ M3 @ N3 )
              & ~ ( P2 @ M3 ) ) )
     => ( P2 @ N ) ) )).

% infinite_descent
thf(fact_312_nat__less__induct,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M3: nat] :
              ( ( ord_less_nat @ M3 @ N3 )
             => ( P2 @ M3 ) )
         => ( P2 @ N3 ) )
     => ( P2 @ N ) ) )).

% nat_less_induct
thf(fact_313_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_314_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_315_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_316_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_317_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_318_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_319_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M2: nat,N2: nat] :
          ( ( ord_less_eq_nat @ M2 @ N2 )
          & ( M2 != N2 ) ) ) )).

% nat_less_le
thf(fact_320_not0__implies__Suc,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ? [M5: nat] :
          ( N
          = ( suc @ M5 ) ) ) )).

% not0_implies_Suc
thf(fact_321_old_Onat_Oinducts,axiom,(
    ! [P2: nat > $o,Nat: nat] :
      ( ( P2 @ zero_zero_nat )
     => ( ! [Nat3: nat] :
            ( ( P2 @ Nat3 )
           => ( P2 @ ( suc @ Nat3 ) ) )
       => ( P2 @ Nat ) ) ) )).

% old.nat.inducts
thf(fact_322_old_Onat_Oexhaust,axiom,(
    ! [Y: nat] :
      ( ( Y != zero_zero_nat )
     => ~ ! [Nat3: nat] :
            ( Y
           != ( suc @ Nat3 ) ) ) )).

% old.nat.exhaust
thf(fact_323_Zero__not__Suc,axiom,(
    ! [M: nat] :
      ( zero_zero_nat
     != ( suc @ M ) ) )).

% Zero_not_Suc
thf(fact_324_Zero__neq__Suc,axiom,(
    ! [M: nat] :
      ( zero_zero_nat
     != ( suc @ M ) ) )).

% Zero_neq_Suc
thf(fact_325_Suc__neq__Zero,axiom,(
    ! [M: nat] :
      ( ( suc @ M )
     != zero_zero_nat ) )).

% Suc_neq_Zero
thf(fact_326_zero__induct,axiom,(
    ! [P2: nat > $o,K: nat] :
      ( ( P2 @ K )
     => ( ! [N3: nat] :
            ( ( P2 @ ( suc @ N3 ) )
           => ( P2 @ N3 ) )
       => ( P2 @ zero_zero_nat ) ) ) )).

% zero_induct
thf(fact_327_diff__induct,axiom,(
    ! [P2: nat > nat > $o,M: nat,N: nat] :
      ( ! [X4: nat] :
          ( P2 @ X4 @ zero_zero_nat )
     => ( ! [Y4: nat] :
            ( P2 @ zero_zero_nat @ ( suc @ Y4 ) )
       => ( ! [X4: nat,Y4: nat] :
              ( ( P2 @ X4 @ Y4 )
             => ( P2 @ ( suc @ X4 ) @ ( suc @ Y4 ) ) )
         => ( P2 @ M @ N ) ) ) ) )).

% diff_induct
thf(fact_328_nat__induct,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ( P2 @ zero_zero_nat )
     => ( ! [N3: nat] :
            ( ( P2 @ N3 )
           => ( P2 @ ( suc @ N3 ) ) )
       => ( P2 @ N ) ) ) )).

% nat_induct
thf(fact_329_nat_OdiscI,axiom,(
    ! [Nat: nat,X22: nat] :
      ( ( Nat
        = ( suc @ X22 ) )
     => ( Nat != zero_zero_nat ) ) )).

% nat.discI
thf(fact_330_old_Onat_Odistinct_I1_J,axiom,(
    ! [Nat2: nat] :
      ( zero_zero_nat
     != ( suc @ Nat2 ) ) )).

% old.nat.distinct(1)
thf(fact_331_old_Onat_Odistinct_I2_J,axiom,(
    ! [Nat2: nat] :
      ( ( suc @ Nat2 )
     != zero_zero_nat ) )).

% old.nat.distinct(2)
thf(fact_332_nat_Odistinct_I1_J,axiom,(
    ! [X22: nat] :
      ( zero_zero_nat
     != ( suc @ X22 ) ) )).

% nat.distinct(1)
thf(fact_333_bot__nat__0_Oextremum__strict,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ zero_zero_nat ) )).

% bot_nat_0.extremum_strict
thf(fact_334_infinite__descent0,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ( P2 @ zero_zero_nat )
     => ( ! [N3: nat] :
            ( ( ord_less_nat @ zero_zero_nat @ N3 )
           => ( ~ ( P2 @ N3 )
             => ? [M3: nat] :
                  ( ( ord_less_nat @ M3 @ N3 )
                  & ~ ( P2 @ M3 ) ) ) )
       => ( P2 @ N ) ) ) )).

% infinite_descent0
thf(fact_335_gr__implies__not0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not0
thf(fact_336_ex__least__nat__le,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ( P2 @ N )
     => ( ~ ( P2 @ zero_zero_nat )
       => ? [K2: nat] :
            ( ( ord_less_eq_nat @ K2 @ N )
            & ! [I3: nat] :
                ( ( ord_less_nat @ I3 @ K2 )
               => ~ ( P2 @ I3 ) )
            & ( P2 @ K2 ) ) ) ) )).

% ex_least_nat_le
thf(fact_337_less__zeroE,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_zeroE
thf(fact_338_not__less0,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less0
thf(fact_339_not__gr0,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr0
thf(fact_340_gr0I,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr0I
thf(fact_341_not__less__less__Suc__eq,axiom,(
    ! [N: nat,M: nat] :
      ( ~ ( ord_less_nat @ N @ M )
     => ( ( ord_less_nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) )).

% not_less_less_Suc_eq
thf(fact_342_strict__inc__induct,axiom,(
    ! [I: nat,J: nat,P2: nat > $o] :
      ( ( ord_less_nat @ I @ J )
     => ( ! [I2: nat] :
            ( ( J
              = ( suc @ I2 ) )
           => ( P2 @ I2 ) )
       => ( ! [I2: nat] :
              ( ( ord_less_nat @ I2 @ J )
             => ( ( P2 @ ( suc @ I2 ) )
               => ( P2 @ I2 ) ) )
         => ( P2 @ I ) ) ) ) )).

% strict_inc_induct
thf(fact_343_less__Suc__induct,axiom,(
    ! [I: nat,J: nat,P2: nat > nat > $o] :
      ( ( ord_less_nat @ I @ J )
     => ( ! [I2: nat] :
            ( P2 @ I2 @ ( suc @ I2 ) )
       => ( ! [I2: nat,J2: nat,K2: nat] :
              ( ( ord_less_nat @ I2 @ J2 )
             => ( ( ord_less_nat @ J2 @ K2 )
               => ( ( P2 @ I2 @ J2 )
                 => ( ( P2 @ J2 @ K2 )
                   => ( P2 @ I2 @ K2 ) ) ) ) )
         => ( P2 @ I @ J ) ) ) ) )).

% less_Suc_induct
thf(fact_344_le__imp__less__Suc,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_nat @ M @ ( suc @ N ) ) ) )).

% le_imp_less_Suc
thf(fact_345_less__trans__Suc,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ( ord_less_nat @ J @ K )
       => ( ord_less_nat @ ( suc @ I ) @ K ) ) ) )).

% less_trans_Suc
thf(fact_346_less__eq__Suc__le,axiom,
    ( ord_less_nat
    = ( ^ [N2: nat] :
          ( ord_less_eq_nat @ ( suc @ N2 ) ) ) )).

% less_eq_Suc_le

% Conjectures (1)
thf(conj_0,conjecture,(
    ord_less_int @ zero_zero_int @ x )).

%------------------------------------------------------------------------------
