%------------------------------------------------------------------------------
% File     : SLH376^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer ListSlice problem prob_229__5618588_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : ListSlice/prob_229__5618588_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  218 (   1 unit;  11 type;   0 defn)
%            Number of atoms       : 1920 ( 163 equality;1183 variable)
%            Maximal formula depth :   18 (   7 average)
%            Number of connectives : 1484 (  97   ~;  22   |;  24   &;1061   @)
%                                         (   0 <=>; 280  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   59 (  59   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   14 (  11   :;   0   =)
%            Number of variables   :  543 (   0 sgn; 473   !;  30   ?;  40   ^)
%                                         ( 543   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:32:59.449
%------------------------------------------------------------------------------
% Could-be-implicit typings (2)
thf(ty_n_t__List__Olist_Itf__a_J,type,(
    list_a: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (9)
thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Nat_Osize__class_Osize_001t__List__Olist_Itf__a_J,type,(
    size_size_list_a: list_a > nat )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Rings_Odivide__class_Odivide_001t__Nat__Onat,type,(
    divide_divide_nat: nat > nat > nat )).

thf(sy_c_Rings_Omodulo__class_Omodulo_001t__Nat__Onat,type,(
    modulo_modulo_nat: nat > nat > nat )).

thf(sy_v_k,type,(
    k: nat )).

thf(sy_v_n,type,(
    n: nat )).

thf(sy_v_xs,type,(
    xs: list_a )).

% Relevant facts (202)
thf(fact_0_div__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ( divide_divide_nat @ M @ N )
        = zero_zero_nat ) ) )).

% div_less
thf(fact_1_bits__mod__div__trivial,axiom,(
    ! [A: nat,B: nat] :
      ( ( divide_divide_nat @ ( modulo_modulo_nat @ A @ B ) @ B )
      = zero_zero_nat ) )).

% bits_mod_div_trivial
thf(fact_2_mod__div__trivial,axiom,(
    ! [A: nat,B: nat] :
      ( ( divide_divide_nat @ ( modulo_modulo_nat @ A @ B ) @ B )
      = zero_zero_nat ) )).

% mod_div_trivial
thf(fact_3_mod__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ( modulo_modulo_nat @ M @ N )
        = M ) ) )).

% mod_less
thf(fact_4_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_5_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_6_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_7_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_8_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_9_mod__0,axiom,(
    ! [A: nat] :
      ( ( modulo_modulo_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% mod_0
thf(fact_10_mod__by__0,axiom,(
    ! [A: nat] :
      ( ( modulo_modulo_nat @ A @ zero_zero_nat )
      = A ) )).

% mod_by_0
thf(fact_11_mod__self,axiom,(
    ! [A: nat] :
      ( ( modulo_modulo_nat @ A @ A )
      = zero_zero_nat ) )).

% mod_self
thf(fact_12_mod__mod__trivial,axiom,(
    ! [A: nat,B: nat] :
      ( ( modulo_modulo_nat @ ( modulo_modulo_nat @ A @ B ) @ B )
      = ( modulo_modulo_nat @ A @ B ) ) )).

% mod_mod_trivial
thf(fact_13_bits__div__by__0,axiom,(
    ! [A: nat] :
      ( ( divide_divide_nat @ A @ zero_zero_nat )
      = zero_zero_nat ) )).

% bits_div_by_0
thf(fact_14_bits__div__0,axiom,(
    ! [A: nat] :
      ( ( divide_divide_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% bits_div_0
thf(fact_15_div__by__0,axiom,(
    ! [A: nat] :
      ( ( divide_divide_nat @ A @ zero_zero_nat )
      = zero_zero_nat ) )).

% div_by_0
thf(fact_16_div__0,axiom,(
    ! [A: nat] :
      ( ( divide_divide_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% div_0
thf(fact_17_bits__mod__0,axiom,(
    ! [A: nat] :
      ( ( modulo_modulo_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% bits_mod_0
thf(fact_18_linorder__neqE__nat,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_19_infinite__descent,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P @ N2 )
         => ? [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
              & ~ ( P @ M2 ) ) )
     => ( P @ N ) ) )).

% infinite_descent
thf(fact_20_nat__less__induct,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ( P @ M2 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) )).

% nat_less_induct
thf(fact_21_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_22_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_23_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_24_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_25_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_26_Nat_Oex__has__greatest__nat,axiom,(
    ! [P: nat > $o,K: nat,B: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq_nat @ Y2 @ B ) )
       => ? [X2: nat] :
            ( ( P @ X2 )
            & ! [Y3: nat] :
                ( ( P @ Y3 )
               => ( ord_less_eq_nat @ Y3 @ X2 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_27_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_28_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_29_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_30_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_31_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_32_size__neq__size__imp__neq,axiom,(
    ! [X: list_a,Y: list_a] :
      ( ( ( size_size_list_a @ X )
       != ( size_size_list_a @ Y ) )
     => ( X != Y ) ) )).

% size_neq_size_imp_neq
thf(fact_33_bot__nat__0_Oextremum__strict,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ zero_zero_nat ) )).

% bot_nat_0.extremum_strict
thf(fact_34_infinite__descent0,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ zero_zero_nat )
     => ( ! [N2: nat] :
            ( ( ord_less_nat @ zero_zero_nat @ N2 )
           => ( ~ ( P @ N2 )
             => ? [M2: nat] :
                  ( ( ord_less_nat @ M2 @ N2 )
                  & ~ ( P @ M2 ) ) ) )
       => ( P @ N ) ) ) )).

% infinite_descent0
thf(fact_35_gr__implies__not0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not0
thf(fact_36_less__zeroE,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_zeroE
thf(fact_37_not__less0,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less0
thf(fact_38_not__gr0,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr0
thf(fact_39_gr0I,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr0I
thf(fact_40_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI
thf(fact_41_bot__nat__0_Oextremum__unique,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
      = ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique
thf(fact_42_le__0__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_0_eq
thf(fact_43_less__eq__nat_Osimps_I1_J,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% less_eq_nat.simps(1)
thf(fact_44_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_nat @ I2 @ J2 )
         => ( ord_less_nat @ ( F @ I2 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I @ J )
       => ( ord_less_eq_nat @ ( F @ I ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_45_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_46_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_47_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M3: nat,N3: nat] :
          ( ( ord_less_nat @ M3 @ N3 )
          | ( M3 = N3 ) ) ) )).

% le_eq_less_or_eq
thf(fact_48_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_49_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M3: nat,N3: nat] :
          ( ( ord_less_eq_nat @ M3 @ N3 )
          & ( M3 != N3 ) ) ) )).

% nat_less_le
thf(fact_50_mod__less__eq__dividend,axiom,(
    ! [M: nat,N: nat] :
      ( ord_less_eq_nat @ ( modulo_modulo_nat @ M @ N ) @ M ) )).

% mod_less_eq_dividend
thf(fact_51_div__le__dividend,axiom,(
    ! [M: nat,N: nat] :
      ( ord_less_eq_nat @ ( divide_divide_nat @ M @ N ) @ M ) )).

% div_le_dividend
thf(fact_52_div__le__mono,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( divide_divide_nat @ M @ K ) @ ( divide_divide_nat @ N @ K ) ) ) )).

% div_le_mono
thf(fact_53_mod__eq__self__iff__div__eq__0,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( modulo_modulo_nat @ A @ B )
        = A )
      = ( ( divide_divide_nat @ A @ B )
        = zero_zero_nat ) ) )).

% mod_eq_self_iff_div_eq_0
thf(fact_54_ex__least__nat__le,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ zero_zero_nat )
       => ? [K2: nat] :
            ( ( ord_less_eq_nat @ K2 @ N )
            & ! [I3: nat] :
                ( ( ord_less_nat @ I3 @ K2 )
               => ~ ( P @ I3 ) )
            & ( P @ K2 ) ) ) ) )).

% ex_least_nat_le
thf(fact_55_mod__less__divisor,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ord_less_nat @ ( modulo_modulo_nat @ M @ N ) @ N ) ) )).

% mod_less_divisor
thf(fact_56_Euclidean__Division_Odiv__eq__0__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( divide_divide_nat @ M @ N )
        = zero_zero_nat )
      = ( ( ord_less_nat @ M @ N )
        | ( N = zero_zero_nat ) ) ) )).

% Euclidean_Division.div_eq_0_iff
thf(fact_57_mod__le__divisor,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ord_less_eq_nat @ ( modulo_modulo_nat @ M @ N ) @ N ) ) )).

% mod_le_divisor
thf(fact_58_div__greater__zero__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( divide_divide_nat @ M @ N ) )
      = ( ( ord_less_eq_nat @ N @ M )
        & ( ord_less_nat @ zero_zero_nat @ N ) ) ) )).

% div_greater_zero_iff
thf(fact_59_div__le__mono2,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ M )
     => ( ( ord_less_eq_nat @ M @ N )
       => ( ord_less_eq_nat @ ( divide_divide_nat @ K @ N ) @ ( divide_divide_nat @ K @ M ) ) ) ) )).

% div_le_mono2
thf(fact_60_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_61_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_62_le__mod__greater__imp__div__less,axiom,(
    ! [A: nat,B: nat,M: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ ( modulo_modulo_nat @ B @ M ) @ ( modulo_modulo_nat @ A @ M ) )
       => ( ord_less_nat @ ( divide_divide_nat @ A @ M ) @ ( divide_divide_nat @ B @ M ) ) ) ) )).

% le_mod_greater_imp_div_less
thf(fact_63_less__mod__ge__imp__div__less,axiom,(
    ! [A: nat,B: nat,M: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( modulo_modulo_nat @ B @ M ) @ ( modulo_modulo_nat @ A @ M ) )
       => ( ord_less_nat @ ( divide_divide_nat @ A @ M ) @ ( divide_divide_nat @ B @ M ) ) ) ) )).

% less_mod_ge_imp_div_less
thf(fact_64_less__mod__0__imp__div__less,axiom,(
    ! [A: nat,B: nat,M: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( modulo_modulo_nat @ B @ M )
          = zero_zero_nat )
       => ( ord_less_nat @ ( divide_divide_nat @ A @ M ) @ ( divide_divide_nat @ B @ M ) ) ) ) )).

% less_mod_0_imp_div_less
thf(fact_65_div__less__mono,axiom,(
    ! [A2: nat,B2: nat,N: nat] :
      ( ( ord_less_nat @ A2 @ B2 )
     => ( ( ord_less_nat @ zero_zero_nat @ N )
       => ( ( ( modulo_modulo_nat @ A2 @ N )
            = zero_zero_nat )
         => ( ( ( modulo_modulo_nat @ B2 @ N )
              = zero_zero_nat )
           => ( ord_less_nat @ ( divide_divide_nat @ A2 @ N ) @ ( divide_divide_nat @ B2 @ N ) ) ) ) ) ) )).

% div_less_mono
thf(fact_66_mod__less__dividend,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ M )
     => ( ( ord_less_eq_nat @ M @ N )
       => ( ord_less_nat @ ( modulo_modulo_nat @ N @ M ) @ N ) ) ) )).

% mod_less_dividend
thf(fact_67_verit__la__disequality,axiom,(
    ! [A: nat,B: nat] :
      ( ( A = B )
      | ~ ( ord_less_eq_nat @ A @ B )
      | ~ ( ord_less_eq_nat @ B @ A ) ) )).

% verit_la_disequality
thf(fact_68_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_69_verit__comp__simplify1_I1_J,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% verit_comp_simplify1(1)
thf(fact_70_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_71_verit__comp__simplify1_I3_J,axiom,(
    ! [B3: nat,A3: nat] :
      ( ( ~ ( ord_less_eq_nat @ B3 @ A3 ) )
      = ( ord_less_nat @ A3 @ B3 ) ) )).

% verit_comp_simplify1(3)
thf(fact_72_gr__zeroI,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_zeroI
thf(fact_73_not__less__zero,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less_zero
thf(fact_74_gr__implies__not__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not_zero
thf(fact_75_zero__less__iff__neq__zero,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( N != zero_zero_nat ) ) )).

% zero_less_iff_neq_zero
thf(fact_76_mod__eq__mod__0__imp__mod__eq,axiom,(
    ! [A: nat,M4: nat,B: nat,M: nat] :
      ( ( ( modulo_modulo_nat @ A @ M4 )
        = ( modulo_modulo_nat @ B @ M4 ) )
     => ( ( ( modulo_modulo_nat @ M4 @ M )
          = zero_zero_nat )
       => ( ( modulo_modulo_nat @ A @ M )
          = ( modulo_modulo_nat @ B @ M ) ) ) ) )).

% mod_eq_mod_0_imp_mod_eq
thf(fact_77_div__eq__0__conv,axiom,(
    ! [N: nat,M: nat] :
      ( ( ( divide_divide_nat @ N @ M )
        = zero_zero_nat )
      = ( ( M = zero_zero_nat )
        | ( ord_less_nat @ N @ M ) ) ) )).

% div_eq_0_conv
thf(fact_78_div__eq__0__conv_H,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ M )
     => ( ( ( divide_divide_nat @ N @ M )
          = zero_zero_nat )
        = ( ord_less_nat @ N @ M ) ) ) )).

% div_eq_0_conv'
thf(fact_79_div__gr__imp__gr__divisor,axiom,(
    ! [X: nat,N: nat,M: nat] :
      ( ( ord_less_nat @ X @ ( divide_divide_nat @ N @ M ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% div_gr_imp_gr_divisor
thf(fact_80_div__le__mod__le__imp__le,axiom,(
    ! [A: nat,M: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( divide_divide_nat @ A @ M ) @ ( divide_divide_nat @ B @ M ) )
     => ( ( ord_less_eq_nat @ ( modulo_modulo_nat @ A @ M ) @ ( modulo_modulo_nat @ B @ M ) )
       => ( ord_less_eq_nat @ A @ B ) ) ) )).

% div_le_mod_le_imp_le
thf(fact_81_unique__euclidean__semiring__numeral__class_Omod__less,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ A @ B )
       => ( ( modulo_modulo_nat @ A @ B )
          = A ) ) ) )).

% unique_euclidean_semiring_numeral_class.mod_less
thf(fact_82_unique__euclidean__semiring__numeral__class_Opos__mod__sign,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ B )
     => ( ord_less_eq_nat @ zero_zero_nat @ ( modulo_modulo_nat @ A @ B ) ) ) )).

% unique_euclidean_semiring_numeral_class.pos_mod_sign
thf(fact_83_unique__euclidean__semiring__numeral__class_Odiv__less,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ A @ B )
       => ( ( divide_divide_nat @ A @ B )
          = zero_zero_nat ) ) ) )).

% unique_euclidean_semiring_numeral_class.div_less
thf(fact_84_div__positive,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( ord_less_nat @ zero_zero_nat @ ( divide_divide_nat @ A @ B ) ) ) ) )).

% div_positive
thf(fact_85_gcd__nat__induct,axiom,(
    ! [P: nat > nat > $o,M: nat,N: nat] :
      ( ! [M5: nat] :
          ( P @ M5 @ zero_zero_nat )
     => ( ! [M5: nat,N2: nat] :
            ( ( ord_less_nat @ zero_zero_nat @ N2 )
           => ( ( P @ N2 @ ( modulo_modulo_nat @ M5 @ N2 ) )
             => ( P @ M5 @ N2 ) ) )
       => ( P @ M @ N ) ) ) )).

% gcd_nat_induct
thf(fact_86_unique__euclidean__semiring__numeral__class_Opos__mod__bound,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ B )
     => ( ord_less_nat @ ( modulo_modulo_nat @ A @ B ) @ B ) ) )).

% unique_euclidean_semiring_numeral_class.pos_mod_bound
thf(fact_87_bezw_Oinduct,axiom,(
    ! [P: nat > nat > $o,A0: nat,A1: nat] :
      ( ! [X2: nat,Y2: nat] :
          ( ( ( Y2 != zero_zero_nat )
           => ( P @ Y2 @ ( modulo_modulo_nat @ X2 @ Y2 ) ) )
         => ( ( ( Y2 != zero_zero_nat )
             => ( P @ Y2 @ ( modulo_modulo_nat @ X2 @ Y2 ) ) )
           => ( ( ( Y2 != zero_zero_nat )
               => ( P @ Y2 @ ( modulo_modulo_nat @ X2 @ Y2 ) ) )
             => ( P @ X2 @ Y2 ) ) ) )
     => ( P @ A0 @ A1 ) ) )).

% bezw.induct
thf(fact_88_unique__euclidean__semiring__numeral__class_Omod__less__eq__dividend,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ord_less_eq_nat @ ( modulo_modulo_nat @ A @ B ) @ A ) ) )).

% unique_euclidean_semiring_numeral_class.mod_less_eq_dividend
thf(fact_89_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_90_nat__gcd_Oinduct,axiom,(
    ! [P: nat > nat > $o,A0: nat,A1: nat] :
      ( ! [X2: nat,Y2: nat] :
          ( ( ( Y2 != zero_zero_nat )
           => ( P @ Y2 @ ( modulo_modulo_nat @ X2 @ Y2 ) ) )
         => ( P @ X2 @ Y2 ) )
     => ( P @ A0 @ A1 ) ) )).

% nat_gcd.induct
thf(fact_91_length__induct,axiom,(
    ! [P: list_a > $o,Xs: list_a] :
      ( ! [Xs2: list_a] :
          ( ! [Ys: list_a] :
              ( ( ord_less_nat @ ( size_size_list_a @ Ys ) @ ( size_size_list_a @ Xs2 ) )
             => ( P @ Ys ) )
         => ( P @ Xs2 ) )
     => ( P @ Xs ) ) )).

% length_induct
thf(fact_92_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_93_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_94_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_95_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_96_eq__iff,axiom,
    ( ( ^ [Y4: nat,Z: nat] : ( Y4 = Z ) )
    = ( ^ [X3: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X3 @ Y5 )
          & ( ord_less_eq_nat @ Y5 @ X3 ) ) ) )).

% eq_iff
thf(fact_97_antisym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_98_linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_eq_nat @ Y @ X ) ) )).

% linear
thf(fact_99_eq__refl,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X = Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% eq_refl
thf(fact_100_le__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% le_cases
thf(fact_101_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_102_le__cases3,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y )
       => ~ ( ord_less_eq_nat @ Y @ Z2 ) )
     => ( ( ( ord_less_eq_nat @ Y @ X )
         => ~ ( ord_less_eq_nat @ X @ Z2 ) )
       => ( ( ( ord_less_eq_nat @ X @ Z2 )
           => ~ ( ord_less_eq_nat @ Z2 @ Y ) )
         => ( ( ( ord_less_eq_nat @ Z2 @ Y )
             => ~ ( ord_less_eq_nat @ Y @ X ) )
           => ( ( ( ord_less_eq_nat @ Y @ Z2 )
               => ~ ( ord_less_eq_nat @ Z2 @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z2 @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_103_antisym__conv,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_104_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: nat,Z: nat] : ( Y4 = Z ) )
    = ( ^ [A4: nat,B4: nat] :
          ( ( ord_less_eq_nat @ A4 @ B4 )
          & ( ord_less_eq_nat @ B4 @ A4 ) ) ) )).

% order_class.order.eq_iff
thf(fact_105_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_106_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_107_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_108_order__trans,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z2 )
       => ( ord_less_eq_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_109_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_110_linorder__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A5: nat,B5: nat] :
          ( ( ord_less_eq_nat @ A5 @ B5 )
         => ( P @ A5 @ B5 ) )
     => ( ! [A5: nat,B5: nat] :
            ( ( P @ B5 @ A5 )
           => ( P @ A5 @ B5 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_111_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_112_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: nat,Z: nat] : ( Y4 = Z ) )
    = ( ^ [A4: nat,B4: nat] :
          ( ( ord_less_eq_nat @ B4 @ A4 )
          & ( ord_less_eq_nat @ A4 @ B4 ) ) ) )).

% dual_order.eq_iff
thf(fact_113_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_114_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_115_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_116_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_117_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_118_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_119_neqE,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% neqE
thf(fact_120_neq__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
      = ( ( ord_less_nat @ X @ Y )
        | ( ord_less_nat @ Y @ X ) ) ) )).

% neq_iff
thf(fact_121_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_122_less__imp__neq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_123_less__asym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_asym
thf(fact_124_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_125_less__trans,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_trans
thf(fact_126_less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
      | ( X = Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% less_linear
thf(fact_127_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_128_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_129_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_130_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_131_less__imp__not__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_132_less__not__sym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_not_sym
thf(fact_133_less__induct,axiom,(
    ! [P: nat > $o,A: nat] :
      ( ! [X2: nat] :
          ( ! [Y3: nat] :
              ( ( ord_less_nat @ Y3 @ X2 )
             => ( P @ Y3 ) )
         => ( P @ X2 ) )
     => ( P @ A ) ) )).

% less_induct
thf(fact_134_antisym__conv3,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_135_less__imp__not__eq2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_136_less__imp__triv,axiom,(
    ! [X: nat,Y: nat,P: $o] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_137_linorder__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_138_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_139_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_140_less__imp__not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_imp_not_less
thf(fact_141_exists__least__iff,axiom,
    ( ( ^ [P2: nat > $o] :
        ? [X4: nat] :
          ( P2 @ X4 ) )
    = ( ^ [P3: nat > $o] :
        ? [N3: nat] :
          ( ( P3 @ N3 )
          & ! [M3: nat] :
              ( ( ord_less_nat @ M3 @ N3 )
             => ~ ( P3 @ M3 ) ) ) ) )).

% exists_least_iff
thf(fact_142_linorder__less__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A5: nat,B5: nat] :
          ( ( ord_less_nat @ A5 @ B5 )
         => ( P @ A5 @ B5 ) )
     => ( ! [A5: nat] :
            ( P @ A5 @ A5 )
       => ( ! [A5: nat,B5: nat] :
              ( ( P @ B5 @ A5 )
             => ( P @ A5 @ B5 ) )
         => ( P @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_143_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_144_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ( ord_less_nat @ Y @ X )
        | ( X = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_145_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_146_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_147_Ex__list__of__length,axiom,(
    ! [N: nat] :
    ? [Xs2: list_a] :
      ( ( size_size_list_a @ Xs2 )
      = N ) )).

% Ex_list_of_length
thf(fact_148_neq__if__length__neq,axiom,(
    ! [Xs: list_a,Ys2: list_a] :
      ( ( ( size_size_list_a @ Xs )
       != ( size_size_list_a @ Ys2 ) )
     => ( Xs != Ys2 ) ) )).

% neq_if_length_neq
thf(fact_149_leD,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ~ ( ord_less_nat @ X @ Y ) ) )).

% leD
thf(fact_150_leI,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% leI
thf(fact_151_le__less,axiom,
    ( ord_less_eq_nat
    = ( ^ [X3: nat,Y5: nat] :
          ( ( ord_less_nat @ X3 @ Y5 )
          | ( X3 = Y5 ) ) ) )).

% le_less
thf(fact_152_less__le,axiom,
    ( ord_less_nat
    = ( ^ [X3: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X3 @ Y5 )
          & ( X3 != Y5 ) ) ) )).

% less_le
thf(fact_153_order__le__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_154_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_155_order__less__le__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_156_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_157_not__le,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_eq_nat @ X @ Y ) )
      = ( ord_less_nat @ Y @ X ) ) )).

% not_le
thf(fact_158_not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ord_less_eq_nat @ Y @ X ) ) )).

% not_less
thf(fact_159_le__neq__trans,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( A != B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_160_antisym__conv1,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv1
thf(fact_161_antisym__conv2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv2
thf(fact_162_less__imp__le,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% less_imp_le
thf(fact_163_le__less__trans,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% le_less_trans
thf(fact_164_less__le__trans,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_le_trans
thf(fact_165_le__less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% le_less_linear
thf(fact_166_le__imp__less__or__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_nat @ X @ Y )
        | ( X = Y ) ) ) )).

% le_imp_less_or_eq
thf(fact_167_less__le__not__le,axiom,
    ( ord_less_nat
    = ( ^ [X3: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X3 @ Y5 )
          & ~ ( ord_less_eq_nat @ Y5 @ X3 ) ) ) )).

% less_le_not_le
thf(fact_168_not__le__imp__less,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_eq_nat @ Y @ X )
     => ( ord_less_nat @ X @ Y ) ) )).

% not_le_imp_less
thf(fact_169_order_Ostrict__trans1,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_170_order_Ostrict__trans2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_171_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [A4: nat,B4: nat] :
          ( ( ord_less_nat @ A4 @ B4 )
          | ( A4 = B4 ) ) ) )).

% order.order_iff_strict
thf(fact_172_order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [A4: nat,B4: nat] :
          ( ( ord_less_eq_nat @ A4 @ B4 )
          & ( A4 != B4 ) ) ) )).

% order.strict_iff_order
thf(fact_173_dual__order_Ostrict__trans1,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_174_dual__order_Ostrict__trans2,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_175_order_Ostrict__implies__order,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_176_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [B4: nat,A4: nat] :
          ( ( ord_less_nat @ B4 @ A4 )
          | ( A4 = B4 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_177_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [B4: nat,A4: nat] :
          ( ( ord_less_eq_nat @ B4 @ A4 )
          & ( A4 != B4 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_178_dual__order_Ostrict__implies__order,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ord_less_eq_nat @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_179_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_180_nat__descend__induct,axiom,(
    ! [N: nat,P: nat > $o,M: nat] :
      ( ! [K2: nat] :
          ( ( ord_less_nat @ N @ K2 )
         => ( P @ K2 ) )
     => ( ! [K2: nat] :
            ( ( ord_less_eq_nat @ K2 @ N )
           => ( ! [I3: nat] :
                  ( ( ord_less_nat @ K2 @ I3 )
                 => ( P @ I3 ) )
             => ( P @ K2 ) ) )
       => ( P @ M ) ) ) )).

% nat_descend_induct
thf(fact_181_gr__implies__gr0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_implies_gr0
thf(fact_182_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_nat @ zero_zero_nat @ zero_zero_nat ) )).

% less_numeral_extra(3)
thf(fact_183_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ zero_zero_nat )).

% le_numeral_extra(3)
thf(fact_184_le__greater__neq__conv,axiom,
    ( ord_less_eq_nat
    = ( ^ [N3: nat,A4: nat] :
        ! [X3: nat] :
          ( ( ord_less_nat @ A4 @ X3 )
         => ( N3 != X3 ) ) ) )).

% le_greater_neq_conv
thf(fact_185_greater__le__neq__conv,axiom,
    ( ord_less_nat
    = ( ^ [A4: nat,N3: nat] :
        ! [X3: nat] :
          ( ( ord_less_eq_nat @ X3 @ A4 )
         => ( N3 != X3 ) ) ) )).

% greater_le_neq_conv
thf(fact_186_less__ge__neq__conv,axiom,
    ( ord_less_nat
    = ( ^ [N3: nat,A4: nat] :
        ! [X3: nat] :
          ( ( ord_less_eq_nat @ A4 @ X3 )
         => ( N3 != X3 ) ) ) )).

% less_ge_neq_conv
thf(fact_187_ge__less__neq__conv,axiom,
    ( ord_less_eq_nat
    = ( ^ [A4: nat,N3: nat] :
        ! [X3: nat] :
          ( ( ord_less_nat @ X3 @ A4 )
         => ( N3 != X3 ) ) ) )).

% ge_less_neq_conv
thf(fact_188_complete__interval,axiom,(
    ! [A: nat,B: nat,P: nat > $o] :
      ( ( ord_less_nat @ A @ B )
     => ( ( P @ A )
       => ( ~ ( P @ B )
         => ? [C2: nat] :
              ( ( ord_less_eq_nat @ A @ C2 )
              & ( ord_less_eq_nat @ C2 @ B )
              & ! [X5: nat] :
                  ( ( ( ord_less_eq_nat @ A @ X5 )
                    & ( ord_less_nat @ X5 @ C2 ) )
                 => ( P @ X5 ) )
              & ! [D: nat] :
                  ( ! [X2: nat] :
                      ( ( ( ord_less_eq_nat @ A @ X2 )
                        & ( ord_less_nat @ X2 @ D ) )
                     => ( P @ X2 ) )
                 => ( ord_less_eq_nat @ D @ C2 ) ) ) ) ) ) )).

% complete_interval
thf(fact_189_pinf_I6_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ~ ( ord_less_eq_nat @ X5 @ T ) ) )).

% pinf(6)
thf(fact_190_minf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z3 )
     => ~ ( ord_less_nat @ T @ X5 ) ) )).

% minf(7)
thf(fact_191_minf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z3 )
     => ( ord_less_nat @ X5 @ T ) ) )).

% minf(5)
thf(fact_192_minf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z3 )
     => ( X5 != T ) ) )).

% minf(4)
thf(fact_193_minf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z3 )
     => ( X5 != T ) ) )).

% minf(3)
thf(fact_194_minf_I2_J,axiom,(
    ! [P: nat > $o,P4: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ X2 @ Z4 )
         => ( ( P @ X2 )
            = ( P4 @ X2 ) ) )
     => ( ? [Z4: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ X2 @ Z4 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z3: nat] :
          ! [X5: nat] :
            ( ( ord_less_nat @ X5 @ Z3 )
           => ( ( ( P @ X5 )
                | ( Q @ X5 ) )
              = ( ( P4 @ X5 )
                | ( Q2 @ X5 ) ) ) ) ) ) )).

% minf(2)
thf(fact_195_minf_I1_J,axiom,(
    ! [P: nat > $o,P4: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ X2 @ Z4 )
         => ( ( P @ X2 )
            = ( P4 @ X2 ) ) )
     => ( ? [Z4: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ X2 @ Z4 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z3: nat] :
          ! [X5: nat] :
            ( ( ord_less_nat @ X5 @ Z3 )
           => ( ( ( P @ X5 )
                & ( Q @ X5 ) )
              = ( ( P4 @ X5 )
                & ( Q2 @ X5 ) ) ) ) ) ) )).

% minf(1)
thf(fact_196_pinf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ( ord_less_nat @ T @ X5 ) ) )).

% pinf(7)
thf(fact_197_pinf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ~ ( ord_less_nat @ X5 @ T ) ) )).

% pinf(5)
thf(fact_198_pinf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ( X5 != T ) ) )).

% pinf(4)
thf(fact_199_pinf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ( X5 != T ) ) )).

% pinf(3)
thf(fact_200_pinf_I2_J,axiom,(
    ! [P: nat > $o,P4: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ Z4 @ X2 )
         => ( ( P @ X2 )
            = ( P4 @ X2 ) ) )
     => ( ? [Z4: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ Z4 @ X2 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z3: nat] :
          ! [X5: nat] :
            ( ( ord_less_nat @ Z3 @ X5 )
           => ( ( ( P @ X5 )
                | ( Q @ X5 ) )
              = ( ( P4 @ X5 )
                | ( Q2 @ X5 ) ) ) ) ) ) )).

% pinf(2)
thf(fact_201_pinf_I1_J,axiom,(
    ! [P: nat > $o,P4: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ Z4 @ X2 )
         => ( ( P @ X2 )
            = ( P4 @ X2 ) ) )
     => ( ? [Z4: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ Z4 @ X2 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z3: nat] :
          ! [X5: nat] :
            ( ( ord_less_nat @ Z3 @ X5 )
           => ( ( ( P @ X5 )
                & ( Q @ X5 ) )
              = ( ( P4 @ X5 )
                & ( Q2 @ X5 ) ) ) ) ) ) )).

% pinf(1)

% Conjectures (5)
thf(conj_0,hypothesis,(
    ord_less_nat @ n @ ( size_size_list_a @ xs ) )).

thf(conj_1,hypothesis,(
    ord_less_nat @ zero_zero_nat @ k )).

thf(conj_2,hypothesis,
    ( ( divide_divide_nat @ ( size_size_list_a @ xs ) @ k )
    = ( divide_divide_nat @ n @ k ) )).

thf(conj_3,hypothesis,(
    ord_less_eq_nat @ ( modulo_modulo_nat @ ( size_size_list_a @ xs ) @ k ) @ ( modulo_modulo_nat @ n @ k ) )).

thf(conj_4,conjecture,(
    $false )).

%------------------------------------------------------------------------------
