%------------------------------------------------------------------------------
% File     : SLH382^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Liouville_Numbers problem prob_288__5868614_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Liouville_Numbers/prob_288__5868614_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  370 (   0 unit;  20 type;   0 defn)
%            Number of atoms       : 3572 ( 233 equality;2276 variable)
%            Maximal formula depth :   18 (   8 average)
%            Number of connectives : 2892 ( 136   ~;  29   |;  35   &;2128   @)
%                                         (   0 <=>; 564  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  112 ( 112   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   22 (  20   :;   0   =)
%            Number of variables   : 1008 (   0 sgn; 931   !;  17   ?;  60   ^)
%                                         (1008   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:42:02.147
%------------------------------------------------------------------------------
% Could-be-implicit typings (3)
thf(ty_n_t__Real__Oreal,type,(
    real: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

thf(ty_n_t__Int__Oint,type,(
    int: $tType )).

% Explicit typings (17)
thf(sy_c_Factorial_Osemiring__char__0__class_Ofact_001t__Int__Oint,type,(
    semiri688227102ct_int: nat > int )).

thf(sy_c_Factorial_Osemiring__char__0__class_Ofact_001t__Nat__Onat,type,(
    semiri50953410ct_nat: nat > nat )).

thf(sy_c_Groups_Oone__class_Oone_001t__Int__Oint,type,(
    one_one_int: int )).

thf(sy_c_Groups_Oone__class_Oone_001t__Nat__Onat,type,(
    one_one_nat: nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Int__Oint,type,(
    zero_zero_int: int )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Liouville__Numbers__Mirabelle__onittbjwdi_Oliouville,type,(
    liouvi1159869758uville: real > ( nat > int ) > ( nat > int ) > $o )).

thf(sy_c_Nat_OSuc,type,(
    suc: nat > nat )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Int__Oint,type,(
    ord_less_int: int > int > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Int__Oint,type,(
    ord_less_eq_int: int > int > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Power_Opower__class_Opower_001t__Int__Oint,type,(
    power_power_int: int > nat > int )).

thf(sy_c_Power_Opower__class_Opower_001t__Nat__Onat,type,(
    power_power_nat: nat > nat > nat )).

thf(sy_v_b,type,(
    b: nat > int )).

thf(sy_v_n____,type,(
    n: nat )).

thf(sy_v_q,type,(
    q: int )).

% Relevant facts (349)
thf(fact_0_assms_I1_J,axiom,(
    ord_less_int @ one_one_int @ q )).

% assms(1)
thf(fact_1_b__def,axiom,
    ( b
    = ( ^ [N: nat] :
          ( power_power_int @ q @ ( semiri50953410ct_nat @ ( suc @ N ) ) ) ) )).

% b_def
thf(fact_2_calculation,axiom,(
    ord_less_int @ one_one_int @ ( power_power_int @ q @ one_one_nat ) )).

% calculation
thf(fact_3_fact__1,axiom,
    ( ( semiri688227102ct_int @ one_one_nat )
    = one_one_int )).

% fact_1
thf(fact_4_fact__1,axiom,
    ( ( semiri50953410ct_nat @ one_one_nat )
    = one_one_nat )).

% fact_1
thf(fact_5_power__one__right,axiom,(
    ! [A: int] :
      ( ( power_power_int @ A @ one_one_nat )
      = A ) )).

% power_one_right
thf(fact_6_power__one__right,axiom,(
    ! [A: nat] :
      ( ( power_power_nat @ A @ one_one_nat )
      = A ) )).

% power_one_right
thf(fact_7_power__one,axiom,(
    ! [N2: nat] :
      ( ( power_power_int @ one_one_int @ N2 )
      = one_one_int ) )).

% power_one
thf(fact_8_power__one,axiom,(
    ! [N2: nat] :
      ( ( power_power_nat @ one_one_nat @ N2 )
      = one_one_nat ) )).

% power_one
thf(fact_9_fact__ge__1,axiom,(
    ! [N2: nat] :
      ( ord_less_eq_int @ one_one_int @ ( semiri688227102ct_int @ N2 ) ) )).

% fact_ge_1
thf(fact_10_fact__ge__1,axiom,(
    ! [N2: nat] :
      ( ord_less_eq_nat @ one_one_nat @ ( semiri50953410ct_nat @ N2 ) ) )).

% fact_ge_1
thf(fact_11_one__le__power,axiom,(
    ! [A: int,N2: nat] :
      ( ( ord_less_eq_int @ one_one_int @ A )
     => ( ord_less_eq_int @ one_one_int @ ( power_power_int @ A @ N2 ) ) ) )).

% one_le_power
thf(fact_12_one__le__power,axiom,(
    ! [A: nat,N2: nat] :
      ( ( ord_less_eq_nat @ one_one_nat @ A )
     => ( ord_less_eq_nat @ one_one_nat @ ( power_power_nat @ A @ N2 ) ) ) )).

% one_le_power
thf(fact_13_power__increasing,axiom,(
    ! [N2: nat,N3: nat,A: int] :
      ( ( ord_less_eq_nat @ N2 @ N3 )
     => ( ( ord_less_eq_int @ one_one_int @ A )
       => ( ord_less_eq_int @ ( power_power_int @ A @ N2 ) @ ( power_power_int @ A @ N3 ) ) ) ) )).

% power_increasing
thf(fact_14_power__increasing,axiom,(
    ! [N2: nat,N3: nat,A: nat] :
      ( ( ord_less_eq_nat @ N2 @ N3 )
     => ( ( ord_less_eq_nat @ one_one_nat @ A )
       => ( ord_less_eq_nat @ ( power_power_nat @ A @ N2 ) @ ( power_power_nat @ A @ N3 ) ) ) ) )).

% power_increasing
thf(fact_15_nat_Oinject,axiom,(
    ! [X2: nat,Y2: nat] :
      ( ( ( suc @ X2 )
        = ( suc @ Y2 ) )
      = ( X2 = Y2 ) ) )).

% nat.inject
thf(fact_16_old_Onat_Oinject,axiom,(
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) )).

% old.nat.inject
thf(fact_17_order__refl,axiom,(
    ! [X: int] :
      ( ord_less_eq_int @ X @ X ) )).

% order_refl
thf(fact_18_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_19_power__increasing__iff,axiom,(
    ! [B: int,X: nat,Y: nat] :
      ( ( ord_less_int @ one_one_int @ B )
     => ( ( ord_less_eq_int @ ( power_power_int @ B @ X ) @ ( power_power_int @ B @ Y ) )
        = ( ord_less_eq_nat @ X @ Y ) ) ) )).

% power_increasing_iff
thf(fact_20_power__increasing__iff,axiom,(
    ! [B: nat,X: nat,Y: nat] :
      ( ( ord_less_nat @ one_one_nat @ B )
     => ( ( ord_less_eq_nat @ ( power_power_nat @ B @ X ) @ ( power_power_nat @ B @ Y ) )
        = ( ord_less_eq_nat @ X @ Y ) ) ) )).

% power_increasing_iff
thf(fact_21_Suc__less__eq,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_nat @ ( suc @ M ) @ ( suc @ N2 ) )
      = ( ord_less_nat @ M @ N2 ) ) )).

% Suc_less_eq
thf(fact_22_Suc__mono,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_nat @ M @ N2 )
     => ( ord_less_nat @ ( suc @ M ) @ ( suc @ N2 ) ) ) )).

% Suc_mono
thf(fact_23_lessI,axiom,(
    ! [N2: nat] :
      ( ord_less_nat @ N2 @ ( suc @ N2 ) ) )).

% lessI
thf(fact_24_Suc__le__mono,axiom,(
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq_nat @ ( suc @ N2 ) @ ( suc @ M ) )
      = ( ord_less_eq_nat @ N2 @ M ) ) )).

% Suc_le_mono
thf(fact_25_power__strict__increasing__iff,axiom,(
    ! [B: int,X: nat,Y: nat] :
      ( ( ord_less_int @ one_one_int @ B )
     => ( ( ord_less_int @ ( power_power_int @ B @ X ) @ ( power_power_int @ B @ Y ) )
        = ( ord_less_nat @ X @ Y ) ) ) )).

% power_strict_increasing_iff
thf(fact_26_power__strict__increasing__iff,axiom,(
    ! [B: nat,X: nat,Y: nat] :
      ( ( ord_less_nat @ one_one_nat @ B )
     => ( ( ord_less_nat @ ( power_power_nat @ B @ X ) @ ( power_power_nat @ B @ Y ) )
        = ( ord_less_nat @ X @ Y ) ) ) )).

% power_strict_increasing_iff
thf(fact_27_power__inject__exp,axiom,(
    ! [A: int,M: nat,N2: nat] :
      ( ( ord_less_int @ one_one_int @ A )
     => ( ( ( power_power_int @ A @ M )
          = ( power_power_int @ A @ N2 ) )
        = ( M = N2 ) ) ) )).

% power_inject_exp
thf(fact_28_power__inject__exp,axiom,(
    ! [A: nat,M: nat,N2: nat] :
      ( ( ord_less_nat @ one_one_nat @ A )
     => ( ( ( power_power_nat @ A @ M )
          = ( power_power_nat @ A @ N2 ) )
        = ( M = N2 ) ) ) )).

% power_inject_exp
thf(fact_29_Suc__leI,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_nat @ M @ N2 )
     => ( ord_less_eq_nat @ ( suc @ M ) @ N2 ) ) )).

% Suc_leI
thf(fact_30_le__refl,axiom,(
    ! [N2: nat] :
      ( ord_less_eq_nat @ N2 @ N2 ) )).

% le_refl
thf(fact_31_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_32_Suc__le__eq,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ ( suc @ M ) @ N2 )
      = ( ord_less_nat @ M @ N2 ) ) )).

% Suc_le_eq
thf(fact_33_eq__imp__le,axiom,(
    ! [M: nat,N2: nat] :
      ( ( M = N2 )
     => ( ord_less_eq_nat @ M @ N2 ) ) )).

% eq_imp_le
thf(fact_34_dec__induct,axiom,(
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( P @ I )
       => ( ! [N4: nat] :
              ( ( ord_less_eq_nat @ I @ N4 )
             => ( ( ord_less_nat @ N4 @ J )
               => ( ( P @ N4 )
                 => ( P @ ( suc @ N4 ) ) ) ) )
         => ( P @ J ) ) ) ) )).

% dec_induct
thf(fact_35_inc__induct,axiom,(
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( P @ J )
       => ( ! [N4: nat] :
              ( ( ord_less_eq_nat @ I @ N4 )
             => ( ( ord_less_nat @ N4 @ J )
               => ( ( P @ ( suc @ N4 ) )
                 => ( P @ N4 ) ) ) )
         => ( P @ I ) ) ) ) )).

% inc_induct
thf(fact_36_le__antisym,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ M @ N2 )
     => ( ( ord_less_eq_nat @ N2 @ M )
       => ( M = N2 ) ) ) )).

% le_antisym
thf(fact_37_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M2: nat,N: nat] :
          ( ( ord_less_eq_nat @ M2 @ N )
          & ( M2 != N ) ) ) )).

% nat_less_le
thf(fact_38_Suc__le__lessD,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ ( suc @ M ) @ N2 )
     => ( ord_less_nat @ M @ N2 ) ) )).

% Suc_le_lessD
thf(fact_39_nat__le__linear,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ M @ N2 )
      | ( ord_less_eq_nat @ N2 @ M ) ) )).

% nat_le_linear
thf(fact_40_le__less__Suc__eq,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ M @ N2 )
     => ( ( ord_less_nat @ N2 @ ( suc @ M ) )
        = ( N2 = M ) ) ) )).

% le_less_Suc_eq
thf(fact_41_less__Suc__eq__le,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_nat @ M @ ( suc @ N2 ) )
      = ( ord_less_eq_nat @ M @ N2 ) ) )).

% less_Suc_eq_le
thf(fact_42_less__eq__Suc__le,axiom,
    ( ord_less_nat
    = ( ^ [N: nat] :
          ( ord_less_eq_nat @ ( suc @ N ) ) ) )).

% less_eq_Suc_le
thf(fact_43_le__imp__less__Suc,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ M @ N2 )
     => ( ord_less_nat @ M @ ( suc @ N2 ) ) ) )).

% le_imp_less_Suc
thf(fact_44_less__imp__le__nat,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_nat @ M @ N2 )
     => ( ord_less_eq_nat @ M @ N2 ) ) )).

% less_imp_le_nat
thf(fact_45_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M2: nat,N: nat] :
          ( ( ord_less_nat @ M2 @ N )
          | ( M2 = N ) ) ) )).

% le_eq_less_or_eq
thf(fact_46_less__or__eq__imp__le,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ( ord_less_nat @ M @ N2 )
        | ( M = N2 ) )
     => ( ord_less_eq_nat @ M @ N2 ) ) )).

% less_or_eq_imp_le
thf(fact_47_Nat_Oex__has__greatest__nat,axiom,(
    ! [P: nat > $o,K: nat,B: nat] :
      ( ( P @ K )
     => ( ! [Y3: nat] :
            ( ( P @ Y3 )
           => ( ord_less_eq_nat @ Y3 @ B ) )
       => ? [X3: nat] :
            ( ( P @ X3 )
            & ! [Y4: nat] :
                ( ( P @ Y4 )
               => ( ord_less_eq_nat @ Y4 @ X3 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_48_le__neq__implies__less,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ M @ N2 )
     => ( ( M != N2 )
       => ( ord_less_nat @ M @ N2 ) ) ) )).

% le_neq_implies_less
thf(fact_49_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_nat @ I2 @ J2 )
         => ( ord_less_nat @ ( F @ I2 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I @ J )
       => ( ord_less_eq_nat @ ( F @ I ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_50_ord__eq__less__subst,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_int @ X3 @ Y3 )
             => ( ord_less_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_51_ord__eq__less__subst,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_int @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_52_ord__eq__less__subst,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_53_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_54_ord__less__eq__subst,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_int @ X3 @ Y3 )
             => ( ord_less_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_55_ord__less__eq__subst,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_int @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_56_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_57_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_58_order__less__subst1,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_int @ X3 @ Y3 )
             => ( ord_less_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_59_order__less__subst1,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_60_order__less__subst1,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_int @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_61_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_62_order__less__subst2,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_int @ X3 @ Y3 )
             => ( ord_less_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_63_order__less__subst2,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_int @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_64_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_65_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_66_lt__ex,axiom,(
    ! [X: int] :
    ? [Y3: int] :
      ( ord_less_int @ Y3 @ X ) )).

% lt_ex
thf(fact_67_gt__ex,axiom,(
    ! [X: int] :
    ? [X_1: int] :
      ( ord_less_int @ X @ X_1 ) )).

% gt_ex
thf(fact_68_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_69_neqE,axiom,(
    ! [X: int,Y: int] :
      ( ( X != Y )
     => ( ~ ( ord_less_int @ X @ Y )
       => ( ord_less_int @ Y @ X ) ) ) )).

% neqE
thf(fact_70_neqE,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% neqE
thf(fact_71_neq__iff,axiom,(
    ! [X: int,Y: int] :
      ( ( X != Y )
      = ( ( ord_less_int @ X @ Y )
        | ( ord_less_int @ Y @ X ) ) ) )).

% neq_iff
thf(fact_72_neq__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
      = ( ( ord_less_nat @ X @ Y )
        | ( ord_less_nat @ Y @ X ) ) ) )).

% neq_iff
thf(fact_73_order_Oasym,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ~ ( ord_less_int @ B @ A ) ) )).

% order.asym
thf(fact_74_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_75_less__imp__neq,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_76_less__imp__neq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_77_less__asym,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ~ ( ord_less_int @ Y @ X ) ) )).

% less_asym
thf(fact_78_less__asym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_asym
thf(fact_79_less__asym_H,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ~ ( ord_less_int @ B @ A ) ) )).

% less_asym'
thf(fact_80_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_81_less__trans,axiom,(
    ! [X: int,Y: int,Z: int] :
      ( ( ord_less_int @ X @ Y )
     => ( ( ord_less_int @ Y @ Z )
       => ( ord_less_int @ X @ Z ) ) ) )).

% less_trans
thf(fact_82_less__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% less_trans
thf(fact_83_less__linear,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
      | ( X = Y )
      | ( ord_less_int @ Y @ X ) ) )).

% less_linear
thf(fact_84_less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
      | ( X = Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% less_linear
thf(fact_85_less__irrefl,axiom,(
    ! [X: int] :
      ~ ( ord_less_int @ X @ X ) )).

% less_irrefl
thf(fact_86_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_87_ord__eq__less__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( A = B )
     => ( ( ord_less_int @ B @ C )
       => ( ord_less_int @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_88_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_89_ord__less__eq__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( B = C )
       => ( ord_less_int @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_90_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_91_dual__order_Oasym,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_int @ B @ A )
     => ~ ( ord_less_int @ A @ B ) ) )).

% dual_order.asym
thf(fact_92_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_93_less__imp__not__eq,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_94_less__imp__not__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_95_less__not__sym,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ~ ( ord_less_int @ Y @ X ) ) )).

% less_not_sym
thf(fact_96_less__not__sym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_not_sym
thf(fact_97_less__induct,axiom,(
    ! [P: nat > $o,A: nat] :
      ( ! [X3: nat] :
          ( ! [Y4: nat] :
              ( ( ord_less_nat @ Y4 @ X3 )
             => ( P @ Y4 ) )
         => ( P @ X3 ) )
     => ( P @ A ) ) )).

% less_induct
thf(fact_98_antisym__conv3,axiom,(
    ! [Y: int,X: int] :
      ( ~ ( ord_less_int @ Y @ X )
     => ( ( ~ ( ord_less_int @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_99_antisym__conv3,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_100_less__imp__not__eq2,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_101_less__imp__not__eq2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_102_less__imp__triv,axiom,(
    ! [X: int,Y: int,P: $o] :
      ( ( ord_less_int @ X @ Y )
     => ( ( ord_less_int @ Y @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_103_less__imp__triv,axiom,(
    ! [X: nat,Y: nat,P: $o] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_104_linorder__cases,axiom,(
    ! [X: int,Y: int] :
      ( ~ ( ord_less_int @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_int @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_105_linorder__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_106_dual__order_Oirrefl,axiom,(
    ! [A: int] :
      ~ ( ord_less_int @ A @ A ) )).

% dual_order.irrefl
thf(fact_107_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_108_order_Ostrict__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_int @ B @ C )
       => ( ord_less_int @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_109_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_110_less__imp__not__less,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ~ ( ord_less_int @ Y @ X ) ) )).

% less_imp_not_less
thf(fact_111_less__imp__not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_imp_not_less
thf(fact_112_exists__least__iff,axiom,
    ( ( ^ [P2: nat > $o] :
        ? [X4: nat] :
          ( P2 @ X4 ) )
    = ( ^ [P3: nat > $o] :
        ? [N: nat] :
          ( ( P3 @ N )
          & ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N )
             => ~ ( P3 @ M2 ) ) ) ) )).

% exists_least_iff
thf(fact_113_linorder__less__wlog,axiom,(
    ! [P: int > int > $o,A: int,B: int] :
      ( ! [A2: int,B2: int] :
          ( ( ord_less_int @ A2 @ B2 )
         => ( P @ A2 @ B2 ) )
     => ( ! [A2: int] :
            ( P @ A2 @ A2 )
       => ( ! [A2: int,B2: int] :
              ( ( P @ B2 @ A2 )
             => ( P @ A2 @ B2 ) )
         => ( P @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_114_linorder__less__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A2: nat,B2: nat] :
          ( ( ord_less_nat @ A2 @ B2 )
         => ( P @ A2 @ B2 ) )
     => ( ! [A2: nat] :
            ( P @ A2 @ A2 )
       => ( ! [A2: nat,B2: nat] :
              ( ( P @ B2 @ A2 )
             => ( P @ A2 @ B2 ) )
         => ( P @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_115_dual__order_Ostrict__trans,axiom,(
    ! [B: int,A: int,C: int] :
      ( ( ord_less_int @ B @ A )
     => ( ( ord_less_int @ C @ B )
       => ( ord_less_int @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_116_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_117_not__less__iff__gr__or__eq,axiom,(
    ! [X: int,Y: int] :
      ( ( ~ ( ord_less_int @ X @ Y ) )
      = ( ( ord_less_int @ Y @ X )
        | ( X = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_118_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ( ord_less_nat @ Y @ X )
        | ( X = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_119_order_Ostrict__implies__not__eq,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_120_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_121_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_int @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_122_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_123_lift__Suc__mono__less__iff,axiom,(
    ! [F: nat > int,N2: nat,M: nat] :
      ( ! [N4: nat] :
          ( ord_less_int @ ( F @ N4 ) @ ( F @ ( suc @ N4 ) ) )
     => ( ( ord_less_int @ ( F @ N2 ) @ ( F @ M ) )
        = ( ord_less_nat @ N2 @ M ) ) ) )).

% lift_Suc_mono_less_iff
thf(fact_124_lift__Suc__mono__less__iff,axiom,(
    ! [F: nat > nat,N2: nat,M: nat] :
      ( ! [N4: nat] :
          ( ord_less_nat @ ( F @ N4 ) @ ( F @ ( suc @ N4 ) ) )
     => ( ( ord_less_nat @ ( F @ N2 ) @ ( F @ M ) )
        = ( ord_less_nat @ N2 @ M ) ) ) )).

% lift_Suc_mono_less_iff
thf(fact_125_lift__Suc__mono__less,axiom,(
    ! [F: nat > int,N2: nat,N5: nat] :
      ( ! [N4: nat] :
          ( ord_less_int @ ( F @ N4 ) @ ( F @ ( suc @ N4 ) ) )
     => ( ( ord_less_nat @ N2 @ N5 )
       => ( ord_less_int @ ( F @ N2 ) @ ( F @ N5 ) ) ) ) )).

% lift_Suc_mono_less
thf(fact_126_lift__Suc__mono__less,axiom,(
    ! [F: nat > nat,N2: nat,N5: nat] :
      ( ! [N4: nat] :
          ( ord_less_nat @ ( F @ N4 ) @ ( F @ ( suc @ N4 ) ) )
     => ( ( ord_less_nat @ N2 @ N5 )
       => ( ord_less_nat @ ( F @ N2 ) @ ( F @ N5 ) ) ) ) )).

% lift_Suc_mono_less
thf(fact_127_not__less__less__Suc__eq,axiom,(
    ! [N2: nat,M: nat] :
      ( ~ ( ord_less_nat @ N2 @ M )
     => ( ( ord_less_nat @ N2 @ ( suc @ M ) )
        = ( N2 = M ) ) ) )).

% not_less_less_Suc_eq
thf(fact_128_strict__inc__induct,axiom,(
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less_nat @ I @ J )
     => ( ! [I2: nat] :
            ( ( J
              = ( suc @ I2 ) )
           => ( P @ I2 ) )
       => ( ! [I2: nat] :
              ( ( ord_less_nat @ I2 @ J )
             => ( ( P @ ( suc @ I2 ) )
               => ( P @ I2 ) ) )
         => ( P @ I ) ) ) ) )).

% strict_inc_induct
thf(fact_129_less__Suc__induct,axiom,(
    ! [I: nat,J: nat,P: nat > nat > $o] :
      ( ( ord_less_nat @ I @ J )
     => ( ! [I2: nat] :
            ( P @ I2 @ ( suc @ I2 ) )
       => ( ! [I2: nat,J2: nat,K2: nat] :
              ( ( ord_less_nat @ I2 @ J2 )
             => ( ( ord_less_nat @ J2 @ K2 )
               => ( ( P @ I2 @ J2 )
                 => ( ( P @ J2 @ K2 )
                   => ( P @ I2 @ K2 ) ) ) ) )
         => ( P @ I @ J ) ) ) ) )).

% less_Suc_induct
thf(fact_130_less__trans__Suc,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ( ord_less_nat @ J @ K )
       => ( ord_less_nat @ ( suc @ I ) @ K ) ) ) )).

% less_trans_Suc
thf(fact_131_Suc__less__SucD,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_nat @ ( suc @ M ) @ ( suc @ N2 ) )
     => ( ord_less_nat @ M @ N2 ) ) )).

% Suc_less_SucD
thf(fact_132_less__antisym,axiom,(
    ! [N2: nat,M: nat] :
      ( ~ ( ord_less_nat @ N2 @ M )
     => ( ( ord_less_nat @ N2 @ ( suc @ M ) )
       => ( M = N2 ) ) ) )).

% less_antisym
thf(fact_133_Suc__less__eq2,axiom,(
    ! [N2: nat,M: nat] :
      ( ( ord_less_nat @ ( suc @ N2 ) @ M )
      = ( ? [M3: nat] :
            ( ( M
              = ( suc @ M3 ) )
            & ( ord_less_nat @ N2 @ M3 ) ) ) ) )).

% Suc_less_eq2
thf(fact_134_All__less__Suc,axiom,(
    ! [N2: nat,P: nat > $o] :
      ( ( ! [I3: nat] :
            ( ( ord_less_nat @ I3 @ ( suc @ N2 ) )
           => ( P @ I3 ) ) )
      = ( ( P @ N2 )
        & ! [I3: nat] :
            ( ( ord_less_nat @ I3 @ N2 )
           => ( P @ I3 ) ) ) ) )).

% All_less_Suc
thf(fact_135_not__less__eq,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ~ ( ord_less_nat @ M @ N2 ) )
      = ( ord_less_nat @ N2 @ ( suc @ M ) ) ) )).

% not_less_eq
thf(fact_136_less__Suc__eq,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_nat @ M @ ( suc @ N2 ) )
      = ( ( ord_less_nat @ M @ N2 )
        | ( M = N2 ) ) ) )).

% less_Suc_eq
thf(fact_137_Ex__less__Suc,axiom,(
    ! [N2: nat,P: nat > $o] :
      ( ( ? [I3: nat] :
            ( ( ord_less_nat @ I3 @ ( suc @ N2 ) )
            & ( P @ I3 ) ) )
      = ( ( P @ N2 )
        | ? [I3: nat] :
            ( ( ord_less_nat @ I3 @ N2 )
            & ( P @ I3 ) ) ) ) )).

% Ex_less_Suc
thf(fact_138_less__SucI,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_nat @ M @ N2 )
     => ( ord_less_nat @ M @ ( suc @ N2 ) ) ) )).

% less_SucI
thf(fact_139_less__SucE,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_nat @ M @ ( suc @ N2 ) )
     => ( ~ ( ord_less_nat @ M @ N2 )
       => ( M = N2 ) ) ) )).

% less_SucE
thf(fact_140_Suc__lessI,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_nat @ M @ N2 )
     => ( ( ( suc @ M )
         != N2 )
       => ( ord_less_nat @ ( suc @ M ) @ N2 ) ) ) )).

% Suc_lessI
thf(fact_141_Suc__lessE,axiom,(
    ! [I: nat,K: nat] :
      ( ( ord_less_nat @ ( suc @ I ) @ K )
     => ~ ! [J2: nat] :
            ( ( ord_less_nat @ I @ J2 )
           => ( K
             != ( suc @ J2 ) ) ) ) )).

% Suc_lessE
thf(fact_142_Suc__lessD,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_nat @ ( suc @ M ) @ N2 )
     => ( ord_less_nat @ M @ N2 ) ) )).

% Suc_lessD
thf(fact_143_Nat_OlessE,axiom,(
    ! [I: nat,K: nat] :
      ( ( ord_less_nat @ I @ K )
     => ( ( K
         != ( suc @ I ) )
       => ~ ! [J2: nat] :
              ( ( ord_less_nat @ I @ J2 )
             => ( K
               != ( suc @ J2 ) ) ) ) ) )).

% Nat.lessE
thf(fact_144_transitive__stepwise__le,axiom,(
    ! [M: nat,N2: nat,R: nat > nat > $o] :
      ( ( ord_less_eq_nat @ M @ N2 )
     => ( ! [X3: nat] :
            ( R @ X3 @ X3 )
       => ( ! [X3: nat,Y3: nat,Z2: nat] :
              ( ( R @ X3 @ Y3 )
             => ( ( R @ Y3 @ Z2 )
               => ( R @ X3 @ Z2 ) ) )
         => ( ! [N4: nat] :
                ( R @ N4 @ ( suc @ N4 ) )
           => ( R @ M @ N2 ) ) ) ) ) )).

% transitive_stepwise_le
thf(fact_145_nat__induct__at__least,axiom,(
    ! [M: nat,N2: nat,P: nat > $o] :
      ( ( ord_less_eq_nat @ M @ N2 )
     => ( ( P @ M )
       => ( ! [N4: nat] :
              ( ( ord_less_eq_nat @ M @ N4 )
             => ( ( P @ N4 )
               => ( P @ ( suc @ N4 ) ) ) )
         => ( P @ N2 ) ) ) ) )).

% nat_induct_at_least
thf(fact_146_full__nat__induct,axiom,(
    ! [P: nat > $o,N2: nat] :
      ( ! [N4: nat] :
          ( ! [M4: nat] :
              ( ( ord_less_eq_nat @ ( suc @ M4 ) @ N4 )
             => ( P @ M4 ) )
         => ( P @ N4 ) )
     => ( P @ N2 ) ) )).

% full_nat_induct
thf(fact_147_not__less__eq__eq,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ~ ( ord_less_eq_nat @ M @ N2 ) )
      = ( ord_less_eq_nat @ ( suc @ N2 ) @ M ) ) )).

% not_less_eq_eq
thf(fact_148_Suc__n__not__le__n,axiom,(
    ! [N2: nat] :
      ~ ( ord_less_eq_nat @ ( suc @ N2 ) @ N2 ) )).

% Suc_n_not_le_n
thf(fact_149_le__Suc__eq,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ M @ ( suc @ N2 ) )
      = ( ( ord_less_eq_nat @ M @ N2 )
        | ( M
          = ( suc @ N2 ) ) ) ) )).

% le_Suc_eq
thf(fact_150_Suc__le__D,axiom,(
    ! [N2: nat,M5: nat] :
      ( ( ord_less_eq_nat @ ( suc @ N2 ) @ M5 )
     => ? [M6: nat] :
          ( M5
          = ( suc @ M6 ) ) ) )).

% Suc_le_D
thf(fact_151_le__SucI,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ M @ N2 )
     => ( ord_less_eq_nat @ M @ ( suc @ N2 ) ) ) )).

% le_SucI
thf(fact_152_le__SucE,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ M @ ( suc @ N2 ) )
     => ( ~ ( ord_less_eq_nat @ M @ N2 )
       => ( M
          = ( suc @ N2 ) ) ) ) )).

% le_SucE
thf(fact_153_Suc__leD,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ ( suc @ M ) @ N2 )
     => ( ord_less_eq_nat @ M @ N2 ) ) )).

% Suc_leD
thf(fact_154_fact__mono__nat,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ M @ N2 )
     => ( ord_less_eq_nat @ ( semiri50953410ct_nat @ M ) @ ( semiri50953410ct_nat @ N2 ) ) ) )).

% fact_mono_nat
thf(fact_155_fact__ge__self,axiom,(
    ! [N2: nat] :
      ( ord_less_eq_nat @ N2 @ ( semiri50953410ct_nat @ N2 ) ) )).

% fact_ge_self
thf(fact_156_power__strict__increasing,axiom,(
    ! [N2: nat,N3: nat,A: int] :
      ( ( ord_less_nat @ N2 @ N3 )
     => ( ( ord_less_int @ one_one_int @ A )
       => ( ord_less_int @ ( power_power_int @ A @ N2 ) @ ( power_power_int @ A @ N3 ) ) ) ) )).

% power_strict_increasing
thf(fact_157_power__strict__increasing,axiom,(
    ! [N2: nat,N3: nat,A: nat] :
      ( ( ord_less_nat @ N2 @ N3 )
     => ( ( ord_less_nat @ one_one_nat @ A )
       => ( ord_less_nat @ ( power_power_nat @ A @ N2 ) @ ( power_power_nat @ A @ N3 ) ) ) ) )).

% power_strict_increasing
thf(fact_158_power__less__imp__less__exp,axiom,(
    ! [A: int,M: nat,N2: nat] :
      ( ( ord_less_int @ one_one_int @ A )
     => ( ( ord_less_int @ ( power_power_int @ A @ M ) @ ( power_power_int @ A @ N2 ) )
       => ( ord_less_nat @ M @ N2 ) ) ) )).

% power_less_imp_less_exp
thf(fact_159_power__less__imp__less__exp,axiom,(
    ! [A: nat,M: nat,N2: nat] :
      ( ( ord_less_nat @ one_one_nat @ A )
     => ( ( ord_less_nat @ ( power_power_nat @ A @ M ) @ ( power_power_nat @ A @ N2 ) )
       => ( ord_less_nat @ M @ N2 ) ) ) )).

% power_less_imp_less_exp
thf(fact_160_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: int,B: int] :
      ( ( A != B )
     => ( ( ord_less_eq_int @ A @ B )
       => ( ord_less_int @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_161_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_162_dual__order_Ostrict__implies__order,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_int @ B @ A )
     => ( ord_less_eq_int @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_163_dual__order_Ostrict__implies__order,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ord_less_eq_nat @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_164_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_int
    = ( ^ [B3: int,A3: int] :
          ( ( ord_less_eq_int @ B3 @ A3 )
          & ( A3 != B3 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_165_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [B3: nat,A3: nat] :
          ( ( ord_less_eq_nat @ B3 @ A3 )
          & ( A3 != B3 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_166_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_int
    = ( ^ [B3: int,A3: int] :
          ( ( ord_less_int @ B3 @ A3 )
          | ( A3 = B3 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_167_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [B3: nat,A3: nat] :
          ( ( ord_less_nat @ B3 @ A3 )
          | ( A3 = B3 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_168_order_Ostrict__implies__order,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ( ord_less_eq_int @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_169_order_Ostrict__implies__order,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_170_dual__order_Ostrict__trans2,axiom,(
    ! [B: int,A: int,C: int] :
      ( ( ord_less_int @ B @ A )
     => ( ( ord_less_eq_int @ C @ B )
       => ( ord_less_int @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_171_dual__order_Ostrict__trans2,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_172_dual__order_Ostrict__trans1,axiom,(
    ! [B: int,A: int,C: int] :
      ( ( ord_less_eq_int @ B @ A )
     => ( ( ord_less_int @ C @ B )
       => ( ord_less_int @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_173_dual__order_Ostrict__trans1,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_174_order_Ostrict__iff__order,axiom,
    ( ord_less_int
    = ( ^ [A3: int,B3: int] :
          ( ( ord_less_eq_int @ A3 @ B3 )
          & ( A3 != B3 ) ) ) )).

% order.strict_iff_order
thf(fact_175_order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A3 @ B3 )
          & ( A3 != B3 ) ) ) )).

% order.strict_iff_order
thf(fact_176_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_int
    = ( ^ [A3: int,B3: int] :
          ( ( ord_less_int @ A3 @ B3 )
          | ( A3 = B3 ) ) ) )).

% order.order_iff_strict
thf(fact_177_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [A3: nat,B3: nat] :
          ( ( ord_less_nat @ A3 @ B3 )
          | ( A3 = B3 ) ) ) )).

% order.order_iff_strict
thf(fact_178_order_Ostrict__trans2,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ord_less_int @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_179_order_Ostrict__trans2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_180_order_Ostrict__trans1,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_int @ B @ C )
       => ( ord_less_int @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_181_order_Ostrict__trans1,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_182_not__le__imp__less,axiom,(
    ! [Y: int,X: int] :
      ( ~ ( ord_less_eq_int @ Y @ X )
     => ( ord_less_int @ X @ Y ) ) )).

% not_le_imp_less
thf(fact_183_not__le__imp__less,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_eq_nat @ Y @ X )
     => ( ord_less_nat @ X @ Y ) ) )).

% not_le_imp_less
thf(fact_184_less__le__not__le,axiom,
    ( ord_less_int
    = ( ^ [X5: int,Y5: int] :
          ( ( ord_less_eq_int @ X5 @ Y5 )
          & ~ ( ord_less_eq_int @ Y5 @ X5 ) ) ) )).

% less_le_not_le
thf(fact_185_less__le__not__le,axiom,
    ( ord_less_nat
    = ( ^ [X5: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X5 @ Y5 )
          & ~ ( ord_less_eq_nat @ Y5 @ X5 ) ) ) )).

% less_le_not_le
thf(fact_186_le__imp__less__or__eq,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_eq_int @ X @ Y )
     => ( ( ord_less_int @ X @ Y )
        | ( X = Y ) ) ) )).

% le_imp_less_or_eq
thf(fact_187_le__imp__less__or__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_nat @ X @ Y )
        | ( X = Y ) ) ) )).

% le_imp_less_or_eq
thf(fact_188_le__less__linear,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_eq_int @ X @ Y )
      | ( ord_less_int @ Y @ X ) ) )).

% le_less_linear
thf(fact_189_le__less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% le_less_linear
thf(fact_190_less__le__trans,axiom,(
    ! [X: int,Y: int,Z: int] :
      ( ( ord_less_int @ X @ Y )
     => ( ( ord_less_eq_int @ Y @ Z )
       => ( ord_less_int @ X @ Z ) ) ) )).

% less_le_trans
thf(fact_191_less__le__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% less_le_trans
thf(fact_192_le__less__trans,axiom,(
    ! [X: int,Y: int,Z: int] :
      ( ( ord_less_eq_int @ X @ Y )
     => ( ( ord_less_int @ Y @ Z )
       => ( ord_less_int @ X @ Z ) ) ) )).

% le_less_trans
thf(fact_193_le__less__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% le_less_trans
thf(fact_194_less__imp__le,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( ord_less_eq_int @ X @ Y ) ) )).

% less_imp_le
thf(fact_195_less__imp__le,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% less_imp_le
thf(fact_196_antisym__conv2,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_eq_int @ X @ Y )
     => ( ( ~ ( ord_less_int @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv2
thf(fact_197_antisym__conv2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv2
thf(fact_198_antisym__conv1,axiom,(
    ! [X: int,Y: int] :
      ( ~ ( ord_less_int @ X @ Y )
     => ( ( ord_less_eq_int @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv1
thf(fact_199_antisym__conv1,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv1
thf(fact_200_le__neq__trans,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( A != B )
       => ( ord_less_int @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_201_le__neq__trans,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( A != B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_202_not__less,axiom,(
    ! [X: int,Y: int] :
      ( ( ~ ( ord_less_int @ X @ Y ) )
      = ( ord_less_eq_int @ Y @ X ) ) )).

% not_less
thf(fact_203_not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ord_less_eq_nat @ Y @ X ) ) )).

% not_less
thf(fact_204_not__le,axiom,(
    ! [X: int,Y: int] :
      ( ( ~ ( ord_less_eq_int @ X @ Y ) )
      = ( ord_less_int @ Y @ X ) ) )).

% not_le
thf(fact_205_not__le,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_eq_nat @ X @ Y ) )
      = ( ord_less_nat @ Y @ X ) ) )).

% not_le
thf(fact_206_order__less__le__subst2,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_int @ X3 @ Y3 )
             => ( ord_less_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_207_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_208_order__less__le__subst2,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_int @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_209_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_210_order__less__le__subst1,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_eq_int @ X3 @ Y3 )
             => ( ord_less_eq_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_211_order__less__le__subst1,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_eq_int @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_212_order__less__le__subst1,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_213_order__less__le__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_214_order__le__less__subst2,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_eq_int @ X3 @ Y3 )
             => ( ord_less_eq_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_215_order__le__less__subst2,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_eq_int @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_216_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_217_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_218_order__le__less__subst1,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_int @ X3 @ Y3 )
             => ( ord_less_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_219_order__le__less__subst1,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_220_order__le__less__subst1,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_int @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_221_order__le__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_nat @ X3 @ Y3 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_222_less__le,axiom,
    ( ord_less_int
    = ( ^ [X5: int,Y5: int] :
          ( ( ord_less_eq_int @ X5 @ Y5 )
          & ( X5 != Y5 ) ) ) )).

% less_le
thf(fact_223_less__le,axiom,
    ( ord_less_nat
    = ( ^ [X5: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X5 @ Y5 )
          & ( X5 != Y5 ) ) ) )).

% less_le
thf(fact_224_le__less,axiom,
    ( ord_less_eq_int
    = ( ^ [X5: int,Y5: int] :
          ( ( ord_less_int @ X5 @ Y5 )
          | ( X5 = Y5 ) ) ) )).

% le_less
thf(fact_225_le__less,axiom,
    ( ord_less_eq_nat
    = ( ^ [X5: nat,Y5: nat] :
          ( ( ord_less_nat @ X5 @ Y5 )
          | ( X5 = Y5 ) ) ) )).

% le_less
thf(fact_226_leI,axiom,(
    ! [X: int,Y: int] :
      ( ~ ( ord_less_int @ X @ Y )
     => ( ord_less_eq_int @ Y @ X ) ) )).

% leI
thf(fact_227_leI,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% leI
thf(fact_228_leD,axiom,(
    ! [Y: int,X: int] :
      ( ( ord_less_eq_int @ Y @ X )
     => ~ ( ord_less_int @ X @ Y ) ) )).

% leD
thf(fact_229_leD,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ~ ( ord_less_nat @ X @ Y ) ) )).

% leD
thf(fact_230_dual__order_Oantisym,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_eq_int @ B @ A )
     => ( ( ord_less_eq_int @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_231_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_232_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y6: int,Z3: int] : ( Y6 = Z3 ) )
    = ( ^ [A3: int,B3: int] :
          ( ( ord_less_eq_int @ B3 @ A3 )
          & ( ord_less_eq_int @ A3 @ B3 ) ) ) )).

% dual_order.eq_iff
thf(fact_233_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 ) )
    = ( ^ [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ B3 @ A3 )
          & ( ord_less_eq_nat @ A3 @ B3 ) ) ) )).

% dual_order.eq_iff
thf(fact_234_dual__order_Otrans,axiom,(
    ! [B: int,A: int,C: int] :
      ( ( ord_less_eq_int @ B @ A )
     => ( ( ord_less_eq_int @ C @ B )
       => ( ord_less_eq_int @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_235_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_236_linorder__wlog,axiom,(
    ! [P: int > int > $o,A: int,B: int] :
      ( ! [A2: int,B2: int] :
          ( ( ord_less_eq_int @ A2 @ B2 )
         => ( P @ A2 @ B2 ) )
     => ( ! [A2: int,B2: int] :
            ( ( P @ B2 @ A2 )
           => ( P @ A2 @ B2 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_237_linorder__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
         => ( P @ A2 @ B2 ) )
     => ( ! [A2: nat,B2: nat] :
            ( ( P @ B2 @ A2 )
           => ( P @ A2 @ B2 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_238_dual__order_Orefl,axiom,(
    ! [A: int] :
      ( ord_less_eq_int @ A @ A ) )).

% dual_order.refl
thf(fact_239_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_240_order__trans,axiom,(
    ! [X: int,Y: int,Z: int] :
      ( ( ord_less_eq_int @ X @ Y )
     => ( ( ord_less_eq_int @ Y @ Z )
       => ( ord_less_eq_int @ X @ Z ) ) ) )).

% order_trans
thf(fact_241_order__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z )
       => ( ord_less_eq_nat @ X @ Z ) ) ) )).

% order_trans
thf(fact_242_order__class_Oorder_Oantisym,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_243_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_244_ord__le__eq__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_int @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_245_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_246_ord__eq__le__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( A = B )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ord_less_eq_int @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_247_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_248_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y6: int,Z3: int] : ( Y6 = Z3 ) )
    = ( ^ [A3: int,B3: int] :
          ( ( ord_less_eq_int @ A3 @ B3 )
          & ( ord_less_eq_int @ B3 @ A3 ) ) ) )).

% order_class.order.eq_iff
thf(fact_249_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 ) )
    = ( ^ [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A3 @ B3 )
          & ( ord_less_eq_nat @ B3 @ A3 ) ) ) )).

% order_class.order.eq_iff
thf(fact_250_antisym__conv,axiom,(
    ! [Y: int,X: int] :
      ( ( ord_less_eq_int @ Y @ X )
     => ( ( ord_less_eq_int @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_251_antisym__conv,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_252_le__cases3,axiom,(
    ! [X: int,Y: int,Z: int] :
      ( ( ( ord_less_eq_int @ X @ Y )
       => ~ ( ord_less_eq_int @ Y @ Z ) )
     => ( ( ( ord_less_eq_int @ Y @ X )
         => ~ ( ord_less_eq_int @ X @ Z ) )
       => ( ( ( ord_less_eq_int @ X @ Z )
           => ~ ( ord_less_eq_int @ Z @ Y ) )
         => ( ( ( ord_less_eq_int @ Z @ Y )
             => ~ ( ord_less_eq_int @ Y @ X ) )
           => ( ( ( ord_less_eq_int @ Y @ Z )
               => ~ ( ord_less_eq_int @ Z @ X ) )
             => ~ ( ( ord_less_eq_int @ Z @ X )
                 => ~ ( ord_less_eq_int @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_253_le__cases3,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y )
       => ~ ( ord_less_eq_nat @ Y @ Z ) )
     => ( ( ( ord_less_eq_nat @ Y @ X )
         => ~ ( ord_less_eq_nat @ X @ Z ) )
       => ( ( ( ord_less_eq_nat @ X @ Z )
           => ~ ( ord_less_eq_nat @ Z @ Y ) )
         => ( ( ( ord_less_eq_nat @ Z @ Y )
             => ~ ( ord_less_eq_nat @ Y @ X ) )
           => ( ( ( ord_less_eq_nat @ Y @ Z )
               => ~ ( ord_less_eq_nat @ Z @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_254_order_Otrans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ord_less_eq_int @ A @ C ) ) ) )).

% order.trans
thf(fact_255_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_256_le__cases,axiom,(
    ! [X: int,Y: int] :
      ( ~ ( ord_less_eq_int @ X @ Y )
     => ( ord_less_eq_int @ Y @ X ) ) )).

% le_cases
thf(fact_257_le__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% le_cases
thf(fact_258_eq__refl,axiom,(
    ! [X: int,Y: int] :
      ( ( X = Y )
     => ( ord_less_eq_int @ X @ Y ) ) )).

% eq_refl
thf(fact_259_eq__refl,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X = Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% eq_refl
thf(fact_260_linear,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_eq_int @ X @ Y )
      | ( ord_less_eq_int @ Y @ X ) ) )).

% linear
thf(fact_261_linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_eq_nat @ Y @ X ) ) )).

% linear
thf(fact_262_antisym,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_eq_int @ X @ Y )
     => ( ( ord_less_eq_int @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_263_antisym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_264_eq__iff,axiom,
    ( ( ^ [Y6: int,Z3: int] : ( Y6 = Z3 ) )
    = ( ^ [X5: int,Y5: int] :
          ( ( ord_less_eq_int @ X5 @ Y5 )
          & ( ord_less_eq_int @ Y5 @ X5 ) ) ) )).

% eq_iff
thf(fact_265_eq__iff,axiom,
    ( ( ^ [Y6: nat,Z3: nat] : ( Y6 = Z3 ) )
    = ( ^ [X5: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X5 @ Y5 )
          & ( ord_less_eq_nat @ Y5 @ X5 ) ) ) )).

% eq_iff
thf(fact_266_ord__le__eq__subst,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_eq_int @ X3 @ Y3 )
             => ( ord_less_eq_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_267_ord__le__eq__subst,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_eq_int @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_268_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_269_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_270_ord__eq__le__subst,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_eq_int @ X3 @ Y3 )
             => ( ord_less_eq_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_271_ord__eq__le__subst,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_eq_int @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_272_ord__eq__le__subst,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_273_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_274_order__subst2,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_eq_int @ X3 @ Y3 )
             => ( ord_less_eq_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_275_order__subst2,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_eq_int @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_276_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_277_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_278_order__subst1,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_eq_int @ X3 @ Y3 )
             => ( ord_less_eq_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_279_order__subst1,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_int @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_280_order__subst1,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X3: int,Y3: int] :
              ( ( ord_less_eq_int @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_281_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y3 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_282_one__reorient,axiom,(
    ! [X: nat] :
      ( ( one_one_nat = X )
      = ( X = one_one_nat ) ) )).

% one_reorient
thf(fact_283_one__reorient,axiom,(
    ! [X: int] :
      ( ( one_one_int = X )
      = ( X = one_one_int ) ) )).

% one_reorient
thf(fact_284_n__not__Suc__n,axiom,(
    ! [N2: nat] :
      ( N2
     != ( suc @ N2 ) ) )).

% n_not_Suc_n
thf(fact_285_Suc__inject,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ( suc @ X )
        = ( suc @ Y ) )
     => ( X = Y ) ) )).

% Suc_inject
thf(fact_286_power__le__imp__le__exp,axiom,(
    ! [A: int,M: nat,N2: nat] :
      ( ( ord_less_int @ one_one_int @ A )
     => ( ( ord_less_eq_int @ ( power_power_int @ A @ M ) @ ( power_power_int @ A @ N2 ) )
       => ( ord_less_eq_nat @ M @ N2 ) ) ) )).

% power_le_imp_le_exp
thf(fact_287_power__le__imp__le__exp,axiom,(
    ! [A: nat,M: nat,N2: nat] :
      ( ( ord_less_nat @ one_one_nat @ A )
     => ( ( ord_less_eq_nat @ ( power_power_nat @ A @ M ) @ ( power_power_nat @ A @ N2 ) )
       => ( ord_less_eq_nat @ M @ N2 ) ) ) )).

% power_le_imp_le_exp
thf(fact_288_power__gt1,axiom,(
    ! [A: int,N2: nat] :
      ( ( ord_less_int @ one_one_int @ A )
     => ( ord_less_int @ one_one_int @ ( power_power_int @ A @ ( suc @ N2 ) ) ) ) )).

% power_gt1
thf(fact_289_power__gt1,axiom,(
    ! [A: nat,N2: nat] :
      ( ( ord_less_nat @ one_one_nat @ A )
     => ( ord_less_nat @ one_one_nat @ ( power_power_nat @ A @ ( suc @ N2 ) ) ) ) )).

% power_gt1
thf(fact_290_lift__Suc__antimono__le,axiom,(
    ! [F: nat > int,N2: nat,N5: nat] :
      ( ! [N4: nat] :
          ( ord_less_eq_int @ ( F @ ( suc @ N4 ) ) @ ( F @ N4 ) )
     => ( ( ord_less_eq_nat @ N2 @ N5 )
       => ( ord_less_eq_int @ ( F @ N5 ) @ ( F @ N2 ) ) ) ) )).

% lift_Suc_antimono_le
thf(fact_291_lift__Suc__antimono__le,axiom,(
    ! [F: nat > nat,N2: nat,N5: nat] :
      ( ! [N4: nat] :
          ( ord_less_eq_nat @ ( F @ ( suc @ N4 ) ) @ ( F @ N4 ) )
     => ( ( ord_less_eq_nat @ N2 @ N5 )
       => ( ord_less_eq_nat @ ( F @ N5 ) @ ( F @ N2 ) ) ) ) )).

% lift_Suc_antimono_le
thf(fact_292_lift__Suc__mono__le,axiom,(
    ! [F: nat > int,N2: nat,N5: nat] :
      ( ! [N4: nat] :
          ( ord_less_eq_int @ ( F @ N4 ) @ ( F @ ( suc @ N4 ) ) )
     => ( ( ord_less_eq_nat @ N2 @ N5 )
       => ( ord_less_eq_int @ ( F @ N2 ) @ ( F @ N5 ) ) ) ) )).

% lift_Suc_mono_le
thf(fact_293_lift__Suc__mono__le,axiom,(
    ! [F: nat > nat,N2: nat,N5: nat] :
      ( ! [N4: nat] :
          ( ord_less_eq_nat @ ( F @ N4 ) @ ( F @ ( suc @ N4 ) ) )
     => ( ( ord_less_eq_nat @ N2 @ N5 )
       => ( ord_less_eq_nat @ ( F @ N2 ) @ ( F @ N5 ) ) ) ) )).

% lift_Suc_mono_le
thf(fact_294_fact__mono,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ M @ N2 )
     => ( ord_less_eq_nat @ ( semiri50953410ct_nat @ M ) @ ( semiri50953410ct_nat @ N2 ) ) ) )).

% fact_mono
thf(fact_295_fact__mono,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq_nat @ M @ N2 )
     => ( ord_less_eq_int @ ( semiri688227102ct_int @ M ) @ ( semiri688227102ct_int @ N2 ) ) ) )).

% fact_mono
thf(fact_296_less__numeral__extra_I4_J,axiom,(
    ~ ( ord_less_int @ one_one_int @ one_one_int ) )).

% less_numeral_extra(4)
thf(fact_297_less__numeral__extra_I4_J,axiom,(
    ~ ( ord_less_nat @ one_one_nat @ one_one_nat ) )).

% less_numeral_extra(4)
thf(fact_298_le__numeral__extra_I4_J,axiom,(
    ord_less_eq_int @ one_one_int @ one_one_int )).

% le_numeral_extra(4)
thf(fact_299_le__numeral__extra_I4_J,axiom,(
    ord_less_eq_nat @ one_one_nat @ one_one_nat )).

% le_numeral_extra(4)
thf(fact_300_power__decreasing__iff,axiom,(
    ! [B: int,M: nat,N2: nat] :
      ( ( ord_less_int @ zero_zero_int @ B )
     => ( ( ord_less_int @ B @ one_one_int )
       => ( ( ord_less_eq_int @ ( power_power_int @ B @ M ) @ ( power_power_int @ B @ N2 ) )
          = ( ord_less_eq_nat @ N2 @ M ) ) ) ) )).

% power_decreasing_iff
thf(fact_301_power__decreasing__iff,axiom,(
    ! [B: nat,M: nat,N2: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ B )
     => ( ( ord_less_nat @ B @ one_one_nat )
       => ( ( ord_less_eq_nat @ ( power_power_nat @ B @ M ) @ ( power_power_nat @ B @ N2 ) )
          = ( ord_less_eq_nat @ N2 @ M ) ) ) ) )).

% power_decreasing_iff
thf(fact_302_complete__interval,axiom,(
    ! [A: int,B: int,P: int > $o] :
      ( ( ord_less_int @ A @ B )
     => ( ( P @ A )
       => ( ~ ( P @ B )
         => ? [C2: int] :
              ( ( ord_less_eq_int @ A @ C2 )
              & ( ord_less_eq_int @ C2 @ B )
              & ! [X6: int] :
                  ( ( ( ord_less_eq_int @ A @ X6 )
                    & ( ord_less_int @ X6 @ C2 ) )
                 => ( P @ X6 ) )
              & ! [D: int] :
                  ( ! [X3: int] :
                      ( ( ( ord_less_eq_int @ A @ X3 )
                        & ( ord_less_int @ X3 @ D ) )
                     => ( P @ X3 ) )
                 => ( ord_less_eq_int @ D @ C2 ) ) ) ) ) ) )).

% complete_interval
thf(fact_303_complete__interval,axiom,(
    ! [A: nat,B: nat,P: nat > $o] :
      ( ( ord_less_nat @ A @ B )
     => ( ( P @ A )
       => ( ~ ( P @ B )
         => ? [C2: nat] :
              ( ( ord_less_eq_nat @ A @ C2 )
              & ( ord_less_eq_nat @ C2 @ B )
              & ! [X6: nat] :
                  ( ( ( ord_less_eq_nat @ A @ X6 )
                    & ( ord_less_nat @ X6 @ C2 ) )
                 => ( P @ X6 ) )
              & ! [D: nat] :
                  ( ! [X3: nat] :
                      ( ( ( ord_less_eq_nat @ A @ X3 )
                        & ( ord_less_nat @ X3 @ D ) )
                     => ( P @ X3 ) )
                 => ( ord_less_eq_nat @ D @ C2 ) ) ) ) ) ) )).

% complete_interval
thf(fact_304_verit__comp__simplify1_I3_J,axiom,(
    ! [B4: int,A4: int] :
      ( ( ~ ( ord_less_eq_int @ B4 @ A4 ) )
      = ( ord_less_int @ A4 @ B4 ) ) )).

% verit_comp_simplify1(3)
thf(fact_305_verit__comp__simplify1_I3_J,axiom,(
    ! [B4: nat,A4: nat] :
      ( ( ~ ( ord_less_eq_nat @ B4 @ A4 ) )
      = ( ord_less_nat @ A4 @ B4 ) ) )).

% verit_comp_simplify1(3)
thf(fact_306_pinf_I6_J,axiom,(
    ! [T: int] :
    ? [Z2: int] :
    ! [X6: int] :
      ( ( ord_less_int @ Z2 @ X6 )
     => ~ ( ord_less_eq_int @ X6 @ T ) ) )).

% pinf(6)
thf(fact_307_pinf_I6_J,axiom,(
    ! [T: nat] :
    ? [Z2: nat] :
    ! [X6: nat] :
      ( ( ord_less_nat @ Z2 @ X6 )
     => ~ ( ord_less_eq_nat @ X6 @ T ) ) )).

% pinf(6)
thf(fact_308_pinf_I8_J,axiom,(
    ! [T: nat] :
    ? [Z2: nat] :
    ! [X6: nat] :
      ( ( ord_less_nat @ Z2 @ X6 )
     => ( ord_less_eq_nat @ T @ X6 ) ) )).

% pinf(8)
thf(fact_309_liouville_Odenom__gt__1,axiom,(
    ! [X: real,P4: nat > int,Q: nat > int,N2: nat] :
      ( ( liouvi1159869758uville @ X @ P4 @ Q )
     => ( ord_less_int @ one_one_int @ ( Q @ N2 ) ) ) )).

% liouville.denom_gt_1
thf(fact_310_nat__power__eq__Suc__0__iff,axiom,(
    ! [X: nat,M: nat] :
      ( ( ( power_power_nat @ X @ M )
        = ( suc @ zero_zero_nat ) )
      = ( ( M = zero_zero_nat )
        | ( X
          = ( suc @ zero_zero_nat ) ) ) ) )).

% nat_power_eq_Suc_0_iff
thf(fact_311_power__Suc__0,axiom,(
    ! [N2: nat] :
      ( ( power_power_nat @ ( suc @ zero_zero_nat ) @ N2 )
      = ( suc @ zero_zero_nat ) ) )).

% power_Suc_0
thf(fact_312_neq0__conv,axiom,(
    ! [N2: nat] :
      ( ( N2 != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N2 ) ) )).

% neq0_conv
thf(fact_313_less__nat__zero__code,axiom,(
    ! [N2: nat] :
      ~ ( ord_less_nat @ N2 @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_314_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_315_nat__zero__less__power__iff,axiom,(
    ! [X: nat,N2: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( power_power_nat @ X @ N2 ) )
      = ( ( ord_less_nat @ zero_zero_nat @ X )
        | ( N2 = zero_zero_nat ) ) ) )).

% nat_zero_less_power_iff
thf(fact_316_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_317_le0,axiom,(
    ! [N2: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N2 ) )).

% le0
thf(fact_318_zero__less__Suc,axiom,(
    ! [N2: nat] :
      ( ord_less_nat @ zero_zero_nat @ ( suc @ N2 ) ) )).

% zero_less_Suc
thf(fact_319_less__Suc0,axiom,(
    ! [N2: nat] :
      ( ( ord_less_nat @ N2 @ ( suc @ zero_zero_nat ) )
      = ( N2 = zero_zero_nat ) ) )).

% less_Suc0
thf(fact_320_less__one,axiom,(
    ! [N2: nat] :
      ( ( ord_less_nat @ N2 @ one_one_nat )
      = ( N2 = zero_zero_nat ) ) )).

% less_one
thf(fact_321_gr0I,axiom,(
    ! [N2: nat] :
      ( ( N2 != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N2 ) ) )).

% gr0I
thf(fact_322_not__gr0,axiom,(
    ! [N2: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N2 ) )
      = ( N2 = zero_zero_nat ) ) )).

% not_gr0
thf(fact_323_not__less0,axiom,(
    ! [N2: nat] :
      ~ ( ord_less_nat @ N2 @ zero_zero_nat ) )).

% not_less0
thf(fact_324_less__zeroE,axiom,(
    ! [N2: nat] :
      ~ ( ord_less_nat @ N2 @ zero_zero_nat ) )).

% less_zeroE
thf(fact_325_nat__neq__iff,axiom,(
    ! [M: nat,N2: nat] :
      ( ( M != N2 )
      = ( ( ord_less_nat @ M @ N2 )
        | ( ord_less_nat @ N2 @ M ) ) ) )).

% nat_neq_iff
thf(fact_326_less__not__refl,axiom,(
    ! [N2: nat] :
      ~ ( ord_less_nat @ N2 @ N2 ) )).

% less_not_refl
thf(fact_327_less__not__refl2,axiom,(
    ! [N2: nat,M: nat] :
      ( ( ord_less_nat @ N2 @ M )
     => ( M != N2 ) ) )).

% less_not_refl2
thf(fact_328_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_329_gr__implies__not0,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less_nat @ M @ N2 )
     => ( N2 != zero_zero_nat ) ) )).

% gr_implies_not0
thf(fact_330_less__irrefl__nat,axiom,(
    ! [N2: nat] :
      ~ ( ord_less_nat @ N2 @ N2 ) )).

% less_irrefl_nat
thf(fact_331_nat__less__induct,axiom,(
    ! [P: nat > $o,N2: nat] :
      ( ! [N4: nat] :
          ( ! [M4: nat] :
              ( ( ord_less_nat @ M4 @ N4 )
             => ( P @ M4 ) )
         => ( P @ N4 ) )
     => ( P @ N2 ) ) )).

% nat_less_induct
thf(fact_332_infinite__descent,axiom,(
    ! [P: nat > $o,N2: nat] :
      ( ! [N4: nat] :
          ( ~ ( P @ N4 )
         => ? [M4: nat] :
              ( ( ord_less_nat @ M4 @ N4 )
              & ~ ( P @ M4 ) ) )
     => ( P @ N2 ) ) )).

% infinite_descent
thf(fact_333_infinite__descent0,axiom,(
    ! [P: nat > $o,N2: nat] :
      ( ( P @ zero_zero_nat )
     => ( ! [N4: nat] :
            ( ( ord_less_nat @ zero_zero_nat @ N4 )
           => ( ~ ( P @ N4 )
             => ? [M4: nat] :
                  ( ( ord_less_nat @ M4 @ N4 )
                  & ~ ( P @ M4 ) ) ) )
       => ( P @ N2 ) ) ) )).

% infinite_descent0
thf(fact_334_linorder__neqE__nat,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_335_bot__nat__0_Oextremum__strict,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ zero_zero_nat ) )).

% bot_nat_0.extremum_strict
thf(fact_336_nat__power__less__imp__less,axiom,(
    ! [I: nat,M: nat,N2: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ I )
     => ( ( ord_less_nat @ ( power_power_nat @ I @ M ) @ ( power_power_nat @ I @ N2 ) )
       => ( ord_less_nat @ M @ N2 ) ) ) )).

% nat_power_less_imp_less
thf(fact_337_imp__le__cong,axiom,(
    ! [X: int,X7: int,P: $o,P5: $o] :
      ( ( X = X7 )
     => ( ( ( ord_less_eq_int @ zero_zero_int @ X7 )
         => ( P = P5 ) )
       => ( ( ( ord_less_eq_int @ zero_zero_int @ X )
           => P )
          = ( ( ord_less_eq_int @ zero_zero_int @ X7 )
           => P5 ) ) ) ) )).

% imp_le_cong
thf(fact_338_conj__le__cong,axiom,(
    ! [X: int,X7: int,P: $o,P5: $o] :
      ( ( X = X7 )
     => ( ( ( ord_less_eq_int @ zero_zero_int @ X7 )
         => ( P = P5 ) )
       => ( ( ( ord_less_eq_int @ zero_zero_int @ X )
            & P )
          = ( ( ord_less_eq_int @ zero_zero_int @ X7 )
            & P5 ) ) ) ) )).

% conj_le_cong
thf(fact_339_nat_Odistinct_I1_J,axiom,(
    ! [X2: nat] :
      ( zero_zero_nat
     != ( suc @ X2 ) ) )).

% nat.distinct(1)
thf(fact_340_old_Onat_Odistinct_I2_J,axiom,(
    ! [Nat2: nat] :
      ( ( suc @ Nat2 )
     != zero_zero_nat ) )).

% old.nat.distinct(2)
thf(fact_341_old_Onat_Odistinct_I1_J,axiom,(
    ! [Nat2: nat] :
      ( zero_zero_nat
     != ( suc @ Nat2 ) ) )).

% old.nat.distinct(1)
thf(fact_342_nat_OdiscI,axiom,(
    ! [Nat: nat,X2: nat] :
      ( ( Nat
        = ( suc @ X2 ) )
     => ( Nat != zero_zero_nat ) ) )).

% nat.discI
thf(fact_343_nat__induct,axiom,(
    ! [P: nat > $o,N2: nat] :
      ( ( P @ zero_zero_nat )
     => ( ! [N4: nat] :
            ( ( P @ N4 )
           => ( P @ ( suc @ N4 ) ) )
       => ( P @ N2 ) ) ) )).

% nat_induct
thf(fact_344_diff__induct,axiom,(
    ! [P: nat > nat > $o,M: nat,N2: nat] :
      ( ! [X3: nat] :
          ( P @ X3 @ zero_zero_nat )
     => ( ! [Y3: nat] :
            ( P @ zero_zero_nat @ ( suc @ Y3 ) )
       => ( ! [X3: nat,Y3: nat] :
              ( ( P @ X3 @ Y3 )
             => ( P @ ( suc @ X3 ) @ ( suc @ Y3 ) ) )
         => ( P @ M @ N2 ) ) ) ) )).

% diff_induct
thf(fact_345_zero__induct,axiom,(
    ! [P: nat > $o,K: nat] :
      ( ( P @ K )
     => ( ! [N4: nat] :
            ( ( P @ ( suc @ N4 ) )
           => ( P @ N4 ) )
       => ( P @ zero_zero_nat ) ) ) )).

% zero_induct
thf(fact_346_Suc__neq__Zero,axiom,(
    ! [M: nat] :
      ( ( suc @ M )
     != zero_zero_nat ) )).

% Suc_neq_Zero
thf(fact_347_Zero__neq__Suc,axiom,(
    ! [M: nat] :
      ( zero_zero_nat
     != ( suc @ M ) ) )).

% Zero_neq_Suc
thf(fact_348_Zero__not__Suc,axiom,(
    ! [M: nat] :
      ( zero_zero_nat
     != ( suc @ M ) ) )).

% Zero_not_Suc

% Conjectures (1)
thf(conj_0,conjecture,(
    ord_less_eq_int @ ( power_power_int @ q @ one_one_nat ) @ ( power_power_int @ q @ ( semiri50953410ct_nat @ ( suc @ n ) ) ) )).

%------------------------------------------------------------------------------
