%------------------------------------------------------------------------------
% File     : SLH448^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Descartes_Sign_Rule problem prob_163__5866536_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Descartes_Sign_Rule/prob_163__5866536_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  158 (   0 unit;  24 type;   0 defn)
%            Number of atoms       : 1099 ( 130 equality; 543 variable)
%            Maximal formula depth :   16 (   6 average)
%            Number of connectives :  770 (  65   ~;   5   |;  12   &; 583   @)
%                                         (   0 <=>; 105  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   53 (  53   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   26 (  24   :;   0   =)
%            Number of variables   :  260 (   0 sgn; 238   !;  14   ?;   8   ^)
%                                         ( 260   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:39:37.231
%------------------------------------------------------------------------------
% Could-be-implicit typings (4)
thf(ty_n_t__List__Olist_Itf__a_J,type,(
    list_a: $tType )).

thf(ty_n_t__Num__Onum,type,(
    num: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

thf(ty_n_tf__a,type,(
    a: $tType )).

% Explicit typings (20)
thf(sy_c_Descartes__Sign__Rule__Mirabelle__gwrulepwnb_Osign__changes_001tf__a,type,(
    descar2095969287nges_a: list_a > nat )).

thf(sy_c_Groups_Ominus__class_Ominus_001t__Nat__Onat,type,(
    minus_minus_nat: nat > nat > nat )).

thf(sy_c_Groups_Oone__class_Oone_001t__Nat__Onat,type,(
    one_one_nat: nat )).

thf(sy_c_Groups_Osgn__class_Osgn_001tf__a,type,(
    sgn_sgn_a: a > a )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001tf__a,type,(
    zero_zero_a: a )).

thf(sy_c_List_Obutlast_001tf__a,type,(
    butlast_a: list_a > list_a )).

thf(sy_c_List_Ofilter_001tf__a,type,(
    filter_a: ( a > $o ) > list_a > list_a )).

thf(sy_c_List_Ogen__length_001tf__a,type,(
    gen_length_a: nat > list_a > nat )).

thf(sy_c_List_Olist_Omap_001tf__a_001tf__a,type,(
    map_a_a: ( a > a ) > list_a > list_a )).

thf(sy_c_List_Omap__tailrec_001tf__a_001tf__a,type,(
    map_tailrec_a_a: ( a > a ) > list_a > list_a )).

thf(sy_c_List_Oremdups__adj_001tf__a,type,(
    remdups_adj_a: list_a > list_a )).

thf(sy_c_Nat_OSuc,type,(
    suc: nat > nat )).

thf(sy_c_Nat_Osize__class_Osize_001t__List__Olist_Itf__a_J,type,(
    size_size_list_a: list_a > nat )).

thf(sy_c_Num_Onum_OOne,type,(
    one: num )).

thf(sy_c_Num_Onumeral__class_Onumeral_001t__Nat__Onat,type,(
    numeral_numeral_nat: num > nat )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Num__Onum,type,(
    ord_less_num: num > num > $o )).

thf(sy_v_xs,type,(
    xs: list_a )).

thf(sy_v_ys,type,(
    ys: list_a )).

% Relevant facts (133)
thf(fact_0_assms,axiom,
    ( ( map_a_a @ sgn_sgn_a @ xs )
    = ( map_a_a @ sgn_sgn_a @ ys ) )).

% assms
thf(fact_1_sign__changes__def,axiom,
    ( descar2095969287nges_a
    = ( ^ [Xs: list_a] :
          ( minus_minus_nat
          @ ( size_size_list_a
            @ ( remdups_adj_a
              @ ( filter_a
                @ ^ [X: a] : ( X != zero_zero_a )
                @ ( map_a_a @ sgn_sgn_a @ Xs ) ) ) )
          @ one_one_nat ) ) )).

% sign_changes_def
thf(fact_2_length__map,axiom,(
    ! [F: a > a,Xs2: list_a] :
      ( ( size_size_list_a @ ( map_a_a @ F @ Xs2 ) )
      = ( size_size_list_a @ Xs2 ) ) )).

% length_map
thf(fact_3_zero__diff,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% zero_diff
thf(fact_4_diff__zero,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ A @ zero_zero_nat )
      = A ) )).

% diff_zero
thf(fact_5_cancel__comm__monoid__add__class_Odiff__cancel,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ A @ A )
      = zero_zero_nat ) )).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_6_map__ident,axiom,
    ( ( map_a_a
      @ ^ [X: a] : X )
    = ( ^ [Xs: list_a] : Xs ) )).

% map_ident
thf(fact_7_filter__filter,axiom,(
    ! [P: a > $o,Q: a > $o,Xs2: list_a] :
      ( ( filter_a @ P @ ( filter_a @ Q @ Xs2 ) )
      = ( filter_a
        @ ^ [X: a] :
            ( ( Q @ X )
            & ( P @ X ) )
        @ Xs2 ) ) )).

% filter_filter
thf(fact_8_zero__reorient,axiom,(
    ! [X2: a] :
      ( ( zero_zero_a = X2 )
      = ( X2 = zero_zero_a ) ) )).

% zero_reorient
thf(fact_9_zero__reorient,axiom,(
    ! [X2: nat] :
      ( ( zero_zero_nat = X2 )
      = ( X2 = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_10_one__reorient,axiom,(
    ! [X2: nat] :
      ( ( one_one_nat = X2 )
      = ( X2 = one_one_nat ) ) )).

% one_reorient
thf(fact_11_cancel__ab__semigroup__add__class_Odiff__right__commute,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ C ) @ B )
      = ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C ) ) )).

% cancel_ab_semigroup_add_class.diff_right_commute
thf(fact_12_neq__if__length__neq,axiom,(
    ! [Xs2: list_a,Ys: list_a] :
      ( ( ( size_size_list_a @ Xs2 )
       != ( size_size_list_a @ Ys ) )
     => ( Xs2 != Ys ) ) )).

% neq_if_length_neq
thf(fact_13_Ex__list__of__length,axiom,(
    ! [N: nat] :
    ? [Xs3: list_a] :
      ( ( size_size_list_a @ Xs3 )
      = N ) )).

% Ex_list_of_length
thf(fact_14_list_Omap__ident,axiom,(
    ! [T: list_a] :
      ( ( map_a_a
        @ ^ [X: a] : X
        @ T )
      = T ) )).

% list.map_ident
thf(fact_15_zero__neq__one,axiom,(
    zero_zero_nat != one_one_nat )).

% zero_neq_one
thf(fact_16_map__eq__imp__length__eq,axiom,(
    ! [F: a > a,Xs2: list_a,G: a > a,Ys: list_a] :
      ( ( ( map_a_a @ F @ Xs2 )
        = ( map_a_a @ G @ Ys ) )
     => ( ( size_size_list_a @ Xs2 )
        = ( size_size_list_a @ Ys ) ) ) )).

% map_eq_imp_length_eq
thf(fact_17_diff__self__eq__0,axiom,(
    ! [M: nat] :
      ( ( minus_minus_nat @ M @ M )
      = zero_zero_nat ) )).

% diff_self_eq_0
thf(fact_18_diff__0__eq__0,axiom,(
    ! [N: nat] :
      ( ( minus_minus_nat @ zero_zero_nat @ N )
      = zero_zero_nat ) )).

% diff_0_eq_0
thf(fact_19_map__eq__map__tailrec,axiom,(
    map_a_a = map_tailrec_a_a )).

% map_eq_map_tailrec
thf(fact_20_length__butlast,axiom,(
    ! [Xs2: list_a] :
      ( ( size_size_list_a @ ( butlast_a @ Xs2 ) )
      = ( minus_minus_nat @ ( size_size_list_a @ Xs2 ) @ one_one_nat ) ) )).

% length_butlast
thf(fact_21_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_22_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_23_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_24_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_25_zero__less__diff,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( minus_minus_nat @ N @ M ) )
      = ( ord_less_nat @ M @ N ) ) )).

% zero_less_diff
thf(fact_26_less__one,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ N @ one_one_nat )
      = ( N = zero_zero_nat ) ) )).

% less_one
thf(fact_27_gr0I,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr0I
thf(fact_28_not__gr0,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr0
thf(fact_29_not__less0,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less0
thf(fact_30_less__zeroE,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_zeroE
thf(fact_31_gr__implies__not0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not0
thf(fact_32_infinite__descent0,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ zero_zero_nat )
     => ( ! [N2: nat] :
            ( ( ord_less_nat @ zero_zero_nat @ N2 )
           => ( ~ ( P @ N2 )
             => ? [M2: nat] :
                  ( ( ord_less_nat @ M2 @ N2 )
                  & ~ ( P @ M2 ) ) ) )
       => ( P @ N ) ) ) )).

% infinite_descent0
thf(fact_33_bot__nat__0_Oextremum__strict,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ zero_zero_nat ) )).

% bot_nat_0.extremum_strict
thf(fact_34_diff__less__mono2,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ( ord_less_nat @ M @ L )
       => ( ord_less_nat @ ( minus_minus_nat @ L @ N ) @ ( minus_minus_nat @ L @ M ) ) ) ) )).

% diff_less_mono2
thf(fact_35_less__imp__diff__less,axiom,(
    ! [J: nat,K: nat,N: nat] :
      ( ( ord_less_nat @ J @ K )
     => ( ord_less_nat @ ( minus_minus_nat @ J @ N ) @ K ) ) )).

% less_imp_diff_less
thf(fact_36_diff__less,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_nat @ zero_zero_nat @ M )
       => ( ord_less_nat @ ( minus_minus_nat @ M @ N ) @ M ) ) ) )).

% diff_less
thf(fact_37_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_nat @ zero_zero_nat @ zero_zero_nat ) )).

% less_numeral_extra(3)
thf(fact_38_gr__zeroI,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_zeroI
thf(fact_39_not__less__zero,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less_zero
thf(fact_40_gr__implies__not__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not_zero
thf(fact_41_zero__less__iff__neq__zero,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( N != zero_zero_nat ) ) )).

% zero_less_iff_neq_zero
thf(fact_42_less__numeral__extra_I4_J,axiom,(
    ~ ( ord_less_nat @ one_one_nat @ one_one_nat ) )).

% less_numeral_extra(4)
thf(fact_43_length__induct,axiom,(
    ! [P: list_a > $o,Xs2: list_a] :
      ( ! [Xs3: list_a] :
          ( ! [Ys2: list_a] :
              ( ( ord_less_nat @ ( size_size_list_a @ Ys2 ) @ ( size_size_list_a @ Xs3 ) )
             => ( P @ Ys2 ) )
         => ( P @ Xs3 ) )
     => ( P @ Xs2 ) ) )).

% length_induct
thf(fact_44_map__butlast,axiom,(
    ! [F: a > a,Xs2: list_a] :
      ( ( map_a_a @ F @ ( butlast_a @ Xs2 ) )
      = ( butlast_a @ ( map_a_a @ F @ Xs2 ) ) ) )).

% map_butlast
thf(fact_45_less__numeral__extra_I1_J,axiom,(
    ord_less_nat @ zero_zero_nat @ one_one_nat )).

% less_numeral_extra(1)
thf(fact_46_zero__less__one,axiom,(
    ord_less_nat @ zero_zero_nat @ one_one_nat )).

% zero_less_one
thf(fact_47_not__one__less__zero,axiom,(
    ~ ( ord_less_nat @ one_one_nat @ zero_zero_nat ) )).

% not_one_less_zero
thf(fact_48_size__neq__size__imp__neq,axiom,(
    ! [X2: list_a,Y: list_a] :
      ( ( ( size_size_list_a @ X2 )
       != ( size_size_list_a @ Y ) )
     => ( X2 != Y ) ) )).

% size_neq_size_imp_neq
thf(fact_49_diff__commute,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I @ J ) @ K )
      = ( minus_minus_nat @ ( minus_minus_nat @ I @ K ) @ J ) ) )).

% diff_commute
thf(fact_50_diffs0__imp__equal,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat )
     => ( ( ( minus_minus_nat @ N @ M )
          = zero_zero_nat )
       => ( M = N ) ) ) )).

% diffs0_imp_equal
thf(fact_51_minus__nat_Odiff__0,axiom,(
    ! [M: nat] :
      ( ( minus_minus_nat @ M @ zero_zero_nat )
      = M ) )).

% minus_nat.diff_0
thf(fact_52_linorder__neqE__nat,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( X2 != Y )
     => ( ~ ( ord_less_nat @ X2 @ Y )
       => ( ord_less_nat @ Y @ X2 ) ) ) )).

% linorder_neqE_nat
thf(fact_53_infinite__descent,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P @ N2 )
         => ? [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
              & ~ ( P @ M2 ) ) )
     => ( P @ N ) ) )).

% infinite_descent
thf(fact_54_nat__less__induct,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ( P @ M2 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) )).

% nat_less_induct
thf(fact_55_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_56_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_57_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_58_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_59_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_60_verit__comp__simplify1_I1_J,axiom,(
    ! [A: num] :
      ~ ( ord_less_num @ A @ A ) )).

% verit_comp_simplify1(1)
thf(fact_61_verit__comp__simplify1_I1_J,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% verit_comp_simplify1(1)
thf(fact_62_length__code,axiom,
    ( size_size_list_a
    = ( gen_length_a @ zero_zero_nat ) )).

% length_code
thf(fact_63_Suc__diff__1,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( suc @ ( minus_minus_nat @ N @ one_one_nat ) )
        = N ) ) )).

% Suc_diff_1
thf(fact_64_numeral__eq__iff,axiom,(
    ! [M: num,N: num] :
      ( ( ( numeral_numeral_nat @ M )
        = ( numeral_numeral_nat @ N ) )
      = ( M = N ) ) )).

% numeral_eq_iff
thf(fact_65_old_Onat_Oinject,axiom,(
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) )).

% old.nat.inject
thf(fact_66_nat_Oinject,axiom,(
    ! [X22: nat,Y2: nat] :
      ( ( ( suc @ X22 )
        = ( suc @ Y2 ) )
      = ( X22 = Y2 ) ) )).

% nat.inject
thf(fact_67_numeral__less__iff,axiom,(
    ! [M: num,N: num] :
      ( ( ord_less_nat @ ( numeral_numeral_nat @ M ) @ ( numeral_numeral_nat @ N ) )
      = ( ord_less_num @ M @ N ) ) )).

% numeral_less_iff
thf(fact_68_lessI,axiom,(
    ! [N: nat] :
      ( ord_less_nat @ N @ ( suc @ N ) ) )).

% lessI
thf(fact_69_Suc__mono,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_nat @ ( suc @ M ) @ ( suc @ N ) ) ) )).

% Suc_mono
thf(fact_70_Suc__less__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( ord_less_nat @ M @ N ) ) )).

% Suc_less_eq
thf(fact_71_diff__Suc__Suc,axiom,(
    ! [M: nat,N: nat] :
      ( ( minus_minus_nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( minus_minus_nat @ M @ N ) ) )).

% diff_Suc_Suc
thf(fact_72_Suc__diff__diff,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ ( suc @ M ) @ N ) @ ( suc @ K ) )
      = ( minus_minus_nat @ ( minus_minus_nat @ M @ N ) @ K ) ) )).

% Suc_diff_diff
thf(fact_73_zero__less__Suc,axiom,(
    ! [N: nat] :
      ( ord_less_nat @ zero_zero_nat @ ( suc @ N ) ) )).

% zero_less_Suc
thf(fact_74_less__Suc0,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ N @ ( suc @ zero_zero_nat ) )
      = ( N = zero_zero_nat ) ) )).

% less_Suc0
thf(fact_75_diff__Suc__1,axiom,(
    ! [N: nat] :
      ( ( minus_minus_nat @ ( suc @ N ) @ one_one_nat )
      = N ) )).

% diff_Suc_1
thf(fact_76_Suc__pred,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( suc @ ( minus_minus_nat @ N @ ( suc @ zero_zero_nat ) ) )
        = N ) ) )).

% Suc_pred
thf(fact_77_zero__neq__numeral,axiom,(
    ! [N: num] :
      ( zero_zero_nat
     != ( numeral_numeral_nat @ N ) ) )).

% zero_neq_numeral
thf(fact_78_not0__implies__Suc,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ? [M3: nat] :
          ( N
          = ( suc @ M3 ) ) ) )).

% not0_implies_Suc
thf(fact_79_old_Onat_Oinducts,axiom,(
    ! [P: nat > $o,Nat: nat] :
      ( ( P @ zero_zero_nat )
     => ( ! [Nat3: nat] :
            ( ( P @ Nat3 )
           => ( P @ ( suc @ Nat3 ) ) )
       => ( P @ Nat ) ) ) )).

% old.nat.inducts
thf(fact_80_old_Onat_Oexhaust,axiom,(
    ! [Y: nat] :
      ( ( Y != zero_zero_nat )
     => ~ ! [Nat3: nat] :
            ( Y
           != ( suc @ Nat3 ) ) ) )).

% old.nat.exhaust
thf(fact_81_Zero__not__Suc,axiom,(
    ! [M: nat] :
      ( zero_zero_nat
     != ( suc @ M ) ) )).

% Zero_not_Suc
thf(fact_82_Zero__neq__Suc,axiom,(
    ! [M: nat] :
      ( zero_zero_nat
     != ( suc @ M ) ) )).

% Zero_neq_Suc
thf(fact_83_Suc__neq__Zero,axiom,(
    ! [M: nat] :
      ( ( suc @ M )
     != zero_zero_nat ) )).

% Suc_neq_Zero
thf(fact_84_zero__induct,axiom,(
    ! [P: nat > $o,K: nat] :
      ( ( P @ K )
     => ( ! [N2: nat] :
            ( ( P @ ( suc @ N2 ) )
           => ( P @ N2 ) )
       => ( P @ zero_zero_nat ) ) ) )).

% zero_induct
thf(fact_85_diff__induct,axiom,(
    ! [P: nat > nat > $o,M: nat,N: nat] :
      ( ! [X3: nat] :
          ( P @ X3 @ zero_zero_nat )
     => ( ! [Y3: nat] :
            ( P @ zero_zero_nat @ ( suc @ Y3 ) )
       => ( ! [X3: nat,Y3: nat] :
              ( ( P @ X3 @ Y3 )
             => ( P @ ( suc @ X3 ) @ ( suc @ Y3 ) ) )
         => ( P @ M @ N ) ) ) ) )).

% diff_induct
thf(fact_86_nat__induct,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ zero_zero_nat )
     => ( ! [N2: nat] :
            ( ( P @ N2 )
           => ( P @ ( suc @ N2 ) ) )
       => ( P @ N ) ) ) )).

% nat_induct
thf(fact_87_nat_OdiscI,axiom,(
    ! [Nat: nat,X22: nat] :
      ( ( Nat
        = ( suc @ X22 ) )
     => ( Nat != zero_zero_nat ) ) )).

% nat.discI
thf(fact_88_old_Onat_Odistinct_I1_J,axiom,(
    ! [Nat2: nat] :
      ( zero_zero_nat
     != ( suc @ Nat2 ) ) )).

% old.nat.distinct(1)
thf(fact_89_old_Onat_Odistinct_I2_J,axiom,(
    ! [Nat2: nat] :
      ( ( suc @ Nat2 )
     != zero_zero_nat ) )).

% old.nat.distinct(2)
thf(fact_90_nat_Odistinct_I1_J,axiom,(
    ! [X22: nat] :
      ( zero_zero_nat
     != ( suc @ X22 ) ) )).

% nat.distinct(1)
thf(fact_91_n__not__Suc__n,axiom,(
    ! [N: nat] :
      ( N
     != ( suc @ N ) ) )).

% n_not_Suc_n
thf(fact_92_Suc__inject,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ( suc @ X2 )
        = ( suc @ Y ) )
     => ( X2 = Y ) ) )).

% Suc_inject
thf(fact_93_zero__induct__lemma,axiom,(
    ! [P: nat > $o,K: nat,I: nat] :
      ( ( P @ K )
     => ( ! [N2: nat] :
            ( ( P @ ( suc @ N2 ) )
           => ( P @ N2 ) )
       => ( P @ ( minus_minus_nat @ K @ I ) ) ) ) )).

% zero_induct_lemma
thf(fact_94_Nat_OlessE,axiom,(
    ! [I: nat,K: nat] :
      ( ( ord_less_nat @ I @ K )
     => ( ( K
         != ( suc @ I ) )
       => ~ ! [J2: nat] :
              ( ( ord_less_nat @ I @ J2 )
             => ( K
               != ( suc @ J2 ) ) ) ) ) )).

% Nat.lessE
thf(fact_95_Suc__lessD,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ ( suc @ M ) @ N )
     => ( ord_less_nat @ M @ N ) ) )).

% Suc_lessD
thf(fact_96_Suc__lessE,axiom,(
    ! [I: nat,K: nat] :
      ( ( ord_less_nat @ ( suc @ I ) @ K )
     => ~ ! [J2: nat] :
            ( ( ord_less_nat @ I @ J2 )
           => ( K
             != ( suc @ J2 ) ) ) ) )).

% Suc_lessE
thf(fact_97_Suc__lessI,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ( ( suc @ M )
         != N )
       => ( ord_less_nat @ ( suc @ M ) @ N ) ) ) )).

% Suc_lessI
thf(fact_98_less__SucE,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less_nat @ M @ N )
       => ( M = N ) ) ) )).

% less_SucE
thf(fact_99_less__SucI,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_nat @ M @ ( suc @ N ) ) ) )).

% less_SucI
thf(fact_100_Ex__less__Suc,axiom,(
    ! [N: nat,P: nat > $o] :
      ( ( ? [I2: nat] :
            ( ( ord_less_nat @ I2 @ ( suc @ N ) )
            & ( P @ I2 ) ) )
      = ( ( P @ N )
        | ? [I2: nat] :
            ( ( ord_less_nat @ I2 @ N )
            & ( P @ I2 ) ) ) ) )).

% Ex_less_Suc
thf(fact_101_less__Suc__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ ( suc @ N ) )
      = ( ( ord_less_nat @ M @ N )
        | ( M = N ) ) ) )).

% less_Suc_eq
thf(fact_102_not__less__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less_nat @ M @ N ) )
      = ( ord_less_nat @ N @ ( suc @ M ) ) ) )).

% not_less_eq
thf(fact_103_All__less__Suc,axiom,(
    ! [N: nat,P: nat > $o] :
      ( ( ! [I2: nat] :
            ( ( ord_less_nat @ I2 @ ( suc @ N ) )
           => ( P @ I2 ) ) )
      = ( ( P @ N )
        & ! [I2: nat] :
            ( ( ord_less_nat @ I2 @ N )
           => ( P @ I2 ) ) ) ) )).

% All_less_Suc
thf(fact_104_Suc__less__eq2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ ( suc @ N ) @ M )
      = ( ? [M4: nat] :
            ( ( M
              = ( suc @ M4 ) )
            & ( ord_less_nat @ N @ M4 ) ) ) ) )).

% Suc_less_eq2
thf(fact_105_less__antisym,axiom,(
    ! [N: nat,M: nat] :
      ( ~ ( ord_less_nat @ N @ M )
     => ( ( ord_less_nat @ N @ ( suc @ M ) )
       => ( M = N ) ) ) )).

% less_antisym
thf(fact_106_Suc__less__SucD,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ ( suc @ M ) @ ( suc @ N ) )
     => ( ord_less_nat @ M @ N ) ) )).

% Suc_less_SucD
thf(fact_107_less__trans__Suc,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ( ord_less_nat @ J @ K )
       => ( ord_less_nat @ ( suc @ I ) @ K ) ) ) )).

% less_trans_Suc
thf(fact_108_less__Suc__induct,axiom,(
    ! [I: nat,J: nat,P: nat > nat > $o] :
      ( ( ord_less_nat @ I @ J )
     => ( ! [I3: nat] :
            ( P @ I3 @ ( suc @ I3 ) )
       => ( ! [I3: nat,J2: nat,K2: nat] :
              ( ( ord_less_nat @ I3 @ J2 )
             => ( ( ord_less_nat @ J2 @ K2 )
               => ( ( P @ I3 @ J2 )
                 => ( ( P @ J2 @ K2 )
                   => ( P @ I3 @ K2 ) ) ) ) )
         => ( P @ I @ J ) ) ) ) )).

% less_Suc_induct
thf(fact_109_strict__inc__induct,axiom,(
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less_nat @ I @ J )
     => ( ! [I3: nat] :
            ( ( J
              = ( suc @ I3 ) )
           => ( P @ I3 ) )
       => ( ! [I3: nat] :
              ( ( ord_less_nat @ I3 @ J )
             => ( ( P @ ( suc @ I3 ) )
               => ( P @ I3 ) ) )
         => ( P @ I ) ) ) ) )).

% strict_inc_induct
thf(fact_110_not__less__less__Suc__eq,axiom,(
    ! [N: nat,M: nat] :
      ( ~ ( ord_less_nat @ N @ M )
     => ( ( ord_less_nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) )).

% not_less_less_Suc_eq
thf(fact_111_zero__less__numeral,axiom,(
    ! [N: num] :
      ( ord_less_nat @ zero_zero_nat @ ( numeral_numeral_nat @ N ) ) )).

% zero_less_numeral
thf(fact_112_not__numeral__less__zero,axiom,(
    ! [N: num] :
      ~ ( ord_less_nat @ ( numeral_numeral_nat @ N ) @ zero_zero_nat ) )).

% not_numeral_less_zero
thf(fact_113_not__numeral__less__one,axiom,(
    ! [N: num] :
      ~ ( ord_less_nat @ ( numeral_numeral_nat @ N ) @ one_one_nat ) )).

% not_numeral_less_one
thf(fact_114_lift__Suc__mono__less,axiom,(
    ! [F: nat > num,N: nat,N3: nat] :
      ( ! [N2: nat] :
          ( ord_less_num @ ( F @ N2 ) @ ( F @ ( suc @ N2 ) ) )
     => ( ( ord_less_nat @ N @ N3 )
       => ( ord_less_num @ ( F @ N ) @ ( F @ N3 ) ) ) ) )).

% lift_Suc_mono_less
thf(fact_115_lift__Suc__mono__less,axiom,(
    ! [F: nat > nat,N: nat,N3: nat] :
      ( ! [N2: nat] :
          ( ord_less_nat @ ( F @ N2 ) @ ( F @ ( suc @ N2 ) ) )
     => ( ( ord_less_nat @ N @ N3 )
       => ( ord_less_nat @ ( F @ N ) @ ( F @ N3 ) ) ) ) )).

% lift_Suc_mono_less
thf(fact_116_lift__Suc__mono__less__iff,axiom,(
    ! [F: nat > num,N: nat,M: nat] :
      ( ! [N2: nat] :
          ( ord_less_num @ ( F @ N2 ) @ ( F @ ( suc @ N2 ) ) )
     => ( ( ord_less_num @ ( F @ N ) @ ( F @ M ) )
        = ( ord_less_nat @ N @ M ) ) ) )).

% lift_Suc_mono_less_iff
thf(fact_117_lift__Suc__mono__less__iff,axiom,(
    ! [F: nat > nat,N: nat,M: nat] :
      ( ! [N2: nat] :
          ( ord_less_nat @ ( F @ N2 ) @ ( F @ ( suc @ N2 ) ) )
     => ( ( ord_less_nat @ ( F @ N ) @ ( F @ M ) )
        = ( ord_less_nat @ N @ M ) ) ) )).

% lift_Suc_mono_less_iff
thf(fact_118_less__Suc__eq__0__disj,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ ( suc @ N ) )
      = ( ( M = zero_zero_nat )
        | ? [J3: nat] :
            ( ( M
              = ( suc @ J3 ) )
            & ( ord_less_nat @ J3 @ N ) ) ) ) )).

% less_Suc_eq_0_disj
thf(fact_119_gr0__implies__Suc,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ? [M3: nat] :
          ( N
          = ( suc @ M3 ) ) ) )).

% gr0_implies_Suc
thf(fact_120_All__less__Suc2,axiom,(
    ! [N: nat,P: nat > $o] :
      ( ( ! [I2: nat] :
            ( ( ord_less_nat @ I2 @ ( suc @ N ) )
           => ( P @ I2 ) ) )
      = ( ( P @ zero_zero_nat )
        & ! [I2: nat] :
            ( ( ord_less_nat @ I2 @ N )
           => ( P @ ( suc @ I2 ) ) ) ) ) )).

% All_less_Suc2
thf(fact_121_gr0__conv__Suc,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( ? [M5: nat] :
            ( N
            = ( suc @ M5 ) ) ) ) )).

% gr0_conv_Suc
thf(fact_122_Ex__less__Suc2,axiom,(
    ! [N: nat,P: nat > $o] :
      ( ( ? [I2: nat] :
            ( ( ord_less_nat @ I2 @ ( suc @ N ) )
            & ( P @ I2 ) ) )
      = ( ( P @ zero_zero_nat )
        | ? [I2: nat] :
            ( ( ord_less_nat @ I2 @ N )
            & ( P @ ( suc @ I2 ) ) ) ) ) )).

% Ex_less_Suc2
thf(fact_123_diff__less__Suc,axiom,(
    ! [M: nat,N: nat] :
      ( ord_less_nat @ ( minus_minus_nat @ M @ N ) @ ( suc @ M ) ) )).

% diff_less_Suc
thf(fact_124_Suc__diff__Suc,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( ( suc @ ( minus_minus_nat @ M @ ( suc @ N ) ) )
        = ( minus_minus_nat @ M @ N ) ) ) )).

% Suc_diff_Suc
thf(fact_125_One__nat__def,axiom,
    ( one_one_nat
    = ( suc @ zero_zero_nat ) )).

% One_nat_def
thf(fact_126_diff__Suc__eq__diff__pred,axiom,(
    ! [M: nat,N: nat] :
      ( ( minus_minus_nat @ M @ ( suc @ N ) )
      = ( minus_minus_nat @ ( minus_minus_nat @ M @ one_one_nat ) @ N ) ) )).

% diff_Suc_eq_diff_pred
thf(fact_127_diff__Suc__less,axiom,(
    ! [N: nat,I: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ord_less_nat @ ( minus_minus_nat @ N @ ( suc @ I ) ) @ N ) ) )).

% diff_Suc_less
thf(fact_128_nat__induct__non__zero,axiom,(
    ! [N: nat,P: nat > $o] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( P @ one_one_nat )
       => ( ! [N2: nat] :
              ( ( ord_less_nat @ zero_zero_nat @ N2 )
             => ( ( P @ N2 )
               => ( P @ ( suc @ N2 ) ) ) )
         => ( P @ N ) ) ) ) )).

% nat_induct_non_zero
thf(fact_129_Suc__diff__eq__diff__pred,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( minus_minus_nat @ ( suc @ M ) @ N )
        = ( minus_minus_nat @ M @ ( minus_minus_nat @ N @ one_one_nat ) ) ) ) )).

% Suc_diff_eq_diff_pred
thf(fact_130_Suc__pred_H,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( N
        = ( suc @ ( minus_minus_nat @ N @ one_one_nat ) ) ) ) )).

% Suc_pred'
thf(fact_131_exists__least__lemma,axiom,(
    ! [P: nat > $o] :
      ( ~ ( P @ zero_zero_nat )
     => ( ? [X_1: nat] :
            ( P @ X_1 )
       => ? [N2: nat] :
            ( ~ ( P @ N2 )
            & ( P @ ( suc @ N2 ) ) ) ) ) )).

% exists_least_lemma
thf(fact_132_one__less__numeral__iff,axiom,(
    ! [N: num] :
      ( ( ord_less_nat @ one_one_nat @ ( numeral_numeral_nat @ N ) )
      = ( ord_less_num @ one @ N ) ) )).

% one_less_numeral_iff

% Conjectures (1)
thf(conj_0,conjecture,
    ( ( minus_minus_nat
      @ ( size_size_list_a
        @ ( remdups_adj_a
          @ ( filter_a
            @ ^ [X: a] : ( X != zero_zero_a )
            @ ( map_a_a @ sgn_sgn_a @ xs ) ) ) )
      @ one_one_nat )
    = ( minus_minus_nat
      @ ( size_size_list_a
        @ ( remdups_adj_a
          @ ( filter_a
            @ ^ [X: a] : ( X != zero_zero_a )
            @ ( map_a_a @ sgn_sgn_a @ ys ) ) ) )
      @ one_one_nat ) )).

%------------------------------------------------------------------------------
