%------------------------------------------------------------------------------
% File     : SLH510^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Number_Partition problem prob_285__5328298_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Number_Partition/prob_285__5328298_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  252 (   1 unit;  21 type;   0 defn)
%            Number of atoms       : 2433 ( 217 equality;1352 variable)
%            Maximal formula depth :   17 (   8 average)
%            Number of connectives : 1829 (  61   ~;  15   |;  31   &;1406   @)
%                                         (   0 <=>; 316  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   91 (  91   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   24 (  21   :;   0   =)
%            Number of variables   :  608 (   3 sgn; 549   !;   6   ?;  53   ^)
%                                         ( 608   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:44:03.421
%------------------------------------------------------------------------------
% Could-be-implicit typings (3)
thf(ty_n_t__Set__Oset_It__Set__Oset_It__Nat__Onat_J_J,type,(
    set_set_nat: $tType )).

thf(ty_n_t__Set__Oset_It__Nat__Onat_J,type,(
    set_nat: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (18)
thf(sy_c_Groups_Oone__class_Oone_001t__Nat__Onat,type,(
    one_one_nat: nat )).

thf(sy_c_Groups_Otimes__class_Otimes_001t__Nat__Onat,type,(
    times_times_nat: nat > nat > nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_001t__Nat__Onat_001t__Nat__Onat,type,(
    groups1842438620at_nat: ( nat > nat ) > set_nat > nat )).

thf(sy_c_Number__Partition__Mirabelle__zerdlymyoj_Opartitions,type,(
    number1551313001itions: ( nat > nat ) > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Set__Oset_It__Nat__Onat_J,type,(
    ord_less_eq_set_nat: set_nat > set_nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Set__Oset_It__Set__Oset_It__Nat__Onat_J_J,type,(
    ord_le1613022364et_nat: set_set_nat > set_set_nat > $o )).

thf(sy_c_Set_OCollect_001t__Nat__Onat,type,(
    collect_nat: ( nat > $o ) > set_nat )).

thf(sy_c_Set_OCollect_001t__Set__Oset_It__Nat__Onat_J,type,(
    collect_set_nat: ( set_nat > $o ) > set_set_nat )).

thf(sy_c_Set__Interval_Oord__class_OatMost_001t__Nat__Onat,type,(
    set_ord_atMost_nat: nat > set_nat )).

thf(sy_c_Set__Interval_Oord__class_OatMost_001t__Set__Oset_It__Nat__Onat_J,type,(
    set_or1086813439et_nat: set_nat > set_set_nat )).

thf(sy_c_member_001t__Nat__Onat,type,(
    member_nat: nat > set_nat > $o )).

thf(sy_c_member_001t__Set__Oset_It__Nat__Onat_J,type,(
    member_set_nat: set_nat > set_set_nat > $o )).

thf(sy_v_k,type,(
    k: nat )).

thf(sy_v_m,type,(
    m: nat )).

thf(sy_v_p,type,(
    p: nat > nat )).

% Relevant facts (230)
thf(fact_0_p,axiom,(
    number1551313001itions @ p @ m )).

% p
thf(fact_1__092_060open_062p_A0_A_061_A0_092_060close_062,axiom,
    ( ( p @ zero_zero_nat )
    = zero_zero_nat )).

% \<open>p 0 = 0\<close>
thf(fact_2_assms_I3_J,axiom,
    ( ( p @ one_one_nat )
    = zero_zero_nat )).

% assms(3)
thf(fact_3_partitions__zero,axiom,(
    ! [P: nat > nat] :
      ( ( number1551313001itions @ P @ zero_zero_nat )
      = ( P
        = ( ^ [I: nat] : zero_zero_nat ) ) ) )).

% partitions_zero
thf(fact_4_sum,axiom,
    ( ( groups1842438620at_nat @ p @ ( set_ord_atMost_nat @ m ) )
    = k )).

% sum
thf(fact_5_zero__natural_Orsp,axiom,(
    zero_zero_nat = zero_zero_nat )).

% zero_natural.rsp
thf(fact_6_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_7_s,axiom,
    ( ( groups1842438620at_nat
      @ ^ [I: nat] :
          ( times_times_nat @ ( p @ I ) @ I )
      @ ( set_ord_atMost_nat @ m ) )
    = m )).

% s
thf(fact_8_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_9_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_10_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_11_mult__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times_nat @ M @ N )
        = zero_zero_nat )
      = ( ( M = zero_zero_nat )
        | ( N = zero_zero_nat ) ) ) )).

% mult_is_0
thf(fact_12_mult__0__right,axiom,(
    ! [M: nat] :
      ( ( times_times_nat @ M @ zero_zero_nat )
      = zero_zero_nat ) )).

% mult_0_right
thf(fact_13_mult__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times_nat @ K @ M )
        = ( times_times_nat @ K @ N ) )
      = ( ( M = N )
        | ( K = zero_zero_nat ) ) ) )).

% mult_cancel1
thf(fact_14__092_060open_062m_A_060_A_I_092_060Sum_062i_092_060le_062m_O_Ap_Ai_A_K_Ai_J_092_060close_062,axiom,
    ( ord_less_nat @ m
    @ ( groups1842438620at_nat
      @ ^ [I: nat] :
          ( times_times_nat @ ( p @ I ) @ I )
      @ ( set_ord_atMost_nat @ m ) ) )).

% \<open>m < (\<Sum>i\<le>m. p i * i)\<close>
thf(fact_15_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_16_mult_Oright__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ one_one_nat )
      = A ) )).

% mult.right_neutral
thf(fact_17_mult_Oleft__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ one_one_nat @ A )
      = A ) )).

% mult.left_neutral
thf(fact_18_mult__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( times_times_nat @ M @ K )
        = ( times_times_nat @ N @ K ) )
      = ( ( M = N )
        | ( K = zero_zero_nat ) ) ) )).

% mult_cancel2
thf(fact_19_nat__mult__eq__1__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times_nat @ M @ N )
        = one_one_nat )
      = ( ( M = one_one_nat )
        & ( N = one_one_nat ) ) ) )).

% nat_mult_eq_1_iff
thf(fact_20_nat__1__eq__mult__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( one_one_nat
        = ( times_times_nat @ M @ N ) )
      = ( ( M = one_one_nat )
        & ( N = one_one_nat ) ) ) )).

% nat_1_eq_mult_iff
thf(fact_21_nat__0__less__mult__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ M @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ M )
        & ( ord_less_nat @ zero_zero_nat @ N ) ) ) )).

% nat_0_less_mult_iff
thf(fact_22_mult__less__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
        & ( ord_less_nat @ M @ N ) ) ) )).

% mult_less_cancel2
thf(fact_23_less__one,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ N @ one_one_nat )
      = ( N = zero_zero_nat ) ) )).

% less_one
thf(fact_24_mult_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( times_times_nat @ B @ ( times_times_nat @ A @ C ) )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.left_commute
thf(fact_25_mult_Ocomm__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ one_one_nat )
      = A ) )).

% mult.comm_neutral
thf(fact_26_mult_Ocommute,axiom,
    ( times_times_nat
    = ( ^ [A2: nat,B2: nat] :
          ( times_times_nat @ B2 @ A2 ) ) )).

% mult.commute
thf(fact_27_mult_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.assoc
thf(fact_28_comm__monoid__mult__class_Omult__1,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ one_one_nat @ A )
      = A ) )).

% comm_monoid_mult_class.mult_1
thf(fact_29_one__natural_Orsp,axiom,(
    one_one_nat = one_one_nat )).

% one_natural.rsp
thf(fact_30_linorder__neqE__nat,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_31_nat__mult__1__right,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ N @ one_one_nat )
      = N ) )).

% nat_mult_1_right
thf(fact_32_infinite__descent,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P2 @ N2 )
         => ? [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
              & ~ ( P2 @ M2 ) ) )
     => ( P2 @ N ) ) )).

% infinite_descent
thf(fact_33_nat__less__induct,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ( P2 @ M2 ) )
         => ( P2 @ N2 ) )
     => ( P2 @ N ) ) )).

% nat_less_induct
thf(fact_34_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_35_one__reorient,axiom,(
    ! [X: nat] :
      ( ( one_one_nat = X )
      = ( X = one_one_nat ) ) )).

% one_reorient
thf(fact_36_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_37_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_38_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_39_mem__Collect__eq,axiom,(
    ! [A: nat,P2: nat > $o] :
      ( ( member_nat @ A @ ( collect_nat @ P2 ) )
      = ( P2 @ A ) ) )).

% mem_Collect_eq
thf(fact_40_Collect__mem__eq,axiom,(
    ! [A3: set_nat] :
      ( ( collect_nat
        @ ^ [X2: nat] :
            ( member_nat @ X2 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_41_Collect__cong,axiom,(
    ! [P2: nat > $o,Q: nat > $o] :
      ( ! [X3: nat] :
          ( ( P2 @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect_nat @ P2 )
        = ( collect_nat @ Q ) ) ) )).

% Collect_cong
thf(fact_42_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_43_nat__mult__1,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ one_one_nat @ N )
      = N ) )).

% nat_mult_1
thf(fact_44_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_45_mult__eq__self__implies__10,axiom,(
    ! [M: nat,N: nat] :
      ( ( M
        = ( times_times_nat @ M @ N ) )
     => ( ( N = one_one_nat )
        | ( M = zero_zero_nat ) ) ) )).

% mult_eq_self_implies_10
thf(fact_46_mult__less__mono2,axiom,(
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I2 @ J )
     => ( ( ord_less_nat @ zero_zero_nat @ K )
       => ( ord_less_nat @ ( times_times_nat @ K @ I2 ) @ ( times_times_nat @ K @ J ) ) ) ) )).

% mult_less_mono2
thf(fact_47_mult__less__mono1,axiom,(
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I2 @ J )
     => ( ( ord_less_nat @ zero_zero_nat @ K )
       => ( ord_less_nat @ ( times_times_nat @ I2 @ K ) @ ( times_times_nat @ J @ K ) ) ) ) )).

% mult_less_mono1
thf(fact_48_zero__less__iff__neq__zero,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( N != zero_zero_nat ) ) )).

% zero_less_iff_neq_zero
thf(fact_49_gr__implies__not__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not_zero
thf(fact_50_not__less__zero,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less_zero
thf(fact_51_gr__zeroI,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_zeroI
thf(fact_52_mult__0,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ zero_zero_nat @ N )
      = zero_zero_nat ) )).

% mult_0
thf(fact_53_bot__nat__0_Oextremum__strict,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ zero_zero_nat ) )).

% bot_nat_0.extremum_strict
thf(fact_54_infinite__descent0,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ( P2 @ zero_zero_nat )
     => ( ! [N2: nat] :
            ( ( ord_less_nat @ zero_zero_nat @ N2 )
           => ( ~ ( P2 @ N2 )
             => ? [M2: nat] :
                  ( ( ord_less_nat @ M2 @ N2 )
                  & ~ ( P2 @ M2 ) ) ) )
       => ( P2 @ N ) ) ) )).

% infinite_descent0
thf(fact_55_gr__implies__not0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not0
thf(fact_56_less__zeroE,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_zeroE
thf(fact_57_not__less0,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less0
thf(fact_58_not__gr0,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr0
thf(fact_59_gr0I,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr0I
thf(fact_60_nat__mult__less__cancel__disj,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
        & ( ord_less_nat @ M @ N ) ) ) )).

% nat_mult_less_cancel_disj
thf(fact_61_sum_Oneutral__const,axiom,(
    ! [A3: set_nat] :
      ( ( groups1842438620at_nat
        @ ^ [Uu: nat] : zero_zero_nat
        @ A3 )
      = zero_zero_nat ) )).

% sum.neutral_const
thf(fact_62_mult__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ( times_times_nat @ A @ C )
        = ( times_times_nat @ B @ C ) )
      = ( ( C = zero_zero_nat )
        | ( A = B ) ) ) )).

% mult_cancel_right
thf(fact_63_mult__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ( times_times_nat @ C @ A )
        = ( times_times_nat @ C @ B ) )
      = ( ( C = zero_zero_nat )
        | ( A = B ) ) ) )).

% mult_cancel_left
thf(fact_64_mult__eq__0__iff,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
        = zero_zero_nat )
      = ( ( A = zero_zero_nat )
        | ( B = zero_zero_nat ) ) ) )).

% mult_eq_0_iff
thf(fact_65_mult__zero__right,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ zero_zero_nat )
      = zero_zero_nat ) )).

% mult_zero_right
thf(fact_66_mult__zero__left,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% mult_zero_left
thf(fact_67_sum_Ocong,axiom,(
    ! [A3: set_nat,B3: set_nat,G: nat > nat,H: nat > nat] :
      ( ( A3 = B3 )
     => ( ! [X3: nat] :
            ( ( member_nat @ X3 @ B3 )
           => ( ( G @ X3 )
              = ( H @ X3 ) ) )
       => ( ( groups1842438620at_nat @ G @ A3 )
          = ( groups1842438620at_nat @ H @ B3 ) ) ) ) )).

% sum.cong
thf(fact_68_sum_Oeq__general,axiom,(
    ! [B3: set_nat,A3: set_nat,H: nat > nat,Gamma: nat > nat,Phi: nat > nat] :
      ( ! [Y2: nat] :
          ( ( member_nat @ Y2 @ B3 )
         => ? [X4: nat] :
              ( ( member_nat @ X4 @ A3 )
              & ( ( H @ X4 )
                = Y2 )
              & ! [Ya: nat] :
                  ( ( ( member_nat @ Ya @ A3 )
                    & ( ( H @ Ya )
                      = Y2 ) )
                 => ( Ya = X4 ) ) ) )
     => ( ! [X3: nat] :
            ( ( member_nat @ X3 @ A3 )
           => ( ( member_nat @ ( H @ X3 ) @ B3 )
              & ( ( Gamma @ ( H @ X3 ) )
                = ( Phi @ X3 ) ) ) )
       => ( ( groups1842438620at_nat @ Phi @ A3 )
          = ( groups1842438620at_nat @ Gamma @ B3 ) ) ) ) )).

% sum.eq_general
thf(fact_69_sum_Oeq__general__inverses,axiom,(
    ! [B3: set_nat,K: nat > nat,A3: set_nat,H: nat > nat,Gamma: nat > nat,Phi: nat > nat] :
      ( ! [Y2: nat] :
          ( ( member_nat @ Y2 @ B3 )
         => ( ( member_nat @ ( K @ Y2 ) @ A3 )
            & ( ( H @ ( K @ Y2 ) )
              = Y2 ) ) )
     => ( ! [X3: nat] :
            ( ( member_nat @ X3 @ A3 )
           => ( ( member_nat @ ( H @ X3 ) @ B3 )
              & ( ( K @ ( H @ X3 ) )
                = X3 )
              & ( ( Gamma @ ( H @ X3 ) )
                = ( Phi @ X3 ) ) ) )
       => ( ( groups1842438620at_nat @ Phi @ A3 )
          = ( groups1842438620at_nat @ Gamma @ B3 ) ) ) ) )).

% sum.eq_general_inverses
thf(fact_70_sum_Oreindex__bij__witness,axiom,(
    ! [S2: set_nat,I2: nat > nat,J: nat > nat,T2: set_nat,H: nat > nat,G: nat > nat] :
      ( ! [A4: nat] :
          ( ( member_nat @ A4 @ S2 )
         => ( ( I2 @ ( J @ A4 ) )
            = A4 ) )
     => ( ! [A4: nat] :
            ( ( member_nat @ A4 @ S2 )
           => ( member_nat @ ( J @ A4 ) @ T2 ) )
       => ( ! [B4: nat] :
              ( ( member_nat @ B4 @ T2 )
             => ( ( J @ ( I2 @ B4 ) )
                = B4 ) )
         => ( ! [B4: nat] :
                ( ( member_nat @ B4 @ T2 )
               => ( member_nat @ ( I2 @ B4 ) @ S2 ) )
           => ( ! [A4: nat] :
                  ( ( member_nat @ A4 @ S2 )
                 => ( ( H @ ( J @ A4 ) )
                    = ( G @ A4 ) ) )
             => ( ( groups1842438620at_nat @ G @ S2 )
                = ( groups1842438620at_nat @ H @ T2 ) ) ) ) ) ) ) )).

% sum.reindex_bij_witness
thf(fact_71_sum_Oswap,axiom,(
    ! [G: nat > nat > nat,B3: set_nat,A3: set_nat] :
      ( ( groups1842438620at_nat
        @ ^ [I: nat] :
            ( groups1842438620at_nat @ ( G @ I ) @ B3 )
        @ A3 )
      = ( groups1842438620at_nat
        @ ^ [J2: nat] :
            ( groups1842438620at_nat
            @ ^ [I: nat] :
                ( G @ I @ J2 )
            @ A3 )
        @ B3 ) ) )).

% sum.swap
thf(fact_72_mult__not__zero,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
       != zero_zero_nat )
     => ( ( A != zero_zero_nat )
        & ( B != zero_zero_nat ) ) ) )).

% mult_not_zero
thf(fact_73_divisors__zero,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
        = zero_zero_nat )
     => ( ( A = zero_zero_nat )
        | ( B = zero_zero_nat ) ) ) )).

% divisors_zero
thf(fact_74_no__zero__divisors,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != zero_zero_nat )
     => ( ( B != zero_zero_nat )
       => ( ( times_times_nat @ A @ B )
         != zero_zero_nat ) ) ) )).

% no_zero_divisors
thf(fact_75_mult__left__cancel,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( ( times_times_nat @ C @ A )
          = ( times_times_nat @ C @ B ) )
        = ( A = B ) ) ) )).

% mult_left_cancel
thf(fact_76_mult__right__cancel,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( ( times_times_nat @ A @ C )
          = ( times_times_nat @ B @ C ) )
        = ( A = B ) ) ) )).

% mult_right_cancel
thf(fact_77_zero__neq__one,axiom,(
    zero_zero_nat != one_one_nat )).

% zero_neq_one
thf(fact_78_sum_Oneutral,axiom,(
    ! [A3: set_nat,G: nat > nat] :
      ( ! [X3: nat] :
          ( ( member_nat @ X3 @ A3 )
         => ( ( G @ X3 )
            = zero_zero_nat ) )
     => ( ( groups1842438620at_nat @ G @ A3 )
        = zero_zero_nat ) ) )).

% sum.neutral
thf(fact_79_sum_Onot__neutral__contains__not__neutral,axiom,(
    ! [G: nat > nat,A3: set_nat] :
      ( ( ( groups1842438620at_nat @ G @ A3 )
       != zero_zero_nat )
     => ~ ! [A4: nat] :
            ( ( member_nat @ A4 @ A3 )
           => ( ( G @ A4 )
              = zero_zero_nat ) ) ) )).

% sum.not_neutral_contains_not_neutral
thf(fact_80_nat__mult__eq__cancel__disj,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times_nat @ K @ M )
        = ( times_times_nat @ K @ N ) )
      = ( ( K = zero_zero_nat )
        | ( M = N ) ) ) )).

% nat_mult_eq_cancel_disj
thf(fact_81_lambda__zero,axiom,
    ( ( ^ [H2: nat] : zero_zero_nat )
    = ( times_times_nat @ zero_zero_nat ) )).

% lambda_zero
thf(fact_82_lambda__one,axiom,
    ( ( ^ [X2: nat] : X2 )
    = ( times_times_nat @ one_one_nat ) )).

% lambda_one
thf(fact_83_sum__product,axiom,(
    ! [F: nat > nat,A3: set_nat,G: nat > nat,B3: set_nat] :
      ( ( times_times_nat @ ( groups1842438620at_nat @ F @ A3 ) @ ( groups1842438620at_nat @ G @ B3 ) )
      = ( groups1842438620at_nat
        @ ^ [I: nat] :
            ( groups1842438620at_nat
            @ ^ [J2: nat] :
                ( times_times_nat @ ( F @ I ) @ ( G @ J2 ) )
            @ B3 )
        @ A3 ) ) )).

% sum_product
thf(fact_84_sum__distrib__left,axiom,(
    ! [R: nat,F: nat > nat,A3: set_nat] :
      ( ( times_times_nat @ R @ ( groups1842438620at_nat @ F @ A3 ) )
      = ( groups1842438620at_nat
        @ ^ [N3: nat] :
            ( times_times_nat @ R @ ( F @ N3 ) )
        @ A3 ) ) )).

% sum_distrib_left
thf(fact_85_sum__distrib__right,axiom,(
    ! [F: nat > nat,A3: set_nat,R: nat] :
      ( ( times_times_nat @ ( groups1842438620at_nat @ F @ A3 ) @ R )
      = ( groups1842438620at_nat
        @ ^ [N3: nat] :
            ( times_times_nat @ ( F @ N3 ) @ R )
        @ A3 ) ) )).

% sum_distrib_right
thf(fact_86_mult__neg__pos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ zero_zero_nat )
     => ( ( ord_less_nat @ zero_zero_nat @ B )
       => ( ord_less_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_neg_pos
thf(fact_87_mult__pos__neg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ B @ zero_zero_nat )
       => ( ord_less_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_pos_neg
thf(fact_88_mult__pos__pos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ zero_zero_nat @ B )
       => ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ A @ B ) ) ) ) )).

% mult_pos_pos
thf(fact_89_mult__pos__neg2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ A )
     => ( ( ord_less_nat @ B @ zero_zero_nat )
       => ( ord_less_nat @ ( times_times_nat @ B @ A ) @ zero_zero_nat ) ) ) )).

% mult_pos_neg2
thf(fact_90_zero__less__mult__pos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ A @ B ) )
     => ( ( ord_less_nat @ zero_zero_nat @ A )
       => ( ord_less_nat @ zero_zero_nat @ B ) ) ) )).

% zero_less_mult_pos
thf(fact_91_zero__less__mult__pos2,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( times_times_nat @ B @ A ) )
     => ( ( ord_less_nat @ zero_zero_nat @ A )
       => ( ord_less_nat @ zero_zero_nat @ B ) ) ) )).

% zero_less_mult_pos2
thf(fact_92_mult__strict__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ zero_zero_nat @ C )
       => ( ord_less_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% mult_strict_left_mono
thf(fact_93_mult__strict__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ zero_zero_nat @ C )
       => ( ord_less_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) ) )).

% mult_strict_right_mono
thf(fact_94_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ zero_zero_nat @ C )
       => ( ord_less_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_95_zero__less__one,axiom,(
    ord_less_nat @ zero_zero_nat @ one_one_nat )).

% zero_less_one
thf(fact_96_not__one__less__zero,axiom,(
    ~ ( ord_less_nat @ one_one_nat @ zero_zero_nat ) )).

% not_one_less_zero
thf(fact_97_less__1__mult,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ one_one_nat @ M )
     => ( ( ord_less_nat @ one_one_nat @ N )
       => ( ord_less_nat @ one_one_nat @ ( times_times_nat @ M @ N ) ) ) ) )).

% less_1_mult
thf(fact_98_nat__mult__eq__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ K )
     => ( ( ( times_times_nat @ K @ M )
          = ( times_times_nat @ K @ N ) )
        = ( M = N ) ) ) )).

% nat_mult_eq_cancel1
thf(fact_99_nat__mult__less__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ K )
     => ( ( ord_less_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
        = ( ord_less_nat @ M @ N ) ) ) )).

% nat_mult_less_cancel1
thf(fact_100__092_060open_062k_A_092_060le_062_Am_092_060close_062,axiom,(
    ord_less_eq_nat @ k @ m )).

% \<open>k \<le> m\<close>
thf(fact_101_less__numeral__extra_I1_J,axiom,(
    ord_less_nat @ zero_zero_nat @ one_one_nat )).

% less_numeral_extra(1)
thf(fact_102_atMost__eq__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ( set_ord_atMost_nat @ X )
        = ( set_ord_atMost_nat @ Y ) )
      = ( X = Y ) ) )).

% atMost_eq_iff
thf(fact_103_partitions__def,axiom,
    ( number1551313001itions
    = ( ^ [P3: nat > nat,N3: nat] :
          ( ! [I: nat] :
              ( ( ( P3 @ I )
               != zero_zero_nat )
             => ( ( ord_less_eq_nat @ one_one_nat @ I )
                & ( ord_less_eq_nat @ I @ N3 ) ) )
          & ( ( groups1842438620at_nat
              @ ^ [I: nat] :
                  ( times_times_nat @ ( P3 @ I ) @ I )
              @ ( set_ord_atMost_nat @ N3 ) )
            = N3 ) ) ) )).

% partitions_def
thf(fact_104_partitionsI,axiom,(
    ! [P: nat > nat,N: nat] :
      ( ! [I3: nat] :
          ( ( ( P @ I3 )
           != zero_zero_nat )
         => ( ( ord_less_eq_nat @ one_one_nat @ I3 )
            & ( ord_less_eq_nat @ I3 @ N ) ) )
     => ( ( ( groups1842438620at_nat
            @ ^ [I: nat] :
                ( times_times_nat @ ( P @ I ) @ I )
            @ ( set_ord_atMost_nat @ N ) )
          = N )
       => ( number1551313001itions @ P @ N ) ) ) )).

% partitionsI
thf(fact_105_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_106_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_107_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_108_atMost__iff,axiom,(
    ! [I2: set_nat,K: set_nat] :
      ( ( member_set_nat @ I2 @ ( set_or1086813439et_nat @ K ) )
      = ( ord_less_eq_set_nat @ I2 @ K ) ) )).

% atMost_iff
thf(fact_109_atMost__iff,axiom,(
    ! [I2: nat,K: nat] :
      ( ( member_nat @ I2 @ ( set_ord_atMost_nat @ K ) )
      = ( ord_less_eq_nat @ I2 @ K ) ) )).

% atMost_iff
thf(fact_110_atMost__subset__iff,axiom,(
    ! [X: set_nat,Y: set_nat] :
      ( ( ord_le1613022364et_nat @ ( set_or1086813439et_nat @ X ) @ ( set_or1086813439et_nat @ Y ) )
      = ( ord_less_eq_set_nat @ X @ Y ) ) )).

% atMost_subset_iff
thf(fact_111_atMost__subset__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_set_nat @ ( set_ord_atMost_nat @ X ) @ ( set_ord_atMost_nat @ Y ) )
      = ( ord_less_eq_nat @ X @ Y ) ) )).

% atMost_subset_iff
thf(fact_112_mult__le__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% mult_le_cancel2
thf(fact_113_nat__mult__le__cancel__disj,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ K )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% nat_mult_le_cancel_disj
thf(fact_114_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ zero_zero_nat )).

% le_numeral_extra(3)
thf(fact_115_le__numeral__extra_I4_J,axiom,(
    ord_less_eq_nat @ one_one_nat @ one_one_nat )).

% le_numeral_extra(4)
thf(fact_116_bounded__Max__nat,axiom,(
    ! [P2: nat > $o,X: nat,M3: nat] :
      ( ( P2 @ X )
     => ( ! [X3: nat] :
            ( ( P2 @ X3 )
           => ( ord_less_eq_nat @ X3 @ M3 ) )
       => ~ ! [M4: nat] :
              ( ( P2 @ M4 )
             => ~ ! [X4: nat] :
                    ( ( P2 @ X4 )
                   => ( ord_less_eq_nat @ X4 @ M4 ) ) ) ) ) )).

% bounded_Max_nat
thf(fact_117_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_118_le__trans,axiom,(
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I2 @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I2 @ K ) ) ) )).

% le_trans
thf(fact_119_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_120_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_121_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_122_Nat_Oex__has__greatest__nat,axiom,(
    ! [P2: nat > $o,K: nat,B: nat] :
      ( ( P2 @ K )
     => ( ! [Y2: nat] :
            ( ( P2 @ Y2 )
           => ( ord_less_eq_nat @ Y2 @ B ) )
       => ? [X3: nat] :
            ( ( P2 @ X3 )
            & ! [Y3: nat] :
                ( ( P2 @ Y3 )
               => ( ord_less_eq_nat @ Y3 @ X3 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_123_atMost__def,axiom,
    ( set_or1086813439et_nat
    = ( ^ [U: set_nat] :
          ( collect_set_nat
          @ ^ [X2: set_nat] :
              ( ord_less_eq_set_nat @ X2 @ U ) ) ) )).

% atMost_def
thf(fact_124_atMost__def,axiom,
    ( set_ord_atMost_nat
    = ( ^ [U: nat] :
          ( collect_nat
          @ ^ [X2: nat] :
              ( ord_less_eq_nat @ X2 @ U ) ) ) )).

% atMost_def
thf(fact_125_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_126_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI
thf(fact_127_bot__nat__0_Oextremum__unique,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
      = ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique
thf(fact_128_le__0__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_0_eq
thf(fact_129_less__eq__nat_Osimps_I1_J,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% less_eq_nat.simps(1)
thf(fact_130_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I2: nat,J: nat] :
      ( ! [I3: nat,J3: nat] :
          ( ( ord_less_nat @ I3 @ J3 )
         => ( ord_less_nat @ ( F @ I3 ) @ ( F @ J3 ) ) )
     => ( ( ord_less_eq_nat @ I2 @ J )
       => ( ord_less_eq_nat @ ( F @ I2 ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_131_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_132_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_133_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M5: nat,N3: nat] :
          ( ( ord_less_nat @ M5 @ N3 )
          | ( M5 = N3 ) ) ) )).

% le_eq_less_or_eq
thf(fact_134_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_135_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M5: nat,N3: nat] :
          ( ( ord_less_eq_nat @ M5 @ N3 )
          & ( M5 != N3 ) ) ) )).

% nat_less_le
thf(fact_136_mult__le__mono2,axiom,(
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I2 @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ K @ I2 ) @ ( times_times_nat @ K @ J ) ) ) )).

% mult_le_mono2
thf(fact_137_mult__le__mono1,axiom,(
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I2 @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ I2 @ K ) @ ( times_times_nat @ J @ K ) ) ) )).

% mult_le_mono1
thf(fact_138_mult__le__mono,axiom,(
    ! [I2: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I2 @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( times_times_nat @ I2 @ K ) @ ( times_times_nat @ J @ L ) ) ) ) )).

% mult_le_mono
thf(fact_139_le__square,axiom,(
    ! [M: nat] :
      ( ord_less_eq_nat @ M @ ( times_times_nat @ M @ M ) ) )).

% le_square
thf(fact_140_le__cube,axiom,(
    ! [M: nat] :
      ( ord_less_eq_nat @ M @ ( times_times_nat @ M @ ( times_times_nat @ M @ M ) ) ) )).

% le_cube
thf(fact_141_partitions__bounds,axiom,(
    ! [P: nat > nat,N: nat,I2: nat] :
      ( ( number1551313001itions @ P @ N )
     => ( ord_less_eq_nat @ ( P @ I2 ) @ N ) ) )).

% partitions_bounds
thf(fact_142_sum__mono,axiom,(
    ! [K2: set_nat,F: nat > nat,G: nat > nat] :
      ( ! [I3: nat] :
          ( ( member_nat @ I3 @ K2 )
         => ( ord_less_eq_nat @ ( F @ I3 ) @ ( G @ I3 ) ) )
     => ( ord_less_eq_nat @ ( groups1842438620at_nat @ F @ K2 ) @ ( groups1842438620at_nat @ G @ K2 ) ) ) )).

% sum_mono
thf(fact_143_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_144_mult__nonneg__nonpos2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( times_times_nat @ B @ A ) @ zero_zero_nat ) ) ) )).

% mult_nonneg_nonpos2
thf(fact_145_mult__nonpos__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_nonpos_nonneg
thf(fact_146_mult__nonneg__nonpos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_nonneg_nonpos
thf(fact_147_mult__nonneg__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ zero_zero_nat @ ( times_times_nat @ A @ B ) ) ) ) )).

% mult_nonneg_nonneg
thf(fact_148_split__mult__neg__le,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( ( ord_less_eq_nat @ zero_zero_nat @ A )
          & ( ord_less_eq_nat @ B @ zero_zero_nat ) )
        | ( ( ord_less_eq_nat @ A @ zero_zero_nat )
          & ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )
     => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) )).

% split_mult_neg_le
thf(fact_149_mult__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) ) )).

% mult_right_mono
thf(fact_150_mult__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% mult_left_mono
thf(fact_151_mult__mono_H,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_mono'
thf(fact_152_mult__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_mono
thf(fact_153_zero__le__one,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ one_one_nat )).

% zero_le_one
thf(fact_154_not__one__le__zero,axiom,(
    ~ ( ord_less_eq_nat @ one_one_nat @ zero_zero_nat ) )).

% not_one_le_zero
thf(fact_155_sum__nonpos,axiom,(
    ! [A3: set_nat,F: nat > nat] :
      ( ! [X3: nat] :
          ( ( member_nat @ X3 @ A3 )
         => ( ord_less_eq_nat @ ( F @ X3 ) @ zero_zero_nat ) )
     => ( ord_less_eq_nat @ ( groups1842438620at_nat @ F @ A3 ) @ zero_zero_nat ) ) )).

% sum_nonpos
thf(fact_156_sum__nonneg,axiom,(
    ! [A3: set_nat,F: nat > nat] :
      ( ! [X3: nat] :
          ( ( member_nat @ X3 @ A3 )
         => ( ord_less_eq_nat @ zero_zero_nat @ ( F @ X3 ) ) )
     => ( ord_less_eq_nat @ zero_zero_nat @ ( groups1842438620at_nat @ F @ A3 ) ) ) )).

% sum_nonneg
thf(fact_157_ex__least__nat__le,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ( P2 @ N )
     => ( ~ ( P2 @ zero_zero_nat )
       => ? [K3: nat] :
            ( ( ord_less_eq_nat @ K3 @ N )
            & ! [I4: nat] :
                ( ( ord_less_nat @ I4 @ K3 )
               => ~ ( P2 @ I4 ) )
            & ( P2 @ K3 ) ) ) ) )).

% ex_least_nat_le
thf(fact_158_mult__left__less__imp__less,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_nat @ A @ B ) ) ) )).

% mult_left_less_imp_less
thf(fact_159_mult__strict__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ C @ D )
       => ( ( ord_less_nat @ zero_zero_nat @ B )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_strict_mono
thf(fact_160_mult__right__less__imp__less,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_nat @ A @ B ) ) ) )).

% mult_right_less_imp_less
thf(fact_161_mult__strict__mono_H,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_strict_mono'
thf(fact_162_mult__left__le__imp__le,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) )
     => ( ( ord_less_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ A @ B ) ) ) )).

% mult_left_le_imp_le
thf(fact_163_mult__right__le__imp__le,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) )
     => ( ( ord_less_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ A @ B ) ) ) )).

% mult_right_le_imp_le
thf(fact_164_mult__le__less__imp__less,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ C @ D )
       => ( ( ord_less_nat @ zero_zero_nat @ A )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_le_less_imp_less
thf(fact_165_mult__less__le__imp__less,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
         => ( ( ord_less_nat @ zero_zero_nat @ C )
           => ( ord_less_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_less_le_imp_less
thf(fact_166_mult__le__one,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ one_one_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ( ord_less_eq_nat @ B @ one_one_nat )
         => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ one_one_nat ) ) ) ) )).

% mult_le_one
thf(fact_167_mult__left__le,axiom,(
    ! [C: nat,A: nat] :
      ( ( ord_less_eq_nat @ C @ one_one_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ A ) ) ) )).

% mult_left_le
thf(fact_168_nat__mult__le__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ K )
     => ( ( ord_less_eq_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) )
        = ( ord_less_eq_nat @ M @ N ) ) ) )).

% nat_mult_le_cancel1
thf(fact_169_partitions__parts__bounded,axiom,(
    ! [P: nat > nat,N: nat] :
      ( ( number1551313001itions @ P @ N )
     => ( ord_less_eq_nat @ ( groups1842438620at_nat @ P @ ( set_ord_atMost_nat @ N ) ) @ N ) ) )).

% partitions_parts_bounded
thf(fact_170_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_nat @ zero_zero_nat @ zero_zero_nat ) )).

% less_numeral_extra(3)
thf(fact_171_less__numeral__extra_I4_J,axiom,(
    ~ ( ord_less_nat @ one_one_nat @ one_one_nat ) )).

% less_numeral_extra(4)
thf(fact_172_partitionsE,axiom,(
    ! [P: nat > nat,N: nat] :
      ( ( number1551313001itions @ P @ N )
     => ~ ( ! [I4: nat] :
              ( ( ( P @ I4 )
               != zero_zero_nat )
             => ( ( ord_less_eq_nat @ one_one_nat @ I4 )
                & ( ord_less_eq_nat @ I4 @ N ) ) )
         => ( ( groups1842438620at_nat
              @ ^ [I: nat] :
                  ( times_times_nat @ ( P @ I ) @ I )
              @ ( set_ord_atMost_nat @ N ) )
           != N ) ) ) )).

% partitionsE
thf(fact_173_order__refl,axiom,(
    ! [X: set_nat] :
      ( ord_less_eq_set_nat @ X @ X ) )).

% order_refl
thf(fact_174_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_175_nat__descend__induct,axiom,(
    ! [N: nat,P2: nat > $o,M: nat] :
      ( ! [K3: nat] :
          ( ( ord_less_nat @ N @ K3 )
         => ( P2 @ K3 ) )
     => ( ! [K3: nat] :
            ( ( ord_less_eq_nat @ K3 @ N )
           => ( ! [I4: nat] :
                  ( ( ord_less_nat @ K3 @ I4 )
                 => ( P2 @ I4 ) )
             => ( P2 @ K3 ) ) )
       => ( P2 @ M ) ) ) )).

% nat_descend_induct
thf(fact_176_order__subst1,axiom,(
    ! [A: nat,F: set_nat > nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X3: set_nat,Y2: set_nat] :
              ( ( ord_less_eq_set_nat @ X3 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_177_order__subst1,axiom,(
    ! [A: set_nat,F: nat > set_nat,B: nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y2 )
             => ( ord_less_eq_set_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_set_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_178_order__subst1,axiom,(
    ! [A: set_nat,F: set_nat > set_nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X3: set_nat,Y2: set_nat] :
              ( ( ord_less_eq_set_nat @ X3 @ Y2 )
             => ( ord_less_eq_set_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_set_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_179_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_180_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_set_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y2 )
             => ( ord_less_eq_set_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_set_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_181_order__subst2,axiom,(
    ! [A: set_nat,B: set_nat,F: set_nat > nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: set_nat,Y2: set_nat] :
              ( ( ord_less_eq_set_nat @ X3 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_182_order__subst2,axiom,(
    ! [A: set_nat,B: set_nat,F: set_nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ord_less_eq_set_nat @ ( F @ B ) @ C )
       => ( ! [X3: set_nat,Y2: set_nat] :
              ( ( ord_less_eq_set_nat @ X3 @ Y2 )
             => ( ord_less_eq_set_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_set_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_183_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_184_ord__eq__le__subst,axiom,(
    ! [A: set_nat,F: nat > set_nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y2 )
             => ( ord_less_eq_set_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_set_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_185_ord__eq__le__subst,axiom,(
    ! [A: nat,F: set_nat > nat,B: set_nat,C: set_nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X3: set_nat,Y2: set_nat] :
              ( ( ord_less_eq_set_nat @ X3 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_186_ord__eq__le__subst,axiom,(
    ! [A: set_nat,F: set_nat > set_nat,B: set_nat,C: set_nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ! [X3: set_nat,Y2: set_nat] :
              ( ( ord_less_eq_set_nat @ X3 @ Y2 )
             => ( ord_less_eq_set_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_set_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_187_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_188_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y2 )
             => ( ord_less_eq_set_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_set_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_189_ord__le__eq__subst,axiom,(
    ! [A: set_nat,B: set_nat,F: set_nat > nat,C: nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: set_nat,Y2: set_nat] :
              ( ( ord_less_eq_set_nat @ X3 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_190_ord__le__eq__subst,axiom,(
    ! [A: set_nat,B: set_nat,F: set_nat > set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: set_nat,Y2: set_nat] :
              ( ( ord_less_eq_set_nat @ X3 @ Y2 )
             => ( ord_less_eq_set_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_set_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_191_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_192_eq__iff,axiom,
    ( ( ^ [Y4: set_nat,Z: set_nat] : ( Y4 = Z ) )
    = ( ^ [X2: set_nat,Y5: set_nat] :
          ( ( ord_less_eq_set_nat @ X2 @ Y5 )
          & ( ord_less_eq_set_nat @ Y5 @ X2 ) ) ) )).

% eq_iff
thf(fact_193_eq__iff,axiom,
    ( ( ^ [Y4: nat,Z: nat] : ( Y4 = Z ) )
    = ( ^ [X2: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X2 @ Y5 )
          & ( ord_less_eq_nat @ Y5 @ X2 ) ) ) )).

% eq_iff
thf(fact_194_antisym,axiom,(
    ! [X: set_nat,Y: set_nat] :
      ( ( ord_less_eq_set_nat @ X @ Y )
     => ( ( ord_less_eq_set_nat @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_195_antisym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_196_linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_eq_nat @ Y @ X ) ) )).

% linear
thf(fact_197_eq__refl,axiom,(
    ! [X: set_nat,Y: set_nat] :
      ( ( X = Y )
     => ( ord_less_eq_set_nat @ X @ Y ) ) )).

% eq_refl
thf(fact_198_eq__refl,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X = Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% eq_refl
thf(fact_199_le__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% le_cases
thf(fact_200_order_Otrans,axiom,(
    ! [A: set_nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ord_less_eq_set_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_201_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_202_le__cases3,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y )
       => ~ ( ord_less_eq_nat @ Y @ Z2 ) )
     => ( ( ( ord_less_eq_nat @ Y @ X )
         => ~ ( ord_less_eq_nat @ X @ Z2 ) )
       => ( ( ( ord_less_eq_nat @ X @ Z2 )
           => ~ ( ord_less_eq_nat @ Z2 @ Y ) )
         => ( ( ( ord_less_eq_nat @ Z2 @ Y )
             => ~ ( ord_less_eq_nat @ Y @ X ) )
           => ( ( ( ord_less_eq_nat @ Y @ Z2 )
               => ~ ( ord_less_eq_nat @ Z2 @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z2 @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_203_antisym__conv,axiom,(
    ! [Y: set_nat,X: set_nat] :
      ( ( ord_less_eq_set_nat @ Y @ X )
     => ( ( ord_less_eq_set_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_204_antisym__conv,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_205_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: set_nat,Z: set_nat] : ( Y4 = Z ) )
    = ( ^ [A2: set_nat,B2: set_nat] :
          ( ( ord_less_eq_set_nat @ A2 @ B2 )
          & ( ord_less_eq_set_nat @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_206_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: nat,Z: nat] : ( Y4 = Z ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( ord_less_eq_nat @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_207_ord__eq__le__trans,axiom,(
    ! [A: set_nat,B: set_nat,C: set_nat] :
      ( ( A = B )
     => ( ( ord_less_eq_set_nat @ B @ C )
       => ( ord_less_eq_set_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_208_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_209_ord__le__eq__trans,axiom,(
    ! [A: set_nat,B: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_set_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_210_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_211_order__class_Oorder_Oantisym,axiom,(
    ! [A: set_nat,B: set_nat] :
      ( ( ord_less_eq_set_nat @ A @ B )
     => ( ( ord_less_eq_set_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_212_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_213_order__trans,axiom,(
    ! [X: set_nat,Y: set_nat,Z2: set_nat] :
      ( ( ord_less_eq_set_nat @ X @ Y )
     => ( ( ord_less_eq_set_nat @ Y @ Z2 )
       => ( ord_less_eq_set_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_214_order__trans,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z2 )
       => ( ord_less_eq_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_215_dual__order_Orefl,axiom,(
    ! [A: set_nat] :
      ( ord_less_eq_set_nat @ A @ A ) )).

% dual_order.refl
thf(fact_216_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_217_linorder__wlog,axiom,(
    ! [P2: nat > nat > $o,A: nat,B: nat] :
      ( ! [A4: nat,B4: nat] :
          ( ( ord_less_eq_nat @ A4 @ B4 )
         => ( P2 @ A4 @ B4 ) )
     => ( ! [A4: nat,B4: nat] :
            ( ( P2 @ B4 @ A4 )
           => ( P2 @ A4 @ B4 ) )
       => ( P2 @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_218_dual__order_Otrans,axiom,(
    ! [B: set_nat,A: set_nat,C: set_nat] :
      ( ( ord_less_eq_set_nat @ B @ A )
     => ( ( ord_less_eq_set_nat @ C @ B )
       => ( ord_less_eq_set_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_219_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_220_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: set_nat,Z: set_nat] : ( Y4 = Z ) )
    = ( ^ [A2: set_nat,B2: set_nat] :
          ( ( ord_less_eq_set_nat @ B2 @ A2 )
          & ( ord_less_eq_set_nat @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_221_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: nat,Z: nat] : ( Y4 = Z ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( ord_less_eq_nat @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_222_dual__order_Oantisym,axiom,(
    ! [B: set_nat,A: set_nat] :
      ( ( ord_less_eq_set_nat @ B @ A )
     => ( ( ord_less_eq_set_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_223_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_224_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y2: nat] :
              ( ( ord_less_nat @ X3 @ Y2 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_225_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y2: nat] :
              ( ( ord_less_nat @ X3 @ Y2 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_226_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y2: nat] :
              ( ( ord_less_nat @ X3 @ Y2 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_227_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y2: nat] :
              ( ( ord_less_nat @ X3 @ Y2 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_228_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_229_neqE,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% neqE

% Conjectures (1)
thf(conj_0,conjecture,(
    $false )).

%------------------------------------------------------------------------------
