%------------------------------------------------------------------------------
% File     : SLH513^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Number_Partition problem prob_179__5326412_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Number_Partition/prob_179__5326412_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  228 (   0 unit;  14 type;   0 defn)
%            Number of atoms       : 1941 ( 176 equality;1195 variable)
%            Maximal formula depth :   18 (   7 average)
%            Number of connectives : 1470 (  95   ~;  21   |;  26   &;1068   @)
%                                         (   0 <=>; 260  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   77 (  77   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   18 (  14   :;   0   =)
%            Number of variables   :  552 (   1 sgn; 479   !;  32   ?;  41   ^)
%                                         ( 552   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:43:07.228
%------------------------------------------------------------------------------
% Could-be-implicit typings (1)
thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (13)
thf(sy_c_Fun_Ofun__upd_001t__Nat__Onat_001t__Nat__Onat,type,(
    fun_upd_nat_nat: ( nat > nat ) > nat > nat > nat > nat )).

thf(sy_c_Groups_Ominus__class_Ominus_001t__Nat__Onat,type,(
    minus_minus_nat: nat > nat > nat )).

thf(sy_c_Groups_Oone__class_Oone_001t__Nat__Onat,type,(
    one_one_nat: nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_If_001t__Nat__Onat,type,(
    if_nat: $o > nat > nat > nat )).

thf(sy_c_Nat_OSuc,type,(
    suc: nat > nat )).

thf(sy_c_Number__Partition__Mirabelle__zerdlymyoj_Opartitions,type,(
    number1551313001itions: ( nat > nat ) > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_v_i____,type,(
    i: nat )).

thf(sy_v_k,type,(
    k: nat )).

thf(sy_v_n,type,(
    n: nat )).

thf(sy_v_p,type,(
    p: nat > nat )).

% Relevant facts (210)
thf(fact_0_gr0,axiom,(
    ord_less_nat @ zero_zero_nat @ ( p @ k ) )).

% gr0
thf(fact_1_partitions,axiom,(
    number1551313001itions @ p @ n )).

% partitions
thf(fact_2_partitions__remove1__bounds,axiom,(
    ! [P: nat > nat,N: nat,K: nat,I: nat] :
      ( ( number1551313001itions @ P @ N )
     => ( ( ord_less_nat @ zero_zero_nat @ ( P @ K ) )
       => ( ( ( fun_upd_nat_nat @ P @ K @ ( minus_minus_nat @ ( P @ K ) @ one_one_nat ) @ I )
           != zero_zero_nat )
         => ( ( ord_less_eq_nat @ one_one_nat @ I )
            & ( ord_less_eq_nat @ I @ ( minus_minus_nat @ N @ K ) ) ) ) ) ) )).

% partitions_remove1_bounds
thf(fact_3__092_060open_062_Ip_Ik_A_058_061_Ap_Ak_A_N_A1_J_J_Ai_A_092_060noteq_062_A0_092_060close_062,axiom,(
    ( fun_upd_nat_nat @ p @ k @ ( minus_minus_nat @ ( p @ k ) @ one_one_nat ) @ i )
 != zero_zero_nat )).

% \<open>(p(k := p k - 1)) i \<noteq> 0\<close>
thf(fact_4_diff__diff__cancel,axiom,(
    ! [I: nat,N: nat] :
      ( ( ord_less_eq_nat @ I @ N )
     => ( ( minus_minus_nat @ N @ ( minus_minus_nat @ N @ I ) )
        = I ) ) )).

% diff_diff_cancel
thf(fact_5_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_6_partitions__bounds,axiom,(
    ! [P: nat > nat,N: nat,I: nat] :
      ( ( number1551313001itions @ P @ N )
     => ( ord_less_eq_nat @ ( P @ I ) @ N ) ) )).

% partitions_bounds
thf(fact_7_eq__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ( minus_minus_nat @ M @ K )
            = ( minus_minus_nat @ N @ K ) )
          = ( M = N ) ) ) ) )).

% eq_diff_iff
thf(fact_8_le__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( ord_less_eq_nat @ M @ N ) ) ) ) )).

% le_diff_iff
thf(fact_9_Nat_Odiff__diff__eq,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( minus_minus_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( minus_minus_nat @ M @ N ) ) ) ) )).

% Nat.diff_diff_eq
thf(fact_10_diff__le__mono,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ M @ L ) @ ( minus_minus_nat @ N @ L ) ) ) )).

% diff_le_mono
thf(fact_11_diff__le__self,axiom,(
    ! [M: nat,N: nat] :
      ( ord_less_eq_nat @ ( minus_minus_nat @ M @ N ) @ M ) )).

% diff_le_self
thf(fact_12_le__diff__iff_H,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ C )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ C @ A ) @ ( minus_minus_nat @ C @ B ) )
          = ( ord_less_eq_nat @ B @ A ) ) ) ) )).

% le_diff_iff'
thf(fact_13_diff__le__mono2,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ L @ N ) @ ( minus_minus_nat @ L @ M ) ) ) )).

% diff_le_mono2
thf(fact_14_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_15_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_16_cancel__comm__monoid__add__class_Odiff__cancel,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ A @ A )
      = zero_zero_nat ) )).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_17_diff__zero,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ A @ zero_zero_nat )
      = A ) )).

% diff_zero
thf(fact_18_zero__diff,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% zero_diff
thf(fact_19_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_20_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_21_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_22_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_23_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_24_diff__self__eq__0,axiom,(
    ! [M: nat] :
      ( ( minus_minus_nat @ M @ M )
      = zero_zero_nat ) )).

% diff_self_eq_0
thf(fact_25_diff__0__eq__0,axiom,(
    ! [N: nat] :
      ( ( minus_minus_nat @ zero_zero_nat @ N )
      = zero_zero_nat ) )).

% diff_0_eq_0
thf(fact_26_zero__less__diff,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( minus_minus_nat @ N @ M ) )
      = ( ord_less_nat @ M @ N ) ) )).

% zero_less_diff
thf(fact_27_diff__is__0__eq_H,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat ) ) )).

% diff_is_0_eq'
thf(fact_28_diff__is__0__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% diff_is_0_eq
thf(fact_29_less__one,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ N @ one_one_nat )
      = ( N = zero_zero_nat ) ) )).

% less_one
thf(fact_30_gr0I,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr0I
thf(fact_31_not__gr0,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr0
thf(fact_32_not__less0,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less0
thf(fact_33_less__zeroE,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_zeroE
thf(fact_34_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_35_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_36_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_37_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_38_gr__implies__not0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not0
thf(fact_39_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_40_nat__less__induct,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ( P2 @ M2 ) )
         => ( P2 @ N2 ) )
     => ( P2 @ N ) ) )).

% nat_less_induct
thf(fact_41_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_42_infinite__descent,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P2 @ N2 )
         => ? [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
              & ~ ( P2 @ M2 ) ) )
     => ( P2 @ N ) ) )).

% infinite_descent
thf(fact_43_infinite__descent0,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ( P2 @ zero_zero_nat )
     => ( ! [N2: nat] :
            ( ( ord_less_nat @ zero_zero_nat @ N2 )
           => ( ~ ( P2 @ N2 )
             => ? [M2: nat] :
                  ( ( ord_less_nat @ M2 @ N2 )
                  & ~ ( P2 @ M2 ) ) ) )
       => ( P2 @ N ) ) ) )).

% infinite_descent0
thf(fact_44_linorder__neqE__nat,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_45_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_46_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_47_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_48_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_49_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_50_bot__nat__0_Oextremum__strict,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ zero_zero_nat ) )).

% bot_nat_0.extremum_strict
thf(fact_51_neqE,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% neqE
thf(fact_52_neq__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
      = ( ( ord_less_nat @ X @ Y )
        | ( ord_less_nat @ Y @ X ) ) ) )).

% neq_iff
thf(fact_53_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_54_less__imp__neq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_55_less__asym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_asym
thf(fact_56_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_57_less__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% less_trans
thf(fact_58_less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
      | ( X = Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% less_linear
thf(fact_59_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_60_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_61_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_62_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_63_less__imp__not__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_64_less__not__sym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_not_sym
thf(fact_65_less__induct,axiom,(
    ! [P2: nat > $o,A: nat] :
      ( ! [X2: nat] :
          ( ! [Y3: nat] :
              ( ( ord_less_nat @ Y3 @ X2 )
             => ( P2 @ Y3 ) )
         => ( P2 @ X2 ) )
     => ( P2 @ A ) ) )).

% less_induct
thf(fact_66_antisym__conv3,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_67_less__imp__not__eq2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_68_less__imp__triv,axiom,(
    ! [X: nat,Y: nat,P2: $o] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ X )
       => P2 ) ) )).

% less_imp_triv
thf(fact_69_linorder__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_70_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_71_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_72_less__imp__not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_imp_not_less
thf(fact_73_exists__least__iff,axiom,
    ( ( ^ [P3: nat > $o] :
        ? [X3: nat] :
          ( P3 @ X3 ) )
    = ( ^ [P4: nat > $o] :
        ? [N3: nat] :
          ( ( P4 @ N3 )
          & ! [M3: nat] :
              ( ( ord_less_nat @ M3 @ N3 )
             => ~ ( P4 @ M3 ) ) ) ) )).

% exists_least_iff
thf(fact_74_linorder__less__wlog,axiom,(
    ! [P2: nat > nat > $o,A: nat,B: nat] :
      ( ! [A2: nat,B2: nat] :
          ( ( ord_less_nat @ A2 @ B2 )
         => ( P2 @ A2 @ B2 ) )
     => ( ! [A2: nat] :
            ( P2 @ A2 @ A2 )
       => ( ! [A2: nat,B2: nat] :
              ( ( P2 @ B2 @ A2 )
             => ( P2 @ A2 @ B2 ) )
         => ( P2 @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_75_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_76_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ( ord_less_nat @ Y @ X )
        | ( X = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_77_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_78_gr__zeroI,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_zeroI
thf(fact_79_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_80_not__less__zero,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less_zero
thf(fact_81_gr__implies__not__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not_zero
thf(fact_82_zero__less__iff__neq__zero,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( N != zero_zero_nat ) ) )).

% zero_less_iff_neq_zero
thf(fact_83_partitions__zero,axiom,(
    ! [P: nat > nat] :
      ( ( number1551313001itions @ P @ zero_zero_nat )
      = ( P
        = ( ^ [I2: nat] : zero_zero_nat ) ) ) )).

% partitions_zero
thf(fact_84_ex__least__nat__le,axiom,(
    ! [P2: nat > $o,N: nat] :
      ( ( P2 @ N )
     => ( ~ ( P2 @ zero_zero_nat )
       => ? [K2: nat] :
            ( ( ord_less_eq_nat @ K2 @ N )
            & ! [I3: nat] :
                ( ( ord_less_nat @ I3 @ K2 )
               => ~ ( P2 @ I3 ) )
            & ( P2 @ K2 ) ) ) ) )).

% ex_least_nat_le
thf(fact_85_diff__less,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( ord_less_nat @ zero_zero_nat @ M )
       => ( ord_less_nat @ ( minus_minus_nat @ M @ N ) @ M ) ) ) )).

% diff_less
thf(fact_86_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_87_dual__order_Ostrict__implies__order,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ord_less_eq_nat @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_88_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [B3: nat,A3: nat] :
          ( ( ord_less_eq_nat @ B3 @ A3 )
          & ( A3 != B3 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_89_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [B3: nat,A3: nat] :
          ( ( ord_less_nat @ B3 @ A3 )
          | ( A3 = B3 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_90_order_Ostrict__implies__order,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_91_dual__order_Ostrict__trans2,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_92_dual__order_Ostrict__trans1,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_93_order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A3 @ B3 )
          & ( A3 != B3 ) ) ) )).

% order.strict_iff_order
thf(fact_94_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [A3: nat,B3: nat] :
          ( ( ord_less_nat @ A3 @ B3 )
          | ( A3 = B3 ) ) ) )).

% order.order_iff_strict
thf(fact_95_order_Ostrict__trans2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_96_order_Ostrict__trans1,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_97_not__le__imp__less,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_eq_nat @ Y @ X )
     => ( ord_less_nat @ X @ Y ) ) )).

% not_le_imp_less
thf(fact_98_less__le__not__le,axiom,
    ( ord_less_nat
    = ( ^ [X4: nat,Y4: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y4 )
          & ~ ( ord_less_eq_nat @ Y4 @ X4 ) ) ) )).

% less_le_not_le
thf(fact_99_le__imp__less__or__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_nat @ X @ Y )
        | ( X = Y ) ) ) )).

% le_imp_less_or_eq
thf(fact_100_le__less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% le_less_linear
thf(fact_101_less__le__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% less_le_trans
thf(fact_102_le__less__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% le_less_trans
thf(fact_103_less__imp__le,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% less_imp_le
thf(fact_104_antisym__conv2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv2
thf(fact_105_antisym__conv1,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv1
thf(fact_106_le__neq__trans,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( A != B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_107_not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ord_less_eq_nat @ Y @ X ) ) )).

% not_less
thf(fact_108_not__le,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_eq_nat @ X @ Y ) )
      = ( ord_less_nat @ Y @ X ) ) )).

% not_le
thf(fact_109_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_110_order__less__le__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_111_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_112_order__le__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_113_less__le,axiom,
    ( ord_less_nat
    = ( ^ [X4: nat,Y4: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y4 )
          & ( X4 != Y4 ) ) ) )).

% less_le
thf(fact_114_le__less,axiom,
    ( ord_less_eq_nat
    = ( ^ [X4: nat,Y4: nat] :
          ( ( ord_less_nat @ X4 @ Y4 )
          | ( X4 = Y4 ) ) ) )).

% le_less
thf(fact_115_leI,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% leI
thf(fact_116_leD,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ~ ( ord_less_nat @ X @ Y ) ) )).

% leD
thf(fact_117_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_118_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I: nat,J: nat] :
      ( ! [I4: nat,J2: nat] :
          ( ( ord_less_nat @ I4 @ J2 )
         => ( ord_less_nat @ ( F @ I4 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I @ J )
       => ( ord_less_eq_nat @ ( F @ I ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_119_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_120_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_121_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M3: nat,N3: nat] :
          ( ( ord_less_nat @ M3 @ N3 )
          | ( M3 = N3 ) ) ) )).

% le_eq_less_or_eq
thf(fact_122_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_123_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M3: nat,N3: nat] :
          ( ( ord_less_eq_nat @ M3 @ N3 )
          & ( M3 != N3 ) ) ) )).

% nat_less_le
thf(fact_124_less__imp__diff__less,axiom,(
    ! [J: nat,K: nat,N: nat] :
      ( ( ord_less_nat @ J @ K )
     => ( ord_less_nat @ ( minus_minus_nat @ J @ N ) @ K ) ) )).

% less_imp_diff_less
thf(fact_125_diff__less__mono2,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ( ord_less_nat @ M @ L )
       => ( ord_less_nat @ ( minus_minus_nat @ L @ N ) @ ( minus_minus_nat @ L @ M ) ) ) ) )).

% diff_less_mono2
thf(fact_126_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI
thf(fact_127_bot__nat__0_Oextremum__unique,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
      = ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique
thf(fact_128_le__0__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_0_eq
thf(fact_129_less__eq__nat_Osimps_I1_J,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% less_eq_nat.simps(1)
thf(fact_130_minus__nat_Odiff__0,axiom,(
    ! [M: nat] :
      ( ( minus_minus_nat @ M @ zero_zero_nat )
      = M ) )).

% minus_nat.diff_0
thf(fact_131_diffs0__imp__equal,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat )
     => ( ( ( minus_minus_nat @ N @ M )
          = zero_zero_nat )
       => ( M = N ) ) ) )).

% diffs0_imp_equal
thf(fact_132_partitions__remaining__Max__part,axiom,(
    ! [P: nat > nat,N: nat,K: nat] :
      ( ( number1551313001itions @ P @ N )
     => ( ( ord_less_nat @ zero_zero_nat @ ( P @ K ) )
       => ! [I3: nat] :
            ( ( ( ord_less_nat @ ( minus_minus_nat @ N @ K ) @ I3 )
              & ( I3 != K ) )
           => ( ( P @ I3 )
              = zero_zero_nat ) ) ) ) )).

% partitions_remaining_Max_part
thf(fact_133_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_134_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y5: nat,Z2: nat] : ( Y5 = Z2 ) )
    = ( ^ [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ B3 @ A3 )
          & ( ord_less_eq_nat @ A3 @ B3 ) ) ) )).

% dual_order.eq_iff
thf(fact_135_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_136_linorder__wlog,axiom,(
    ! [P2: nat > nat > $o,A: nat,B: nat] :
      ( ! [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
         => ( P2 @ A2 @ B2 ) )
     => ( ! [A2: nat,B2: nat] :
            ( ( P2 @ B2 @ A2 )
           => ( P2 @ A2 @ B2 ) )
       => ( P2 @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_137_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_138_order__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z )
       => ( ord_less_eq_nat @ X @ Z ) ) ) )).

% order_trans
thf(fact_139_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_140_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_141_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_142_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y5: nat,Z2: nat] : ( Y5 = Z2 ) )
    = ( ^ [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A3 @ B3 )
          & ( ord_less_eq_nat @ B3 @ A3 ) ) ) )).

% order_class.order.eq_iff
thf(fact_143_antisym__conv,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_144_le__cases3,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y )
       => ~ ( ord_less_eq_nat @ Y @ Z ) )
     => ( ( ( ord_less_eq_nat @ Y @ X )
         => ~ ( ord_less_eq_nat @ X @ Z ) )
       => ( ( ( ord_less_eq_nat @ X @ Z )
           => ~ ( ord_less_eq_nat @ Z @ Y ) )
         => ( ( ( ord_less_eq_nat @ Z @ Y )
             => ~ ( ord_less_eq_nat @ Y @ X ) )
           => ( ( ( ord_less_eq_nat @ Y @ Z )
               => ~ ( ord_less_eq_nat @ Z @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_145_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_146_le__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% le_cases
thf(fact_147_eq__refl,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X = Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% eq_refl
thf(fact_148_linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_eq_nat @ Y @ X ) ) )).

% linear
thf(fact_149_antisym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_150_eq__iff,axiom,
    ( ( ^ [Y5: nat,Z2: nat] : ( Y5 = Z2 ) )
    = ( ^ [X4: nat,Y4: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y4 )
          & ( ord_less_eq_nat @ Y4 @ X4 ) ) ) )).

% eq_iff
thf(fact_151_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_152_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_153_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_154_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_155_cancel__ab__semigroup__add__class_Odiff__right__commute,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ C ) @ B )
      = ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C ) ) )).

% cancel_ab_semigroup_add_class.diff_right_commute
thf(fact_156_one__reorient,axiom,(
    ! [X: nat] :
      ( ( one_one_nat = X )
      = ( X = one_one_nat ) ) )).

% one_reorient
thf(fact_157_Nat_Oex__has__greatest__nat,axiom,(
    ! [P2: nat > $o,K: nat,B: nat] :
      ( ( P2 @ K )
     => ( ! [Y2: nat] :
            ( ( P2 @ Y2 )
           => ( ord_less_eq_nat @ Y2 @ B ) )
       => ? [X2: nat] :
            ( ( P2 @ X2 )
            & ! [Y3: nat] :
                ( ( P2 @ Y3 )
               => ( ord_less_eq_nat @ Y3 @ X2 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_158_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_159_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_160_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_161_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_162_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_163_diff__commute,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I @ J ) @ K )
      = ( minus_minus_nat @ ( minus_minus_nat @ I @ K ) @ J ) ) )).

% diff_commute
thf(fact_164_diff__less__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ A )
       => ( ord_less_nat @ ( minus_minus_nat @ A @ C ) @ ( minus_minus_nat @ B @ C ) ) ) ) )).

% diff_less_mono
thf(fact_165_less__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ord_less_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( ord_less_nat @ M @ N ) ) ) ) )).

% less_diff_iff
thf(fact_166_not__one__less__zero,axiom,(
    ~ ( ord_less_nat @ one_one_nat @ zero_zero_nat ) )).

% not_one_less_zero
thf(fact_167_zero__less__one,axiom,(
    ord_less_nat @ zero_zero_nat @ one_one_nat )).

% zero_less_one
thf(fact_168_less__numeral__extra_I1_J,axiom,(
    ord_less_nat @ zero_zero_nat @ one_one_nat )).

% less_numeral_extra(1)
thf(fact_169_not__one__le__zero,axiom,(
    ~ ( ord_less_eq_nat @ one_one_nat @ zero_zero_nat ) )).

% not_one_le_zero
thf(fact_170_zero__le__one,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ one_one_nat )).

% zero_le_one
thf(fact_171_fun__upd__upd,axiom,(
    ! [F: nat > nat,X: nat,Y: nat,Z: nat] :
      ( ( fun_upd_nat_nat @ ( fun_upd_nat_nat @ F @ X @ Y ) @ X @ Z )
      = ( fun_upd_nat_nat @ F @ X @ Z ) ) )).

% fun_upd_upd
thf(fact_172_fun__upd__triv,axiom,(
    ! [F: nat > nat,X: nat] :
      ( ( fun_upd_nat_nat @ F @ X @ ( F @ X ) )
      = F ) )).

% fun_upd_triv
thf(fact_173_fun__upd__apply,axiom,
    ( fun_upd_nat_nat
    = ( ^ [F2: nat > nat,X4: nat,Y4: nat,Z3: nat] :
          ( if_nat @ ( Z3 = X4 ) @ Y4 @ ( F2 @ Z3 ) ) ) )).

% fun_upd_apply
thf(fact_174_fun__upd__idem__iff,axiom,(
    ! [F: nat > nat,X: nat,Y: nat] :
      ( ( ( fun_upd_nat_nat @ F @ X @ Y )
        = F )
      = ( ( F @ X )
        = Y ) ) )).

% fun_upd_idem_iff
thf(fact_175_fun__upd__twist,axiom,(
    ! [A: nat,C: nat,M: nat > nat,B: nat,D: nat] :
      ( ( A != C )
     => ( ( fun_upd_nat_nat @ ( fun_upd_nat_nat @ M @ A @ B ) @ C @ D )
        = ( fun_upd_nat_nat @ ( fun_upd_nat_nat @ M @ C @ D ) @ A @ B ) ) ) )).

% fun_upd_twist
thf(fact_176_fun__upd__other,axiom,(
    ! [Z: nat,X: nat,F: nat > nat,Y: nat] :
      ( ( Z != X )
     => ( ( fun_upd_nat_nat @ F @ X @ Y @ Z )
        = ( F @ Z ) ) ) )).

% fun_upd_other
thf(fact_177_fun__upd__same,axiom,(
    ! [F: nat > nat,X: nat,Y: nat] :
      ( ( fun_upd_nat_nat @ F @ X @ Y @ X )
      = Y ) )).

% fun_upd_same
thf(fact_178_fun__upd__idem,axiom,(
    ! [F: nat > nat,X: nat,Y: nat] :
      ( ( ( F @ X )
        = Y )
     => ( ( fun_upd_nat_nat @ F @ X @ Y )
        = F ) ) )).

% fun_upd_idem
thf(fact_179_fun__upd__eqD,axiom,(
    ! [F: nat > nat,X: nat,Y: nat,G: nat > nat,Z: nat] :
      ( ( ( fun_upd_nat_nat @ F @ X @ Y )
        = ( fun_upd_nat_nat @ G @ X @ Z ) )
     => ( Y = Z ) ) )).

% fun_upd_eqD
thf(fact_180_fun__upd__def,axiom,
    ( fun_upd_nat_nat
    = ( ^ [F2: nat > nat,A3: nat,B3: nat,X4: nat] :
          ( if_nat @ ( X4 = A3 ) @ B3 @ ( F2 @ X4 ) ) ) )).

% fun_upd_def
thf(fact_181_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ zero_zero_nat )).

% le_numeral_extra(3)
thf(fact_182_less__numeral__extra_I3_J,axiom,(
    ~ ( ord_less_nat @ zero_zero_nat @ zero_zero_nat ) )).

% less_numeral_extra(3)
thf(fact_183_le__numeral__extra_I4_J,axiom,(
    ord_less_eq_nat @ one_one_nat @ one_one_nat )).

% le_numeral_extra(4)
thf(fact_184_zero__neq__one,axiom,(
    zero_zero_nat != one_one_nat )).

% zero_neq_one
thf(fact_185_less__numeral__extra_I4_J,axiom,(
    ~ ( ord_less_nat @ one_one_nat @ one_one_nat ) )).

% less_numeral_extra(4)
thf(fact_186_nat__descend__induct,axiom,(
    ! [N: nat,P2: nat > $o,M: nat] :
      ( ! [K2: nat] :
          ( ( ord_less_nat @ N @ K2 )
         => ( P2 @ K2 ) )
     => ( ! [K2: nat] :
            ( ( ord_less_eq_nat @ K2 @ N )
           => ( ! [I3: nat] :
                  ( ( ord_less_nat @ K2 @ I3 )
                 => ( P2 @ I3 ) )
             => ( P2 @ K2 ) ) )
       => ( P2 @ M ) ) ) )).

% nat_descend_induct
thf(fact_187_minf_I8_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z4 )
     => ~ ( ord_less_eq_nat @ T @ X5 ) ) )).

% minf(8)
thf(fact_188_minf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z4 )
     => ~ ( ord_less_nat @ T @ X5 ) ) )).

% minf(7)
thf(fact_189_minf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z4 )
     => ( ord_less_nat @ X5 @ T ) ) )).

% minf(5)
thf(fact_190_minf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z4 )
     => ( X5 != T ) ) )).

% minf(4)
thf(fact_191_minf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z4 )
     => ( X5 != T ) ) )).

% minf(3)
thf(fact_192_minf_I2_J,axiom,(
    ! [P2: nat > $o,P5: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z5: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ X2 @ Z5 )
         => ( ( P2 @ X2 )
            = ( P5 @ X2 ) ) )
     => ( ? [Z5: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ X2 @ Z5 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z4: nat] :
          ! [X5: nat] :
            ( ( ord_less_nat @ X5 @ Z4 )
           => ( ( ( P2 @ X5 )
                | ( Q @ X5 ) )
              = ( ( P5 @ X5 )
                | ( Q2 @ X5 ) ) ) ) ) ) )).

% minf(2)
thf(fact_193_minf_I1_J,axiom,(
    ! [P2: nat > $o,P5: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z5: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ X2 @ Z5 )
         => ( ( P2 @ X2 )
            = ( P5 @ X2 ) ) )
     => ( ? [Z5: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ X2 @ Z5 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z4: nat] :
          ! [X5: nat] :
            ( ( ord_less_nat @ X5 @ Z4 )
           => ( ( ( P2 @ X5 )
                & ( Q @ X5 ) )
              = ( ( P5 @ X5 )
                & ( Q2 @ X5 ) ) ) ) ) ) )).

% minf(1)
thf(fact_194_pinf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z4 @ X5 )
     => ( ord_less_nat @ T @ X5 ) ) )).

% pinf(7)
thf(fact_195_pinf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z4 @ X5 )
     => ~ ( ord_less_nat @ X5 @ T ) ) )).

% pinf(5)
thf(fact_196_pinf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z4 @ X5 )
     => ( X5 != T ) ) )).

% pinf(4)
thf(fact_197_pinf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z4 @ X5 )
     => ( X5 != T ) ) )).

% pinf(3)
thf(fact_198_pinf_I2_J,axiom,(
    ! [P2: nat > $o,P5: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z5: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ Z5 @ X2 )
         => ( ( P2 @ X2 )
            = ( P5 @ X2 ) ) )
     => ( ? [Z5: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ Z5 @ X2 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z4: nat] :
          ! [X5: nat] :
            ( ( ord_less_nat @ Z4 @ X5 )
           => ( ( ( P2 @ X5 )
                | ( Q @ X5 ) )
              = ( ( P5 @ X5 )
                | ( Q2 @ X5 ) ) ) ) ) ) )).

% pinf(2)
thf(fact_199_pinf_I1_J,axiom,(
    ! [P2: nat > $o,P5: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z5: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ Z5 @ X2 )
         => ( ( P2 @ X2 )
            = ( P5 @ X2 ) ) )
     => ( ? [Z5: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ Z5 @ X2 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z4: nat] :
          ! [X5: nat] :
            ( ( ord_less_nat @ Z4 @ X5 )
           => ( ( ( P2 @ X5 )
                & ( Q @ X5 ) )
              = ( ( P5 @ X5 )
                & ( Q2 @ X5 ) ) ) ) ) ) )).

% pinf(1)
thf(fact_200_pinf_I6_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z4 @ X5 )
     => ~ ( ord_less_eq_nat @ X5 @ T ) ) )).

% pinf(6)
thf(fact_201_pinf_I8_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z4 @ X5 )
     => ( ord_less_eq_nat @ T @ X5 ) ) )).

% pinf(8)
thf(fact_202_minf_I6_J,axiom,(
    ! [T: nat] :
    ? [Z4: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z4 )
     => ( ord_less_eq_nat @ X5 @ T ) ) )).

% minf(6)
thf(fact_203_complete__interval,axiom,(
    ! [A: nat,B: nat,P2: nat > $o] :
      ( ( ord_less_nat @ A @ B )
     => ( ( P2 @ A )
       => ( ~ ( P2 @ B )
         => ? [C2: nat] :
              ( ( ord_less_eq_nat @ A @ C2 )
              & ( ord_less_eq_nat @ C2 @ B )
              & ! [X5: nat] :
                  ( ( ( ord_less_eq_nat @ A @ X5 )
                    & ( ord_less_nat @ X5 @ C2 ) )
                 => ( P2 @ X5 ) )
              & ! [D2: nat] :
                  ( ! [X2: nat] :
                      ( ( ( ord_less_eq_nat @ A @ X2 )
                        & ( ord_less_nat @ X2 @ D2 ) )
                     => ( P2 @ X2 ) )
                 => ( ord_less_eq_nat @ D2 @ C2 ) ) ) ) ) ) )).

% complete_interval
thf(fact_204_verit__comp__simplify1_I3_J,axiom,(
    ! [B4: nat,A4: nat] :
      ( ( ~ ( ord_less_eq_nat @ B4 @ A4 ) )
      = ( ord_less_nat @ A4 @ B4 ) ) )).

% verit_comp_simplify1(3)
thf(fact_205_verit__la__disequality,axiom,(
    ! [A: nat,B: nat] :
      ( ( A = B )
      | ~ ( ord_less_eq_nat @ A @ B )
      | ~ ( ord_less_eq_nat @ B @ A ) ) )).

% verit_la_disequality
thf(fact_206_verit__comp__simplify1_I1_J,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% verit_comp_simplify1(1)
thf(fact_207_Suc__diff__1,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
     => ( ( suc @ ( minus_minus_nat @ N @ one_one_nat ) )
        = N ) ) )).

% Suc_diff_1
thf(fact_208_old_Onat_Oinject,axiom,(
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) )).

% old.nat.inject
thf(fact_209_nat_Oinject,axiom,(
    ! [X22: nat,Y22: nat] :
      ( ( ( suc @ X22 )
        = ( suc @ Y22 ) )
      = ( X22 = Y22 ) ) )).

% nat.inject

% Helper facts (3)
thf(help_If_3_1_If_001t__Nat__Onat_T,axiom,(
    ! [P2: $o] :
      ( ( P2 = $true )
      | ( P2 = $false ) ) )).

thf(help_If_2_1_If_001t__Nat__Onat_T,axiom,(
    ! [X: nat,Y: nat] :
      ( ( if_nat @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_If_001t__Nat__Onat_T,axiom,(
    ! [X: nat,Y: nat] :
      ( ( if_nat @ $true @ X @ Y )
      = X ) )).

% Conjectures (1)
thf(conj_0,conjecture,
    ( ( ord_less_eq_nat @ one_one_nat @ i )
    & ( ord_less_eq_nat @ i @ ( minus_minus_nat @ n @ k ) ) )).

%------------------------------------------------------------------------------
