%------------------------------------------------------------------------------
% File     : SLH577^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer EdmondsKarp_Termination_Abstract problem prob_13__7578902_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : EdmondsKarp_Termination_Abstract/prob_13__7578902_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  238 (   0 unit;  12 type;   0 defn)
%            Number of atoms       : 2243 ( 165 equality;1411 variable)
%            Maximal formula depth :   18 (   8 average)
%            Number of connectives : 1767 (  80   ~;  21   |;  32   &;1359   @)
%                                         (   0 <=>; 275  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   51 (  51   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   14 (  12   :;   0   =)
%            Number of variables   :  671 (   0 sgn; 597   !;  33   ?;  41   ^)
%                                         ( 671   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:29:43.379
%------------------------------------------------------------------------------
% Could-be-implicit typings (1)
thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (11)
thf(sy_c_Groups_Oone__class_Oone_001t__Nat__Onat,type,(
    one_one_nat: nat )).

thf(sy_c_Groups_Oplus__class_Oplus_001t__Nat__Onat,type,(
    plus_plus_nat: nat > nat > nat )).

thf(sy_c_Groups_Otimes__class_Otimes_001t__Nat__Onat,type,(
    times_times_nat: nat > nat > nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_v_N,type,(
    n: nat )).

thf(sy_v_a,type,(
    a: nat )).

thf(sy_v_a_H,type,(
    a2: nat )).

thf(sy_v_b,type,(
    b: nat )).

thf(sy_v_b_H,type,(
    b2: nat )).

% Relevant facts (225)
thf(fact_0_assms_I3_J,axiom,(
    ord_less_nat @ b2 @ n )).

% assms(3)
thf(fact_1_assms_I2_J,axiom,(
    ord_less_nat @ b @ n )).

% assms(2)
thf(fact_2_assms_I1_J,axiom,(
    ord_less_nat @ a @ a2 )).

% assms(1)
thf(fact_3_nat__1__eq__mult__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( one_one_nat
        = ( times_times_nat @ M @ N ) )
      = ( ( M = one_one_nat )
        & ( N = one_one_nat ) ) ) )).

% nat_1_eq_mult_iff
thf(fact_4_nat__mult__eq__1__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times_nat @ M @ N )
        = one_one_nat )
      = ( ( M = one_one_nat )
        & ( N = one_one_nat ) ) ) )).

% nat_mult_eq_1_iff
thf(fact_5_nat__add__left__cancel__le,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% nat_add_left_cancel_le
thf(fact_6_mult_Oleft__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ one_one_nat @ A )
      = A ) )).

% mult.left_neutral
thf(fact_7_mult_Oright__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ one_one_nat )
      = A ) )).

% mult.right_neutral
thf(fact_8_add__le__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_9_add__le__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_10_add__left__cancel,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
      = ( B = C ) ) )).

% add_left_cancel
thf(fact_11_add__right__cancel,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
      = ( B = C ) ) )).

% add_right_cancel
thf(fact_12_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_13_nat__mult__1,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ one_one_nat @ N )
      = N ) )).

% nat_mult_1
thf(fact_14_add__less__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( ord_less_nat @ A @ B ) ) )).

% add_less_cancel_right
thf(fact_15_add__less__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( ord_less_nat @ A @ B ) ) )).

% add_less_cancel_left
thf(fact_16_nat__add__left__cancel__less,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_nat @ M @ N ) ) )).

% nat_add_left_cancel_less
thf(fact_17_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_18_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_19_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_20_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_21_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_22_nat__less__induct,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ( P @ M2 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) )).

% nat_less_induct
thf(fact_23_infinite__descent,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P @ N2 )
         => ? [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
              & ~ ( P @ M2 ) ) )
     => ( P @ N ) ) )).

% infinite_descent
thf(fact_24_linorder__neqE__nat,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_25_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_26_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_27_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_28_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_29_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_30_neqE,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% neqE
thf(fact_31_neq__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
      = ( ( ord_less_nat @ X @ Y )
        | ( ord_less_nat @ Y @ X ) ) ) )).

% neq_iff
thf(fact_32_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_33_less__imp__neq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_34_less__asym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_asym
thf(fact_35_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_36_less__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% less_trans
thf(fact_37_less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
      | ( X = Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% less_linear
thf(fact_38_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_39_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_40_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_41_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_42_less__imp__not__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_43_less__not__sym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_not_sym
thf(fact_44_less__induct,axiom,(
    ! [P: nat > $o,A: nat] :
      ( ! [X2: nat] :
          ( ! [Y3: nat] :
              ( ( ord_less_nat @ Y3 @ X2 )
             => ( P @ Y3 ) )
         => ( P @ X2 ) )
     => ( P @ A ) ) )).

% less_induct
thf(fact_45_antisym__conv3,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_46_less__imp__not__eq2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_47_less__imp__triv,axiom,(
    ! [X: nat,Y: nat,P: $o] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_48_linorder__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_49_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_50_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_51_less__imp__not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_imp_not_less
thf(fact_52_exists__least__iff,axiom,
    ( ( ^ [P2: nat > $o] :
        ? [X3: nat] :
          ( P2 @ X3 ) )
    = ( ^ [P3: nat > $o] :
        ? [N3: nat] :
          ( ( P3 @ N3 )
          & ! [M3: nat] :
              ( ( ord_less_nat @ M3 @ N3 )
             => ~ ( P3 @ M3 ) ) ) ) )).

% exists_least_iff
thf(fact_53_linorder__less__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A2: nat,B2: nat] :
          ( ( ord_less_nat @ A2 @ B2 )
         => ( P @ A2 @ B2 ) )
     => ( ! [A2: nat] :
            ( P @ A2 @ A2 )
       => ( ! [A2: nat,B2: nat] :
              ( ( P @ B2 @ A2 )
             => ( P @ A2 @ B2 ) )
         => ( P @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_54_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_55_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ( ord_less_nat @ Y @ X )
        | ( X = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_56_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_57_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_58_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_59_dual__order_Ostrict__implies__order,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ord_less_eq_nat @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_60_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [B3: nat,A3: nat] :
          ( ( ord_less_eq_nat @ B3 @ A3 )
          & ( A3 != B3 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_61_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [B3: nat,A3: nat] :
          ( ( ord_less_nat @ B3 @ A3 )
          | ( A3 = B3 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_62_order_Ostrict__implies__order,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_63_dual__order_Ostrict__trans2,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_64_dual__order_Ostrict__trans1,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_65_order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A3 @ B3 )
          & ( A3 != B3 ) ) ) )).

% order.strict_iff_order
thf(fact_66_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [A3: nat,B3: nat] :
          ( ( ord_less_nat @ A3 @ B3 )
          | ( A3 = B3 ) ) ) )).

% order.order_iff_strict
thf(fact_67_order_Ostrict__trans2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_68_order_Ostrict__trans1,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_69_not__le__imp__less,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_eq_nat @ Y @ X )
     => ( ord_less_nat @ X @ Y ) ) )).

% not_le_imp_less
thf(fact_70_less__le__not__le,axiom,
    ( ord_less_nat
    = ( ^ [X4: nat,Y4: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y4 )
          & ~ ( ord_less_eq_nat @ Y4 @ X4 ) ) ) )).

% less_le_not_le
thf(fact_71_le__imp__less__or__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_nat @ X @ Y )
        | ( X = Y ) ) ) )).

% le_imp_less_or_eq
thf(fact_72_le__less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% le_less_linear
thf(fact_73_less__le__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% less_le_trans
thf(fact_74_le__less__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% le_less_trans
thf(fact_75_less__imp__le,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% less_imp_le
thf(fact_76_antisym__conv2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv2
thf(fact_77_antisym__conv1,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv1
thf(fact_78_le__neq__trans,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( A != B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_79_not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ord_less_eq_nat @ Y @ X ) ) )).

% not_less
thf(fact_80_not__le,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_eq_nat @ X @ Y ) )
      = ( ord_less_nat @ Y @ X ) ) )).

% not_le
thf(fact_81_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_82_order__less__le__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_83_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_84_order__le__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_85_less__le,axiom,
    ( ord_less_nat
    = ( ^ [X4: nat,Y4: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y4 )
          & ( X4 != Y4 ) ) ) )).

% less_le
thf(fact_86_le__less,axiom,
    ( ord_less_eq_nat
    = ( ^ [X4: nat,Y4: nat] :
          ( ( ord_less_nat @ X4 @ Y4 )
          | ( X4 = Y4 ) ) ) )).

% le_less
thf(fact_87_leI,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% leI
thf(fact_88_leD,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ~ ( ord_less_nat @ X @ Y ) ) )).

% leD
thf(fact_89_add__less__imp__less__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
     => ( ord_less_nat @ A @ B ) ) )).

% add_less_imp_less_right
thf(fact_90_add__less__imp__less__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
     => ( ord_less_nat @ A @ B ) ) )).

% add_less_imp_less_left
thf(fact_91_add__strict__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) ) ) )).

% add_strict_right_mono
thf(fact_92_add__strict__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) ) ) )).

% add_strict_left_mono
thf(fact_93_add__strict__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ C @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_strict_mono
thf(fact_94_add__mono__thms__linordered__field_I1_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( K = L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(1)
thf(fact_95_add__mono__thms__linordered__field_I2_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(2)
thf(fact_96_add__mono__thms__linordered__field_I5_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(5)
thf(fact_97_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_nat @ I2 @ J2 )
         => ( ord_less_nat @ ( F @ I2 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I @ J )
       => ( ord_less_eq_nat @ ( F @ I ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_98_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_99_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_100_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M3: nat,N3: nat] :
          ( ( ord_less_nat @ M3 @ N3 )
          | ( M3 = N3 ) ) ) )).

% le_eq_less_or_eq
thf(fact_101_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_102_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M3: nat,N3: nat] :
          ( ( ord_less_eq_nat @ M3 @ N3 )
          & ( M3 != N3 ) ) ) )).

% nat_less_le
thf(fact_103_less__add__eq__less,axiom,(
    ! [K: nat,L: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ K @ L )
     => ( ( ( plus_plus_nat @ M @ L )
          = ( plus_plus_nat @ K @ N ) )
       => ( ord_less_nat @ M @ N ) ) ) )).

% less_add_eq_less
thf(fact_104_trans__less__add2,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ I @ ( plus_plus_nat @ M @ J ) ) ) )).

% trans_less_add2
thf(fact_105_trans__less__add1,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ I @ ( plus_plus_nat @ J @ M ) ) ) )).

% trans_less_add1
thf(fact_106_add__less__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ K ) ) ) )).

% add_less_mono1
thf(fact_107_not__add__less2,axiom,(
    ! [J: nat,I: nat] :
      ~ ( ord_less_nat @ ( plus_plus_nat @ J @ I ) @ I ) )).

% not_add_less2
thf(fact_108_not__add__less1,axiom,(
    ! [I: nat,J: nat] :
      ~ ( ord_less_nat @ ( plus_plus_nat @ I @ J ) @ I ) )).

% not_add_less1
thf(fact_109_add__less__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ( ord_less_nat @ K @ L )
       => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) ) )).

% add_less_mono
thf(fact_110_add__lessD1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ I @ J ) @ K )
     => ( ord_less_nat @ I @ K ) ) )).

% add_lessD1
thf(fact_111_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_112_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y5: nat,Z2: nat] : ( Y5 = Z2 ) )
    = ( ^ [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ B3 @ A3 )
          & ( ord_less_eq_nat @ A3 @ B3 ) ) ) )).

% dual_order.eq_iff
thf(fact_113_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_114_linorder__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
         => ( P @ A2 @ B2 ) )
     => ( ! [A2: nat,B2: nat] :
            ( ( P @ B2 @ A2 )
           => ( P @ A2 @ B2 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_115_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_116_order__trans,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z )
       => ( ord_less_eq_nat @ X @ Z ) ) ) )).

% order_trans
thf(fact_117_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_118_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_119_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_120_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y5: nat,Z2: nat] : ( Y5 = Z2 ) )
    = ( ^ [A3: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A3 @ B3 )
          & ( ord_less_eq_nat @ B3 @ A3 ) ) ) )).

% order_class.order.eq_iff
thf(fact_121_antisym__conv,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_122_le__cases3,axiom,(
    ! [X: nat,Y: nat,Z: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y )
       => ~ ( ord_less_eq_nat @ Y @ Z ) )
     => ( ( ( ord_less_eq_nat @ Y @ X )
         => ~ ( ord_less_eq_nat @ X @ Z ) )
       => ( ( ( ord_less_eq_nat @ X @ Z )
           => ~ ( ord_less_eq_nat @ Z @ Y ) )
         => ( ( ( ord_less_eq_nat @ Z @ Y )
             => ~ ( ord_less_eq_nat @ Y @ X ) )
           => ( ( ( ord_less_eq_nat @ Y @ Z )
               => ~ ( ord_less_eq_nat @ Z @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_123_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_124_le__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% le_cases
thf(fact_125_eq__refl,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X = Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% eq_refl
thf(fact_126_linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_eq_nat @ Y @ X ) ) )).

% linear
thf(fact_127_antisym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_128_eq__iff,axiom,
    ( ( ^ [Y5: nat,Z2: nat] : ( Y5 = Z2 ) )
    = ( ^ [X4: nat,Y4: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y4 )
          & ( ord_less_eq_nat @ Y4 @ X4 ) ) ) )).

% eq_iff
thf(fact_129_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_130_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_131_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_132_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_133_mult_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( times_times_nat @ B @ ( times_times_nat @ A @ C ) )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.left_commute
thf(fact_134_mult_Ocommute,axiom,
    ( times_times_nat
    = ( ^ [A3: nat,B3: nat] :
          ( times_times_nat @ B3 @ A3 ) ) )).

% mult.commute
thf(fact_135_mult_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.assoc
thf(fact_136_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_137_add__right__imp__eq,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
     => ( B = C ) ) )).

% add_right_imp_eq
thf(fact_138_add__left__imp__eq,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
     => ( B = C ) ) )).

% add_left_imp_eq
thf(fact_139_add_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( plus_plus_nat @ B @ ( plus_plus_nat @ A @ C ) )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.left_commute
thf(fact_140_add_Ocommute,axiom,
    ( plus_plus_nat
    = ( ^ [A3: nat,B3: nat] :
          ( plus_plus_nat @ B3 @ A3 ) ) )).

% add.commute
thf(fact_141_add_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.assoc
thf(fact_142_group__cancel_Oadd2,axiom,(
    ! [B4: nat,K: nat,B: nat,A: nat] :
      ( ( B4
        = ( plus_plus_nat @ K @ B ) )
     => ( ( plus_plus_nat @ A @ B4 )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add2
thf(fact_143_group__cancel_Oadd1,axiom,(
    ! [A4: nat,K: nat,A: nat,B: nat] :
      ( ( A4
        = ( plus_plus_nat @ K @ A ) )
     => ( ( plus_plus_nat @ A4 @ B )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add1
thf(fact_144_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( K = L ) )
     => ( ( plus_plus_nat @ I @ K )
        = ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_145_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_146_one__reorient,axiom,(
    ! [X: nat] :
      ( ( one_one_nat = X )
      = ( X = one_one_nat ) ) )).

% one_reorient
thf(fact_147_Nat_Oex__has__greatest__nat,axiom,(
    ! [P: nat > $o,K: nat,B: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq_nat @ Y2 @ B ) )
       => ? [X2: nat] :
            ( ( P @ X2 )
            & ! [Y3: nat] :
                ( ( P @ Y3 )
               => ( ord_less_eq_nat @ Y3 @ X2 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_148_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_149_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_150_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_151_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_152_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_153_add__less__le__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_less_le_mono
thf(fact_154_add__le__less__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ C @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_le_less_mono
thf(fact_155_add__mono__thms__linordered__field_I3_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(3)
thf(fact_156_add__mono__thms__linordered__field_I4_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(4)
thf(fact_157_mono__nat__linear__lb,axiom,(
    ! [F: nat > nat,M: nat,K: nat] :
      ( ! [M4: nat,N2: nat] :
          ( ( ord_less_nat @ M4 @ N2 )
         => ( ord_less_nat @ ( F @ M4 ) @ ( F @ N2 ) ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ ( F @ M ) @ K ) @ ( F @ ( plus_plus_nat @ M @ K ) ) ) ) )).

% mono_nat_linear_lb
thf(fact_158_add__le__imp__le__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_right
thf(fact_159_add__le__imp__le__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_left
thf(fact_160_le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [A3: nat,B3: nat] :
        ? [C2: nat] :
          ( B3
          = ( plus_plus_nat @ A3 @ C2 ) ) ) )).

% le_iff_add
thf(fact_161_add__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) ) ) )).

% add_right_mono
thf(fact_162_less__eqE,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ~ ! [C3: nat] :
            ( B
           != ( plus_plus_nat @ A @ C3 ) ) ) )).

% less_eqE
thf(fact_163_add__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) ) ) )).

% add_left_mono
thf(fact_164_add__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_mono
thf(fact_165_add__mono__thms__linordered__semiring_I1_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(1)
thf(fact_166_add__mono__thms__linordered__semiring_I2_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(2)
thf(fact_167_add__mono__thms__linordered__semiring_I3_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( K = L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(3)
thf(fact_168_mult_Ocomm__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ one_one_nat )
      = A ) )).

% mult.comm_neutral
thf(fact_169_comm__monoid__mult__class_Omult__1,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ one_one_nat @ A )
      = A ) )).

% comm_monoid_mult_class.mult_1
thf(fact_170_nat__le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [M3: nat,N3: nat] :
        ? [K2: nat] :
          ( N3
          = ( plus_plus_nat @ M3 @ K2 ) ) ) )).

% nat_le_iff_add
thf(fact_171_trans__le__add2,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ I @ ( plus_plus_nat @ M @ J ) ) ) )).

% trans_le_add2
thf(fact_172_trans__le__add1,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ I @ ( plus_plus_nat @ J @ M ) ) ) )).

% trans_le_add1
thf(fact_173_add__le__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ K ) ) ) )).

% add_le_mono1
thf(fact_174_add__le__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) ) )).

% add_le_mono
thf(fact_175_le__Suc__ex,axiom,(
    ! [K: nat,L: nat] :
      ( ( ord_less_eq_nat @ K @ L )
     => ? [N2: nat] :
          ( L
          = ( plus_plus_nat @ K @ N2 ) ) ) )).

% le_Suc_ex
thf(fact_176_add__leD2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ( ord_less_eq_nat @ K @ N ) ) )).

% add_leD2
thf(fact_177_add__leD1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% add_leD1
thf(fact_178_le__add2,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ N @ ( plus_plus_nat @ M @ N ) ) )).

% le_add2
thf(fact_179_le__add1,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ N @ ( plus_plus_nat @ N @ M ) ) )).

% le_add1
thf(fact_180_add__leE,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq_nat @ M @ N )
         => ~ ( ord_less_eq_nat @ K @ N ) ) ) )).

% add_leE
thf(fact_181_mult__le__mono2,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ K @ I ) @ ( times_times_nat @ K @ J ) ) ) )).

% mult_le_mono2
thf(fact_182_mult__le__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ I @ K ) @ ( times_times_nat @ J @ K ) ) ) )).

% mult_le_mono1
thf(fact_183_mult__le__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( times_times_nat @ I @ K ) @ ( times_times_nat @ J @ L ) ) ) ) )).

% mult_le_mono
thf(fact_184_le__square,axiom,(
    ! [M: nat] :
      ( ord_less_eq_nat @ M @ ( times_times_nat @ M @ M ) ) )).

% le_square
thf(fact_185_le__cube,axiom,(
    ! [M: nat] :
      ( ord_less_eq_nat @ M @ ( times_times_nat @ M @ ( times_times_nat @ M @ M ) ) ) )).

% le_cube
thf(fact_186_add__mult__distrib2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times_nat @ K @ ( plus_plus_nat @ M @ N ) )
      = ( plus_plus_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) ) ) )).

% add_mult_distrib2
thf(fact_187_add__mult__distrib,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times_nat @ ( plus_plus_nat @ M @ N ) @ K )
      = ( plus_plus_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) ) ) )).

% add_mult_distrib
thf(fact_188_nat__mult__1__right,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ N @ one_one_nat )
      = N ) )).

% nat_mult_1_right
thf(fact_189_discrete,axiom,
    ( ord_less_nat
    = ( ^ [A3: nat] :
          ( ord_less_eq_nat @ ( plus_plus_nat @ A3 @ one_one_nat ) ) ) )).

% discrete
thf(fact_190_add__mono1,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_nat @ ( plus_plus_nat @ A @ one_one_nat ) @ ( plus_plus_nat @ B @ one_one_nat ) ) ) )).

% add_mono1
thf(fact_191_less__add__one,axiom,(
    ! [A: nat] :
      ( ord_less_nat @ A @ ( plus_plus_nat @ A @ one_one_nat ) ) )).

% less_add_one
thf(fact_192_less__1__mult,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ one_one_nat @ M )
     => ( ( ord_less_nat @ one_one_nat @ N )
       => ( ord_less_nat @ one_one_nat @ ( times_times_nat @ M @ N ) ) ) ) )).

% less_1_mult
thf(fact_193_left__add__mult__distrib,axiom,(
    ! [I: nat,U: nat,J: nat,K: nat] :
      ( ( plus_plus_nat @ ( times_times_nat @ I @ U ) @ ( plus_plus_nat @ ( times_times_nat @ J @ U ) @ K ) )
      = ( plus_plus_nat @ ( times_times_nat @ ( plus_plus_nat @ I @ J ) @ U ) @ K ) ) )).

% left_add_mult_distrib
thf(fact_194_nat__descend__induct,axiom,(
    ! [N: nat,P: nat > $o,M: nat] :
      ( ! [K3: nat] :
          ( ( ord_less_nat @ N @ K3 )
         => ( P @ K3 ) )
     => ( ! [K3: nat] :
            ( ( ord_less_eq_nat @ K3 @ N )
           => ( ! [I3: nat] :
                  ( ( ord_less_nat @ K3 @ I3 )
                 => ( P @ I3 ) )
             => ( P @ K3 ) ) )
       => ( P @ M ) ) ) )).

% nat_descend_induct
thf(fact_195_crossproduct__noteq,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ( A != B )
        & ( C != D ) )
      = ( ( plus_plus_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) )
       != ( plus_plus_nat @ ( times_times_nat @ A @ D ) @ ( times_times_nat @ B @ C ) ) ) ) )).

% crossproduct_noteq
thf(fact_196_bounded__Max__nat,axiom,(
    ! [P: nat > $o,X: nat,M5: nat] :
      ( ( P @ X )
     => ( ! [X2: nat] :
            ( ( P @ X2 )
           => ( ord_less_eq_nat @ X2 @ M5 ) )
       => ~ ! [M4: nat] :
              ( ( P @ M4 )
             => ~ ! [X5: nat] :
                    ( ( P @ X5 )
                   => ( ord_less_eq_nat @ X5 @ M4 ) ) ) ) ) )).

% bounded_Max_nat
thf(fact_197_comm__semiring__class_Odistrib,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) )).

% comm_semiring_class.distrib
thf(fact_198_distrib__left,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ A @ ( plus_plus_nat @ B @ C ) )
      = ( plus_plus_nat @ ( times_times_nat @ A @ B ) @ ( times_times_nat @ A @ C ) ) ) )).

% distrib_left
thf(fact_199_distrib__right,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) )).

% distrib_right
thf(fact_200_combine__common__factor,axiom,(
    ! [A: nat,E: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( times_times_nat @ A @ E ) @ ( plus_plus_nat @ ( times_times_nat @ B @ E ) @ C ) )
      = ( plus_plus_nat @ ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ E ) @ C ) ) )).

% combine_common_factor
thf(fact_201_crossproduct__eq,axiom,(
    ! [W: nat,Y: nat,X: nat,Z: nat] :
      ( ( ( plus_plus_nat @ ( times_times_nat @ W @ Y ) @ ( times_times_nat @ X @ Z ) )
        = ( plus_plus_nat @ ( times_times_nat @ W @ Z ) @ ( times_times_nat @ X @ Y ) ) )
      = ( ( W = X )
        | ( Y = Z ) ) ) )).

% crossproduct_eq
thf(fact_202_less__numeral__extra_I4_J,axiom,(
    ~ ( ord_less_nat @ one_one_nat @ one_one_nat ) )).

% less_numeral_extra(4)
thf(fact_203_le__numeral__extra_I4_J,axiom,(
    ord_less_eq_nat @ one_one_nat @ one_one_nat )).

% le_numeral_extra(4)
thf(fact_204_complete__interval,axiom,(
    ! [A: nat,B: nat,P: nat > $o] :
      ( ( ord_less_nat @ A @ B )
     => ( ( P @ A )
       => ( ~ ( P @ B )
         => ? [C3: nat] :
              ( ( ord_less_eq_nat @ A @ C3 )
              & ( ord_less_eq_nat @ C3 @ B )
              & ! [X5: nat] :
                  ( ( ( ord_less_eq_nat @ A @ X5 )
                    & ( ord_less_nat @ X5 @ C3 ) )
                 => ( P @ X5 ) )
              & ! [D2: nat] :
                  ( ! [X2: nat] :
                      ( ( ( ord_less_eq_nat @ A @ X2 )
                        & ( ord_less_nat @ X2 @ D2 ) )
                     => ( P @ X2 ) )
                 => ( ord_less_eq_nat @ D2 @ C3 ) ) ) ) ) ) )).

% complete_interval
thf(fact_205_verit__comp__simplify1_I3_J,axiom,(
    ! [B5: nat,A5: nat] :
      ( ( ~ ( ord_less_eq_nat @ B5 @ A5 ) )
      = ( ord_less_nat @ A5 @ B5 ) ) )).

% verit_comp_simplify1(3)
thf(fact_206_verit__la__disequality,axiom,(
    ! [A: nat,B: nat] :
      ( ( A = B )
      | ~ ( ord_less_eq_nat @ A @ B )
      | ~ ( ord_less_eq_nat @ B @ A ) ) )).

% verit_la_disequality
thf(fact_207_verit__comp__simplify1_I1_J,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% verit_comp_simplify1(1)
thf(fact_208_minf_I8_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z3 )
     => ~ ( ord_less_eq_nat @ T @ X5 ) ) )).

% minf(8)
thf(fact_209_minf_I6_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z3 )
     => ( ord_less_eq_nat @ X5 @ T ) ) )).

% minf(6)
thf(fact_210_minf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z3 )
     => ~ ( ord_less_nat @ T @ X5 ) ) )).

% minf(7)
thf(fact_211_minf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z3 )
     => ( ord_less_nat @ X5 @ T ) ) )).

% minf(5)
thf(fact_212_minf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z3 )
     => ( X5 != T ) ) )).

% minf(4)
thf(fact_213_minf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ X5 @ Z3 )
     => ( X5 != T ) ) )).

% minf(3)
thf(fact_214_minf_I2_J,axiom,(
    ! [P: nat > $o,P4: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ X2 @ Z4 )
         => ( ( P @ X2 )
            = ( P4 @ X2 ) ) )
     => ( ? [Z4: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ X2 @ Z4 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z3: nat] :
          ! [X5: nat] :
            ( ( ord_less_nat @ X5 @ Z3 )
           => ( ( ( P @ X5 )
                | ( Q @ X5 ) )
              = ( ( P4 @ X5 )
                | ( Q2 @ X5 ) ) ) ) ) ) )).

% minf(2)
thf(fact_215_minf_I1_J,axiom,(
    ! [P: nat > $o,P4: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ X2 @ Z4 )
         => ( ( P @ X2 )
            = ( P4 @ X2 ) ) )
     => ( ? [Z4: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ X2 @ Z4 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z3: nat] :
          ! [X5: nat] :
            ( ( ord_less_nat @ X5 @ Z3 )
           => ( ( ( P @ X5 )
                & ( Q @ X5 ) )
              = ( ( P4 @ X5 )
                & ( Q2 @ X5 ) ) ) ) ) ) )).

% minf(1)
thf(fact_216_pinf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ( ord_less_nat @ T @ X5 ) ) )).

% pinf(7)
thf(fact_217_pinf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ~ ( ord_less_nat @ X5 @ T ) ) )).

% pinf(5)
thf(fact_218_pinf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ( X5 != T ) ) )).

% pinf(4)
thf(fact_219_pinf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ( X5 != T ) ) )).

% pinf(3)
thf(fact_220_pinf_I2_J,axiom,(
    ! [P: nat > $o,P4: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ Z4 @ X2 )
         => ( ( P @ X2 )
            = ( P4 @ X2 ) ) )
     => ( ? [Z4: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ Z4 @ X2 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z3: nat] :
          ! [X5: nat] :
            ( ( ord_less_nat @ Z3 @ X5 )
           => ( ( ( P @ X5 )
                | ( Q @ X5 ) )
              = ( ( P4 @ X5 )
                | ( Q2 @ X5 ) ) ) ) ) ) )).

% pinf(2)
thf(fact_221_pinf_I1_J,axiom,(
    ! [P: nat > $o,P4: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ Z4 @ X2 )
         => ( ( P @ X2 )
            = ( P4 @ X2 ) ) )
     => ( ? [Z4: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ Z4 @ X2 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z3: nat] :
          ! [X5: nat] :
            ( ( ord_less_nat @ Z3 @ X5 )
           => ( ( ( P @ X5 )
                & ( Q @ X5 ) )
              = ( ( P4 @ X5 )
                & ( Q2 @ X5 ) ) ) ) ) ) )).

% pinf(1)
thf(fact_222_pinf_I6_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ~ ( ord_less_eq_nat @ X5 @ T ) ) )).

% pinf(6)
thf(fact_223_pinf_I8_J,axiom,(
    ! [T: nat] :
    ? [Z3: nat] :
    ! [X5: nat] :
      ( ( ord_less_nat @ Z3 @ X5 )
     => ( ord_less_eq_nat @ T @ X5 ) ) )).

% pinf(8)
thf(fact_224_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum

% Conjectures (1)
thf(conj_0,conjecture,(
    ord_less_eq_nat @ ( plus_plus_nat @ ( plus_plus_nat @ ( times_times_nat @ a @ n ) @ b ) @ one_one_nat ) @ ( plus_plus_nat @ ( times_times_nat @ a @ n ) @ n ) )).

%------------------------------------------------------------------------------
