%------------------------------------------------------------------------------
% File     : SLH578^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer EdmondsKarp_Termination_Abstract problem prob_123__7582752_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : EdmondsKarp_Termination_Abstract/prob_123__7582752_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  269 (   0 unit;  28 type;   0 defn)
%            Number of atoms       : 2504 ( 171 equality;1583 variable)
%            Maximal formula depth :   16 (   8 average)
%            Number of connectives : 1988 (  67   ~;  14   |;  38   &;1556   @)
%                                         (   0 <=>; 313  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  118 ( 118   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   30 (  28   :;   0   =)
%            Number of variables   :  735 (   0 sgn; 646   !;  23   ?;  66   ^)
%                                         ( 735   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:30:14.349
%------------------------------------------------------------------------------
% Could-be-implicit typings (5)
thf(ty_n_t__List__Olist_It__Product____Type__Oprod_It__Nat__Onat_Mt__Nat__Onat_J_J,type,(
    list_P559422087at_nat: $tType )).

thf(ty_n_t__Product____Type__Oprod_It__Nat__Onat_Mt__Nat__Onat_J,type,(
    product_prod_nat_nat: $tType )).

thf(ty_n_t__Set__Oset_It__Nat__Onat_J,type,(
    set_nat: $tType )).

thf(ty_n_tf__capacity,type,(
    capacity: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (23)
thf(sy_c_Graph_OGraph_Oconnected_001tf__capacity,type,(
    connected_capacity: ( product_prod_nat_nat > capacity ) > nat > nat > $o )).

thf(sy_c_Graph_OGraph_Odist_001tf__capacity,type,(
    dist_capacity: ( product_prod_nat_nat > capacity ) > nat > nat > nat > $o )).

thf(sy_c_Graph_OGraph_OisPath_001tf__capacity,type,(
    isPath_capacity: ( product_prod_nat_nat > capacity ) > nat > list_P559422087at_nat > nat > $o )).

thf(sy_c_Graph_OGraph_OisShortestPath_001tf__capacity,type,(
    isShor1936442771pacity: ( product_prod_nat_nat > capacity ) > nat > list_P559422087at_nat > nat > $o )).

thf(sy_c_Graph_OGraph_OisSimplePath_001tf__capacity,type,(
    isSimp1359852763pacity: ( product_prod_nat_nat > capacity ) > nat > list_P559422087at_nat > nat > $o )).

thf(sy_c_Graph_OGraph_Omin__dist_001tf__capacity,type,(
    min_dist_capacity: ( product_prod_nat_nat > capacity ) > nat > nat > nat )).

thf(sy_c_Graph_OGraph_OreachableNodes_001tf__capacity,type,(
    reacha1693770334pacity: ( product_prod_nat_nat > capacity ) > nat > set_nat )).

thf(sy_c_Groups_Oplus__class_Oplus_001t__Nat__Onat,type,(
    plus_plus_nat: nat > nat > nat )).

thf(sy_c_List_Olist_ONil_001t__Product____Type__Oprod_It__Nat__Onat_Mt__Nat__Onat_J,type,(
    nil_Pr1308055047at_nat: list_P559422087at_nat )).

thf(sy_c_Nat_Osize__class_Osize_001t__List__Olist_It__Product____Type__Oprod_It__Nat__Onat_Mt__Nat__Onat_J_J,type,(
    size_s1990949619at_nat: list_P559422087at_nat > nat )).

thf(sy_c_Orderings_Oord__class_OLeast_001t__Nat__Onat,type,(
    ord_Least_nat: ( nat > $o ) > nat )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Set_OCollect_001t__Nat__Onat,type,(
    collect_nat: ( nat > $o ) > set_nat )).

thf(sy_c_member_001t__Nat__Onat,type,(
    member_nat: nat > set_nat > $o )).

thf(sy_v_c,type,(
    c: product_prod_nat_nat > capacity )).

thf(sy_v_p,type,(
    p: list_P559422087at_nat )).

thf(sy_v_p1____,type,(
    p1: list_P559422087at_nat )).

thf(sy_v_p1a____,type,(
    p1a: list_P559422087at_nat )).

thf(sy_v_s,type,(
    s: nat )).

thf(sy_v_t,type,(
    t: nat )).

thf(sy_v_v____,type,(
    v: nat )).

thf(sy_v_va____,type,(
    va: nat )).

% Relevant facts (240)
thf(fact_0_min__dist__minD,axiom,(
    ! [V: nat,D: nat,V2: nat] :
      ( ( dist_capacity @ c @ V @ D @ V2 )
     => ( ord_less_eq_nat @ ( min_dist_capacity @ c @ V @ V2 ) @ D ) ) )).

% min_dist_minD
thf(fact_1_P1,axiom,(
    isPath_capacity @ c @ s @ p1a @ va )).

% P1
thf(fact_2_min__distI__eq,axiom,(
    ! [V: nat,D: nat,V2: nat] :
      ( ( dist_capacity @ c @ V @ D @ V2 )
     => ( ! [D2: nat] :
            ( ( dist_capacity @ c @ V @ D2 @ V2 )
           => ( ord_less_eq_nat @ D @ D2 ) )
       => ( ( min_dist_capacity @ c @ V @ V2 )
          = D ) ) ) )).

% min_distI_eq
thf(fact_3__092_060open_062isPath_As_Ap1_____Av_____092_060close_062,axiom,(
    isPath_capacity @ c @ s @ p1 @ v )).

% \<open>isPath s p1__ v__\<close>
thf(fact_4_dist__def,axiom,(
    ! [V: nat,D: nat,V2: nat] :
      ( ( dist_capacity @ c @ V @ D @ V2 )
      = ( ? [P: list_P559422087at_nat] :
            ( ( isPath_capacity @ c @ V @ P @ V2 )
            & ( ( size_s1990949619at_nat @ P )
              = D ) ) ) ) )).

% dist_def
thf(fact_5_isPath__distD,axiom,(
    ! [U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isPath_capacity @ c @ U @ P2 @ V )
     => ( dist_capacity @ c @ U @ ( size_s1990949619at_nat @ P2 ) @ V ) ) )).

% isPath_distD
thf(fact_6_min__dist__le,axiom,(
    ! [Src: nat,V: nat,D3: nat] :
      ( ( connected_capacity @ c @ Src @ V )
     => ( ( ord_less_eq_nat @ D3 @ ( min_dist_capacity @ c @ Src @ V ) )
       => ? [V3: nat] :
            ( ( connected_capacity @ c @ Src @ V3 )
            & ( ( min_dist_capacity @ c @ Src @ V3 )
              = D3 ) ) ) ) )).

% min_dist_le
thf(fact_7_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_8__C1_Oprems_C_I2_J,axiom,(
    isPath_capacity @ c @ s @ p1a @ va )).

% "1.prems"(2)
thf(fact_9_isShortestPath__min__dist__def,axiom,(
    ! [U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isShor1936442771pacity @ c @ U @ P2 @ V )
      = ( ( isPath_capacity @ c @ U @ P2 @ V )
        & ( ( size_s1990949619at_nat @ P2 )
          = ( min_dist_capacity @ c @ U @ V ) ) ) ) )).

% isShortestPath_min_dist_def
thf(fact_10_isShortestPath__def,axiom,(
    ! [U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isShor1936442771pacity @ c @ U @ P2 @ V )
      = ( ( isPath_capacity @ c @ U @ P2 @ V )
        & ! [P3: list_P559422087at_nat] :
            ( ( isPath_capacity @ c @ U @ P3 @ V )
           => ( ord_less_eq_nat @ ( size_s1990949619at_nat @ P2 ) @ ( size_s1990949619at_nat @ P3 ) ) ) ) ) )).

% isShortestPath_def
thf(fact_11_min__distI2,axiom,(
    ! [V: nat,V2: nat,Q: nat > $o] :
      ( ( connected_capacity @ c @ V @ V2 )
     => ( ! [D4: nat] :
            ( ( dist_capacity @ c @ V @ D4 @ V2 )
           => ( ! [D5: nat] :
                  ( ( dist_capacity @ c @ V @ D5 @ V2 )
                 => ( ord_less_eq_nat @ D4 @ D5 ) )
             => ( Q @ D4 ) ) )
       => ( Q @ ( min_dist_capacity @ c @ V @ V2 ) ) ) ) )).

% min_distI2
thf(fact_12_min__dist__split_I2_J,axiom,(
    ! [U: nat,D1: nat,W: nat,D22: nat,V: nat] :
      ( ( dist_capacity @ c @ U @ D1 @ W )
     => ( ( dist_capacity @ c @ W @ D22 @ V )
       => ( ( ( min_dist_capacity @ c @ U @ V )
            = ( plus_plus_nat @ D1 @ D22 ) )
         => ( ( min_dist_capacity @ c @ W @ V )
            = D22 ) ) ) ) )).

% min_dist_split(2)
thf(fact_13_min__dist__split_I1_J,axiom,(
    ! [U: nat,D1: nat,W: nat,D22: nat,V: nat] :
      ( ( dist_capacity @ c @ U @ D1 @ W )
     => ( ( dist_capacity @ c @ W @ D22 @ V )
       => ( ( ( min_dist_capacity @ c @ U @ V )
            = ( plus_plus_nat @ D1 @ D22 ) )
         => ( ( min_dist_capacity @ c @ U @ W )
            = D1 ) ) ) ) )).

% min_dist_split(1)
thf(fact_14_min__dist__is__dist,axiom,(
    ! [V: nat,V2: nat] :
      ( ( connected_capacity @ c @ V @ V2 )
     => ( dist_capacity @ c @ V @ ( min_dist_capacity @ c @ V @ V2 ) @ V2 ) ) )).

% min_dist_is_dist
thf(fact_15_SP,axiom,(
    isShor1936442771pacity @ c @ s @ p @ t )).

% SP
thf(fact_16_Graph_Omin__distI__eq,axiom,(
    ! [C: product_prod_nat_nat > capacity,V: nat,D: nat,V2: nat] :
      ( ( dist_capacity @ C @ V @ D @ V2 )
     => ( ! [D2: nat] :
            ( ( dist_capacity @ C @ V @ D2 @ V2 )
           => ( ord_less_eq_nat @ D @ D2 ) )
       => ( ( min_dist_capacity @ C @ V @ V2 )
          = D ) ) ) )).

% Graph.min_distI_eq
thf(fact_17_Graph_Omin__dist__minD,axiom,(
    ! [C: product_prod_nat_nat > capacity,V: nat,D: nat,V2: nat] :
      ( ( dist_capacity @ C @ V @ D @ V2 )
     => ( ord_less_eq_nat @ ( min_dist_capacity @ C @ V @ V2 ) @ D ) ) )).

% Graph.min_dist_minD
thf(fact_18_dist__trans,axiom,(
    ! [U: nat,D1: nat,W: nat,D22: nat,V: nat] :
      ( ( dist_capacity @ c @ U @ D1 @ W )
     => ( ( dist_capacity @ c @ W @ D22 @ V )
       => ( dist_capacity @ c @ U @ ( plus_plus_nat @ D1 @ D22 ) @ V ) ) ) )).

% dist_trans
thf(fact_19_connected__def,axiom,(
    ! [U: nat,V: nat] :
      ( ( connected_capacity @ c @ U @ V )
      = ( ? [P: list_P559422087at_nat] :
            ( isPath_capacity @ c @ U @ P @ V ) ) ) )).

% connected_def
thf(fact_20_shortestPath__is__path,axiom,(
    ! [U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isShor1936442771pacity @ c @ U @ P2 @ V )
     => ( isPath_capacity @ c @ U @ P2 @ V ) ) )).

% shortestPath_is_path
thf(fact_21_connected__by__dist,axiom,(
    ! [V: nat,V2: nat] :
      ( ( connected_capacity @ c @ V @ V2 )
      = ( ? [D6: nat] :
            ( dist_capacity @ c @ V @ D6 @ V2 ) ) ) )).

% connected_by_dist
thf(fact_22_obtain__shortest__path,axiom,(
    ! [U: nat,V: nat] :
      ( ( connected_capacity @ c @ U @ V )
     => ~ ! [P4: list_P559422087at_nat] :
            ~ ( isShor1936442771pacity @ c @ U @ P4 @ V ) ) )).

% obtain_shortest_path
thf(fact_23_connected__refl,axiom,(
    ! [V: nat] :
      ( connected_capacity @ c @ V @ V ) )).

% connected_refl
thf(fact_24_connected__distI,axiom,(
    ! [V: nat,D: nat,V2: nat] :
      ( ( dist_capacity @ c @ V @ D @ V2 )
     => ( connected_capacity @ c @ V @ V2 ) ) )).

% connected_distI
thf(fact_25_Graph_Odist_Ocong,axiom,(
    dist_capacity = dist_capacity )).

% Graph.dist.cong
thf(fact_26_Graph_Odist__trans,axiom,(
    ! [C: product_prod_nat_nat > capacity,U: nat,D1: nat,W: nat,D22: nat,V: nat] :
      ( ( dist_capacity @ C @ U @ D1 @ W )
     => ( ( dist_capacity @ C @ W @ D22 @ V )
       => ( dist_capacity @ C @ U @ ( plus_plus_nat @ D1 @ D22 ) @ V ) ) ) )).

% Graph.dist_trans
thf(fact_27_Graph_OisPath_Ocong,axiom,(
    isPath_capacity = isPath_capacity )).

% Graph.isPath.cong
thf(fact_28_Graph_Oconnected__def,axiom,
    ( connected_capacity
    = ( ^ [C2: product_prod_nat_nat > capacity,U2: nat,V4: nat] :
        ? [P: list_P559422087at_nat] :
          ( isPath_capacity @ C2 @ U2 @ P @ V4 ) ) )).

% Graph.connected_def
thf(fact_29_Graph_Oconnected_Ocong,axiom,(
    connected_capacity = connected_capacity )).

% Graph.connected.cong
thf(fact_30_Graph_Oconnected__refl,axiom,(
    ! [C: product_prod_nat_nat > capacity,V: nat] :
      ( connected_capacity @ C @ V @ V ) )).

% Graph.connected_refl
thf(fact_31_Graph_Oconnected__distI,axiom,(
    ! [C: product_prod_nat_nat > capacity,V: nat,D: nat,V2: nat] :
      ( ( dist_capacity @ C @ V @ D @ V2 )
     => ( connected_capacity @ C @ V @ V2 ) ) )).

% Graph.connected_distI
thf(fact_32_Graph_Oconnected__by__dist,axiom,
    ( connected_capacity
    = ( ^ [C2: product_prod_nat_nat > capacity,V4: nat,V5: nat] :
        ? [D6: nat] :
          ( dist_capacity @ C2 @ V4 @ D6 @ V5 ) ) )).

% Graph.connected_by_dist
thf(fact_33_Graph_OisShortestPath_Ocong,axiom,(
    isShor1936442771pacity = isShor1936442771pacity )).

% Graph.isShortestPath.cong
thf(fact_34_Graph_Oobtain__shortest__path,axiom,(
    ! [C: product_prod_nat_nat > capacity,U: nat,V: nat] :
      ( ( connected_capacity @ C @ U @ V )
     => ~ ! [P4: list_P559422087at_nat] :
            ~ ( isShor1936442771pacity @ C @ U @ P4 @ V ) ) )).

% Graph.obtain_shortest_path
thf(fact_35_Graph_OshortestPath__is__path,axiom,(
    ! [C: product_prod_nat_nat > capacity,U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isShor1936442771pacity @ C @ U @ P2 @ V )
     => ( isPath_capacity @ C @ U @ P2 @ V ) ) )).

% Graph.shortestPath_is_path
thf(fact_36_Graph_Omin__dist__split_I1_J,axiom,(
    ! [C: product_prod_nat_nat > capacity,U: nat,D1: nat,W: nat,D22: nat,V: nat] :
      ( ( dist_capacity @ C @ U @ D1 @ W )
     => ( ( dist_capacity @ C @ W @ D22 @ V )
       => ( ( ( min_dist_capacity @ C @ U @ V )
            = ( plus_plus_nat @ D1 @ D22 ) )
         => ( ( min_dist_capacity @ C @ U @ W )
            = D1 ) ) ) ) )).

% Graph.min_dist_split(1)
thf(fact_37_Graph_Omin__dist__split_I2_J,axiom,(
    ! [C: product_prod_nat_nat > capacity,U: nat,D1: nat,W: nat,D22: nat,V: nat] :
      ( ( dist_capacity @ C @ U @ D1 @ W )
     => ( ( dist_capacity @ C @ W @ D22 @ V )
       => ( ( ( min_dist_capacity @ C @ U @ V )
            = ( plus_plus_nat @ D1 @ D22 ) )
         => ( ( min_dist_capacity @ C @ W @ V )
            = D22 ) ) ) ) )).

% Graph.min_dist_split(2)
thf(fact_38_Graph_Omin__dist__is__dist,axiom,(
    ! [C: product_prod_nat_nat > capacity,V: nat,V2: nat] :
      ( ( connected_capacity @ C @ V @ V2 )
     => ( dist_capacity @ C @ V @ ( min_dist_capacity @ C @ V @ V2 ) @ V2 ) ) )).

% Graph.min_dist_is_dist
thf(fact_39_Graph_Omin__distI2,axiom,(
    ! [C: product_prod_nat_nat > capacity,V: nat,V2: nat,Q: nat > $o] :
      ( ( connected_capacity @ C @ V @ V2 )
     => ( ! [D4: nat] :
            ( ( dist_capacity @ C @ V @ D4 @ V2 )
           => ( ! [D5: nat] :
                  ( ( dist_capacity @ C @ V @ D5 @ V2 )
                 => ( ord_less_eq_nat @ D4 @ D5 ) )
             => ( Q @ D4 ) ) )
       => ( Q @ ( min_dist_capacity @ C @ V @ V2 ) ) ) ) )).

% Graph.min_distI2
thf(fact_40_Graph_OisPath__distD,axiom,(
    ! [C: product_prod_nat_nat > capacity,U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isPath_capacity @ C @ U @ P2 @ V )
     => ( dist_capacity @ C @ U @ ( size_s1990949619at_nat @ P2 ) @ V ) ) )).

% Graph.isPath_distD
thf(fact_41_Graph_Odist__def,axiom,
    ( dist_capacity
    = ( ^ [C2: product_prod_nat_nat > capacity,V4: nat,D6: nat,V5: nat] :
        ? [P: list_P559422087at_nat] :
          ( ( isPath_capacity @ C2 @ V4 @ P @ V5 )
          & ( ( size_s1990949619at_nat @ P )
            = D6 ) ) ) )).

% Graph.dist_def
thf(fact_42_Graph_OisShortestPath__def,axiom,
    ( isShor1936442771pacity
    = ( ^ [C2: product_prod_nat_nat > capacity,U2: nat,P: list_P559422087at_nat,V4: nat] :
          ( ( isPath_capacity @ C2 @ U2 @ P @ V4 )
          & ! [P3: list_P559422087at_nat] :
              ( ( isPath_capacity @ C2 @ U2 @ P3 @ V4 )
             => ( ord_less_eq_nat @ ( size_s1990949619at_nat @ P ) @ ( size_s1990949619at_nat @ P3 ) ) ) ) ) )).

% Graph.isShortestPath_def
thf(fact_43_Graph_OisShortestPath__min__dist__def,axiom,
    ( isShor1936442771pacity
    = ( ^ [C2: product_prod_nat_nat > capacity,U2: nat,P: list_P559422087at_nat,V4: nat] :
          ( ( isPath_capacity @ C2 @ U2 @ P @ V4 )
          & ( ( size_s1990949619at_nat @ P )
            = ( min_dist_capacity @ C2 @ U2 @ V4 ) ) ) ) )).

% Graph.isShortestPath_min_dist_def
thf(fact_44_Graph_Omin__dist__le,axiom,(
    ! [C: product_prod_nat_nat > capacity,Src: nat,V: nat,D3: nat] :
      ( ( connected_capacity @ C @ Src @ V )
     => ( ( ord_less_eq_nat @ D3 @ ( min_dist_capacity @ C @ Src @ V ) )
       => ? [V3: nat] :
            ( ( connected_capacity @ C @ Src @ V3 )
            & ( ( min_dist_capacity @ C @ Src @ V3 )
              = D3 ) ) ) ) )).

% Graph.min_dist_le
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: nat,P5: nat > $o] :
      ( ( member_nat @ A @ ( collect_nat @ P5 ) )
      = ( P5 @ A ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A2: set_nat] :
      ( ( collect_nat
        @ ^ [X2: nat] :
            ( member_nat @ X2 @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [P5: nat > $o,Q: nat > $o] :
      ( ! [X3: nat] :
          ( ( P5 @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect_nat @ P5 )
        = ( collect_nat @ Q ) ) ) )).

% Collect_cong
thf(fact_48_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_49_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y: nat,Z: nat] : ( Y = Z ) )
    = ( ^ [A3: nat,B2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A3 )
          & ( ord_less_eq_nat @ A3 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_50_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_51_linorder__wlog,axiom,(
    ! [P5: nat > nat > $o,A: nat,B: nat] :
      ( ! [A4: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A4 @ B3 )
         => ( P5 @ A4 @ B3 ) )
     => ( ! [A4: nat,B3: nat] :
            ( ( P5 @ B3 @ A4 )
           => ( P5 @ A4 @ B3 ) )
       => ( P5 @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_52_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_53_order__trans,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ Z2 )
       => ( ord_less_eq_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_54_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_55_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_56_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_57_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y: nat,Z: nat] : ( Y = Z ) )
    = ( ^ [A3: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A3 @ B2 )
          & ( ord_less_eq_nat @ B2 @ A3 ) ) ) )).

% order_class.order.eq_iff
thf(fact_58_antisym__conv,axiom,(
    ! [Y2: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y2 @ X )
     => ( ( ord_less_eq_nat @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv
thf(fact_59_le__cases3,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y2 )
       => ~ ( ord_less_eq_nat @ Y2 @ Z2 ) )
     => ( ( ( ord_less_eq_nat @ Y2 @ X )
         => ~ ( ord_less_eq_nat @ X @ Z2 ) )
       => ( ( ( ord_less_eq_nat @ X @ Z2 )
           => ~ ( ord_less_eq_nat @ Z2 @ Y2 ) )
         => ( ( ( ord_less_eq_nat @ Z2 @ Y2 )
             => ~ ( ord_less_eq_nat @ Y2 @ X ) )
           => ( ( ( ord_less_eq_nat @ Y2 @ Z2 )
               => ~ ( ord_less_eq_nat @ Z2 @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z2 @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y2 ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_60_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_61_le__cases,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ Y2 @ X ) ) )).

% le_cases
thf(fact_62_eq__refl,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X = Y2 )
     => ( ord_less_eq_nat @ X @ Y2 ) ) )).

% eq_refl
thf(fact_63_linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
      | ( ord_less_eq_nat @ Y2 @ X ) ) )).

% linear
thf(fact_64_antisym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ X )
       => ( X = Y2 ) ) ) )).

% antisym
thf(fact_65_eq__iff,axiom,
    ( ( ^ [Y: nat,Z: nat] : ( Y = Z ) )
    = ( ^ [X2: nat,Y3: nat] :
          ( ( ord_less_eq_nat @ X2 @ Y3 )
          & ( ord_less_eq_nat @ Y3 @ X2 ) ) ) )).

% eq_iff
thf(fact_66_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_67_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_68_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_69_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_70_Graph_Omin__dist_Ocong,axiom,(
    min_dist_capacity = min_dist_capacity )).

% Graph.min_dist.cong
thf(fact_71_reachableNodes__def,axiom,(
    ! [U: nat] :
      ( ( reacha1693770334pacity @ c @ U )
      = ( collect_nat @ ( connected_capacity @ c @ U ) ) ) )).

% reachableNodes_def
thf(fact_72_min__dist__def,axiom,(
    ! [V: nat,V2: nat] :
      ( ( min_dist_capacity @ c @ V @ V2 )
      = ( ord_Least_nat
        @ ^ [D6: nat] :
            ( dist_capacity @ c @ V @ D6 @ V2 ) ) ) )).

% min_dist_def
thf(fact_73_nat__add__left__cancel__le,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% nat_add_left_cancel_le
thf(fact_74_add__le__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_75_add__le__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_76_isShortestPath__alt,axiom,(
    ! [U: nat,P2: list_P559422087at_nat,V: nat] :
      ( ( isShor1936442771pacity @ c @ U @ P2 @ V )
      = ( ( isSimp1359852763pacity @ c @ U @ P2 @ V )
        & ( ( size_s1990949619at_nat @ P2 )
          = ( min_dist_capacity @ c @ U @ V ) ) ) ) )).

% isShortestPath_alt
thf(fact_77_min__dist__less,axiom,(
    ! [Src: nat,V: nat,D: nat,D3: nat] :
      ( ( connected_capacity @ c @ Src @ V )
     => ( ( ( min_dist_capacity @ c @ Src @ V )
          = D )
       => ( ( ord_less_nat @ D3 @ D )
         => ? [V3: nat] :
              ( ( connected_capacity @ c @ Src @ V3 )
              & ( ( min_dist_capacity @ c @ Src @ V3 )
                = D3 ) ) ) ) ) )).

% min_dist_less
thf(fact_78_add__left__cancel,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
      = ( B = C ) ) )).

% add_left_cancel
thf(fact_79_add__right__cancel,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
      = ( B = C ) ) )).

% add_right_cancel
thf(fact_80_isPath_Osimps_I1_J,axiom,(
    ! [U: nat,V: nat] :
      ( ( isPath_capacity @ c @ U @ nil_Pr1308055047at_nat @ V )
      = ( U = V ) ) )).

% isPath.simps(1)
thf(fact_81_isSPath__pathLE,axiom,(
    ! [S: nat,P2: list_P559422087at_nat,T: nat] :
      ( ( isPath_capacity @ c @ S @ P2 @ T )
     => ? [P6: list_P559422087at_nat] :
          ( isSimp1359852763pacity @ c @ S @ P6 @ T ) ) )).

% isSPath_pathLE
thf(fact_82_shortestPath__is__simple,axiom,(
    ! [S: nat,P2: list_P559422087at_nat,T: nat] :
      ( ( isShor1936442771pacity @ c @ S @ P2 @ T )
     => ( isSimp1359852763pacity @ c @ S @ P2 @ T ) ) )).

% shortestPath_is_simple
thf(fact_83_add__less__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( ord_less_nat @ A @ B ) ) )).

% add_less_cancel_right
thf(fact_84_add__less__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( ord_less_nat @ A @ B ) ) )).

% add_less_cancel_left
thf(fact_85_nat__add__left__cancel__less,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_nat @ M @ N ) ) )).

% nat_add_left_cancel_less
thf(fact_86_simplePath__empty__conv,axiom,(
    ! [S: nat,T: nat] :
      ( ( isSimp1359852763pacity @ c @ S @ nil_Pr1308055047at_nat @ T )
      = ( S = T ) ) )).

% simplePath_empty_conv
thf(fact_87_simplePath__same__conv,axiom,(
    ! [S: nat,P2: list_P559422087at_nat] :
      ( ( isSimp1359852763pacity @ c @ S @ P2 @ S )
      = ( P2 = nil_Pr1308055047at_nat ) ) )).

% simplePath_same_conv
thf(fact_88_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_89_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_90_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_91_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_92_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_93_Graph_OisSimplePath_Ocong,axiom,(
    isSimp1359852763pacity = isSimp1359852763pacity )).

% Graph.isSimplePath.cong
thf(fact_94_neqE,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_nat @ X @ Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% neqE
thf(fact_95_Graph_OreachableNodes_Ocong,axiom,(
    reacha1693770334pacity = reacha1693770334pacity )).

% Graph.reachableNodes.cong
thf(fact_96_Graph_OsimplePath__same__conv,axiom,(
    ! [C: product_prod_nat_nat > capacity,S: nat,P2: list_P559422087at_nat] :
      ( ( isSimp1359852763pacity @ C @ S @ P2 @ S )
      = ( P2 = nil_Pr1308055047at_nat ) ) )).

% Graph.simplePath_same_conv
thf(fact_97_neq__iff,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
      = ( ( ord_less_nat @ X @ Y2 )
        | ( ord_less_nat @ Y2 @ X ) ) ) )).

% neq_iff
thf(fact_98_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_99_Graph_OsimplePath__empty__conv,axiom,(
    ! [C: product_prod_nat_nat > capacity,S: nat,T: nat] :
      ( ( isSimp1359852763pacity @ C @ S @ nil_Pr1308055047at_nat @ T )
      = ( S = T ) ) )).

% Graph.simplePath_empty_conv
thf(fact_100_LeastI2,axiom,(
    ! [P5: nat > $o,A: nat,Q: nat > $o] :
      ( ( P5 @ A )
     => ( ! [X3: nat] :
            ( ( P5 @ X3 )
           => ( Q @ X3 ) )
       => ( Q @ ( ord_Least_nat @ P5 ) ) ) ) )).

% LeastI2
thf(fact_101_less__imp__neq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_neq
thf(fact_102_less__asym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_asym
thf(fact_103_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_104_less__trans,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_trans
thf(fact_105_LeastI__ex,axiom,(
    ! [P5: nat > $o] :
      ( ? [X_12: nat] :
          ( P5 @ X_12 )
     => ( P5 @ ( ord_Least_nat @ P5 ) ) ) )).

% LeastI_ex
thf(fact_106_less__linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
      | ( X = Y2 )
      | ( ord_less_nat @ Y2 @ X ) ) )).

% less_linear
thf(fact_107_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_108_LeastI2__ex,axiom,(
    ! [P5: nat > $o,Q: nat > $o] :
      ( ? [X_12: nat] :
          ( P5 @ X_12 )
     => ( ! [X3: nat] :
            ( ( P5 @ X3 )
           => ( Q @ X3 ) )
       => ( Q @ ( ord_Least_nat @ P5 ) ) ) ) )).

% LeastI2_ex
thf(fact_109_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_110_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_111_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_112_less__imp__not__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_not_eq
thf(fact_113_less__not__sym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_not_sym
thf(fact_114_less__induct,axiom,(
    ! [P5: nat > $o,A: nat] :
      ( ! [X3: nat] :
          ( ! [Y5: nat] :
              ( ( ord_less_nat @ Y5 @ X3 )
             => ( P5 @ Y5 ) )
         => ( P5 @ X3 ) )
     => ( P5 @ A ) ) )).

% less_induct
thf(fact_115_antisym__conv3,axiom,(
    ! [Y2: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y2 @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv3
thf(fact_116_less__imp__not__eq2,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( Y2 != X ) ) )).

% less_imp_not_eq2
thf(fact_117_less__imp__triv,axiom,(
    ! [X: nat,Y2: nat,P5: $o] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ X )
       => P5 ) ) )).

% less_imp_triv
thf(fact_118_linorder__cases,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_nat @ X @ Y2 )
     => ( ( X != Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% linorder_cases
thf(fact_119_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_120_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_121_not__less__Least,axiom,(
    ! [K: nat,P5: nat > $o] :
      ( ( ord_less_nat @ K @ ( ord_Least_nat @ P5 ) )
     => ~ ( P5 @ K ) ) )).

% not_less_Least
thf(fact_122_less__imp__not__less,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_imp_not_less
thf(fact_123_exists__least__iff,axiom,
    ( ( ^ [P7: nat > $o] :
        ? [X4: nat] :
          ( P7 @ X4 ) )
    = ( ^ [P8: nat > $o] :
        ? [N2: nat] :
          ( ( P8 @ N2 )
          & ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ~ ( P8 @ M2 ) ) ) ) )).

% exists_least_iff
thf(fact_124_linorder__less__wlog,axiom,(
    ! [P5: nat > nat > $o,A: nat,B: nat] :
      ( ! [A4: nat,B3: nat] :
          ( ( ord_less_nat @ A4 @ B3 )
         => ( P5 @ A4 @ B3 ) )
     => ( ! [A4: nat] :
            ( P5 @ A4 @ A4 )
       => ( ! [A4: nat,B3: nat] :
              ( ( P5 @ B3 @ A4 )
             => ( P5 @ A4 @ B3 ) )
         => ( P5 @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_125_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_126_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y2 ) )
      = ( ( ord_less_nat @ Y2 @ X )
        | ( X = Y2 ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_127_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_128_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_129_linorder__neqE__nat,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_nat @ X @ Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_130_infinite__descent,axiom,(
    ! [P5: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ~ ( P5 @ N3 )
         => ? [M3: nat] :
              ( ( ord_less_nat @ M3 @ N3 )
              & ~ ( P5 @ M3 ) ) )
     => ( P5 @ N ) ) )).

% infinite_descent
thf(fact_131_nat__less__induct,axiom,(
    ! [P5: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M3: nat] :
              ( ( ord_less_nat @ M3 @ N3 )
             => ( P5 @ M3 ) )
         => ( P5 @ N3 ) )
     => ( P5 @ N ) ) )).

% nat_less_induct
thf(fact_132_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_133_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_134_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_135_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_136_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_137_add__less__imp__less__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
     => ( ord_less_nat @ A @ B ) ) )).

% add_less_imp_less_right
thf(fact_138_add__less__imp__less__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
     => ( ord_less_nat @ A @ B ) ) )).

% add_less_imp_less_left
thf(fact_139_add__strict__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) ) ) )).

% add_strict_right_mono
thf(fact_140_add__strict__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) ) ) )).

% add_strict_left_mono
thf(fact_141_add__strict__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ C @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_strict_mono
thf(fact_142_add__mono__thms__linordered__field_I1_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( K = L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(1)
thf(fact_143_add__mono__thms__linordered__field_I2_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(2)
thf(fact_144_add__mono__thms__linordered__field_I5_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(5)
thf(fact_145_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M2: nat,N2: nat] :
          ( ( ord_less_eq_nat @ M2 @ N2 )
          & ( M2 != N2 ) ) ) )).

% nat_less_le
thf(fact_146_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_147_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M2: nat,N2: nat] :
          ( ( ord_less_nat @ M2 @ N2 )
          | ( M2 = N2 ) ) ) )).

% le_eq_less_or_eq
thf(fact_148_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_149_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_150_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_nat @ I2 @ J2 )
         => ( ord_less_nat @ ( F @ I2 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I @ J )
       => ( ord_less_eq_nat @ ( F @ I ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_151_less__add__eq__less,axiom,(
    ! [K: nat,L: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ K @ L )
     => ( ( ( plus_plus_nat @ M @ L )
          = ( plus_plus_nat @ K @ N ) )
       => ( ord_less_nat @ M @ N ) ) ) )).

% less_add_eq_less
thf(fact_152_trans__less__add2,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ I @ ( plus_plus_nat @ M @ J ) ) ) )).

% trans_less_add2
thf(fact_153_trans__less__add1,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ I @ ( plus_plus_nat @ J @ M ) ) ) )).

% trans_less_add1
thf(fact_154_add__less__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ K ) ) ) )).

% add_less_mono1
thf(fact_155_not__add__less2,axiom,(
    ! [J: nat,I: nat] :
      ~ ( ord_less_nat @ ( plus_plus_nat @ J @ I ) @ I ) )).

% not_add_less2
thf(fact_156_not__add__less1,axiom,(
    ! [I: nat,J: nat] :
      ~ ( ord_less_nat @ ( plus_plus_nat @ I @ J ) @ I ) )).

% not_add_less1
thf(fact_157_add__less__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ( ord_less_nat @ K @ L )
       => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) ) )).

% add_less_mono
thf(fact_158_add__lessD1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ I @ J ) @ K )
     => ( ord_less_nat @ I @ K ) ) )).

% add_lessD1
thf(fact_159_LeastI,axiom,(
    ! [P5: nat > $o,K: nat] :
      ( ( P5 @ K )
     => ( P5 @ ( ord_Least_nat @ P5 ) ) ) )).

% LeastI
thf(fact_160_leD,axiom,(
    ! [Y2: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y2 @ X )
     => ~ ( ord_less_nat @ X @ Y2 ) ) )).

% leD
thf(fact_161_leI,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ Y2 @ X ) ) )).

% leI
thf(fact_162_le__less,axiom,
    ( ord_less_eq_nat
    = ( ^ [X2: nat,Y3: nat] :
          ( ( ord_less_nat @ X2 @ Y3 )
          | ( X2 = Y3 ) ) ) )).

% le_less
thf(fact_163_less__le,axiom,
    ( ord_less_nat
    = ( ^ [X2: nat,Y3: nat] :
          ( ( ord_less_eq_nat @ X2 @ Y3 )
          & ( X2 != Y3 ) ) ) )).

% less_le
thf(fact_164_order__le__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_165_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_166_order__less__le__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y4 )
             => ( ord_less_eq_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_167_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_nat @ X3 @ Y4 )
             => ( ord_less_nat @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_168_not__le,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ~ ( ord_less_eq_nat @ X @ Y2 ) )
      = ( ord_less_nat @ Y2 @ X ) ) )).

% not_le
thf(fact_169_not__less,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y2 ) )
      = ( ord_less_eq_nat @ Y2 @ X ) ) )).

% not_less
thf(fact_170_le__neq__trans,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( A != B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_171_antisym__conv1,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv1
thf(fact_172_antisym__conv2,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ~ ( ord_less_nat @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv2
thf(fact_173_less__imp__le,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ X @ Y2 ) ) )).

% less_imp_le
thf(fact_174_le__less__trans,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% le_less_trans
thf(fact_175_less__le__trans,axiom,(
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_le_trans
thf(fact_176_le__less__linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
      | ( ord_less_nat @ Y2 @ X ) ) )).

% le_less_linear
thf(fact_177_le__imp__less__or__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_nat @ X @ Y2 )
        | ( X = Y2 ) ) ) )).

% le_imp_less_or_eq
thf(fact_178_less__le__not__le,axiom,
    ( ord_less_nat
    = ( ^ [X2: nat,Y3: nat] :
          ( ( ord_less_eq_nat @ X2 @ Y3 )
          & ~ ( ord_less_eq_nat @ Y3 @ X2 ) ) ) )).

% less_le_not_le
thf(fact_179_not__le__imp__less,axiom,(
    ! [Y2: nat,X: nat] :
      ( ~ ( ord_less_eq_nat @ Y2 @ X )
     => ( ord_less_nat @ X @ Y2 ) ) )).

% not_le_imp_less
thf(fact_180_order_Ostrict__trans1,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans1
thf(fact_181_order_Ostrict__trans2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans2
thf(fact_182_order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [A3: nat,B2: nat] :
          ( ( ord_less_nat @ A3 @ B2 )
          | ( A3 = B2 ) ) ) )).

% order.order_iff_strict
thf(fact_183_order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [A3: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A3 @ B2 )
          & ( A3 != B2 ) ) ) )).

% order.strict_iff_order
thf(fact_184_dual__order_Ostrict__trans1,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans1
thf(fact_185_dual__order_Ostrict__trans2,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans2
thf(fact_186_order_Ostrict__implies__order,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% order.strict_implies_order
thf(fact_187_dual__order_Oorder__iff__strict,axiom,
    ( ord_less_eq_nat
    = ( ^ [B2: nat,A3: nat] :
          ( ( ord_less_nat @ B2 @ A3 )
          | ( A3 = B2 ) ) ) )).

% dual_order.order_iff_strict
thf(fact_188_dual__order_Ostrict__iff__order,axiom,
    ( ord_less_nat
    = ( ^ [B2: nat,A3: nat] :
          ( ( ord_less_eq_nat @ B2 @ A3 )
          & ( A3 != B2 ) ) ) )).

% dual_order.strict_iff_order
thf(fact_189_dual__order_Ostrict__implies__order,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ord_less_eq_nat @ B @ A ) ) )).

% dual_order.strict_implies_order
thf(fact_190_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_191_Graph_OisPath_Osimps_I1_J,axiom,(
    ! [C: product_prod_nat_nat > capacity,U: nat,V: nat] :
      ( ( isPath_capacity @ C @ U @ nil_Pr1308055047at_nat @ V )
      = ( U = V ) ) )).

% Graph.isPath.simps(1)
thf(fact_192_add__less__le__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_less_le_mono
thf(fact_193_add__le__less__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ C @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_le_less_mono
thf(fact_194_add__mono__thms__linordered__field_I3_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(3)
thf(fact_195_add__mono__thms__linordered__field_I4_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(4)
thf(fact_196_mono__nat__linear__lb,axiom,(
    ! [F: nat > nat,M: nat,K: nat] :
      ( ! [M4: nat,N3: nat] :
          ( ( ord_less_nat @ M4 @ N3 )
         => ( ord_less_nat @ ( F @ M4 ) @ ( F @ N3 ) ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ ( F @ M ) @ K ) @ ( F @ ( plus_plus_nat @ M @ K ) ) ) ) )).

% mono_nat_linear_lb
thf(fact_197_Graph_OisSPath__pathLE,axiom,(
    ! [C: product_prod_nat_nat > capacity,S: nat,P2: list_P559422087at_nat,T: nat] :
      ( ( isPath_capacity @ C @ S @ P2 @ T )
     => ? [P6: list_P559422087at_nat] :
          ( isSimp1359852763pacity @ C @ S @ P6 @ T ) ) )).

% Graph.isSPath_pathLE
thf(fact_198_Least1I,axiom,(
    ! [P5: nat > $o] :
      ( ? [X5: nat] :
          ( ( P5 @ X5 )
          & ! [Y4: nat] :
              ( ( P5 @ Y4 )
             => ( ord_less_eq_nat @ X5 @ Y4 ) )
          & ! [Y4: nat] :
              ( ( ( P5 @ Y4 )
                & ! [Ya: nat] :
                    ( ( P5 @ Ya )
                   => ( ord_less_eq_nat @ Y4 @ Ya ) ) )
             => ( Y4 = X5 ) ) )
     => ( P5 @ ( ord_Least_nat @ P5 ) ) ) )).

% Least1I
thf(fact_199_Least1__le,axiom,(
    ! [P5: nat > $o,Z2: nat] :
      ( ? [X5: nat] :
          ( ( P5 @ X5 )
          & ! [Y4: nat] :
              ( ( P5 @ Y4 )
             => ( ord_less_eq_nat @ X5 @ Y4 ) )
          & ! [Y4: nat] :
              ( ( ( P5 @ Y4 )
                & ! [Ya: nat] :
                    ( ( P5 @ Ya )
                   => ( ord_less_eq_nat @ Y4 @ Ya ) ) )
             => ( Y4 = X5 ) ) )
     => ( ( P5 @ Z2 )
       => ( ord_less_eq_nat @ ( ord_Least_nat @ P5 ) @ Z2 ) ) ) )).

% Least1_le
thf(fact_200_LeastI2__order,axiom,(
    ! [P5: nat > $o,X: nat,Q: nat > $o] :
      ( ( P5 @ X )
     => ( ! [Y4: nat] :
            ( ( P5 @ Y4 )
           => ( ord_less_eq_nat @ X @ Y4 ) )
       => ( ! [X3: nat] :
              ( ( P5 @ X3 )
             => ( ! [Y5: nat] :
                    ( ( P5 @ Y5 )
                   => ( ord_less_eq_nat @ X3 @ Y5 ) )
               => ( Q @ X3 ) ) )
         => ( Q @ ( ord_Least_nat @ P5 ) ) ) ) ) )).

% LeastI2_order
thf(fact_201_Least__equality,axiom,(
    ! [P5: nat > $o,X: nat] :
      ( ( P5 @ X )
     => ( ! [Y4: nat] :
            ( ( P5 @ Y4 )
           => ( ord_less_eq_nat @ X @ Y4 ) )
       => ( ( ord_Least_nat @ P5 )
          = X ) ) ) )).

% Least_equality
thf(fact_202_LeastI2__wellorder,axiom,(
    ! [P5: nat > $o,A: nat,Q: nat > $o] :
      ( ( P5 @ A )
     => ( ! [A4: nat] :
            ( ( P5 @ A4 )
           => ( ! [B4: nat] :
                  ( ( P5 @ B4 )
                 => ( ord_less_eq_nat @ A4 @ B4 ) )
             => ( Q @ A4 ) ) )
       => ( Q @ ( ord_Least_nat @ P5 ) ) ) ) )).

% LeastI2_wellorder
thf(fact_203_LeastI2__wellorder__ex,axiom,(
    ! [P5: nat > $o,Q: nat > $o] :
      ( ? [X_12: nat] :
          ( P5 @ X_12 )
     => ( ! [A4: nat] :
            ( ( P5 @ A4 )
           => ( ! [B4: nat] :
                  ( ( P5 @ B4 )
                 => ( ord_less_eq_nat @ A4 @ B4 ) )
             => ( Q @ A4 ) ) )
       => ( Q @ ( ord_Least_nat @ P5 ) ) ) ) )).

% LeastI2_wellorder_ex
thf(fact_204_Graph_OshortestPath__is__simple,axiom,(
    ! [C: product_prod_nat_nat > capacity,S: nat,P2: list_P559422087at_nat,T: nat] :
      ( ( isShor1936442771pacity @ C @ S @ P2 @ T )
     => ( isSimp1359852763pacity @ C @ S @ P2 @ T ) ) )).

% Graph.shortestPath_is_simple
thf(fact_205_Least__le,axiom,(
    ! [P5: nat > $o,K: nat] :
      ( ( P5 @ K )
     => ( ord_less_eq_nat @ ( ord_Least_nat @ P5 ) @ K ) ) )).

% Least_le
thf(fact_206_Graph_Omin__dist__less,axiom,(
    ! [C: product_prod_nat_nat > capacity,Src: nat,V: nat,D: nat,D3: nat] :
      ( ( connected_capacity @ C @ Src @ V )
     => ( ( ( min_dist_capacity @ C @ Src @ V )
          = D )
       => ( ( ord_less_nat @ D3 @ D )
         => ? [V3: nat] :
              ( ( connected_capacity @ C @ Src @ V3 )
              & ( ( min_dist_capacity @ C @ Src @ V3 )
                = D3 ) ) ) ) ) )).

% Graph.min_dist_less
thf(fact_207_Graph_OreachableNodes__def,axiom,
    ( reacha1693770334pacity
    = ( ^ [C2: product_prod_nat_nat > capacity,U2: nat] :
          ( collect_nat @ ( connected_capacity @ C2 @ U2 ) ) ) )).

% Graph.reachableNodes_def
thf(fact_208_add__right__imp__eq,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
     => ( B = C ) ) )).

% add_right_imp_eq
thf(fact_209_add__left__imp__eq,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
     => ( B = C ) ) )).

% add_left_imp_eq
thf(fact_210_add_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( plus_plus_nat @ B @ ( plus_plus_nat @ A @ C ) )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.left_commute
thf(fact_211_add_Ocommute,axiom,
    ( plus_plus_nat
    = ( ^ [A3: nat,B2: nat] :
          ( plus_plus_nat @ B2 @ A3 ) ) )).

% add.commute
thf(fact_212_add_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.assoc
thf(fact_213_group__cancel_Oadd2,axiom,(
    ! [B5: nat,K: nat,B: nat,A: nat] :
      ( ( B5
        = ( plus_plus_nat @ K @ B ) )
     => ( ( plus_plus_nat @ A @ B5 )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add2
thf(fact_214_group__cancel_Oadd1,axiom,(
    ! [A2: nat,K: nat,A: nat,B: nat] :
      ( ( A2
        = ( plus_plus_nat @ K @ A ) )
     => ( ( plus_plus_nat @ A2 @ B )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add1
thf(fact_215_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( K = L ) )
     => ( ( plus_plus_nat @ I @ K )
        = ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_216_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_217_Graph_Omin__dist__def,axiom,
    ( min_dist_capacity
    = ( ^ [C2: product_prod_nat_nat > capacity,V4: nat,V5: nat] :
          ( ord_Least_nat
          @ ^ [D6: nat] :
              ( dist_capacity @ C2 @ V4 @ D6 @ V5 ) ) ) )).

% Graph.min_dist_def
thf(fact_218_size__neq__size__imp__neq,axiom,(
    ! [X: list_P559422087at_nat,Y2: list_P559422087at_nat] :
      ( ( ( size_s1990949619at_nat @ X )
       != ( size_s1990949619at_nat @ Y2 ) )
     => ( X != Y2 ) ) )).

% size_neq_size_imp_neq
thf(fact_219_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_220_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_221_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_222_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_223_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_224_Nat_Oex__has__greatest__nat,axiom,(
    ! [P5: nat > $o,K: nat,B: nat] :
      ( ( P5 @ K )
     => ( ! [Y4: nat] :
            ( ( P5 @ Y4 )
           => ( ord_less_eq_nat @ Y4 @ B ) )
       => ? [X3: nat] :
            ( ( P5 @ X3 )
            & ! [Y5: nat] :
                ( ( P5 @ Y5 )
               => ( ord_less_eq_nat @ Y5 @ X3 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_225_Graph_OisShortestPath__alt,axiom,
    ( isShor1936442771pacity
    = ( ^ [C2: product_prod_nat_nat > capacity,U2: nat,P: list_P559422087at_nat,V4: nat] :
          ( ( isSimp1359852763pacity @ C2 @ U2 @ P @ V4 )
          & ( ( size_s1990949619at_nat @ P )
            = ( min_dist_capacity @ C2 @ U2 @ V4 ) ) ) ) )).

% Graph.isShortestPath_alt
thf(fact_226_add__mono__thms__linordered__semiring_I3_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( K = L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(3)
thf(fact_227_add__mono__thms__linordered__semiring_I2_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(2)
thf(fact_228_add__mono__thms__linordered__semiring_I1_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(1)
thf(fact_229_add__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_mono
thf(fact_230_add__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) ) ) )).

% add_left_mono
thf(fact_231_less__eqE,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ~ ! [C3: nat] :
            ( B
           != ( plus_plus_nat @ A @ C3 ) ) ) )).

% less_eqE
thf(fact_232_add__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) ) ) )).

% add_right_mono
thf(fact_233_le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [A3: nat,B2: nat] :
        ? [C2: nat] :
          ( B2
          = ( plus_plus_nat @ A3 @ C2 ) ) ) )).

% le_iff_add
thf(fact_234_add__le__imp__le__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_left
thf(fact_235_add__le__imp__le__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_right
thf(fact_236_add__leE,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq_nat @ M @ N )
         => ~ ( ord_less_eq_nat @ K @ N ) ) ) )).

% add_leE
thf(fact_237_le__add1,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ N @ ( plus_plus_nat @ N @ M ) ) )).

% le_add1
thf(fact_238_le__add2,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ N @ ( plus_plus_nat @ M @ N ) ) )).

% le_add2
thf(fact_239_add__leD1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% add_leD1

% Conjectures (1)
thf(conj_0,conjecture,(
    ord_less_eq_nat @ ( min_dist_capacity @ c @ s @ va ) @ ( size_s1990949619at_nat @ p1a ) )).

%------------------------------------------------------------------------------
