%------------------------------------------------------------------------------
% File     : SLH611^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer Poincare_Bendixson problem prob_55__19558810_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : Poincare_Bendixson/prob_55__19558810_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  374 (   0 unit;  20 type;   0 defn)
%            Number of atoms       : 3916 ( 460 equality;1925 variable)
%            Maximal formula depth :   19 (   8 average)
%            Number of connectives : 2666 (  24   ~;  24   |;  48   &;2312   @)
%                                         (   0 <=>; 258  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   40 (  40   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   22 (  20   :;   0   =)
%            Number of variables   :  872 (   0 sgn; 846   !;   7   ?;  19   ^)
%                                         ( 872   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:41:45.547
%------------------------------------------------------------------------------
% Could-be-implicit typings (3)
thf(ty_n_t__Set__Oset_It__Real__Oreal_J,type,(
    set_real: $tType )).

thf(ty_n_t__Real__Oreal,type,(
    real: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (17)
thf(sy_c_Groups_Ominus__class_Ominus_001t__Nat__Onat,type,(
    minus_minus_nat: nat > nat > nat )).

thf(sy_c_Groups_Ominus__class_Ominus_001t__Real__Oreal,type,(
    minus_minus_real: real > real > real )).

thf(sy_c_Groups_Oone__class_Oone_001t__Nat__Onat,type,(
    one_one_nat: nat )).

thf(sy_c_Groups_Oone__class_Oone_001t__Real__Oreal,type,(
    one_one_real: real )).

thf(sy_c_Groups_Oplus__class_Oplus_001t__Nat__Onat,type,(
    plus_plus_nat: nat > nat > nat )).

thf(sy_c_Groups_Oplus__class_Oplus_001t__Real__Oreal,type,(
    plus_plus_real: real > real > real )).

thf(sy_c_Groups_Otimes__class_Otimes_001t__Nat__Onat,type,(
    times_times_nat: nat > nat > nat )).

thf(sy_c_Groups_Otimes__class_Otimes_001t__Real__Oreal,type,(
    times_times_real: real > real > real )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Real__Oreal,type,(
    zero_zero_real: real )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Real__Oreal,type,(
    ord_less_eq_real: real > real > $o )).

thf(sy_c_Set_OCollect_001t__Real__Oreal,type,(
    collect_real: ( real > $o ) > set_real )).

thf(sy_c_member_001t__Real__Oreal,type,(
    member_real: real > set_real > $o )).

thf(sy_v_t,type,(
    t: real )).

thf(sy_v_t_H,type,(
    t2: real )).

thf(sy_v_xa,type,(
    xa: real )).

% Relevant facts (351)
thf(fact_0_assms_I1_J,axiom,(
    ord_less_eq_real @ t @ t2 )).

% assms(1)
thf(fact_1_le__add__diff__inverse,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( plus_plus_real @ B @ ( minus_minus_real @ A @ B ) )
        = A ) ) )).

% le_add_diff_inverse
thf(fact_2_le__add__diff__inverse,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( plus_plus_nat @ B @ ( minus_minus_nat @ A @ B ) )
        = A ) ) )).

% le_add_diff_inverse
thf(fact_3_le__add__diff__inverse2,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( plus_plus_real @ ( minus_minus_real @ A @ B ) @ B )
        = A ) ) )).

% le_add_diff_inverse2
thf(fact_4_le__add__diff__inverse2,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( plus_plus_nat @ ( minus_minus_nat @ A @ B ) @ B )
        = A ) ) )).

% le_add_diff_inverse2
thf(fact_5_diff__add__zero,axiom,(
    ! [A: nat,B: nat] :
      ( ( minus_minus_nat @ A @ ( plus_plus_nat @ A @ B ) )
      = zero_zero_nat ) )).

% diff_add_zero
thf(fact_6_diff__numeral__special_I9_J,axiom,
    ( ( minus_minus_real @ one_one_real @ one_one_real )
    = zero_zero_real )).

% diff_numeral_special(9)
thf(fact_7_sum__squares__eq__zero__iff,axiom,(
    ! [X: real,Y: real] :
      ( ( ( plus_plus_real @ ( times_times_real @ X @ X ) @ ( times_times_real @ Y @ Y ) )
        = zero_zero_real )
      = ( ( X = zero_zero_real )
        & ( Y = zero_zero_real ) ) ) )).

% sum_squares_eq_zero_iff
thf(fact_8_mult__cancel__left1,axiom,(
    ! [C: real,B: real] :
      ( ( C
        = ( times_times_real @ C @ B ) )
      = ( ( C = zero_zero_real )
        | ( B = one_one_real ) ) ) )).

% mult_cancel_left1
thf(fact_9_mult__cancel__left2,axiom,(
    ! [C: real,A: real] :
      ( ( ( times_times_real @ C @ A )
        = C )
      = ( ( C = zero_zero_real )
        | ( A = one_one_real ) ) ) )).

% mult_cancel_left2
thf(fact_10_mult__cancel__right1,axiom,(
    ! [C: real,B: real] :
      ( ( C
        = ( times_times_real @ B @ C ) )
      = ( ( C = zero_zero_real )
        | ( B = one_one_real ) ) ) )).

% mult_cancel_right1
thf(fact_11_mult__cancel__right2,axiom,(
    ! [A: real,C: real] :
      ( ( ( times_times_real @ A @ C )
        = C )
      = ( ( C = zero_zero_real )
        | ( A = one_one_real ) ) ) )).

% mult_cancel_right2
thf(fact_12_diff__ge__0__iff__ge,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( minus_minus_real @ A @ B ) )
      = ( ord_less_eq_real @ B @ A ) ) )).

% diff_ge_0_iff_ge
thf(fact_13_add__le__same__cancel1,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ B @ A ) @ B )
      = ( ord_less_eq_real @ A @ zero_zero_real ) ) )).

% add_le_same_cancel1
thf(fact_14_add__le__same__cancel1,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ B @ A ) @ B )
      = ( ord_less_eq_nat @ A @ zero_zero_nat ) ) )).

% add_le_same_cancel1
thf(fact_15_add__le__same__cancel2,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ A @ B ) @ B )
      = ( ord_less_eq_real @ A @ zero_zero_real ) ) )).

% add_le_same_cancel2
thf(fact_16_add__le__same__cancel2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ B ) @ B )
      = ( ord_less_eq_nat @ A @ zero_zero_nat ) ) )).

% add_le_same_cancel2
thf(fact_17_add__right__cancel,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ( plus_plus_real @ B @ A )
        = ( plus_plus_real @ C @ A ) )
      = ( B = C ) ) )).

% add_right_cancel
thf(fact_18_add__right__cancel,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
      = ( B = C ) ) )).

% add_right_cancel
thf(fact_19_add__left__cancel,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ( plus_plus_real @ A @ B )
        = ( plus_plus_real @ A @ C ) )
      = ( B = C ) ) )).

% add_left_cancel
thf(fact_20_add__left__cancel,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
      = ( B = C ) ) )).

% add_left_cancel
thf(fact_21_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_22_mult__cancel__right,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( ( times_times_real @ A @ C )
        = ( times_times_real @ B @ C ) )
      = ( ( C = zero_zero_real )
        | ( A = B ) ) ) )).

% mult_cancel_right
thf(fact_23_mult__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ( times_times_nat @ A @ C )
        = ( times_times_nat @ B @ C ) )
      = ( ( C = zero_zero_nat )
        | ( A = B ) ) ) )).

% mult_cancel_right
thf(fact_24_mult__cancel__left,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( ( times_times_real @ C @ A )
        = ( times_times_real @ C @ B ) )
      = ( ( C = zero_zero_real )
        | ( A = B ) ) ) )).

% mult_cancel_left
thf(fact_25_mult__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ( times_times_nat @ C @ A )
        = ( times_times_nat @ C @ B ) )
      = ( ( C = zero_zero_nat )
        | ( A = B ) ) ) )).

% mult_cancel_left
thf(fact_26_mult__eq__0__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ( times_times_real @ A @ B )
        = zero_zero_real )
      = ( ( A = zero_zero_real )
        | ( B = zero_zero_real ) ) ) )).

% mult_eq_0_iff
thf(fact_27_mult__eq__0__iff,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
        = zero_zero_nat )
      = ( ( A = zero_zero_nat )
        | ( B = zero_zero_nat ) ) ) )).

% mult_eq_0_iff
thf(fact_28_mult__zero__right,axiom,(
    ! [A: real] :
      ( ( times_times_real @ A @ zero_zero_real )
      = zero_zero_real ) )).

% mult_zero_right
thf(fact_29_mult__zero__right,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ zero_zero_nat )
      = zero_zero_nat ) )).

% mult_zero_right
thf(fact_30_mult__zero__left,axiom,(
    ! [A: real] :
      ( ( times_times_real @ zero_zero_real @ A )
      = zero_zero_real ) )).

% mult_zero_left
thf(fact_31_mult__zero__left,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% mult_zero_left
thf(fact_32_zero__eq__add__iff__both__eq__0,axiom,(
    ! [X: nat,Y: nat] :
      ( ( zero_zero_nat
        = ( plus_plus_nat @ X @ Y ) )
      = ( ( X = zero_zero_nat )
        & ( Y = zero_zero_nat ) ) ) )).

% zero_eq_add_iff_both_eq_0
thf(fact_33_add__eq__0__iff__both__eq__0,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ( plus_plus_nat @ X @ Y )
        = zero_zero_nat )
      = ( ( X = zero_zero_nat )
        & ( Y = zero_zero_nat ) ) ) )).

% add_eq_0_iff_both_eq_0
thf(fact_34_add__cancel__right__right,axiom,(
    ! [A: real,B: real] :
      ( ( A
        = ( plus_plus_real @ A @ B ) )
      = ( B = zero_zero_real ) ) )).

% add_cancel_right_right
thf(fact_35_add__cancel__right__right,axiom,(
    ! [A: nat,B: nat] :
      ( ( A
        = ( plus_plus_nat @ A @ B ) )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_right_right
thf(fact_36_add__cancel__right__left,axiom,(
    ! [A: real,B: real] :
      ( ( A
        = ( plus_plus_real @ B @ A ) )
      = ( B = zero_zero_real ) ) )).

% add_cancel_right_left
thf(fact_37_add__cancel__right__left,axiom,(
    ! [A: nat,B: nat] :
      ( ( A
        = ( plus_plus_nat @ B @ A ) )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_right_left
thf(fact_38_add__cancel__left__right,axiom,(
    ! [A: real,B: real] :
      ( ( ( plus_plus_real @ A @ B )
        = A )
      = ( B = zero_zero_real ) ) )).

% add_cancel_left_right
thf(fact_39_add__cancel__left__right,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = A )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_left_right
thf(fact_40_add__cancel__left__left,axiom,(
    ! [B: real,A: real] :
      ( ( ( plus_plus_real @ B @ A )
        = A )
      = ( B = zero_zero_real ) ) )).

% add_cancel_left_left
thf(fact_41_add__cancel__left__left,axiom,(
    ! [B: nat,A: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = A )
      = ( B = zero_zero_nat ) ) )).

% add_cancel_left_left
thf(fact_42_double__zero__sym,axiom,(
    ! [A: real] :
      ( ( zero_zero_real
        = ( plus_plus_real @ A @ A ) )
      = ( A = zero_zero_real ) ) )).

% double_zero_sym
thf(fact_43_linordered__ab__group__add__class_Odouble__zero,axiom,(
    ! [A: real] :
      ( ( ( plus_plus_real @ A @ A )
        = zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% linordered_ab_group_add_class.double_zero
thf(fact_44_add_Oright__neutral,axiom,(
    ! [A: real] :
      ( ( plus_plus_real @ A @ zero_zero_real )
      = A ) )).

% add.right_neutral
thf(fact_45_add_Oright__neutral,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ A @ zero_zero_nat )
      = A ) )).

% add.right_neutral
thf(fact_46_add_Oleft__neutral,axiom,(
    ! [A: real] :
      ( ( plus_plus_real @ zero_zero_real @ A )
      = A ) )).

% add.left_neutral
thf(fact_47_add_Oleft__neutral,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ zero_zero_nat @ A )
      = A ) )).

% add.left_neutral
thf(fact_48_add__le__cancel__right,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ A @ C ) @ ( plus_plus_real @ B @ C ) )
      = ( ord_less_eq_real @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_49_add__le__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_50_add__le__cancel__left,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ C @ A ) @ ( plus_plus_real @ C @ B ) )
      = ( ord_less_eq_real @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_51_add__le__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_52_cancel__comm__monoid__add__class_Odiff__cancel,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ A )
      = zero_zero_real ) )).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_53_cancel__comm__monoid__add__class_Odiff__cancel,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ A @ A )
      = zero_zero_nat ) )).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_54_diff__zero,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ zero_zero_real )
      = A ) )).

% diff_zero
thf(fact_55_diff__zero,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ A @ zero_zero_nat )
      = A ) )).

% diff_zero
thf(fact_56_zero__diff,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% zero_diff
thf(fact_57_diff__0__right,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ zero_zero_real )
      = A ) )).

% diff_0_right
thf(fact_58_diff__self,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ A )
      = zero_zero_real ) )).

% diff_self
thf(fact_59_mult_Oright__neutral,axiom,(
    ! [A: real] :
      ( ( times_times_real @ A @ one_one_real )
      = A ) )).

% mult.right_neutral
thf(fact_60_mult_Oright__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ one_one_nat )
      = A ) )).

% mult.right_neutral
thf(fact_61_mult_Oleft__neutral,axiom,(
    ! [A: real] :
      ( ( times_times_real @ one_one_real @ A )
      = A ) )).

% mult.left_neutral
thf(fact_62_mult_Oleft__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ one_one_nat @ A )
      = A ) )).

% mult.left_neutral
thf(fact_63_add__diff__cancel__right_H,axiom,(
    ! [A: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ B )
      = A ) )).

% add_diff_cancel_right'
thf(fact_64_add__diff__cancel__right_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ A @ B ) @ B )
      = A ) )).

% add_diff_cancel_right'
thf(fact_65_add__diff__cancel__right,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ C ) @ ( plus_plus_real @ B @ C ) )
      = ( minus_minus_real @ A @ B ) ) )).

% add_diff_cancel_right
thf(fact_66_add__diff__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( minus_minus_nat @ A @ B ) ) )).

% add_diff_cancel_right
thf(fact_67_add__diff__cancel__left_H,axiom,(
    ! [A: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ A )
      = B ) )).

% add_diff_cancel_left'
thf(fact_68_add__diff__cancel__left_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ A @ B ) @ A )
      = B ) )).

% add_diff_cancel_left'
thf(fact_69_mem__Collect__eq,axiom,(
    ! [A: real,P: real > $o] :
      ( ( member_real @ A @ ( collect_real @ P ) )
      = ( P @ A ) ) )).

% mem_Collect_eq
thf(fact_70_Collect__mem__eq,axiom,(
    ! [A2: set_real] :
      ( ( collect_real
        @ ^ [X2: real] :
            ( member_real @ X2 @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_71_Collect__cong,axiom,(
    ! [P: real > $o,Q: real > $o] :
      ( ! [X3: real] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect_real @ P )
        = ( collect_real @ Q ) ) ) )).

% Collect_cong
thf(fact_72_add__diff__cancel__left,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ C @ A ) @ ( plus_plus_real @ C @ B ) )
      = ( minus_minus_real @ A @ B ) ) )).

% add_diff_cancel_left
thf(fact_73_add__diff__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( minus_minus_nat @ A @ B ) ) )).

% add_diff_cancel_left
thf(fact_74_diff__add__cancel,axiom,(
    ! [A: real,B: real] :
      ( ( plus_plus_real @ ( minus_minus_real @ A @ B ) @ B )
      = A ) )).

% diff_add_cancel
thf(fact_75_add__diff__cancel,axiom,(
    ! [A: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ B )
      = A ) )).

% add_diff_cancel
thf(fact_76_linordered__ab__group__add__class_Ozero__le__double__add__iff__zero__le__single__add,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( plus_plus_real @ A @ A ) )
      = ( ord_less_eq_real @ zero_zero_real @ A ) ) )).

% linordered_ab_group_add_class.zero_le_double_add_iff_zero_le_single_add
thf(fact_77_linordered__ab__group__add__class_Odouble__add__le__zero__iff__single__add__le__zero,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ A @ A ) @ zero_zero_real )
      = ( ord_less_eq_real @ A @ zero_zero_real ) ) )).

% linordered_ab_group_add_class.double_add_le_zero_iff_single_add_le_zero
thf(fact_78_le__add__same__cancel2,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ ( plus_plus_real @ B @ A ) )
      = ( ord_less_eq_real @ zero_zero_real @ B ) ) )).

% le_add_same_cancel2
thf(fact_79_le__add__same__cancel2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ ( plus_plus_nat @ B @ A ) )
      = ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )).

% le_add_same_cancel2
thf(fact_80_le__add__same__cancel1,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ ( plus_plus_real @ A @ B ) )
      = ( ord_less_eq_real @ zero_zero_real @ B ) ) )).

% le_add_same_cancel1
thf(fact_81_le__add__same__cancel1,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ ( plus_plus_nat @ A @ B ) )
      = ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )).

% le_add_same_cancel1
thf(fact_82_zero__reorient,axiom,(
    ! [X: real] :
      ( ( zero_zero_real = X )
      = ( X = zero_zero_real ) ) )).

% zero_reorient
thf(fact_83_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_84_mult_Oleft__commute,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( times_times_real @ B @ ( times_times_real @ A @ C ) )
      = ( times_times_real @ A @ ( times_times_real @ B @ C ) ) ) )).

% mult.left_commute
thf(fact_85_mult_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( times_times_nat @ B @ ( times_times_nat @ A @ C ) )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.left_commute
thf(fact_86_mult_Ocommute,axiom,
    ( times_times_real
    = ( ^ [A3: real,B2: real] :
          ( times_times_real @ B2 @ A3 ) ) )).

% mult.commute
thf(fact_87_mult_Ocommute,axiom,
    ( times_times_nat
    = ( ^ [A3: nat,B2: nat] :
          ( times_times_nat @ B2 @ A3 ) ) )).

% mult.commute
thf(fact_88_mult_Oassoc,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ ( times_times_real @ A @ B ) @ C )
      = ( times_times_real @ A @ ( times_times_real @ B @ C ) ) ) )).

% mult.assoc
thf(fact_89_mult_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% mult.assoc
thf(fact_90_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ ( times_times_real @ A @ B ) @ C )
      = ( times_times_real @ A @ ( times_times_real @ B @ C ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_91_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( times_times_nat @ A @ B ) @ C )
      = ( times_times_nat @ A @ ( times_times_nat @ B @ C ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_92_one__reorient,axiom,(
    ! [X: real] :
      ( ( one_one_real = X )
      = ( X = one_one_real ) ) )).

% one_reorient
thf(fact_93_one__reorient,axiom,(
    ! [X: nat] :
      ( ( one_one_nat = X )
      = ( X = one_one_nat ) ) )).

% one_reorient
thf(fact_94_add__right__imp__eq,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ( plus_plus_real @ B @ A )
        = ( plus_plus_real @ C @ A ) )
     => ( B = C ) ) )).

% add_right_imp_eq
thf(fact_95_add__right__imp__eq,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
     => ( B = C ) ) )).

% add_right_imp_eq
thf(fact_96_add__left__imp__eq,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ( plus_plus_real @ A @ B )
        = ( plus_plus_real @ A @ C ) )
     => ( B = C ) ) )).

% add_left_imp_eq
thf(fact_97_add__left__imp__eq,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
     => ( B = C ) ) )).

% add_left_imp_eq
thf(fact_98_add_Oleft__commute,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( plus_plus_real @ B @ ( plus_plus_real @ A @ C ) )
      = ( plus_plus_real @ A @ ( plus_plus_real @ B @ C ) ) ) )).

% add.left_commute
thf(fact_99_add_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( plus_plus_nat @ B @ ( plus_plus_nat @ A @ C ) )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.left_commute
thf(fact_100_add_Ocommute,axiom,
    ( plus_plus_real
    = ( ^ [A3: real,B2: real] :
          ( plus_plus_real @ B2 @ A3 ) ) )).

% add.commute
thf(fact_101_add_Ocommute,axiom,
    ( plus_plus_nat
    = ( ^ [A3: nat,B2: nat] :
          ( plus_plus_nat @ B2 @ A3 ) ) )).

% add.commute
thf(fact_102_add_Oright__cancel,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ( plus_plus_real @ B @ A )
        = ( plus_plus_real @ C @ A ) )
      = ( B = C ) ) )).

% add.right_cancel
thf(fact_103_add_Oleft__cancel,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ( plus_plus_real @ A @ B )
        = ( plus_plus_real @ A @ C ) )
      = ( B = C ) ) )).

% add.left_cancel
thf(fact_104_add_Oassoc,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( plus_plus_real @ ( plus_plus_real @ A @ B ) @ C )
      = ( plus_plus_real @ A @ ( plus_plus_real @ B @ C ) ) ) )).

% add.assoc
thf(fact_105_add_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.assoc
thf(fact_106_group__cancel_Oadd2,axiom,(
    ! [B3: real,K: real,B: real,A: real] :
      ( ( B3
        = ( plus_plus_real @ K @ B ) )
     => ( ( plus_plus_real @ A @ B3 )
        = ( plus_plus_real @ K @ ( plus_plus_real @ A @ B ) ) ) ) )).

% group_cancel.add2
thf(fact_107_group__cancel_Oadd2,axiom,(
    ! [B3: nat,K: nat,B: nat,A: nat] :
      ( ( B3
        = ( plus_plus_nat @ K @ B ) )
     => ( ( plus_plus_nat @ A @ B3 )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add2
thf(fact_108_group__cancel_Oadd1,axiom,(
    ! [A2: real,K: real,A: real,B: real] :
      ( ( A2
        = ( plus_plus_real @ K @ A ) )
     => ( ( plus_plus_real @ A2 @ B )
        = ( plus_plus_real @ K @ ( plus_plus_real @ A @ B ) ) ) ) )).

% group_cancel.add1
thf(fact_109_group__cancel_Oadd1,axiom,(
    ! [A2: nat,K: nat,A: nat,B: nat] :
      ( ( A2
        = ( plus_plus_nat @ K @ A ) )
     => ( ( plus_plus_nat @ A2 @ B )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add1
thf(fact_110_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I: real,J: real,K: real,L: real] :
      ( ( ( I = J )
        & ( K = L ) )
     => ( ( plus_plus_real @ I @ K )
        = ( plus_plus_real @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_111_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( K = L ) )
     => ( ( plus_plus_nat @ I @ K )
        = ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_112_is__num__normalize_I1_J,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( plus_plus_real @ ( plus_plus_real @ A @ B ) @ C )
      = ( plus_plus_real @ A @ ( plus_plus_real @ B @ C ) ) ) )).

% is_num_normalize(1)
thf(fact_113_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( plus_plus_real @ ( plus_plus_real @ A @ B ) @ C )
      = ( plus_plus_real @ A @ ( plus_plus_real @ B @ C ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_114_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_115_cancel__ab__semigroup__add__class_Odiff__right__commute,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( minus_minus_real @ ( minus_minus_real @ A @ C ) @ B )
      = ( minus_minus_real @ ( minus_minus_real @ A @ B ) @ C ) ) )).

% cancel_ab_semigroup_add_class.diff_right_commute
thf(fact_116_cancel__ab__semigroup__add__class_Odiff__right__commute,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ C ) @ B )
      = ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C ) ) )).

% cancel_ab_semigroup_add_class.diff_right_commute
thf(fact_117_diff__eq__diff__eq,axiom,(
    ! [A: real,B: real,C: real,D: real] :
      ( ( ( minus_minus_real @ A @ B )
        = ( minus_minus_real @ C @ D ) )
     => ( ( A = B )
        = ( C = D ) ) ) )).

% diff_eq_diff_eq
thf(fact_118_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_119_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_real @ zero_zero_real @ zero_zero_real )).

% le_numeral_extra(3)
thf(fact_120_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ zero_zero_nat )).

% le_numeral_extra(3)
thf(fact_121_mult__right__cancel,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( C != zero_zero_real )
     => ( ( ( times_times_real @ A @ C )
          = ( times_times_real @ B @ C ) )
        = ( A = B ) ) ) )).

% mult_right_cancel
thf(fact_122_mult__right__cancel,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( ( times_times_nat @ A @ C )
          = ( times_times_nat @ B @ C ) )
        = ( A = B ) ) ) )).

% mult_right_cancel
thf(fact_123_mult__left__cancel,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( C != zero_zero_real )
     => ( ( ( times_times_real @ C @ A )
          = ( times_times_real @ C @ B ) )
        = ( A = B ) ) ) )).

% mult_left_cancel
thf(fact_124_mult__left__cancel,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( C != zero_zero_nat )
     => ( ( ( times_times_nat @ C @ A )
          = ( times_times_nat @ C @ B ) )
        = ( A = B ) ) ) )).

% mult_left_cancel
thf(fact_125_no__zero__divisors,axiom,(
    ! [A: real,B: real] :
      ( ( A != zero_zero_real )
     => ( ( B != zero_zero_real )
       => ( ( times_times_real @ A @ B )
         != zero_zero_real ) ) ) )).

% no_zero_divisors
thf(fact_126_no__zero__divisors,axiom,(
    ! [A: nat,B: nat] :
      ( ( A != zero_zero_nat )
     => ( ( B != zero_zero_nat )
       => ( ( times_times_nat @ A @ B )
         != zero_zero_nat ) ) ) )).

% no_zero_divisors
thf(fact_127_divisors__zero,axiom,(
    ! [A: real,B: real] :
      ( ( ( times_times_real @ A @ B )
        = zero_zero_real )
     => ( ( A = zero_zero_real )
        | ( B = zero_zero_real ) ) ) )).

% divisors_zero
thf(fact_128_divisors__zero,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
        = zero_zero_nat )
     => ( ( A = zero_zero_nat )
        | ( B = zero_zero_nat ) ) ) )).

% divisors_zero
thf(fact_129_mult__not__zero,axiom,(
    ! [A: real,B: real] :
      ( ( ( times_times_real @ A @ B )
       != zero_zero_real )
     => ( ( A != zero_zero_real )
        & ( B != zero_zero_real ) ) ) )).

% mult_not_zero
thf(fact_130_mult__not__zero,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( times_times_nat @ A @ B )
       != zero_zero_nat )
     => ( ( A != zero_zero_nat )
        & ( B != zero_zero_nat ) ) ) )).

% mult_not_zero
thf(fact_131_zero__neq__one,axiom,(
    zero_zero_real != one_one_real )).

% zero_neq_one
thf(fact_132_zero__neq__one,axiom,(
    zero_zero_nat != one_one_nat )).

% zero_neq_one
thf(fact_133_le__numeral__extra_I4_J,axiom,(
    ord_less_eq_real @ one_one_real @ one_one_real )).

% le_numeral_extra(4)
thf(fact_134_le__numeral__extra_I4_J,axiom,(
    ord_less_eq_nat @ one_one_nat @ one_one_nat )).

% le_numeral_extra(4)
thf(fact_135_add_Ogroup__left__neutral,axiom,(
    ! [A: real] :
      ( ( plus_plus_real @ zero_zero_real @ A )
      = A ) )).

% add.group_left_neutral
thf(fact_136_add_Ocomm__neutral,axiom,(
    ! [A: real] :
      ( ( plus_plus_real @ A @ zero_zero_real )
      = A ) )).

% add.comm_neutral
thf(fact_137_add_Ocomm__neutral,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ A @ zero_zero_nat )
      = A ) )).

% add.comm_neutral
thf(fact_138_comm__monoid__add__class_Oadd__0,axiom,(
    ! [A: real] :
      ( ( plus_plus_real @ zero_zero_real @ A )
      = A ) )).

% comm_monoid_add_class.add_0
thf(fact_139_comm__monoid__add__class_Oadd__0,axiom,(
    ! [A: nat] :
      ( ( plus_plus_nat @ zero_zero_nat @ A )
      = A ) )).

% comm_monoid_add_class.add_0
thf(fact_140_add__le__imp__le__right,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ A @ C ) @ ( plus_plus_real @ B @ C ) )
     => ( ord_less_eq_real @ A @ B ) ) )).

% add_le_imp_le_right
thf(fact_141_add__le__imp__le__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_right
thf(fact_142_add__le__imp__le__left,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ C @ A ) @ ( plus_plus_real @ C @ B ) )
     => ( ord_less_eq_real @ A @ B ) ) )).

% add_le_imp_le_left
thf(fact_143_add__le__imp__le__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_left
thf(fact_144_le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [A3: nat,B2: nat] :
        ? [C2: nat] :
          ( B2
          = ( plus_plus_nat @ A3 @ C2 ) ) ) )).

% le_iff_add
thf(fact_145_add__right__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ord_less_eq_real @ ( plus_plus_real @ A @ C ) @ ( plus_plus_real @ B @ C ) ) ) )).

% add_right_mono
thf(fact_146_add__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) ) ) )).

% add_right_mono
thf(fact_147_less__eqE,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ~ ! [C3: nat] :
            ( B
           != ( plus_plus_nat @ A @ C3 ) ) ) )).

% less_eqE
thf(fact_148_add__left__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ord_less_eq_real @ ( plus_plus_real @ C @ A ) @ ( plus_plus_real @ C @ B ) ) ) )).

% add_left_mono
thf(fact_149_add__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) ) ) )).

% add_left_mono
thf(fact_150_add__mono,axiom,(
    ! [A: real,B: real,C: real,D: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ C @ D )
       => ( ord_less_eq_real @ ( plus_plus_real @ A @ C ) @ ( plus_plus_real @ B @ D ) ) ) ) )).

% add_mono
thf(fact_151_add__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_mono
thf(fact_152_add__mono__thms__linordered__semiring_I1_J,axiom,(
    ! [I: real,J: real,K: real,L: real] :
      ( ( ( ord_less_eq_real @ I @ J )
        & ( ord_less_eq_real @ K @ L ) )
     => ( ord_less_eq_real @ ( plus_plus_real @ I @ K ) @ ( plus_plus_real @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(1)
thf(fact_153_add__mono__thms__linordered__semiring_I1_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(1)
thf(fact_154_add__mono__thms__linordered__semiring_I2_J,axiom,(
    ! [I: real,J: real,K: real,L: real] :
      ( ( ( I = J )
        & ( ord_less_eq_real @ K @ L ) )
     => ( ord_less_eq_real @ ( plus_plus_real @ I @ K ) @ ( plus_plus_real @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(2)
thf(fact_155_add__mono__thms__linordered__semiring_I2_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(2)
thf(fact_156_add__mono__thms__linordered__semiring_I3_J,axiom,(
    ! [I: real,J: real,K: real,L: real] :
      ( ( ( ord_less_eq_real @ I @ J )
        & ( K = L ) )
     => ( ord_less_eq_real @ ( plus_plus_real @ I @ K ) @ ( plus_plus_real @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(3)
thf(fact_157_add__mono__thms__linordered__semiring_I3_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( K = L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(3)
thf(fact_158_eq__iff__diff__eq__0,axiom,
    ( ( ^ [Y2: real,Z: real] : ( Y2 = Z ) )
    = ( ^ [A3: real,B2: real] :
          ( ( minus_minus_real @ A3 @ B2 )
          = zero_zero_real ) ) )).

% eq_iff_diff_eq_0
thf(fact_159_diff__eq__diff__less__eq,axiom,(
    ! [A: real,B: real,C: real,D: real] :
      ( ( ( minus_minus_real @ A @ B )
        = ( minus_minus_real @ C @ D ) )
     => ( ( ord_less_eq_real @ A @ B )
        = ( ord_less_eq_real @ C @ D ) ) ) )).

% diff_eq_diff_less_eq
thf(fact_160_diff__right__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ord_less_eq_real @ ( minus_minus_real @ A @ C ) @ ( minus_minus_real @ B @ C ) ) ) )).

% diff_right_mono
thf(fact_161_diff__left__mono,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ord_less_eq_real @ ( minus_minus_real @ C @ A ) @ ( minus_minus_real @ C @ B ) ) ) )).

% diff_left_mono
thf(fact_162_diff__mono,axiom,(
    ! [A: real,B: real,D: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ D @ C )
       => ( ord_less_eq_real @ ( minus_minus_real @ A @ C ) @ ( minus_minus_real @ B @ D ) ) ) ) )).

% diff_mono
thf(fact_163_mult_Ocomm__neutral,axiom,(
    ! [A: real] :
      ( ( times_times_real @ A @ one_one_real )
      = A ) )).

% mult.comm_neutral
thf(fact_164_mult_Ocomm__neutral,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ A @ one_one_nat )
      = A ) )).

% mult.comm_neutral
thf(fact_165_comm__monoid__mult__class_Omult__1,axiom,(
    ! [A: real] :
      ( ( times_times_real @ one_one_real @ A )
      = A ) )).

% comm_monoid_mult_class.mult_1
thf(fact_166_comm__monoid__mult__class_Omult__1,axiom,(
    ! [A: nat] :
      ( ( times_times_nat @ one_one_nat @ A )
      = A ) )).

% comm_monoid_mult_class.mult_1
thf(fact_167_combine__common__factor,axiom,(
    ! [A: real,E: real,B: real,C: real] :
      ( ( plus_plus_real @ ( times_times_real @ A @ E ) @ ( plus_plus_real @ ( times_times_real @ B @ E ) @ C ) )
      = ( plus_plus_real @ ( times_times_real @ ( plus_plus_real @ A @ B ) @ E ) @ C ) ) )).

% combine_common_factor
thf(fact_168_combine__common__factor,axiom,(
    ! [A: nat,E: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( times_times_nat @ A @ E ) @ ( plus_plus_nat @ ( times_times_nat @ B @ E ) @ C ) )
      = ( plus_plus_nat @ ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ E ) @ C ) ) )).

% combine_common_factor
thf(fact_169_distrib__right,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ ( plus_plus_real @ A @ B ) @ C )
      = ( plus_plus_real @ ( times_times_real @ A @ C ) @ ( times_times_real @ B @ C ) ) ) )).

% distrib_right
thf(fact_170_distrib__right,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) )).

% distrib_right
thf(fact_171_distrib__left,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ A @ ( plus_plus_real @ B @ C ) )
      = ( plus_plus_real @ ( times_times_real @ A @ B ) @ ( times_times_real @ A @ C ) ) ) )).

% distrib_left
thf(fact_172_distrib__left,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ A @ ( plus_plus_nat @ B @ C ) )
      = ( plus_plus_nat @ ( times_times_nat @ A @ B ) @ ( times_times_nat @ A @ C ) ) ) )).

% distrib_left
thf(fact_173_comm__semiring__class_Odistrib,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ ( plus_plus_real @ A @ B ) @ C )
      = ( plus_plus_real @ ( times_times_real @ A @ C ) @ ( times_times_real @ B @ C ) ) ) )).

% comm_semiring_class.distrib
thf(fact_174_comm__semiring__class_Odistrib,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) )).

% comm_semiring_class.distrib
thf(fact_175_ring__class_Oring__distribs_I1_J,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ A @ ( plus_plus_real @ B @ C ) )
      = ( plus_plus_real @ ( times_times_real @ A @ B ) @ ( times_times_real @ A @ C ) ) ) )).

% ring_class.ring_distribs(1)
thf(fact_176_ring__class_Oring__distribs_I2_J,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ ( plus_plus_real @ A @ B ) @ C )
      = ( plus_plus_real @ ( times_times_real @ A @ C ) @ ( times_times_real @ B @ C ) ) ) )).

% ring_class.ring_distribs(2)
thf(fact_177_right__diff__distrib_H,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ A @ ( minus_minus_real @ B @ C ) )
      = ( minus_minus_real @ ( times_times_real @ A @ B ) @ ( times_times_real @ A @ C ) ) ) )).

% right_diff_distrib'
thf(fact_178_right__diff__distrib_H,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( times_times_nat @ A @ ( minus_minus_nat @ B @ C ) )
      = ( minus_minus_nat @ ( times_times_nat @ A @ B ) @ ( times_times_nat @ A @ C ) ) ) )).

% right_diff_distrib'
thf(fact_179_left__diff__distrib_H,axiom,(
    ! [B: real,C: real,A: real] :
      ( ( times_times_real @ ( minus_minus_real @ B @ C ) @ A )
      = ( minus_minus_real @ ( times_times_real @ B @ A ) @ ( times_times_real @ C @ A ) ) ) )).

% left_diff_distrib'
thf(fact_180_left__diff__distrib_H,axiom,(
    ! [B: nat,C: nat,A: nat] :
      ( ( times_times_nat @ ( minus_minus_nat @ B @ C ) @ A )
      = ( minus_minus_nat @ ( times_times_nat @ B @ A ) @ ( times_times_nat @ C @ A ) ) ) )).

% left_diff_distrib'
thf(fact_181_right__diff__distrib,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ A @ ( minus_minus_real @ B @ C ) )
      = ( minus_minus_real @ ( times_times_real @ A @ B ) @ ( times_times_real @ A @ C ) ) ) )).

% right_diff_distrib
thf(fact_182_left__diff__distrib,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( times_times_real @ ( minus_minus_real @ A @ B ) @ C )
      = ( minus_minus_real @ ( times_times_real @ A @ C ) @ ( times_times_real @ B @ C ) ) ) )).

% left_diff_distrib
thf(fact_183_add__implies__diff,axiom,(
    ! [C: real,B: real,A: real] :
      ( ( ( plus_plus_real @ C @ B )
        = A )
     => ( C
        = ( minus_minus_real @ A @ B ) ) ) )).

% add_implies_diff
thf(fact_184_add__implies__diff,axiom,(
    ! [C: nat,B: nat,A: nat] :
      ( ( ( plus_plus_nat @ C @ B )
        = A )
     => ( C
        = ( minus_minus_nat @ A @ B ) ) ) )).

% add_implies_diff
thf(fact_185_diff__diff__add,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( minus_minus_real @ ( minus_minus_real @ A @ B ) @ C )
      = ( minus_minus_real @ A @ ( plus_plus_real @ B @ C ) ) ) )).

% diff_diff_add
thf(fact_186_diff__diff__add,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C )
      = ( minus_minus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% diff_diff_add
thf(fact_187_diff__add__eq__diff__diff__swap,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( minus_minus_real @ A @ ( plus_plus_real @ B @ C ) )
      = ( minus_minus_real @ ( minus_minus_real @ A @ C ) @ B ) ) )).

% diff_add_eq_diff_diff_swap
thf(fact_188_diff__add__eq,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( plus_plus_real @ ( minus_minus_real @ A @ B ) @ C )
      = ( minus_minus_real @ ( plus_plus_real @ A @ C ) @ B ) ) )).

% diff_add_eq
thf(fact_189_diff__diff__eq2,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( minus_minus_real @ A @ ( minus_minus_real @ B @ C ) )
      = ( minus_minus_real @ ( plus_plus_real @ A @ C ) @ B ) ) )).

% diff_diff_eq2
thf(fact_190_add__diff__eq,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( plus_plus_real @ A @ ( minus_minus_real @ B @ C ) )
      = ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ C ) ) )).

% add_diff_eq
thf(fact_191_eq__diff__eq,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( A
        = ( minus_minus_real @ C @ B ) )
      = ( ( plus_plus_real @ A @ B )
        = C ) ) )).

% eq_diff_eq
thf(fact_192_diff__eq__eq,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ( minus_minus_real @ A @ B )
        = C )
      = ( A
        = ( plus_plus_real @ C @ B ) ) ) )).

% diff_eq_eq
thf(fact_193_group__cancel_Osub1,axiom,(
    ! [A2: real,K: real,A: real,B: real] :
      ( ( A2
        = ( plus_plus_real @ K @ A ) )
     => ( ( minus_minus_real @ A2 @ B )
        = ( plus_plus_real @ K @ ( minus_minus_real @ A @ B ) ) ) ) )).

% group_cancel.sub1
thf(fact_194_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ zero_zero_real @ C )
       => ( ord_less_eq_real @ ( times_times_real @ C @ A ) @ ( times_times_real @ C @ B ) ) ) ) )).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_195_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_196_zero__le__mult__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( times_times_real @ A @ B ) )
      = ( ( ( ord_less_eq_real @ zero_zero_real @ A )
          & ( ord_less_eq_real @ zero_zero_real @ B ) )
        | ( ( ord_less_eq_real @ A @ zero_zero_real )
          & ( ord_less_eq_real @ B @ zero_zero_real ) ) ) ) )).

% zero_le_mult_iff
thf(fact_197_mult__nonneg__nonpos2,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ B @ zero_zero_real )
       => ( ord_less_eq_real @ ( times_times_real @ B @ A ) @ zero_zero_real ) ) ) )).

% mult_nonneg_nonpos2
thf(fact_198_mult__nonneg__nonpos2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( times_times_nat @ B @ A ) @ zero_zero_nat ) ) ) )).

% mult_nonneg_nonpos2
thf(fact_199_mult__nonpos__nonneg,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ zero_zero_real )
     => ( ( ord_less_eq_real @ zero_zero_real @ B )
       => ( ord_less_eq_real @ ( times_times_real @ A @ B ) @ zero_zero_real ) ) ) )).

% mult_nonpos_nonneg
thf(fact_200_mult__nonpos__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_nonpos_nonneg
thf(fact_201_mult__nonneg__nonpos,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ B @ zero_zero_real )
       => ( ord_less_eq_real @ ( times_times_real @ A @ B ) @ zero_zero_real ) ) ) )).

% mult_nonneg_nonpos
thf(fact_202_mult__nonneg__nonpos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% mult_nonneg_nonpos
thf(fact_203_mult__nonneg__nonneg,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ zero_zero_real @ B )
       => ( ord_less_eq_real @ zero_zero_real @ ( times_times_real @ A @ B ) ) ) ) )).

% mult_nonneg_nonneg
thf(fact_204_mult__nonneg__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ zero_zero_nat @ ( times_times_nat @ A @ B ) ) ) ) )).

% mult_nonneg_nonneg
thf(fact_205_split__mult__neg__le,axiom,(
    ! [A: real,B: real] :
      ( ( ( ( ord_less_eq_real @ zero_zero_real @ A )
          & ( ord_less_eq_real @ B @ zero_zero_real ) )
        | ( ( ord_less_eq_real @ A @ zero_zero_real )
          & ( ord_less_eq_real @ zero_zero_real @ B ) ) )
     => ( ord_less_eq_real @ ( times_times_real @ A @ B ) @ zero_zero_real ) ) )).

% split_mult_neg_le
thf(fact_206_split__mult__neg__le,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( ( ord_less_eq_nat @ zero_zero_nat @ A )
          & ( ord_less_eq_nat @ B @ zero_zero_nat ) )
        | ( ( ord_less_eq_nat @ A @ zero_zero_nat )
          & ( ord_less_eq_nat @ zero_zero_nat @ B ) ) )
     => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ zero_zero_nat ) ) )).

% split_mult_neg_le
thf(fact_207_mult__le__0__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ ( times_times_real @ A @ B ) @ zero_zero_real )
      = ( ( ( ord_less_eq_real @ zero_zero_real @ A )
          & ( ord_less_eq_real @ B @ zero_zero_real ) )
        | ( ( ord_less_eq_real @ A @ zero_zero_real )
          & ( ord_less_eq_real @ zero_zero_real @ B ) ) ) ) )).

% mult_le_0_iff
thf(fact_208_mult__right__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ zero_zero_real @ C )
       => ( ord_less_eq_real @ ( times_times_real @ A @ C ) @ ( times_times_real @ B @ C ) ) ) ) )).

% mult_right_mono
thf(fact_209_mult__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ C ) ) ) ) )).

% mult_right_mono
thf(fact_210_mult__right__mono__neg,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ C @ zero_zero_real )
       => ( ord_less_eq_real @ ( times_times_real @ A @ C ) @ ( times_times_real @ B @ C ) ) ) ) )).

% mult_right_mono_neg
thf(fact_211_mult__left__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ zero_zero_real @ C )
       => ( ord_less_eq_real @ ( times_times_real @ C @ A ) @ ( times_times_real @ C @ B ) ) ) ) )).

% mult_left_mono
thf(fact_212_mult__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
       => ( ord_less_eq_nat @ ( times_times_nat @ C @ A ) @ ( times_times_nat @ C @ B ) ) ) ) )).

% mult_left_mono
thf(fact_213_mult__nonpos__nonpos,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ zero_zero_real )
     => ( ( ord_less_eq_real @ B @ zero_zero_real )
       => ( ord_less_eq_real @ zero_zero_real @ ( times_times_real @ A @ B ) ) ) ) )).

% mult_nonpos_nonpos
thf(fact_214_mult__left__mono__neg,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ C @ zero_zero_real )
       => ( ord_less_eq_real @ ( times_times_real @ C @ A ) @ ( times_times_real @ C @ B ) ) ) ) )).

% mult_left_mono_neg
thf(fact_215_split__mult__pos__le,axiom,(
    ! [A: real,B: real] :
      ( ( ( ( ord_less_eq_real @ zero_zero_real @ A )
          & ( ord_less_eq_real @ zero_zero_real @ B ) )
        | ( ( ord_less_eq_real @ A @ zero_zero_real )
          & ( ord_less_eq_real @ B @ zero_zero_real ) ) )
     => ( ord_less_eq_real @ zero_zero_real @ ( times_times_real @ A @ B ) ) ) )).

% split_mult_pos_le
thf(fact_216_zero__le__square,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ zero_zero_real @ ( times_times_real @ A @ A ) ) )).

% zero_le_square
thf(fact_217_mult__mono_H,axiom,(
    ! [A: real,B: real,C: real,D: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ C @ D )
       => ( ( ord_less_eq_real @ zero_zero_real @ A )
         => ( ( ord_less_eq_real @ zero_zero_real @ C )
           => ( ord_less_eq_real @ ( times_times_real @ A @ C ) @ ( times_times_real @ B @ D ) ) ) ) ) ) )).

% mult_mono'
thf(fact_218_mult__mono_H,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_mono'
thf(fact_219_mult__mono,axiom,(
    ! [A: real,B: real,C: real,D: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ C @ D )
       => ( ( ord_less_eq_real @ zero_zero_real @ B )
         => ( ( ord_less_eq_real @ zero_zero_real @ C )
           => ( ord_less_eq_real @ ( times_times_real @ A @ C ) @ ( times_times_real @ B @ D ) ) ) ) ) ) )).

% mult_mono
thf(fact_220_mult__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
         => ( ( ord_less_eq_nat @ zero_zero_nat @ C )
           => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ ( times_times_nat @ B @ D ) ) ) ) ) ) )).

% mult_mono
thf(fact_221_not__one__le__zero,axiom,(
    ~ ( ord_less_eq_real @ one_one_real @ zero_zero_real ) )).

% not_one_le_zero
thf(fact_222_not__one__le__zero,axiom,(
    ~ ( ord_less_eq_nat @ one_one_nat @ zero_zero_nat ) )).

% not_one_le_zero
thf(fact_223_zero__le__one,axiom,(
    ord_less_eq_real @ zero_zero_real @ one_one_real )).

% zero_le_one
thf(fact_224_zero__le__one,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ one_one_nat )).

% zero_le_one
thf(fact_225_add__nonpos__eq__0__iff,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ X @ zero_zero_real )
     => ( ( ord_less_eq_real @ Y @ zero_zero_real )
       => ( ( ( plus_plus_real @ X @ Y )
            = zero_zero_real )
          = ( ( X = zero_zero_real )
            & ( Y = zero_zero_real ) ) ) ) ) )).

% add_nonpos_eq_0_iff
thf(fact_226_add__nonpos__eq__0__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ Y @ zero_zero_nat )
       => ( ( ( plus_plus_nat @ X @ Y )
            = zero_zero_nat )
          = ( ( X = zero_zero_nat )
            & ( Y = zero_zero_nat ) ) ) ) ) )).

% add_nonpos_eq_0_iff
thf(fact_227_add__nonneg__eq__0__iff,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ X )
     => ( ( ord_less_eq_real @ zero_zero_real @ Y )
       => ( ( ( plus_plus_real @ X @ Y )
            = zero_zero_real )
          = ( ( X = zero_zero_real )
            & ( Y = zero_zero_real ) ) ) ) ) )).

% add_nonneg_eq_0_iff
thf(fact_228_add__nonneg__eq__0__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ X )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ Y )
       => ( ( ( plus_plus_nat @ X @ Y )
            = zero_zero_nat )
          = ( ( X = zero_zero_nat )
            & ( Y = zero_zero_nat ) ) ) ) ) )).

% add_nonneg_eq_0_iff
thf(fact_229_add__nonpos__nonpos,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ zero_zero_real )
     => ( ( ord_less_eq_real @ B @ zero_zero_real )
       => ( ord_less_eq_real @ ( plus_plus_real @ A @ B ) @ zero_zero_real ) ) ) )).

% add_nonpos_nonpos
thf(fact_230_add__nonpos__nonpos,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ B @ zero_zero_nat )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ B ) @ zero_zero_nat ) ) ) )).

% add_nonpos_nonpos
thf(fact_231_add__nonneg__nonneg,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ zero_zero_real @ B )
       => ( ord_less_eq_real @ zero_zero_real @ ( plus_plus_real @ A @ B ) ) ) ) )).

% add_nonneg_nonneg
thf(fact_232_add__nonneg__nonneg,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ zero_zero_nat @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% add_nonneg_nonneg
thf(fact_233_add__increasing2,axiom,(
    ! [C: real,B: real,A: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ C )
     => ( ( ord_less_eq_real @ B @ A )
       => ( ord_less_eq_real @ B @ ( plus_plus_real @ A @ C ) ) ) ) )).

% add_increasing2
thf(fact_234_add__increasing2,axiom,(
    ! [C: nat,B: nat,A: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ C )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( ord_less_eq_nat @ B @ ( plus_plus_nat @ A @ C ) ) ) ) )).

% add_increasing2
thf(fact_235_add__decreasing2,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( ord_less_eq_real @ C @ zero_zero_real )
     => ( ( ord_less_eq_real @ A @ B )
       => ( ord_less_eq_real @ ( plus_plus_real @ A @ C ) @ B ) ) ) )).

% add_decreasing2
thf(fact_236_add__decreasing2,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ C @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ B ) ) ) )).

% add_decreasing2
thf(fact_237_add__increasing,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ord_less_eq_real @ B @ ( plus_plus_real @ A @ C ) ) ) ) )).

% add_increasing
thf(fact_238_add__increasing,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ B @ ( plus_plus_nat @ A @ C ) ) ) ) )).

% add_increasing
thf(fact_239_add__decreasing,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( ord_less_eq_real @ A @ zero_zero_real )
     => ( ( ord_less_eq_real @ C @ B )
       => ( ord_less_eq_real @ ( plus_plus_real @ A @ C ) @ B ) ) ) )).

% add_decreasing
thf(fact_240_add__decreasing,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ B ) ) ) )).

% add_decreasing
thf(fact_241_le__iff__diff__le__0,axiom,
    ( ord_less_eq_real
    = ( ^ [A3: real,B2: real] :
          ( ord_less_eq_real @ ( minus_minus_real @ A3 @ B2 ) @ zero_zero_real ) ) )).

% le_iff_diff_le_0
thf(fact_242_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ( ( minus_minus_nat @ B @ A )
            = C )
          = ( B
            = ( plus_plus_nat @ C @ A ) ) ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_243_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( plus_plus_nat @ A @ ( minus_minus_nat @ B @ A ) )
        = B ) ) )).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_244_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( minus_minus_nat @ C @ ( minus_minus_nat @ B @ A ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ C @ A ) @ B ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_245_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( minus_minus_nat @ ( plus_plus_nat @ B @ C ) @ A )
        = ( plus_plus_nat @ ( minus_minus_nat @ B @ A ) @ C ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_246_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( plus_plus_nat @ ( minus_minus_nat @ B @ A ) @ C )
        = ( minus_minus_nat @ ( plus_plus_nat @ B @ C ) @ A ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_247_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( minus_minus_nat @ ( plus_plus_nat @ C @ B ) @ A )
        = ( plus_plus_nat @ C @ ( minus_minus_nat @ B @ A ) ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_248_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( plus_plus_nat @ C @ ( minus_minus_nat @ B @ A ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ C @ B ) @ A ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_249_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ ( minus_minus_nat @ B @ A ) )
        = ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ B ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_250_le__add__diff,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ C @ ( minus_minus_nat @ ( plus_plus_nat @ B @ C ) @ A ) ) ) )).

% le_add_diff
thf(fact_251_add__le__add__imp__diff__le,axiom,(
    ! [I: real,K: real,N: real,J: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ I @ K ) @ N )
     => ( ( ord_less_eq_real @ N @ ( plus_plus_real @ J @ K ) )
       => ( ( ord_less_eq_real @ ( plus_plus_real @ I @ K ) @ N )
         => ( ( ord_less_eq_real @ N @ ( plus_plus_real @ J @ K ) )
           => ( ord_less_eq_real @ ( minus_minus_real @ N @ K ) @ J ) ) ) ) ) )).

% add_le_add_imp_diff_le
thf(fact_252_add__le__add__imp__diff__le,axiom,(
    ! [I: nat,K: nat,N: nat,J: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ N )
     => ( ( ord_less_eq_nat @ N @ ( plus_plus_nat @ J @ K ) )
       => ( ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ N )
         => ( ( ord_less_eq_nat @ N @ ( plus_plus_nat @ J @ K ) )
           => ( ord_less_eq_nat @ ( minus_minus_nat @ N @ K ) @ J ) ) ) ) ) )).

% add_le_add_imp_diff_le
thf(fact_253_ordered__cancel__comm__monoid__diff__class_Odiff__add,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( plus_plus_nat @ ( minus_minus_nat @ B @ A ) @ A )
        = B ) ) )).

% ordered_cancel_comm_monoid_diff_class.diff_add
thf(fact_254_add__le__imp__le__diff,axiom,(
    ! [I: real,K: real,N: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ I @ K ) @ N )
     => ( ord_less_eq_real @ I @ ( minus_minus_real @ N @ K ) ) ) )).

% add_le_imp_le_diff
thf(fact_255_add__le__imp__le__diff,axiom,(
    ! [I: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ N )
     => ( ord_less_eq_nat @ I @ ( minus_minus_nat @ N @ K ) ) ) )).

% add_le_imp_le_diff
thf(fact_256_le__diff__eq,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( ord_less_eq_real @ A @ ( minus_minus_real @ C @ B ) )
      = ( ord_less_eq_real @ ( plus_plus_real @ A @ B ) @ C ) ) )).

% le_diff_eq
thf(fact_257_diff__le__eq,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ ( minus_minus_real @ A @ B ) @ C )
      = ( ord_less_eq_real @ A @ ( plus_plus_real @ C @ B ) ) ) )).

% diff_le_eq
thf(fact_258_square__diff__square__factored,axiom,(
    ! [X: real,Y: real] :
      ( ( minus_minus_real @ ( times_times_real @ X @ X ) @ ( times_times_real @ Y @ Y ) )
      = ( times_times_real @ ( plus_plus_real @ X @ Y ) @ ( minus_minus_real @ X @ Y ) ) ) )).

% square_diff_square_factored
thf(fact_259_eq__add__iff2,axiom,(
    ! [A: real,E: real,C: real,B: real,D: real] :
      ( ( ( plus_plus_real @ ( times_times_real @ A @ E ) @ C )
        = ( plus_plus_real @ ( times_times_real @ B @ E ) @ D ) )
      = ( C
        = ( plus_plus_real @ ( times_times_real @ ( minus_minus_real @ B @ A ) @ E ) @ D ) ) ) )).

% eq_add_iff2
thf(fact_260_eq__add__iff1,axiom,(
    ! [A: real,E: real,C: real,B: real,D: real] :
      ( ( ( plus_plus_real @ ( times_times_real @ A @ E ) @ C )
        = ( plus_plus_real @ ( times_times_real @ B @ E ) @ D ) )
      = ( ( plus_plus_real @ ( times_times_real @ ( minus_minus_real @ A @ B ) @ E ) @ C )
        = D ) ) )).

% eq_add_iff1
thf(fact_261_mult__left__le,axiom,(
    ! [C: real,A: real] :
      ( ( ord_less_eq_real @ C @ one_one_real )
     => ( ( ord_less_eq_real @ zero_zero_real @ A )
       => ( ord_less_eq_real @ ( times_times_real @ A @ C ) @ A ) ) ) )).

% mult_left_le
thf(fact_262_mult__left__le,axiom,(
    ! [C: nat,A: nat] :
      ( ( ord_less_eq_nat @ C @ one_one_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
       => ( ord_less_eq_nat @ ( times_times_nat @ A @ C ) @ A ) ) ) )).

% mult_left_le
thf(fact_263_mult__le__one,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ one_one_real )
     => ( ( ord_less_eq_real @ zero_zero_real @ B )
       => ( ( ord_less_eq_real @ B @ one_one_real )
         => ( ord_less_eq_real @ ( times_times_real @ A @ B ) @ one_one_real ) ) ) ) )).

% mult_le_one
thf(fact_264_mult__le__one,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ one_one_nat )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ( ord_less_eq_nat @ B @ one_one_nat )
         => ( ord_less_eq_nat @ ( times_times_nat @ A @ B ) @ one_one_nat ) ) ) ) )).

% mult_le_one
thf(fact_265_mult__right__le__one__le,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ X )
     => ( ( ord_less_eq_real @ zero_zero_real @ Y )
       => ( ( ord_less_eq_real @ Y @ one_one_real )
         => ( ord_less_eq_real @ ( times_times_real @ X @ Y ) @ X ) ) ) ) )).

% mult_right_le_one_le
thf(fact_266_mult__left__le__one__le,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ X )
     => ( ( ord_less_eq_real @ zero_zero_real @ Y )
       => ( ( ord_less_eq_real @ Y @ one_one_real )
         => ( ord_less_eq_real @ ( times_times_real @ Y @ X ) @ X ) ) ) ) )).

% mult_left_le_one_le
thf(fact_267_sum__squares__le__zero__iff,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ ( times_times_real @ X @ X ) @ ( times_times_real @ Y @ Y ) ) @ zero_zero_real )
      = ( ( X = zero_zero_real )
        & ( Y = zero_zero_real ) ) ) )).

% sum_squares_le_zero_iff
thf(fact_268_sum__squares__ge__zero,axiom,(
    ! [X: real,Y: real] :
      ( ord_less_eq_real @ zero_zero_real @ ( plus_plus_real @ ( times_times_real @ X @ X ) @ ( times_times_real @ Y @ Y ) ) ) )).

% sum_squares_ge_zero
thf(fact_269_ordered__ring__class_Ole__add__iff2,axiom,(
    ! [A: real,E: real,C: real,B: real,D: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ ( times_times_real @ A @ E ) @ C ) @ ( plus_plus_real @ ( times_times_real @ B @ E ) @ D ) )
      = ( ord_less_eq_real @ C @ ( plus_plus_real @ ( times_times_real @ ( minus_minus_real @ B @ A ) @ E ) @ D ) ) ) )).

% ordered_ring_class.le_add_iff2
thf(fact_270_ordered__ring__class_Ole__add__iff1,axiom,(
    ! [A: real,E: real,C: real,B: real,D: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ ( times_times_real @ A @ E ) @ C ) @ ( plus_plus_real @ ( times_times_real @ B @ E ) @ D ) )
      = ( ord_less_eq_real @ ( plus_plus_real @ ( times_times_real @ ( minus_minus_real @ A @ B ) @ E ) @ C ) @ D ) ) )).

% ordered_ring_class.le_add_iff1
thf(fact_271_square__diff__one__factored,axiom,(
    ! [X: real] :
      ( ( minus_minus_real @ ( times_times_real @ X @ X ) @ one_one_real )
      = ( times_times_real @ ( plus_plus_real @ X @ one_one_real ) @ ( minus_minus_real @ X @ one_one_real ) ) ) )).

% square_diff_one_factored
thf(fact_272_convex__bound__le,axiom,(
    ! [X: real,A: real,Y: real,U: real,V: real] :
      ( ( ord_less_eq_real @ X @ A )
     => ( ( ord_less_eq_real @ Y @ A )
       => ( ( ord_less_eq_real @ zero_zero_real @ U )
         => ( ( ord_less_eq_real @ zero_zero_real @ V )
           => ( ( ( plus_plus_real @ U @ V )
                = one_one_real )
             => ( ord_less_eq_real @ ( plus_plus_real @ ( times_times_real @ U @ X ) @ ( times_times_real @ V @ Y ) ) @ A ) ) ) ) ) ) )).

% convex_bound_le
thf(fact_273_lattice__ab__group__add__class_Ozero__le__double__add__iff__zero__le__single__add,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( plus_plus_real @ A @ A ) )
      = ( ord_less_eq_real @ zero_zero_real @ A ) ) )).

% lattice_ab_group_add_class.zero_le_double_add_iff_zero_le_single_add
thf(fact_274_lattice__ab__group__add__class_Odouble__add__le__zero__iff__single__add__le__zero,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ A @ A ) @ zero_zero_real )
      = ( ord_less_eq_real @ A @ zero_zero_real ) ) )).

% lattice_ab_group_add_class.double_add_le_zero_iff_single_add_le_zero
thf(fact_275_segment__bound__lemma,axiom,(
    ! [B3: real,X: real,Y: real,U: real] :
      ( ( ord_less_eq_real @ B3 @ X )
     => ( ( ord_less_eq_real @ B3 @ Y )
       => ( ( ord_less_eq_real @ zero_zero_real @ U )
         => ( ( ord_less_eq_real @ U @ one_one_real )
           => ( ord_less_eq_real @ B3 @ ( plus_plus_real @ ( times_times_real @ ( minus_minus_real @ one_one_real @ U ) @ X ) @ ( times_times_real @ U @ Y ) ) ) ) ) ) ) )).

% segment_bound_lemma
thf(fact_276_linepath__le__1,axiom,(
    ! [A: real,B: real,U: real] :
      ( ( ord_less_eq_real @ A @ one_one_real )
     => ( ( ord_less_eq_real @ B @ one_one_real )
       => ( ( ord_less_eq_real @ zero_zero_real @ U )
         => ( ( ord_less_eq_real @ U @ one_one_real )
           => ( ord_less_eq_real @ ( plus_plus_real @ ( times_times_real @ ( minus_minus_real @ one_one_real @ U ) @ A ) @ ( times_times_real @ U @ B ) ) @ one_one_real ) ) ) ) ) )).

% linepath_le_1
thf(fact_277_plus__times__le__one__lemma,axiom,(
    ! [I: real,U: real] :
      ( ( ord_less_eq_real @ I @ one_one_real )
     => ( ( ord_less_eq_real @ U @ one_one_real )
       => ( ord_less_eq_real @ ( minus_minus_real @ ( plus_plus_real @ I @ U ) @ ( times_times_real @ I @ U ) ) @ one_one_real ) ) ) )).

% plus_times_le_one_lemma
thf(fact_278_vector__space__over__itself_Oscale__one,axiom,(
    ! [X: real] :
      ( ( times_times_real @ one_one_real @ X )
      = X ) )).

% vector_space_over_itself.scale_one
thf(fact_279_lattice__ab__group__add__class_Odouble__zero,axiom,(
    ! [A: real] :
      ( ( ( plus_plus_real @ A @ A )
        = zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% lattice_ab_group_add_class.double_zero
thf(fact_280_vector__space__over__itself_Oscale__cancel__right,axiom,(
    ! [A: real,X: real,B: real] :
      ( ( ( times_times_real @ A @ X )
        = ( times_times_real @ B @ X ) )
      = ( ( A = B )
        | ( X = zero_zero_real ) ) ) )).

% vector_space_over_itself.scale_cancel_right
thf(fact_281_vector__space__over__itself_Oscale__cancel__left,axiom,(
    ! [A: real,X: real,Y: real] :
      ( ( ( times_times_real @ A @ X )
        = ( times_times_real @ A @ Y ) )
      = ( ( X = Y )
        | ( A = zero_zero_real ) ) ) )).

% vector_space_over_itself.scale_cancel_left
thf(fact_282_vector__space__over__itself_Oscale__zero__right,axiom,(
    ! [A: real] :
      ( ( times_times_real @ A @ zero_zero_real )
      = zero_zero_real ) )).

% vector_space_over_itself.scale_zero_right
thf(fact_283_vector__space__over__itself_Oscale__zero__left,axiom,(
    ! [X: real] :
      ( ( times_times_real @ zero_zero_real @ X )
      = zero_zero_real ) )).

% vector_space_over_itself.scale_zero_left
thf(fact_284_vector__space__over__itself_Oscale__eq__0__iff,axiom,(
    ! [A: real,X: real] :
      ( ( ( times_times_real @ A @ X )
        = zero_zero_real )
      = ( ( A = zero_zero_real )
        | ( X = zero_zero_real ) ) ) )).

% vector_space_over_itself.scale_eq_0_iff
thf(fact_285_vector__space__over__itself_Oscale__scale,axiom,(
    ! [A: real,B: real,X: real] :
      ( ( times_times_real @ A @ ( times_times_real @ B @ X ) )
      = ( times_times_real @ ( times_times_real @ A @ B ) @ X ) ) )).

% vector_space_over_itself.scale_scale
thf(fact_286_vector__space__over__itself_Oscale__left__commute,axiom,(
    ! [A: real,B: real,X: real] :
      ( ( times_times_real @ A @ ( times_times_real @ B @ X ) )
      = ( times_times_real @ B @ ( times_times_real @ A @ X ) ) ) )).

% vector_space_over_itself.scale_left_commute
thf(fact_287_vector__space__over__itself_Oscale__left__imp__eq,axiom,(
    ! [A: real,X: real,Y: real] :
      ( ( A != zero_zero_real )
     => ( ( ( times_times_real @ A @ X )
          = ( times_times_real @ A @ Y ) )
       => ( X = Y ) ) ) )).

% vector_space_over_itself.scale_left_imp_eq
thf(fact_288_vector__space__over__itself_Oscale__right__imp__eq,axiom,(
    ! [X: real,A: real,B: real] :
      ( ( X != zero_zero_real )
     => ( ( ( times_times_real @ A @ X )
          = ( times_times_real @ B @ X ) )
       => ( A = B ) ) ) )).

% vector_space_over_itself.scale_right_imp_eq
thf(fact_289_vector__space__over__itself_Oscale__left__distrib,axiom,(
    ! [A: real,B: real,X: real] :
      ( ( times_times_real @ ( plus_plus_real @ A @ B ) @ X )
      = ( plus_plus_real @ ( times_times_real @ A @ X ) @ ( times_times_real @ B @ X ) ) ) )).

% vector_space_over_itself.scale_left_distrib
thf(fact_290_vector__space__over__itself_Oscale__right__distrib,axiom,(
    ! [A: real,X: real,Y: real] :
      ( ( times_times_real @ A @ ( plus_plus_real @ X @ Y ) )
      = ( plus_plus_real @ ( times_times_real @ A @ X ) @ ( times_times_real @ A @ Y ) ) ) )).

% vector_space_over_itself.scale_right_distrib
thf(fact_291_vector__space__over__itself_Oscale__left__diff__distrib,axiom,(
    ! [A: real,B: real,X: real] :
      ( ( times_times_real @ ( minus_minus_real @ A @ B ) @ X )
      = ( minus_minus_real @ ( times_times_real @ A @ X ) @ ( times_times_real @ B @ X ) ) ) )).

% vector_space_over_itself.scale_left_diff_distrib
thf(fact_292_vector__space__over__itself_Oscale__right__diff__distrib,axiom,(
    ! [A: real,X: real,Y: real] :
      ( ( times_times_real @ A @ ( minus_minus_real @ X @ Y ) )
      = ( minus_minus_real @ ( times_times_real @ A @ X ) @ ( times_times_real @ A @ Y ) ) ) )).

% vector_space_over_itself.scale_right_diff_distrib
thf(fact_293_affine__ineq,axiom,(
    ! [X: real,V: real,U: real] :
      ( ( ord_less_eq_real @ X @ one_one_real )
     => ( ( ord_less_eq_real @ V @ U )
       => ( ord_less_eq_real @ ( plus_plus_real @ V @ ( times_times_real @ X @ U ) ) @ ( plus_plus_real @ U @ ( times_times_real @ X @ V ) ) ) ) ) )).

% affine_ineq
thf(fact_294_sum__le__prod1,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ one_one_real )
     => ( ( ord_less_eq_real @ B @ one_one_real )
       => ( ord_less_eq_real @ ( plus_plus_real @ A @ B ) @ ( plus_plus_real @ one_one_real @ ( times_times_real @ A @ B ) ) ) ) ) )).

% sum_le_prod1
thf(fact_295_mult__eq__1,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ A @ one_one_real )
       => ( ( ord_less_eq_real @ B @ one_one_real )
         => ( ( ( times_times_real @ A @ B )
              = one_one_real )
            = ( ( A = one_one_real )
              & ( B = one_one_real ) ) ) ) ) ) )).

% mult_eq_1
thf(fact_296_mult__eq__1,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ A @ one_one_nat )
       => ( ( ord_less_eq_nat @ B @ one_one_nat )
         => ( ( ( times_times_nat @ A @ B )
              = one_one_nat )
            = ( ( A = one_one_nat )
              & ( B = one_one_nat ) ) ) ) ) ) )).

% mult_eq_1
thf(fact_297_mult__mono__nonpos__nonpos,axiom,(
    ! [C: real,A: real,D: real,B: real] :
      ( ( ord_less_eq_real @ C @ A )
     => ( ( ord_less_eq_real @ A @ zero_zero_real )
       => ( ( ord_less_eq_real @ D @ B )
         => ( ( ord_less_eq_real @ D @ zero_zero_real )
           => ( ord_less_eq_real @ ( times_times_real @ A @ B ) @ ( times_times_real @ C @ D ) ) ) ) ) ) )).

% mult_mono_nonpos_nonpos
thf(fact_298_mult__mono__nonpos__nonneg,axiom,(
    ! [A: real,C: real,D: real,B: real] :
      ( ( ord_less_eq_real @ A @ C )
     => ( ( ord_less_eq_real @ A @ zero_zero_real )
       => ( ( ord_less_eq_real @ zero_zero_real @ D )
         => ( ( ord_less_eq_real @ D @ B )
           => ( ord_less_eq_real @ ( times_times_real @ A @ B ) @ ( times_times_real @ C @ D ) ) ) ) ) ) )).

% mult_mono_nonpos_nonneg
thf(fact_299_mult__mono__nonneg__nonpos,axiom,(
    ! [A: real,C: real,D: real,B: real] :
      ( ( ord_less_eq_real @ A @ C )
     => ( ( ord_less_eq_real @ C @ zero_zero_real )
       => ( ( ord_less_eq_real @ zero_zero_real @ D )
         => ( ( ord_less_eq_real @ D @ B )
           => ( ord_less_eq_real @ ( times_times_real @ B @ A ) @ ( times_times_real @ D @ C ) ) ) ) ) ) )).

% mult_mono_nonneg_nonpos
thf(fact_300_kuhn__labelling__lemma_H,axiom,(
    ! [P: ( nat > real ) > $o,F: ( nat > real ) > nat > real,Q: nat > $o] :
      ( ! [X3: nat > real] :
          ( ( P @ X3 )
         => ( P @ ( F @ X3 ) ) )
     => ( ! [X3: nat > real] :
            ( ( P @ X3 )
           => ! [I2: nat] :
                ( ( Q @ I2 )
               => ( ( ord_less_eq_real @ zero_zero_real @ ( X3 @ I2 ) )
                  & ( ord_less_eq_real @ ( X3 @ I2 ) @ one_one_real ) ) ) )
       => ? [L2: ( nat > real ) > nat > nat] :
            ( ! [X4: nat > real,I3: nat] :
                ( ord_less_eq_nat @ ( L2 @ X4 @ I3 ) @ one_one_nat )
            & ! [X4: nat > real,I3: nat] :
                ( ( ( P @ X4 )
                  & ( Q @ I3 )
                  & ( ( X4 @ I3 )
                    = zero_zero_real ) )
               => ( ( L2 @ X4 @ I3 )
                  = zero_zero_nat ) )
            & ! [X4: nat > real,I3: nat] :
                ( ( ( P @ X4 )
                  & ( Q @ I3 )
                  & ( ( X4 @ I3 )
                    = one_one_real ) )
               => ( ( L2 @ X4 @ I3 )
                  = one_one_nat ) )
            & ! [X4: nat > real,I3: nat] :
                ( ( ( P @ X4 )
                  & ( Q @ I3 )
                  & ( ( L2 @ X4 @ I3 )
                    = zero_zero_nat ) )
               => ( ord_less_eq_real @ ( X4 @ I3 ) @ ( F @ X4 @ I3 ) ) )
            & ! [X4: nat > real,I3: nat] :
                ( ( ( P @ X4 )
                  & ( Q @ I3 )
                  & ( ( L2 @ X4 @ I3 )
                    = one_one_nat ) )
               => ( ord_less_eq_real @ ( F @ X4 @ I3 ) @ ( X4 @ I3 ) ) ) ) ) ) )).

% kuhn_labelling_lemma'
thf(fact_301_mult__diff__mult,axiom,(
    ! [X: real,Y: real,A: real,B: real] :
      ( ( minus_minus_real @ ( times_times_real @ X @ Y ) @ ( times_times_real @ A @ B ) )
      = ( plus_plus_real @ ( times_times_real @ X @ ( minus_minus_real @ Y @ B ) ) @ ( times_times_real @ ( minus_minus_real @ X @ A ) @ B ) ) ) )).

% mult_diff_mult
thf(fact_302_complete__real,axiom,(
    ! [S: set_real] :
      ( ? [X4: real] :
          ( member_real @ X4 @ S )
     => ( ? [Z2: real] :
          ! [X3: real] :
            ( ( member_real @ X3 @ S )
           => ( ord_less_eq_real @ X3 @ Z2 ) )
       => ? [Y3: real] :
            ( ! [X4: real] :
                ( ( member_real @ X4 @ S )
               => ( ord_less_eq_real @ X4 @ Y3 ) )
            & ! [Z2: real] :
                ( ! [X3: real] :
                    ( ( member_real @ X3 @ S )
                   => ( ord_less_eq_real @ X3 @ Z2 ) )
               => ( ord_less_eq_real @ Y3 @ Z2 ) ) ) ) ) )).

% complete_real
thf(fact_303_add__diff__add,axiom,(
    ! [A: real,C: real,B: real,D: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ C ) @ ( plus_plus_real @ B @ D ) )
      = ( plus_plus_real @ ( minus_minus_real @ A @ B ) @ ( minus_minus_real @ C @ D ) ) ) )).

% add_diff_add
thf(fact_304_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_305_diff__is__0__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% diff_is_0_eq
thf(fact_306_mult__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( times_times_nat @ M @ K )
        = ( times_times_nat @ N @ K ) )
      = ( ( M = N )
        | ( K = zero_zero_nat ) ) ) )).

% mult_cancel2
thf(fact_307_mult__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times_nat @ K @ M )
        = ( times_times_nat @ K @ N ) )
      = ( ( M = N )
        | ( K = zero_zero_nat ) ) ) )).

% mult_cancel1
thf(fact_308_mult__0__right,axiom,(
    ! [M: nat] :
      ( ( times_times_nat @ M @ zero_zero_nat )
      = zero_zero_nat ) )).

% mult_0_right
thf(fact_309_Nat_Oadd__0__right,axiom,(
    ! [M: nat] :
      ( ( plus_plus_nat @ M @ zero_zero_nat )
      = M ) )).

% Nat.add_0_right
thf(fact_310_mult__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times_nat @ M @ N )
        = zero_zero_nat )
      = ( ( M = zero_zero_nat )
        | ( N = zero_zero_nat ) ) ) )).

% mult_is_0
thf(fact_311_add__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus_nat @ M @ N )
        = zero_zero_nat )
      = ( ( M = zero_zero_nat )
        & ( N = zero_zero_nat ) ) ) )).

% add_is_0
thf(fact_312_nat__add__left__cancel__le,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% nat_add_left_cancel_le
thf(fact_313_nat__mult__eq__1__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times_nat @ M @ N )
        = one_one_nat )
      = ( ( M = one_one_nat )
        & ( N = one_one_nat ) ) ) )).

% nat_mult_eq_1_iff
thf(fact_314_nat__1__eq__mult__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( one_one_nat
        = ( times_times_nat @ M @ N ) )
      = ( ( M = one_one_nat )
        & ( N = one_one_nat ) ) ) )).

% nat_1_eq_mult_iff
thf(fact_315_diff__diff__left,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I @ J ) @ K )
      = ( minus_minus_nat @ I @ ( plus_plus_nat @ J @ K ) ) ) )).

% diff_diff_left
thf(fact_316_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_317_diff__self__eq__0,axiom,(
    ! [M: nat] :
      ( ( minus_minus_nat @ M @ M )
      = zero_zero_nat ) )).

% diff_self_eq_0
thf(fact_318_diff__0__eq__0,axiom,(
    ! [N: nat] :
      ( ( minus_minus_nat @ zero_zero_nat @ N )
      = zero_zero_nat ) )).

% diff_0_eq_0
thf(fact_319_diff__diff__cancel,axiom,(
    ! [I: nat,N: nat] :
      ( ( ord_less_eq_nat @ I @ N )
     => ( ( minus_minus_nat @ N @ ( minus_minus_nat @ N @ I ) )
        = I ) ) )).

% diff_diff_cancel
thf(fact_320_Nat_Odiff__diff__right,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( minus_minus_nat @ I @ ( minus_minus_nat @ J @ K ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ I @ K ) @ J ) ) ) )).

% Nat.diff_diff_right
thf(fact_321_Nat_Oadd__diff__assoc2,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( plus_plus_nat @ ( minus_minus_nat @ J @ K ) @ I )
        = ( minus_minus_nat @ ( plus_plus_nat @ J @ I ) @ K ) ) ) )).

% Nat.add_diff_assoc2
thf(fact_322_Nat_Oadd__diff__assoc,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( plus_plus_nat @ I @ ( minus_minus_nat @ J @ K ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ I @ J ) @ K ) ) ) )).

% Nat.add_diff_assoc
thf(fact_323_diff__is__0__eq_H,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat ) ) )).

% diff_is_0_eq'
thf(fact_324_diff__mult__distrib2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times_nat @ K @ ( minus_minus_nat @ M @ N ) )
      = ( minus_minus_nat @ ( times_times_nat @ K @ M ) @ ( times_times_nat @ K @ N ) ) ) )).

% diff_mult_distrib2
thf(fact_325_diff__mult__distrib,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times_nat @ ( minus_minus_nat @ M @ N ) @ K )
      = ( minus_minus_nat @ ( times_times_nat @ M @ K ) @ ( times_times_nat @ N @ K ) ) ) )).

% diff_mult_distrib
thf(fact_326_diff__add__inverse2,axiom,(
    ! [M: nat,N: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ M @ N ) @ N )
      = M ) )).

% diff_add_inverse2
thf(fact_327_diff__add__inverse,axiom,(
    ! [N: nat,M: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ N @ M ) @ N )
      = M ) )).

% diff_add_inverse
thf(fact_328_diff__commute,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I @ J ) @ K )
      = ( minus_minus_nat @ ( minus_minus_nat @ I @ K ) @ J ) ) )).

% diff_commute
thf(fact_329_diff__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ M @ K ) @ ( plus_plus_nat @ N @ K ) )
      = ( minus_minus_nat @ M @ N ) ) )).

% diff_cancel2
thf(fact_330_Nat_Odiff__cancel,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( minus_minus_nat @ M @ N ) ) )).

% Nat.diff_cancel
thf(fact_331_mult__0,axiom,(
    ! [N: nat] :
      ( ( times_times_nat @ zero_zero_nat @ N )
      = zero_zero_nat ) )).

% mult_0
thf(fact_332_minus__nat_Odiff__0,axiom,(
    ! [M: nat] :
      ( ( minus_minus_nat @ M @ zero_zero_nat )
      = M ) )).

% minus_nat.diff_0
thf(fact_333_diffs0__imp__equal,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat )
     => ( ( ( minus_minus_nat @ N @ M )
          = zero_zero_nat )
       => ( M = N ) ) ) )).

% diffs0_imp_equal
thf(fact_334_add__eq__self__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus_nat @ M @ N )
        = M )
     => ( N = zero_zero_nat ) ) )).

% add_eq_self_zero
thf(fact_335_plus__nat_Oadd__0,axiom,(
    ! [N: nat] :
      ( ( plus_plus_nat @ zero_zero_nat @ N )
      = N ) )).

% plus_nat.add_0
thf(fact_336_diff__add__0,axiom,(
    ! [N: nat,M: nat] :
      ( ( minus_minus_nat @ N @ ( plus_plus_nat @ N @ M ) )
      = zero_zero_nat ) )).

% diff_add_0
thf(fact_337_Nat_Oex__has__greatest__nat,axiom,(
    ! [P: nat > $o,K: nat,B: nat] :
      ( ( P @ K )
     => ( ! [Y3: nat] :
            ( ( P @ Y3 )
           => ( ord_less_eq_nat @ Y3 @ B ) )
       => ? [X3: nat] :
            ( ( P @ X3 )
            & ! [Y4: nat] :
                ( ( P @ Y4 )
               => ( ord_less_eq_nat @ Y4 @ X3 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_338_Nat_Ole__imp__diff__is__add,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ( minus_minus_nat @ J @ I )
          = K )
        = ( J
          = ( plus_plus_nat @ K @ I ) ) ) ) )).

% Nat.le_imp_diff_is_add
thf(fact_339_Nat_Odiff__add__assoc2,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( minus_minus_nat @ ( plus_plus_nat @ J @ I ) @ K )
        = ( plus_plus_nat @ ( minus_minus_nat @ J @ K ) @ I ) ) ) )).

% Nat.diff_add_assoc2
thf(fact_340_nat__le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [M2: nat,N2: nat] :
        ? [K2: nat] :
          ( N2
          = ( plus_plus_nat @ M2 @ K2 ) ) ) )).

% nat_le_iff_add
thf(fact_341_Nat_Odiff__add__assoc,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( minus_minus_nat @ ( plus_plus_nat @ I @ J ) @ K )
        = ( plus_plus_nat @ I @ ( minus_minus_nat @ J @ K ) ) ) ) )).

% Nat.diff_add_assoc
thf(fact_342_trans__le__add2,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ I @ ( plus_plus_nat @ M @ J ) ) ) )).

% trans_le_add2
thf(fact_343_trans__le__add1,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ I @ ( plus_plus_nat @ J @ M ) ) ) )).

% trans_le_add1
thf(fact_344_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_345_mult__le__mono2,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ K @ I ) @ ( times_times_nat @ K @ J ) ) ) )).

% mult_le_mono2
thf(fact_346_mult__le__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( times_times_nat @ I @ K ) @ ( times_times_nat @ J @ K ) ) ) )).

% mult_le_mono1
thf(fact_347_Nat_Ole__diff__conv2,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ K ) )
        = ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ J ) ) ) )).

% Nat.le_diff_conv2
thf(fact_348_diff__le__mono2,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ L @ N ) @ ( minus_minus_nat @ L @ M ) ) ) )).

% diff_le_mono2
thf(fact_349_mult__le__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( times_times_nat @ I @ K ) @ ( times_times_nat @ J @ L ) ) ) ) )).

% mult_le_mono
thf(fact_350_le__diff__iff_H,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ C )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ C @ A ) @ ( minus_minus_nat @ C @ B ) )
          = ( ord_less_eq_nat @ B @ A ) ) ) ) )).

% le_diff_iff'

% Conjectures (3)
thf(conj_0,hypothesis,(
    ord_less_eq_real @ zero_zero_real @ xa )).

thf(conj_1,hypothesis,(
    ord_less_eq_real @ xa @ one_one_real )).

thf(conj_2,conjecture,(
    ord_less_eq_real @ ( plus_plus_real @ ( times_times_real @ ( minus_minus_real @ one_one_real @ xa ) @ t ) @ ( times_times_real @ xa @ t2 ) ) @ t2 )).

%------------------------------------------------------------------------------
