%------------------------------------------------------------------------------
% File     : SLH651^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer GenClock problem prob_491__3247452_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : GenClock/prob_491__3247452_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  388 (   0 unit;  31 type;   0 defn)
%            Number of atoms       : 3661 ( 273 equality;2268 variable)
%            Maximal formula depth :   21 (   8 average)
%            Number of connectives : 2866 ( 108   ~;  22   |;  36   &;2213   @)
%                                         (   0 <=>; 487  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  124 ( 124   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   35 (  31   :;   0   =)
%            Number of variables   : 1015 (   0 sgn; 915   !;  15   ?;  85   ^)
%                                         (1015   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:30:33.109
%------------------------------------------------------------------------------
% Could-be-implicit typings (3)
thf(ty_n_t__Set__Oset_It__Real__Oreal_J,type,(
    set_real: $tType )).

thf(ty_n_t__Real__Oreal,type,(
    real: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (28)
thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_OIC,type,(
    genClo1160817912lle_IC: nat > nat > real > real )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_OVC,type,(
    genClo1161670699lle_VC: nat > real > real )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_O_092_060beta_062,type,(
    genClo1278781456e_beta: real )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_O_092_060delta_062,type,(
    genClo332484818_delta: real )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_Ocorrect,type,(
    genClo1015804716orrect: nat > real > $o )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_OokClocks,type,(
    genClo1297122271Clocks: nat > nat > nat > $o )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_OokRead1,type,(
    genClo293725281kRead1: ( nat > real ) > real > ( nat > $o ) > $o )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_OokRead2,type,(
    genClo293725282kRead2: ( nat > real ) > ( nat > real ) > real > ( nat > $o ) > $o )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_Ookmaxsync,type,(
    genClo208577157axsync: nat > real > $o )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_Ote,type,(
    genClo1163638703lle_te: nat > nat > real )).

thf(sy_c_Groups_Oabs__class_Oabs_001t__Real__Oreal,type,(
    abs_abs_real: real > real )).

thf(sy_c_Groups_Ominus__class_Ominus_001t__Nat__Onat,type,(
    minus_minus_nat: nat > nat > nat )).

thf(sy_c_Groups_Ominus__class_Ominus_001t__Real__Oreal,type,(
    minus_minus_real: real > real > real )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Real__Oreal,type,(
    zero_zero_real: real )).

thf(sy_c_If_001t__Nat__Onat,type,(
    if_nat: $o > nat > nat > nat )).

thf(sy_c_If_001t__Real__Oreal,type,(
    if_real: $o > real > real > real )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Real__Oreal,type,(
    ord_less_real: real > real > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Real__Oreal,type,(
    ord_less_eq_real: real > real > $o )).

thf(sy_c_Orderings_Oord__class_Omax_001t__Nat__Onat,type,(
    ord_max_nat: nat > nat > nat )).

thf(sy_c_Orderings_Oord__class_Omax_001t__Real__Oreal,type,(
    ord_max_real: real > real > real )).

thf(sy_c_Set_OCollect_001t__Real__Oreal,type,(
    collect_real: ( real > $o ) > set_real )).

thf(sy_c_member_001t__Real__Oreal,type,(
    member_real: real > set_real > $o )).

thf(sy_v_i,type,(
    i: nat )).

thf(sy_v_p,type,(
    p: nat )).

thf(sy_v_q,type,(
    q: nat )).

% Relevant facts (351)
thf(fact_0_ok__pq,axiom,(
    genClo1297122271Clocks @ p @ q @ i )).

% ok_pq
thf(fact_1__092_060open_062_092_060And_062t_O_A_092_060lbrakk_0620_A_092_060le_062_At_059_At_A_060_Amax_A_Ite_Aq_Ai_J_A_Ite_Ap_Ai_J_059_Acorrect_Aq_At_059_Acorrect_Ap_At_092_060rbrakk_062_A_092_060Longrightarrow_062_A_092_060bar_062VC_Aq_At_A_N_AVC_Ap_At_092_060bar_062_A_092_060le_062_A_092_060delta_062_092_060close_062,axiom,(
    ! [T: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ T )
     => ( ( ord_less_real @ T @ ( ord_max_real @ ( genClo1163638703lle_te @ q @ i ) @ ( genClo1163638703lle_te @ p @ i ) ) )
       => ( ( genClo1015804716orrect @ q @ T )
         => ( ( genClo1015804716orrect @ p @ T )
           => ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ ( genClo1161670699lle_VC @ q @ T ) @ ( genClo1161670699lle_VC @ p @ T ) ) ) @ genClo332484818_delta ) ) ) ) ) )).

% \<open>\<And>t. \<lbrakk>0 \<le> t; t < max (te q i) (te p i); correct q t; correct p t\<rbrakk> \<Longrightarrow> \<bar>VC q t - VC p t\<bar> \<le> \<delta>\<close>
thf(fact_2_okClocks__def,axiom,
    ( genClo1297122271Clocks
    = ( ^ [P: nat,Q: nat,I: nat] :
        ! [T2: real] :
          ( ( ( ord_less_eq_real @ zero_zero_real @ T2 )
            & ( ord_less_real @ T2 @ ( ord_max_real @ ( genClo1163638703lle_te @ P @ I ) @ ( genClo1163638703lle_te @ Q @ I ) ) )
            & ( genClo1015804716orrect @ P @ T2 )
            & ( genClo1015804716orrect @ Q @ T2 ) )
         => ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ ( genClo1161670699lle_VC @ P @ T2 ) @ ( genClo1161670699lle_VC @ Q @ T2 ) ) ) @ genClo332484818_delta ) ) ) )).

% okClocks_def
thf(fact_3_correct__closed,axiom,(
    ! [P2: nat,S: real,T3: real] :
      ( ( ( ord_less_eq_real @ S @ T3 )
        & ( genClo1015804716orrect @ P2 @ T3 ) )
     => ( genClo1015804716orrect @ P2 @ S ) ) )).

% correct_closed
thf(fact_4_event__bound,axiom,(
    ! [T: real,P3: nat,Q2: nat] :
      ( ( ord_less_eq_real @ zero_zero_real @ T )
     => ( ( genClo1015804716orrect @ P3 @ T )
       => ( ( genClo1015804716orrect @ Q2 @ T )
         => ? [I2: nat] :
              ( ord_less_real @ T @ ( ord_max_real @ ( genClo1163638703lle_te @ P3 @ I2 ) @ ( genClo1163638703lle_te @ Q2 @ I2 ) ) ) ) ) ) )).

% event_bound
thf(fact_5_zero__less__abs__iff,axiom,(
    ! [A: real] :
      ( ( ord_less_real @ zero_zero_real @ ( abs_abs_real @ A ) )
      = ( A != zero_zero_real ) ) )).

% zero_less_abs_iff
thf(fact_6_abs__of__nonneg,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( abs_abs_real @ A )
        = A ) ) )).

% abs_of_nonneg
thf(fact_7_abs__le__self__iff,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ ( abs_abs_real @ A ) @ A )
      = ( ord_less_eq_real @ zero_zero_real @ A ) ) )).

% abs_le_self_iff
thf(fact_8_abs__le__zero__iff,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ ( abs_abs_real @ A ) @ zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% abs_le_zero_iff
thf(fact_9_diff__gt__0__iff__gt,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ zero_zero_real @ ( minus_minus_real @ A @ B ) )
      = ( ord_less_real @ B @ A ) ) )).

% diff_gt_0_iff_gt
thf(fact_10_diff__ge__0__iff__ge,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( minus_minus_real @ A @ B ) )
      = ( ord_less_eq_real @ B @ A ) ) )).

% diff_ge_0_iff_ge
thf(fact_11_lemma__interval,axiom,(
    ! [A: real,X: real,B: real] :
      ( ( ord_less_real @ A @ X )
     => ( ( ord_less_real @ X @ B )
       => ? [D: real] :
            ( ( ord_less_real @ zero_zero_real @ D )
            & ! [Y: real] :
                ( ( ord_less_real @ ( abs_abs_real @ ( minus_minus_real @ X @ Y ) ) @ D )
               => ( ( ord_less_eq_real @ A @ Y )
                  & ( ord_less_eq_real @ Y @ B ) ) ) ) ) ) )).

% lemma_interval
thf(fact_12_max__less__iff__conj,axiom,(
    ! [X: real,Y2: real,Z: real] :
      ( ( ord_less_real @ ( ord_max_real @ X @ Y2 ) @ Z )
      = ( ( ord_less_real @ X @ Z )
        & ( ord_less_real @ Y2 @ Z ) ) ) )).

% max_less_iff_conj
thf(fact_13_max__less__iff__conj,axiom,(
    ! [X: nat,Y2: nat,Z: nat] :
      ( ( ord_less_nat @ ( ord_max_nat @ X @ Y2 ) @ Z )
      = ( ( ord_less_nat @ X @ Z )
        & ( ord_less_nat @ Y2 @ Z ) ) ) )).

% max_less_iff_conj
thf(fact_14_max_Obounded__iff,axiom,(
    ! [B: real,C: real,A: real] :
      ( ( ord_less_eq_real @ ( ord_max_real @ B @ C ) @ A )
      = ( ( ord_less_eq_real @ B @ A )
        & ( ord_less_eq_real @ C @ A ) ) ) )).

% max.bounded_iff
thf(fact_15_max_Obounded__iff,axiom,(
    ! [B: nat,C: nat,A: nat] :
      ( ( ord_less_eq_nat @ ( ord_max_nat @ B @ C ) @ A )
      = ( ( ord_less_eq_nat @ B @ A )
        & ( ord_less_eq_nat @ C @ A ) ) ) )).

% max.bounded_iff
thf(fact_16_abs__0,axiom,
    ( ( abs_abs_real @ zero_zero_real )
    = zero_zero_real )).

% abs_0
thf(fact_17_abs__0__eq,axiom,(
    ! [A: real] :
      ( ( zero_zero_real
        = ( abs_abs_real @ A ) )
      = ( A = zero_zero_real ) ) )).

% abs_0_eq
thf(fact_18_abs__eq__0,axiom,(
    ! [A: real] :
      ( ( ( abs_abs_real @ A )
        = zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% abs_eq_0
thf(fact_19_abs__idempotent,axiom,(
    ! [A: real] :
      ( ( abs_abs_real @ ( abs_abs_real @ A ) )
      = ( abs_abs_real @ A ) ) )).

% abs_idempotent
thf(fact_20_abs__abs,axiom,(
    ! [A: real] :
      ( ( abs_abs_real @ ( abs_abs_real @ A ) )
      = ( abs_abs_real @ A ) ) )).

% abs_abs
thf(fact_21_max_Oright__idem,axiom,(
    ! [A: real,B: real] :
      ( ( ord_max_real @ ( ord_max_real @ A @ B ) @ B )
      = ( ord_max_real @ A @ B ) ) )).

% max.right_idem
thf(fact_22_max_Oright__idem,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_max_nat @ ( ord_max_nat @ A @ B ) @ B )
      = ( ord_max_nat @ A @ B ) ) )).

% max.right_idem
thf(fact_23_max_Oleft__idem,axiom,(
    ! [A: real,B: real] :
      ( ( ord_max_real @ A @ ( ord_max_real @ A @ B ) )
      = ( ord_max_real @ A @ B ) ) )).

% max.left_idem
thf(fact_24_max_Oleft__idem,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_max_nat @ A @ ( ord_max_nat @ A @ B ) )
      = ( ord_max_nat @ A @ B ) ) )).

% max.left_idem
thf(fact_25_max_Oidem,axiom,(
    ! [A: real] :
      ( ( ord_max_real @ A @ A )
      = A ) )).

% max.idem
thf(fact_26_max_Oidem,axiom,(
    ! [A: nat] :
      ( ( ord_max_nat @ A @ A )
      = A ) )).

% max.idem
thf(fact_27_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_28_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_29_cancel__comm__monoid__add__class_Odiff__cancel,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ A )
      = zero_zero_real ) )).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_30_cancel__comm__monoid__add__class_Odiff__cancel,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ A @ A )
      = zero_zero_nat ) )).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_31_diff__zero,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ zero_zero_real )
      = A ) )).

% diff_zero
thf(fact_32_diff__zero,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ A @ zero_zero_nat )
      = A ) )).

% diff_zero
thf(fact_33_zero__diff,axiom,(
    ! [A: nat] :
      ( ( minus_minus_nat @ zero_zero_nat @ A )
      = zero_zero_nat ) )).

% zero_diff
thf(fact_34_diff__0__right,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ zero_zero_real )
      = A ) )).

% diff_0_right
thf(fact_35_diff__self,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ A )
      = zero_zero_real ) )).

% diff_self
thf(fact_36_abs__zero,axiom,
    ( ( abs_abs_real @ zero_zero_real )
    = zero_zero_real )).

% abs_zero
thf(fact_37_synch0,axiom,(
    ! [P2: nat] :
      ( ( genClo1163638703lle_te @ P2 @ zero_zero_nat )
      = zero_zero_real ) )).

% synch0
thf(fact_38_zero__reorient,axiom,(
    ! [X: real] :
      ( ( zero_zero_real = X )
      = ( X = zero_zero_real ) ) )).

% zero_reorient
thf(fact_39_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_40_linorder__neqE__linordered__idom,axiom,(
    ! [X: real,Y2: real] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_real @ X @ Y2 )
       => ( ord_less_real @ Y2 @ X ) ) ) )).

% linorder_neqE_linordered_idom
thf(fact_41_diff__right__commute,axiom,(
    ! [A: real,C: real,B: real] :
      ( ( minus_minus_real @ ( minus_minus_real @ A @ C ) @ B )
      = ( minus_minus_real @ ( minus_minus_real @ A @ B ) @ C ) ) )).

% diff_right_commute
thf(fact_42_diff__right__commute,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ C ) @ B )
      = ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C ) ) )).

% diff_right_commute
thf(fact_43_diff__eq__diff__eq,axiom,(
    ! [A: real,B: real,C: real,D2: real] :
      ( ( ( minus_minus_real @ A @ B )
        = ( minus_minus_real @ C @ D2 ) )
     => ( ( A = B )
        = ( C = D2 ) ) ) )).

% diff_eq_diff_eq
thf(fact_44_max_Oleft__commute,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_max_real @ B @ ( ord_max_real @ A @ C ) )
      = ( ord_max_real @ A @ ( ord_max_real @ B @ C ) ) ) )).

% max.left_commute
thf(fact_45_max_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_max_nat @ B @ ( ord_max_nat @ A @ C ) )
      = ( ord_max_nat @ A @ ( ord_max_nat @ B @ C ) ) ) )).

% max.left_commute
thf(fact_46_max_Ocommute,axiom,
    ( ord_max_real
    = ( ^ [A2: real,B2: real] :
          ( ord_max_real @ B2 @ A2 ) ) )).

% max.commute
thf(fact_47_max_Ocommute,axiom,
    ( ord_max_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ord_max_nat @ B2 @ A2 ) ) )).

% max.commute
thf(fact_48_max_Oassoc,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_max_real @ ( ord_max_real @ A @ B ) @ C )
      = ( ord_max_real @ A @ ( ord_max_real @ B @ C ) ) ) )).

% max.assoc
thf(fact_49_max_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_max_nat @ ( ord_max_nat @ A @ B ) @ C )
      = ( ord_max_nat @ A @ ( ord_max_nat @ B @ C ) ) ) )).

% max.assoc
thf(fact_50_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_51_zero__less__iff__neq__zero,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ N )
      = ( N != zero_zero_nat ) ) )).

% zero_less_iff_neq_zero
thf(fact_52_gr__implies__not__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( N != zero_zero_nat ) ) )).

% gr_implies_not_zero
thf(fact_53_not__less__zero,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% not_less_zero
thf(fact_54_mem__Collect__eq,axiom,(
    ! [A: real,P4: real > $o] :
      ( ( member_real @ A @ ( collect_real @ P4 ) )
      = ( P4 @ A ) ) )).

% mem_Collect_eq
thf(fact_55_Collect__mem__eq,axiom,(
    ! [A3: set_real] :
      ( ( collect_real
        @ ^ [X2: real] :
            ( member_real @ X2 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_56_gr__zeroI,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% gr_zeroI
thf(fact_57_diff__eq__diff__less__eq,axiom,(
    ! [A: real,B: real,C: real,D2: real] :
      ( ( ( minus_minus_real @ A @ B )
        = ( minus_minus_real @ C @ D2 ) )
     => ( ( ord_less_eq_real @ A @ B )
        = ( ord_less_eq_real @ C @ D2 ) ) ) )).

% diff_eq_diff_less_eq
thf(fact_58_diff__right__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ord_less_eq_real @ ( minus_minus_real @ A @ C ) @ ( minus_minus_real @ B @ C ) ) ) )).

% diff_right_mono
thf(fact_59_diff__left__mono,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ord_less_eq_real @ ( minus_minus_real @ C @ A ) @ ( minus_minus_real @ C @ B ) ) ) )).

% diff_left_mono
thf(fact_60_diff__mono,axiom,(
    ! [A: real,B: real,D2: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ D2 @ C )
       => ( ord_less_eq_real @ ( minus_minus_real @ A @ C ) @ ( minus_minus_real @ B @ D2 ) ) ) ) )).

% diff_mono
thf(fact_61_eq__iff__diff__eq__0,axiom,
    ( ( ^ [Y3: real,Z2: real] : ( Y3 = Z2 ) )
    = ( ^ [A2: real,B2: real] :
          ( ( minus_minus_real @ A2 @ B2 )
          = zero_zero_real ) ) )).

% eq_iff_diff_eq_0
thf(fact_62_diff__strict__right__mono,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ord_less_real @ ( minus_minus_real @ A @ C ) @ ( minus_minus_real @ B @ C ) ) ) )).

% diff_strict_right_mono
thf(fact_63_diff__strict__left__mono,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_real @ B @ A )
     => ( ord_less_real @ ( minus_minus_real @ C @ A ) @ ( minus_minus_real @ C @ B ) ) ) )).

% diff_strict_left_mono
thf(fact_64_diff__eq__diff__less,axiom,(
    ! [A: real,B: real,C: real,D2: real] :
      ( ( ( minus_minus_real @ A @ B )
        = ( minus_minus_real @ C @ D2 ) )
     => ( ( ord_less_real @ A @ B )
        = ( ord_less_real @ C @ D2 ) ) ) )).

% diff_eq_diff_less
thf(fact_65_diff__strict__mono,axiom,(
    ! [A: real,B: real,D2: real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_real @ D2 @ C )
       => ( ord_less_real @ ( minus_minus_real @ A @ C ) @ ( minus_minus_real @ B @ D2 ) ) ) ) )).

% diff_strict_mono
thf(fact_66_abs__ge__self,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ A @ ( abs_abs_real @ A ) ) )).

% abs_ge_self
thf(fact_67_abs__le__D1,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ ( abs_abs_real @ A ) @ B )
     => ( ord_less_eq_real @ A @ B ) ) )).

% abs_le_D1
thf(fact_68_abs__eq__0__iff,axiom,(
    ! [A: real] :
      ( ( ( abs_abs_real @ A )
        = zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% abs_eq_0_iff
thf(fact_69_abs__minus__commute,axiom,(
    ! [A: real,B: real] :
      ( ( abs_abs_real @ ( minus_minus_real @ A @ B ) )
      = ( abs_abs_real @ ( minus_minus_real @ B @ A ) ) ) )).

% abs_minus_commute
thf(fact_70_max_OcoboundedI2,axiom,(
    ! [C: real,B: real,A: real] :
      ( ( ord_less_eq_real @ C @ B )
     => ( ord_less_eq_real @ C @ ( ord_max_real @ A @ B ) ) ) )).

% max.coboundedI2
thf(fact_71_max_OcoboundedI2,axiom,(
    ! [C: nat,B: nat,A: nat] :
      ( ( ord_less_eq_nat @ C @ B )
     => ( ord_less_eq_nat @ C @ ( ord_max_nat @ A @ B ) ) ) )).

% max.coboundedI2
thf(fact_72_max_OcoboundedI1,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( ord_less_eq_real @ C @ A )
     => ( ord_less_eq_real @ C @ ( ord_max_real @ A @ B ) ) ) )).

% max.coboundedI1
thf(fact_73_max_OcoboundedI1,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ C @ A )
     => ( ord_less_eq_nat @ C @ ( ord_max_nat @ A @ B ) ) ) )).

% max.coboundedI1
thf(fact_74_max_Oabsorb__iff2,axiom,
    ( ord_less_eq_real
    = ( ^ [A2: real,B2: real] :
          ( ( ord_max_real @ A2 @ B2 )
          = B2 ) ) )).

% max.absorb_iff2
thf(fact_75_max_Oabsorb__iff2,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_max_nat @ A2 @ B2 )
          = B2 ) ) )).

% max.absorb_iff2
thf(fact_76_max_Oabsorb__iff1,axiom,
    ( ord_less_eq_real
    = ( ^ [B2: real,A2: real] :
          ( ( ord_max_real @ A2 @ B2 )
          = A2 ) ) )).

% max.absorb_iff1
thf(fact_77_max_Oabsorb__iff1,axiom,
    ( ord_less_eq_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( ord_max_nat @ A2 @ B2 )
          = A2 ) ) )).

% max.absorb_iff1
thf(fact_78_le__max__iff__disj,axiom,(
    ! [Z: real,X: real,Y2: real] :
      ( ( ord_less_eq_real @ Z @ ( ord_max_real @ X @ Y2 ) )
      = ( ( ord_less_eq_real @ Z @ X )
        | ( ord_less_eq_real @ Z @ Y2 ) ) ) )).

% le_max_iff_disj
thf(fact_79_le__max__iff__disj,axiom,(
    ! [Z: nat,X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ Z @ ( ord_max_nat @ X @ Y2 ) )
      = ( ( ord_less_eq_nat @ Z @ X )
        | ( ord_less_eq_nat @ Z @ Y2 ) ) ) )).

% le_max_iff_disj
thf(fact_80_max_Ocobounded2,axiom,(
    ! [B: real,A: real] :
      ( ord_less_eq_real @ B @ ( ord_max_real @ A @ B ) ) )).

% max.cobounded2
thf(fact_81_max_Ocobounded2,axiom,(
    ! [B: nat,A: nat] :
      ( ord_less_eq_nat @ B @ ( ord_max_nat @ A @ B ) ) )).

% max.cobounded2
thf(fact_82_max_Ocobounded1,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ A @ ( ord_max_real @ A @ B ) ) )).

% max.cobounded1
thf(fact_83_max_Ocobounded1,axiom,(
    ! [A: nat,B: nat] :
      ( ord_less_eq_nat @ A @ ( ord_max_nat @ A @ B ) ) )).

% max.cobounded1
thf(fact_84_max_Oorder__iff,axiom,
    ( ord_less_eq_real
    = ( ^ [B2: real,A2: real] :
          ( A2
          = ( ord_max_real @ A2 @ B2 ) ) ) )).

% max.order_iff
thf(fact_85_max_Oorder__iff,axiom,
    ( ord_less_eq_nat
    = ( ^ [B2: nat,A2: nat] :
          ( A2
          = ( ord_max_nat @ A2 @ B2 ) ) ) )).

% max.order_iff
thf(fact_86_max_OboundedI,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ C @ A )
       => ( ord_less_eq_real @ ( ord_max_real @ B @ C ) @ A ) ) ) )).

% max.boundedI
thf(fact_87_max_OboundedI,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ A )
       => ( ord_less_eq_nat @ ( ord_max_nat @ B @ C ) @ A ) ) ) )).

% max.boundedI
thf(fact_88_max_OboundedE,axiom,(
    ! [B: real,C: real,A: real] :
      ( ( ord_less_eq_real @ ( ord_max_real @ B @ C ) @ A )
     => ~ ( ( ord_less_eq_real @ B @ A )
         => ~ ( ord_less_eq_real @ C @ A ) ) ) )).

% max.boundedE
thf(fact_89_max_OboundedE,axiom,(
    ! [B: nat,C: nat,A: nat] :
      ( ( ord_less_eq_nat @ ( ord_max_nat @ B @ C ) @ A )
     => ~ ( ( ord_less_eq_nat @ B @ A )
         => ~ ( ord_less_eq_nat @ C @ A ) ) ) )).

% max.boundedE
thf(fact_90_max_Oabsorb2,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_max_real @ A @ B )
        = B ) ) )).

% max.absorb2
thf(fact_91_max_Oabsorb2,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_max_nat @ A @ B )
        = B ) ) )).

% max.absorb2
thf(fact_92_max_Oabsorb1,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_max_real @ A @ B )
        = A ) ) )).

% max.absorb1
thf(fact_93_max_Oabsorb1,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_max_nat @ A @ B )
        = A ) ) )).

% max.absorb1
thf(fact_94_max_OorderI,axiom,(
    ! [A: real,B: real] :
      ( ( A
        = ( ord_max_real @ A @ B ) )
     => ( ord_less_eq_real @ B @ A ) ) )).

% max.orderI
thf(fact_95_max_OorderI,axiom,(
    ! [A: nat,B: nat] :
      ( ( A
        = ( ord_max_nat @ A @ B ) )
     => ( ord_less_eq_nat @ B @ A ) ) )).

% max.orderI
thf(fact_96_max_OorderE,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( A
        = ( ord_max_real @ A @ B ) ) ) )).

% max.orderE
thf(fact_97_max_OorderE,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( A
        = ( ord_max_nat @ A @ B ) ) ) )).

% max.orderE
thf(fact_98_max_Omono,axiom,(
    ! [C: real,A: real,D2: real,B: real] :
      ( ( ord_less_eq_real @ C @ A )
     => ( ( ord_less_eq_real @ D2 @ B )
       => ( ord_less_eq_real @ ( ord_max_real @ C @ D2 ) @ ( ord_max_real @ A @ B ) ) ) ) )).

% max.mono
thf(fact_99_max_Omono,axiom,(
    ! [C: nat,A: nat,D2: nat,B: nat] :
      ( ( ord_less_eq_nat @ C @ A )
     => ( ( ord_less_eq_nat @ D2 @ B )
       => ( ord_less_eq_nat @ ( ord_max_nat @ C @ D2 ) @ ( ord_max_nat @ A @ B ) ) ) ) )).

% max.mono
thf(fact_100_max_Ostrict__coboundedI2,axiom,(
    ! [C: real,B: real,A: real] :
      ( ( ord_less_real @ C @ B )
     => ( ord_less_real @ C @ ( ord_max_real @ A @ B ) ) ) )).

% max.strict_coboundedI2
thf(fact_101_max_Ostrict__coboundedI2,axiom,(
    ! [C: nat,B: nat,A: nat] :
      ( ( ord_less_nat @ C @ B )
     => ( ord_less_nat @ C @ ( ord_max_nat @ A @ B ) ) ) )).

% max.strict_coboundedI2
thf(fact_102_max_Ostrict__coboundedI1,axiom,(
    ! [C: real,A: real,B: real] :
      ( ( ord_less_real @ C @ A )
     => ( ord_less_real @ C @ ( ord_max_real @ A @ B ) ) ) )).

% max.strict_coboundedI1
thf(fact_103_max_Ostrict__coboundedI1,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ C @ A )
     => ( ord_less_nat @ C @ ( ord_max_nat @ A @ B ) ) ) )).

% max.strict_coboundedI1
thf(fact_104_max_Ostrict__order__iff,axiom,
    ( ord_less_real
    = ( ^ [B2: real,A2: real] :
          ( ( A2
            = ( ord_max_real @ A2 @ B2 ) )
          & ( A2 != B2 ) ) ) )).

% max.strict_order_iff
thf(fact_105_max_Ostrict__order__iff,axiom,
    ( ord_less_nat
    = ( ^ [B2: nat,A2: nat] :
          ( ( A2
            = ( ord_max_nat @ A2 @ B2 ) )
          & ( A2 != B2 ) ) ) )).

% max.strict_order_iff
thf(fact_106_max_Ostrict__boundedE,axiom,(
    ! [B: real,C: real,A: real] :
      ( ( ord_less_real @ ( ord_max_real @ B @ C ) @ A )
     => ~ ( ( ord_less_real @ B @ A )
         => ~ ( ord_less_real @ C @ A ) ) ) )).

% max.strict_boundedE
thf(fact_107_max_Ostrict__boundedE,axiom,(
    ! [B: nat,C: nat,A: nat] :
      ( ( ord_less_nat @ ( ord_max_nat @ B @ C ) @ A )
     => ~ ( ( ord_less_nat @ B @ A )
         => ~ ( ord_less_nat @ C @ A ) ) ) )).

% max.strict_boundedE
thf(fact_108_less__max__iff__disj,axiom,(
    ! [Z: real,X: real,Y2: real] :
      ( ( ord_less_real @ Z @ ( ord_max_real @ X @ Y2 ) )
      = ( ( ord_less_real @ Z @ X )
        | ( ord_less_real @ Z @ Y2 ) ) ) )).

% less_max_iff_disj
thf(fact_109_less__max__iff__disj,axiom,(
    ! [Z: nat,X: nat,Y2: nat] :
      ( ( ord_less_nat @ Z @ ( ord_max_nat @ X @ Y2 ) )
      = ( ( ord_less_nat @ Z @ X )
        | ( ord_less_nat @ Z @ Y2 ) ) ) )).

% less_max_iff_disj
thf(fact_110_max__diff__distrib__left,axiom,(
    ! [X: real,Y2: real,Z: real] :
      ( ( minus_minus_real @ ( ord_max_real @ X @ Y2 ) @ Z )
      = ( ord_max_real @ ( minus_minus_real @ X @ Z ) @ ( minus_minus_real @ Y2 @ Z ) ) ) )).

% max_diff_distrib_left
thf(fact_111_le__iff__diff__le__0,axiom,
    ( ord_less_eq_real
    = ( ^ [A2: real,B2: real] :
          ( ord_less_eq_real @ ( minus_minus_real @ A2 @ B2 ) @ zero_zero_real ) ) )).

% le_iff_diff_le_0
thf(fact_112_less__iff__diff__less__0,axiom,
    ( ord_less_real
    = ( ^ [A2: real,B2: real] :
          ( ord_less_real @ ( minus_minus_real @ A2 @ B2 ) @ zero_zero_real ) ) )).

% less_iff_diff_less_0
thf(fact_113_abs__ge__zero,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ zero_zero_real @ ( abs_abs_real @ A ) ) )).

% abs_ge_zero
thf(fact_114_abs__not__less__zero,axiom,(
    ! [A: real] :
      ~ ( ord_less_real @ ( abs_abs_real @ A ) @ zero_zero_real ) )).

% abs_not_less_zero
thf(fact_115_abs__of__pos,axiom,(
    ! [A: real] :
      ( ( ord_less_real @ zero_zero_real @ A )
     => ( ( abs_abs_real @ A )
        = A ) ) )).

% abs_of_pos
thf(fact_116_abs__triangle__ineq2__sym,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ ( minus_minus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) @ ( abs_abs_real @ ( minus_minus_real @ B @ A ) ) ) )).

% abs_triangle_ineq2_sym
thf(fact_117_abs__triangle__ineq3,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) ) @ ( abs_abs_real @ ( minus_minus_real @ A @ B ) ) ) )).

% abs_triangle_ineq3
thf(fact_118_abs__triangle__ineq2,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ ( minus_minus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) @ ( abs_abs_real @ ( minus_minus_real @ A @ B ) ) ) )).

% abs_triangle_ineq2
thf(fact_119_dense__eq0__I,axiom,(
    ! [X: real] :
      ( ! [E: real] :
          ( ( ord_less_real @ zero_zero_real @ E )
         => ( ord_less_eq_real @ ( abs_abs_real @ X ) @ E ) )
     => ( X = zero_zero_real ) ) )).

% dense_eq0_I
thf(fact_120_lemma__interval__lt,axiom,(
    ! [A: real,X: real,B: real] :
      ( ( ord_less_real @ A @ X )
     => ( ( ord_less_real @ X @ B )
       => ? [D: real] :
            ( ( ord_less_real @ zero_zero_real @ D )
            & ! [Y: real] :
                ( ( ord_less_real @ ( abs_abs_real @ ( minus_minus_real @ X @ Y ) ) @ D )
               => ( ( ord_less_real @ A @ Y )
                  & ( ord_less_real @ Y @ B ) ) ) ) ) ) )).

% lemma_interval_lt
thf(fact_121_Bolzano,axiom,(
    ! [A: real,B: real,P4: real > real > $o] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ! [A4: real,B3: real,C2: real] :
            ( ( P4 @ A4 @ B3 )
           => ( ( P4 @ B3 @ C2 )
             => ( ( ord_less_eq_real @ A4 @ B3 )
               => ( ( ord_less_eq_real @ B3 @ C2 )
                 => ( P4 @ A4 @ C2 ) ) ) ) )
       => ( ! [X3: real] :
              ( ( ord_less_eq_real @ A @ X3 )
             => ( ( ord_less_eq_real @ X3 @ B )
               => ? [D3: real] :
                    ( ( ord_less_real @ zero_zero_real @ D3 )
                    & ! [A4: real,B3: real] :
                        ( ( ( ord_less_eq_real @ A4 @ X3 )
                          & ( ord_less_eq_real @ X3 @ B3 )
                          & ( ord_less_real @ ( minus_minus_real @ B3 @ A4 ) @ D3 ) )
                       => ( P4 @ A4 @ B3 ) ) ) ) )
         => ( P4 @ A @ B ) ) ) ) )).

% Bolzano
thf(fact_122_okRead2__def,axiom,
    ( genClo293725282kRead2
    = ( ^ [F: nat > real,G: nat > real,X2: real,Ppred: nat > $o] :
        ! [P: nat] :
          ( ( Ppred @ P )
         => ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ ( F @ P ) @ ( G @ P ) ) ) @ X2 ) ) ) )).

% okRead2_def
thf(fact_123_rts2b,axiom,(
    ! [P2: nat,Q3: nat,I3: nat] :
      ( ( ( genClo1015804716orrect @ P2 @ ( genClo1163638703lle_te @ P2 @ I3 ) )
        & ( genClo1015804716orrect @ Q3 @ ( genClo1163638703lle_te @ Q3 @ I3 ) ) )
     => ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ ( genClo1163638703lle_te @ P2 @ I3 ) @ ( genClo1163638703lle_te @ Q3 @ I3 ) ) ) @ genClo1278781456e_beta ) ) )).

% rts2b
thf(fact_124_okmaxsync__def,axiom,
    ( genClo208577157axsync
    = ( ^ [I: nat,X2: real] :
        ! [P: nat,Q: nat] :
          ( ( ( genClo1015804716orrect @ P @ ( ord_max_real @ ( genClo1163638703lle_te @ P @ I ) @ ( genClo1163638703lle_te @ Q @ I ) ) )
            & ( genClo1015804716orrect @ Q @ ( ord_max_real @ ( genClo1163638703lle_te @ P @ I ) @ ( genClo1163638703lle_te @ Q @ I ) ) ) )
         => ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ ( genClo1160817912lle_IC @ P @ I @ ( ord_max_real @ ( genClo1163638703lle_te @ P @ I ) @ ( genClo1163638703lle_te @ Q @ I ) ) ) @ ( genClo1160817912lle_IC @ Q @ I @ ( ord_max_real @ ( genClo1163638703lle_te @ P @ I ) @ ( genClo1163638703lle_te @ Q @ I ) ) ) ) ) @ X2 ) ) ) )).

% okmaxsync_def
thf(fact_125_okRead1__def,axiom,
    ( genClo293725281kRead1
    = ( ^ [F: nat > real,X2: real,Ppred: nat > $o] :
        ! [L: nat,M2: nat] :
          ( ( ( Ppred @ L )
            & ( Ppred @ M2 ) )
         => ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ ( F @ L ) @ ( F @ M2 ) ) ) @ X2 ) ) ) )).

% okRead1_def
thf(fact_126_order__refl,axiom,(
    ! [X: real] :
      ( ord_less_eq_real @ X @ X ) )).

% order_refl
thf(fact_127_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_128_max__def,axiom,
    ( ord_max_real
    = ( ^ [A2: real,B2: real] :
          ( if_real @ ( ord_less_eq_real @ A2 @ B2 ) @ B2 @ A2 ) ) )).

% max_def
thf(fact_129_max__def,axiom,
    ( ord_max_nat
    = ( ^ [A2: nat,B2: nat] :
          ( if_nat @ ( ord_less_eq_nat @ A2 @ B2 ) @ B2 @ A2 ) ) )).

% max_def
thf(fact_130_max__absorb2,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_eq_real @ X @ Y2 )
     => ( ( ord_max_real @ X @ Y2 )
        = Y2 ) ) )).

% max_absorb2
thf(fact_131_max__absorb2,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_max_nat @ X @ Y2 )
        = Y2 ) ) )).

% max_absorb2
thf(fact_132_max__absorb1,axiom,(
    ! [Y2: real,X: real] :
      ( ( ord_less_eq_real @ Y2 @ X )
     => ( ( ord_max_real @ X @ Y2 )
        = X ) ) )).

% max_absorb1
thf(fact_133_max__absorb1,axiom,(
    ! [Y2: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y2 @ X )
     => ( ( ord_max_nat @ X @ Y2 )
        = X ) ) )).

% max_absorb1
thf(fact_134_less__eq__real__def,axiom,
    ( ord_less_eq_real
    = ( ^ [X2: real,Y4: real] :
          ( ( ord_less_real @ X2 @ Y4 )
          | ( X2 = Y4 ) ) ) )).

% less_eq_real_def
thf(fact_135_order__subst1,axiom,(
    ! [A: real,F2: real > real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ ( F2 @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_eq_real @ X3 @ Y5 )
             => ( ord_less_eq_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_eq_real @ A @ ( F2 @ C ) ) ) ) ) )).

% order_subst1
thf(fact_136_order__subst1,axiom,(
    ! [A: real,F2: nat > real,B: nat,C: nat] :
      ( ( ord_less_eq_real @ A @ ( F2 @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y5 )
             => ( ord_less_eq_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_eq_real @ A @ ( F2 @ C ) ) ) ) ) )).

% order_subst1
thf(fact_137_order__subst1,axiom,(
    ! [A: nat,F2: real > nat,B: real,C: real] :
      ( ( ord_less_eq_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_eq_real @ X3 @ Y5 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_eq_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_subst1
thf(fact_138_order__subst1,axiom,(
    ! [A: nat,F2: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y5 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_eq_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_subst1
thf(fact_139_order__subst2,axiom,(
    ! [A: real,B: real,F2: real > real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ ( F2 @ B ) @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_eq_real @ X3 @ Y5 )
             => ( ord_less_eq_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_eq_real @ ( F2 @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_140_order__subst2,axiom,(
    ! [A: real,B: real,F2: real > nat,C: nat] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_eq_real @ X3 @ Y5 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_eq_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_141_order__subst2,axiom,(
    ! [A: nat,B: nat,F2: nat > real,C: real] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_real @ ( F2 @ B ) @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y5 )
             => ( ord_less_eq_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_eq_real @ ( F2 @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_142_order__subst2,axiom,(
    ! [A: nat,B: nat,F2: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y5 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_eq_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_143_ord__eq__le__subst,axiom,(
    ! [A: real,F2: real > real,B: real,C: real] :
      ( ( A
        = ( F2 @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_eq_real @ X3 @ Y5 )
             => ( ord_less_eq_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_eq_real @ A @ ( F2 @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_144_ord__eq__le__subst,axiom,(
    ! [A: nat,F2: real > nat,B: real,C: real] :
      ( ( A
        = ( F2 @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_eq_real @ X3 @ Y5 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_eq_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_145_ord__eq__le__subst,axiom,(
    ! [A: real,F2: nat > real,B: nat,C: nat] :
      ( ( A
        = ( F2 @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y5 )
             => ( ord_less_eq_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_eq_real @ A @ ( F2 @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_146_ord__eq__le__subst,axiom,(
    ! [A: nat,F2: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F2 @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y5 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_eq_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_147_ord__le__eq__subst,axiom,(
    ! [A: real,B: real,F2: real > real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ( F2 @ B )
          = C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_eq_real @ X3 @ Y5 )
             => ( ord_less_eq_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_eq_real @ ( F2 @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_148_ord__le__eq__subst,axiom,(
    ! [A: real,B: real,F2: real > nat,C: nat] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ( F2 @ B )
          = C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_eq_real @ X3 @ Y5 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_eq_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_149_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F2: nat > real,C: real] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F2 @ B )
          = C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y5 )
             => ( ord_less_eq_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_eq_real @ ( F2 @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_150_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F2: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F2 @ B )
          = C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y5 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_eq_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_151_eq__iff,axiom,
    ( ( ^ [Y3: real,Z2: real] : ( Y3 = Z2 ) )
    = ( ^ [X2: real,Y4: real] :
          ( ( ord_less_eq_real @ X2 @ Y4 )
          & ( ord_less_eq_real @ Y4 @ X2 ) ) ) )).

% eq_iff
thf(fact_152_eq__iff,axiom,
    ( ( ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 ) )
    = ( ^ [X2: nat,Y4: nat] :
          ( ( ord_less_eq_nat @ X2 @ Y4 )
          & ( ord_less_eq_nat @ Y4 @ X2 ) ) ) )).

% eq_iff
thf(fact_153_antisym,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_eq_real @ X @ Y2 )
     => ( ( ord_less_eq_real @ Y2 @ X )
       => ( X = Y2 ) ) ) )).

% antisym
thf(fact_154_antisym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ X )
       => ( X = Y2 ) ) ) )).

% antisym
thf(fact_155_linear,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_eq_real @ X @ Y2 )
      | ( ord_less_eq_real @ Y2 @ X ) ) )).

% linear
thf(fact_156_linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
      | ( ord_less_eq_nat @ Y2 @ X ) ) )).

% linear
thf(fact_157_eq__refl,axiom,(
    ! [X: real,Y2: real] :
      ( ( X = Y2 )
     => ( ord_less_eq_real @ X @ Y2 ) ) )).

% eq_refl
thf(fact_158_eq__refl,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X = Y2 )
     => ( ord_less_eq_nat @ X @ Y2 ) ) )).

% eq_refl
thf(fact_159_le__cases,axiom,(
    ! [X: real,Y2: real] :
      ( ~ ( ord_less_eq_real @ X @ Y2 )
     => ( ord_less_eq_real @ Y2 @ X ) ) )).

% le_cases
thf(fact_160_le__cases,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ Y2 @ X ) ) )).

% le_cases
thf(fact_161_order_Otrans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ord_less_eq_real @ A @ C ) ) ) )).

% order.trans
thf(fact_162_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_163_le__cases3,axiom,(
    ! [X: real,Y2: real,Z: real] :
      ( ( ( ord_less_eq_real @ X @ Y2 )
       => ~ ( ord_less_eq_real @ Y2 @ Z ) )
     => ( ( ( ord_less_eq_real @ Y2 @ X )
         => ~ ( ord_less_eq_real @ X @ Z ) )
       => ( ( ( ord_less_eq_real @ X @ Z )
           => ~ ( ord_less_eq_real @ Z @ Y2 ) )
         => ( ( ( ord_less_eq_real @ Z @ Y2 )
             => ~ ( ord_less_eq_real @ Y2 @ X ) )
           => ( ( ( ord_less_eq_real @ Y2 @ Z )
               => ~ ( ord_less_eq_real @ Z @ X ) )
             => ~ ( ( ord_less_eq_real @ Z @ X )
                 => ~ ( ord_less_eq_real @ X @ Y2 ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_164_le__cases3,axiom,(
    ! [X: nat,Y2: nat,Z: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y2 )
       => ~ ( ord_less_eq_nat @ Y2 @ Z ) )
     => ( ( ( ord_less_eq_nat @ Y2 @ X )
         => ~ ( ord_less_eq_nat @ X @ Z ) )
       => ( ( ( ord_less_eq_nat @ X @ Z )
           => ~ ( ord_less_eq_nat @ Z @ Y2 ) )
         => ( ( ( ord_less_eq_nat @ Z @ Y2 )
             => ~ ( ord_less_eq_nat @ Y2 @ X ) )
           => ( ( ( ord_less_eq_nat @ Y2 @ Z )
               => ~ ( ord_less_eq_nat @ Z @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y2 ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_165_antisym__conv,axiom,(
    ! [Y2: real,X: real] :
      ( ( ord_less_eq_real @ Y2 @ X )
     => ( ( ord_less_eq_real @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv
thf(fact_166_antisym__conv,axiom,(
    ! [Y2: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y2 @ X )
     => ( ( ord_less_eq_nat @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv
thf(fact_167_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y3: real,Z2: real] : ( Y3 = Z2 ) )
    = ( ^ [A2: real,B2: real] :
          ( ( ord_less_eq_real @ A2 @ B2 )
          & ( ord_less_eq_real @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_168_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( ord_less_eq_nat @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_169_ord__eq__le__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( A = B )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ord_less_eq_real @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_170_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_171_ord__le__eq__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_real @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_172_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_173_order__class_Oorder_Oantisym,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_174_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_175_order__trans,axiom,(
    ! [X: real,Y2: real,Z: real] :
      ( ( ord_less_eq_real @ X @ Y2 )
     => ( ( ord_less_eq_real @ Y2 @ Z )
       => ( ord_less_eq_real @ X @ Z ) ) ) )).

% order_trans
thf(fact_176_order__trans,axiom,(
    ! [X: nat,Y2: nat,Z: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ Z )
       => ( ord_less_eq_nat @ X @ Z ) ) ) )).

% order_trans
thf(fact_177_dual__order_Orefl,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ A @ A ) )).

% dual_order.refl
thf(fact_178_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_179_linorder__wlog,axiom,(
    ! [P4: real > real > $o,A: real,B: real] :
      ( ! [A4: real,B3: real] :
          ( ( ord_less_eq_real @ A4 @ B3 )
         => ( P4 @ A4 @ B3 ) )
     => ( ! [A4: real,B3: real] :
            ( ( P4 @ B3 @ A4 )
           => ( P4 @ A4 @ B3 ) )
       => ( P4 @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_180_linorder__wlog,axiom,(
    ! [P4: nat > nat > $o,A: nat,B: nat] :
      ( ! [A4: nat,B3: nat] :
          ( ( ord_less_eq_nat @ A4 @ B3 )
         => ( P4 @ A4 @ B3 ) )
     => ( ! [A4: nat,B3: nat] :
            ( ( P4 @ B3 @ A4 )
           => ( P4 @ A4 @ B3 ) )
       => ( P4 @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_181_dual__order_Otrans,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ C @ B )
       => ( ord_less_eq_real @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_182_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_183_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y3: real,Z2: real] : ( Y3 = Z2 ) )
    = ( ^ [A2: real,B2: real] :
          ( ( ord_less_eq_real @ B2 @ A2 )
          & ( ord_less_eq_real @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_184_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( ord_less_eq_nat @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_185_dual__order_Oantisym,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_186_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_187_ord__eq__less__subst,axiom,(
    ! [A: real,F2: real > real,B: real,C: real] :
      ( ( A
        = ( F2 @ B ) )
     => ( ( ord_less_real @ B @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_real @ X3 @ Y5 )
             => ( ord_less_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_real @ A @ ( F2 @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_188_ord__eq__less__subst,axiom,(
    ! [A: nat,F2: real > nat,B: real,C: real] :
      ( ( A
        = ( F2 @ B ) )
     => ( ( ord_less_real @ B @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_real @ X3 @ Y5 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_189_ord__eq__less__subst,axiom,(
    ! [A: real,F2: nat > real,B: nat,C: nat] :
      ( ( A
        = ( F2 @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_nat @ X3 @ Y5 )
             => ( ord_less_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_real @ A @ ( F2 @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_190_ord__eq__less__subst,axiom,(
    ! [A: nat,F2: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F2 @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_nat @ X3 @ Y5 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_191_ord__less__eq__subst,axiom,(
    ! [A: real,B: real,F2: real > real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ( F2 @ B )
          = C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_real @ X3 @ Y5 )
             => ( ord_less_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_real @ ( F2 @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_192_ord__less__eq__subst,axiom,(
    ! [A: real,B: real,F2: real > nat,C: nat] :
      ( ( ord_less_real @ A @ B )
     => ( ( ( F2 @ B )
          = C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_real @ X3 @ Y5 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_193_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F2: nat > real,C: real] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F2 @ B )
          = C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_nat @ X3 @ Y5 )
             => ( ord_less_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_real @ ( F2 @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_194_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F2: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F2 @ B )
          = C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_nat @ X3 @ Y5 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_195_order__less__subst1,axiom,(
    ! [A: real,F2: real > real,B: real,C: real] :
      ( ( ord_less_real @ A @ ( F2 @ B ) )
     => ( ( ord_less_real @ B @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_real @ X3 @ Y5 )
             => ( ord_less_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_real @ A @ ( F2 @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_196_order__less__subst1,axiom,(
    ! [A: real,F2: nat > real,B: nat,C: nat] :
      ( ( ord_less_real @ A @ ( F2 @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_nat @ X3 @ Y5 )
             => ( ord_less_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_real @ A @ ( F2 @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_197_order__less__subst1,axiom,(
    ! [A: nat,F2: real > nat,B: real,C: real] :
      ( ( ord_less_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_real @ B @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_real @ X3 @ Y5 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_198_order__less__subst1,axiom,(
    ! [A: nat,F2: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_nat @ X3 @ Y5 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_199_order__less__subst2,axiom,(
    ! [A: real,B: real,F2: real > real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_real @ ( F2 @ B ) @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_real @ X3 @ Y5 )
             => ( ord_less_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_real @ ( F2 @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_200_order__less__subst2,axiom,(
    ! [A: real,B: real,F2: real > nat,C: nat] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_real @ X3 @ Y5 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_201_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F2: nat > real,C: real] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_real @ ( F2 @ B ) @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_nat @ X3 @ Y5 )
             => ( ord_less_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_real @ ( F2 @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_202_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F2: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_nat @ X3 @ Y5 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_203_lt__ex,axiom,(
    ! [X: real] :
    ? [Y5: real] :
      ( ord_less_real @ Y5 @ X ) )).

% lt_ex
thf(fact_204_gt__ex,axiom,(
    ! [X: real] :
    ? [X_1: real] :
      ( ord_less_real @ X @ X_1 ) )).

% gt_ex
thf(fact_205_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_206_neqE,axiom,(
    ! [X: real,Y2: real] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_real @ X @ Y2 )
       => ( ord_less_real @ Y2 @ X ) ) ) )).

% neqE
thf(fact_207_neqE,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_nat @ X @ Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% neqE
thf(fact_208_neq__iff,axiom,(
    ! [X: real,Y2: real] :
      ( ( X != Y2 )
      = ( ( ord_less_real @ X @ Y2 )
        | ( ord_less_real @ Y2 @ X ) ) ) )).

% neq_iff
thf(fact_209_neq__iff,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
      = ( ( ord_less_nat @ X @ Y2 )
        | ( ord_less_nat @ Y2 @ X ) ) ) )).

% neq_iff
thf(fact_210_order_Oasym,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ B )
     => ~ ( ord_less_real @ B @ A ) ) )).

% order.asym
thf(fact_211_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_212_dense,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ? [Z3: real] :
          ( ( ord_less_real @ X @ Z3 )
          & ( ord_less_real @ Z3 @ Y2 ) ) ) )).

% dense
thf(fact_213_less__imp__neq,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_neq
thf(fact_214_less__imp__neq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_neq
thf(fact_215_less__asym,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ~ ( ord_less_real @ Y2 @ X ) ) )).

% less_asym
thf(fact_216_less__asym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_asym
thf(fact_217_less__asym_H,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ B )
     => ~ ( ord_less_real @ B @ A ) ) )).

% less_asym'
thf(fact_218_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_219_less__trans,axiom,(
    ! [X: real,Y2: real,Z: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ( ( ord_less_real @ Y2 @ Z )
       => ( ord_less_real @ X @ Z ) ) ) )).

% less_trans
thf(fact_220_less__trans,axiom,(
    ! [X: nat,Y2: nat,Z: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% less_trans
thf(fact_221_less__linear,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
      | ( X = Y2 )
      | ( ord_less_real @ Y2 @ X ) ) )).

% less_linear
thf(fact_222_less__linear,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
      | ( X = Y2 )
      | ( ord_less_nat @ Y2 @ X ) ) )).

% less_linear
thf(fact_223_less__irrefl,axiom,(
    ! [X: real] :
      ~ ( ord_less_real @ X @ X ) )).

% less_irrefl
thf(fact_224_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_225_ord__eq__less__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( A = B )
     => ( ( ord_less_real @ B @ C )
       => ( ord_less_real @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_226_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_227_ord__less__eq__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( B = C )
       => ( ord_less_real @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_228_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_229_dual__order_Oasym,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_real @ B @ A )
     => ~ ( ord_less_real @ A @ B ) ) )).

% dual_order.asym
thf(fact_230_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_231_less__imp__not__eq,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_not_eq
thf(fact_232_less__imp__not__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( X != Y2 ) ) )).

% less_imp_not_eq
thf(fact_233_less__not__sym,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ~ ( ord_less_real @ Y2 @ X ) ) )).

% less_not_sym
thf(fact_234_less__not__sym,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_not_sym
thf(fact_235_less__induct,axiom,(
    ! [P4: nat > $o,A: nat] :
      ( ! [X3: nat] :
          ( ! [Y: nat] :
              ( ( ord_less_nat @ Y @ X3 )
             => ( P4 @ Y ) )
         => ( P4 @ X3 ) )
     => ( P4 @ A ) ) )).

% less_induct
thf(fact_236_antisym__conv3,axiom,(
    ! [Y2: real,X: real] :
      ( ~ ( ord_less_real @ Y2 @ X )
     => ( ( ~ ( ord_less_real @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv3
thf(fact_237_antisym__conv3,axiom,(
    ! [Y2: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y2 @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv3
thf(fact_238_less__imp__not__eq2,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ( Y2 != X ) ) )).

% less_imp_not_eq2
thf(fact_239_less__imp__not__eq2,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( Y2 != X ) ) )).

% less_imp_not_eq2
thf(fact_240_less__imp__triv,axiom,(
    ! [X: real,Y2: real,P4: $o] :
      ( ( ord_less_real @ X @ Y2 )
     => ( ( ord_less_real @ Y2 @ X )
       => P4 ) ) )).

% less_imp_triv
thf(fact_241_less__imp__triv,axiom,(
    ! [X: nat,Y2: nat,P4: $o] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ X )
       => P4 ) ) )).

% less_imp_triv
thf(fact_242_linorder__cases,axiom,(
    ! [X: real,Y2: real] :
      ( ~ ( ord_less_real @ X @ Y2 )
     => ( ( X != Y2 )
       => ( ord_less_real @ Y2 @ X ) ) ) )).

% linorder_cases
thf(fact_243_linorder__cases,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_nat @ X @ Y2 )
     => ( ( X != Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% linorder_cases
thf(fact_244_dual__order_Oirrefl,axiom,(
    ! [A: real] :
      ~ ( ord_less_real @ A @ A ) )).

% dual_order.irrefl
thf(fact_245_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_246_order_Ostrict__trans,axiom,(
    ! [A: real,B: real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_real @ B @ C )
       => ( ord_less_real @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_247_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_248_less__imp__not__less,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ~ ( ord_less_real @ Y2 @ X ) ) )).

% less_imp_not_less
thf(fact_249_less__imp__not__less,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ~ ( ord_less_nat @ Y2 @ X ) ) )).

% less_imp_not_less
thf(fact_250_exists__least__iff,axiom,
    ( ( ^ [P5: nat > $o] :
        ? [X4: nat] :
          ( P5 @ X4 ) )
    = ( ^ [P6: nat > $o] :
        ? [N2: nat] :
          ( ( P6 @ N2 )
          & ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ~ ( P6 @ M2 ) ) ) ) )).

% exists_least_iff
thf(fact_251_linorder__less__wlog,axiom,(
    ! [P4: real > real > $o,A: real,B: real] :
      ( ! [A4: real,B3: real] :
          ( ( ord_less_real @ A4 @ B3 )
         => ( P4 @ A4 @ B3 ) )
     => ( ! [A4: real] :
            ( P4 @ A4 @ A4 )
       => ( ! [A4: real,B3: real] :
              ( ( P4 @ B3 @ A4 )
             => ( P4 @ A4 @ B3 ) )
         => ( P4 @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_252_linorder__less__wlog,axiom,(
    ! [P4: nat > nat > $o,A: nat,B: nat] :
      ( ! [A4: nat,B3: nat] :
          ( ( ord_less_nat @ A4 @ B3 )
         => ( P4 @ A4 @ B3 ) )
     => ( ! [A4: nat] :
            ( P4 @ A4 @ A4 )
       => ( ! [A4: nat,B3: nat] :
              ( ( P4 @ B3 @ A4 )
             => ( P4 @ A4 @ B3 ) )
         => ( P4 @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_253_dual__order_Ostrict__trans,axiom,(
    ! [B: real,A: real,C: real] :
      ( ( ord_less_real @ B @ A )
     => ( ( ord_less_real @ C @ B )
       => ( ord_less_real @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_254_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_255_not__less__iff__gr__or__eq,axiom,(
    ! [X: real,Y2: real] :
      ( ( ~ ( ord_less_real @ X @ Y2 ) )
      = ( ( ord_less_real @ Y2 @ X )
        | ( X = Y2 ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_256_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y2 ) )
      = ( ( ord_less_nat @ Y2 @ X )
        | ( X = Y2 ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_257_order_Ostrict__implies__not__eq,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_real @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_258_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_259_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_real @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_260_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_261_complete__real,axiom,(
    ! [S2: set_real] :
      ( ? [X5: real] :
          ( member_real @ X5 @ S2 )
     => ( ? [Z4: real] :
          ! [X3: real] :
            ( ( member_real @ X3 @ S2 )
           => ( ord_less_eq_real @ X3 @ Z4 ) )
       => ? [Y5: real] :
            ( ! [X5: real] :
                ( ( member_real @ X5 @ S2 )
               => ( ord_less_eq_real @ X5 @ Y5 ) )
            & ! [Z4: real] :
                ( ! [X3: real] :
                    ( ( member_real @ X3 @ S2 )
                   => ( ord_less_eq_real @ X3 @ Z4 ) )
               => ( ord_less_eq_real @ Y5 @ Z4 ) ) ) ) ) )).

% complete_real
thf(fact_262_leD,axiom,(
    ! [Y2: real,X: real] :
      ( ( ord_less_eq_real @ Y2 @ X )
     => ~ ( ord_less_real @ X @ Y2 ) ) )).

% leD
thf(fact_263_leD,axiom,(
    ! [Y2: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y2 @ X )
     => ~ ( ord_less_nat @ X @ Y2 ) ) )).

% leD
thf(fact_264_leI,axiom,(
    ! [X: real,Y2: real] :
      ( ~ ( ord_less_real @ X @ Y2 )
     => ( ord_less_eq_real @ Y2 @ X ) ) )).

% leI
thf(fact_265_leI,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ Y2 @ X ) ) )).

% leI
thf(fact_266_le__less,axiom,
    ( ord_less_eq_real
    = ( ^ [X2: real,Y4: real] :
          ( ( ord_less_real @ X2 @ Y4 )
          | ( X2 = Y4 ) ) ) )).

% le_less
thf(fact_267_le__less,axiom,
    ( ord_less_eq_nat
    = ( ^ [X2: nat,Y4: nat] :
          ( ( ord_less_nat @ X2 @ Y4 )
          | ( X2 = Y4 ) ) ) )).

% le_less
thf(fact_268_less__le,axiom,
    ( ord_less_real
    = ( ^ [X2: real,Y4: real] :
          ( ( ord_less_eq_real @ X2 @ Y4 )
          & ( X2 != Y4 ) ) ) )).

% less_le
thf(fact_269_less__le,axiom,
    ( ord_less_nat
    = ( ^ [X2: nat,Y4: nat] :
          ( ( ord_less_eq_nat @ X2 @ Y4 )
          & ( X2 != Y4 ) ) ) )).

% less_le
thf(fact_270_order__le__less__subst1,axiom,(
    ! [A: real,F2: real > real,B: real,C: real] :
      ( ( ord_less_eq_real @ A @ ( F2 @ B ) )
     => ( ( ord_less_real @ B @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_real @ X3 @ Y5 )
             => ( ord_less_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_real @ A @ ( F2 @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_271_order__le__less__subst1,axiom,(
    ! [A: real,F2: nat > real,B: nat,C: nat] :
      ( ( ord_less_eq_real @ A @ ( F2 @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_nat @ X3 @ Y5 )
             => ( ord_less_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_real @ A @ ( F2 @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_272_order__le__less__subst1,axiom,(
    ! [A: nat,F2: real > nat,B: real,C: real] :
      ( ( ord_less_eq_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_real @ B @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_real @ X3 @ Y5 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_273_order__le__less__subst1,axiom,(
    ! [A: nat,F2: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_nat @ X3 @ Y5 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_274_order__le__less__subst2,axiom,(
    ! [A: real,B: real,F2: real > real,C: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_real @ ( F2 @ B ) @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_eq_real @ X3 @ Y5 )
             => ( ord_less_eq_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_real @ ( F2 @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_275_order__le__less__subst2,axiom,(
    ! [A: real,B: real,F2: real > nat,C: nat] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_eq_real @ X3 @ Y5 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_276_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F2: nat > real,C: real] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_real @ ( F2 @ B ) @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y5 )
             => ( ord_less_eq_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_real @ ( F2 @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_277_order__le__less__subst2,axiom,(
    ! [A: nat,B: nat,F2: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y5 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_le_less_subst2
thf(fact_278_order__less__le__subst1,axiom,(
    ! [A: real,F2: real > real,B: real,C: real] :
      ( ( ord_less_real @ A @ ( F2 @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_eq_real @ X3 @ Y5 )
             => ( ord_less_eq_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_real @ A @ ( F2 @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_279_order__less__le__subst1,axiom,(
    ! [A: nat,F2: real > nat,B: real,C: real] :
      ( ( ord_less_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_eq_real @ B @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_eq_real @ X3 @ Y5 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_280_order__less__le__subst1,axiom,(
    ! [A: real,F2: nat > real,B: nat,C: nat] :
      ( ( ord_less_real @ A @ ( F2 @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y5 )
             => ( ord_less_eq_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_real @ A @ ( F2 @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_281_order__less__le__subst1,axiom,(
    ! [A: nat,F2: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F2 @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_eq_nat @ X3 @ Y5 )
             => ( ord_less_eq_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_nat @ A @ ( F2 @ C ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_282_order__less__le__subst2,axiom,(
    ! [A: real,B: real,F2: real > real,C: real] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_eq_real @ ( F2 @ B ) @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_real @ X3 @ Y5 )
             => ( ord_less_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_real @ ( F2 @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_283_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F2: nat > real,C: real] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_real @ ( F2 @ B ) @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_nat @ X3 @ Y5 )
             => ( ord_less_real @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_real @ ( F2 @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_284_order__less__le__subst2,axiom,(
    ! [A: real,B: real,F2: real > nat,C: nat] :
      ( ( ord_less_real @ A @ B )
     => ( ( ord_less_eq_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: real,Y5: real] :
              ( ( ord_less_real @ X3 @ Y5 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_285_order__less__le__subst2,axiom,(
    ! [A: nat,B: nat,F2: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F2 @ B ) @ C )
       => ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_nat @ X3 @ Y5 )
             => ( ord_less_nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ord_less_nat @ ( F2 @ A ) @ C ) ) ) ) )).

% order_less_le_subst2
thf(fact_286_not__le,axiom,(
    ! [X: real,Y2: real] :
      ( ( ~ ( ord_less_eq_real @ X @ Y2 ) )
      = ( ord_less_real @ Y2 @ X ) ) )).

% not_le
thf(fact_287_not__le,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ~ ( ord_less_eq_nat @ X @ Y2 ) )
      = ( ord_less_nat @ Y2 @ X ) ) )).

% not_le
thf(fact_288_not__less,axiom,(
    ! [X: real,Y2: real] :
      ( ( ~ ( ord_less_real @ X @ Y2 ) )
      = ( ord_less_eq_real @ Y2 @ X ) ) )).

% not_less
thf(fact_289_not__less,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y2 ) )
      = ( ord_less_eq_nat @ Y2 @ X ) ) )).

% not_less
thf(fact_290_le__neq__trans,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( A != B )
       => ( ord_less_real @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_291_le__neq__trans,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( A != B )
       => ( ord_less_nat @ A @ B ) ) ) )).

% le_neq_trans
thf(fact_292_antisym__conv1,axiom,(
    ! [X: real,Y2: real] :
      ( ~ ( ord_less_real @ X @ Y2 )
     => ( ( ord_less_eq_real @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv1
thf(fact_293_antisym__conv1,axiom,(
    ! [X: nat,Y2: nat] :
      ( ~ ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ X @ Y2 )
        = ( X = Y2 ) ) ) )).

% antisym_conv1
thf(fact_294_antisym__conv2,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_eq_real @ X @ Y2 )
     => ( ( ~ ( ord_less_real @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv2
thf(fact_295_antisym__conv2,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ~ ( ord_less_nat @ X @ Y2 ) )
        = ( X = Y2 ) ) ) )).

% antisym_conv2
thf(fact_296_less__imp__le,axiom,(
    ! [X: real,Y2: real] :
      ( ( ord_less_real @ X @ Y2 )
     => ( ord_less_eq_real @ X @ Y2 ) ) )).

% less_imp_le
thf(fact_297_less__imp__le,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ord_less_eq_nat @ X @ Y2 ) ) )).

% less_imp_le
thf(fact_298_le__less__trans,axiom,(
    ! [X: real,Y2: real,Z: real] :
      ( ( ord_less_eq_real @ X @ Y2 )
     => ( ( ord_less_real @ Y2 @ Z )
       => ( ord_less_real @ X @ Z ) ) ) )).

% le_less_trans
thf(fact_299_le__less__trans,axiom,(
    ! [X: nat,Y2: nat,Z: nat] :
      ( ( ord_less_eq_nat @ X @ Y2 )
     => ( ( ord_less_nat @ Y2 @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% le_less_trans
thf(fact_300_less__le__trans,axiom,(
    ! [X: nat,Y2: nat,Z: nat] :
      ( ( ord_less_nat @ X @ Y2 )
     => ( ( ord_less_eq_nat @ Y2 @ Z )
       => ( ord_less_nat @ X @ Z ) ) ) )).

% less_le_trans
thf(fact_301_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_302_max__0L,axiom,(
    ! [N: nat] :
      ( ( ord_max_nat @ zero_zero_nat @ N )
      = N ) )).

% max_0L
thf(fact_303_max__0R,axiom,(
    ! [N: nat] :
      ( ( ord_max_nat @ N @ zero_zero_nat )
      = N ) )).

% max_0R
thf(fact_304_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_305_diff__0__eq__0,axiom,(
    ! [N: nat] :
      ( ( minus_minus_nat @ zero_zero_nat @ N )
      = zero_zero_nat ) )).

% diff_0_eq_0
thf(fact_306_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_307_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_308_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_309_diff__self__eq__0,axiom,(
    ! [M: nat] :
      ( ( minus_minus_nat @ M @ M )
      = zero_zero_nat ) )).

% diff_self_eq_0
thf(fact_310_diff__diff__cancel,axiom,(
    ! [I4: nat,N: nat] :
      ( ( ord_less_eq_nat @ I4 @ N )
     => ( ( minus_minus_nat @ N @ ( minus_minus_nat @ N @ I4 ) )
        = I4 ) ) )).

% diff_diff_cancel
thf(fact_311_max__nat_Oright__neutral,axiom,(
    ! [A: nat] :
      ( ( ord_max_nat @ A @ zero_zero_nat )
      = A ) )).

% max_nat.right_neutral
thf(fact_312_max__nat_Oneutr__eq__iff,axiom,(
    ! [A: nat,B: nat] :
      ( ( zero_zero_nat
        = ( ord_max_nat @ A @ B ) )
      = ( ( A = zero_zero_nat )
        & ( B = zero_zero_nat ) ) ) )).

% max_nat.neutr_eq_iff
thf(fact_313_max__nat_Oleft__neutral,axiom,(
    ! [A: nat] :
      ( ( ord_max_nat @ zero_zero_nat @ A )
      = A ) )).

% max_nat.left_neutral
thf(fact_314_max__nat_Oeq__neutr__iff,axiom,(
    ! [A: nat,B: nat] :
      ( ( ( ord_max_nat @ A @ B )
        = zero_zero_nat )
      = ( ( A = zero_zero_nat )
        & ( B = zero_zero_nat ) ) ) )).

% max_nat.eq_neutr_iff
thf(fact_315_zero__less__diff,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( minus_minus_nat @ N @ M ) )
      = ( ord_less_nat @ M @ N ) ) )).

% zero_less_diff
thf(fact_316_diff__is__0__eq_H,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat ) ) )).

% diff_is_0_eq'
thf(fact_317_diff__is__0__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ N )
        = zero_zero_nat )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% diff_is_0_eq
thf(fact_318_eq__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ( minus_minus_nat @ M @ K )
            = ( minus_minus_nat @ N @ K ) )
          = ( M = N ) ) ) ) )).

% eq_diff_iff
thf(fact_319_le__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( ord_less_eq_nat @ M @ N ) ) ) ) )).

% le_diff_iff
thf(fact_320_diff__commute,axiom,(
    ! [I4: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I4 @ J ) @ K )
      = ( minus_minus_nat @ ( minus_minus_nat @ I4 @ K ) @ J ) ) )).

% diff_commute
thf(fact_321_Nat_Odiff__diff__eq,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( minus_minus_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( minus_minus_nat @ M @ N ) ) ) ) )).

% Nat.diff_diff_eq
thf(fact_322_diff__le__mono,axiom,(
    ! [M: nat,N: nat,L2: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ M @ L2 ) @ ( minus_minus_nat @ N @ L2 ) ) ) )).

% diff_le_mono
thf(fact_323_diff__le__self,axiom,(
    ! [M: nat,N: nat] :
      ( ord_less_eq_nat @ ( minus_minus_nat @ M @ N ) @ M ) )).

% diff_le_self
thf(fact_324_le__diff__iff_H,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ C )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ C @ A ) @ ( minus_minus_nat @ C @ B ) )
          = ( ord_less_eq_nat @ B @ A ) ) ) ) )).

% le_diff_iff'
thf(fact_325_diff__le__mono2,axiom,(
    ! [M: nat,N: nat,L2: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ L2 @ N ) @ ( minus_minus_nat @ L2 @ M ) ) ) )).

% diff_le_mono2
thf(fact_326_less__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ord_less_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( ord_less_nat @ M @ N ) ) ) ) )).

% less_diff_iff
thf(fact_327_diff__less__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ A )
       => ( ord_less_nat @ ( minus_minus_nat @ A @ C ) @ ( minus_minus_nat @ B @ C ) ) ) ) )).

% diff_less_mono
thf(fact_328_diff__less__mono2,axiom,(
    ! [M: nat,N: nat,L2: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ( ord_less_nat @ M @ L2 )
       => ( ord_less_nat @ ( minus_minus_nat @ L2 @ N ) @ ( minus_minus_nat @ L2 @ M ) ) ) ) )).

% diff_less_mono2
thf(fact_329_less__imp__diff__less,axiom,(
    ! [J: nat,K: nat,N: nat] :
      ( ( ord_less_nat @ J @ K )
     => ( ord_less_nat @ ( minus_minus_nat @ J @ N ) @ K ) ) )).

% less_imp_diff_less
thf(fact_330_less__mono__imp__le__mono,axiom,(
    ! [F2: nat > nat,I4: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_nat @ I2 @ J2 )
         => ( ord_less_nat @ ( F2 @ I2 ) @ ( F2 @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I4 @ J )
       => ( ord_less_eq_nat @ ( F2 @ I4 ) @ ( F2 @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_331_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_332_Nat_Oex__has__greatest__nat,axiom,(
    ! [P4: nat > $o,K: nat,B: nat] :
      ( ( P4 @ K )
     => ( ! [Y5: nat] :
            ( ( P4 @ Y5 )
           => ( ord_less_eq_nat @ Y5 @ B ) )
       => ? [X3: nat] :
            ( ( P4 @ X3 )
            & ! [Y: nat] :
                ( ( P4 @ Y )
               => ( ord_less_eq_nat @ Y @ X3 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_333_linorder__neqE__nat,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
     => ( ~ ( ord_less_nat @ X @ Y2 )
       => ( ord_less_nat @ Y2 @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_334_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_335_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M2: nat,N2: nat] :
          ( ( ord_less_nat @ M2 @ N2 )
          | ( M2 = N2 ) ) ) )).

% le_eq_less_or_eq
thf(fact_336_infinite__descent,axiom,(
    ! [P4: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ~ ( P4 @ N3 )
         => ? [M3: nat] :
              ( ( ord_less_nat @ M3 @ N3 )
              & ~ ( P4 @ M3 ) ) )
     => ( P4 @ N ) ) )).

% infinite_descent
thf(fact_337_nat__less__induct,axiom,(
    ! [P4: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M3: nat] :
              ( ( ord_less_nat @ M3 @ N3 )
             => ( P4 @ M3 ) )
         => ( P4 @ N3 ) )
     => ( P4 @ N ) ) )).

% nat_less_induct
thf(fact_338_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_339_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_340_less__not__refl3,axiom,(
    ! [S3: nat,T: nat] :
      ( ( ord_less_nat @ S3 @ T )
     => ( S3 != T ) ) )).

% less_not_refl3
thf(fact_341_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_342_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_343_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_344_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_345_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M2: nat,N2: nat] :
          ( ( ord_less_eq_nat @ M2 @ N2 )
          & ( M2 != N2 ) ) ) )).

% nat_less_le
thf(fact_346_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_347_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_348_le__trans,axiom,(
    ! [I4: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I4 @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I4 @ K ) ) ) )).

% le_trans
thf(fact_349_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_350_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI

% Helper facts (5)
thf(help_If_2_1_If_001t__Nat__Onat_T,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( if_nat @ $false @ X @ Y2 )
      = Y2 ) )).

thf(help_If_1_1_If_001t__Nat__Onat_T,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( if_nat @ $true @ X @ Y2 )
      = X ) )).

thf(help_If_3_1_If_001t__Real__Oreal_T,axiom,(
    ! [P4: $o] :
      ( ( P4 = $true )
      | ( P4 = $false ) ) )).

thf(help_If_2_1_If_001t__Real__Oreal_T,axiom,(
    ! [X: real,Y2: real] :
      ( ( if_real @ $false @ X @ Y2 )
      = Y2 ) )).

thf(help_If_1_1_If_001t__Real__Oreal_T,axiom,(
    ! [X: real,Y2: real] :
      ( ( if_real @ $true @ X @ Y2 )
      = X ) )).

% Conjectures (1)
thf(conj_0,conjecture,(
    genClo1297122271Clocks @ q @ p @ i )).

%------------------------------------------------------------------------------
