thf(mworld,type,
    mworld: $tType ).

thf(mrel_type,type,
    mrel: mworld > mworld > $o ).

thf(mactual_type,type,
    mactual: mworld ).

thf(mlocal_type,type,
    mlocal: ( mworld > $o ) > $o ).

thf(mlocal_def,definition,
    ( mlocal
    = ( ^ [Phi: mworld > $o] : ( Phi @ mactual ) ) ) ).

thf(mnot_type,type,
    mnot: ( mworld > $o ) > mworld > $o ).

thf(mand_type,type,
    mand: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mor_type,type,
    mor: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mimplies_type,type,
    mimplies: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mequiv_type,type,
    mequiv: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mnot_def,definition,
    ( mnot
    = ( ^ [A: mworld > $o,W: mworld] :
          ~ ( A @ W ) ) ) ).

thf(mand_def,definition,
    ( mand
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          & ( B @ W ) ) ) ) ).

thf(mor_def,definition,
    ( mor
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          | ( B @ W ) ) ) ) ).

thf(mimplies_def,definition,
    ( mimplies
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
         => ( B @ W ) ) ) ) ).

thf(mequiv_def,definition,
    ( mequiv
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
        <=> ( B @ W ) ) ) ) ).

thf(mbox_type,type,
    mbox: ( mworld > $o ) > mworld > $o ).

thf(mbox_def,definition,
    ( mbox
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ! [V: mworld] :
          ( ( mrel @ W @ V )
         => ( Phi @ V ) ) ) ) ).

thf(mdia_type,type,
    mdia: ( mworld > $o ) > mworld > $o ).

thf(mdia_def,definition,
    ( mdia
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ? [V: mworld] :
          ( ( mrel @ W @ V )
          & ( Phi @ V ) ) ) ) ).

thf(eiw_di_type,type,
    eiw_di: $i > mworld > $o ).

thf(mforall_di_type,type,
    mforall_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mforall_di_def,definition,
    ( mforall_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ! [X: $i] :
          ( ( eiw_di @ X @ W )
         => ( A @ X @ W ) ) ) ) ).

thf(mexists_di_type,type,
    mexists_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mexists_di_def,definition,
    ( mexists_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ? [X: $i] :
          ( ( eiw_di @ X @ W )
          & ( A @ X @ W ) ) ) ) ).

thf(intersect_decl,type,
    intersect: $i > $i > mworld > $o ).

thf(member_decl,type,
    member: $i > $i > mworld > $o ).

thf(mrel_reflexive,axiom,
    ! [W: mworld] : ( mrel @ W @ W ) ).

thf(intersect_defn,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [B: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [C: $i] :
                  ( mand
                  @ ( mbox
                    @ ( mimplies @ ( mbox @ ( intersect @ B @ C ) )
                      @ ( mexists_di
                        @ ^ [D: $i] : ( mand @ ( mbox @ ( member @ D @ B ) ) @ ( mbox @ ( member @ D @ C ) ) ) ) ) )
                  @ ( mbox
                    @ ( mimplies
                      @ ( mexists_di
                        @ ^ [D: $i] : ( mand @ ( mbox @ ( member @ D @ B ) ) @ ( mbox @ ( member @ D @ C ) ) ) )
                      @ ( mbox @ ( intersect @ B @ C ) ) ) ) ) ) ) ) ) ) ).

thf(eiw_di_cumul,axiom,
    ! [W: mworld,V: mworld,X: $i] :
      ( ( ( mrel @ W @ V )
        & ( eiw_di @ X @ W ) )
     => ( eiw_di @ X @ V ) ) ).

thf(symmetry_of_intersect,axiom,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [B: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [C: $i] : ( mbox @ ( mimplies @ ( mbox @ ( intersect @ B @ C ) ) @ ( mbox @ ( intersect @ C @ B ) ) ) ) ) ) ) ) ) ).

thf(mrel_euclidean,axiom,
    ! [W: mworld,V: mworld,U: mworld] :
      ( ( mrel @ U @ V )
     <= ( ( mrel @ W @ V )
        & ( mrel @ W @ U ) ) ) ).

thf(prove_th13,conjecture,
    ( mlocal
    @ ( mbox
      @ ( mforall_di
        @ ^ [B: $i] :
            ( mbox
            @ ( mforall_di
              @ ^ [C: $i] :
                  ( mbox
                  @ ( mforall_di
                    @ ^ [D: $i] : ( mbox @ ( mimplies @ ( mand @ ( mbox @ ( member @ B @ C ) ) @ ( mbox @ ( member @ B @ D ) ) ) @ ( mbox @ ( intersect @ C @ D ) ) ) ) ) ) ) ) ) ) ) ).

thf(eiw_di_nonempty,axiom,
    ! [W: mworld] :
    ? [X: $i] : ( eiw_di @ X @ W ) ).

