thf(mworld,type,
    mworld: $tType ).

thf(mrel_type,type,
    mrel: mworld > mworld > $o ).

thf(mactual_type,type,
    mactual: mworld ).

thf(mlocal_type,type,
    mlocal: ( mworld > $o ) > $o ).

thf(mlocal_def,definition,
    ( mlocal
    = ( ^ [Phi: mworld > $o] : ( Phi @ mactual ) ) ) ).

thf(mnot_type,type,
    mnot: ( mworld > $o ) > mworld > $o ).

thf(mand_type,type,
    mand: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mor_type,type,
    mor: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mimplies_type,type,
    mimplies: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mequiv_type,type,
    mequiv: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mnot_def,definition,
    ( mnot
    = ( ^ [A: mworld > $o,W: mworld] :
          ~ ( A @ W ) ) ) ).

thf(mand_def,definition,
    ( mand
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          & ( B @ W ) ) ) ) ).

thf(mor_def,definition,
    ( mor
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          | ( B @ W ) ) ) ) ).

thf(mimplies_def,definition,
    ( mimplies
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
         => ( B @ W ) ) ) ) ).

thf(mequiv_def,definition,
    ( mequiv
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
        <=> ( B @ W ) ) ) ) ).

thf(mbox_type,type,
    mbox: ( mworld > $o ) > mworld > $o ).

thf(mbox_def,definition,
    ( mbox
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ! [V: mworld] :
          ( ( mrel @ W @ V )
         => ( Phi @ V ) ) ) ) ).

thf(mdia_type,type,
    mdia: ( mworld > $o ) > mworld > $o ).

thf(mdia_def,definition,
    ( mdia
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ? [V: mworld] :
          ( ( mrel @ W @ V )
          & ( Phi @ V ) ) ) ) ).

thf(mforall_di_type,type,
    mforall_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mforall_di_def,definition,
    ( mforall_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ! [X: $i] : ( A @ X @ W ) ) ) ).

thf(mexists_di_type,type,
    mexists_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mexists_di_def,definition,
    ( mexists_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ? [X: $i] : ( A @ X @ W ) ) ) ).

thf(qmltpeq_decl,type,
    qmltpeq: $i > $i > mworld > $o ).

thf(member_decl,type,
    member: $i > $i > mworld > $o ).

thf(subset_decl,type,
    subset: $i > $i > mworld > $o ).

thf(union_decl,type,
    union: $i > $i > $i ).

thf(union_defn,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [B: $i] :
          ( mforall_di
          @ ^ [C: $i] :
              ( mforall_di
              @ ^ [D: $i] : ( mequiv @ ( member @ D @ ( union @ B @ C ) ) @ ( mor @ ( member @ D @ B ) @ ( member @ D @ C ) ) ) ) ) ) ) ).

thf(subset_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( subset @ A @ C ) ) @ ( subset @ B @ C ) ) ) ) ) ) ).

thf(mrel_serial,axiom,
    ! [W: mworld] :
    ? [V: mworld] : ( mrel @ W @ V ) ).

thf(reflexivity,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] : ( qmltpeq @ X @ X ) ) ) ).

thf(member_substitution_2,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( member @ C @ A ) ) @ ( member @ C @ B ) ) ) ) ) ) ).

thf(reflexivity_of_subset,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [B: $i] : ( subset @ B @ B ) ) ) ).

thf(subset_union,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [B: $i] :
          ( mforall_di
          @ ^ [C: $i] : ( mimplies @ ( subset @ B @ C ) @ ( qmltpeq @ ( union @ B @ C ) @ C ) ) ) ) ) ).

thf(equal_defn,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [B: $i] :
          ( mforall_di
          @ ^ [C: $i] : ( mequiv @ ( qmltpeq @ B @ C ) @ ( mand @ ( subset @ B @ C ) @ ( subset @ C @ B ) ) ) ) ) ) ).

thf(commutativity_of_union,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [B: $i] :
          ( mforall_di
          @ ^ [C: $i] : ( qmltpeq @ ( union @ B @ C ) @ ( union @ C @ B ) ) ) ) ) ).

thf(subset_defn,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [B: $i] :
          ( mforall_di
          @ ^ [C: $i] :
              ( mequiv @ ( subset @ B @ C )
              @ ( mforall_di
                @ ^ [D: $i] : ( mimplies @ ( member @ D @ B ) @ ( member @ D @ C ) ) ) ) ) ) ) ).

thf(symmetry,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] :
          ( mforall_di
          @ ^ [Y: $i] : ( mimplies @ ( qmltpeq @ X @ Y ) @ ( qmltpeq @ Y @ X ) ) ) ) ) ).

thf(union_substitution_2,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( qmltpeq @ A @ B ) @ ( qmltpeq @ ( union @ C @ A ) @ ( union @ C @ B ) ) ) ) ) ) ) ).

thf(transitivity,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] :
          ( mforall_di
          @ ^ [Y: $i] :
              ( mforall_di
              @ ^ [Z: $i] : ( mimplies @ ( mand @ ( qmltpeq @ X @ Y ) @ ( qmltpeq @ Y @ Z ) ) @ ( qmltpeq @ X @ Z ) ) ) ) ) ) ).

thf(equal_member_defn,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [B: $i] :
          ( mforall_di
          @ ^ [C: $i] :
              ( mequiv @ ( qmltpeq @ B @ C )
              @ ( mforall_di
                @ ^ [D: $i] : ( mequiv @ ( member @ D @ B ) @ ( member @ D @ C ) ) ) ) ) ) ) ).

thf(union_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( qmltpeq @ A @ B ) @ ( qmltpeq @ ( union @ A @ C ) @ ( union @ B @ C ) ) ) ) ) ) ) ).

thf(subset_substitution_2,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( subset @ C @ A ) ) @ ( subset @ C @ B ) ) ) ) ) ) ).

thf(member_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( member @ A @ C ) ) @ ( member @ B @ C ) ) ) ) ) ) ).

thf(prove_idempotency_of_union,conjecture,
    ( mlocal
    @ ( mforall_di
      @ ^ [B: $i] : ( qmltpeq @ ( union @ B @ B ) @ B ) ) ) ).

