thf(mworld,type,
    mworld: $tType ).

thf(mrel_type,type,
    mrel: mworld > mworld > $o ).

thf(mactual_type,type,
    mactual: mworld ).

thf(mlocal_type,type,
    mlocal: ( mworld > $o ) > $o ).

thf(mlocal_def,definition,
    ( mlocal
    = ( ^ [Phi: mworld > $o] : ( Phi @ mactual ) ) ) ).

thf(mnot_type,type,
    mnot: ( mworld > $o ) > mworld > $o ).

thf(mand_type,type,
    mand: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mor_type,type,
    mor: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mimplies_type,type,
    mimplies: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mequiv_type,type,
    mequiv: ( mworld > $o ) > ( mworld > $o ) > mworld > $o ).

thf(mnot_def,definition,
    ( mnot
    = ( ^ [A: mworld > $o,W: mworld] :
          ~ ( A @ W ) ) ) ).

thf(mand_def,definition,
    ( mand
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          & ( B @ W ) ) ) ) ).

thf(mor_def,definition,
    ( mor
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
          | ( B @ W ) ) ) ) ).

thf(mimplies_def,definition,
    ( mimplies
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
         => ( B @ W ) ) ) ) ).

thf(mequiv_def,definition,
    ( mequiv
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
        <=> ( B @ W ) ) ) ) ).

thf(mbox_type,type,
    mbox: ( mworld > $o ) > mworld > $o ).

thf(mbox_def,definition,
    ( mbox
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ! [V: mworld] :
          ( ( mrel @ W @ V )
         => ( Phi @ V ) ) ) ) ).

thf(mdia_type,type,
    mdia: ( mworld > $o ) > mworld > $o ).

thf(mdia_def,definition,
    ( mdia
    = ( ^ [Phi: mworld > $o,W: mworld] :
        ? [V: mworld] :
          ( ( mrel @ W @ V )
          & ( Phi @ V ) ) ) ) ).

thf(mforall_di_type,type,
    mforall_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mforall_di_def,definition,
    ( mforall_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ! [X: $i] : ( A @ X @ W ) ) ) ).

thf(mexists_di_type,type,
    mexists_di: ( $i > mworld > $o ) > mworld > $o ).

thf(mexists_di_def,definition,
    ( mexists_di
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ? [X: $i] : ( A @ X @ W ) ) ) ).

thf(empty_set_decl,type,
    empty_set: $i ).

thf(qmltpeq_decl,type,
    qmltpeq: $i > $i > mworld > $o ).

thf(equal_set_decl,type,
    equal_set: $i > $i > mworld > $o ).

thf(member_decl,type,
    member: $i > $i > mworld > $o ).

thf(subset_decl,type,
    subset: $i > $i > mworld > $o ).

thf(singleton_decl,type,
    singleton: $i > $i ).

thf(product_decl,type,
    product: $i > $i ).

thf(unordered_pair_decl,type,
    unordered_pair: $i > $i > $i ).

thf(intersection_decl,type,
    intersection: $i > $i > $i ).

thf(difference_decl,type,
    difference: $i > $i > $i ).

thf(sum_decl,type,
    sum: $i > $i ).

thf(union_decl,type,
    union: $i > $i > $i ).

thf(power_set_decl,type,
    power_set: $i > $i ).

thf(intersection_substitution_2,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( qmltpeq @ A @ B ) @ ( qmltpeq @ ( intersection @ C @ A ) @ ( intersection @ C @ B ) ) ) ) ) ) ) ).

thf(symmetry,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] :
          ( mforall_di
          @ ^ [Y: $i] : ( mimplies @ ( qmltpeq @ X @ Y ) @ ( qmltpeq @ Y @ X ) ) ) ) ) ).

thf(singleton_0,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] :
          ( mforall_di
          @ ^ [A: $i] : ( mequiv @ ( member @ X @ ( singleton @ A ) ) @ ( qmltpeq @ X @ A ) ) ) ) ) ).

thf(subset_substitution_2,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( subset @ C @ A ) ) @ ( subset @ C @ B ) ) ) ) ) ) ).

thf(transitivity,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] :
          ( mforall_di
          @ ^ [Y: $i] :
              ( mforall_di
              @ ^ [Z: $i] : ( mimplies @ ( mand @ ( qmltpeq @ X @ Y ) @ ( qmltpeq @ Y @ Z ) ) @ ( qmltpeq @ X @ Z ) ) ) ) ) ) ).

thf(union_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( qmltpeq @ A @ B ) @ ( qmltpeq @ ( union @ A @ C ) @ ( union @ B @ C ) ) ) ) ) ) ) ).

thf(sum_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( qmltpeq @ A @ B ) @ ( qmltpeq @ ( sum @ A ) @ ( sum @ B ) ) ) ) ) ) ).

thf(sum_0,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] :
          ( mforall_di
          @ ^ [A: $i] :
              ( mequiv @ ( member @ X @ ( sum @ A ) )
              @ ( mexists_di
                @ ^ [Y: $i] : ( mand @ ( member @ Y @ A ) @ ( member @ X @ Y ) ) ) ) ) ) ) ).

thf(empty_set_0,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] : ( mnot @ ( member @ X @ empty_set ) ) ) ) ).

thf(mrel_reflexive,axiom,
    ! [W: mworld] : ( mrel @ W @ W ) ).

thf(power_set_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( qmltpeq @ A @ B ) @ ( qmltpeq @ ( power_set @ A ) @ ( power_set @ B ) ) ) ) ) ) ).

thf(unordered_pair_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( qmltpeq @ A @ B ) @ ( qmltpeq @ ( unordered_pair @ A @ C ) @ ( unordered_pair @ B @ C ) ) ) ) ) ) ) ).

thf(difference_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( qmltpeq @ A @ B ) @ ( qmltpeq @ ( difference @ A @ C ) @ ( difference @ B @ C ) ) ) ) ) ) ) ).

thf(equal_set_0,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mequiv @ ( equal_set @ A @ B ) @ ( mand @ ( subset @ A @ B ) @ ( subset @ B @ A ) ) ) ) ) ) ).

thf(intersection_0,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] :
          ( mforall_di
          @ ^ [A: $i] :
              ( mforall_di
              @ ^ [B: $i] : ( mequiv @ ( member @ X @ ( intersection @ A @ B ) ) @ ( mand @ ( member @ X @ A ) @ ( member @ X @ B ) ) ) ) ) ) ) ).

thf(union_0,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] :
          ( mforall_di
          @ ^ [A: $i] :
              ( mforall_di
              @ ^ [B: $i] : ( mequiv @ ( member @ X @ ( union @ A @ B ) ) @ ( mor @ ( member @ X @ A ) @ ( member @ X @ B ) ) ) ) ) ) ) ).

thf(equal_set_substitution_2,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( equal_set @ C @ A ) ) @ ( equal_set @ C @ B ) ) ) ) ) ) ).

thf(reflexivity,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] : ( qmltpeq @ X @ X ) ) ) ).

thf(singleton_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( qmltpeq @ A @ B ) @ ( qmltpeq @ ( singleton @ A ) @ ( singleton @ B ) ) ) ) ) ) ).

thf(product_0,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] :
          ( mforall_di
          @ ^ [A: $i] :
              ( mequiv @ ( member @ X @ ( product @ A ) )
              @ ( mforall_di
                @ ^ [Y: $i] : ( mimplies @ ( member @ Y @ A ) @ ( member @ X @ Y ) ) ) ) ) ) ) ).

thf(member_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( member @ A @ C ) ) @ ( member @ B @ C ) ) ) ) ) ) ).

thf(difference_0,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [B: $i] :
          ( mforall_di
          @ ^ [A: $i] :
              ( mforall_di
              @ ^ [E: $i] : ( mequiv @ ( member @ B @ ( difference @ E @ A ) ) @ ( mand @ ( member @ B @ E ) @ ( mnot @ ( member @ B @ A ) ) ) ) ) ) ) ) ).

thf(thI06,conjecture,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( equal_set @ ( intersection @ A @ B ) @ ( intersection @ B @ A ) ) ) ) ) ).

thf(product_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] : ( mimplies @ ( qmltpeq @ A @ B ) @ ( qmltpeq @ ( product @ A ) @ ( product @ B ) ) ) ) ) ) ).

thf(unordered_pair_0,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] :
          ( mforall_di
          @ ^ [A: $i] :
              ( mforall_di
              @ ^ [B: $i] : ( mequiv @ ( member @ X @ ( unordered_pair @ A @ B ) ) @ ( mor @ ( qmltpeq @ X @ A ) @ ( qmltpeq @ X @ B ) ) ) ) ) ) ) ).

thf(difference_substitution_2,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( qmltpeq @ A @ B ) @ ( qmltpeq @ ( difference @ C @ A ) @ ( difference @ C @ B ) ) ) ) ) ) ) ).

thf(power_set_0,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [X: $i] :
          ( mforall_di
          @ ^ [A: $i] : ( mequiv @ ( member @ X @ ( power_set @ A ) ) @ ( subset @ X @ A ) ) ) ) ) ).

thf(unordered_pair_substitution_2,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( qmltpeq @ A @ B ) @ ( qmltpeq @ ( unordered_pair @ C @ A ) @ ( unordered_pair @ C @ B ) ) ) ) ) ) ) ).

thf(subset_0,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mequiv @ ( subset @ A @ B )
              @ ( mforall_di
                @ ^ [X: $i] : ( mimplies @ ( member @ X @ A ) @ ( member @ X @ B ) ) ) ) ) ) ) ).

thf(equal_set_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( equal_set @ A @ C ) ) @ ( equal_set @ B @ C ) ) ) ) ) ) ).

thf(intersection_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( qmltpeq @ A @ B ) @ ( qmltpeq @ ( intersection @ A @ C ) @ ( intersection @ B @ C ) ) ) ) ) ) ) ).

thf(union_substitution_2,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( qmltpeq @ A @ B ) @ ( qmltpeq @ ( union @ C @ A ) @ ( union @ C @ B ) ) ) ) ) ) ) ).

thf(member_substitution_2,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( member @ C @ A ) ) @ ( member @ C @ B ) ) ) ) ) ) ).

thf(mrel_transitive,axiom,
    ! [W: mworld,V: mworld,U: mworld] :
      ( ( mrel @ W @ U )
     <= ( ( mrel @ W @ V )
        & ( mrel @ V @ U ) ) ) ).

thf(subset_substitution_1,axiom,
    ( mlocal
    @ ( mforall_di
      @ ^ [A: $i] :
          ( mforall_di
          @ ^ [B: $i] :
              ( mforall_di
              @ ^ [C: $i] : ( mimplies @ ( mand @ ( qmltpeq @ A @ B ) @ ( subset @ A @ C ) ) @ ( subset @ B @ C ) ) ) ) ) ) ).

