tff(exp,type,
    exp: $real > $real ).

tff(log,type,
    log: $real > $real ).

tff(log2,type,
    log2: $real > $real ).

tff(log10,type,
    log10: $real > $real ).

tff(pow,type,
    pow: ( $real * $real ) > $real ).

tff(sqr,type,
    sqr: $real > $real ).

tff(sqrt,type,
    sqrt: $real > $real ).

tff(sqr_def,axiom,
    ! [X: $real] : ( sqr(X) = $product(X,X) ) ).

tff(log_exp,axiom,
    ! [X: $real] : ( log(exp(X)) = X ) ).

tff(exp_zero,axiom,
    exp(0.0) = 1.0 ).

tff(pow_x_zero,axiom,
    ! [X: $real] :
      ( ( pow(X,0.0) = 1.0 )
     <= $less(0.0,X) ) ).

tff(square_sqrt,axiom,
    ! [X: $real] :
      ( ( sqrt($product(X,X)) = X )
     <= $lesseq(0.0,X) ) ).

tff(pow_one_y,axiom,
    ! [Y: $real] : ( pow(1.0,Y) = 1.0 ) ).

tff(sqrt_mul,axiom,
    ! [X: $real,Y: $real] :
      ( ( sqrt($product(X,Y)) = $product(sqrt(X),sqrt(Y)) )
     <= ( $lesseq(0.0,X)
        & $lesseq(0.0,Y) ) ) ).

tff(pow_mult,axiom,
    ! [X: $real,Y: $real,Z: $real] :
      ( ( pow(pow(X,Y),Z) = pow(X,$product(Y,Z)) )
     <= $less(0.0,X) ) ).

tff(log10_def,axiom,
    ! [X: $real] : ( log10(X) = $quotient(log(X),log(10.0)) ) ).

tff(exp_log,axiom,
    ! [X: $real] :
      ( $less(0.0,X)
     => ( exp(log(X)) = X ) ) ).

tff(pow_2_21,conjecture,
    pow(2.0,2.0) = 4.0 ).

tff(pow_half,axiom,
    ! [X: $real] :
      ( ( pow(X,0.5) = sqrt(X) )
     <= $less(0.0,X) ) ).

tff(sqrt_le,axiom,
    ! [X: $real,Y: $real] :
      ( $lesseq(sqrt(X),sqrt(Y))
     <= ( $lesseq(X,Y)
        & $lesseq(0.0,X) ) ) ).

tff(sqrt_square,axiom,
    ! [X: $real] :
      ( ( sqr(sqrt(X)) = X )
     <= $lesseq(0.0,X) ) ).

tff(exp_sum,axiom,
    ! [X: $real,Y: $real] : ( exp($sum(X,Y)) = $product(exp(X),exp(Y)) ) ).

tff(pow_x_two,axiom,
    ! [X: $real] :
      ( $less(0.0,X)
     => ( pow(X,2.0) = sqr(X) ) ) ).

tff(log_mul,axiom,
    ! [X: $real,Y: $real] :
      ( ( $less(0.0,Y)
        & $less(0.0,X) )
     => ( log($product(X,Y)) = $sum(log(X),log(Y)) ) ) ).

tff(pow_plus,axiom,
    ! [X: $real,Y: $real,Z: $real] :
      ( $less(0.0,Z)
     => ( pow(Z,$sum(X,Y)) = $product(pow(Z,X),pow(Z,Y)) ) ) ).

tff(pow_pos,axiom,
    ! [X: $real,Y: $real] :
      ( $less(0.0,pow(X,Y))
     <= $less(0.0,X) ) ).

tff(log_one,axiom,
    log(1.0) = 0.0 ).

tff(pow_x_one,axiom,
    ! [X: $real] :
      ( ( pow(X,1.0) = X )
     <= $less(0.0,X) ) ).

tff(sqrt_positive,axiom,
    ! [X: $real] :
      ( $lesseq(0.0,sqrt(X))
     <= $lesseq(0.0,X) ) ).

tff(pow_def,axiom,
    ! [X: $real,Y: $real] :
      ( ( pow(X,Y) = exp($product(Y,log(X))) )
     <= $less(0.0,X) ) ).

tff(log2_def,axiom,
    ! [X: $real] : ( log2(X) = $quotient(log(X),log(2.0)) ) ).

