tff(set_type,type,
    set: $tType ).

tff(element_type,type,
    element: $tType ).

tff(empty_set_type,type,
    empty_set: set ).

tff(singleton_type,type,
    singleton: element > set ).

tff(member_type,type,
    member: ( element * set ) > $o ).

tff(subset_type,type,
    subset: ( set * set ) > $o ).

tff(intersection_type,type,
    intersection: ( set * set ) > set ).

tff(union_type,type,
    union: ( set * set ) > set ).

tff(difference_type,type,
    difference: ( set * set ) > set ).

tff(complement_type,type,
    complement: set > set ).

tff(cardinality_type,type,
    cardinality: set > $int ).

tff(singleton,axiom,
    ! [X: element,A: element] :
      ( ( X = A )
    <=> member(X,singleton(A)) ) ).

tff(union,axiom,
    ! [X: element,A: set,B: set] :
      ( ( member(X,B)
        | member(X,A) )
    <=> member(X,union(A,B)) ) ).

tff(intersection,axiom,
    ! [X: element,A: set,B: set] :
      ( ( member(X,A)
        & member(X,B) )
    <=> member(X,intersection(A,B)) ) ).

tff(cardinality_empty_set,axiom,
    ! [S: set] :
      ( ( cardinality(S) = 0 )
    <=> ( S = empty_set ) ) ).

tff(subset,axiom,
    ! [A: set,B: set] :
      ( subset(A,B)
    <=> ! [X: element] :
          ( member(X,A)
         => member(X,B) ) ) ).

tff(cardinality_intersection_2,axiom,
    ! [X: element,S: set] :
      ( ( intersection(singleton(X),S) = empty_set )
    <=> ( cardinality(union(singleton(X),S)) = $sum(cardinality(S),1) ) ) ).

tff(difference,axiom,
    ! [B: element,A: set,E: set] :
      ( ( ~ member(B,A)
        & member(B,E) )
    <=> member(B,difference(E,A)) ) ).

tff(complement,axiom,
    ! [X: element,S: set] :
      ( member(X,S)
    <=> ~ member(X,complement(S)) ) ).

tff(cardinality_union,axiom,
    ! [A: set,B: set] :
      ( ( cardinality(union(A,B)) = $sum(cardinality(A),cardinality(B)) )
    <=> ( intersection(A,B) = empty_set ) ) ).

tff(vc2,conjecture,
    ! [X: element,C: set,Size: $int] :
      ( ( $sum(Size,1) = cardinality(union(singleton(X),C)) )
     <= ( ( Size = cardinality(C) )
        & ~ member(X,C) ) ) ).

tff(cardinality_intersection_3,axiom,
    ! [S: set,T: set] :
      ( ( intersection(S,T) = empty_set )
    <=> ( cardinality(intersection(S,T)) = 0 ) ) ).

tff(cardinality_intersection_1,axiom,
    ! [X: element,S: set] :
      ( ( intersection(singleton(X),S) = singleton(X) )
    <=> ( cardinality(union(singleton(X),S)) = cardinality(S) ) ) ).

tff(empty_set,axiom,
    ! [S: set] :
      ( ( S = empty_set )
    <=> ! [X: element] : ~ member(X,S) ) ).

