tff(set_type,type,
    set: $tType ).

tff(element_type,type,
    element: $tType ).

tff(empty_set_type,type,
    empty_set: set ).

tff(singleton_type,type,
    singleton: element > set ).

tff(member_type,type,
    member: ( element * set ) > $o ).

tff(subset_type,type,
    subset: ( set * set ) > $o ).

tff(intersection_type,type,
    intersection: ( set * set ) > set ).

tff(union_type,type,
    union: ( set * set ) > set ).

tff(difference_type,type,
    difference: ( set * set ) > set ).

tff(complement_type,type,
    complement: set > set ).

tff(cardinality_type,type,
    cardinality: set > $int ).

tff(empty_set,axiom,
    ! [S: set] :
      ( ( S = empty_set )
    <=> ! [X: element] : ~ member(X,S) ) ).

tff(subset,axiom,
    ! [A: set,B: set] :
      ( subset(A,B)
    <=> ! [X: element] :
          ( member(X,B)
         <= member(X,A) ) ) ).

tff(cardinality_empty_set,axiom,
    ! [S: set] :
      ( ( S = empty_set )
    <=> ( cardinality(S) = 0 ) ) ).

tff(cardinality_intersection_3,axiom,
    ! [S: set,T: set] :
      ( ( intersection(S,T) = empty_set )
    <=> ( cardinality(intersection(S,T)) = 0 ) ) ).

tff(vc5,conjecture,
    ! [C: set,A0: set,A1: set,A2: set,X1: element,X2: element,X3: element] :
      ( ( subset(union(A0,singleton(X1)),A1)
        & ~ member(X2,A1)
        & subset(union(A1,singleton(X2)),A2)
        & ~ member(X3,A2)
        & ~ member(X1,A0)
        & subset(C,A0) )
     => ( cardinality(union(union(union(C,singleton(X1)),singleton(X2)),singleton(X3))) = $sum(cardinality(C),3) ) ) ).

tff(cardinality_union,axiom,
    ! [A: set,B: set] :
      ( ( cardinality(union(A,B)) = $sum(cardinality(A),cardinality(B)) )
    <=> ( intersection(A,B) = empty_set ) ) ).

tff(intersection,axiom,
    ! [X: element,A: set,B: set] :
      ( member(X,intersection(A,B))
    <=> ( member(X,B)
        & member(X,A) ) ) ).

tff(cardinality_intersection_2,axiom,
    ! [X: element,S: set] :
      ( ( cardinality(union(singleton(X),S)) = $sum(cardinality(S),1) )
    <=> ( intersection(singleton(X),S) = empty_set ) ) ).

tff(cardinality_intersection_1,axiom,
    ! [X: element,S: set] :
      ( ( intersection(singleton(X),S) = singleton(X) )
    <=> ( cardinality(union(singleton(X),S)) = cardinality(S) ) ) ).

tff(difference,axiom,
    ! [B: element,A: set,E: set] :
      ( member(B,difference(E,A))
    <=> ( ~ member(B,A)
        & member(B,E) ) ) ).

tff(singleton,axiom,
    ! [X: element,A: element] :
      ( ( X = A )
    <=> member(X,singleton(A)) ) ).

tff(complement,axiom,
    ! [X: element,S: set] :
      ( ~ member(X,complement(S))
    <=> member(X,S) ) ).

tff(union,axiom,
    ! [X: element,A: set,B: set] :
      ( member(X,union(A,B))
    <=> ( member(X,A)
        | member(X,B) ) ) ).

