tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort: ( ty * uni ) > $o ).

tff(witness,type,
    witness: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool: $tType ).

tff(bool1,type,
    bool1: ty ).

tff(true,type,
    true: bool ).

tff(false,type,
    false: bool ).

tff(match_bool,type,
    match_bool: ( ty * bool * uni * uni ) > uni ).

tff(tuple0,type,
    tuple0: $tType ).

tff(tuple01,type,
    tuple01: ty ).

tff(tuple02,type,
    tuple02: tuple0 ).

tff(qtmark,type,
    qtmark: ty ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(x2,type,
    x2: $int ).

tff(y2,type,
    y2: $int ).

tff(abs,type,
    abs: $int > $int ).

tff(best,type,
    best: ( $int * $int ) > $o ).

tff(match_bool_sort,axiom,
    ! [A: ty,X: bool,X1: uni,X2: uni] : sort(A,match_bool(A,X,X1,X2)) ).

tff(contents_def,axiom,
    ! [A: ty,U: uni] :
      ( ( contents(A,mk_ref(A,U)) = U )
     <= sort(A,U) ) ).

tff(abs_def,axiom,
    ! [X: $int] :
      ( ( ~ $lesseq(0,X)
       => ( abs(X) = $uminus(X) ) )
      & ( ( abs(X) = X )
       <= $lesseq(0,X) ) ) ).

tff(wP_parameter_bresenham,conjecture,
    ( ! [E: $int,Y: $int,X: $int] :
        ( ( best(X,Y)
         <= ( ( E = $difference($product($product(2,$sum(X,1)),y2),$product($sum($product(2,Y),1),x2)) )
            & $lesseq(E,$product(2,y2))
            & $lesseq($product(2,$difference(y2,x2)),E) ) )
       <= ( $lesseq(0,X)
          & $lesseq(X,x2) ) )
   <= $lesseq(0,x2) ) ).

tff(witness_sort,axiom,
    ! [A: ty] : sort(A,witness(A)) ).

tff(true_False,axiom,
    true != false ).

tff(abs_pos,axiom,
    ! [X: $int] : $lesseq(0,abs(X)) ).

tff(bool_inversion,axiom,
    ! [U: bool] :
      ( ( U = false )
      | ( U = true ) ) ).

tff(abs_le,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq($uminus(Y),X)
        & $lesseq(X,Y) )
    <=> $lesseq(abs(X),Y) ) ).

tff(closest,axiom,
    ! [A: $int,B: $int,C: $int] :
      ( ! [Bqt: $int] : $lesseq(abs($difference($product(A,B),C)),abs($difference($product(A,Bqt),C)))
     <= $lesseq(abs($difference($product($product(2,A),B),$product(2,C))),A) ) ).

tff(mk_ref_sort,axiom,
    ! [A: ty,X: uni] : sort(ref(A),mk_ref(A,X)) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool(A,false,Z,Z1) = Z1 )
     <= sort(A,Z1) ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool(A,true,Z,Z1) = Z )
     <= sort(A,Z) ) ).

tff(first_octant,axiom,
    ( $lesseq(y2,x2)
    & $lesseq(0,y2) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple0] : ( U = tuple02 ) ).

tff(best_def,axiom,
    ! [X: $int,Y: $int] :
      ( ! [Yqt: $int] : $lesseq(abs($difference($product(x2,Y),$product(X,y2))),abs($difference($product(x2,Yqt),$product(X,y2))))
    <=> best(X,Y) ) ).

tff(ref_inversion,axiom,
    ! [A: ty,U: uni] :
      ( ( U = mk_ref(A,contents(A,U)) )
     <= sort(ref(A),U) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq($product(X,Z),$product(Y,Z))
       <= $lesseq(0,Z) )
     <= $lesseq(X,Y) ) ).

tff(contents_sort,axiom,
    ! [A: ty,X: uni] : sort(A,contents(A,X)) ).

