tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort: ( ty * uni ) > $o ).

tff(witness,type,
    witness: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool: $tType ).

tff(bool1,type,
    bool1: ty ).

tff(true,type,
    true: bool ).

tff(false,type,
    false: bool ).

tff(match_bool,type,
    match_bool: ( ty * bool * uni * uni ) > uni ).

tff(tuple0,type,
    tuple0: $tType ).

tff(tuple01,type,
    tuple01: ty ).

tff(tuple02,type,
    tuple02: tuple0 ).

tff(qtmark,type,
    qtmark: ty ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(const,type,
    const: ( ty * ty * uni ) > uni ).

tff(array,type,
    array: ty > ty ).

tff(mk_array,type,
    mk_array: ( ty * $int * uni ) > uni ).

tff(length,type,
    length: ( ty * uni ) > $int ).

tff(elts,type,
    elts: ( ty * uni ) > uni ).

tff(get1,type,
    get1: ( ty * uni * $int ) > uni ).

tff(t2tb,type,
    t2tb: $int > uni ).

tff(tb2t,type,
    tb2t: uni > $int ).

tff(set1,type,
    set1: ( ty * uni * $int * uni ) > uni ).

tff(make,type,
    make: ( ty * $int * uni ) > uni ).

tff(array_int,type,
    array_int: $tType ).

tff(is_partition,type,
    is_partition: array_int > $o ).

tff(t2tb1,type,
    t2tb1: array_int > uni ).

tff(tb2t1,type,
    tb2t1: uni > array_int ).

tff(numofgt,type,
    numofgt: ( array_int * $int * $int ) > $o ).

tff(is_conjugate,type,
    is_conjugate: ( array_int * array_int ) > $o ).

tff(map_int_int,type,
    map_int_int: $tType ).

tff(t2tb2,type,
    t2tb2: map_int_int > uni ).

tff(tb2t2,type,
    tb2t2: uni > map_int_int ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(bool_inversion,axiom,
    ! [U: bool] :
      ( ( U = true )
      | ( U = false ) ) ).

tff(get_def,axiom,
    ! [A: ty,A1: uni,I: $int] : ( get1(A,A1,I) = get(A,int,elts(A,A1),t2tb(I)) ) ).

tff(ref_inversion,axiom,
    ! [A: ty,U: uni] :
      ( ( U = mk_ref(A,contents(A,U)) )
     <= sort(ref(A),U) ) ).

tff(elts_sort,axiom,
    ! [A: ty,X: uni] : sort(map(int,A),elts(A,X)) ).

tff(bridgeL,axiom,
    ! [I: $int] : ( tb2t(t2tb(I)) = I ) ).

tff(match_bool_sort,axiom,
    ! [A: ty,X: bool,X1: uni,X2: uni] : sort(A,match_bool(A,X,X1,X2)) ).

tff(true_False,axiom,
    true != false ).

tff(bridgeL2,axiom,
    ! [I: map_int_int] : ( tb2t2(t2tb2(I)) = I ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort(A,Z1)
     => ( match_bool(A,false,Z,Z1) = Z1 ) ) ).

tff(t2tb_sort,axiom,
    ! [X: $int] : sort(int,t2tb(X)) ).

tff(t2tb_sort1,axiom,
    ! [X: array_int] : sort(array(int),t2tb1(X)) ).

tff(array_inversion,axiom,
    ! [A: ty,U: uni] : ( U = mk_array(A,length(A,U),elts(A,U)) ) ).

tff(const_sort,axiom,
    ! [A: ty,B: ty,X: uni] : sort(map(A,B),const(B,A,X)) ).

tff(get_sort1,axiom,
    ! [A: ty,X: uni,X1: $int] : sort(A,get1(A,X,X1)) ).

tff(set_sort1,axiom,
    ! [A: ty,X: uni,X1: $int,X2: uni] : sort(array(A),set1(A,X,X1,X2)) ).

tff(select_eq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( sort(B,B1)
     => ( ( get(B,A,set(B,A,M,A1,B1),A2) = B1 )
       <= ( A1 = A2 ) ) ) ).

tff(mk_array_sort,axiom,
    ! [A: ty,X: $int,X1: uni] : sort(array(A),mk_array(A,X,X1)) ).

tff(length_def,axiom,
    ! [A: ty,U: $int,U1: uni] : ( length(A,mk_array(A,U,U1)) = U ) ).

tff(const1,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( ( get(B,A,const(B,A,B1),A1) = B1 )
     <= sort(B,B1) ) ).

tff(make_def,axiom,
    ! [A: ty,N: $int,V: uni] : ( make(A,N,V) = mk_array(A,N,const(A,int,V)) ) ).

tff(set_def,axiom,
    ! [A: ty,A1: uni,I: $int,V: uni] : ( set1(A,A1,I,V) = mk_array(A,length(A,A1),set(A,int,elts(A,A1),t2tb(I),V)) ) ).

tff(elts_def,axiom,
    ! [A: ty,U: $int,U1: uni] :
      ( ( elts(A,mk_array(A,U,U1)) = U1 )
     <= sort(map(int,A),U1) ) ).

tff(witness_sort,axiom,
    ! [A: ty] : sort(A,witness(A)) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple0] : ( U = tuple02 ) ).

tff(is_partition_def,axiom,
    ! [A: array_int] :
      ( ( is_partition(A)
       => ( $less(0,length(int,t2tb1(A)))
          & ! [I: $int,J: $int] :
              ( $lesseq(tb2t(get1(int,t2tb1(A),J)),tb2t(get1(int,t2tb1(A),I)))
             <= ( $lesseq(0,I)
                & $lesseq(I,J)
                & $less(J,length(int,t2tb1(A))) ) )
          & ( tb2t(get1(int,t2tb1(A),$difference(length(int,t2tb1(A)),1))) = 0 ) ) )
      & ( ( ( tb2t(get1(int,t2tb1(A),$difference(length(int,t2tb1(A)),1))) = 0 )
          & ! [I: $int,J: $int] :
              ( ( $lesseq(0,I)
                & $lesseq(I,J)
                & $less(J,length(int,t2tb1(A))) )
             => $lesseq(tb2t(get1(int,t2tb1(A),J)),tb2t(get1(int,t2tb1(A),I))) )
          & $less(0,length(int,t2tb1(A))) )
       => is_partition(A) ) ) ).

tff(make_sort,axiom,
    ! [A: ty,X: $int,X1: uni] : sort(array(A),make(A,X,X1)) ).

tff(contents_def,axiom,
    ! [A: ty,U: uni] :
      ( ( contents(A,mk_ref(A,U)) = U )
     <= sort(A,U) ) ).

tff(bridgeL1,axiom,
    ! [I: array_int] : ( tb2t1(t2tb1(I)) = I ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort(A,Z)
     => ( match_bool(A,true,Z,Z1) = Z ) ) ).

tff(bridgeR2,axiom,
    ! [J: uni] : ( t2tb2(tb2t2(J)) = J ) ).

tff(is_conjugate_def,axiom,
    ! [A: array_int,B: array_int] :
      ( is_conjugate(A,B)
    <=> ( ! [J: $int] :
            ( ( $less(J,length(int,t2tb1(B)))
              & $lesseq(0,J) )
           => numofgt(A,tb2t(get1(int,t2tb1(B),J)),J) )
        & $less(tb2t(get1(int,t2tb1(A),0)),length(int,t2tb1(B))) ) ) ).

tff(numofgt_def,axiom,
    ! [A: array_int,N: $int,V: $int] :
      ( ( numofgt(A,N,V)
       => ( $lesseq(0,N)
          & $less(N,length(int,t2tb1(A)))
          & $lesseq(tb2t(get1(int,t2tb1(A),N)),V)
          & ! [J: $int] :
              ( $less(V,tb2t(get1(int,t2tb1(A),J)))
             <= ( $lesseq(0,J)
                & $less(J,N) ) ) ) )
      & ( numofgt(A,N,V)
       <= ( $less(N,length(int,t2tb1(A)))
          & $lesseq(tb2t(get1(int,t2tb1(A),N)),V)
          & ! [J: $int] :
              ( ( $lesseq(0,J)
                & $less(J,N) )
             => $less(V,tb2t(get1(int,t2tb1(A),J))) )
          & $lesseq(0,N) ) ) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $lesseq(X,Y)
     => ( $lesseq($product(X,Z),$product(Y,Z))
       <= $lesseq(0,Z) ) ) ).

tff(get_sort,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort(B,get(B,A,X,X1)) ).

tff(select_neq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( sort(A,A1)
     => ( ! [B1: uni] :
            ( ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) )
           <= ( A1 != A2 ) )
       <= sort(A,A2) ) ) ).

tff(set_sort,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort(map(A,B),set(B,A,X,X1,X2)) ).

tff(contents_sort,axiom,
    ! [A: ty,X: uni] : sort(A,contents(A,X)) ).

tff(wP_parameter_conjugate,conjecture,
    ! [A: $int,A1: map_int_int] :
      ( ( is_partition(tb2t1(mk_array(int,A,t2tb2(A1))))
        & $lesseq(0,A) )
     => ( ( ( $lesseq(0,0)
            & ! [J: $int] :
                ( ( $less(J,$sum(tb2t(get(int,int,t2tb2(A1),t2tb(0))),1))
                  & $lesseq(tb2t(get(int,int,t2tb2(A1),t2tb(0))),J) )
               => numofgt(tb2t1(mk_array(int,A,t2tb2(A1))),tb2t(get(int,int,const(int,int,t2tb(0)),t2tb(J))),J) )
            & ! [Partc: $int,B: map_int_int] :
                ( ( $lesseq(0,Partc)
                  & ( ~ ( ( tb2t(get(int,int,t2tb2(A1),t2tb(Partc))) != 0 ) )
                   => ( ( tb2t(get(int,int,t2tb2(A1),t2tb(Partc))) = 0 )
                      & $lesseq(0,$sum(tb2t(get(int,int,t2tb2(A1),t2tb(0))),1))
                      & is_conjugate(tb2t1(mk_array(int,A,t2tb2(A1))),tb2t1(mk_array(int,$sum(tb2t(get(int,int,t2tb2(A1),t2tb(0))),1),t2tb2(B)))) ) )
                  & ( ( ! [Partc1: $int] :
                          ( ( $lesseq(Partc,Partc1)
                            & $less(Partc1,A)
                            & ! [J: $int] :
                                ( ( tb2t(get(int,int,t2tb2(A1),t2tb(J))) = tb2t(get(int,int,t2tb2(A1),t2tb(Partc))) )
                               <= ( $lesseq(Partc,J)
                                  & $less(J,Partc1) ) )
                            & ! [Partc2: $int] :
                                ( ( $less(Partc2,A)
                                  & ! [J: $int] :
                                      ( ( $less(J,Partc2)
                                        & $lesseq(Partc,J) )
                                     => ( tb2t(get(int,int,t2tb2(A1),t2tb(J))) = tb2t(get(int,int,t2tb2(A1),t2tb(Partc))) ) )
                                  & $lesseq(Partc,Partc2) )
                               => ( ( ! [Partc3: $int] :
                                        ( ( $less($difference(A,Partc3),$difference(A,Partc2))
                                          & $lesseq(0,$difference(A,Partc2))
                                          & ! [J: $int] :
                                              ( ( tb2t(get(int,int,t2tb2(A1),t2tb(J))) = tb2t(get(int,int,t2tb2(A1),t2tb(Partc))) )
                                             <= ( $less(J,Partc3)
                                                & $lesseq(Partc,J) ) )
                                          & $less(Partc3,A)
                                          & $lesseq(Partc,Partc3) )
                                       <= ( Partc3 = $sum(Partc2,1) ) )
                                   <= ( tb2t(get(int,int,t2tb2(A1),t2tb(Partc2))) = tb2t(get(int,int,t2tb2(A1),t2tb(Partc))) ) )
                                  & ( ( ( ( ! [J: $int] :
                                              ( ( tb2t(get(int,int,t2tb2(B),t2tb(J))) = Partc2 )
                                             <= ( $less(J,tb2t(get(int,int,t2tb2(A1),t2tb(Partc2))))
                                                & $lesseq(tb2t(get(int,int,t2tb2(A1),t2tb(Partc2))),J) ) )
                                          & ! [B1: map_int_int] :
                                              ( ! [I: $int] :
                                                  ( ( ( ! [J: $int] :
                                                          ( ( tb2t(get(int,int,t2tb2(B1),t2tb(J))) = tb2t(get(int,int,t2tb2(B),t2tb(J))) )
                                                         <= ( $less(J,$sum(tb2t(get(int,int,t2tb2(A1),t2tb(0))),1))
                                                            & $lesseq(tb2t(get(int,int,t2tb2(A1),t2tb(Partc))),J) ) )
                                                      & ! [J: $int] :
                                                          ( ( tb2t(get(int,int,t2tb2(B1),t2tb(J))) = Partc2 )
                                                         <= ( $lesseq(tb2t(get(int,int,t2tb2(A1),t2tb(Partc2))),J)
                                                            & $less(J,I) ) ) )
                                                   => ( ! [B2: map_int_int] :
                                                          ( ( ( B2 = tb2t2(set(int,int,t2tb2(B1),t2tb(I),t2tb(Partc2))) )
                                                            & $lesseq(0,$sum(tb2t(get(int,int,t2tb2(A1),t2tb(0))),1)) )
                                                         => ( ! [J: $int] :
                                                                ( ( $lesseq(tb2t(get(int,int,t2tb2(A1),t2tb(Partc))),J)
                                                                  & $less(J,$sum(tb2t(get(int,int,t2tb2(A1),t2tb(0))),1)) )
                                                               => ( tb2t(get(int,int,t2tb2(B2),t2tb(J))) = tb2t(get(int,int,t2tb2(B),t2tb(J))) ) )
                                                            & ! [J: $int] :
                                                                ( ( tb2t(get(int,int,t2tb2(B2),t2tb(J))) = Partc2 )
                                                               <= ( $lesseq(tb2t(get(int,int,t2tb2(A1),t2tb(Partc2))),J)
                                                                  & $less(J,$sum(I,1)) ) ) ) )
                                                      & $less(I,$sum(tb2t(get(int,int,t2tb2(A1),t2tb(0))),1))
                                                      & $lesseq(0,I)
                                                      & $lesseq(0,$sum(tb2t(get(int,int,t2tb2(A1),t2tb(0))),1)) ) )
                                                 <= ( $lesseq(tb2t(get(int,int,t2tb2(A1),t2tb(Partc2))),I)
                                                    & $lesseq(I,$difference(tb2t(get(int,int,t2tb2(A1),t2tb(Partc))),1)) ) )
                                              & ( ( ! [J: $int] :
                                                      ( ( $lesseq(tb2t(get(int,int,t2tb2(A1),t2tb(Partc2))),J)
                                                        & $less(J,$sum($difference(tb2t(get(int,int,t2tb2(A1),t2tb(Partc))),1),1)) )
                                                     => ( tb2t(get(int,int,t2tb2(B1),t2tb(J))) = Partc2 ) )
                                                  & ! [J: $int] :
                                                      ( ( tb2t(get(int,int,t2tb2(B1),t2tb(J))) = tb2t(get(int,int,t2tb2(B),t2tb(J))) )
                                                     <= ( $less(J,$sum(tb2t(get(int,int,t2tb2(A1),t2tb(0))),1))
                                                        & $lesseq(tb2t(get(int,int,t2tb2(A1),t2tb(Partc))),J) ) ) )
                                               => ( $lesseq(0,Partc2)
                                                  & $less($difference(A,Partc2),$difference(A,Partc))
                                                  & $lesseq(0,$difference(A,Partc))
                                                  & ! [J: $int] :
                                                      ( numofgt(tb2t1(mk_array(int,A,t2tb2(A1))),tb2t(get(int,int,t2tb2(B1),t2tb(J))),J)
                                                     <= ( $lesseq(tb2t(get(int,int,t2tb2(A1),t2tb(Partc2))),J)
                                                        & $less(J,$sum(tb2t(get(int,int,t2tb2(A1),t2tb(0))),1)) ) )
                                                  & $less(Partc2,A) ) ) ) )
                                       <= $lesseq(tb2t(get(int,int,t2tb2(A1),t2tb(Partc2))),$difference(tb2t(get(int,int,t2tb2(A1),t2tb(Partc))),1)) )
                                      & ( ( $lesseq(0,Partc2)
                                          & $less(Partc2,A)
                                          & $lesseq(0,$difference(A,Partc))
                                          & $less($difference(A,Partc2),$difference(A,Partc))
                                          & ! [J: $int] :
                                              ( ( $lesseq(tb2t(get(int,int,t2tb2(A1),t2tb(Partc2))),J)
                                                & $less(J,$sum(tb2t(get(int,int,t2tb2(A1),t2tb(0))),1)) )
                                             => numofgt(tb2t1(mk_array(int,A,t2tb2(A1))),tb2t(get(int,int,t2tb2(B),t2tb(J))),J) ) )
                                       <= $less($difference(tb2t(get(int,int,t2tb2(A1),t2tb(Partc))),1),tb2t(get(int,int,t2tb2(A1),t2tb(Partc2)))) )
                                      & $less(Partc2,A)
                                      & $lesseq(0,Partc2) )
                                   <= ( tb2t(get(int,int,t2tb2(A1),t2tb(Partc2))) != tb2t(get(int,int,t2tb2(A1),t2tb(Partc))) ) )
                                  & $less(Partc2,A)
                                  & $lesseq(0,Partc2) ) ) )
                         <= ( Partc1 = $sum(Partc,1) ) )
                      & $less(Partc,A)
                      & $lesseq(0,Partc) )
                   <= ( tb2t(get(int,int,t2tb2(A1),t2tb(Partc))) != 0 ) )
                  & $less(Partc,A) )
               <= ( $lesseq(0,Partc)
                  & $less(Partc,A)
                  & ! [J: $int] :
                      ( numofgt(tb2t1(mk_array(int,A,t2tb2(A1))),tb2t(get(int,int,t2tb2(B),t2tb(J))),J)
                     <= ( $lesseq(tb2t(get(int,int,t2tb2(A1),t2tb(Partc))),J)
                        & $less(J,$sum(tb2t(get(int,int,t2tb2(A1),t2tb(0))),1)) ) ) ) )
            & $less(0,A) )
         <= $lesseq(0,$sum(tb2t(get(int,int,t2tb2(A1),t2tb(0))),1)) )
        & $lesseq(0,$sum(tb2t(get(int,int,t2tb2(A1),t2tb(0))),1))
        & $less(0,A)
        & $lesseq(0,0) ) ) ).

tff(bridgeR1,axiom,
    ! [J: uni] : ( t2tb1(tb2t1(J)) = J ) ).

tff(mk_ref_sort,axiom,
    ! [A: ty,X: uni] : sort(ref(A),mk_ref(A,X)) ).

tff(t2tb_sort2,axiom,
    ! [X: map_int_int] : sort(map(int,int),t2tb2(X)) ).

