tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort: ( ty * uni ) > $o ).

tff(witness,type,
    witness: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool: $tType ).

tff(bool1,type,
    bool1: ty ).

tff(true,type,
    true: bool ).

tff(false,type,
    false: bool ).

tff(match_bool,type,
    match_bool: ( ty * bool * uni * uni ) > uni ).

tff(tuple0,type,
    tuple0: $tType ).

tff(tuple01,type,
    tuple01: ty ).

tff(tuple02,type,
    tuple02: tuple0 ).

tff(qtmark,type,
    qtmark: ty ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(const,type,
    const: ( ty * ty * uni ) > uni ).

tff(array,type,
    array: ty > ty ).

tff(mk_array,type,
    mk_array: ( ty * $int * uni ) > uni ).

tff(length,type,
    length: ( ty * uni ) > $int ).

tff(elts,type,
    elts: ( ty * uni ) > uni ).

tff(get1,type,
    get1: ( ty * uni * $int ) > uni ).

tff(t2tb,type,
    t2tb: $int > uni ).

tff(tb2t,type,
    tb2t: uni > $int ).

tff(set1,type,
    set1: ( ty * uni * $int * uni ) > uni ).

tff(make,type,
    make: ( ty * $int * uni ) > uni ).

tff(occ,type,
    occ: ( ty * uni * uni * $int * $int ) > $int ).

tff(permut,type,
    permut: ( ty * uni * uni * $int * $int ) > $o ).

tff(map_eq_sub,type,
    map_eq_sub: ( ty * uni * uni * $int * $int ) > $o ).

tff(array_eq_sub,type,
    array_eq_sub: ( ty * uni * uni * $int * $int ) > $o ).

tff(array_eq,type,
    array_eq: ( ty * uni * uni ) > $o ).

tff(exchange,type,
    exchange: ( ty * uni * uni * $int * $int * $int * $int ) > $o ).

tff(exchange1,type,
    exchange1: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut1,type,
    permut1: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut_sub,type,
    permut_sub: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut_all,type,
    permut_all: ( ty * uni * uni ) > $o ).

tff(usN,type,
    usN: $int ).

tff(f,type,
    f: $int ).

tff(array_int,type,
    array_int: $tType ).

tff(found,type,
    found: array_int > $o ).

tff(t2tb1,type,
    t2tb1: array_int > uni ).

tff(tb2t1,type,
    tb2t1: uni > array_int ).

tff(m_invariant,type,
    m_invariant: ( $int * array_int ) > $o ).

tff(n_invariant,type,
    n_invariant: ( $int * array_int ) > $o ).

tff(i_invariant,type,
    i_invariant: ( $int * $int * $int * $int * array_int ) > $o ).

tff(j_invariant,type,
    j_invariant: ( $int * $int * $int * $int * array_int ) > $o ).

tff(termination,type,
    termination: ( $int * $int * $int * $int * $int * array_int ) > $o ).

tff(map_int_int,type,
    map_int_int: $tType ).

tff(t2tb2,type,
    t2tb2: map_int_int > uni ).

tff(tb2t2,type,
    tb2t2: uni > map_int_int ).

tff(occ_right_add,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( $less(L,U)
     => ( ( occ(A,V,M,L,U) = $sum(1,occ(A,V,M,L,$difference(U,1))) )
       <= ( get(A,int,M,t2tb($difference(U,1))) = V ) ) ) ).

tff(f_N_range,axiom,
    ( $lesseq(1,f)
    & $lesseq(f,usN) ) ).

tff(permut_trans,axiom,
    ! [A: ty,A1: uni,A2: uni,A3: uni,L: $int,U: $int] :
      ( permut(A,A1,A2,L,U)
     => ( permut(A,A1,A3,L,U)
       <= permut(A,A2,A3,L,U) ) ) ).

tff(elts_def,axiom,
    ! [A: ty,U: $int,U1: uni] :
      ( ( elts(A,mk_array(A,U,U1)) = U1 )
     <= sort(map(int,A),U1) ) ).

tff(occ_append,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,Mid: $int,U: $int] :
      ( ( occ(A,V,M,L,U) = $sum(occ(A,V,M,L,Mid),occ(A,V,M,Mid,U)) )
     <= ( $lesseq(L,Mid)
        & $lesseq(Mid,U) ) ) ).

tff(bridgeL1,axiom,
    ! [I: array_int] : ( tb2t1(t2tb1(I)) = I ) ).

tff(bool_inversion,axiom,
    ! [U: bool] :
      ( ( U = false )
      | ( U = true ) ) ).

tff(contents_def,axiom,
    ! [A: ty,U: uni] :
      ( sort(A,U)
     => ( contents(A,mk_ref(A,U)) = U ) ) ).

tff(permut_exists,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int,I: $int] :
      ( permut(A,A1,A2,L,U)
     => ( ? [J: $int] :
            ( ( get(A,int,A1,t2tb(J)) = get(A,int,A2,t2tb(I)) )
            & $less(J,U)
            & $lesseq(L,J) )
       <= ( $less(I,U)
          & $lesseq(L,I) ) ) ) ).

tff(mk_ref_sort,axiom,
    ! [A: ty,X: uni] : sort(ref(A),mk_ref(A,X)) ).

tff(occ_pos,axiom,
    ! [A: ty,M: uni,L: $int,U: $int,I: $int] :
      ( $less(0,occ(A,get(A,int,M,t2tb(I)),M,L,U))
     <= ( $lesseq(L,I)
        & $less(I,U) ) ) ).

tff(set_sort,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort(map(A,B),set(B,A,X,X1,X2)) ).

tff(i_invariant_def,axiom,
    ! [M: $int,N: $int,I: $int,R: $int,A: array_int] :
      ( i_invariant(M,N,I,R,A)
    <=> ( $lesseq(M,I)
        & ! [P: $int] :
            ( $lesseq(tb2t(get1(int,t2tb1(A),P)),R)
           <= ( $less(P,I)
              & $lesseq(1,P) ) )
        & ( $lesseq(I,N)
         => ? [P: $int] :
              ( $lesseq(I,P)
              & $lesseq(R,tb2t(get1(int,t2tb1(A),P)))
              & $lesseq(P,N) ) ) ) ) ).

tff(permut_sub_weakening,axiom,
    ! [A: ty,A1: uni,A2: uni,L1: $int,U1: $int,L2: $int,U2: $int] :
      ( ( ( ( $lesseq(U1,U2)
            & $lesseq(U2,length(A,A1)) )
         => permut_sub(A,A1,A2,L2,U2) )
       <= ( $lesseq(0,L2)
          & $lesseq(L2,L1) ) )
     <= permut_sub(A,A1,A2,L1,U1) ) ).

tff(permut_def,axiom,
    ! [A: ty,M1: uni,M2: uni,L: $int,U: $int] :
      ( ( permut(A,M1,M2,L,U)
       => ! [V: uni] : ( occ(A,V,M1,L,U) = occ(A,V,M2,L,U) ) )
      & ( permut(A,M1,M2,L,U)
       <= ! [V: uni] :
            ( sort(A,V)
           => ( occ(A,V,M1,L,U) = occ(A,V,M2,L,U) ) ) ) ) ).

tff(occ_eq,axiom,
    ! [A: ty,V: uni,M1: uni,M2: uni,L: $int,U: $int] :
      ( ! [I: $int] :
          ( ( get(A,int,M1,t2tb(I)) = get(A,int,M2,t2tb(I)) )
         <= ( $less(I,U)
            & $lesseq(L,I) ) )
     => ( occ(A,V,M1,L,U) = occ(A,V,M2,L,U) ) ) ).

tff(permut_all_def,axiom,
    ! [A: ty,A1: uni,A2: uni] :
      ( permut_all(A,A1,A2)
    <=> ( permut(A,elts(A,A1),elts(A,A2),0,length(A,A1))
        & ( length(A,A1) = length(A,A2) ) ) ) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(get_sort,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort(B,get(B,A,X,X1)) ).

tff(permut_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( ( map_eq_sub(A,elts(A,A1),elts(A,A2),U,length(A,A1))
        & permut1(A,A1,A2,L,U)
        & map_eq_sub(A,elts(A,A1),elts(A,A2),0,L) )
    <=> permut_sub(A,A1,A2,L,U) ) ).

tff(bridgeL,axiom,
    ! [I: $int] : ( tb2t(t2tb(I)) = I ) ).

tff(bridgeR2,axiom,
    ! [J: uni] : ( t2tb2(tb2t2(J)) = J ) ).

tff(occ_exists,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( $less(0,occ(A,V,M,L,U))
       => ? [I: $int] :
            ( $lesseq(L,I)
            & $less(I,U)
            & ( get(A,int,M,t2tb(I)) = V ) ) )
     <= sort(A,V) ) ).

tff(occ_empty,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( $lesseq(U,L)
     => ( occ(A,V,M,L,U) = 0 ) ) ).

tff(length_def,axiom,
    ! [A: ty,U: $int,U1: uni] : ( length(A,mk_array(A,U,U1)) = U ) ).

tff(get_def,axiom,
    ! [A: ty,A1: uni,I: $int] : ( get1(A,A1,I) = get(A,int,elts(A,A1),t2tb(I)) ) ).

tff(make_def,axiom,
    ! [A: ty,N: $int,V: uni] : ( make(A,N,V) = mk_array(A,N,const(A,int,V)) ) ).

tff(exchange_permut_all,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int] :
      ( permut_all(A,A1,A2)
     <= exchange1(A,A1,A2,I,J) ) ).

tff(array_eq_def,axiom,
    ! [A: ty,A1: uni,A2: uni] :
      ( ( ( length(A,A1) = length(A,A2) )
        & map_eq_sub(A,elts(A,A1),elts(A,A2),0,length(A,A1)) )
    <=> array_eq(A,A1,A2) ) ).

tff(occ_bounds,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( $lesseq(L,U)
     => ( $lesseq(0,occ(A,V,M,L,U))
        & $lesseq(occ(A,V,M,L,U),$difference(U,L)) ) ) ).

tff(t2tb_sort1,axiom,
    ! [X: array_int] : sort(array(int),t2tb1(X)) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool(A,true,Z,Z1) = Z )
     <= sort(A,Z) ) ).

tff(mk_array_sort,axiom,
    ! [A: ty,X: $int,X1: uni] : sort(array(A),mk_array(A,X,X1)) ).

tff(bridgeR1,axiom,
    ! [J: uni] : ( t2tb1(tb2t1(J)) = J ) ).

tff(occ_neq,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( ! [I: $int] :
            ( ( get(A,int,M,t2tb(I)) != V )
           <= ( $less(I,U)
              & $lesseq(L,I) ) )
       => ( occ(A,V,M,L,U) = 0 ) )
     <= sort(A,V) ) ).

tff(get_sort1,axiom,
    ! [A: ty,X: uni,X1: $int] : sort(A,get1(A,X,X1)) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool(A,false,Z,Z1) = Z1 )
     <= sort(A,Z1) ) ).

tff(exchange_permut_sub,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int,L: $int,U: $int] :
      ( ( ( $lesseq(L,I)
          & $less(I,U) )
       => ( ( $lesseq(L,J)
            & $less(J,U) )
         => ( ( permut_sub(A,A1,A2,L,U)
             <= $lesseq(U,length(A,A1)) )
           <= $lesseq(0,L) ) ) )
     <= exchange1(A,A1,A2,I,J) ) ).

tff(wP_parameter_find,conjecture,
    ! [A: $int,A1: map_int_int] :
      ( ! [N: $int,M: $int,A2: map_int_int] :
          ( ( m_invariant(M,tb2t1(mk_array(int,A,t2tb2(A2))))
            & n_invariant(N,tb2t1(mk_array(int,A,t2tb2(A2))))
            & $lesseq(1,M)
            & $lesseq(N,usN)
            & permut_all(int,mk_array(int,A,t2tb2(A2)),mk_array(int,A,t2tb2(A1))) )
         => ( $less(M,N)
           => ( ! [J: $int,I: $int,A3: map_int_int] :
                  ( ( ! [I1: $int] :
                        ( ( ( $lesseq(0,A)
                            & $less(I1,A)
                            & $lesseq(0,I1) )
                         => ( ! [J1: $int] :
                                ( ( j_invariant(M,N,J1,tb2t(get(int,int,t2tb2(A2),t2tb(f))),tb2t1(mk_array(int,A,t2tb2(A3))))
                                  & $lesseq(J1,J)
                                  & termination(I1,J1,M,N,tb2t(get(int,int,t2tb2(A2),t2tb(f))),tb2t1(mk_array(int,A,t2tb2(A3))))
                                  & $lesseq(M,J1) )
                               => ( ( $less(tb2t(get(int,int,t2tb2(A2),t2tb(f))),tb2t(get(int,int,t2tb2(A3),t2tb(J1))))
                                   => ! [J2: $int] :
                                        ( termination(I1,J2,M,N,tb2t(get(int,int,t2tb2(A2),t2tb(f))),tb2t1(mk_array(int,A,t2tb2(A3))))
                                       <= ( J2 = $difference(J1,1) ) ) )
                                 <= ( $less(J1,A)
                                    & $lesseq(0,J1) ) ) )
                           <= ~ $less(tb2t(get(int,int,t2tb2(A3),t2tb(I1))),tb2t(get(int,int,t2tb2(A2),t2tb(f)))) ) )
                       <= ( i_invariant(M,N,I1,tb2t(get(int,int,t2tb2(A2),t2tb(f))),tb2t1(mk_array(int,A,t2tb2(A3))))
                          & $lesseq(I,I1)
                          & $lesseq(I1,N)
                          & termination(I1,J,M,N,tb2t(get(int,int,t2tb2(A2),t2tb(f))),tb2t1(mk_array(int,A,t2tb2(A3)))) ) )
                   <= $lesseq(I,J) )
                 <= ( i_invariant(M,N,I,tb2t(get(int,int,t2tb2(A2),t2tb(f))),tb2t1(mk_array(int,A,t2tb2(A3))))
                    & m_invariant(M,tb2t1(mk_array(int,A,t2tb2(A3))))
                    & n_invariant(N,tb2t1(mk_array(int,A,t2tb2(A3))))
                    & $lesseq(0,J)
                    & termination(I,J,M,N,tb2t(get(int,int,t2tb2(A2),t2tb(f))),tb2t1(mk_array(int,A,t2tb2(A3))))
                    & permut_all(int,mk_array(int,A,t2tb2(A3)),mk_array(int,A,t2tb2(A1)))
                    & $lesseq(I,$sum(usN,1))
                    & j_invariant(M,N,J,tb2t(get(int,int,t2tb2(A2),t2tb(f))),tb2t1(mk_array(int,A,t2tb2(A3)))) ) )
             <= ( $lesseq(0,A)
                & $lesseq(0,f)
                & $less(f,A) ) ) ) )
     <= ( ( A = $sum(usN,1) )
        & $lesseq(0,A) ) ) ).

tff(t2tb_sort2,axiom,
    ! [X: map_int_int] : sort(map(int,int),t2tb2(X)) ).

tff(ref_inversion,axiom,
    ! [A: ty,U: uni] :
      ( ( U = mk_ref(A,contents(A,U)) )
     <= sort(ref(A),U) ) ).

tff(const1,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( sort(B,B1)
     => ( get(B,A,const(B,A,B1),A1) = B1 ) ) ).

tff(permut_def1,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( ( ( length(A,A1) = length(A,A2) )
        & $lesseq(0,L)
        & $lesseq(L,length(A,A1))
        & $lesseq(0,U)
        & permut(A,elts(A,A1),elts(A,A2),L,U)
        & $lesseq(U,length(A,A1)) )
    <=> permut1(A,A1,A2,L,U) ) ).

tff(exchange_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int,I: $int,J: $int] :
      ( ( $less(I,U)
        & $less(J,U)
        & ( get(A,int,A1,t2tb(I)) = get(A,int,A2,t2tb(J)) )
        & ! [K: $int] :
            ( ( $lesseq(L,K)
              & $less(K,U) )
           => ( ( K != I )
             => ( ( K != J )
               => ( get(A,int,A1,t2tb(K)) = get(A,int,A2,t2tb(K)) ) ) ) )
        & ( get(A,int,A1,t2tb(J)) = get(A,int,A2,t2tb(I)) )
        & $lesseq(L,J)
        & $lesseq(L,I) )
    <=> exchange(A,A1,A2,L,U,I,J) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $lesseq(X,Y)
     => ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) ) ) ).

tff(select_neq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( sort(A,A1)
     => ( sort(A,A2)
       => ! [B1: uni] :
            ( ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) )
           <= ( A1 != A2 ) ) ) ) ).

tff(m_invariant_def,axiom,
    ! [M: $int,A: array_int] :
      ( m_invariant(M,A)
    <=> ( ! [P: $int,Q: $int] :
            ( $lesseq(tb2t(get1(int,t2tb1(A),P)),tb2t(get1(int,t2tb1(A),Q)))
           <= ( $lesseq(1,P)
              & $lesseq(M,Q)
              & $lesseq(Q,usN)
              & $less(P,M) ) )
        & $lesseq(M,f) ) ) ).

tff(exchange_set,axiom,
    ! [A: ty,A1: uni,L: $int,U: $int,I: $int,J: $int] :
      ( ( $less(I,U)
        & $lesseq(L,I) )
     => ( ( $lesseq(L,J)
          & $less(J,U) )
       => exchange(A,A1,set(A,int,set(A,int,A1,t2tb(I),get(A,int,A1,t2tb(J))),t2tb(J),get(A,int,A1,t2tb(I))),L,U,I,J) ) ) ).

tff(const_sort,axiom,
    ! [A: ty,B: ty,X: uni] : sort(map(A,B),const(B,A,X)) ).

tff(select_eq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( sort(B,B1)
     => ( ( A1 = A2 )
       => ( get(B,A,set(B,A,M,A1,B1),A2) = B1 ) ) ) ).

tff(array_inversion,axiom,
    ! [A: ty,U: uni] : ( U = mk_array(A,length(A,U),elts(A,U)) ) ).

tff(bridgeL2,axiom,
    ! [I: map_int_int] : ( tb2t2(t2tb2(I)) = I ) ).

tff(found_def,axiom,
    ! [A: array_int] :
      ( found(A)
    <=> ! [P: $int,Q: $int] :
          ( ( $lesseq(tb2t(get1(int,t2tb1(A),P)),tb2t(get1(int,t2tb1(A),f)))
            & $lesseq(tb2t(get1(int,t2tb1(A),f)),tb2t(get1(int,t2tb1(A),Q))) )
         <= ( $lesseq(1,P)
            & $lesseq(P,f)
            & $lesseq(f,Q)
            & $lesseq(Q,usN) ) ) ) ).

tff(t2tb_sort,axiom,
    ! [X: $int] : sort(int,t2tb(X)) ).

tff(exchange_def1,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int] :
      ( exchange1(A,A1,A2,I,J)
    <=> ( exchange(A,elts(A,A1),elts(A,A2),0,length(A,A1),I,J)
        & ( length(A,A1) = length(A,A2) ) ) ) ).

tff(true_False,axiom,
    true != false ).

tff(contents_sort,axiom,
    ! [A: ty,X: uni] : sort(A,contents(A,X)) ).

tff(occ_right_no_add,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( sort(A,V)
     => ( ( ( get(A,int,M,t2tb($difference(U,1))) != V )
         => ( occ(A,V,M,L,U) = occ(A,V,M,L,$difference(U,1)) ) )
       <= $less(L,U) ) ) ).

tff(j_invariant_def,axiom,
    ! [M: $int,N: $int,J: $int,R: $int,A: array_int] :
      ( ( $lesseq(J,N)
        & ! [Q: $int] :
            ( ( $less(J,Q)
              & $lesseq(Q,usN) )
           => $lesseq(R,tb2t(get1(int,t2tb1(A),Q))) )
        & ( $lesseq(M,J)
         => ? [Q: $int] :
              ( $lesseq(M,Q)
              & $lesseq(tb2t(get1(int,t2tb1(A),Q)),R)
              & $lesseq(Q,J) ) ) )
    <=> j_invariant(M,N,J,R,A) ) ).

tff(set_sort1,axiom,
    ! [A: ty,X: uni,X1: $int,X2: uni] : sort(array(A),set1(A,X,X1,X2)) ).

tff(make_sort,axiom,
    ! [A: ty,X: $int,X1: uni] : sort(array(A),make(A,X,X1)) ).

tff(map_eq_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( ! [I: $int] :
          ( ( get(A,int,A1,t2tb(I)) = get(A,int,A2,t2tb(I)) )
         <= ( $less(I,U)
            & $lesseq(L,I) ) )
    <=> map_eq_sub(A,A1,A2,L,U) ) ).

tff(witness_sort,axiom,
    ! [A: ty] : sort(A,witness(A)) ).

tff(elts_sort,axiom,
    ! [A: ty,X: uni] : sort(map(int,A),elts(A,X)) ).

tff(termination_def,axiom,
    ! [I: $int,J: $int,I0: $int,J0: $int,R: $int,A: array_int] :
      ( ( ( ( tb2t(get1(int,t2tb1(A),f)) = R )
          & $lesseq(f,J)
          & $lesseq(I,f) )
        | ( $less(I0,I)
          & $less(J,J0) ) )
    <=> termination(I,J,I0,J0,R,A) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple0] : ( U = tuple02 ) ).

tff(n_invariant_def,axiom,
    ! [N: $int,A: array_int] :
      ( n_invariant(N,A)
    <=> ( $lesseq(f,N)
        & ! [P: $int,Q: $int] :
            ( $lesseq(tb2t(get1(int,t2tb1(A),P)),tb2t(get1(int,t2tb1(A),Q)))
           <= ( $lesseq(1,P)
              & $lesseq(P,N)
              & $lesseq(Q,usN)
              & $less(N,Q) ) ) ) ) ).

tff(match_bool_sort,axiom,
    ! [A: ty,X: bool,X1: uni,X2: uni] : sort(A,match_bool(A,X,X1,X2)) ).

tff(set_def,axiom,
    ! [A: ty,A1: uni,I: $int,V: uni] : ( set1(A,A1,I,V) = mk_array(A,length(A,A1),set(A,int,elts(A,A1),t2tb(I),V)) ) ).

tff(array_eq_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( array_eq_sub(A,A1,A2,L,U)
    <=> ( ( length(A,A1) = length(A,A2) )
        & map_eq_sub(A,elts(A,A1),elts(A,A2),L,U)
        & $lesseq(U,length(A,A1))
        & $lesseq(0,U)
        & $lesseq(L,length(A,A1))
        & $lesseq(0,L) ) ) ).

