tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort: ( ty * uni ) > $o ).

tff(witness,type,
    witness: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool: $tType ).

tff(bool1,type,
    bool1: ty ).

tff(true,type,
    true: bool ).

tff(false,type,
    false: bool ).

tff(match_bool,type,
    match_bool: ( ty * bool * uni * uni ) > uni ).

tff(tuple0,type,
    tuple0: $tType ).

tff(tuple01,type,
    tuple01: ty ).

tff(tuple02,type,
    tuple02: tuple0 ).

tff(qtmark,type,
    qtmark: ty ).

tff(min,type,
    min: ( $int * $int ) > $int ).

tff(max,type,
    max: ( $int * $int ) > $int ).

tff(tree,type,
    tree: $tType ).

tff(tree1,type,
    tree1: ty ).

tff(empty,type,
    empty: tree ).

tff(node,type,
    node: ( tree * $int * tree ) > tree ).

tff(match_tree,type,
    match_tree: ( ty * tree * uni * uni ) > uni ).

tff(node_proj_1,type,
    node_proj_1: tree > tree ).

tff(node_proj_2,type,
    node_proj_2: tree > $int ).

tff(node_proj_3,type,
    node_proj_3: tree > tree ).

tff(size,type,
    size: tree > $int ).

tff(mem,type,
    mem: ( $int * tree ) > $o ).

tff(min_is_some,axiom,
    ! [X: $int,Y: $int] :
      ( ( min(X,Y) = Y )
      | ( min(X,Y) = X ) ) ).

tff(witness_sort,axiom,
    ! [A: ty] : sort(A,witness(A)) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort(A,Z)
     => ( match_bool(A,true,Z,Z1) = Z ) ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool(A,false,Z,Z1) = Z1 )
     <= sort(A,Z1) ) ).

tff(mem_def,axiom,
    ! [X: $int] :
      ( ! [X1: tree,X2: $int,X3: tree] :
          ( ( ( X = X2 )
            | mem(X,X3)
            | mem(X,X1) )
        <=> mem(X,node(X1,X2,X3)) )
      & ~ mem(X,empty) ) ).

tff(node_proj_2_def,axiom,
    ! [U: tree,U1: $int,U2: tree] : ( node_proj_2(node(U,U1,U2)) = U1 ) ).

tff(max_is_some,axiom,
    ! [X: $int,Y: $int] :
      ( ( max(X,Y) = X )
      | ( max(X,Y) = Y ) ) ).

tff(bool_inversion,axiom,
    ! [U: bool] :
      ( ( U = true )
      | ( U = false ) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq($product(X,Z),$product(Y,Z))
       <= $lesseq(0,Z) )
     <= $lesseq(X,Y) ) ).

tff(min_y,axiom,
    ! [X: $int,Y: $int] :
      ( ( min(X,Y) = Y )
     <= $lesseq(Y,X) ) ).

tff(size_nonneg,axiom,
    ! [T: tree] : $lesseq(0,size(T)) ).

tff(min_sym,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(Y,X)
     => ( min(X,Y) = min(Y,X) ) ) ).

tff(match_bool_sort,axiom,
    ! [A: ty,X: bool,X1: uni,X2: uni] : sort(A,match_bool(A,X,X1,X2)) ).

tff(match_tree_Node,axiom,
    ! [A: ty,Z: uni,Z1: uni,U: tree,U1: $int,U2: tree] :
      ( sort(A,Z1)
     => ( match_tree(A,node(U,U1,U2),Z,Z1) = Z1 ) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple0] : ( U = tuple02 ) ).

tff(match_tree_sort,axiom,
    ! [A: ty,X: tree,X1: uni,X2: uni] : sort(A,match_tree(A,X,X1,X2)) ).

tff(max_is_ge,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(X,max(X,Y))
      & $lesseq(Y,max(X,Y)) ) ).

tff(node_proj_3_def,axiom,
    ! [U: tree,U1: $int,U2: tree] : ( node_proj_3(node(U,U1,U2)) = U2 ) ).

tff(match_tree_Empty,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort(A,Z)
     => ( match_tree(A,empty,Z,Z1) = Z ) ) ).

tff(wP_parameter_maximum,conjecture,
    ! [T: tree] :
      ( ( T != empty )
     => ( ( $false
         <= ( T = empty ) )
        & ! [X: tree,X1: $int,X2: tree] :
            ( ( ! [W: tree,W1: $int,W2: tree] :
                  ( ( X2 = node(W,W1,W2) )
                 => ( ( ( $lesseq(0,size(T))
                        & $less(size(X2),size(T))
                        & ! [O: $int] :
                            ( ( mem(O,X2)
                              & ! [X3: $int] :
                                  ( $lesseq(X3,O)
                                 <= mem(X3,X2) ) )
                           => ( ! [X3: $int] :
                                  ( $lesseq(X3,max(O,X1))
                                 <= mem(X3,T) )
                              & mem(max(O,X1),T) ) )
                        & ( X2 != empty ) )
                     <= ( X = empty ) )
                    & ! [W3: tree,W4: $int,W5: tree] :
                        ( ( $lesseq(0,size(T))
                          & ! [O: $int] :
                              ( ( mem(O,X2)
                                & ! [X3: $int] :
                                    ( $lesseq(X3,O)
                                   <= mem(X3,X2) ) )
                             => ( ! [O1: $int] :
                                    ( ( ! [X3: $int] :
                                          ( mem(X3,X)
                                         => $lesseq(X3,O1) )
                                      & mem(O1,X) )
                                   => ( mem(max(O1,max(X1,O)),T)
                                      & ! [X3: $int] :
                                          ( mem(X3,T)
                                         => $lesseq(X3,max(O1,max(X1,O))) ) ) )
                                & ( X != empty )
                                & $less(size(X),size(T))
                                & $lesseq(0,size(T)) ) )
                          & ( X2 != empty )
                          & $less(size(X2),size(T)) )
                       <= ( X = node(W3,W4,W5) ) ) ) )
              & ( ( X2 = empty )
               => ( ( ( ! [X3: $int] :
                          ( $lesseq(X3,X1)
                         <= mem(X3,T) )
                      & mem(X1,T) )
                   <= ( X = empty ) )
                  & ! [W: tree,W1: $int,W2: tree] :
                      ( ( X = node(W,W1,W2) )
                     => ( $less(size(X),size(T))
                        & ( X != empty )
                        & ! [O: $int] :
                            ( ( mem(O,X)
                              & ! [X3: $int] :
                                  ( mem(X3,X)
                                 => $lesseq(X3,O) ) )
                           => ( mem(max(O,X1),T)
                              & ! [X3: $int] :
                                  ( $lesseq(X3,max(O,X1))
                                 <= mem(X3,T) ) ) )
                        & $lesseq(0,size(T)) ) ) ) ) )
           <= ( T = node(X,X1,X2) ) ) ) ) ).

tff(true_False,axiom,
    true != false ).

tff(max_x,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(Y,X)
     => ( max(X,Y) = X ) ) ).

tff(min_is_le,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(min(X,Y),Y)
      & $lesseq(min(X,Y),X) ) ).

tff(max_sym,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(Y,X)
     => ( max(X,Y) = max(Y,X) ) ) ).

tff(min_x,axiom,
    ! [X: $int,Y: $int] :
      ( ( min(X,Y) = X )
     <= $lesseq(X,Y) ) ).

tff(node_proj_1_def,axiom,
    ! [U: tree,U1: $int,U2: tree] : ( node_proj_1(node(U,U1,U2)) = U ) ).

tff(size_def,axiom,
    ( ( size(empty) = 0 )
    & ! [X: tree,X1: $int,X2: tree] : ( size(node(X,X1,X2)) = $sum($sum(1,size(X)),size(X2)) ) ) ).

tff(tree_inversion,axiom,
    ! [U: tree] :
      ( ( U = empty )
      | ( U = node(node_proj_1(U),node_proj_2(U),node_proj_3(U)) ) ) ).

tff(empty_Node,axiom,
    ! [V: tree,V1: $int,V2: tree] : ( empty != node(V,V1,V2) ) ).

tff(max_y,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(X,Y)
     => ( max(X,Y) = Y ) ) ).

