tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort: ( ty * uni ) > $o ).

tff(witness,type,
    witness: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool: $tType ).

tff(bool1,type,
    bool1: ty ).

tff(true,type,
    true: bool ).

tff(false,type,
    false: bool ).

tff(match_bool,type,
    match_bool: ( ty * bool * uni * uni ) > uni ).

tff(tuple0,type,
    tuple0: $tType ).

tff(tuple01,type,
    tuple01: ty ).

tff(tuple02,type,
    tuple02: tuple0 ).

tff(qtmark,type,
    qtmark: ty ).

tff(abs,type,
    abs: $int > $int ).

tff(div,type,
    div: ( $int * $int ) > $int ).

tff(mod,type,
    mod: ( $int * $int ) > $int ).

tff(divides,type,
    divides: ( $int * $int ) > $o ).

tff(even,type,
    even: $int > $o ).

tff(odd,type,
    odd: $int > $o ).

tff(gcd,type,
    gcd: ( $int * $int ) > $int ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(odd_def,axiom,
    ! [N: $int] :
      ( ? [K: $int] : ( N = $sum($product(2,K),1) )
    <=> odd(N) ) ).

tff(divides_multl,axiom,
    ! [A: $int,B: $int,C: $int] :
      ( divides(A,$product(C,B))
     <= divides(A,B) ) ).

tff(divides_antisym,axiom,
    ! [A: $int,B: $int] :
      ( ( ( ( A = $uminus(B) )
          | ( A = B ) )
       <= divides(B,A) )
     <= divides(A,B) ) ).

tff(contents_def,axiom,
    ! [A: ty,U: uni] :
      ( ( contents(A,mk_ref(A,U)) = U )
     <= sort(A,U) ) ).

tff(odd_odd,axiom,
    ! [N: $int] :
      ( odd($sum(N,2))
     <= odd(N) ) ).

tff(gcd_0_neg,axiom,
    ! [A: $int] :
      ( $less(A,0)
     => ( gcd(A,0) = $uminus(A) ) ) ).

tff(comm,axiom,
    ! [X: $int,Y: $int] : ( gcd(X,Y) = gcd(Y,X) ) ).

tff(mod_divides_computer,axiom,
    ! [A: $int,B: $int] :
      ( ( ( mod(A,B) = 0 )
       => divides(B,A) )
     <= ( B != 0 ) ) ).

tff(div_mod,axiom,
    ! [X: $int,Y: $int] :
      ( ( X = $sum($product(Y,div(X,Y)),mod(X,Y)) )
     <= ( Y != 0 ) ) ).

tff(even_def,axiom,
    ! [N: $int] :
      ( ? [K: $int] : ( N = $product(2,K) )
    <=> even(N) ) ).

tff(even_not_odd,axiom,
    ! [N: $int] :
      ( ~ odd(N)
     <= even(N) ) ).

tff(mod_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( Y != 0 )
     => ( $less($uminus(abs(Y)),mod(X,Y))
        & $less(mod(X,Y),abs(Y)) ) ) ).

tff(divides_right,axiom,
    ! [A: $int,B: $int,C: $int] :
      ( divides(A,B)
     => divides($product(A,C),$product(B,C)) ) ).

tff(divides_left,axiom,
    ! [A: $int,B: $int,C: $int] :
      ( divides($product(C,A),$product(C,B))
     <= divides(A,B) ) ).

tff(mod_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( mod(X,Y) = X )
     <= ( $less(X,Y)
        & $lesseq(0,X) ) ) ).

tff(abs_le,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(X,Y)
        & $lesseq($uminus(Y),X) )
    <=> $lesseq(abs(X),Y) ) ).

tff(gcd_0_pos,axiom,
    ! [A: $int] :
      ( $lesseq(0,A)
     => ( gcd(A,0) = A ) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) )
     <= $lesseq(X,Y) ) ).

tff(contents_sort,axiom,
    ! [A: ty,X: uni] : sort(A,contents(A,X)) ).

tff(ref_inversion,axiom,
    ! [A: ty,U: uni] :
      ( sort(ref(A),U)
     => ( U = mk_ref(A,contents(A,U)) ) ) ).

tff(div_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( div(X,Y) = 0 )
     <= ( $lesseq(0,X)
        & $less(X,Y) ) ) ).

tff(even_divides,axiom,
    ! [A: $int] :
      ( divides(2,A)
    <=> even(A) ) ).

tff(divides_oppr_rev,axiom,
    ! [A: $int,B: $int] :
      ( divides($uminus(A),B)
     => divides(A,B) ) ).

tff(mod_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( mod($sum($product(X,Y),Z),X) = mod(Z,X) )
     <= ( $lesseq(0,Y)
        & $lesseq(0,Z)
        & $less(0,X) ) ) ).

tff(divides_multr,axiom,
    ! [A: $int,B: $int,C: $int] :
      ( divides(A,$product(B,C))
     <= divides(A,B) ) ).

tff(even_or_odd,axiom,
    ! [N: $int] :
      ( odd(N)
      | even(N) ) ).

tff(gcd_unique,axiom,
    ! [A: $int,B: $int,D: $int] :
      ( $lesseq(0,D)
     => ( ( divides(D,B)
         => ( ! [X: $int] :
                ( ( divides(X,B)
                 => divides(X,D) )
               <= divides(X,A) )
           => ( D = gcd(A,B) ) ) )
       <= divides(D,A) ) ) ).

tff(even_even,axiom,
    ! [N: $int] :
      ( even($sum(N,2))
     <= even(N) ) ).

tff(divides_def,axiom,
    ! [D: $int,N: $int] :
      ( ? [Q: $int] : ( N = $product(Q,D) )
    <=> divides(D,N) ) ).

tff(gcd_def3,axiom,
    ! [A: $int,B: $int,X: $int] :
      ( divides(X,A)
     => ( divides(X,B)
       => divides(X,gcd(A,B)) ) ) ).

tff(div_1,axiom,
    ! [X: $int] : ( div(X,1) = X ) ).

tff(rounds_toward_zero,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(abs($product(div(X,Y),Y)),abs(X))
     <= ( Y != 0 ) ) ).

tff(mod_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(X,0)
        & ( Y != 0 ) )
     => $lesseq(mod(X,Y),0) ) ).

tff(mod_1,axiom,
    ! [X: $int] : ( mod(X,1) = 0 ) ).

tff(divides_factorl,axiom,
    ! [A: $int,B: $int] : divides(A,$product(B,A)) ).

tff(abs_def,axiom,
    ! [X: $int] :
      ( ( ( abs(X) = $uminus(X) )
       <= ~ $lesseq(0,X) )
      & ( $lesseq(0,X)
       => ( abs(X) = X ) ) ) ).

tff(div_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(0,div(X,Y))
     <= ( $less(0,Y)
        & $lesseq(0,X) ) ) ).

tff(divides_mod_euclidean,axiom,
    ! [A: $int,B: $int] :
      ( ( divides(B,A)
       => ( $remainder_e(A,B) = 0 ) )
     <= ( B != 0 ) ) ).

tff(mod_divides_euclidean,axiom,
    ! [A: $int,B: $int] :
      ( ( B != 0 )
     => ( ( $remainder_e(A,B) = 0 )
       => divides(B,A) ) ) ).

tff(div_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(div(X,Y),0)
     <= ( $lesseq(X,0)
        & $less(0,Y) ) ) ).

tff(gcd_computer_mod,axiom,
    ! [A: $int,B: $int] :
      ( ( B != 0 )
     => ( gcd(B,mod(A,B)) = gcd(A,B) ) ) ).

tff(bool_inversion,axiom,
    ! [U: bool] :
      ( ( U = true )
      | ( U = false ) ) ).

tff(odd_2k1,axiom,
    ! [K: $int] : odd($sum($product(2,K),1)) ).

tff(gcd_euclidean_mod,axiom,
    ! [A: $int,B: $int] :
      ( ( gcd(B,$remainder_e(A,B)) = gcd(A,B) )
     <= ( B != 0 ) ) ).

tff(match_bool_sort,axiom,
    ! [A: ty,X: bool,X1: uni,X2: uni] : sort(A,match_bool(A,X,X1,X2)) ).

tff(gcd_def2,axiom,
    ! [A: $int,B: $int] : divides(gcd(A,B),B) ).

tff(gcd_def1,axiom,
    ! [A: $int,B: $int] : divides(gcd(A,B),A) ).

tff(divides_n_1,axiom,
    ! [N: $int] :
      ( ( ( N = $uminus(1) )
        | ( N = 1 ) )
     <= divides(N,1) ) ).

tff(divides_oppl_rev,axiom,
    ! [A: $int,B: $int] :
      ( divides(A,B)
     <= divides(A,$uminus(B)) ) ).

tff(mk_ref_sort,axiom,
    ! [A: ty,X: uni] : sort(ref(A),mk_ref(A,X)) ).

tff(divides_plusr,axiom,
    ! [A: $int,B: $int,C: $int] :
      ( divides(A,B)
     => ( divides(A,C)
       => divides(A,$sum(B,C)) ) ) ).

tff(true_False,axiom,
    true != false ).

tff(odd_even,axiom,
    ! [N: $int] :
      ( odd(N)
     => even($sum(N,1)) ) ).

tff(divides_minusr,axiom,
    ! [A: $int,B: $int,C: $int] :
      ( divides(A,B)
     => ( divides(A,C)
       => divides(A,$difference(B,C)) ) ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool(A,false,Z,Z1) = Z1 )
     <= sort(A,Z1) ) ).

tff(wP_parameter_gcd,conjecture,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(0,Y)
        & $lesseq(0,X) )
     => ! [D: $int,C: $int,B: $int,A: $int,Y1: $int,X1: $int] :
          ( ( ? [A1: $int,B1: $int] : ( $sum($product(A1,X),$product(B1,Y)) = X1 )
           <= ~ $less(0,Y1) )
         <= ( $lesseq(0,X1)
            & ( gcd(X1,Y1) = gcd(X,Y) )
            & ( $sum($product(C,X),$product(D,Y)) = Y1 )
            & ( $sum($product(A,X),$product(B,Y)) = X1 )
            & $lesseq(0,Y1) ) ) ) ).

tff(even_odd,axiom,
    ! [N: $int] :
      ( odd($sum(N,1))
     <= even(N) ) ).

tff(div_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( div($sum($product(X,Y),Z),X) = $sum(Y,div(Z,X)) )
     <= ( $less(0,X)
        & $lesseq(0,Z)
        & $lesseq(0,Y) ) ) ).

tff(odd_divides,axiom,
    ! [A: $int] :
      ( odd(A)
    <=> ~ divides(2,A) ) ).

tff(div_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(0,X)
        & $less(0,Y) )
     => ( $lesseq(0,div(X,Y))
        & $lesseq(div(X,Y),X) ) ) ).

tff(abs_pos,axiom,
    ! [X: $int] : $lesseq(0,abs(X)) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple0] : ( U = tuple02 ) ).

tff(mod_mult1,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $less(0,X)
     => ( $remainder_e($sum($product(X,Y),Z),X) = $remainder_e(Z,X) ) ) ).

tff(divides_mod_computer,axiom,
    ! [A: $int,B: $int] :
      ( ( divides(B,A)
       => ( mod(A,B) = 0 ) )
     <= ( B != 0 ) ) ).

tff(gcd_euclid,axiom,
    ! [A: $int,B: $int,Q: $int] : ( gcd(A,B) = gcd(A,$difference(B,$product(Q,A))) ) ).

tff(divides_trans,axiom,
    ! [A: $int,B: $int,C: $int] :
      ( divides(A,B)
     => ( divides(B,C)
       => divides(A,C) ) ) ).

tff(div_mult1,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $less(0,X)
     => ( $quotient_e($sum($product(X,Y),Z),X) = $sum(Y,$quotient_e(Z,X)) ) ) ).

tff(gcd_mult,axiom,
    ! [A: $int,B: $int,C: $int] :
      ( $lesseq(0,C)
     => ( gcd($product(C,A),$product(C,B)) = $product(C,gcd(A,B)) ) ) ).

tff(gcd_nonneg,axiom,
    ! [A: $int,B: $int] : $lesseq(0,gcd(A,B)) ).

tff(assoc,axiom,
    ! [X: $int,Y: $int,Z: $int] : ( gcd(gcd(X,Y),Z) = gcd(X,gcd(Y,Z)) ) ).

tff(even_2k,axiom,
    ! [K: $int] : even($product(2,K)) ).

tff(witness_sort,axiom,
    ! [A: ty] : sort(A,witness(A)) ).

tff(mod_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(0,mod(X,Y))
     <= ( $lesseq(0,X)
        & ( Y != 0 ) ) ) ).

tff(odd_not_even,axiom,
    ! [N: $int] :
      ( odd(N)
     => ~ even(N) ) ).

tff(divides_0,axiom,
    ! [N: $int] : divides(N,0) ).

tff(divides_factorr,axiom,
    ! [A: $int,B: $int] : divides(A,$product(A,B)) ).

tff(divides_oppl,axiom,
    ! [A: $int,B: $int] :
      ( divides(A,B)
     => divides($uminus(A),B) ) ).

tff(divides_oppr,axiom,
    ! [A: $int,B: $int] :
      ( divides(A,$uminus(B))
     <= divides(A,B) ) ).

tff(divides_refl,axiom,
    ! [N: $int] : divides(N,N) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool(A,true,Z,Z1) = Z )
     <= sort(A,Z) ) ).

tff(divides_bounds,axiom,
    ! [A: $int,B: $int] :
      ( ( ( B != 0 )
       => $lesseq(abs(A),abs(B)) )
     <= divides(A,B) ) ).

tff(gcd_opp,axiom,
    ! [A: $int,B: $int] : ( gcd(A,B) = gcd($uminus(A),B) ) ).

tff(divides_1_n,axiom,
    ! [N: $int] : divides(1,N) ).

