tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort: ( ty * uni ) > $o ).

tff(witness,type,
    witness: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool: $tType ).

tff(bool1,type,
    bool1: ty ).

tff(true,type,
    true: bool ).

tff(false,type,
    false: bool ).

tff(match_bool,type,
    match_bool: ( ty * bool * uni * uni ) > uni ).

tff(tuple0,type,
    tuple0: $tType ).

tff(tuple01,type,
    tuple01: ty ).

tff(tuple02,type,
    tuple02: tuple0 ).

tff(qtmark,type,
    qtmark: ty ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(const,type,
    const: ( ty * ty * uni ) > uni ).

tff(array,type,
    array: ty > ty ).

tff(mk_array,type,
    mk_array: ( ty * $int * uni ) > uni ).

tff(length,type,
    length: ( ty * uni ) > $int ).

tff(elts,type,
    elts: ( ty * uni ) > uni ).

tff(get1,type,
    get1: ( ty * uni * $int ) > uni ).

tff(t2tb,type,
    t2tb: $int > uni ).

tff(tb2t,type,
    tb2t: uni > $int ).

tff(set1,type,
    set1: ( ty * uni * $int * uni ) > uni ).

tff(make,type,
    make: ( ty * $int * uni ) > uni ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(prefix_tl,type,
    prefix_tl: $int > $int ).

tff(map_int_int,type,
    map_int_int: $tType ).

tff(pr,type,
    pr: ( map_int_int * $int ) > $o ).

tff(t2tb1,type,
    t2tb1: map_int_int > uni ).

tff(tb2t1,type,
    tb2t1: uni > map_int_int ).

tff(num_of,type,
    num_of: ( map_int_int * $int * $int ) > $int ).

tff(array_int,type,
    array_int: $tType ).

tff(is_permutation,type,
    is_permutation: array_int > $o ).

tff(t2tb2,type,
    t2tb2: array_int > uni ).

tff(tb2t2,type,
    tb2t2: uni > array_int ).

tff(loopinvariant,type,
    loopinvariant: ( array_int * array_int * $int * $int * $int ) > $o ).

tff(empty,axiom,
    ! [P: map_int_int,A: $int,B: $int] :
      ( ( num_of(P,A,B) = 0 )
     <= ! [N: $int] :
          ( ( $lesseq(A,N)
            & $less(N,B) )
         => ~ pr(P,N) ) ) ).

tff(bridgeL,axiom,
    ! [I: $int] : ( tb2t(t2tb(I)) = I ) ).

tff(bridgeR2,axiom,
    ! [J: uni] : ( t2tb2(tb2t2(J)) = J ) ).

tff(bool_inversion,axiom,
    ! [U: bool] :
      ( ( U = true )
      | ( U = false ) ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool(A,false,Z,Z1) = Z1 )
     <= sort(A,Z1) ) ).

tff(pr_def,axiom,
    ! [A: map_int_int,N: $int] :
      ( $lesseq(0,tb2t(get(int,int,t2tb1(A),t2tb(N))))
    <=> pr(A,N) ) ).

tff(make_def,axiom,
    ! [A: ty,N: $int,V: uni] : ( make(A,N,V) = mk_array(A,N,const(A,int,V)) ) ).

tff(num_of_change_any,axiom,
    ! [P1: map_int_int,P2: map_int_int,A: $int,B: $int] :
      ( $lesseq(num_of(P1,A,B),num_of(P2,A,B))
     <= ! [J: $int] :
          ( ( pr(P2,J)
           <= pr(P1,J) )
         <= ( $lesseq(A,J)
            & $less(J,B) ) ) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple0] : ( U = tuple02 ) ).

tff(select_neq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( sort(A,A1)
     => ( ! [B1: uni] :
            ( ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) )
           <= ( A1 != A2 ) )
       <= sort(A,A2) ) ) ).

tff(true_False,axiom,
    true != false ).

tff(match_bool_sort,axiom,
    ! [A: ty,X: bool,X1: uni,X2: uni] : sort(A,match_bool(A,X,X1,X2)) ).

tff(num_of_empty,axiom,
    ! [P: map_int_int,A: $int,B: $int] :
      ( ( num_of(P,A,B) = 0 )
     <= $lesseq(B,A) ) ).

tff(bridgeR1,axiom,
    ! [J: uni] : ( t2tb1(tb2t1(J)) = J ) ).

tff(loopinvariant_def,axiom,
    ! [Old: array_int,A: array_int,M: $int,Mqt: $int,N: $int] :
      ( ( ! [E: $int] :
            ( ( $lesseq(0,E)
              & $less(E,N) )
           => ( $less(tb2t(get1(int,t2tb2(A),E)),N)
              & $lesseq($uminus(N),tb2t(get1(int,t2tb2(A),E))) ) )
        & ! [E: $int] :
            ( $lesseq(0,tb2t(get1(int,t2tb2(A),E)))
           <= ( $less(E,N)
              & $less(M,E) ) )
        & ! [E: $int] :
            ( ( $less(M,E)
              & $less(E,N) )
           => ( tb2t(get1(int,t2tb2(Old),tb2t(get1(int,t2tb2(A),E)))) = E ) )
        & ! [E: $int] :
            ( ( $lesseq(E,M)
              & $lesseq(0,E) )
           => $lesseq(tb2t(get1(int,t2tb2(A),E)),M) )
        & ! [E: $int] :
            ( ( $less(tb2t(get1(int,t2tb2(A),E)),0)
             => ( ( tb2t(get1(int,t2tb2(Old),prefix_tl(tb2t(get1(int,t2tb2(A),E))))) = E )
                & ( $less(tb2t(get1(int,t2tb2(A),prefix_tl(tb2t(get1(int,t2tb2(A),E))))),0)
                 <= $lesseq(prefix_tl(tb2t(get1(int,t2tb2(A),E))),M) ) ) )
           <= ( $lesseq(0,E)
              & $lesseq(E,Mqt) ) )
        & ! [E: $int] :
            ( ( $lesseq(E,Mqt)
              & $lesseq(0,E) )
           => ( ( tb2t(get1(int,t2tb2(Old),E)) = tb2t(get1(int,t2tb2(A),E)) )
             <= $lesseq(0,tb2t(get1(int,t2tb2(A),E))) ) ) )
    <=> loopinvariant(Old,A,M,Mqt,N) ) ).

tff(is_permutation_inverse,axiom,
    ! [A: array_int,B: array_int] :
      ( ( length(int,t2tb2(A)) = length(int,t2tb2(B)) )
     => ( is_permutation(A)
       => ( ! [I: $int] :
              ( ( $lesseq(0,I)
                & $less(I,length(int,t2tb2(B))) )
             => ( $less(tb2t(get1(int,t2tb2(B),I)),length(int,t2tb2(B)))
                & $lesseq(0,tb2t(get1(int,t2tb2(B),I))) ) )
         => ( is_permutation(B)
           <= ! [I: $int] :
                ( ( $lesseq(0,I)
                  & $less(I,length(int,t2tb2(B))) )
               => ( tb2t(get1(int,t2tb2(A),tb2t(get1(int,t2tb2(B),I)))) = I ) ) ) ) ) ) ).

tff(elts_sort,axiom,
    ! [A: ty,X: uni] : sort(map(int,A),elts(A,X)) ).

tff(num_of_decrease,axiom,
    ! [M: map_int_int,L: $int,R: $int,I: $int,V: $int] :
      ( ( ( $less(V,0)
         => $less(num_of(tb2t1(set(int,int,t2tb1(M),t2tb(I),t2tb(V))),L,R),num_of(M,L,R)) )
       <= $lesseq(0,tb2t(get(int,int,t2tb1(M),t2tb(I)))) )
     <= ( $less(I,R)
        & $lesseq(L,I) ) ) ).

tff(mk_array_sort,axiom,
    ! [A: ty,X: $int,X1: uni] : sort(array(A),mk_array(A,X,X1)) ).

tff(get_def,axiom,
    ! [A: ty,A1: uni,I: $int] : ( get1(A,A1,I) = get(A,int,elts(A,A1),t2tb(I)) ) ).

tff(num_of_append,axiom,
    ! [P: map_int_int,A: $int,B: $int,C: $int] :
      ( ( $lesseq(A,B)
        & $lesseq(B,C) )
     => ( num_of(P,A,C) = $sum(num_of(P,A,B),num_of(P,B,C)) ) ) ).

tff(const_sort,axiom,
    ! [A: ty,B: ty,X: uni] : sort(map(A,B),const(B,A,X)) ).

tff(wP_parameter_test1,conjecture,
    ( $lesseq(0,3)
    & ( $lesseq(0,3)
     => ( $lesseq(0,0)
        & ! [A: map_int_int] :
            ( ( ! [A1: map_int_int] :
                  ( ( $lesseq(0,3)
                    & ( A1 = tb2t1(set(int,int,t2tb1(A),t2tb(2),t2tb(0))) ) )
                 => ( $lesseq(0,1)
                    & $less(1,3)
                    & ! [A2: map_int_int] :
                        ( is_permutation(tb2t2(mk_array(int,3,t2tb1(A2))))
                       <= ( $lesseq(0,3)
                          & ( A2 = tb2t1(set(int,int,t2tb1(A1),t2tb(1),t2tb(1))) ) ) ) ) )
              & $less(2,3)
              & $lesseq(0,2) )
           <= ( $lesseq(0,3)
              & ( A = tb2t1(set(int,int,const(int,int,t2tb(0)),t2tb(0),t2tb(2))) ) ) )
        & $less(0,3) ) ) ) ).

tff(t2tb_sort,axiom,
    ! [X: $int] : sort(int,t2tb(X)) ).

tff(prefix_tl_def,axiom,
    ! [X: $int] : ( prefix_tl(X) = $difference($uminus(X),1) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) )
     <= $lesseq(X,Y) ) ).

tff(num_of_right_add,axiom,
    ! [P: map_int_int,A: $int,B: $int] :
      ( ( pr(P,$difference(B,1))
       => ( num_of(P,A,B) = $sum(1,num_of(P,A,$difference(B,1))) ) )
     <= $less(A,B) ) ).

tff(is_permutation_def,axiom,
    ! [A: array_int] :
      ( is_permutation(A)
    <=> ! [I: $int] :
          ( ( $lesseq(0,tb2t(get1(int,t2tb2(A),I)))
            & ! [J: $int] :
                ( ( ( I != J )
                 => ( tb2t(get1(int,t2tb2(A),I)) != tb2t(get1(int,t2tb2(A),J)) ) )
               <= ( $lesseq(0,J)
                  & $less(J,length(int,t2tb2(A))) ) )
            & $less(tb2t(get1(int,t2tb2(A),I)),length(int,t2tb2(A))) )
         <= ( $lesseq(0,I)
            & $less(I,length(int,t2tb2(A))) ) ) ) ).

tff(witness_sort,axiom,
    ! [A: ty] : sort(A,witness(A)) ).

tff(num_of_change_some,axiom,
    ! [P1: map_int_int,P2: map_int_int,A: $int,B: $int,I: $int] :
      ( ( ! [J: $int] :
            ( ( $less(J,B)
              & $lesseq(A,J) )
           => ( pr(P2,J)
             <= pr(P1,J) ) )
       => ( ( $less(num_of(P1,A,B),num_of(P2,A,B))
           <= pr(P2,I) )
         <= ~ pr(P1,I) ) )
     <= ( $lesseq(A,I)
        & $less(I,B) ) ) ).

tff(num_of_left_no_add,axiom,
    ! [P: map_int_int,A: $int,B: $int] :
      ( ( ( num_of(P,A,B) = num_of(P,$sum(A,1),B) )
       <= ~ pr(P,A) )
     <= $less(A,B) ) ).

tff(make_sort,axiom,
    ! [A: ty,X: $int,X1: uni] : sort(array(A),make(A,X,X1)) ).

tff(full,axiom,
    ! [P: map_int_int,A: $int,B: $int] :
      ( ( ! [N: $int] :
            ( pr(P,N)
           <= ( $lesseq(A,N)
              & $less(N,B) ) )
       => ( num_of(P,A,B) = $difference(B,A) ) )
     <= $lesseq(A,B) ) ).

tff(bridgeL1,axiom,
    ! [I: map_int_int] : ( tb2t1(t2tb1(I)) = I ) ).

tff(num_of_increasing,axiom,
    ! [P: map_int_int,I: $int,J: $int,K: $int] :
      ( $lesseq(num_of(P,I,J),num_of(P,I,K))
     <= ( $lesseq(J,K)
        & $lesseq(I,J) ) ) ).

tff(num_of_strictly_increasing,axiom,
    ! [P: map_int_int,I: $int,J: $int,K: $int,L: $int] :
      ( ( $less(num_of(P,I,J),num_of(P,I,L))
       <= pr(P,K) )
     <= ( $less(K,L)
        & $lesseq(J,K)
        & $lesseq(I,J) ) ) ).

tff(num_of_right_no_add,axiom,
    ! [P: map_int_int,A: $int,B: $int] :
      ( $less(A,B)
     => ( ~ pr(P,$difference(B,1))
       => ( num_of(P,A,B) = num_of(P,A,$difference(B,1)) ) ) ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort(A,Z)
     => ( match_bool(A,true,Z,Z1) = Z ) ) ).

tff(set_sort1,axiom,
    ! [A: ty,X: uni,X1: $int,X2: uni] : sort(array(A),set1(A,X,X1,X2)) ).

tff(num_of_left_add,axiom,
    ! [P: map_int_int,A: $int,B: $int] :
      ( $less(A,B)
     => ( pr(P,A)
       => ( num_of(P,A,B) = $sum(1,num_of(P,$sum(A,1),B)) ) ) ) ).

tff(elts_def,axiom,
    ! [A: ty,U: $int,U1: uni] :
      ( sort(map(int,A),U1)
     => ( elts(A,mk_array(A,U,U1)) = U1 ) ) ).

tff(bridgeL2,axiom,
    ! [I: array_int] : ( tb2t2(t2tb2(I)) = I ) ).

tff(t2tb_sort1,axiom,
    ! [X: map_int_int] : sort(map(int,int),t2tb1(X)) ).

tff(contents_def,axiom,
    ! [A: ty,U: uni] :
      ( sort(A,U)
     => ( contents(A,mk_ref(A,U)) = U ) ) ).

tff(get_sort1,axiom,
    ! [A: ty,X: uni,X1: $int] : sort(A,get1(A,X,X1)) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(set_def,axiom,
    ! [A: ty,A1: uni,I: $int,V: uni] : ( set1(A,A1,I,V) = mk_array(A,length(A,A1),set(A,int,elts(A,A1),t2tb(I),V)) ) ).

tff(select_eq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( sort(B,B1)
     => ( ( get(B,A,set(B,A,M,A1,B1),A2) = B1 )
       <= ( A1 = A2 ) ) ) ).

tff(array_inversion,axiom,
    ! [A: ty,U: uni] : ( U = mk_array(A,length(A,U),elts(A,U)) ) ).

tff(ref_inversion,axiom,
    ! [A: ty,U: uni] :
      ( ( U = mk_ref(A,contents(A,U)) )
     <= sort(ref(A),U) ) ).

tff(get_sort,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort(B,get(B,A,X,X1)) ).

tff(set_sort,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort(map(A,B),set(B,A,X,X1,X2)) ).

tff(num_of_bounds,axiom,
    ! [P: map_int_int,A: $int,B: $int] :
      ( $less(A,B)
     => ( $lesseq(0,num_of(P,A,B))
        & $lesseq(num_of(P,A,B),$difference(B,A)) ) ) ).

tff(contents_sort,axiom,
    ! [A: ty,X: uni] : sort(A,contents(A,X)) ).

tff(length_def,axiom,
    ! [A: ty,U: $int,U1: uni] : ( length(A,mk_array(A,U,U1)) = U ) ).

tff(t2tb_sort2,axiom,
    ! [X: array_int] : sort(array(int),t2tb2(X)) ).

tff(mk_ref_sort,axiom,
    ! [A: ty,X: uni] : sort(ref(A),mk_ref(A,X)) ).

tff(const1,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( sort(B,B1)
     => ( get(B,A,const(B,A,B1),A1) = B1 ) ) ).

