tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort1: ( ty * uni ) > $o ).

tff(witness,type,
    witness1: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool1: $tType ).

tff(bool1,type,
    bool: ty ).

tff(true,type,
    true1: bool1 ).

tff(false,type,
    false1: bool1 ).

tff(match_bool,type,
    match_bool1: ( ty * bool1 * uni * uni ) > uni ).

tff(tuple0,type,
    tuple02: $tType ).

tff(tuple01,type,
    tuple0: ty ).

tff(tuple02,type,
    tuple03: tuple02 ).

tff(qtmark,type,
    qtmark: ty ).

tff(abs,type,
    abs1: $int > $int ).

tff(div,type,
    div1: ( $int * $int ) > $int ).

tff(mod,type,
    mod1: ( $int * $int ) > $int ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(div_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(div1(X,Y),X)
        & $lesseq(0,div1(X,Y)) )
     <= ( $less(0,Y)
        & $lesseq(0,X) ) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq($product(X,Z),$product(Y,Z))
       <= $lesseq(0,Z) )
     <= $lesseq(X,Y) ) ).

tff(abs_le,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(abs1(X),Y)
    <=> ( $lesseq(X,Y)
        & $lesseq($uminus(Y),X) ) ) ).

tff(div_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(0,div1(X,Y))
     <= ( $lesseq(0,X)
        & $less(0,Y) ) ) ).

tff(rounds_toward_zero,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(abs1($product(div1(X,Y),Y)),abs1(X))
     <= ( Y != 0 ) ) ).

tff(bool_inversion,axiom,
    ! [U: bool1] :
      ( ( U = true1 )
      | ( U = false1 ) ) ).

tff(abs_pos,axiom,
    ! [X: $int] : $lesseq(0,abs1(X)) ).

tff(match_bool_sort1,axiom,
    ! [A: ty,X: bool1,X1: uni,X2: uni] : sort1(A,match_bool1(A,X,X1,X2)) ).

tff(abs_def,axiom,
    ! [X: $int] :
      ( ( ~ $lesseq(0,X)
       => ( abs1(X) = $uminus(X) ) )
      & ( ( abs1(X) = X )
       <= $lesseq(0,X) ) ) ).

tff(mod_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less(X,Y)
        & $lesseq(0,X) )
     => ( mod1(X,Y) = X ) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple02] : ( U = tuple03 ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool1(A,false1,Z,Z1) = Z1 )
     <= sort1(A,Z1) ) ).

tff(witness_sort1,axiom,
    ! [A: ty] : sort1(A,witness1(A)) ).

tff(div_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( div1(X,Y) = 0 )
     <= ( $less(X,Y)
        & $lesseq(0,X) ) ) ).

tff(div_mod,axiom,
    ! [X: $int,Y: $int] :
      ( ( X = $sum($product(Y,div1(X,Y)),mod1(X,Y)) )
     <= ( Y != 0 ) ) ).

tff(mod_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less($uminus(abs1(Y)),mod1(X,Y))
        & $less(mod1(X,Y),abs1(Y)) )
     <= ( Y != 0 ) ) ).

tff(mod_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( mod1($sum($product(X,Y),Z),X) = mod1(Z,X) )
     <= ( $less(0,X)
        & $lesseq(0,Y)
        & $lesseq(0,Z) ) ) ).

tff(contents_def1,axiom,
    ! [A: ty,U: uni] :
      ( sort1(A,U)
     => ( contents(A,mk_ref(A,U)) = U ) ) ).

tff(ref_inversion1,axiom,
    ! [A: ty,U: uni] :
      ( ( U = mk_ref(A,contents(A,U)) )
     <= sort1(ref(A),U) ) ).

tff(div_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(X,0)
        & $less(0,Y) )
     => $lesseq(div1(X,Y),0) ) ).

tff(mod_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( ( ( Y != 0 )
        & $lesseq(X,0) )
     => $lesseq(mod1(X,Y),0) ) ).

tff(contents_sort1,axiom,
    ! [A: ty,X: uni] : sort1(A,contents(A,X)) ).

tff(true_False,axiom,
    true1 != false1 ).

tff(mk_ref_sort1,axiom,
    ! [A: ty,X: uni] : sort1(ref(A),mk_ref(A,X)) ).

tff(div_1,axiom,
    ! [X: $int] : ( div1(X,1) = X ) ).

tff(mod_1,axiom,
    ! [X: $int] : ( mod1(X,1) = 0 ) ).

tff(div_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( div1($sum($product(X,Y),Z),X) = $sum(Y,div1(Z,X)) )
     <= ( $lesseq(0,Z)
        & $lesseq(0,Y)
        & $less(0,X) ) ) ).

tff(mod_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(0,X)
        & ( Y != 0 ) )
     => $lesseq(0,mod1(X,Y)) ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool1(A,true1,Z,Z1) = Z )
     <= sort1(A,Z) ) ).

tff(wP_parameter_sqrt,conjecture,
    ! [X: $int] :
      ( ( ( ~ $lesseq(X,3)
         => ! [Z: $int,Y: $int] :
              ( ( $less(0,Z)
                & $less(0,Y)
                & $less(X,$product($sum(Y,1),$sum(Y,1)))
                & $less(X,$product($sum(Z,1),$sum(Z,1)))
                & ( Z = div1($sum(div1(X,Y),Y),2) ) )
             => ( ~ $less(Z,Y)
               => ( $less(X,$product($sum(Y,1),$sum(Y,1)))
                  & $lesseq($product(Y,Y),X) ) ) ) )
       <= ( X != 0 ) )
     <= $lesseq(0,X) ) ).

