tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort1: ( ty * uni ) > $o ).

tff(witness,type,
    witness1: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool1: $tType ).

tff(bool1,type,
    bool: ty ).

tff(true,type,
    true1: bool1 ).

tff(false,type,
    false1: bool1 ).

tff(match_bool,type,
    match_bool1: ( ty * bool1 * uni * uni ) > uni ).

tff(tuple0,type,
    tuple02: $tType ).

tff(tuple01,type,
    tuple0: ty ).

tff(tuple02,type,
    tuple03: tuple02 ).

tff(qtmark,type,
    qtmark: ty ).

tff(abs,type,
    abs1: $int > $int ).

tff(div,type,
    div2: ( $int * $int ) > $int ).

tff(mod,type,
    mod2: ( $int * $int ) > $int ).

tff(lt_nat,type,
    lt_nat1: ( $int * $int ) > $o ).

tff(tuple2,type,
    tuple2: ( ty * ty ) > ty ).

tff(tuple21,type,
    tuple21: ( ty * ty * uni * uni ) > uni ).

tff(tuple2_proj_1,type,
    tuple2_proj_11: ( ty * ty * uni ) > uni ).

tff(tuple2_proj_2,type,
    tuple2_proj_21: ( ty * ty * uni ) > uni ).

tff(lpintcm_intrp,type,
    lpintcm_intrp: $tType ).

tff(lex,type,
    lex1: ( lpintcm_intrp * lpintcm_intrp ) > $o ).

tff(t2tb,type,
    t2tb: lpintcm_intrp > uni ).

tff(tb2t,type,
    tb2t: uni > lpintcm_intrp ).

tff(t2tb1,type,
    t2tb1: $int > uni ).

tff(tb2t1,type,
    tb2t1: uni > $int ).

tff(even,type,
    even1: $int > $o ).

tff(odd,type,
    odd1: $int > $o ).

tff(divides,type,
    divides1: ( $int * $int ) > $o ).

tff(prime,type,
    prime1: $int > $o ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(const1,type,
    const: ( ty * ty * uni ) > uni ).

tff(array,type,
    array: ty > ty ).

tff(mk_array,type,
    mk_array1: ( ty * $int * uni ) > uni ).

tff(length,type,
    length1: ( ty * uni ) > $int ).

tff(elts,type,
    elts: ( ty * uni ) > uni ).

tff(get1,type,
    get2: ( ty * uni * $int ) > uni ).

tff(set1,type,
    set2: ( ty * uni * $int * uni ) > uni ).

tff(make,type,
    make1: ( ty * $int * uni ) > uni ).

tff(no_prime_in,type,
    no_prime_in1: ( $int * $int ) > $o ).

tff(array_int,type,
    array_int: $tType ).

tff(first_primes,type,
    first_primes1: ( array_int * $int ) > $o ).

tff(t2tb2,type,
    t2tb2: array_int > uni ).

tff(tb2t2,type,
    tb2t2: uni > array_int ).

tff(map_int_int,type,
    map_int_int: $tType ).

tff(t2tb3,type,
    t2tb3: map_int_int > uni ).

tff(tb2t3,type,
    tb2t3: uni > map_int_int ).

tff(divides_oppr_rev,axiom,
    ! [A: $int,B: $int] :
      ( divides1($uminus(A),B)
     => divides1(A,B) ) ).

tff(odd_odd,axiom,
    ! [N: $int] :
      ( odd1(N)
     => odd1($sum(N,2)) ) ).

tff(not_prime_1,axiom,
    ~ prime1(1) ).

tff(array_inversion1,axiom,
    ! [A: ty,U: uni] : ( U = mk_array1(A,length1(A,U),elts(A,U)) ) ).

tff(bridgeR1,axiom,
    ! [J: uni] : ( t2tb1(tb2t1(J)) = J ) ).

tff(bertrand_postulate,axiom,
    ! [P: $int] :
      ( ~ no_prime_in1(P,$product(2,P))
     <= prime1(P) ) ).

tff(even_prime,axiom,
    ! [P: $int] :
      ( prime1(P)
     => ( ( P = 2 )
       <= even1(P) ) ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z)
     => ( match_bool1(A,true1,Z,Z1) = Z ) ) ).

tff(tuple2_proj_2_def1,axiom,
    ! [A: ty,A1: ty,U: uni,U1: uni] :
      ( ( tuple2_proj_21(A1,A,tuple21(A1,A,U,U1)) = U1 )
     <= sort1(A,U1) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $lesseq(X,Y)
     => ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) ) ) ).

tff(divides_factorr,axiom,
    ! [A: $int,B: $int] : divides1(A,$product(A,B)) ).

tff(select_neq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( sort1(A,A1)
     => ( sort1(A,A2)
       => ! [B1: uni] :
            ( ( A1 != A2 )
           => ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) ) ) ) ) ).

tff(abs_def,axiom,
    ! [X: $int] :
      ( ( ( abs1(X) = X )
       <= $lesseq(0,X) )
      & ( ~ $lesseq(0,X)
       => ( abs1(X) = $uminus(X) ) ) ) ).

tff(even_even,axiom,
    ! [N: $int] :
      ( even1(N)
     => even1($sum(N,2)) ) ).

tff(tuple2_sort1,axiom,
    ! [A: ty,A1: ty,X: uni,X1: uni] : sort1(tuple2(A1,A),tuple21(A1,A,X,X1)) ).

tff(odd_divides,axiom,
    ! [A: $int] :
      ( ~ divides1(2,A)
    <=> odd1(A) ) ).

tff(abs_pos,axiom,
    ! [X: $int] : $lesseq(0,abs1(X)) ).

tff(lt_nat_def,axiom,
    ! [X: $int,Y: $int] :
      ( lt_nat1(X,Y)
    <=> ( $less(X,Y)
        & $lesseq(0,Y) ) ) ).

tff(length_def1,axiom,
    ! [A: ty,U: $int,U1: uni] : ( length1(A,mk_array1(A,U,U1)) = U ) ).

tff(select_eq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( ( ( A1 = A2 )
       => ( get(B,A,set(B,A,M,A1,B1),A2) = B1 ) )
     <= sort1(B,B1) ) ).

tff(elts_sort1,axiom,
    ! [A: ty,X: uni] : sort1(map(int,A),elts(A,X)) ).

tff(divides_oppr,axiom,
    ! [A: $int,B: $int] :
      ( divides1(A,B)
     => divides1(A,$uminus(B)) ) ).

tff(set_sort3,axiom,
    ! [A: ty,X: uni,X1: $int,X2: uni] : sort1(array(A),set2(A,X,X1,X2)) ).

tff(get_sort3,axiom,
    ! [A: ty,X: uni,X1: $int] : sort1(A,get2(A,X,X1)) ).

tff(odd_prime,axiom,
    ! [P: $int] :
      ( prime1(P)
     => ( $lesseq(3,P)
       => odd1(P) ) ) ).

tff(tuple2_inversion1,axiom,
    ! [A: ty,A1: ty,U: uni] :
      ( sort1(tuple2(A1,A),U)
     => ( U = tuple21(A1,A,tuple2_proj_11(A1,A,U),tuple2_proj_21(A1,A,U)) ) ) ).

tff(no_prime_in_def,axiom,
    ! [L: $int,U: $int] :
      ( ! [X: $int] :
          ( ( $less(X,U)
            & $less(L,X) )
         => ~ prime1(X) )
    <=> no_prime_in1(L,U) ) ).

tff(divides_oppl_rev,axiom,
    ! [A: $int,B: $int] :
      ( divides1(A,B)
     <= divides1(A,$uminus(B)) ) ).

tff(divides_factorl,axiom,
    ! [A: $int,B: $int] : divides1(A,$product(B,A)) ).

tff(bridgeL3,axiom,
    ! [I: map_int_int] : ( tb2t3(t2tb3(I)) = I ) ).

tff(odd_not_even,axiom,
    ! [N: $int] :
      ( ~ even1(N)
     <= odd1(N) ) ).

tff(div_1,axiom,
    ! [X: $int] : ( div2(X,1) = X ) ).

tff(tuple2_proj_2_sort1,axiom,
    ! [A: ty,A1: ty,X: uni] : sort1(A,tuple2_proj_21(A1,A,X)) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple02] : ( U = tuple03 ) ).

tff(divides_antisym,axiom,
    ! [A: $int,B: $int] :
      ( ( divides1(B,A)
       => ( ( A = B )
          | ( A = $uminus(B) ) ) )
     <= divides1(A,B) ) ).

tff(even_def,axiom,
    ! [N: $int] :
      ( ? [K: $int] : ( N = $product(2,K) )
    <=> even1(N) ) ).

tff(get_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort1(B,get(B,A,X,X1)) ).

tff(divides_mod_euclidean,axiom,
    ! [A: $int,B: $int] :
      ( ( ( $remainder_e(A,B) = 0 )
       <= divides1(B,A) )
     <= ( B != 0 ) ) ).

tff(divides_n_1,axiom,
    ! [N: $int] :
      ( divides1(N,1)
     => ( ( N = $uminus(1) )
        | ( N = 1 ) ) ) ).

tff(div_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $less(0,X)
        & $lesseq(0,Z)
        & $lesseq(0,Y) )
     => ( div2($sum($product(X,Y),Z),X) = $sum(Y,div2(Z,X)) ) ) ).

tff(lex_2,axiom,
    ! [X: $int,Y1: $int,Y2: $int] :
      ( lex1(tb2t(tuple21(int,int,t2tb1(X),t2tb1(Y1))),tb2t(tuple21(int,int,t2tb1(X),t2tb1(Y2))))
     <= lt_nat1(Y1,Y2) ) ).

tff(lex_inversion,axiom,
    ! [Z: lpintcm_intrp,Z1: lpintcm_intrp] :
      ( ( ? [X: $int,Y1: $int,Y2: $int] :
            ( lt_nat1(Y1,Y2)
            & ( Z = tb2t(tuple21(int,int,t2tb1(X),t2tb1(Y1))) )
            & ( Z1 = tb2t(tuple21(int,int,t2tb1(X),t2tb1(Y2))) ) )
        | ? [X1: $int,X2: $int,Y1: $int,Y2: $int] :
            ( ( Z = tb2t(tuple21(int,int,t2tb1(X1),t2tb1(Y1))) )
            & ( Z1 = tb2t(tuple21(int,int,t2tb1(X2),t2tb1(Y2))) )
            & lt_nat1(X1,X2) ) )
     <= lex1(Z,Z1) ) ).

tff(witness_sort1,axiom,
    ! [A: ty] : sort1(A,witness1(A)) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(t2tb_sort3,axiom,
    ! [X: map_int_int] : sort1(map(int,int),t2tb3(X)) ).

tff(elts_def1,axiom,
    ! [A: ty,U: $int,U1: uni] :
      ( ( elts(A,mk_array1(A,U,U1)) = U1 )
     <= sort1(map(int,A),U1) ) ).

tff(divides_refl,axiom,
    ! [N: $int] : divides1(N,N) ).

tff(tuple2_proj_1_def1,axiom,
    ! [A: ty,A1: ty,U: uni,U1: uni] :
      ( ( tuple2_proj_11(A1,A,tuple21(A1,A,U,U1)) = U )
     <= sort1(A1,U) ) ).

tff(divides_bounds,axiom,
    ! [A: $int,B: $int] :
      ( ( ( B != 0 )
       => $lesseq(abs1(A),abs1(B)) )
     <= divides1(A,B) ) ).

tff(bridgeL1,axiom,
    ! [I: $int] : ( tb2t1(t2tb1(I)) = I ) ).

tff(mod_mult1,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $remainder_e($sum($product(X,Y),Z),X) = $remainder_e(Z,X) )
     <= $less(0,X) ) ).

tff(div_mult1,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $less(0,X)
     => ( $quotient_e($sum($product(X,Y),Z),X) = $sum(Y,$quotient_e(Z,X)) ) ) ).

tff(divides_multl,axiom,
    ! [A: $int,B: $int,C: $int] :
      ( divides1(A,$product(C,B))
     <= divides1(A,B) ) ).

tff(odd_def,axiom,
    ! [N: $int] :
      ( odd1(N)
    <=> ? [K: $int] : ( N = $sum($product(2,K),1) ) ) ).

tff(divides_oppl,axiom,
    ! [A: $int,B: $int] :
      ( divides1(A,B)
     => divides1($uminus(A),B) ) ).

tff(prime_def,axiom,
    ! [P: $int] :
      ( prime1(P)
    <=> ( ! [N: $int] :
            ( ~ divides1(N,P)
           <= ( $less(N,P)
              & $less(1,N) ) )
        & $lesseq(2,P) ) ) ).

tff(bridgeL,axiom,
    ! [I: lpintcm_intrp] : ( tb2t(t2tb(I)) = I ) ).

tff(divides_minusr,axiom,
    ! [A: $int,B: $int,C: $int] :
      ( ( divides1(A,$difference(B,C))
       <= divides1(A,C) )
     <= divides1(A,B) ) ).

tff(const,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( ( get(B,A,const(B,A,B1),A1) = B1 )
     <= sort1(B,B1) ) ).

tff(t2tb_sort2,axiom,
    ! [X: array_int] : sort1(array(int),t2tb2(X)) ).

tff(exists_prime,axiom,
    ! [P: array_int,U: $int] :
      ( ( ! [D: $int] :
            ( ( $lesseq(2,D)
              & $lesseq(D,tb2t1(get2(int,t2tb2(P),$difference(U,1)))) )
           => ( ? [I: $int] :
                  ( $lesseq(0,I)
                  & $less(I,U)
                  & ( D = tb2t1(get2(int,t2tb2(P),I)) ) )
             <= prime1(D) ) )
       <= first_primes1(P,U) )
     <= $lesseq(1,U) ) ).

tff(t2tb_sort,axiom,
    ! [X: lpintcm_intrp] : sort1(tuple2(int,int),t2tb(X)) ).

tff(contents_sort1,axiom,
    ! [A: ty,X: uni] : sort1(A,contents(A,X)) ).

tff(first_primes_def,axiom,
    ! [P: array_int,U: $int] :
      ( first_primes1(P,U)
    <=> ( ! [I: $int,J: $int] :
            ( ( $lesseq(0,I)
              & $less(I,J)
              & $less(J,U) )
           => $less(tb2t1(get2(int,t2tb2(P),I)),tb2t1(get2(int,t2tb2(P),J))) )
        & ! [I: $int] :
            ( ( $lesseq(0,I)
              & $less(I,U) )
           => prime1(tb2t1(get2(int,t2tb2(P),I))) )
        & ! [I: $int] :
            ( no_prime_in1(tb2t1(get2(int,t2tb2(P),I)),tb2t1(get2(int,t2tb2(P),$sum(I,1))))
           <= ( $lesseq(0,I)
              & $less(I,$difference(U,1)) ) )
        & ( tb2t1(get2(int,t2tb2(P),0)) = 2 ) ) ) ).

tff(divides_mod_computer,axiom,
    ! [A: $int,B: $int] :
      ( ( B != 0 )
     => ( ( mod2(A,B) = 0 )
       <= divides1(B,A) ) ) ).

tff(even_2k,axiom,
    ! [K: $int] : even1($product(2,K)) ).

tff(divides_plusr,axiom,
    ! [A: $int,B: $int,C: $int] :
      ( divides1(A,B)
     => ( divides1(A,C)
       => divides1(A,$sum(B,C)) ) ) ).

tff(divides_1_n,axiom,
    ! [N: $int] : divides1(1,N) ).

tff(make_def,axiom,
    ! [A: ty,N: $int,V: uni] : ( make1(A,N,V) = mk_array1(A,N,const(A,int,V)) ) ).

tff(divides_left,axiom,
    ! [A: $int,B: $int,C: $int] :
      ( divides1(A,B)
     => divides1($product(C,A),$product(C,B)) ) ).

tff(mod_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less($uminus(abs1(Y)),mod2(X,Y))
        & $less(mod2(X,Y),abs1(Y)) )
     <= ( Y != 0 ) ) ).

tff(get_def,axiom,
    ! [A: ty,A1: uni,I: $int] : ( get2(A,A1,I) = get(A,int,elts(A,A1),t2tb1(I)) ) ).

tff(even_divides,axiom,
    ! [A: $int] :
      ( divides1(2,A)
    <=> even1(A) ) ).

tff(const_sort1,axiom,
    ! [A: ty,B: ty,X: uni] : sort1(map(A,B),const(B,A,X)) ).

tff(divides_trans,axiom,
    ! [A: $int,B: $int,C: $int] :
      ( ( divides1(B,C)
       => divides1(A,C) )
     <= divides1(A,B) ) ).

tff(bool_inversion,axiom,
    ! [U: bool1] :
      ( ( U = true1 )
      | ( U = false1 ) ) ).

tff(mk_ref_sort1,axiom,
    ! [A: ty,X: uni] : sort1(ref(A),mk_ref(A,X)) ).

tff(t2tb_sort1,axiom,
    ! [X: $int] : sort1(int,t2tb1(X)) ).

tff(rounds_toward_zero,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(abs1($product(div2(X,Y),Y)),abs1(X))
     <= ( Y != 0 ) ) ).

tff(div_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(X,0)
        & $less(0,Y) )
     => $lesseq(div2(X,Y),0) ) ).

tff(abs_le,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(abs1(X),Y)
    <=> ( $lesseq($uminus(Y),X)
        & $lesseq(X,Y) ) ) ).

tff(bridgeR2,axiom,
    ! [J: uni] : ( t2tb2(tb2t2(J)) = J ) ).

tff(set_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort1(map(A,B),set(B,A,X,X1,X2)) ).

tff(wP_parameter_prime_numbers,conjecture,
    ! [M: $int] :
      ( $lesseq(2,M)
     => ( ( $lesseq(0,M)
         => ( ( $lesseq(0,0)
              & $less(0,M) )
           => ! [P: map_int_int] :
                ( ( $lesseq(0,M)
                  & ( P = tb2t3(set(int,int,const(int,int,t2tb1(0)),t2tb1(0),t2tb1(2))) ) )
               => ( ! [P1: map_int_int] :
                      ( ( ! [N: $int,P2: map_int_int,J: $int] :
                            ( ( $lesseq(J,$difference(M,1))
                              & $lesseq(2,J) )
                           => ( ( ! [N1: $int] :
                                    ( ( prime1(N1)
                                      & no_prime_in1(tb2t1(get(int,int,t2tb3(P2),t2tb1($difference(J,1)))),N1)
                                      & $less(tb2t1(get(int,int,t2tb3(P2),t2tb1($difference(J,1)))),N1) )
                                   => ( ( $lesseq(0,J)
                                        & $less(J,M) )
                                     => ! [P3: map_int_int] :
                                          ( ! [N2: $int] :
                                              ( no_prime_in1(tb2t1(get(int,int,t2tb3(P3),t2tb1($difference($sum(J,1),1)))),N2)
                                             <= ( N2 = $sum(N1,2) ) )
                                         <= ( $lesseq(0,M)
                                            & ( P3 = tb2t3(set(int,int,t2tb3(P2),t2tb1(J),t2tb1(N1))) ) ) ) ) )
                               <= ( $lesseq(1,1)
                                  & $less(1,J)
                                  & $less(tb2t1(get(int,int,t2tb3(P2),t2tb1($difference(J,1)))),N)
                                  & odd1(N)
                                  & no_prime_in1(tb2t1(get(int,int,t2tb3(P2),t2tb1($difference(J,1)))),N)
                                  & ! [I: $int] :
                                      ( ( $lesseq(0,I)
                                        & $less(I,1) )
                                     => ~ divides1(tb2t1(get(int,int,t2tb3(P2),t2tb1(I))),N) )
                                  & $less(N,$product(2,tb2t1(get(int,int,t2tb3(P2),t2tb1($difference(J,1))))))
                                  & first_primes1(tb2t2(mk_array1(int,M,t2tb3(P2))),J)
                                  & $lesseq(0,M) ) )
                             <= ( first_primes1(tb2t2(mk_array1(int,M,t2tb3(P2))),J)
                                & no_prime_in1(tb2t1(get(int,int,t2tb3(P2),t2tb1($difference(J,1)))),N)
                                & odd1(N)
                                & $less(N,$product(2,tb2t1(get(int,int,t2tb3(P2),t2tb1($difference(J,1))))))
                                & $less(tb2t1(get(int,int,t2tb3(P2),t2tb1($difference(J,1)))),N) ) ) )
                       <= $lesseq(2,$difference(M,1)) )
                     <= ( ( P1 = tb2t3(set(int,int,t2tb3(P),t2tb1(1),t2tb1(3))) )
                        & $lesseq(0,M) ) )
                 <= ( $less(1,M)
                    & $lesseq(0,1) ) ) ) ) )
       <= $lesseq(0,M) ) ) ).

tff(mod_1,axiom,
    ! [X: $int] : ( mod2(X,1) = 0 ) ).

tff(mod_divides_computer,axiom,
    ! [A: $int,B: $int] :
      ( ( divides1(B,A)
       <= ( mod2(A,B) = 0 ) )
     <= ( B != 0 ) ) ).

tff(mk_array_sort1,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),mk_array1(A,X,X1)) ).

tff(even_odd,axiom,
    ! [N: $int] :
      ( even1(N)
     => odd1($sum(N,1)) ) ).

tff(prime_divisors,axiom,
    ! [P: $int] :
      ( ! [D: $int] :
          ( ( ( D = 1 )
            | ( D = $uminus(P) )
            | ( D = P )
            | ( D = $uminus(1) ) )
         <= divides1(D,P) )
     <= prime1(P) ) ).

tff(div_mod,axiom,
    ! [X: $int,Y: $int] :
      ( ( X = $sum($product(Y,div2(X,Y)),mod2(X,Y)) )
     <= ( Y != 0 ) ) ).

tff(divides_right,axiom,
    ! [A: $int,B: $int,C: $int] :
      ( divides1($product(A,C),$product(B,C))
     <= divides1(A,B) ) ).

tff(div_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(0,X)
        & $less(X,Y) )
     => ( div2(X,Y) = 0 ) ) ).

tff(mod_divides_euclidean,axiom,
    ! [A: $int,B: $int] :
      ( ( divides1(B,A)
       <= ( $remainder_e(A,B) = 0 ) )
     <= ( B != 0 ) ) ).

tff(ref_inversion1,axiom,
    ! [A: ty,U: uni] :
      ( sort1(ref(A),U)
     => ( U = mk_ref(A,contents(A,U)) ) ) ).

tff(bridgeL2,axiom,
    ! [I: array_int] : ( tb2t2(t2tb2(I)) = I ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool1(A,false1,Z,Z1) = Z1 )
     <= sort1(A,Z1) ) ).

tff(true_False,axiom,
    true1 != false1 ).

tff(odd_even,axiom,
    ! [N: $int] :
      ( odd1(N)
     => even1($sum(N,1)) ) ).

tff(odd_2k1,axiom,
    ! [K: $int] : odd1($sum($product(2,K),1)) ).

tff(make_sort1,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),make1(A,X,X1)) ).

tff(divides_def,axiom,
    ! [D: $int,N: $int] :
      ( ? [Q: $int] : ( N = $product(Q,D) )
    <=> divides1(D,N) ) ).

tff(small_divisors,axiom,
    ! [P: $int] :
      ( ( prime1(P)
       <= ! [D: $int] :
            ( ( prime1(D)
             => ( ( $less(1,$product(D,D))
                  & $lesseq($product(D,D),P) )
               => ~ divides1(D,P) ) )
           <= $lesseq(2,D) ) )
     <= $lesseq(2,P) ) ).

tff(div_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(0,X)
        & $less(0,Y) )
     => $lesseq(0,div2(X,Y)) ) ).

tff(divides_0,axiom,
    ! [N: $int] : divides1(N,0) ).

tff(match_bool_sort1,axiom,
    ! [A: ty,X: bool1,X1: uni,X2: uni] : sort1(A,match_bool1(A,X,X1,X2)) ).

tff(even_not_odd,axiom,
    ! [N: $int] :
      ( ~ odd1(N)
     <= even1(N) ) ).

tff(divides_multr,axiom,
    ! [A: $int,B: $int,C: $int] :
      ( divides1(A,B)
     => divides1(A,$product(B,C)) ) ).

tff(div_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(0,X)
        & $less(0,Y) )
     => ( $lesseq(0,div2(X,Y))
        & $lesseq(div2(X,Y),X) ) ) ).

tff(set_def,axiom,
    ! [A: ty,A1: uni,I: $int,V: uni] : ( set2(A,A1,I,V) = mk_array1(A,length1(A,A1),set(A,int,elts(A,A1),t2tb1(I),V)) ) ).

tff(tuple2_proj_1_sort1,axiom,
    ! [A: ty,A1: ty,X: uni] : sort1(A1,tuple2_proj_11(A1,A,X)) ).

tff(mod_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( ( ( Y != 0 )
        & $lesseq(X,0) )
     => $lesseq(mod2(X,Y),0) ) ).

tff(bridgeR3,axiom,
    ! [J: uni] : ( t2tb3(tb2t3(J)) = J ) ).

tff(even_or_odd,axiom,
    ! [N: $int] :
      ( even1(N)
      | odd1(N) ) ).

tff(mod_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(0,mod2(X,Y))
     <= ( $lesseq(0,X)
        & ( Y != 0 ) ) ) ).

tff(prime_3,axiom,
    prime1(3) ).

tff(lex_1,axiom,
    ! [X1: $int,X2: $int,Y1: $int,Y2: $int] :
      ( lt_nat1(X1,X2)
     => lex1(tb2t(tuple21(int,int,t2tb1(X1),t2tb1(Y1))),tb2t(tuple21(int,int,t2tb1(X2),t2tb1(Y2)))) ) ).

tff(mod_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( mod2($sum($product(X,Y),Z),X) = mod2(Z,X) )
     <= ( $lesseq(0,Z)
        & $lesseq(0,Y)
        & $less(0,X) ) ) ).

tff(prime_2,axiom,
    prime1(2) ).

tff(contents_def1,axiom,
    ! [A: ty,U: uni] :
      ( sort1(A,U)
     => ( contents(A,mk_ref(A,U)) = U ) ) ).

tff(mod_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( mod2(X,Y) = X )
     <= ( $less(X,Y)
        & $lesseq(0,X) ) ) ).

