tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort: ( ty * uni ) > $o ).

tff(witness,type,
    witness: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool: $tType ).

tff(bool1,type,
    bool1: ty ).

tff(true,type,
    true: bool ).

tff(false,type,
    false: bool ).

tff(match_bool,type,
    match_bool: ( ty * bool * uni * uni ) > uni ).

tff(tuple0,type,
    tuple0: $tType ).

tff(tuple01,type,
    tuple01: ty ).

tff(tuple02,type,
    tuple02: tuple0 ).

tff(qtmark,type,
    qtmark: ty ).

tff(list,type,
    list: ty > ty ).

tff(nil,type,
    nil: ty > uni ).

tff(cons,type,
    cons: ( ty * uni * uni ) > uni ).

tff(match_list,type,
    match_list: ( ty * ty * uni * uni * uni ) > uni ).

tff(cons_proj_1,type,
    cons_proj_1: ( ty * uni ) > uni ).

tff(cons_proj_2,type,
    cons_proj_2: ( ty * uni ) > uni ).

tff(head,type,
    head: ( ty * uni ) > uni ).

tff(tail,type,
    tail: ( ty * uni ) > uni ).

tff(mem,type,
    mem: ( ty * uni * uni ) > $o ).

tff(disjoint,type,
    disjoint: ( ty * uni * uni ) > $o ).

tff(no_repet,type,
    no_repet: ( ty * uni ) > $o ).

tff(infix_plpl,type,
    infix_plpl: ( ty * uni * uni ) > uni ).

tff(length,type,
    length: ( ty * uni ) > $int ).

tff(reverse,type,
    reverse: ( ty * uni ) > uni ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(const,type,
    const: ( ty * ty * uni ) > uni ).

tff(loc,type,
    loc: $tType ).

tff(loc1,type,
    loc1: ty ).

tff(null,type,
    null: loc ).

tff(list_loc,type,
    list_loc: $tType ).

tff(map_loc_loc,type,
    map_loc_loc: $tType ).

tff(list_seg,type,
    list_seg: ( loc * map_loc_loc * list_loc * loc ) > $o ).

tff(t2tb,type,
    t2tb: list_loc > uni ).

tff(tb2t,type,
    tb2t: uni > list_loc ).

tff(t2tb1,type,
    t2tb1: map_loc_loc > uni ).

tff(tb2t1,type,
    tb2t1: uni > map_loc_loc ).

tff(t2tb2,type,
    t2tb2: loc > uni ).

tff(tb2t2,type,
    tb2t2: uni > loc ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(bridgeL2,axiom,
    ! [I: loc] : ( tb2t2(t2tb2(I)) = I ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple0] : ( U = tuple02 ) ).

tff(length_def,axiom,
    ! [A: ty] :
      ( ! [X: uni,X1: uni] : ( length(A,cons(A,X,X1)) = $sum(1,length(A,X1)) )
      & ( length(A,nil(A)) = 0 ) ) ).

tff(tail_cons,axiom,
    ! [A: ty,X: uni,L: uni] : ( tail(A,cons(A,X,L)) = L ) ).

tff(bool_inversion,axiom,
    ! [U: bool] :
      ( ( U = false )
      | ( U = true ) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) )
     <= $lesseq(X,Y) ) ).

tff(list_inversion,axiom,
    ! [A: ty,U: uni] :
      ( ( U = nil(A) )
      | ( U = cons(A,cons_proj_1(A,U),cons_proj_2(A,U)) ) ) ).

tff(const1,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( ( get(B,A,const(B,A,B1),A1) = B1 )
     <= sort(B,B1) ) ).

tff(reverse_append,axiom,
    ! [A: ty,L1: uni,L2: uni,X: uni] : ( infix_plpl(A,reverse(A,cons(A,X,L1)),L2) = infix_plpl(A,reverse(A,L1),cons(A,X,L2)) ) ).

tff(cons_proj_2_def,axiom,
    ! [A: ty,U: uni,U1: uni] : ( cons_proj_2(A,cons(A,U,U1)) = U1 ) ).

tff(infix_plpl_def,axiom,
    ! [A: ty,L2: uni] :
      ( ! [X: uni,X1: uni] : ( infix_plpl(A,cons(A,X,X1),L2) = cons(A,X,infix_plpl(A,X1,L2)) )
      & ( infix_plpl(A,nil(A),L2) = L2 ) ) ).

tff(list_seg_sublistl,axiom,
    ! [Next: map_loc_loc,L1: list_loc,L2: list_loc,P: loc,Q: loc] :
      ( list_seg(P,Next,tb2t(infix_plpl(loc1,t2tb(L1),cons(loc1,t2tb2(Q),t2tb(L2)))),null)
     => list_seg(Q,Next,tb2t(cons(loc1,t2tb2(Q),t2tb(L2))),null) ) ).

tff(t2tb_sort1,axiom,
    ! [X: map_loc_loc] : sort(map(loc1,loc1),t2tb1(X)) ).

tff(head_sort,axiom,
    ! [A: ty,X: uni] : sort(A,head(A,X)) ).

tff(list_seg_frame,axiom,
    ! [Next1: map_loc_loc,Next2: map_loc_loc,P: loc,Q: loc,V: loc,PM: list_loc] :
      ( list_seg(P,Next2,PM,null)
     <= ( list_seg(P,Next1,PM,null)
        & ~ mem(loc1,t2tb2(Q),t2tb(PM))
        & ( Next2 = tb2t1(set(loc1,loc1,t2tb1(Next1),t2tb2(Q),t2tb2(V))) ) ) ) ).

tff(get_sort,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort(B,get(B,A,X,X1)) ).

tff(bridgeR1,axiom,
    ! [J: uni] :
      ( sort(map(loc1,loc1),J)
     => ( t2tb1(tb2t1(J)) = J ) ) ).

tff(append_length,axiom,
    ! [A: ty,L1: uni,L2: uni] : ( length(A,infix_plpl(A,L1,L2)) = $sum(length(A,L1),length(A,L2)) ) ).

tff(append_assoc,axiom,
    ! [A: ty,L1: uni,L2: uni,L3: uni] : ( infix_plpl(A,L1,infix_plpl(A,L2,L3)) = infix_plpl(A,infix_plpl(A,L1,L2),L3) ) ).

tff(cons_proj_1_sort,axiom,
    ! [A: ty,X: uni] : sort(A,cons_proj_1(A,X)) ).

tff(true_False,axiom,
    true != false ).

tff(wP_parameter_in_place_reverse,conjecture,
    ! [L: loc,LM: list_loc,Next: map_loc_loc] :
      ( ! [RM: list_loc,R: loc,PM: list_loc,P: loc,Next1: map_loc_loc] :
          ( ( list_seg(P,Next1,PM,null)
            & list_seg(R,Next1,RM,null)
            & ( tb2t(infix_plpl(loc1,reverse(loc1,t2tb(PM)),t2tb(RM))) = tb2t(reverse(loc1,t2tb(LM))) )
            & disjoint(loc1,t2tb(PM),t2tb(RM)) )
         => ( ( P != null )
           => ! [Next2: map_loc_loc] :
                ( ( list_seg(R,Next2,RM,null)
                 => ! [R1: loc] :
                      ( ! [P1: loc] :
                          ( ( P1 = tb2t2(get(loc1,loc1,t2tb1(Next1),t2tb2(P))) )
                         => ! [RM1: list_loc] :
                              ( ! [PM1: list_loc] :
                                  ( ( ! [X: loc,X1: list_loc] :
                                        ( ( PM = tb2t(cons(loc1,t2tb2(X),t2tb(X1))) )
                                       => ( X1 = PM1 ) )
                                    & ( PM != tb2t(nil(loc1)) ) )
                                 <= ( PM1 = tb2t(tail(loc1,t2tb(PM))) ) )
                             <= ( RM1 = tb2t(cons(loc1,head(loc1,t2tb(PM)),t2tb(RM))) ) ) )
                     <= ( R1 = P ) ) )
               <= ( Next2 = tb2t1(set(loc1,loc1,t2tb1(Next1),t2tb2(P),t2tb2(R))) ) ) ) )
     <= list_seg(L,Next,LM,null) ) ).

tff(disjoint_def,axiom,
    ! [A: ty,L1: uni,L2: uni] :
      ( ( disjoint(A,L1,L2)
       <= ! [X: uni] :
            ( sort(A,X)
           => ~ ( mem(A,X,L1)
                & mem(A,X,L2) ) ) )
      & ( disjoint(A,L1,L2)
       => ! [X: uni] :
            ~ ( mem(A,X,L2)
              & mem(A,X,L1) ) ) ) ).

tff(tail_sort,axiom,
    ! [A: ty,X: uni] : sort(list(A),tail(A,X)) ).

tff(append_l_nil,axiom,
    ! [A: ty,L: uni] : ( infix_plpl(A,L,nil(A)) = L ) ).

tff(nil_Cons,axiom,
    ! [A: ty,V: uni,V1: uni] : ( nil(A) != cons(A,V,V1) ) ).

tff(set_sort,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort(map(A,B),set(B,A,X,X1,X2)) ).

tff(contents_sort,axiom,
    ! [A: ty,X: uni] : sort(A,contents(A,X)) ).

tff(list_seg_cons,axiom,
    ! [P: loc,Q: loc,Next: map_loc_loc,L: list_loc] :
      ( ( list_seg(tb2t2(get(loc1,loc1,t2tb1(Next),t2tb2(P))),Next,L,Q)
        & ( P != null ) )
     => list_seg(P,Next,tb2t(cons(loc1,t2tb2(P),t2tb(L))),Q) ) ).

tff(match_list_Cons,axiom,
    ! [A: ty,A1: ty,Z: uni,Z1: uni,U: uni,U1: uni] :
      ( sort(A1,Z1)
     => ( match_list(A1,A,cons(A,U,U1),Z,Z1) = Z1 ) ) ).

tff(bridgeR2,axiom,
    ! [J: uni] :
      ( ( t2tb2(tb2t2(J)) = J )
     <= sort(loc1,J) ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool(A,true,Z,Z1) = Z )
     <= sort(A,Z) ) ).

tff(mem_def,axiom,
    ! [A: ty,X: uni] :
      ( ( ~ mem(A,X,nil(A))
        & ! [X1: uni,X2: uni] :
            ( sort(A,X1)
           => ( mem(A,X,cons(A,X1,X2))
            <=> ( ( X = X1 )
                | mem(A,X,X2) ) ) ) )
     <= sort(A,X) ) ).

tff(reverse_sort,axiom,
    ! [A: ty,X: uni] : sort(list(A),reverse(A,X)) ).

tff(mk_ref_sort,axiom,
    ! [A: ty,X: uni] : sort(ref(A),mk_ref(A,X)) ).

tff(reverse_mem,axiom,
    ! [A: ty,L: uni,X: uni] :
      ( mem(A,X,reverse(A,L))
    <=> mem(A,X,L) ) ).

tff(length_nil,axiom,
    ! [A: ty,L: uni] :
      ( ( L = nil(A) )
    <=> ( length(A,L) = 0 ) ) ).

tff(match_bool_sort,axiom,
    ! [A: ty,X: bool,X1: uni,X2: uni] : sort(A,match_bool(A,X,X1,X2)) ).

tff(reverse_def,axiom,
    ! [A: ty] :
      ( ! [X: uni,X1: uni] : ( reverse(A,cons(A,X,X1)) = infix_plpl(A,reverse(A,X1),cons(A,X,nil(A))) )
      & ( reverse(A,nil(A)) = nil(A) ) ) ).

tff(infix_plpl_sort,axiom,
    ! [A: ty,X: uni,X1: uni] : sort(list(A),infix_plpl(A,X,X1)) ).

tff(cons_proj_1_def,axiom,
    ! [A: ty,U: uni,U1: uni] :
      ( ( cons_proj_1(A,cons(A,U,U1)) = U )
     <= sort(A,U) ) ).

tff(bridgeL,axiom,
    ! [I: list_loc] : ( tb2t(t2tb(I)) = I ) ).

tff(list_seg_no_repet,axiom,
    ! [Next: map_loc_loc,PM: list_loc,P: loc] :
      ( no_repet(loc1,t2tb(PM))
     <= list_seg(P,Next,PM,null) ) ).

tff(reverse_length,axiom,
    ! [A: ty,L: uni] : ( length(A,reverse(A,L)) = length(A,L) ) ).

tff(select_eq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( sort(B,B1)
     => ( ( get(B,A,set(B,A,M,A1,B1),A2) = B1 )
       <= ( A1 = A2 ) ) ) ).

tff(list_seg_inversion,axiom,
    ! [Z: loc,Z1: map_loc_loc,Z2: list_loc,Z3: loc] :
      ( ( ? [P: loc,Next: map_loc_loc] :
            ( ( Z2 = tb2t(nil(loc1)) )
            & ( Z3 = P )
            & ( Z1 = Next )
            & ( Z = P ) )
        | ? [P: loc,Q: loc,Next: map_loc_loc,L: list_loc] :
            ( ( Z1 = Next )
            & ( Z3 = Q )
            & ( Z2 = tb2t(cons(loc1,t2tb2(P),t2tb(L))) )
            & ( Z = P )
            & list_seg(tb2t2(get(loc1,loc1,t2tb1(Next),t2tb2(P))),Next,L,Q)
            & ( P != null ) ) )
     <= list_seg(Z,Z1,Z2,Z3) ) ).

tff(match_list_sort,axiom,
    ! [A: ty,A1: ty,X: uni,X1: uni,X2: uni] : sort(A1,match_list(A1,A,X,X1,X2)) ).

tff(list_seg_functional,axiom,
    ! [Next: map_loc_loc,L1: list_loc,L2: list_loc,P: loc] :
      ( ( list_seg(P,Next,L2,null)
        & list_seg(P,Next,L1,null) )
     => ( L1 = L2 ) ) ).

tff(bridgeL1,axiom,
    ! [I: map_loc_loc] : ( tb2t1(t2tb1(I)) = I ) ).

tff(mem_decomp,axiom,
    ! [A: ty,X: uni,L: uni] :
      ( mem(A,X,L)
     => ? [L1: uni,L2: uni] :
          ( sort(list(A),L2)
          & ( L = infix_plpl(A,L1,cons(A,X,L2)) )
          & sort(list(A),L1) ) ) ).

tff(reverse_reverse,axiom,
    ! [A: ty,L: uni] : ( reverse(A,reverse(A,L)) = L ) ).

tff(match_list_Nil,axiom,
    ! [A: ty,A1: ty,Z: uni,Z1: uni] :
      ( sort(A1,Z)
     => ( match_list(A1,A,nil(A),Z,Z1) = Z ) ) ).

tff(ref_inversion,axiom,
    ! [A: ty,U: uni] :
      ( ( U = mk_ref(A,contents(A,U)) )
     <= sort(ref(A),U) ) ).

tff(contents_def,axiom,
    ! [A: ty,U: uni] :
      ( ( contents(A,mk_ref(A,U)) = U )
     <= sort(A,U) ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool(A,false,Z,Z1) = Z1 )
     <= sort(A,Z1) ) ).

tff(select_neq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( sort(A,A1)
     => ( ! [B1: uni] :
            ( ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) )
           <= ( A1 != A2 ) )
       <= sort(A,A2) ) ) ).

tff(cons_proj_2_sort,axiom,
    ! [A: ty,X: uni] : sort(list(A),cons_proj_2(A,X)) ).

tff(length_nonnegative,axiom,
    ! [A: ty,L: uni] : $lesseq(0,length(A,L)) ).

tff(no_repet_def,axiom,
    ! [A: ty] :
      ( ! [X: uni,X1: uni] :
          ( no_repet(A,cons(A,X,X1))
        <=> ( ~ mem(A,X,X1)
            & no_repet(A,X1) ) )
      & no_repet(A,nil(A)) ) ).

tff(cons_sort,axiom,
    ! [A: ty,X: uni,X1: uni] : sort(list(A),cons(A,X,X1)) ).

tff(witness_sort,axiom,
    ! [A: ty] : sort(A,witness(A)) ).

tff(t2tb_sort,axiom,
    ! [X: list_loc] : sort(list(loc1),t2tb(X)) ).

tff(reverse_cons,axiom,
    ! [A: ty,L: uni,X: uni] : ( reverse(A,cons(A,X,L)) = infix_plpl(A,reverse(A,L),cons(A,X,nil(A))) ) ).

tff(head_cons,axiom,
    ! [A: ty,X: uni,L: uni] :
      ( ( head(A,cons(A,X,L)) = X )
     <= sort(A,X) ) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(list_seg_nil,axiom,
    ! [P: loc,Next: map_loc_loc] : list_seg(P,Next,tb2t(nil(loc1)),P) ).

tff(t2tb_sort2,axiom,
    ! [X: loc] : sort(loc1,t2tb2(X)) ).

tff(mem_append,axiom,
    ! [A: ty,X: uni,L1: uni,L2: uni] :
      ( mem(A,X,infix_plpl(A,L1,L2))
    <=> ( mem(A,X,L1)
        | mem(A,X,L2) ) ) ).

tff(nil_sort,axiom,
    ! [A: ty] : sort(list(A),nil(A)) ).

tff(const_sort,axiom,
    ! [A: ty,B: ty,X: uni] : sort(map(A,B),const(B,A,X)) ).

