tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort1: ( ty * uni ) > $o ).

tff(witness,type,
    witness1: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool1: $tType ).

tff(bool1,type,
    bool: ty ).

tff(true,type,
    true1: bool1 ).

tff(false,type,
    false1: bool1 ).

tff(match_bool,type,
    match_bool1: ( ty * bool1 * uni * uni ) > uni ).

tff(tuple0,type,
    tuple02: $tType ).

tff(tuple01,type,
    tuple0: ty ).

tff(tuple02,type,
    tuple03: tuple02 ).

tff(qtmark,type,
    qtmark: ty ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(const1,type,
    const: ( ty * ty * uni ) > uni ).

tff(array,type,
    array: ty > ty ).

tff(mk_array,type,
    mk_array1: ( ty * $int * uni ) > uni ).

tff(length,type,
    length1: ( ty * uni ) > $int ).

tff(elts,type,
    elts: ( ty * uni ) > uni ).

tff(get1,type,
    get2: ( ty * uni * $int ) > uni ).

tff(t2tb,type,
    t2tb: $int > uni ).

tff(tb2t,type,
    tb2t: uni > $int ).

tff(set1,type,
    set2: ( ty * uni * $int * uni ) > uni ).

tff(make,type,
    make1: ( ty * $int * uni ) > uni ).

tff(elt,type,
    elt1: $tType ).

tff(elt1,type,
    elt: ty ).

tff(le,type,
    le1: ( elt1 * elt1 ) > $o ).

tff(array_elt,type,
    array_elt: $tType ).

tff(sorted_sub,type,
    sorted_sub1: ( array_elt * $int * $int ) > $o ).

tff(t2tb1,type,
    t2tb1: array_elt > uni ).

tff(tb2t1,type,
    tb2t1: uni > array_elt ).

tff(t2tb2,type,
    t2tb2: elt1 > uni ).

tff(tb2t2,type,
    tb2t2: uni > elt1 ).

tff(sorted,type,
    sorted1: array_elt > $o ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(occ,type,
    occ1: ( ty * uni * uni * $int * $int ) > $int ).

tff(permut,type,
    permut2: ( ty * uni * uni * $int * $int ) > $o ).

tff(map_eq_sub,type,
    map_eq_sub1: ( ty * uni * uni * $int * $int ) > $o ).

tff(array_eq_sub,type,
    array_eq_sub1: ( ty * uni * uni * $int * $int ) > $o ).

tff(array_eq,type,
    array_eq: ( ty * uni * uni ) > $o ).

tff(exchange,type,
    exchange2: ( ty * uni * uni * $int * $int * $int * $int ) > $o ).

tff(exchange1,type,
    exchange3: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut1,type,
    permut3: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut_sub,type,
    permut_sub1: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut_all,type,
    permut_all: ( ty * uni * uni ) > $o ).

tff(map_int_elt,type,
    map_int_elt: $tType ).

tff(t2tb3,type,
    t2tb3: map_int_elt > uni ).

tff(tb2t3,type,
    tb2t3: uni > map_int_elt ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) )
     <= $lesseq(X,Y) ) ).

tff(occ_pos,axiom,
    ! [A: ty,M: uni,L: $int,U: $int,I: $int] :
      ( $less(0,occ1(A,get(A,int,M,t2tb(I)),M,L,U))
     <= ( $less(I,U)
        & $lesseq(L,I) ) ) ).

tff(map_eq_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( map_eq_sub1(A,A1,A2,L,U)
    <=> ! [I: $int] :
          ( ( $lesseq(L,I)
            & $less(I,U) )
         => ( get(A,int,A1,t2tb(I)) = get(A,int,A2,t2tb(I)) ) ) ) ).

tff(set_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort1(map(A,B),set(B,A,X,X1,X2)) ).

tff(occ_right_no_add,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( $less(L,U)
       => ( ( get(A,int,M,t2tb($difference(U,1))) != V )
         => ( occ1(A,V,M,L,U) = occ1(A,V,M,L,$difference(U,1)) ) ) )
     <= sort1(A,V) ) ).

tff(array_inversion1,axiom,
    ! [A: ty,U: uni] : ( U = mk_array1(A,length1(A,U),elts(A,U)) ) ).

tff(make_sort1,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),make1(A,X,X1)) ).

tff(true_False,axiom,
    true1 != false1 ).

tff(bool_inversion,axiom,
    ! [U: bool1] :
      ( ( U = true1 )
      | ( U = false1 ) ) ).

tff(const,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( sort1(B,B1)
     => ( get(B,A,const(B,A,B1),A1) = B1 ) ) ).

tff(wP_parameter_merge,conjecture,
    ! [Tmp: $int,Tmp1: map_int_elt,A: $int,A1: map_int_elt,L: $int,M: $int,R: $int] :
      ( ( $lesseq(0,Tmp)
        & $lesseq(0,A)
        & $lesseq(0,L)
        & $lesseq(L,M)
        & $lesseq(R,Tmp)
        & sorted_sub1(tb2t1(mk_array1(elt,Tmp,t2tb3(Tmp1))),L,M)
        & sorted_sub1(tb2t1(mk_array1(elt,Tmp,t2tb3(Tmp1))),M,R)
        & ( Tmp = A )
        & $lesseq(M,R) )
     => ( $lesseq(L,$difference(R,1))
       => ! [J: $int,I: $int,A2: map_int_elt,K: $int] :
            ( ( $lesseq(K,$difference(R,1))
              & $lesseq(L,K) )
           => ( ( $lesseq(I,M)
                & $lesseq(M,J)
                & ! [I1: $int] :
                    ( ( tb2t2(get(elt,int,t2tb3(A2),t2tb(I1))) = tb2t2(get(elt,int,t2tb3(A1),t2tb(I1))) )
                   <= ( ( $lesseq(0,I1)
                        & $less(I1,L) )
                      | ( $lesseq(R,I1)
                        & $less(I1,A) ) ) )
                & ! [V: elt1] : ( $sum(occ1(elt,t2tb2(V),t2tb3(Tmp1),L,I),occ1(elt,t2tb2(V),t2tb3(Tmp1),M,J)) = occ1(elt,t2tb2(V),t2tb3(A2),L,K) )
                & ! [X: $int,Y: $int] :
                    ( ( $less(X,K)
                      & $lesseq(L,X) )
                   => ( ( $less(Y,R)
                        & $lesseq(J,Y) )
                     => le1(tb2t2(get(elt,int,t2tb3(A2),t2tb(X))),tb2t2(get(elt,int,t2tb3(Tmp1),t2tb(Y)))) ) )
                & ! [X: $int,Y: $int] :
                    ( ( $lesseq(L,X)
                      & $less(X,K) )
                   => ( le1(tb2t2(get(elt,int,t2tb3(A2),t2tb(X))),tb2t2(get(elt,int,t2tb3(Tmp1),t2tb(Y))))
                     <= ( $lesseq(I,Y)
                        & $less(Y,M) ) ) )
                & sorted_sub1(tb2t1(mk_array1(elt,A,t2tb3(A2))),L,K)
                & ( $difference($sum($difference(I,L),J),M) = $difference(K,L) )
                & $lesseq(J,R)
                & $lesseq(L,I) )
             => ( $less(I,M)
               => ( ( J != R )
                 => ( ( $lesseq(0,J)
                      & $less(J,Tmp) )
                   => ( ( le1(tb2t2(get(elt,int,t2tb3(Tmp1),t2tb(I))),tb2t2(get(elt,int,t2tb3(Tmp1),t2tb(J))))
                       => ( ( ! [A3: map_int_elt] :
                                ( ( ( A3 = tb2t3(set(elt,int,t2tb3(A2),t2tb(K),get(elt,int,t2tb3(Tmp1),t2tb(I)))) )
                                  & $lesseq(0,A) )
                               => ! [I1: $int] :
                                    ( ( I1 = $sum(I,1) )
                                   => ! [V: elt1] : ( $sum(occ1(elt,t2tb2(V),t2tb3(Tmp1),L,I1),occ1(elt,t2tb2(V),t2tb3(Tmp1),M,J)) = occ1(elt,t2tb2(V),t2tb3(A3),L,$sum(K,1)) ) ) )
                           <= ( $lesseq(0,A)
                              & $lesseq(0,K)
                              & $less(K,A) ) )
                         <= ( $lesseq(0,I)
                            & $less(I,Tmp) ) ) )
                     <= ( $less(I,Tmp)
                        & $lesseq(0,I) ) ) ) ) ) ) ) ) ) ).

tff(exchange_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int,I: $int,J: $int] :
      ( ( $less(I,U)
        & $lesseq(L,J)
        & ( get(A,int,A1,t2tb(I)) = get(A,int,A2,t2tb(J)) )
        & ! [K: $int] :
            ( ( $lesseq(L,K)
              & $less(K,U) )
           => ( ( ( K != J )
               => ( get(A,int,A1,t2tb(K)) = get(A,int,A2,t2tb(K)) ) )
             <= ( K != I ) ) )
        & ( get(A,int,A1,t2tb(J)) = get(A,int,A2,t2tb(I)) )
        & $less(J,U)
        & $lesseq(L,I) )
    <=> exchange2(A,A1,A2,L,U,I,J) ) ).

tff(witness_sort1,axiom,
    ! [A: ty] : sort1(A,witness1(A)) ).

tff(array_eq_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( array_eq_sub1(A,A1,A2,L,U)
    <=> ( $lesseq(0,L)
        & $lesseq(L,length1(A,A1))
        & map_eq_sub1(A,elts(A,A1),elts(A,A2),L,U)
        & $lesseq(U,length1(A,A1))
        & $lesseq(0,U)
        & ( length1(A,A1) = length1(A,A2) ) ) ) ).

tff(trans1,axiom,
    ! [X: elt1,Y: elt1,Z: elt1] :
      ( ( le1(X,Z)
       <= le1(Y,Z) )
     <= le1(X,Y) ) ).

tff(mk_array_sort1,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),mk_array1(A,X,X1)) ).

tff(bridgeL1,axiom,
    ! [I: array_elt] : ( tb2t1(t2tb1(I)) = I ) ).

tff(contents_sort1,axiom,
    ! [A: ty,X: uni] : sort1(A,contents(A,X)) ).

tff(ref_inversion1,axiom,
    ! [A: ty,U: uni] :
      ( sort1(ref(A),U)
     => ( U = mk_ref(A,contents(A,U)) ) ) ).

tff(make_def,axiom,
    ! [A: ty,N: $int,V: uni] : ( make1(A,N,V) = mk_array1(A,N,const(A,int,V)) ) ).

tff(array_eq_def,axiom,
    ! [A: ty,A1: uni,A2: uni] :
      ( ( ( length1(A,A1) = length1(A,A2) )
        & map_eq_sub1(A,elts(A,A1),elts(A,A2),0,length1(A,A1)) )
    <=> array_eq(A,A1,A2) ) ).

tff(bridgeL,axiom,
    ! [I: $int] : ( tb2t(t2tb(I)) = I ) ).

tff(t2tb_sort2,axiom,
    ! [X: elt1] : sort1(elt,t2tb2(X)) ).

tff(bridgeL2,axiom,
    ! [I: elt1] : ( tb2t2(t2tb2(I)) = I ) ).

tff(const_sort1,axiom,
    ! [A: ty,B: ty,X: uni] : sort1(map(A,B),const(B,A,X)) ).

tff(length_def1,axiom,
    ! [A: ty,U: $int,U1: uni] : ( length1(A,mk_array1(A,U,U1)) = U ) ).

tff(occ_eq,axiom,
    ! [A: ty,V: uni,M1: uni,M2: uni,L: $int,U: $int] :
      ( ( occ1(A,V,M1,L,U) = occ1(A,V,M2,L,U) )
     <= ! [I: $int] :
          ( ( get(A,int,M1,t2tb(I)) = get(A,int,M2,t2tb(I)) )
         <= ( $lesseq(L,I)
            & $less(I,U) ) ) ) ).

tff(permut_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( ( map_eq_sub1(A,elts(A,A1),elts(A,A2),U,length1(A,A1))
        & permut3(A,A1,A2,L,U)
        & map_eq_sub1(A,elts(A,A1),elts(A,A2),0,L) )
    <=> permut_sub1(A,A1,A2,L,U) ) ).

tff(permut_trans,axiom,
    ! [A: ty,A1: uni,A2: uni,A3: uni,L: $int,U: $int] :
      ( permut2(A,A1,A2,L,U)
     => ( permut2(A,A1,A3,L,U)
       <= permut2(A,A2,A3,L,U) ) ) ).

tff(occ_empty,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( occ1(A,V,M,L,U) = 0 )
     <= $lesseq(U,L) ) ).

tff(occ_bounds,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( $lesseq(L,U)
     => ( $lesseq(0,occ1(A,V,M,L,U))
        & $lesseq(occ1(A,V,M,L,U),$difference(U,L)) ) ) ).

tff(elts_sort1,axiom,
    ! [A: ty,X: uni] : sort1(map(int,A),elts(A,X)) ).

tff(select_eq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( sort1(B,B1)
     => ( ( A1 = A2 )
       => ( get(B,A,set(B,A,M,A1,B1),A2) = B1 ) ) ) ).

tff(permut_def1,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( ( $lesseq(0,L)
        & $lesseq(U,length1(A,A1))
        & permut2(A,elts(A,A1),elts(A,A2),L,U)
        & $lesseq(0,U)
        & $lesseq(L,length1(A,A1))
        & ( length1(A,A1) = length1(A,A2) ) )
    <=> permut3(A,A1,A2,L,U) ) ).

tff(occ_exists,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( $less(0,occ1(A,V,M,L,U))
       => ? [I: $int] :
            ( $lesseq(L,I)
            & ( get(A,int,M,t2tb(I)) = V )
            & $less(I,U) ) )
     <= sort1(A,V) ) ).

tff(select_neq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( ( sort1(A,A2)
       => ! [B1: uni] :
            ( ( A1 != A2 )
           => ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) ) ) )
     <= sort1(A,A1) ) ).

tff(exchange_permut_sub,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int,L: $int,U: $int] :
      ( exchange3(A,A1,A2,I,J)
     => ( ( $less(I,U)
          & $lesseq(L,I) )
       => ( ( $less(J,U)
            & $lesseq(L,J) )
         => ( ( permut_sub1(A,A1,A2,L,U)
             <= $lesseq(U,length1(A,A1)) )
           <= $lesseq(0,L) ) ) ) ) ).

tff(occ_right_add,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( ( get(A,int,M,t2tb($difference(U,1))) = V )
       => ( occ1(A,V,M,L,U) = $sum(1,occ1(A,V,M,L,$difference(U,1))) ) )
     <= $less(L,U) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple02] : ( U = tuple03 ) ).

tff(occ_neq,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( sort1(A,V)
     => ( ! [I: $int] :
            ( ( get(A,int,M,t2tb(I)) != V )
           <= ( $lesseq(L,I)
              & $less(I,U) ) )
       => ( occ1(A,V,M,L,U) = 0 ) ) ) ).

tff(sorted_sub_def,axiom,
    ! [A: array_elt,L: $int,U: $int] :
      ( ! [I1: $int,I2: $int] :
          ( ( $lesseq(L,I1)
            & $less(I2,U)
            & $lesseq(I1,I2) )
         => le1(tb2t2(get2(elt,t2tb1(A),I1)),tb2t2(get2(elt,t2tb1(A),I2))) )
    <=> sorted_sub1(A,L,U) ) ).

tff(t2tb_sort1,axiom,
    ! [X: array_elt] : sort1(array(elt),t2tb1(X)) ).

tff(exchange_def1,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int] :
      ( exchange3(A,A1,A2,I,J)
    <=> ( ( length1(A,A1) = length1(A,A2) )
        & exchange2(A,elts(A,A1),elts(A,A2),0,length1(A,A1),I,J) ) ) ).

tff(set_def,axiom,
    ! [A: ty,A1: uni,I: $int,V: uni] : ( set2(A,A1,I,V) = mk_array1(A,length1(A,A1),set(A,int,elts(A,A1),t2tb(I),V)) ) ).

tff(total1,axiom,
    ! [X: elt1,Y: elt1] :
      ( le1(X,Y)
      | le1(Y,X) ) ).

tff(get_sort3,axiom,
    ! [A: ty,X: uni,X1: $int] : sort1(A,get2(A,X,X1)) ).

tff(mk_ref_sort1,axiom,
    ! [A: ty,X: uni] : sort1(ref(A),mk_ref(A,X)) ).

tff(t2tb_sort,axiom,
    ! [X: $int] : sort1(int,t2tb(X)) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z1)
     => ( match_bool1(A,false1,Z,Z1) = Z1 ) ) ).

tff(occ_append,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,Mid: $int,U: $int] :
      ( ( occ1(A,V,M,L,U) = $sum(occ1(A,V,M,L,Mid),occ1(A,V,M,Mid,U)) )
     <= ( $lesseq(Mid,U)
        & $lesseq(L,Mid) ) ) ).

tff(bridgeL3,axiom,
    ! [I: map_int_elt] : ( tb2t3(t2tb3(I)) = I ) ).

tff(elts_def1,axiom,
    ! [A: ty,U: $int,U1: uni] :
      ( ( elts(A,mk_array1(A,U,U1)) = U1 )
     <= sort1(map(int,A),U1) ) ).

tff(permut_all_def,axiom,
    ! [A: ty,A1: uni,A2: uni] :
      ( permut_all(A,A1,A2)
    <=> ( ( length1(A,A1) = length1(A,A2) )
        & permut2(A,elts(A,A1),elts(A,A2),0,length1(A,A1)) ) ) ).

tff(sorted_def,axiom,
    ! [A: array_elt] :
      ( ! [I1: $int,I2: $int] :
          ( ( $lesseq(0,I1)
            & $less(I2,length1(elt,t2tb1(A)))
            & $lesseq(I1,I2) )
         => le1(tb2t2(get2(elt,t2tb1(A),I1)),tb2t2(get2(elt,t2tb1(A),I2))) )
    <=> sorted1(A) ) ).

tff(bridgeR3,axiom,
    ! [J: uni] :
      ( ( t2tb3(tb2t3(J)) = J )
     <= sort1(map(int,elt),J) ) ).

tff(permut_def,axiom,
    ! [A: ty,M1: uni,M2: uni,L: $int,U: $int] :
      ( ( permut2(A,M1,M2,L,U)
       <= ! [V: uni] :
            ( ( occ1(A,V,M1,L,U) = occ1(A,V,M2,L,U) )
           <= sort1(A,V) ) )
      & ( permut2(A,M1,M2,L,U)
       => ! [V: uni] : ( occ1(A,V,M1,L,U) = occ1(A,V,M2,L,U) ) ) ) ).

tff(match_bool_sort1,axiom,
    ! [A: ty,X: bool1,X1: uni,X2: uni] : sort1(A,match_bool1(A,X,X1,X2)) ).

tff(exchange_permut_all,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int] :
      ( permut_all(A,A1,A2)
     <= exchange3(A,A1,A2,I,J) ) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(permut_exists,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int,I: $int] :
      ( permut2(A,A1,A2,L,U)
     => ( ( $less(I,U)
          & $lesseq(L,I) )
       => ? [J: $int] :
            ( $less(J,U)
            & ( get(A,int,A1,t2tb(J)) = get(A,int,A2,t2tb(I)) )
            & $lesseq(L,J) ) ) ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool1(A,true1,Z,Z1) = Z )
     <= sort1(A,Z) ) ).

tff(set_sort3,axiom,
    ! [A: ty,X: uni,X1: $int,X2: uni] : sort1(array(A),set2(A,X,X1,X2)) ).

tff(exchange_set,axiom,
    ! [A: ty,A1: uni,L: $int,U: $int,I: $int,J: $int] :
      ( ( ( $lesseq(L,J)
          & $less(J,U) )
       => exchange2(A,A1,set(A,int,set(A,int,A1,t2tb(I),get(A,int,A1,t2tb(J))),t2tb(J),get(A,int,A1,t2tb(I))),L,U,I,J) )
     <= ( $lesseq(L,I)
        & $less(I,U) ) ) ).

tff(get_def,axiom,
    ! [A: ty,A1: uni,I: $int] : ( get2(A,A1,I) = get(A,int,elts(A,A1),t2tb(I)) ) ).

tff(contents_def1,axiom,
    ! [A: ty,U: uni] :
      ( sort1(A,U)
     => ( contents(A,mk_ref(A,U)) = U ) ) ).

tff(bridgeR1,axiom,
    ! [J: uni] : ( t2tb1(tb2t1(J)) = J ) ).

tff(permut_sub_weakening,axiom,
    ! [A: ty,A1: uni,A2: uni,L1: $int,U1: $int,L2: $int,U2: $int] :
      ( ( ( $lesseq(L2,L1)
          & $lesseq(0,L2) )
       => ( permut_sub1(A,A1,A2,L2,U2)
         <= ( $lesseq(U2,length1(A,A1))
            & $lesseq(U1,U2) ) ) )
     <= permut_sub1(A,A1,A2,L1,U1) ) ).

tff(t2tb_sort3,axiom,
    ! [X: map_int_elt] : sort1(map(int,elt),t2tb3(X)) ).

tff(bridgeR2,axiom,
    ! [J: uni] :
      ( sort1(elt,J)
     => ( t2tb2(tb2t2(J)) = J ) ) ).

tff(get_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort1(B,get(B,A,X,X1)) ).

tff(refl1,axiom,
    ! [X: elt1] : le1(X,X) ).

