tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort: ( ty * uni ) > $o ).

tff(witness,type,
    witness: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool: $tType ).

tff(bool1,type,
    bool1: ty ).

tff(true,type,
    true: bool ).

tff(false,type,
    false: bool ).

tff(match_bool,type,
    match_bool: ( ty * bool * uni * uni ) > uni ).

tff(tuple0,type,
    tuple0: $tType ).

tff(tuple01,type,
    tuple01: ty ).

tff(tuple02,type,
    tuple02: tuple0 ).

tff(qtmark,type,
    qtmark: ty ).

tff(list,type,
    list: ty > ty ).

tff(nil,type,
    nil: ty > uni ).

tff(cons,type,
    cons: ( ty * uni * uni ) > uni ).

tff(match_list,type,
    match_list: ( ty * ty * uni * uni * uni ) > uni ).

tff(cons_proj_1,type,
    cons_proj_1: ( ty * uni ) > uni ).

tff(cons_proj_2,type,
    cons_proj_2: ( ty * uni ) > uni ).

tff(length,type,
    length: ( ty * uni ) > $int ).

tff(infix_plpl,type,
    infix_plpl: ( ty * uni * uni ) > uni ).

tff(mem,type,
    mem: ( ty * uni * uni ) > $o ).

tff(num_occ,type,
    num_occ: ( ty * uni * uni ) > $int ).

tff(reverse,type,
    reverse: ( ty * uni ) > uni ).

tff(permut,type,
    permut: ( ty * uni * uni ) > $o ).

tff(elt,type,
    elt: $tType ).

tff(elt1,type,
    elt1: ty ).

tff(le,type,
    le: ( elt * elt ) > $o ).

tff(list_elt,type,
    list_elt: $tType ).

tff(sorted,type,
    sorted: list_elt > $o ).

tff(t2tb,type,
    t2tb: list_elt > uni ).

tff(tb2t,type,
    tb2t: uni > list_elt ).

tff(t2tb1,type,
    t2tb1: elt > uni ).

tff(tb2t1,type,
    tb2t1: uni > elt ).

tff(rev_append,type,
    rev_append: ( ty * uni * uni ) > uni ).

tff(prefix,type,
    prefix: ( ty * $int * uni ) > uni ).

tff(abs,type,
    abs: $int > $int ).

tff(div,type,
    div: ( $int * $int ) > $int ).

tff(mod,type,
    mod: ( $int * $int ) > $int ).

tff(sorted_inversion,axiom,
    ! [Z: list_elt] :
      ( sorted(Z)
     => ( ? [X: elt] : ( Z = tb2t(cons(elt1,t2tb1(X),nil(elt1))) )
        | ? [X: elt,Y: elt,L: list_elt] :
            ( sorted(tb2t(cons(elt1,t2tb1(Y),t2tb(L))))
            & ( Z = tb2t(cons(elt1,t2tb1(X),cons(elt1,t2tb1(Y),t2tb(L)))) )
            & le(X,Y) )
        | ( Z = tb2t(nil(elt1)) ) ) ) ).

tff(append_length,axiom,
    ! [A: ty,L1: uni,L2: uni] : ( length(A,infix_plpl(A,L1,L2)) = $sum(length(A,L1),length(A,L2)) ) ).

tff(permut_def,axiom,
    ! [A: ty,L1: uni,L2: uni] :
      ( ( ! [X: uni] :
            ( sort(A,X)
           => ( num_occ(A,X,L1) = num_occ(A,X,L2) ) )
       => permut(A,L1,L2) )
      & ( permut(A,L1,L2)
       => ! [X: uni] : ( num_occ(A,X,L1) = num_occ(A,X,L2) ) ) ) ).

tff(infix_plpl_sort,axiom,
    ! [A: ty,X: uni,X1: uni] : sort(list(A),infix_plpl(A,X,X1)) ).

tff(permut_length,axiom,
    ! [A: ty,L1: uni,L2: uni] :
      ( permut(A,L1,L2)
     => ( length(A,L1) = length(A,L2) ) ) ).

tff(true_False,axiom,
    true != false ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort(A,Z)
     => ( match_bool(A,true,Z,Z1) = Z ) ) ).

tff(sorted_Two,axiom,
    ! [X: elt,Y: elt,L: list_elt] :
      ( le(X,Y)
     => ( sorted(tb2t(cons(elt1,t2tb1(Y),t2tb(L))))
       => sorted(tb2t(cons(elt1,t2tb1(X),cons(elt1,t2tb1(Y),t2tb(L))))) ) ) ).

tff(match_list_Cons,axiom,
    ! [A: ty,A1: ty,Z: uni,Z1: uni,U: uni,U1: uni] :
      ( ( match_list(A1,A,cons(A,U,U1),Z,Z1) = Z1 )
     <= sort(A1,Z1) ) ).

tff(sorted_rev_append,axiom,
    ! [Acc: list_elt,L: list_elt] :
      ( ( ( ! [X: elt,Y: elt] :
              ( ( le(X,Y)
               <= mem(elt1,t2tb1(Y),t2tb(L)) )
             <= mem(elt1,t2tb1(X),t2tb(Acc)) )
         => sorted(tb2t(reverse(elt1,rev_append(elt1,t2tb(L),t2tb(Acc))))) )
       <= sorted(L) )
     <= sorted(tb2t(reverse(elt1,t2tb(Acc)))) ) ).

tff(nil_sort,axiom,
    ! [A: ty] : sort(list(A),nil(A)) ).

tff(div_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less(0,Y)
        & $lesseq(X,0) )
     => $lesseq(div(X,Y),0) ) ).

tff(permut_sym,axiom,
    ! [A: ty,L1: uni,L2: uni] :
      ( permut(A,L2,L1)
     <= permut(A,L1,L2) ) ).

tff(sorted_reverse_cons2,axiom,
    ! [X: elt,L: list_elt] :
      ( sorted(tb2t(reverse(elt1,cons(elt1,t2tb1(X),t2tb(L)))))
     => sorted(tb2t(reverse(elt1,t2tb(L)))) ) ).

tff(sorted_append,axiom,
    ! [L1: list_elt,L2: list_elt] :
      ( ( sorted(L1)
        & ! [X: elt,Y: elt] :
            ( mem(elt1,t2tb1(X),t2tb(L1))
           => ( le(X,Y)
             <= mem(elt1,t2tb1(Y),t2tb(L2)) ) )
        & sorted(L2) )
    <=> sorted(tb2t(infix_plpl(elt1,t2tb(L1),t2tb(L2)))) ) ).

tff(reverse_mem,axiom,
    ! [A: ty,L: uni,X: uni] :
      ( mem(A,X,reverse(A,L))
    <=> mem(A,X,L) ) ).

tff(cons_proj_1_sort,axiom,
    ! [A: ty,X: uni] : sort(A,cons_proj_1(A,X)) ).

tff(reverse_def,axiom,
    ! [A: ty] :
      ( ! [X: uni,X1: uni] : ( reverse(A,cons(A,X,X1)) = infix_plpl(A,reverse(A,X1),cons(A,X,nil(A))) )
      & ( reverse(A,nil(A)) = nil(A) ) ) ).

tff(mod_1,axiom,
    ! [X: $int] : ( mod(X,1) = 0 ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $lesseq(X,Y)
     => ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) ) ) ).

tff(mem_decomp,axiom,
    ! [A: ty,X: uni,L: uni] :
      ( ? [L1: uni,L2: uni] :
          ( sort(list(A),L1)
          & sort(list(A),L2)
          & ( L = infix_plpl(A,L1,cons(A,X,L2)) ) )
     <= mem(A,X,L) ) ).

tff(nil_Cons,axiom,
    ! [A: ty,V: uni,V1: uni] : ( nil(A) != cons(A,V,V1) ) ).

tff(prefix_def1,axiom,
    ! [A: ty,L: uni] : ( prefix(A,0,L) = nil(A) ) ).

tff(length_def,axiom,
    ! [A: ty] :
      ( ! [X: uni,X1: uni] : ( length(A,cons(A,X,X1)) = $sum(1,length(A,X1)) )
      & ( length(A,nil(A)) = 0 ) ) ).

tff(rounds_toward_zero,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(abs($product(div(X,Y),Y)),abs(X))
     <= ( Y != 0 ) ) ).

tff(cons_proj_2_def,axiom,
    ! [A: ty,U: uni,U1: uni] : ( cons_proj_2(A,cons(A,U,U1)) = U1 ) ).

tff(mod_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(mod(X,Y),0)
     <= ( ( Y != 0 )
        & $lesseq(X,0) ) ) ).

tff(sorted_mem,axiom,
    ! [X: elt,L: list_elt] :
      ( sorted(tb2t(cons(elt1,t2tb1(X),t2tb(L))))
    <=> ( sorted(L)
        & ! [Y: elt] :
            ( mem(elt1,t2tb1(Y),t2tb(L))
           => le(X,Y) ) ) ) ).

tff(abs_def,axiom,
    ! [X: $int] :
      ( ( ~ $lesseq(0,X)
       => ( abs(X) = $uminus(X) ) )
      & ( $lesseq(0,X)
       => ( abs(X) = X ) ) ) ).

tff(abs_le,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(X,Y)
        & $lesseq($uminus(Y),X) )
    <=> $lesseq(abs(X),Y) ) ).

tff(mem_append,axiom,
    ! [A: ty,X: uni,L1: uni,L2: uni] :
      ( mem(A,X,infix_plpl(A,L1,L2))
    <=> ( mem(A,X,L2)
        | mem(A,X,L1) ) ) ).

tff(rev_append_append_r,axiom,
    ! [A: ty,R: uni,S: uni,T: uni] : ( rev_append(A,R,infix_plpl(A,S,T)) = rev_append(A,rev_append(A,S,R),T) ) ).

tff(div_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(0,div(X,Y))
        & $lesseq(div(X,Y),X) )
     <= ( $lesseq(0,X)
        & $less(0,Y) ) ) ).

tff(mod_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less(X,Y)
        & $lesseq(0,X) )
     => ( mod(X,Y) = X ) ) ).

tff(permut_cons,axiom,
    ! [A: ty,X: uni,L1: uni,L2: uni] :
      ( permut(A,L1,L2)
     => permut(A,cons(A,X,L1),cons(A,X,L2)) ) ).

tff(bridgeL,axiom,
    ! [I: list_elt] : ( tb2t(t2tb(I)) = I ) ).

tff(reverse_num_occ,axiom,
    ! [A: ty,X: uni,L: uni] : ( num_occ(A,X,L) = num_occ(A,X,reverse(A,L)) ) ).

tff(div_mod,axiom,
    ! [X: $int,Y: $int] :
      ( ( X = $sum($product(Y,div(X,Y)),mod(X,Y)) )
     <= ( Y != 0 ) ) ).

tff(reverse_cons,axiom,
    ! [A: ty,L: uni,X: uni] : ( reverse(A,cons(A,X,L)) = infix_plpl(A,reverse(A,L),cons(A,X,nil(A))) ) ).

tff(reverse_sort,axiom,
    ! [A: ty,X: uni] : sort(list(A),reverse(A,X)) ).

tff(rev_append_def1,axiom,
    ! [A: ty,R: uni,S: uni] : ( rev_append(A,R,S) = infix_plpl(A,reverse(A,R),S) ) ).

tff(permut_refl,axiom,
    ! [A: ty,L: uni] : permut(A,L,L) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple0] : ( U = tuple02 ) ).

tff(sorted_One,axiom,
    ! [X: elt] : sorted(tb2t(cons(elt1,t2tb1(X),nil(elt1)))) ).

tff(div_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( div(X,Y) = 0 )
     <= ( $less(X,Y)
        & $lesseq(0,X) ) ) ).

tff(num_occ_def,axiom,
    ! [A: ty,X: uni] :
      ( ( ! [X1: uni,X2: uni] :
            ( ( ( ( num_occ(A,X,cons(A,X1,X2)) = $sum(1,num_occ(A,X,X2)) )
               <= ( X = X1 ) )
              & ( ( num_occ(A,X,cons(A,X1,X2)) = $sum(0,num_occ(A,X,X2)) )
               <= ( X != X1 ) ) )
           <= sort(A,X1) )
        & ( num_occ(A,X,nil(A)) = 0 ) )
     <= sort(A,X) ) ).

tff(cons_proj_1_def,axiom,
    ! [A: ty,U: uni,U1: uni] :
      ( sort(A,U)
     => ( cons_proj_1(A,cons(A,U,U1)) = U ) ) ).

tff(mem_def,axiom,
    ! [A: ty,X: uni] :
      ( ( ! [X1: uni,X2: uni] :
            ( ( mem(A,X,cons(A,X1,X2))
            <=> ( ( X = X1 )
                | mem(A,X,X2) ) )
           <= sort(A,X1) )
        & ~ mem(A,X,nil(A)) )
     <= sort(A,X) ) ).

tff(abs_pos,axiom,
    ! [X: $int] : $lesseq(0,abs(X)) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(sorted_Nil,axiom,
    sorted(tb2t(nil(elt1))) ).

tff(bool_inversion,axiom,
    ! [U: bool] :
      ( ( U = false )
      | ( U = true ) ) ).

tff(t2tb_sort1,axiom,
    ! [X: elt] : sort(elt1,t2tb1(X)) ).

tff(mod_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( mod($sum($product(X,Y),Z),X) = mod(Z,X) )
     <= ( $less(0,X)
        & $lesseq(0,Y)
        & $lesseq(0,Z) ) ) ).

tff(length_nonnegative,axiom,
    ! [A: ty,L: uni] : $lesseq(0,length(A,L)) ).

tff(prefix_length,axiom,
    ! [A: ty,N: $int,L: uni] :
      ( ( length(A,prefix(A,N,L)) = N )
     <= ( $lesseq(0,N)
        & $lesseq(N,length(A,L)) ) ) ).

tff(match_list_Nil,axiom,
    ! [A: ty,A1: ty,Z: uni,Z1: uni] :
      ( sort(A1,Z)
     => ( match_list(A1,A,nil(A),Z,Z1) = Z ) ) ).

tff(trans,axiom,
    ! [X: elt,Y: elt,Z: elt] :
      ( le(X,Y)
     => ( le(X,Z)
       <= le(Y,Z) ) ) ).

tff(permut_swap,axiom,
    ! [A: ty,X: uni,Y: uni,L: uni] : permut(A,cons(A,X,cons(A,Y,L)),cons(A,Y,cons(A,X,L))) ).

tff(div_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq(0,Y)
        & $lesseq(0,Z)
        & $less(0,X) )
     => ( div($sum($product(X,Y),Z),X) = $sum(Y,div(Z,X)) ) ) ).

tff(reverse_length,axiom,
    ! [A: ty,L: uni] : ( length(A,reverse(A,L)) = length(A,L) ) ).

tff(rev_append_length,axiom,
    ! [A: ty,S: uni,T: uni] : ( length(A,rev_append(A,S,T)) = $sum(length(A,S),length(A,T)) ) ).

tff(sorted_reverse_mem,axiom,
    ! [X: elt,L: list_elt] :
      ( sorted(tb2t(reverse(elt1,cons(elt1,t2tb1(X),t2tb(L)))))
     => ! [Y: elt] :
          ( le(Y,X)
         <= mem(elt1,t2tb1(Y),t2tb(L)) ) ) ).

tff(infix_plpl_def,axiom,
    ! [A: ty,L2: uni] :
      ( ( infix_plpl(A,nil(A),L2) = L2 )
      & ! [X: uni,X1: uni] : ( infix_plpl(A,cons(A,X,X1),L2) = cons(A,X,infix_plpl(A,X1,L2)) ) ) ).

tff(refl,axiom,
    ! [X: elt] : le(X,X) ).

tff(permut_assoc,axiom,
    ! [A: ty,L1: uni,L2: uni,L3: uni] : permut(A,infix_plpl(A,infix_plpl(A,L1,L2),L3),infix_plpl(A,L1,infix_plpl(A,L2,L3))) ).

tff(cons_sort,axiom,
    ! [A: ty,X: uni,X1: uni] : sort(list(A),cons(A,X,X1)) ).

tff(match_list_sort,axiom,
    ! [A: ty,A1: ty,X: uni,X1: uni,X2: uni] : sort(A1,match_list(A1,A,X,X1,X2)) ).

tff(permut_append_swap,axiom,
    ! [A: ty,L1: uni,L2: uni] : permut(A,infix_plpl(A,L1,L2),infix_plpl(A,L2,L1)) ).

tff(bridgeL1,axiom,
    ! [I: elt] : ( tb2t1(t2tb1(I)) = I ) ).

tff(mem_Num_Occ,axiom,
    ! [A: ty,X: uni,L: uni] :
      ( mem(A,X,L)
    <=> $less(0,num_occ(A,X,L)) ) ).

tff(div_1,axiom,
    ! [X: $int] : ( div(X,1) = X ) ).

tff(witness_sort,axiom,
    ! [A: ty] : sort(A,witness(A)) ).

tff(append_l_nil,axiom,
    ! [A: ty,L: uni] : ( infix_plpl(A,L,nil(A)) = L ) ).

tff(div_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less(0,Y)
        & $lesseq(0,X) )
     => $lesseq(0,div(X,Y)) ) ).

tff(sorted_reverse_cons,axiom,
    ! [Acc: list_elt,X1: elt] :
      ( ( ! [X: elt] :
            ( le(X,X1)
           <= mem(elt1,t2tb1(X),t2tb(Acc)) )
       => sorted(tb2t(reverse(elt1,cons(elt1,t2tb1(X1),t2tb(Acc))))) )
     <= sorted(tb2t(reverse(elt1,t2tb(Acc)))) ) ).

tff(prefix_append,axiom,
    ! [A: ty,N: $int,L1: uni,L2: uni] :
      ( ( $lesseq(N,$sum(length(A,L1),length(A,L2)))
        & $lesseq(length(A,L1),N) )
     => ( prefix(A,N,infix_plpl(A,L1,L2)) = infix_plpl(A,prefix(A,length(A,L1),L1),prefix(A,$difference(N,length(A,L1)),L2)) ) ) ).

tff(permut_append,axiom,
    ! [A: ty,L1: uni,L2: uni,K1: uni,K2: uni] :
      ( permut(A,L1,K1)
     => ( permut(A,L2,K2)
       => permut(A,infix_plpl(A,L1,L2),infix_plpl(A,K1,K2)) ) ) ).

tff(t2tb_sort,axiom,
    ! [X: list_elt] : sort(list(elt1),t2tb(X)) ).

tff(permut_cons_append,axiom,
    ! [A: ty,X: uni,L1: uni,L2: uni] : permut(A,infix_plpl(A,cons(A,X,L1),L2),infix_plpl(A,L1,cons(A,X,L2))) ).

tff(permut_trans,axiom,
    ! [A: ty,L1: uni,L2: uni,L3: uni] :
      ( permut(A,L1,L2)
     => ( permut(A,L2,L3)
       => permut(A,L1,L3) ) ) ).

tff(append_Num_Occ,axiom,
    ! [A: ty,X: uni,L1: uni,L2: uni] : ( num_occ(A,X,infix_plpl(A,L1,L2)) = $sum(num_occ(A,X,L1),num_occ(A,X,L2)) ) ).

tff(wP_parameter_sort,conjecture,
    ! [N: $int,L: list_elt] :
      ( ( ( ! [X: elt,X1: list_elt] :
              ( ( L = tb2t(cons(elt1,t2tb1(X),t2tb(X1))) )
             => ! [X2: elt,X3: list_elt] :
                  ( ! [X4: elt,X5: list_elt] :
                      ( ( X3 = tb2t(cons(elt1,t2tb1(X4),t2tb(X5))) )
                     => ( ( ~ le(X,X4)
                         => ( ( permut(elt1,cons(elt1,t2tb1(X4),cons(elt1,t2tb1(X2),cons(elt1,t2tb1(X),nil(elt1)))),prefix(elt1,N,t2tb(L)))
                             <= ~ le(X2,X4) )
                            & ( permut(elt1,cons(elt1,t2tb1(X2),cons(elt1,t2tb1(X4),cons(elt1,t2tb1(X),nil(elt1)))),prefix(elt1,N,t2tb(L)))
                             <= le(X2,X4) ) ) )
                       <= ~ le(X,X2) ) )
                 <= ( X1 = tb2t(cons(elt1,t2tb1(X2),t2tb(X3))) ) ) )
         <= ( N = 3 ) )
       <= ( N != 2 ) )
     <= ( $lesseq(2,N)
        & $lesseq(N,length(elt1,t2tb(L))) ) ) ).

tff(length_nil,axiom,
    ! [A: ty,L: uni] :
      ( ( length(A,L) = 0 )
    <=> ( L = nil(A) ) ) ).

tff(rev_append_append_l,axiom,
    ! [A: ty,R: uni,S: uni,T: uni] : ( rev_append(A,infix_plpl(A,R,S),T) = rev_append(A,S,rev_append(A,R,T)) ) ).

tff(total,axiom,
    ! [X: elt,Y: elt] :
      ( le(Y,X)
      | le(X,Y) ) ).

tff(cons_proj_2_sort,axiom,
    ! [A: ty,X: uni] : sort(list(A),cons_proj_2(A,X)) ).

tff(reverse_reverse,axiom,
    ! [A: ty,L: uni] : ( reverse(A,reverse(A,L)) = L ) ).

tff(mod_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( ( ( Y != 0 )
        & $lesseq(0,X) )
     => $lesseq(0,mod(X,Y)) ) ).

tff(prefix_def2,axiom,
    ! [A: ty,N: $int,X: uni,L: uni] :
      ( ( prefix(A,N,cons(A,X,L)) = cons(A,X,prefix(A,$difference(N,1),L)) )
     <= $less(0,N) ) ).

tff(rev_append_sort,axiom,
    ! [A: ty,X: uni,X1: uni] : sort(list(A),rev_append(A,X,X1)) ).

tff(bridgeR1,axiom,
    ! [J: uni] :
      ( ( t2tb1(tb2t1(J)) = J )
     <= sort(elt1,J) ) ).

tff(permut_mem,axiom,
    ! [A: ty,X: uni,L1: uni,L2: uni] :
      ( ( mem(A,X,L2)
       <= mem(A,X,L1) )
     <= permut(A,L1,L2) ) ).

tff(mod_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less(mod(X,Y),abs(Y))
        & $less($uminus(abs(Y)),mod(X,Y)) )
     <= ( Y != 0 ) ) ).

tff(reverse_append,axiom,
    ! [A: ty,L1: uni,L2: uni,X: uni] : ( infix_plpl(A,reverse(A,cons(A,X,L1)),L2) = infix_plpl(A,reverse(A,L1),cons(A,X,L2)) ) ).

tff(list_inversion,axiom,
    ! [A: ty,U: uni] :
      ( ( U = nil(A) )
      | ( U = cons(A,cons_proj_1(A,U),cons_proj_2(A,U)) ) ) ).

tff(prefix_sort,axiom,
    ! [A: ty,X: $int,X1: uni] : sort(list(A),prefix(A,X,X1)) ).

tff(append_assoc,axiom,
    ! [A: ty,L1: uni,L2: uni,L3: uni] : ( infix_plpl(A,L1,infix_plpl(A,L2,L3)) = infix_plpl(A,infix_plpl(A,L1,L2),L3) ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool(A,false,Z,Z1) = Z1 )
     <= sort(A,Z1) ) ).

tff(rev_append_def,axiom,
    ! [A: ty,T: uni] :
      ( ( rev_append(A,nil(A),T) = T )
      & ! [X: uni,R: uni] : ( rev_append(A,cons(A,X,R),T) = rev_append(A,R,cons(A,X,T)) ) ) ).

tff(match_bool_sort,axiom,
    ! [A: ty,X: bool,X1: uni,X2: uni] : sort(A,match_bool(A,X,X1,X2)) ).

