tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort: ( ty * uni ) > $o ).

tff(witness,type,
    witness: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool: $tType ).

tff(bool1,type,
    bool1: ty ).

tff(true,type,
    true: bool ).

tff(false,type,
    false: bool ).

tff(match_bool,type,
    match_bool: ( ty * bool * uni * uni ) > uni ).

tff(tuple0,type,
    tuple0: $tType ).

tff(tuple01,type,
    tuple01: ty ).

tff(tuple02,type,
    tuple02: tuple0 ).

tff(qtmark,type,
    qtmark: ty ).

tff(power,type,
    power: ( $int * $int ) > $int ).

tff(abs,type,
    abs: $int > $int ).

tff(div,type,
    div: ( $int * $int ) > $int ).

tff(mod,type,
    mod: ( $int * $int ) > $int ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(mod_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( mod(X,Y) = X )
     <= ( $less(X,Y)
        & $lesseq(0,X) ) ) ).

tff(power_sum,axiom,
    ! [X: $int,N: $int,M: $int] :
      ( $lesseq(0,N)
     => ( ( power(X,$sum(N,M)) = $product(power(X,N),power(X,M)) )
       <= $lesseq(0,M) ) ) ).

tff(mod_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( ( ( Y != 0 )
        & $lesseq(0,X) )
     => $lesseq(0,mod(X,Y)) ) ).

tff(abs_pos,axiom,
    ! [X: $int] : $lesseq(0,abs(X)) ).

tff(mk_ref_sort,axiom,
    ! [A: ty,X: uni] : sort(ref(A),mk_ref(A,X)) ).

tff(div_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(0,div(X,Y))
        & $lesseq(div(X,Y),X) )
     <= ( $lesseq(0,X)
        & $less(0,Y) ) ) ).

tff(div_mod,axiom,
    ! [X: $int,Y: $int] :
      ( ( Y != 0 )
     => ( X = $sum($product(Y,div(X,Y)),mod(X,Y)) ) ) ).

tff(power_s_alt,axiom,
    ! [X: $int,N: $int] :
      ( ( power(X,N) = $product(X,power(X,$difference(N,1))) )
     <= $less(0,N) ) ).

tff(bool_inversion,axiom,
    ! [U: bool] :
      ( ( U = false )
      | ( U = true ) ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort(A,Z)
     => ( match_bool(A,true,Z,Z1) = Z ) ) ).

tff(abs_le,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(abs(X),Y)
    <=> ( $lesseq(X,Y)
        & $lesseq($uminus(Y),X) ) ) ).

tff(wP_parameter_fast_exp_imperative,conjecture,
    ! [X: $int,N: $int] :
      ( ! [E: $int,P: $int,R: $int] :
          ( ( $lesseq(0,E)
            & ( $product(R,power(P,E)) = power(X,N) ) )
         => ( ~ $less(0,E)
           => ( R = power(X,N) ) ) )
     <= $lesseq(0,N) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple0] : ( U = tuple02 ) ).

tff(div_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(div(X,Y),0)
     <= ( $less(0,Y)
        & $lesseq(X,0) ) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $lesseq(X,Y)
     => ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) ) ) ).

tff(div_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(0,div(X,Y))
     <= ( $less(0,Y)
        & $lesseq(0,X) ) ) ).

tff(power_0,axiom,
    ! [X: $int] : ( power(X,0) = 1 ) ).

tff(power_mult,axiom,
    ! [X: $int,N: $int,M: $int] :
      ( $lesseq(0,N)
     => ( $lesseq(0,M)
       => ( power(X,$product(N,M)) = power(power(X,N),M) ) ) ) ).

tff(power_s,axiom,
    ! [X: $int,N: $int] :
      ( ( power(X,$sum(N,1)) = $product(X,power(X,N)) )
     <= $lesseq(0,N) ) ).

tff(contents_def,axiom,
    ! [A: ty,U: uni] :
      ( sort(A,U)
     => ( contents(A,mk_ref(A,U)) = U ) ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool(A,false,Z,Z1) = Z1 )
     <= sort(A,Z1) ) ).

tff(rounds_toward_zero,axiom,
    ! [X: $int,Y: $int] :
      ( ( Y != 0 )
     => $lesseq(abs($product(div(X,Y),Y)),abs(X)) ) ).

tff(power_1,axiom,
    ! [X: $int] : ( power(X,1) = X ) ).

tff(true_False,axiom,
    true != false ).

tff(contents_sort,axiom,
    ! [A: ty,X: uni] : sort(A,contents(A,X)) ).

tff(abs_def,axiom,
    ! [X: $int] :
      ( ( ( abs(X) = X )
       <= $lesseq(0,X) )
      & ( ( abs(X) = $uminus(X) )
       <= ~ $lesseq(0,X) ) ) ).

tff(power_mult2,axiom,
    ! [X: $int,Y: $int,N: $int] :
      ( ( power($product(X,Y),N) = $product(power(X,N),power(Y,N)) )
     <= $lesseq(0,N) ) ).

tff(div_1,axiom,
    ! [X: $int] : ( div(X,1) = X ) ).

tff(mod_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( mod($sum($product(X,Y),Z),X) = mod(Z,X) )
     <= ( $less(0,X)
        & $lesseq(0,Y)
        & $lesseq(0,Z) ) ) ).

tff(div_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( div($sum($product(X,Y),Z),X) = $sum(Y,div(Z,X)) )
     <= ( $lesseq(0,Y)
        & $lesseq(0,Z)
        & $less(0,X) ) ) ).

tff(ref_inversion,axiom,
    ! [A: ty,U: uni] :
      ( ( U = mk_ref(A,contents(A,U)) )
     <= sort(ref(A),U) ) ).

tff(mod_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(mod(X,Y),0)
     <= ( $lesseq(X,0)
        & ( Y != 0 ) ) ) ).

tff(div_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( div(X,Y) = 0 )
     <= ( $lesseq(0,X)
        & $less(X,Y) ) ) ).

tff(mod_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( Y != 0 )
     => ( $less(mod(X,Y),abs(Y))
        & $less($uminus(abs(Y)),mod(X,Y)) ) ) ).

tff(match_bool_sort1,axiom,
    ! [A: ty,X: bool,X1: uni,X2: uni] : sort(A,match_bool(A,X,X1,X2)) ).

tff(witness_sort,axiom,
    ! [A: ty] : sort(A,witness(A)) ).

tff(mod_1,axiom,
    ! [X: $int] : ( mod(X,1) = 0 ) ).

