tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort: ( ty * uni ) > $o ).

tff(witness,type,
    witness: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool: $tType ).

tff(bool1,type,
    bool1: ty ).

tff(true,type,
    true: bool ).

tff(false,type,
    false: bool ).

tff(match_bool,type,
    match_bool: ( ty * bool * uni * uni ) > uni ).

tff(tuple0,type,
    tuple0: $tType ).

tff(tuple01,type,
    tuple01: ty ).

tff(tuple02,type,
    tuple02: tuple0 ).

tff(qtmark,type,
    qtmark: ty ).

tff(list,type,
    list: ty > ty ).

tff(nil,type,
    nil: ty > uni ).

tff(cons,type,
    cons: ( ty * uni * uni ) > uni ).

tff(match_list,type,
    match_list: ( ty * ty * uni * uni * uni ) > uni ).

tff(cons_proj_1,type,
    cons_proj_1: ( ty * uni ) > uni ).

tff(cons_proj_2,type,
    cons_proj_2: ( ty * uni ) > uni ).

tff(length,type,
    length: ( ty * uni ) > $int ).

tff(infix_plpl,type,
    infix_plpl: ( ty * uni * uni ) > uni ).

tff(mem,type,
    mem: ( ty * uni * uni ) > $o ).

tff(option,type,
    option: ty > ty ).

tff(none,type,
    none: ty > uni ).

tff(some,type,
    some: ( ty * uni ) > uni ).

tff(match_option,type,
    match_option: ( ty * ty * uni * uni * uni ) > uni ).

tff(some_proj_1,type,
    some_proj_1: ( ty * uni ) > uni ).

tff(nth,type,
    nth: ( ty * $int * uni ) > uni ).

tff(pal,type,
    pal: ( ty * uni * $int ) > $o ).

tff(a,type,
    a: $tType ).

tff(a1,type,
    a1: ty ).

tff(t2tb,type,
    t2tb: a > uni ).

tff(tb2t,type,
    tb2t: uni > a ).

tff(option_a1,type,
    option_a1: $tType ).

tff(t2tb4,type,
    t2tb4: option_a1 > uni ).

tff(tb2t4,type,
    tb2t4: uni > option_a1 ).

tff(list_a1,type,
    list_a1: $tType ).

tff(t2tb3,type,
    t2tb3: list_a1 > uni ).

tff(tb2t3,type,
    tb2t3: uni > list_a1 ).

tff(true_False,axiom,
    true != false ).

tff(t2tb_sort6,axiom,
    ! [X: list_a1] : sort(list(a1),t2tb3(X)) ).

tff(bridgeR,axiom,
    ! [J: uni] :
      ( sort(a1,J)
     => ( t2tb(tb2t(J)) = J ) ) ).

tff(bridgeL,axiom,
    ! [I: a] : ( tb2t(t2tb(I)) = I ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool(A,false,Z,Z1) = Z1 )
     <= sort(A,Z1) ) ).

tff(nth_append_2,axiom,
    ! [A: ty,L1: uni,L2: uni,I: $int] :
      ( ( nth(A,I,infix_plpl(A,L1,L2)) = nth(A,$difference(I,length(A,L1)),L2) )
     <= $lesseq(length(A,L1),I) ) ).

tff(length_nonnegative,axiom,
    ! [A: ty,L: uni] : $lesseq(0,length(A,L)) ).

tff(nth_none_2,axiom,
    ! [A: ty,L: uni,I: $int] :
      ( ( nth(A,I,L) = none(A) )
     <= $lesseq(length(A,L),I) ) ).

tff(some_proj_1_def,axiom,
    ! [A: ty,U: uni] :
      ( sort(A,U)
     => ( some_proj_1(A,some(A,U)) = U ) ) ).

tff(nth_def,axiom,
    ! [A: ty,N: $int] :
      ( ( nth(A,N,nil(A)) = none(A) )
      & ! [X: uni,X1: uni] :
          ( ( ( nth(A,N,cons(A,X,X1)) = some(A,X) )
           <= ( N = 0 ) )
          & ( ( N != 0 )
           => ( nth(A,N,cons(A,X,X1)) = nth(A,$difference(N,1),X1) ) ) ) ) ).

tff(cons_proj_2_def,axiom,
    ! [A: ty,U: uni,U1: uni] : ( cons_proj_2(A,cons(A,U,U1)) = U1 ) ).

tff(match_option_sort,axiom,
    ! [A: ty,A1: ty,X: uni,X1: uni,X2: uni] : sort(A1,match_option(A1,A,X,X1,X2)) ).

tff(nil_sort1,axiom,
    ! [A: ty] : sort(list(A),nil(A)) ).

tff(cons_sort1,axiom,
    ! [A: ty,X: uni,X1: uni] : sort(list(A),cons(A,X,X1)) ).

tff(bridgeR4,axiom,
    ! [J: uni] :
      ( ( t2tb4(tb2t4(J)) = J )
     <= sort(option(a1),J) ) ).

tff(bridgeL3,axiom,
    ! [I: list_a1] : ( tb2t3(t2tb3(I)) = I ) ).

tff(bool_inversion,axiom,
    ! [U: bool] :
      ( ( U = false )
      | ( U = true ) ) ).

tff(pal_def,axiom,
    ! [A: ty,X: uni,N: $int] :
      ( pal(A,X,N)
    <=> ! [I: $int] :
          ( ( nth(A,I,X) = nth(A,$difference($difference(N,1),I),X) )
         <= ( $lesseq(0,I)
            & $less(I,N) ) ) ) ).

tff(length_nil,axiom,
    ! [A: ty,L: uni] :
      ( ( length(A,L) = 0 )
    <=> ( L = nil(A) ) ) ).

tff(infix_plpl_def,axiom,
    ! [A: ty,L2: uni] :
      ( ( infix_plpl(A,nil(A),L2) = L2 )
      & ! [X: uni,X1: uni] : ( infix_plpl(A,cons(A,X,X1),L2) = cons(A,X,infix_plpl(A,X1,L2)) ) ) ).

tff(none_Some,axiom,
    ! [A: ty,V: uni] : ( none(A) != some(A,V) ) ).

tff(t2tb_sort5,axiom,
    ! [X: option_a1] : sort(option(a1),t2tb4(X)) ).

tff(match_bool_sort1,axiom,
    ! [A: ty,X: bool,X1: uni,X2: uni] : sort(A,match_bool(A,X,X1,X2)) ).

tff(length_def,axiom,
    ! [A: ty] :
      ( ! [X: uni,X1: uni] : ( length(A,cons(A,X,X1)) = $sum(1,length(A,X1)) )
      & ( length(A,nil(A)) = 0 ) ) ).

tff(some_proj_1_sort,axiom,
    ! [A: ty,X: uni] : sort(A,some_proj_1(A,X)) ).

tff(bridgeR3,axiom,
    ! [J: uni] : ( t2tb3(tb2t3(J)) = J ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple0] : ( U = tuple02 ) ).

tff(nth_sort,axiom,
    ! [A: ty,X: $int,X1: uni] : sort(option(A),nth(A,X,X1)) ).

tff(cons_proj_2_sort1,axiom,
    ! [A: ty,X: uni] : sort(list(A),cons_proj_2(A,X)) ).

tff(none_sort,axiom,
    ! [A: ty] : sort(option(A),none(A)) ).

tff(nil_Cons,axiom,
    ! [A: ty,V: uni,V1: uni] : ( nil(A) != cons(A,V,V1) ) ).

tff(mem_decomp,axiom,
    ! [A: ty,X: uni,L: uni] :
      ( mem(A,X,L)
     => ? [L1: uni,L2: uni] :
          ( sort(list(A),L1)
          & ( L = infix_plpl(A,L1,cons(A,X,L2)) )
          & sort(list(A),L2) ) ) ).

tff(cons_proj_1_def,axiom,
    ! [A: ty,U: uni,U1: uni] :
      ( sort(A,U)
     => ( cons_proj_1(A,cons(A,U,U1)) = U ) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $lesseq(X,Y)
     => ( $lesseq($product(X,Z),$product(Y,Z))
       <= $lesseq(0,Z) ) ) ).

tff(match_list_Cons,axiom,
    ! [A: ty,A1: ty,Z: uni,Z1: uni,U: uni,U1: uni] :
      ( ( match_list(A1,A,cons(A,U,U1),Z,Z1) = Z1 )
     <= sort(A1,Z1) ) ).

tff(match_list_Nil,axiom,
    ! [A: ty,A1: ty,Z: uni,Z1: uni] :
      ( sort(A1,Z)
     => ( match_list(A1,A,nil(A),Z,Z1) = Z ) ) ).

tff(append_length,axiom,
    ! [A: ty,L1: uni,L2: uni] : ( length(A,infix_plpl(A,L1,L2)) = $sum(length(A,L1),length(A,L2)) ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort(A,Z)
     => ( match_bool(A,true,Z,Z1) = Z ) ) ).

tff(option_inversion,axiom,
    ! [A: ty,U: uni] :
      ( ( ( U = none(A) )
        | ( U = some(A,some_proj_1(A,U)) ) )
     <= sort(option(A),U) ) ).

tff(nth_none_1,axiom,
    ! [A: ty,L: uni,I: $int] :
      ( ( nth(A,I,L) = none(A) )
     <= $less(I,0) ) ).

tff(match_list_sort1,axiom,
    ! [A: ty,A1: ty,X: uni,X1: uni,X2: uni] : sort(A1,match_list(A1,A,X,X1,X2)) ).

tff(nth_append_1,axiom,
    ! [A: ty,L1: uni,L2: uni,I: $int] :
      ( $less(I,length(A,L1))
     => ( nth(A,I,infix_plpl(A,L1,L2)) = nth(A,I,L1) ) ) ).

tff(cons_proj_1_sort1,axiom,
    ! [A: ty,X: uni] : sort(A,cons_proj_1(A,X)) ).

tff(match_option_Some,axiom,
    ! [A: ty,A1: ty,Z: uni,Z1: uni,U: uni] :
      ( ( match_option(A1,A,some(A,U),Z,Z1) = Z1 )
     <= sort(A1,Z1) ) ).

tff(bridgeL4,axiom,
    ! [I: option_a1] : ( tb2t4(t2tb4(I)) = I ) ).

tff(mem_append,axiom,
    ! [A: ty,X: uni,L1: uni,L2: uni] :
      ( ( mem(A,X,L2)
        | mem(A,X,L1) )
    <=> mem(A,X,infix_plpl(A,L1,L2)) ) ).

tff(match_option_None,axiom,
    ! [A: ty,A1: ty,Z: uni,Z1: uni] :
      ( sort(A1,Z)
     => ( match_option(A1,A,none(A),Z,Z1) = Z ) ) ).

tff(infix_plpl_sort1,axiom,
    ! [A: ty,X: uni,X1: uni] : sort(list(A),infix_plpl(A,X,X1)) ).

tff(list_inversion,axiom,
    ! [A: ty,U: uni] :
      ( ( U = nil(A) )
      | ( U = cons(A,cons_proj_1(A,U),cons_proj_2(A,U)) ) ) ).

tff(some_sort,axiom,
    ! [A: ty,X: uni] : sort(option(A),some(A,X)) ).

tff(append_assoc,axiom,
    ! [A: ty,L1: uni,L2: uni,L3: uni] : ( infix_plpl(A,L1,infix_plpl(A,L2,L3)) = infix_plpl(A,infix_plpl(A,L1,L2),L3) ) ).

tff(wP_parameter_palindrome_rec,conjecture,
    ! [X: list_a1,Y: list_a1] :
      ( $lesseq(length(a1,t2tb3(Y)),length(a1,t2tb3(X)))
     => ! [X1: a,X2: list_a1] :
          ( ( Y = tb2t3(cons(a1,t2tb(X1),t2tb3(X2))) )
         => ! [X3: a,X4: list_a1] :
              ( ! [X5: a,X6: list_a1] :
                  ( ( $lesseq(length(a1,t2tb3(X4)),length(a1,t2tb3(X6)))
                   => ! [Result: list_a1] :
                        ( ! [X11: a,Xs: list_a1] :
                            ( ( Result = tb2t3(cons(a1,t2tb(X11),t2tb3(Xs))) )
                           => ( ( ( X5 = X11 )
                               => ? [X0: list_a1] :
                                    ( ( length(a1,t2tb3(X0)) = length(a1,t2tb3(Y)) )
                                    & ( X = tb2t3(infix_plpl(a1,t2tb3(X0),t2tb3(Xs))) ) ) )
                             <= ( tb2t4(nth(a1,$difference(length(a1,t2tb3(Y)),1),t2tb3(X))) = tb2t4(some(a1,t2tb(X11))) ) ) )
                       <= ( pal(a1,t2tb3(X6),length(a1,t2tb3(X4)))
                          & ? [X0: list_a1] :
                              ( ( length(a1,t2tb3(X0)) = length(a1,t2tb3(X4)) )
                              & ( X6 = tb2t3(infix_plpl(a1,t2tb3(X0),t2tb3(Result))) ) ) ) ) )
                 <= ( X = tb2t3(cons(a1,t2tb(X5),t2tb3(X6))) ) )
             <= ( X2 = tb2t3(cons(a1,t2tb(X3),t2tb3(X4))) ) ) ) ) ).

tff(witness_sort,axiom,
    ! [A: ty] : sort(A,witness(A)) ).

tff(nth_none_3,axiom,
    ! [A: ty,L: uni,I: $int] :
      ( ( nth(A,I,L) = none(A) )
     => ( $less(I,0)
        | $lesseq(length(A,L),I) ) ) ).

tff(t2tb_sort4,axiom,
    ! [X: a] : sort(a1,t2tb(X)) ).

tff(mem_def,axiom,
    ! [A: ty,X: uni] :
      ( ( ~ mem(A,X,nil(A))
        & ! [X1: uni,X2: uni] :
            ( sort(A,X1)
           => ( ( ( X = X1 )
                | mem(A,X,X2) )
            <=> mem(A,X,cons(A,X1,X2)) ) ) )
     <= sort(A,X) ) ).

tff(append_l_nil,axiom,
    ! [A: ty,L: uni] : ( infix_plpl(A,L,nil(A)) = L ) ).

