tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort1: ( ty * uni ) > $o ).

tff(witness,type,
    witness1: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool1: $tType ).

tff(bool1,type,
    bool: ty ).

tff(true,type,
    true1: bool1 ).

tff(false,type,
    false1: bool1 ).

tff(match_bool,type,
    match_bool1: ( ty * bool1 * uni * uni ) > uni ).

tff(tuple0,type,
    tuple02: $tType ).

tff(tuple01,type,
    tuple0: ty ).

tff(tuple02,type,
    tuple03: tuple02 ).

tff(qtmark,type,
    qtmark: ty ).

tff(t,type,
    t1: $tType ).

tff(t1,type,
    t: ty ).

tff(f,type,
    f1: t1 > t1 ).

tff(x0,type,
    x01: t1 ).

tff(iter,type,
    iter1: ( $int * t1 ) > t1 ).

tff(mu,type,
    mu1: $int ).

tff(lambda,type,
    lambda1: $int ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(dist,type,
    dist1: ( $int * $int ) > $int ).

tff(rel,type,
    rel1: ( t1 * t1 ) > $o ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $lesseq(X,Y)
     => ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) ) ) ).

tff(iter_s,axiom,
    ! [K: $int,X: t1] :
      ( $less(0,K)
     => ( iter1(K,X) = iter1($difference(K,1),f1(X)) ) ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z1)
     => ( match_bool1(A,false1,Z,Z1) = Z1 ) ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool1(A,true1,Z,Z1) = Z )
     <= sort1(A,Z) ) ).

tff(true_False,axiom,
    true1 != false1 ).

tff(ref_inversion1,axiom,
    ! [A: ty,U: uni] :
      ( ( U = mk_ref(A,contents(A,U)) )
     <= sort1(ref(A),U) ) ).

tff(lambda_range,axiom,
    $lesseq(1,lambda1) ).

tff(dist_def,axiom,
    ! [I: $int,J: $int] :
      ( $lesseq(mu1,I)
     => ( $lesseq(mu1,J)
       => ( $lesseq(0,dist1(I,J))
          & ( iter1($sum(I,dist1(I,J)),x01) = iter1(J,x01) )
          & ! [K: $int] :
              ( $lesseq(0,K)
             => ( $lesseq(dist1(I,J),K)
               <= ( iter1($sum(I,K),x01) = iter1(J,x01) ) ) ) ) ) ) ).

tff(iter_1,axiom,
    ! [X: t1] : ( iter1(1,X) = f1(X) ) ).

tff(wP_parameter_tortoise_hare,conjecture,
    ? [T: $int] :
      ( $lesseq(1,T)
      & ! [I: $int] :
          ( ( iter1(I,x01) != iter1($product(2,I),x01) )
         <= ( $less(I,T)
            & $lesseq(1,I) ) )
      & ( f1(f1(x01)) = iter1($product(2,T),x01) )
      & ( f1(x01) = iter1(T,x01) )
      & $lesseq(T,$sum(mu1,lambda1)) ) ).

tff(mk_ref_sort1,axiom,
    ! [A: ty,X: uni] : sort1(ref(A),mk_ref(A,X)) ).

tff(contents_def1,axiom,
    ! [A: ty,U: uni] :
      ( sort1(A,U)
     => ( contents(A,mk_ref(A,U)) = U ) ) ).

tff(iter_0,axiom,
    ! [X: t1] : ( iter1(0,X) = X ) ).

tff(witness_sort1,axiom,
    ! [A: ty] : sort1(A,witness1(A)) ).

tff(contents_sort1,axiom,
    ! [A: ty,X: uni] : sort1(A,contents(A,X)) ).

tff(cycle,axiom,
    ! [N: $int] :
      ( ( iter1($sum(N,lambda1),x01) = iter1(N,x01) )
     <= $lesseq(mu1,N) ) ).

tff(iter_s2,axiom,
    ! [K: $int,X: t1] :
      ( $less(0,K)
     => ( iter1(K,X) = f1(iter1($difference(K,1),X)) ) ) ).

tff(mu_range,axiom,
    $lesseq(0,mu1) ).

tff(cycle_induction,axiom,
    ! [N: $int] :
      ( $lesseq(mu1,N)
     => ! [K: $int] :
          ( $lesseq(0,K)
         => ( iter1($sum(N,$product(lambda1,K)),x01) = iter1(N,x01) ) ) ) ).

tff(bool_inversion,axiom,
    ! [U: bool1] :
      ( ( U = true1 )
      | ( U = false1 ) ) ).

tff(rel_def,axiom,
    ! [T2: t1,T1: t1] :
      ( ? [I: $int] :
          ( ( T2 = iter1($sum(I,1),x01) )
          & ( $less(dist1($sum($product(2,I),2),$sum(I,1)),dist1($product(2,I),I))
           <= $lesseq(mu1,I) )
          & $lesseq(I,$sum(mu1,lambda1))
          & $lesseq(1,I)
          & ( T1 = iter1(I,x01) ) )
    <=> rel1(T2,T1) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple02] : ( U = tuple03 ) ).

tff(match_bool_sort2,axiom,
    ! [A: ty,X: bool1,X1: uni,X2: uni] : sort1(A,match_bool1(A,X,X1,X2)) ).

tff(distinct,axiom,
    ! [I: $int,J: $int] :
      ( ( $less(I,$sum(mu1,lambda1))
        & $lesseq(0,I) )
     => ( ( ( iter1(I,x01) != iter1(J,x01) )
         <= ( I != J ) )
       <= ( $less(J,$sum(mu1,lambda1))
          & $lesseq(0,J) ) ) ) ).

