tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort1: ( ty * uni ) > $o ).

tff(witness,type,
    witness1: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool1: $tType ).

tff(bool1,type,
    bool: ty ).

tff(true,type,
    true1: bool1 ).

tff(false,type,
    false1: bool1 ).

tff(match_bool,type,
    match_bool1: ( ty * bool1 * uni * uni ) > uni ).

tff(tuple0,type,
    tuple02: $tType ).

tff(tuple01,type,
    tuple0: ty ).

tff(tuple02,type,
    tuple03: tuple02 ).

tff(qtmark,type,
    qtmark: ty ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(const1,type,
    const: ( ty * ty * uni ) > uni ).

tff(array,type,
    array: ty > ty ).

tff(mk_array,type,
    mk_array1: ( ty * $int * uni ) > uni ).

tff(length,type,
    length1: ( ty * uni ) > $int ).

tff(elts,type,
    elts: ( ty * uni ) > uni ).

tff(get1,type,
    get2: ( ty * uni * $int ) > uni ).

tff(t2tb,type,
    t2tb: $int > uni ).

tff(tb2t,type,
    tb2t: uni > $int ).

tff(set1,type,
    set2: ( ty * uni * $int * uni ) > uni ).

tff(make,type,
    make1: ( ty * $int * uni ) > uni ).

tff(array_int,type,
    array_int: $tType ).

tff(is_common_prefix,type,
    is_common_prefix1: ( array_int * $int * $int * $int ) > $o ).

tff(t2tb1,type,
    t2tb1: array_int > uni ).

tff(tb2t1,type,
    tb2t1: uni > array_int ).

tff(is_longest_common_prefix,type,
    is_longest_common_prefix1: ( array_int * $int * $int * $int ) > $o ).

tff(lt,type,
    lt1: ( array_int * $int * $int ) > $o ).

tff(map_int_int,type,
    map_int_int: $tType ).

tff(injective,type,
    injective1: ( map_int_int * $int ) > $o ).

tff(t2tb2,type,
    t2tb2: map_int_int > uni ).

tff(tb2t2,type,
    tb2t2: uni > map_int_int ).

tff(surjective,type,
    surjective1: ( map_int_int * $int ) > $o ).

tff(range,type,
    range2: ( map_int_int * $int ) > $o ).

tff(occ,type,
    occ1: ( ty * uni * uni * $int * $int ) > $int ).

tff(range1,type,
    range3: array_int > $o ).

tff(permut,type,
    permut2: ( ty * uni * uni * $int * $int ) > $o ).

tff(map_eq_sub,type,
    map_eq_sub1: ( ty * uni * uni * $int * $int ) > $o ).

tff(array_eq_sub,type,
    array_eq_sub1: ( ty * uni * uni * $int * $int ) > $o ).

tff(array_eq,type,
    array_eq: ( ty * uni * uni ) > $o ).

tff(exchange,type,
    exchange2: ( ty * uni * uni * $int * $int * $int * $int ) > $o ).

tff(exchange1,type,
    exchange3: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut1,type,
    permut3: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut_sub,type,
    permut_sub1: ( ty * uni * uni * $int * $int ) > $o ).

tff(permut_all,type,
    permut_all: ( ty * uni * uni ) > $o ).

tff(le,type,
    le1: ( array_int * $int * $int ) > $o ).

tff(sorted_sub,type,
    sorted_sub1: ( array_int * map_int_int * $int * $int ) > $o ).

tff(sorted,type,
    sorted1: ( array_int * array_int ) > $o ).

tff(permut_trans,axiom,
    ! [A: ty,A1: uni,A2: uni,A3: uni,L: $int,U: $int] :
      ( permut2(A,A1,A2,L,U)
     => ( permut2(A,A2,A3,L,U)
       => permut2(A,A1,A3,L,U) ) ) ).

tff(longest_common_prefix_succ,axiom,
    ! [A: array_int,X: $int,Y: $int,L: $int] :
      ( is_longest_common_prefix1(A,X,Y,L)
     <= ( is_common_prefix1(A,X,Y,L)
        & ~ is_common_prefix1(A,X,Y,$sum(L,1)) ) ) ).

tff(exchange_set,axiom,
    ! [A: ty,A1: uni,L: $int,U: $int,I: $int,J: $int] :
      ( ( exchange2(A,A1,set(A,int,set(A,int,A1,t2tb(I),get(A,int,A1,t2tb(J))),t2tb(J),get(A,int,A1,t2tb(I))),L,U,I,J)
       <= ( $lesseq(L,J)
          & $less(J,U) ) )
     <= ( $lesseq(L,I)
        & $less(I,U) ) ) ).

tff(elts_sort2,axiom,
    ! [A: ty,X: uni] : sort1(map(int,A),elts(A,X)) ).

tff(exchange_def1,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int] :
      ( exchange3(A,A1,A2,I,J)
    <=> ( ( length1(A,A1) = length1(A,A2) )
        & exchange2(A,elts(A,A1),elts(A,A2),0,length1(A,A1),I,J) ) ) ).

tff(elts_def3,axiom,
    ! [A: ty,U: $int,U1: uni] :
      ( ( elts(A,mk_array1(A,U,U1)) = U1 )
     <= sort1(map(int,A),U1) ) ).

tff(const,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( ( get(B,A,const(B,A,B1),A1) = B1 )
     <= sort1(B,B1) ) ).

tff(lcp_same_index,axiom,
    ! [A: array_int,X: $int] :
      ( is_longest_common_prefix1(A,X,X,$difference(length1(int,t2tb1(A)),X))
     <= ( $lesseq(X,length1(int,t2tb1(A)))
        & $lesseq(0,X) ) ) ).

tff(t2tb_sort4,axiom,
    ! [X: map_int_int] : sort1(map(int,int),t2tb2(X)) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z1)
     => ( match_bool1(A,false1,Z,Z1) = Z1 ) ) ).

tff(sorted_sub_def,axiom,
    ! [A: array_int,Data: map_int_int,L: $int,U: $int] :
      ( ! [I1: $int,I2: $int] :
          ( ( $lesseq(L,I1)
            & $lesseq(I1,I2)
            & $less(I2,U) )
         => le1(A,tb2t(get(int,int,t2tb2(Data),t2tb(I1))),tb2t(get(int,int,t2tb2(Data),t2tb(I2)))) )
    <=> sorted_sub1(A,Data,L,U) ) ).

tff(make_def,axiom,
    ! [A: ty,N: $int,V: uni] : ( make1(A,N,V) = mk_array1(A,N,const(A,int,V)) ) ).

tff(witness_sort1,axiom,
    ! [A: ty] : sort1(A,witness1(A)) ).

tff(is_longest_common_prefix_def,axiom,
    ! [A: array_int,X: $int,Y: $int,L: $int] :
      ( is_longest_common_prefix1(A,X,Y,L)
    <=> ( is_common_prefix1(A,X,Y,L)
        & ! [M: $int] :
            ( ~ is_common_prefix1(A,X,Y,M)
           <= $less(L,M) ) ) ) ).

tff(injective_surjective,axiom,
    ! [A: map_int_int,N: $int] :
      ( injective1(A,N)
     => ( surjective1(A,N)
       <= range2(A,N) ) ) ).

tff(permut_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( ( map_eq_sub1(A,elts(A,A1),elts(A,A2),U,length1(A,A1))
        & permut3(A,A1,A2,L,U)
        & map_eq_sub1(A,elts(A,A1),elts(A,A2),0,L) )
    <=> permut_sub1(A,A1,A2,L,U) ) ).

tff(true_False,axiom,
    true1 != false1 ).

tff(select_neq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( ( sort1(A,A2)
       => ! [B1: uni] :
            ( ( A1 != A2 )
           => ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) ) ) )
     <= sort1(A,A1) ) ).

tff(occ_right_no_add,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( $less(L,U)
       => ( ( get(A,int,M,t2tb($difference(U,1))) != V )
         => ( occ1(A,V,M,L,U) = occ1(A,V,M,L,$difference(U,1)) ) ) )
     <= sort1(A,V) ) ).

tff(sorted_def,axiom,
    ! [A: array_int,Data: array_int] :
      ( sorted1(A,Data)
    <=> sorted_sub1(A,tb2t2(elts(int,t2tb1(Data))),0,length1(int,t2tb1(Data))) ) ).

tff(le_def,axiom,
    ! [A: array_int,X: $int,Y: $int] :
      ( le1(A,X,Y)
    <=> ( lt1(A,X,Y)
        | ( X = Y ) ) ) ).

tff(occ_bounds,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( $lesseq(0,occ1(A,V,M,L,U))
        & $lesseq(occ1(A,V,M,L,U),$difference(U,L)) )
     <= $lesseq(L,U) ) ).

tff(t2tb_sort2,axiom,
    ! [X: $int] : sort1(int,t2tb(X)) ).

tff(le_trans,axiom,
    ! [A: array_int,X: $int,Y: $int,Z: $int] :
      ( ( le1(A,Y,Z)
        & le1(A,X,Y) )
     => le1(A,X,Z) ) ).

tff(array_eq_def,axiom,
    ! [A: ty,A1: uni,A2: uni] :
      ( array_eq(A,A1,A2)
    <=> ( map_eq_sub1(A,elts(A,A1),elts(A,A2),0,length1(A,A1))
        & ( length1(A,A1) = length1(A,A2) ) ) ) ).

tff(exchange_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int,I: $int,J: $int] :
      ( ( $lesseq(L,I)
        & ( get(A,int,A1,t2tb(I)) = get(A,int,A2,t2tb(J)) )
        & ( get(A,int,A1,t2tb(J)) = get(A,int,A2,t2tb(I)) )
        & ! [K: $int] :
            ( ( ( ( K != J )
               => ( get(A,int,A1,t2tb(K)) = get(A,int,A2,t2tb(K)) ) )
             <= ( K != I ) )
           <= ( $less(K,U)
              & $lesseq(L,K) ) )
        & $less(J,U)
        & $lesseq(L,J)
        & $less(I,U) )
    <=> exchange2(A,A1,A2,L,U,I,J) ) ).

tff(occ_right_add,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( $less(L,U)
     => ( ( get(A,int,M,t2tb($difference(U,1))) = V )
       => ( occ1(A,V,M,L,U) = $sum(1,occ1(A,V,M,L,$difference(U,1))) ) ) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $lesseq(X,Y)
     => ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) ) ) ).

tff(bridgeL2,axiom,
    ! [I: map_int_int] : ( tb2t2(t2tb2(I)) = I ) ).

tff(make_sort2,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),make1(A,X,X1)) ).

tff(injection_occ,axiom,
    ! [M: map_int_int,N: $int] :
      ( ! [V: $int] : $lesseq(occ1(int,t2tb(V),t2tb2(M),0,N),1)
    <=> injective1(M,N) ) ).

tff(occ_neq,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( ! [I: $int] :
            ( ( $less(I,U)
              & $lesseq(L,I) )
           => ( get(A,int,M,t2tb(I)) != V ) )
       => ( occ1(A,V,M,L,U) = 0 ) )
     <= sort1(A,V) ) ).

tff(exchange_permut_sub,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int,L: $int,U: $int] :
      ( ( ( $less(I,U)
          & $lesseq(L,I) )
       => ( ( $lesseq(0,L)
           => ( $lesseq(U,length1(A,A1))
             => permut_sub1(A,A1,A2,L,U) ) )
         <= ( $less(J,U)
            & $lesseq(L,J) ) ) )
     <= exchange3(A,A1,A2,I,J) ) ).

tff(range_def,axiom,
    ! [A: map_int_int,N: $int] :
      ( ! [I: $int] :
          ( ( $lesseq(0,I)
            & $less(I,N) )
         => ( $less(tb2t(get(int,int,t2tb2(A),t2tb(I))),N)
            & $lesseq(0,tb2t(get(int,int,t2tb2(A),t2tb(I)))) ) )
    <=> range2(A,N) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple02] : ( U = tuple03 ) ).

tff(ref_inversion3,axiom,
    ! [A: ty,U: uni] :
      ( sort1(ref(A),U)
     => ( U = mk_ref(A,contents(A,U)) ) ) ).

tff(contents_sort1,axiom,
    ! [A: ty,X: uni] : sort1(A,contents(A,X)) ).

tff(mk_ref_sort1,axiom,
    ! [A: ty,X: uni] : sort1(ref(A),mk_ref(A,X)) ).

tff(permut_all_def,axiom,
    ! [A: ty,A1: uni,A2: uni] :
      ( permut_all(A,A1,A2)
    <=> ( ( length1(A,A1) = length1(A,A2) )
        & permut2(A,elts(A,A1),elts(A,A2),0,length1(A,A1)) ) ) ).

tff(mk_array_sort2,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),mk_array1(A,X,X1)) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(not_common_prefix_if_last_char_are_different,axiom,
    ! [A: array_int,X: $int,Y: $int,L: $int] :
      ( ~ is_common_prefix1(A,X,Y,$sum(L,1))
     <= ( $lesseq(0,L)
        & $less($sum(X,L),length1(int,t2tb1(A)))
        & $less($sum(Y,L),length1(int,t2tb1(A)))
        & ( tb2t(get2(int,t2tb1(A),$sum(X,L))) != tb2t(get2(int,t2tb1(A),$sum(Y,L))) ) ) ) ).

tff(occ_empty,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( occ1(A,V,M,L,U) = 0 )
     <= $lesseq(U,L) ) ).

tff(get_def,axiom,
    ! [A: ty,A1: uni,I: $int] : ( get2(A,A1,I) = get(A,int,elts(A,A1),t2tb(I)) ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z)
     => ( match_bool1(A,true1,Z,Z1) = Z ) ) ).

tff(length_def3,axiom,
    ! [A: ty,U: $int,U1: uni] : ( length1(A,mk_array1(A,U,U1)) = U ) ).

tff(occ_exists,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,U: $int] :
      ( ( $less(0,occ1(A,V,M,L,U))
       => ? [I: $int] :
            ( $lesseq(L,I)
            & ( get(A,int,M,t2tb(I)) = V )
            & $less(I,U) ) )
     <= sort1(A,V) ) ).

tff(permut_exists,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int,I: $int] :
      ( ( ( $less(I,U)
          & $lesseq(L,I) )
       => ? [J: $int] :
            ( $lesseq(L,J)
            & $less(J,U)
            & ( get(A,int,A1,t2tb(J)) = get(A,int,A2,t2tb(I)) ) ) )
     <= permut2(A,A1,A2,L,U) ) ).

tff(set_def,axiom,
    ! [A: ty,A1: uni,I: $int,V: uni] : ( set2(A,A1,I,V) = mk_array1(A,length1(A,A1),set(A,int,elts(A,A1),t2tb(I),V)) ) ).

tff(set_sort4,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort1(map(A,B),set(B,A,X,X1,X2)) ).

tff(surjective_def,axiom,
    ! [A: map_int_int,N: $int] :
      ( ! [I: $int] :
          ( ( $lesseq(0,I)
            & $less(I,N) )
         => ? [J: $int] :
              ( $lesseq(0,J)
              & ( tb2t(get(int,int,t2tb2(A),t2tb(J))) = I )
              & $less(J,N) ) )
    <=> surjective1(A,N) ) ).

tff(array_eq_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( ( ( length1(A,A1) = length1(A,A2) )
        & $lesseq(0,L)
        & $lesseq(L,length1(A,A1))
        & $lesseq(U,length1(A,A1))
        & map_eq_sub1(A,elts(A,A1),elts(A,A2),L,U)
        & $lesseq(0,U) )
    <=> array_eq_sub1(A,A1,A2,L,U) ) ).

tff(occ_append,axiom,
    ! [A: ty,V: uni,M: uni,L: $int,Mid: $int,U: $int] :
      ( ( occ1(A,V,M,L,U) = $sum(occ1(A,V,M,L,Mid),occ1(A,V,M,Mid,U)) )
     <= ( $lesseq(L,Mid)
        & $lesseq(Mid,U) ) ) ).

tff(bridgeL1,axiom,
    ! [I: array_int] : ( tb2t1(t2tb1(I)) = I ) ).

tff(bridgeL,axiom,
    ! [I: $int] : ( tb2t(t2tb(I)) = I ) ).

tff(permut_def1,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( permut3(A,A1,A2,L,U)
    <=> ( permut2(A,elts(A,A1),elts(A,A2),L,U)
        & $lesseq(U,length1(A,A1))
        & $lesseq(0,U)
        & $lesseq(L,length1(A,A1))
        & $lesseq(0,L)
        & ( length1(A,A1) = length1(A,A2) ) ) ) ).

tff(range_def1,axiom,
    ! [A: array_int] :
      ( range2(tb2t2(elts(int,t2tb1(A))),length1(int,t2tb1(A)))
    <=> range3(A) ) ).

tff(injective_def,axiom,
    ! [A: map_int_int,N: $int] :
      ( injective1(A,N)
    <=> ! [I: $int,J: $int] :
          ( ( $less(I,N)
            & $lesseq(0,I) )
         => ( ( ( I != J )
             => ( tb2t(get(int,int,t2tb2(A),t2tb(I))) != tb2t(get(int,int,t2tb2(A),t2tb(J))) ) )
           <= ( $lesseq(0,J)
              & $less(J,N) ) ) ) ) ).

tff(permut_def,axiom,
    ! [A: ty,M1: uni,M2: uni,L: $int,U: $int] :
      ( ( permut2(A,M1,M2,L,U)
       => ! [V: uni] : ( occ1(A,V,M1,L,U) = occ1(A,V,M2,L,U) ) )
      & ( ! [V: uni] :
            ( ( occ1(A,V,M1,L,U) = occ1(A,V,M2,L,U) )
           <= sort1(A,V) )
       => permut2(A,M1,M2,L,U) ) ) ).

tff(permut_sub_weakening,axiom,
    ! [A: ty,A1: uni,A2: uni,L1: $int,U1: $int,L2: $int,U2: $int] :
      ( ( ( $lesseq(0,L2)
          & $lesseq(L2,L1) )
       => ( ( $lesseq(U2,length1(A,A1))
            & $lesseq(U1,U2) )
         => permut_sub1(A,A1,A2,L2,U2) ) )
     <= permut_sub1(A,A1,A2,L1,U1) ) ).

tff(lt_def,axiom,
    ! [A: array_int,X: $int,Y: $int] :
      ( ( $lesseq(0,X)
        & $lesseq(X,length1(int,t2tb1(A)))
        & $lesseq(0,Y)
        & ? [L: $int] :
            ( is_common_prefix1(A,X,Y,L)
            & $less($sum(Y,L),length1(int,t2tb1(A)))
            & ( $less(tb2t(get2(int,t2tb1(A),$sum(X,L))),tb2t(get2(int,t2tb1(A),$sum(Y,L))))
              | ( $sum(X,L) = length1(int,t2tb1(A)) ) ) )
        & $lesseq(Y,length1(int,t2tb1(A))) )
    <=> lt1(A,X,Y) ) ).

tff(get_sort5,axiom,
    ! [A: ty,X: uni,X1: $int] : sort1(A,get2(A,X,X1)) ).

tff(is_common_prefix_def,axiom,
    ! [A: array_int,X: $int,Y: $int,L: $int] :
      ( ( $lesseq($sum(Y,L),length1(int,t2tb1(A)))
        & ! [I: $int] :
            ( ( $less(I,L)
              & $lesseq(0,I) )
           => ( tb2t(get2(int,t2tb1(A),$sum(X,I))) = tb2t(get2(int,t2tb1(A),$sum(Y,I))) ) )
        & $lesseq($sum(X,L),length1(int,t2tb1(A)))
        & $lesseq(0,L) )
    <=> is_common_prefix1(A,X,Y,L) ) ).

tff(const_sort2,axiom,
    ! [A: ty,B: ty,X: uni] : sort1(map(A,B),const(B,A,X)) ).

tff(get_sort4,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort1(B,get(B,A,X,X1)) ).

tff(t2tb_sort3,axiom,
    ! [X: array_int] : sort1(array(int),t2tb1(X)) ).

tff(map_eq_sub_def,axiom,
    ! [A: ty,A1: uni,A2: uni,L: $int,U: $int] :
      ( map_eq_sub1(A,A1,A2,L,U)
    <=> ! [I: $int] :
          ( ( $less(I,U)
            & $lesseq(L,I) )
         => ( get(A,int,A1,t2tb(I)) = get(A,int,A2,t2tb(I)) ) ) ) ).

tff(select_eq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( ( ( get(B,A,set(B,A,M,A1,B1),A2) = B1 )
       <= ( A1 = A2 ) )
     <= sort1(B,B1) ) ).

tff(bool_inversion,axiom,
    ! [U: bool1] :
      ( ( U = true1 )
      | ( U = false1 ) ) ).

tff(bridgeR1,axiom,
    ! [J: uni] : ( t2tb1(tb2t1(J)) = J ) ).

tff(occ_pos,axiom,
    ! [A: ty,M: uni,L: $int,U: $int,I: $int] :
      ( $less(0,occ1(A,get(A,int,M,t2tb(I)),M,L,U))
     <= ( $less(I,U)
        & $lesseq(L,I) ) ) ).

tff(occ_eq,axiom,
    ! [A: ty,V: uni,M1: uni,M2: uni,L: $int,U: $int] :
      ( ( occ1(A,V,M1,L,U) = occ1(A,V,M2,L,U) )
     <= ! [I: $int] :
          ( ( $lesseq(L,I)
            & $less(I,U) )
         => ( get(A,int,M1,t2tb(I)) = get(A,int,M2,t2tb(I)) ) ) ) ).

tff(contents_def3,axiom,
    ! [A: ty,U: uni] :
      ( ( contents(A,mk_ref(A,U)) = U )
     <= sort1(A,U) ) ).

tff(bridgeR2,axiom,
    ! [J: uni] : ( t2tb2(tb2t2(J)) = J ) ).

tff(exchange_permut_all,axiom,
    ! [A: ty,A1: uni,A2: uni,I: $int,J: $int] :
      ( exchange3(A,A1,A2,I,J)
     => permut_all(A,A1,A2) ) ).

tff(set_sort5,axiom,
    ! [A: ty,X: uni,X1: $int,X2: uni] : sort1(array(A),set2(A,X,X1,X2)) ).

tff(array_inversion3,axiom,
    ! [A: ty,U: uni] : ( U = mk_array1(A,length1(A,U),elts(A,U)) ) ).

tff(wP_parameter_sort,conjecture,
    ! [A: $int,A1: map_int_int,Data: $int,Data1: map_int_int] :
      ( ( $lesseq(0,$difference(Data,1))
       => ! [Data2: map_int_int,I: $int] :
            ( ( $lesseq(I,$difference(Data,1))
              & $lesseq(0,I) )
           => ( ( sorted_sub1(tb2t1(mk_array1(int,A,t2tb2(A1))),Data2,0,I)
                & range2(Data2,Data)
                & permut_all(int,mk_array1(int,Data,t2tb2(Data1)),mk_array1(int,Data,t2tb2(Data2))) )
             => ! [J: $int,Data3: map_int_int] :
                  ( ( $lesseq(J,I)
                    & range2(Data3,Data)
                    & permut_all(int,mk_array1(int,Data,t2tb2(Data1)),mk_array1(int,Data,t2tb2(Data3)))
                    & sorted_sub1(tb2t1(mk_array1(int,A,t2tb2(A1))),Data3,0,J)
                    & sorted_sub1(tb2t1(mk_array1(int,A,t2tb2(A1))),Data3,J,$sum(I,1))
                    & ! [K1: $int,K2: $int] :
                        ( ( $less(K1,J)
                          & $lesseq($sum(J,1),K2)
                          & $lesseq(K2,I)
                          & $lesseq(0,K1) )
                       => le1(tb2t1(mk_array1(int,A,t2tb2(A1))),tb2t(get(int,int,t2tb2(Data3),t2tb(K1))),tb2t(get(int,int,t2tb2(Data3),t2tb(K2)))) )
                    & $lesseq(0,J) )
                 => ( ( ( ( ( $lesseq(tb2t(get(int,int,t2tb2(Data3),t2tb($difference(J,1)))),A)
                            & $lesseq(0,tb2t(get(int,int,t2tb2(Data3),t2tb(J))))
                            & $lesseq(tb2t(get(int,int,t2tb2(Data3),t2tb(J))),A)
                            & $lesseq(0,tb2t(get(int,int,t2tb2(Data3),t2tb($difference(J,1))))) )
                         => ! [O: $int] :
                              ( ( ( ( $less(J,Data)
                                    & $lesseq(0,J) )
                                 => ( ( $lesseq(0,$difference(J,1))
                                      & $less($difference(J,1),Data) )
                                   => ( ! [Data4: map_int_int] :
                                          ( ( ( Data4 = tb2t2(set(int,int,t2tb2(Data3),t2tb(J),get(int,int,t2tb2(Data3),t2tb($difference(J,1))))) )
                                            & $lesseq(0,Data) )
                                         => ( ( $lesseq(0,$difference(J,1))
                                              & $less($difference(J,1),Data) )
                                           => ! [Data5: map_int_int] :
                                                ( ( ( Data5 = tb2t2(set(int,int,t2tb2(Data4),t2tb($difference(J,1)),get(int,int,t2tb2(Data3),t2tb(J)))) )
                                                  & $lesseq(0,Data) )
                                               => ( ! [J1: $int] :
                                                      ( ( J1 = $difference(J,1) )
                                                     => ! [K1: $int,K2: $int] :
                                                          ( le1(tb2t1(mk_array1(int,A,t2tb2(A1))),tb2t(get(int,int,t2tb2(Data5),t2tb(K1))),tb2t(get(int,int,t2tb2(Data5),t2tb(K2))))
                                                         <= ( $less(K1,J1)
                                                            & $lesseq($sum(J1,1),K2)
                                                            & $lesseq(K2,I)
                                                            & $lesseq(0,K1) ) ) )
                                                 <= exchange3(int,mk_array1(int,Data,t2tb2(Data3)),mk_array1(int,Data,t2tb2(Data5)),$difference(J,1),J) ) ) ) )
                                     <= ( $lesseq(0,J)
                                        & $less(J,Data) ) ) ) )
                               <= $less(0,O) )
                             <= ( ( $less(O,0)
                                 => lt1(tb2t1(mk_array1(int,A,t2tb2(A1))),tb2t(get(int,int,t2tb2(Data3),t2tb($difference(J,1)))),tb2t(get(int,int,t2tb2(Data3),t2tb(J)))) )
                                & ( $less(0,O)
                                 => lt1(tb2t1(mk_array1(int,A,t2tb2(A1))),tb2t(get(int,int,t2tb2(Data3),t2tb(J))),tb2t(get(int,int,t2tb2(Data3),t2tb($difference(J,1))))) )
                                & ( ( tb2t(get(int,int,t2tb2(Data3),t2tb($difference(J,1)))) = tb2t(get(int,int,t2tb2(Data3),t2tb(J))) )
                                 <= ( O = 0 ) ) ) ) )
                       <= ( $lesseq(0,$difference(J,1))
                          & $less($difference(J,1),Data) ) )
                     <= ( $lesseq(0,Data)
                        & $lesseq(0,J)
                        & $less(J,Data) ) )
                   <= $less(0,J) ) ) ) ) )
     <= ( $lesseq(0,A)
        & ( Data = A )
        & range2(Data1,Data)
        & $lesseq(0,Data) ) ) ).

tff(match_bool_sort2,axiom,
    ! [A: ty,X: bool1,X1: uni,X2: uni] : sort1(A,match_bool1(A,X,X1,X2)) ).

