tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort1: ( ty * uni ) > $o ).

tff(witness,type,
    witness1: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool1: $tType ).

tff(bool1,type,
    bool: ty ).

tff(true,type,
    true1: bool1 ).

tff(false,type,
    false1: bool1 ).

tff(match_bool,type,
    match_bool1: ( ty * bool1 * uni * uni ) > uni ).

tff(tuple0,type,
    tuple02: $tType ).

tff(tuple01,type,
    tuple0: ty ).

tff(tuple02,type,
    tuple03: tuple02 ).

tff(qtmark,type,
    qtmark: ty ).

tff(abs,type,
    abs1: $int > $int ).

tff(div,type,
    div1: ( $int * $int ) > $int ).

tff(mod,type,
    mod1: ( $int * $int ) > $int ).

tff(power,type,
    power1: ( $int * $int ) > $int ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(const1,type,
    const: ( ty * ty * uni ) > uni ).

tff(array,type,
    array: ty > ty ).

tff(mk_array,type,
    mk_array1: ( ty * $int * uni ) > uni ).

tff(length,type,
    length1: ( ty * uni ) > $int ).

tff(elts,type,
    elts: ( ty * uni ) > uni ).

tff(get1,type,
    get2: ( ty * uni * $int ) > uni ).

tff(t2tb,type,
    t2tb: $int > uni ).

tff(tb2t,type,
    tb2t: uni > $int ).

tff(set1,type,
    set2: ( ty * uni * $int * uni ) > uni ).

tff(make,type,
    make1: ( ty * $int * uni ) > uni ).

tff(map_int_int,type,
    map_int_int: $tType ).

tff(sum,type,
    sum2: ( map_int_int * $int * $int ) > $int ).

tff(t2tb1,type,
    t2tb1: map_int_int > uni ).

tff(tb2t1,type,
    tb2t1: uni > map_int_int ).

tff(array_int,type,
    array_int: $tType ).

tff(sum1,type,
    sum3: ( array_int * $int * $int ) > $int ).

tff(t2tb2,type,
    t2tb2: array_int > uni ).

tff(tb2t2,type,
    tb2t2: uni > array_int ).

tff(is_power_of_2,type,
    is_power_of_21: $int > $o ).

tff(elts_def1,axiom,
    ! [A: ty,U: $int,U1: uni] :
      ( ( elts(A,mk_array1(A,U,U1)) = U1 )
     <= sort1(map(int,A),U1) ) ).

tff(power_s,axiom,
    ! [X: $int,N: $int] :
      ( $lesseq(0,N)
     => ( power1(X,$sum(N,1)) = $product(X,power1(X,N)) ) ) ).

tff(abs_le,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(X,Y)
        & $lesseq($uminus(Y),X) )
    <=> $lesseq(abs1(X),Y) ) ).

tff(set_def,axiom,
    ! [A: ty,A1: uni,I: $int,V: uni] : ( set2(A,A1,I,V) = mk_array1(A,length1(A,A1),set(A,int,elts(A,A1),t2tb(I),V)) ) ).

tff(sum_right_extension,axiom,
    ! [C: map_int_int,I: $int,J: $int] :
      ( $less(I,J)
     => ( sum2(C,I,J) = $sum(sum2(C,I,$difference(J,1)),tb2t(get(int,int,t2tb1(C),t2tb($difference(J,1))))) ) ) ).

tff(power_1,axiom,
    ! [X: $int] : ( power1(X,1) = X ) ).

tff(bridgeR1,axiom,
    ! [J: uni] : ( t2tb1(tb2t1(J)) = J ) ).

tff(mod_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( mod1(X,Y) = X )
     <= ( $less(X,Y)
        & $lesseq(0,X) ) ) ).

tff(get_def,axiom,
    ! [A: ty,A1: uni,I: $int] : ( get2(A,A1,I) = get(A,int,elts(A,A1),t2tb(I)) ) ).

tff(sum_def_non_empty,axiom,
    ! [C: map_int_int,I: $int,J: $int] :
      ( ( sum2(C,I,J) = $sum(tb2t(get(int,int,t2tb1(C),t2tb(I))),sum2(C,$sum(I,1),J)) )
     <= $less(I,J) ) ).

tff(div_1,axiom,
    ! [X: $int] : ( div1(X,1) = X ) ).

tff(set_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort1(map(A,B),set(B,A,X,X1,X2)) ).

tff(mod_1,axiom,
    ! [X: $int] : ( mod1(X,1) = 0 ) ).

tff(is_power_of_2_1,conjecture,
    ! [X: $int] :
      ( ( $less(1,X)
       => ( $product(2,div1(X,2)) = X ) )
     <= is_power_of_21(X) ) ).

tff(div_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $less(0,X)
        & $lesseq(0,Y)
        & $lesseq(0,Z) )
     => ( div1($sum($product(X,Y),Z),X) = $sum(Y,div1(Z,X)) ) ) ).

tff(div_mod_2,axiom,
    ! [X: $int] :
      ( ( $lesseq($difference(X,1),$product(2,div1(X,2)))
        & $lesseq($product(2,div1(X,2)),X) )
     <= $lesseq(0,X) ) ).

tff(div_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(0,div1(X,Y))
     <= ( $lesseq(0,X)
        & $less(0,Y) ) ) ).

tff(div_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(div1(X,Y),0)
     <= ( $less(0,Y)
        & $lesseq(X,0) ) ) ).

tff(power_0,axiom,
    ! [X: $int] : ( power1(X,0) = 1 ) ).

tff(get_sort3,axiom,
    ! [A: ty,X: uni,X1: $int] : sort1(A,get2(A,X,X1)) ).

tff(bridgeL,axiom,
    ! [I: $int] : ( tb2t(t2tb(I)) = I ) ).

tff(power_sum,axiom,
    ! [X: $int,N: $int,M: $int] :
      ( $lesseq(0,N)
     => ( ( power1(X,$sum(N,M)) = $product(power1(X,N),power1(X,M)) )
       <= $lesseq(0,M) ) ) ).

tff(get_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort1(B,get(B,A,X,X1)) ).

tff(rounds_toward_zero,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(abs1($product(div1(X,Y),Y)),abs1(X))
     <= ( Y != 0 ) ) ).

tff(sum_transitivity,axiom,
    ! [C: map_int_int,I: $int,K: $int,J: $int] :
      ( ( $lesseq(K,J)
        & $lesseq(I,K) )
     => ( sum2(C,I,J) = $sum(sum2(C,I,K),sum2(C,K,J)) ) ) ).

tff(mod_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less($uminus(abs1(Y)),mod1(X,Y))
        & $less(mod1(X,Y),abs1(Y)) )
     <= ( Y != 0 ) ) ).

tff(t2tb_sort2,axiom,
    ! [X: array_int] : sort1(array(int),t2tb2(X)) ).

tff(const_sort1,axiom,
    ! [A: ty,B: ty,X: uni] : sort1(map(A,B),const(B,A,X)) ).

tff(power_s_alt,axiom,
    ! [X: $int,N: $int] :
      ( ( power1(X,N) = $product(X,power1(X,$difference(N,1))) )
     <= $less(0,N) ) ).

tff(elts_sort1,axiom,
    ! [A: ty,X: uni] : sort1(map(int,A),elts(A,X)) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple02] : ( U = tuple03 ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool1(A,false1,Z,Z1) = Z1 )
     <= sort1(A,Z1) ) ).

tff(power_mult,axiom,
    ! [X: $int,N: $int,M: $int] :
      ( ( ( power1(X,$product(N,M)) = power1(power1(X,N),M) )
       <= $lesseq(0,M) )
     <= $lesseq(0,N) ) ).

tff(div_mod,axiom,
    ! [X: $int,Y: $int] :
      ( ( Y != 0 )
     => ( X = $sum($product(Y,div1(X,Y)),mod1(X,Y)) ) ) ).

tff(const,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( sort1(B,B1)
     => ( get(B,A,const(B,A,B1),A1) = B1 ) ) ).

tff(length_def1,axiom,
    ! [A: ty,U: $int,U1: uni] : ( length1(A,mk_array1(A,U,U1)) = U ) ).

tff(abs_def,axiom,
    ! [X: $int] :
      ( ( ~ $lesseq(0,X)
       => ( abs1(X) = $uminus(X) ) )
      & ( ( abs1(X) = X )
       <= $lesseq(0,X) ) ) ).

tff(bridgeL1,axiom,
    ! [I: map_int_int] : ( tb2t1(t2tb1(I)) = I ) ).

tff(mk_array_sort1,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),mk_array1(A,X,X1)) ).

tff(array_inversion1,axiom,
    ! [A: ty,U: uni] : ( U = mk_array1(A,length1(A,U),elts(A,U)) ) ).

tff(bridgeL2,axiom,
    ! [I: array_int] : ( tb2t2(t2tb2(I)) = I ) ).

tff(t2tb_sort,axiom,
    ! [X: $int] : sort1(int,t2tb(X)) ).

tff(sum_def,axiom,
    ! [A: array_int,L: $int,H: $int] : ( sum3(A,L,H) = sum2(tb2t1(elts(int,t2tb2(A))),L,H) ) ).

tff(div_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( div1(X,Y) = 0 )
     <= ( $less(X,Y)
        & $lesseq(0,X) ) ) ).

tff(set_sort3,axiom,
    ! [A: ty,X: uni,X1: $int,X2: uni] : sort1(array(A),set2(A,X,X1,X2)) ).

tff(true_False,axiom,
    true1 != false1 ).

tff(select_neq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( ( sort1(A,A2)
       => ! [B1: uni] :
            ( ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) )
           <= ( A1 != A2 ) ) )
     <= sort1(A,A1) ) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(sum_eq,axiom,
    ! [C1: map_int_int,C2: map_int_int,I: $int,J: $int] :
      ( ! [K: $int] :
          ( ( $lesseq(I,K)
            & $less(K,J) )
         => ( tb2t(get(int,int,t2tb1(C1),t2tb(K))) = tb2t(get(int,int,t2tb1(C2),t2tb(K))) ) )
     => ( sum2(C1,I,J) = sum2(C2,I,J) ) ) ).

tff(is_power_of_2_def,axiom,
    ! [X: $int] :
      ( is_power_of_21(X)
    <=> ? [K: $int] :
          ( $lesseq(0,K)
          & ( X = power1(2,K) ) ) ) ).

tff(select_eq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( sort1(B,B1)
     => ( ( get(B,A,set(B,A,M,A1,B1),A2) = B1 )
       <= ( A1 = A2 ) ) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $lesseq(X,Y)
     => ( $lesseq($product(X,Z),$product(Y,Z))
       <= $lesseq(0,Z) ) ) ).

tff(sum_def_empty,axiom,
    ! [C: map_int_int,I: $int,J: $int] :
      ( ( sum2(C,I,J) = 0 )
     <= $lesseq(J,I) ) ).

tff(bool_inversion,axiom,
    ! [U: bool1] :
      ( ( U = false1 )
      | ( U = true1 ) ) ).

tff(mod_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(X,0)
        & ( Y != 0 ) )
     => $lesseq(mod1(X,Y),0) ) ).

tff(match_bool_sort1,axiom,
    ! [A: ty,X: bool1,X1: uni,X2: uni] : sort1(A,match_bool1(A,X,X1,X2)) ).

tff(t2tb_sort1,axiom,
    ! [X: map_int_int] : sort1(map(int,int),t2tb1(X)) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z)
     => ( match_bool1(A,true1,Z,Z1) = Z ) ) ).

tff(witness_sort1,axiom,
    ! [A: ty] : sort1(A,witness1(A)) ).

tff(make_sort1,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),make1(A,X,X1)) ).

tff(mod_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(0,X)
        & ( Y != 0 ) )
     => $lesseq(0,mod1(X,Y)) ) ).

tff(bridgeR2,axiom,
    ! [J: uni] : ( t2tb2(tb2t2(J)) = J ) ).

tff(mod_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $less(0,X)
        & $lesseq(0,Z)
        & $lesseq(0,Y) )
     => ( mod1($sum($product(X,Y),Z),X) = mod1(Z,X) ) ) ).

tff(power_mult2,axiom,
    ! [X: $int,Y: $int,N: $int] :
      ( $lesseq(0,N)
     => ( power1($product(X,Y),N) = $product(power1(X,N),power1(Y,N)) ) ) ).

tff(abs_pos,axiom,
    ! [X: $int] : $lesseq(0,abs1(X)) ).

tff(div_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(0,div1(X,Y))
        & $lesseq(div1(X,Y),X) )
     <= ( $less(0,Y)
        & $lesseq(0,X) ) ) ).

tff(make_def,axiom,
    ! [A: ty,N: $int,V: uni] : ( make1(A,N,V) = mk_array1(A,N,const(A,int,V)) ) ).

