tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort1: ( ty * uni ) > $o ).

tff(witness,type,
    witness1: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool1: $tType ).

tff(bool1,type,
    bool: ty ).

tff(true,type,
    true1: bool1 ).

tff(false,type,
    false1: bool1 ).

tff(match_bool,type,
    match_bool1: ( ty * bool1 * uni * uni ) > uni ).

tff(tuple0,type,
    tuple02: $tType ).

tff(tuple01,type,
    tuple0: ty ).

tff(tuple02,type,
    tuple03: tuple02 ).

tff(qtmark,type,
    qtmark: ty ).

tff(abs,type,
    abs1: $int > $int ).

tff(div,type,
    div1: ( $int * $int ) > $int ).

tff(mod,type,
    mod1: ( $int * $int ) > $int ).

tff(power,type,
    power1: ( $int * $int ) > $int ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(const1,type,
    const: ( ty * ty * uni ) > uni ).

tff(array,type,
    array: ty > ty ).

tff(mk_array,type,
    mk_array1: ( ty * $int * uni ) > uni ).

tff(length,type,
    length1: ( ty * uni ) > $int ).

tff(elts,type,
    elts: ( ty * uni ) > uni ).

tff(get1,type,
    get2: ( ty * uni * $int ) > uni ).

tff(t2tb,type,
    t2tb: $int > uni ).

tff(tb2t,type,
    tb2t: uni > $int ).

tff(set1,type,
    set2: ( ty * uni * $int * uni ) > uni ).

tff(make,type,
    make1: ( ty * $int * uni ) > uni ).

tff(map_int_int,type,
    map_int_int: $tType ).

tff(sum,type,
    sum2: ( map_int_int * $int * $int ) > $int ).

tff(t2tb1,type,
    t2tb1: map_int_int > uni ).

tff(tb2t1,type,
    tb2t1: uni > map_int_int ).

tff(array_int,type,
    array_int: $tType ).

tff(sum1,type,
    sum3: ( array_int * $int * $int ) > $int ).

tff(t2tb2,type,
    t2tb2: array_int > uni ).

tff(tb2t2,type,
    tb2t2: uni > array_int ).

tff(is_power_of_2,type,
    is_power_of_21: $int > $o ).

tff(go_left,type,
    go_left1: ( $int * $int ) > $int ).

tff(go_right,type,
    go_right1: ( $int * $int ) > $int ).

tff(phase1,type,
    phase11: ( $int * $int * array_int * array_int ) > $o ).

tff(go_right_def,axiom,
    ! [Left: $int,Right: $int] : ( go_right1(Left,Right) = $difference(Right,div1($difference(Right,Left),2)) ) ).

tff(div_mod,axiom,
    ! [X: $int,Y: $int] :
      ( ( X = $sum($product(Y,div1(X,Y)),mod1(X,Y)) )
     <= ( Y != 0 ) ) ).

tff(t2tb_sort,axiom,
    ! [X: $int] : sort1(int,t2tb(X)) ).

tff(div_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(div1(X,Y),0)
     <= ( $less(0,Y)
        & $lesseq(X,0) ) ) ).

tff(power_sum,axiom,
    ! [X: $int,N: $int,M: $int] :
      ( $lesseq(0,N)
     => ( ( power1(X,$sum(N,M)) = $product(power1(X,N),power1(X,M)) )
       <= $lesseq(0,M) ) ) ).

tff(power_s_alt,axiom,
    ! [X: $int,N: $int] :
      ( $less(0,N)
     => ( power1(X,N) = $product(X,power1(X,$difference(N,1))) ) ) ).

tff(sum_right_extension,axiom,
    ! [C: map_int_int,I: $int,J: $int] :
      ( $less(I,J)
     => ( sum2(C,I,J) = $sum(sum2(C,I,$difference(J,1)),tb2t(get(int,int,t2tb1(C),t2tb($difference(J,1))))) ) ) ).

tff(mod_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq(0,Y)
        & $lesseq(0,Z)
        & $less(0,X) )
     => ( mod1($sum($product(X,Y),Z),X) = mod1(Z,X) ) ) ).

tff(div_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less(0,Y)
        & $lesseq(0,X) )
     => $lesseq(0,div1(X,Y)) ) ).

tff(div_mod_2,axiom,
    ! [X: $int] :
      ( $lesseq(0,X)
     => ( $lesseq($product(2,div1(X,2)),X)
        & $lesseq($difference(X,1),$product(2,div1(X,2))) ) ) ).

tff(power_1,axiom,
    ! [X: $int] : ( power1(X,1) = X ) ).

tff(elts_sort1,axiom,
    ! [A: ty,X: uni] : sort1(map(int,A),elts(A,X)) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $lesseq(X,Y)
     => ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) ) ) ).

tff(leaf,axiom,
    ! [Left: $int,Right: $int,A0: array_int,A: array_int] :
      ( ( phase11(Left,Right,A0,A)
       <= ( tb2t(get2(int,t2tb2(A),Left)) = tb2t(get2(int,t2tb2(A0),Left)) ) )
     <= ( Right = $sum(Left,1) ) ) ).

tff(bridgeR1,axiom,
    ! [J: uni] : ( t2tb1(tb2t1(J)) = J ) ).

tff(abs_le,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(abs1(X),Y)
    <=> ( $lesseq($uminus(Y),X)
        & $lesseq(X,Y) ) ) ).

tff(sum_eq,axiom,
    ! [C1: map_int_int,C2: map_int_int,I: $int,J: $int] :
      ( ! [K: $int] :
          ( ( tb2t(get(int,int,t2tb1(C1),t2tb(K))) = tb2t(get(int,int,t2tb1(C2),t2tb(K))) )
         <= ( $less(K,J)
            & $lesseq(I,K) ) )
     => ( sum2(C1,I,J) = sum2(C2,I,J) ) ) ).

tff(set_def,axiom,
    ! [A: ty,A1: uni,I: $int,V: uni] : ( set2(A,A1,I,V) = mk_array1(A,length1(A,A1),set(A,int,elts(A,A1),t2tb(I),V)) ) ).

tff(wP_parameter_upsweep,conjecture,
    ! [Left: $int,Right: $int,A: $int,A1: map_int_int] :
      ( ( $less($sum(Left,1),Right)
       => ( ( $lesseq(0,$difference(Left,div1($difference(Right,Left),2)))
            & $less($difference(Left,div1($difference(Right,Left),2)),Left)
            & $lesseq($uminus(1),$difference($difference(Left,div1($difference(Right,Left),2)),$difference(Left,$difference(Left,div1($difference(Right,Left),2)))))
            & is_power_of_21($difference(Left,$difference(Left,div1($difference(Right,Left),2))))
            & $less(Left,A) )
         => ! [A2: map_int_int] :
              ( ( ( tb2t(get(int,int,t2tb1(A2),t2tb(Left))) = sum2(A1,$sum($difference($difference(Left,div1($difference(Right,Left),2)),$difference(Left,$difference(Left,div1($difference(Right,Left),2)))),1),$sum(Left,1)) )
                & ! [I: $int] :
                    ( ( tb2t(get(int,int,t2tb1(A2),t2tb(I))) = tb2t(get(int,int,t2tb1(A1),t2tb(I))) )
                   <= $less(Left,I) )
                & ! [I: $int] :
                    ( $lesseq(I,$difference($difference(Left,div1($difference(Right,Left),2)),$difference(Left,$difference(Left,div1($difference(Right,Left),2)))))
                   => ( tb2t(get(int,int,t2tb1(A2),t2tb(I))) = tb2t(get(int,int,t2tb1(A1),t2tb(I))) ) )
                & phase11($difference(Left,div1($difference(Right,Left),2)),Left,tb2t2(mk_array1(int,A,t2tb1(A1))),tb2t2(mk_array1(int,A,t2tb1(A2))))
                & $lesseq(0,A) )
             => ( ! [A3: map_int_int] :
                    ( ( $lesseq(0,A)
                      & ! [I: $int] :
                          ( ( tb2t(get(int,int,t2tb1(A3),t2tb(I))) = tb2t(get(int,int,t2tb1(A2),t2tb(I))) )
                         <= $less(Right,I) )
                      & ! [I: $int] :
                          ( ( tb2t(get(int,int,t2tb1(A3),t2tb(I))) = tb2t(get(int,int,t2tb1(A2),t2tb(I))) )
                         <= $lesseq(I,$difference($difference(Right,div1($difference(Right,Left),2)),$difference(Right,$difference(Right,div1($difference(Right,Left),2))))) )
                      & ( tb2t(get(int,int,t2tb1(A3),t2tb(Right))) = sum2(A2,$sum($difference($difference(Right,div1($difference(Right,Left),2)),$difference(Right,$difference(Right,div1($difference(Right,Left),2)))),1),$sum(Right,1)) )
                      & phase11($difference(Right,div1($difference(Right,Left),2)),Right,tb2t2(mk_array1(int,A,t2tb1(A2))),tb2t2(mk_array1(int,A,t2tb1(A3)))) )
                   => phase11($difference(Left,div1($difference(Right,Left),2)),Left,tb2t2(mk_array1(int,A,t2tb1(A1))),tb2t2(mk_array1(int,A,t2tb1(A3)))) )
               <= ( $less(Right,A)
                  & $lesseq($uminus(1),$difference($difference(Right,div1($difference(Right,Left),2)),$difference(Right,$difference(Right,div1($difference(Right,Left),2)))))
                  & is_power_of_21($difference(Right,$difference(Right,div1($difference(Right,Left),2))))
                  & $less($difference(Right,div1($difference(Right,Left),2)),Right)
                  & $lesseq(0,$difference(Right,div1($difference(Right,Left),2))) ) ) ) ) )
     <= ( $lesseq(0,A)
        & $less(Left,Right)
        & $less(Right,A)
        & $lesseq($uminus(1),$difference(Left,$difference(Right,Left)))
        & is_power_of_21($difference(Right,Left))
        & $lesseq(0,Left) ) ) ).

tff(div_1,axiom,
    ! [X: $int] : ( div1(X,1) = X ) ).

tff(set_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort1(map(A,B),set(B,A,X,X1,X2)) ).

tff(mod_sign_pos,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(0,X)
        & ( Y != 0 ) )
     => $lesseq(0,mod1(X,Y)) ) ).

tff(sum_transitivity,axiom,
    ! [C: map_int_int,I: $int,K: $int,J: $int] :
      ( ( sum2(C,I,J) = $sum(sum2(C,I,K),sum2(C,K,J)) )
     <= ( $lesseq(K,J)
        & $lesseq(I,K) ) ) ).

tff(is_power_of_2_1,axiom,
    ! [X: $int] :
      ( ( $less(1,X)
       => ( $product(2,div1(X,2)) = X ) )
     <= is_power_of_21(X) ) ).

tff(rounds_toward_zero,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(abs1($product(div1(X,Y),Y)),abs1(X))
     <= ( Y != 0 ) ) ).

tff(bridgeR2,axiom,
    ! [J: uni] : ( t2tb2(tb2t2(J)) = J ) ).

tff(mod_sign_neg,axiom,
    ! [X: $int,Y: $int] :
      ( $lesseq(mod1(X,Y),0)
     <= ( $lesseq(X,0)
        & ( Y != 0 ) ) ) ).

tff(bridgeL,axiom,
    ! [I: $int] : ( tb2t(t2tb(I)) = I ) ).

tff(mod_1,axiom,
    ! [X: $int] : ( mod1(X,1) = 0 ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple02] : ( U = tuple03 ) ).

tff(abs_def,axiom,
    ! [X: $int] :
      ( ( ( abs1(X) = X )
       <= $lesseq(0,X) )
      & ( ( abs1(X) = $uminus(X) )
       <= ~ $lesseq(0,X) ) ) ).

tff(bool_inversion,axiom,
    ! [U: bool1] :
      ( ( U = true1 )
      | ( U = false1 ) ) ).

tff(sum_def_non_empty,axiom,
    ! [C: map_int_int,I: $int,J: $int] :
      ( ( sum2(C,I,J) = $sum(tb2t(get(int,int,t2tb1(C),t2tb(I))),sum2(C,$sum(I,1),J)) )
     <= $less(I,J) ) ).

tff(bridgeL2,axiom,
    ! [I: array_int] : ( tb2t2(t2tb2(I)) = I ) ).

tff(power_mult2,axiom,
    ! [X: $int,Y: $int,N: $int] :
      ( ( power1($product(X,Y),N) = $product(power1(X,N),power1(Y,N)) )
     <= $lesseq(0,N) ) ).

tff(make_sort1,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),make1(A,X,X1)) ).

tff(mod_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less($uminus(abs1(Y)),mod1(X,Y))
        & $less(mod1(X,Y),abs1(Y)) )
     <= ( Y != 0 ) ) ).

tff(set_sort3,axiom,
    ! [A: ty,X: uni,X1: $int,X2: uni] : sort1(array(A),set2(A,X,X1,X2)) ).

tff(sum_def_empty,axiom,
    ! [C: map_int_int,I: $int,J: $int] :
      ( $lesseq(J,I)
     => ( sum2(C,I,J) = 0 ) ) ).

tff(get_def,axiom,
    ! [A: ty,A1: uni,I: $int] : ( get2(A,A1,I) = get(A,int,elts(A,A1),t2tb(I)) ) ).

tff(div_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( $lesseq(0,X)
        & $less(X,Y) )
     => ( div1(X,Y) = 0 ) ) ).

tff(div_bound,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less(0,Y)
        & $lesseq(0,X) )
     => ( $lesseq(div1(X,Y),X)
        & $lesseq(0,div1(X,Y)) ) ) ).

tff(array_inversion1,axiom,
    ! [A: ty,U: uni] : ( U = mk_array1(A,length1(A,U),elts(A,U)) ) ).

tff(sum_def,axiom,
    ! [A: array_int,L: $int,H: $int] : ( sum3(A,L,H) = sum2(tb2t1(elts(int,t2tb2(A))),L,H) ) ).

tff(const,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( sort1(B,B1)
     => ( get(B,A,const(B,A,B1),A1) = B1 ) ) ).

tff(phase1_frame,axiom,
    ! [Left: $int,Right: $int,A0: array_int,A: array_int,Aqt: array_int] :
      ( phase11(Left,Right,A0,Aqt)
     <= ( $lesseq(0,length1(int,t2tb2(A)))
        & $lesseq(0,length1(int,t2tb2(Aqt)))
        & phase11(Left,Right,A0,A)
        & ! [I: $int] :
            ( ( $less($difference(Left,$difference(Right,Left)),I)
              & $less(I,Right) )
           => ( tb2t(get2(int,t2tb2(A),I)) = tb2t(get2(int,t2tb2(Aqt),I)) ) )
        & $lesseq(0,length1(int,t2tb2(A0))) ) ) ).

tff(phase1_inversion,axiom,
    ! [Z: $int,Z1: $int,Z2: array_int,Z3: array_int] :
      ( ( ? [Left: $int,A0: array_int,A: array_int] :
            ( ( tb2t(get2(int,t2tb2(A),Left)) = tb2t(get2(int,t2tb2(A0),Left)) )
            & ( Z = Left )
            & ( Z1 = $sum(Left,1) )
            & ( Z3 = A )
            & ( Z2 = A0 ) )
        | ? [Left: $int,Right: $int,A0: array_int,A: array_int] :
            ( $less($sum(Left,1),Right)
            & ( Z1 = Right )
            & ( Z2 = A0 )
            & ( Z3 = A )
            & ( Z = Left )
            & ( tb2t(get2(int,t2tb2(A),Left)) = sum3(A0,$sum($difference(Left,$difference(Right,Left)),1),$sum(Left,1)) )
            & phase11(go_right1(Left,Right),Right,A0,A)
            & phase11(go_left1(Left,Right),Left,A0,A) ) )
     <= phase11(Z,Z1,Z2,Z3) ) ).

tff(phase1_frame2,axiom,
    ! [Left: $int,Right: $int,A0: array_int,A0qt: array_int,A: array_int] :
      ( phase11(Left,Right,A0qt,A)
     <= ( $lesseq(0,length1(int,t2tb2(A0qt)))
        & phase11(Left,Right,A0,A)
        & ! [I: $int] :
            ( ( tb2t(get2(int,t2tb2(A0),I)) = tb2t(get2(int,t2tb2(A0qt),I)) )
           <= ( $less(I,Right)
              & $less($difference(Left,$difference(Right,Left)),I) ) )
        & $lesseq(0,length1(int,t2tb2(A)))
        & $lesseq(0,length1(int,t2tb2(A0))) ) ) ).

tff(t2tb_sort1,axiom,
    ! [X: map_int_int] : sort1(map(int,int),t2tb1(X)) ).

tff(power_mult,axiom,
    ! [X: $int,N: $int,M: $int] :
      ( ( ( power1(X,$product(N,M)) = power1(power1(X,N),M) )
       <= $lesseq(0,M) )
     <= $lesseq(0,N) ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool1(A,true1,Z,Z1) = Z )
     <= sort1(A,Z) ) ).

tff(get_sort3,axiom,
    ! [A: ty,X: uni,X1: $int] : sort1(A,get2(A,X,X1)) ).

tff(match_bool_sort1,axiom,
    ! [A: ty,X: bool1,X1: uni,X2: uni] : sort1(A,match_bool1(A,X,X1,X2)) ).

tff(length_def1,axiom,
    ! [A: ty,U: $int,U1: uni] : ( length1(A,mk_array1(A,U,U1)) = U ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z1)
     => ( match_bool1(A,false1,Z,Z1) = Z1 ) ) ).

tff(make_def,axiom,
    ! [A: ty,N: $int,V: uni] : ( make1(A,N,V) = mk_array1(A,N,const(A,int,V)) ) ).

tff(true_False,axiom,
    true1 != false1 ).

tff(bridgeL1,axiom,
    ! [I: map_int_int] : ( tb2t1(t2tb1(I)) = I ) ).

tff(mk_array_sort1,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),mk_array1(A,X,X1)) ).

tff(const_sort1,axiom,
    ! [A: ty,B: ty,X: uni] : sort1(map(A,B),const(B,A,X)) ).

tff(select_eq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( sort1(B,B1)
     => ( ( get(B,A,set(B,A,M,A1,B1),A2) = B1 )
       <= ( A1 = A2 ) ) ) ).

tff(is_power_of_2_def,axiom,
    ! [X: $int] :
      ( ? [K: $int] :
          ( ( X = power1(2,K) )
          & $lesseq(0,K) )
    <=> is_power_of_21(X) ) ).

tff(witness_sort1,axiom,
    ! [A: ty] : sort1(A,witness1(A)) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(power_s,axiom,
    ! [X: $int,N: $int] :
      ( $lesseq(0,N)
     => ( power1(X,$sum(N,1)) = $product(X,power1(X,N)) ) ) ).

tff(node,axiom,
    ! [Left: $int,Right: $int,A0: array_int,A: array_int] :
      ( ( ( ( phase11(Left,Right,A0,A)
           <= ( tb2t(get2(int,t2tb2(A),Left)) = sum3(A0,$sum($difference(Left,$difference(Right,Left)),1),$sum(Left,1)) ) )
         <= phase11(go_right1(Left,Right),Right,A0,A) )
       <= phase11(go_left1(Left,Right),Left,A0,A) )
     <= $less($sum(Left,1),Right) ) ).

tff(power_0,axiom,
    ! [X: $int] : ( power1(X,0) = 1 ) ).

tff(go_left_def,axiom,
    ! [Left: $int,Right: $int] : ( go_left1(Left,Right) = $difference(Left,div1($difference(Right,Left),2)) ) ).

tff(elts_def1,axiom,
    ! [A: ty,U: $int,U1: uni] :
      ( ( elts(A,mk_array1(A,U,U1)) = U1 )
     <= sort1(map(int,A),U1) ) ).

tff(div_mult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( div1($sum($product(X,Y),Z),X) = $sum(Y,div1(Z,X)) )
     <= ( $lesseq(0,Y)
        & $lesseq(0,Z)
        & $less(0,X) ) ) ).

tff(mod_inf,axiom,
    ! [X: $int,Y: $int] :
      ( ( $less(X,Y)
        & $lesseq(0,X) )
     => ( mod1(X,Y) = X ) ) ).

tff(abs_pos,axiom,
    ! [X: $int] : $lesseq(0,abs1(X)) ).

tff(t2tb_sort2,axiom,
    ! [X: array_int] : sort1(array(int),t2tb2(X)) ).

tff(select_neq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( ( sort1(A,A2)
       => ! [B1: uni] :
            ( ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) )
           <= ( A1 != A2 ) ) )
     <= sort1(A,A1) ) ).

tff(get_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort1(B,get(B,A,X,X1)) ).

