tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort1: ( ty * uni ) > $o ).

tff(witness,type,
    witness1: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool1: $tType ).

tff(bool1,type,
    bool: ty ).

tff(true,type,
    true1: bool1 ).

tff(false,type,
    false1: bool1 ).

tff(match_bool,type,
    match_bool1: ( ty * bool1 * uni * uni ) > uni ).

tff(tuple0,type,
    tuple02: $tType ).

tff(tuple01,type,
    tuple0: ty ).

tff(tuple02,type,
    tuple03: tuple02 ).

tff(qtmark,type,
    qtmark: ty ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(map,type,
    map: ( ty * ty ) > ty ).

tff(get,type,
    get: ( ty * ty * uni * uni ) > uni ).

tff(set,type,
    set: ( ty * ty * uni * uni * uni ) > uni ).

tff(const1,type,
    const: ( ty * ty * uni ) > uni ).

tff(array,type,
    array: ty > ty ).

tff(mk_array,type,
    mk_array1: ( ty * $int * uni ) > uni ).

tff(length,type,
    length1: ( ty * uni ) > $int ).

tff(elts,type,
    elts: ( ty * uni ) > uni ).

tff(get1,type,
    get2: ( ty * uni * $int ) > uni ).

tff(t2tb,type,
    t2tb: $int > uni ).

tff(tb2t,type,
    tb2t: uni > $int ).

tff(set1,type,
    set2: ( ty * uni * $int * uni ) > uni ).

tff(make,type,
    make1: ( ty * $int * uni ) > uni ).

tff(map_int_int,type,
    map_int_int: $tType ).

tff(sum,type,
    sum2: ( map_int_int * $int * $int ) > $int ).

tff(t2tb1,type,
    t2tb1: map_int_int > uni ).

tff(tb2t1,type,
    tb2t1: uni > map_int_int ).

tff(array_int,type,
    array_int: $tType ).

tff(sum1,type,
    sum3: ( array_int * $int * $int ) > $int ).

tff(t2tb2,type,
    t2tb2: array_int > uni ).

tff(tb2t2,type,
    tb2t2: uni > array_int ).

tff(is_max,type,
    is_max1: ( array_int * $int * $int * $int ) > $o ).

tff(const,axiom,
    ! [A: ty,B: ty,B1: uni,A1: uni] :
      ( sort1(B,B1)
     => ( get(B,A,const(B,A,B1),A1) = B1 ) ) ).

tff(sum_transitivity,axiom,
    ! [C: map_int_int,I: $int,K: $int,J: $int] :
      ( ( $lesseq(K,J)
        & $lesseq(I,K) )
     => ( sum2(C,I,J) = $sum(sum2(C,I,K),sum2(C,K,J)) ) ) ).

tff(true_False,axiom,
    true1 != false1 ).

tff(bridgeL1,axiom,
    ! [I: map_int_int] : ( tb2t1(t2tb1(I)) = I ) ).

tff(get_sort3,axiom,
    ! [A: ty,X: uni,X1: $int] : sort1(A,get2(A,X,X1)) ).

tff(sum_eq,axiom,
    ! [C1: map_int_int,C2: map_int_int,I: $int,J: $int] :
      ( ( sum2(C1,I,J) = sum2(C2,I,J) )
     <= ! [K: $int] :
          ( ( tb2t(get(int,int,t2tb1(C1),t2tb(K))) = tb2t(get(int,int,t2tb1(C2),t2tb(K))) )
         <= ( $lesseq(I,K)
            & $less(K,J) ) ) ) ).

tff(t2tb_sort,axiom,
    ! [X: $int] : sort1(int,t2tb(X)) ).

tff(set_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni,X2: uni] : sort1(map(A,B),set(B,A,X,X1,X2)) ).

tff(length_def1,axiom,
    ! [A: ty,U: $int,U1: uni] : ( length1(A,mk_array1(A,U,U1)) = U ) ).

tff(match_bool_sort1,axiom,
    ! [A: ty,X: bool1,X1: uni,X2: uni] : sort1(A,match_bool1(A,X,X1,X2)) ).

tff(get_sort2,axiom,
    ! [A: ty,B: ty,X: uni,X1: uni] : sort1(B,get(B,A,X,X1)) ).

tff(is_max_def,axiom,
    ! [A: array_int,L: $int,H: $int,M: $int] :
      ( ( ( ( ( $less(L,H)
              & ? [K: $int] :
                  ( $lesseq(L,K)
                  & ( M = tb2t(get2(int,t2tb2(A),K)) )
                  & $less(K,H) ) )
            | ( ( M = 0 )
              & $lesseq(H,L) ) )
          & ! [K: $int] :
              ( $lesseq(tb2t(get2(int,t2tb2(A),K)),M)
             <= ( $less(K,H)
                & $lesseq(L,K) ) ) )
       <= is_max1(A,L,H,M) )
      & ( ( ! [K: $int] :
              ( $lesseq(tb2t(get2(int,t2tb2(A),K)),M)
             <= ( $less(K,H)
                & $lesseq(L,K) ) )
          & ( ( $less(L,H)
              & ? [K: $int] :
                  ( $less(K,H)
                  & ( M = tb2t(get2(int,t2tb2(A),K)) )
                  & $lesseq(L,K) ) )
            | ( ( M = 0 )
              & $lesseq(H,L) ) ) )
       => is_max1(A,L,H,M) ) ) ).

tff(const_sort1,axiom,
    ! [A: ty,B: ty,X: uni] : sort1(map(A,B),const(B,A,X)) ).

tff(witness_sort1,axiom,
    ! [A: ty] : sort1(A,witness1(A)) ).

tff(bridgeR1,axiom,
    ! [J: uni] : ( t2tb1(tb2t1(J)) = J ) ).

tff(wP_parameter_test,conjecture,
    ( ( $lesseq(0,10)
     => ( $lesseq(0,0)
        & $less(0,10)
        & ! [A: map_int_int] :
            ( ( $lesseq(0,1)
              & $less(1,10)
              & ! [A1: map_int_int] :
                  ( ( $lesseq(0,10)
                    & ( A1 = tb2t1(set(int,int,t2tb1(A),t2tb(1),t2tb(5))) ) )
                 => ( ! [A2: map_int_int] :
                        ( ( ( A2 = tb2t1(set(int,int,t2tb1(A1),t2tb(2),t2tb(0))) )
                          & $lesseq(0,10) )
                       => ( $lesseq(0,3)
                          & ! [A3: map_int_int] :
                              ( ( ! [A4: map_int_int] :
                                    ( ( ( A4 = tb2t1(set(int,int,t2tb1(A3),t2tb(4),t2tb(7))) )
                                      & $lesseq(0,10) )
                                   => ( $lesseq(0,5)
                                      & $less(5,10)
                                      & ! [A5: map_int_int] :
                                          ( ( ( A5 = tb2t1(set(int,int,t2tb1(A4),t2tb(5),t2tb(3))) )
                                            & $lesseq(0,10) )
                                         => ( $lesseq(0,6)
                                            & $less(6,10)
                                            & ! [A6: map_int_int] :
                                                ( ( ( A6 = tb2t1(set(int,int,t2tb1(A5),t2tb(6),t2tb(2))) )
                                                  & $lesseq(0,10) )
                                               => ( $lesseq(0,7)
                                                  & $less(7,10)
                                                  & ! [A7: map_int_int] :
                                                      ( ( $lesseq(0,10)
                                                        & ( A7 = tb2t1(set(int,int,t2tb1(A6),t2tb(7),t2tb(1))) ) )
                                                     => ( $less(8,10)
                                                        & ! [A8: map_int_int] :
                                                            ( ( $lesseq(0,10)
                                                              & ( A8 = tb2t1(set(int,int,t2tb1(A7),t2tb(8),t2tb(10))) ) )
                                                           => ( $lesseq(0,9)
                                                              & ! [A9: map_int_int] :
                                                                  ( ( ! [Result: $int,Result1: $int] :
                                                                        ( ( is_max1(tb2t2(mk_array1(int,10,t2tb1(A9))),0,10,Result1)
                                                                          & $lesseq(Result,$product(10,Result1))
                                                                          & ( Result = sum2(A9,0,10) ) )
                                                                       => ( ( Result = 45 )
                                                                          & ( Result1 = 10 ) ) )
                                                                    & ! [I: $int] :
                                                                        ( $lesseq(0,tb2t(get(int,int,t2tb1(A9),t2tb(I))))
                                                                       <= ( $lesseq(0,I)
                                                                          & $less(I,10) ) ) )
                                                                 <= ( ( A9 = tb2t1(set(int,int,t2tb1(A8),t2tb(9),t2tb(6))) )
                                                                    & $lesseq(0,10) ) )
                                                              & $less(9,10) ) )
                                                        & $lesseq(0,8) ) ) ) ) ) ) ) )
                                & $less(4,10)
                                & $lesseq(0,4) )
                             <= ( ( A3 = tb2t1(set(int,int,t2tb1(A2),t2tb(3),t2tb(2))) )
                                & $lesseq(0,10) ) )
                          & $less(3,10) ) )
                    & $less(2,10)
                    & $lesseq(0,2) ) ) )
           <= ( ( A = tb2t1(set(int,int,const(int,int,t2tb(0)),t2tb(0),t2tb(9))) )
              & $lesseq(0,10) ) ) ) )
    & $lesseq(0,10) ) ).

tff(bridgeR2,axiom,
    ! [J: uni] : ( t2tb2(tb2t2(J)) = J ) ).

tff(sum_right_extension,axiom,
    ! [C: map_int_int,I: $int,J: $int] :
      ( ( sum2(C,I,J) = $sum(sum2(C,I,$difference(J,1)),tb2t(get(int,int,t2tb1(C),t2tb($difference(J,1))))) )
     <= $less(I,J) ) ).

tff(sum_def_empty,axiom,
    ! [C: map_int_int,I: $int,J: $int] :
      ( ( sum2(C,I,J) = 0 )
     <= $lesseq(J,I) ) ).

tff(get_def,axiom,
    ! [A: ty,A1: uni,I: $int] : ( get2(A,A1,I) = get(A,int,elts(A,A1),t2tb(I)) ) ).

tff(elts_sort1,axiom,
    ! [A: ty,X: uni] : sort1(map(int,A),elts(A,X)) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) )
     <= $lesseq(X,Y) ) ).

tff(contents_def1,axiom,
    ! [A: ty,U: uni] :
      ( sort1(A,U)
     => ( contents(A,mk_ref(A,U)) = U ) ) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z1)
     => ( match_bool1(A,false1,Z,Z1) = Z1 ) ) ).

tff(make_def,axiom,
    ! [A: ty,N: $int,V: uni] : ( make1(A,N,V) = mk_array1(A,N,const(A,int,V)) ) ).

tff(bridgeL,axiom,
    ! [I: $int] : ( tb2t(t2tb(I)) = I ) ).

tff(set_def,axiom,
    ! [A: ty,A1: uni,I: $int,V: uni] : ( set2(A,A1,I,V) = mk_array1(A,length1(A,A1),set(A,int,elts(A,A1),t2tb(I),V)) ) ).

tff(mk_ref_sort1,axiom,
    ! [A: ty,X: uni] : sort1(ref(A),mk_ref(A,X)) ).

tff(sum_def,axiom,
    ! [A: array_int,L: $int,H: $int] : ( sum3(A,L,H) = sum2(tb2t1(elts(int,t2tb2(A))),L,H) ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( ( match_bool1(A,true1,Z,Z1) = Z )
     <= sort1(A,Z) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple02] : ( U = tuple03 ) ).

tff(sum_def_non_empty,axiom,
    ! [C: map_int_int,I: $int,J: $int] :
      ( ( sum2(C,I,J) = $sum(tb2t(get(int,int,t2tb1(C),t2tb(I))),sum2(C,$sum(I,1),J)) )
     <= $less(I,J) ) ).

tff(t2tb_sort2,axiom,
    ! [X: array_int] : sort1(array(int),t2tb2(X)) ).

tff(bridgeL2,axiom,
    ! [I: array_int] : ( tb2t2(t2tb2(I)) = I ) ).

tff(array_inversion1,axiom,
    ! [A: ty,U: uni] : ( U = mk_array1(A,length1(A,U),elts(A,U)) ) ).

tff(bool_inversion,axiom,
    ! [U: bool1] :
      ( ( U = true1 )
      | ( U = false1 ) ) ).

tff(elts_def1,axiom,
    ! [A: ty,U: $int,U1: uni] :
      ( ( elts(A,mk_array1(A,U,U1)) = U1 )
     <= sort1(map(int,A),U1) ) ).

tff(select_neq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni] :
      ( ( sort1(A,A2)
       => ! [B1: uni] :
            ( ( get(B,A,set(B,A,M,A1,B1),A2) = get(B,A,M,A2) )
           <= ( A1 != A2 ) ) )
     <= sort1(A,A1) ) ).

tff(ref_inversion1,axiom,
    ! [A: ty,U: uni] :
      ( ( U = mk_ref(A,contents(A,U)) )
     <= sort1(ref(A),U) ) ).

tff(bridgeR,axiom,
    ! [J: uni] : ( t2tb(tb2t(J)) = J ) ).

tff(make_sort1,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),make1(A,X,X1)) ).

tff(mk_array_sort1,axiom,
    ! [A: ty,X: $int,X1: uni] : sort1(array(A),mk_array1(A,X,X1)) ).

tff(contents_sort1,axiom,
    ! [A: ty,X: uni] : sort1(A,contents(A,X)) ).

tff(t2tb_sort1,axiom,
    ! [X: map_int_int] : sort1(map(int,int),t2tb1(X)) ).

tff(set_sort3,axiom,
    ! [A: ty,X: uni,X1: $int,X2: uni] : sort1(array(A),set2(A,X,X1,X2)) ).

tff(select_eq,axiom,
    ! [A: ty,B: ty,M: uni,A1: uni,A2: uni,B1: uni] :
      ( ( ( A1 = A2 )
       => ( get(B,A,set(B,A,M,A1,B1),A2) = B1 ) )
     <= sort1(B,B1) ) ).

