tff(uni,type,
    uni: $tType ).

tff(ty,type,
    ty: $tType ).

tff(sort,type,
    sort1: ( ty * uni ) > $o ).

tff(witness,type,
    witness1: ty > uni ).

tff(int,type,
    int: ty ).

tff(real,type,
    real: ty ).

tff(bool,type,
    bool1: $tType ).

tff(bool1,type,
    bool: ty ).

tff(true,type,
    true1: bool1 ).

tff(false,type,
    false1: bool1 ).

tff(match_bool,type,
    match_bool1: ( ty * bool1 * uni * uni ) > uni ).

tff(tuple0,type,
    tuple02: $tType ).

tff(tuple01,type,
    tuple0: ty ).

tff(tuple02,type,
    tuple03: tuple02 ).

tff(qtmark,type,
    qtmark: ty ).

tff(set,type,
    set: ty > ty ).

tff(mem,type,
    mem: ( ty * uni * uni ) > $o ).

tff(infix_eqeq,type,
    infix_eqeq: ( ty * uni * uni ) > $o ).

tff(subset,type,
    subset: ( ty * uni * uni ) > $o ).

tff(empty,type,
    empty: ty > uni ).

tff(is_empty,type,
    is_empty: ( ty * uni ) > $o ).

tff(add,type,
    add: ( ty * uni * uni ) > uni ).

tff(remove,type,
    remove: ( ty * uni * uni ) > uni ).

tff(union,type,
    union: ( ty * uni * uni ) > uni ).

tff(inter,type,
    inter: ( ty * uni * uni ) > uni ).

tff(diff,type,
    diff: ( ty * uni * uni ) > uni ).

tff(choose,type,
    choose: ( ty * uni ) > uni ).

tff(cardinal,type,
    cardinal1: ( ty * uni ) > $int ).

tff(vertex,type,
    vertex1: $tType ).

tff(vertex1,type,
    vertex: ty ).

tff(set_vertex,type,
    set_vertex: $tType ).

tff(succ,type,
    succ1: vertex1 > set_vertex ).

tff(path,type,
    path1: ( vertex1 * vertex1 * $int ) > $o ).

tff(t2tb,type,
    t2tb: set_vertex > uni ).

tff(tb2t,type,
    tb2t: uni > set_vertex ).

tff(t2tb1,type,
    t2tb1: vertex1 > uni ).

tff(tb2t1,type,
    tb2t1: uni > vertex1 ).

tff(shortest_path,type,
    shortest_path1: ( vertex1 * vertex1 * $int ) > $o ).

tff(ref,type,
    ref: ty > ty ).

tff(mk_ref,type,
    mk_ref: ( ty * uni ) > uni ).

tff(contents,type,
    contents: ( ty * uni ) > uni ).

tff(inv,type,
    inv1: ( vertex1 * vertex1 * set_vertex * set_vertex * set_vertex * $int ) > $o ).

tff(closure,type,
    closure1: ( set_vertex * set_vertex * set_vertex * vertex1 ) > $o ).

tff(path_inversion,axiom,
    ! [Z: vertex1,Z1: vertex1,Z2: $int] :
      ( ( ? [V: vertex1] :
            ( ( Z = V )
            & ( Z1 = V )
            & ( Z2 = 0 ) )
        | ? [V1: vertex1,V2: vertex1,V3: vertex1,N: $int] :
            ( mem(vertex,t2tb1(V3),t2tb(succ1(V2)))
            & ( Z2 = $sum(N,1) )
            & ( Z1 = V3 )
            & ( Z = V1 )
            & path1(V1,V2,N) ) )
     <= path1(Z,Z1,Z2) ) ).

tff(union_def1,axiom,
    ! [A: ty,S1: uni,S2: uni,X: uni] :
      ( ( mem(A,X,S2)
        | mem(A,X,S1) )
    <=> mem(A,X,union(A,S1,S2)) ) ).

tff(diff_sort1,axiom,
    ! [A: ty,X: uni,X1: uni] : sort1(set(A),diff(A,X,X1)) ).

tff(inv_def,axiom,
    ! [S: vertex1,T: vertex1,Visited: set_vertex,Current: set_vertex,Next: set_vertex,D: $int] :
      ( inv1(S,T,Visited,Current,Next,D)
    <=> ( subset(vertex,t2tb(Next),t2tb(Visited))
        & ! [X: vertex1] :
            ( mem(vertex,t2tb1(X),t2tb(Next))
           => shortest_path1(S,X,$sum(D,1)) )
        & ! [X: vertex1] :
            ( mem(vertex,t2tb1(X),t2tb(Visited))
           => ? [M: $int] :
                ( $lesseq(M,$sum(D,1))
                & path1(S,X,M) ) )
        & ( ( mem(vertex,t2tb1(T),t2tb(Next))
            | mem(vertex,t2tb1(T),t2tb(Current)) )
         <= mem(vertex,t2tb1(T),t2tb(Visited)) )
        & ! [X: vertex1] :
            ( shortest_path1(S,X,$sum(D,1))
           => ( mem(vertex,t2tb1(X),t2tb(Next))
              | ~ mem(vertex,t2tb1(X),t2tb(Visited)) ) )
        & ! [X: vertex1,M: $int] :
            ( ( $lesseq(M,D)
             => mem(vertex,t2tb1(X),t2tb(Visited)) )
           <= path1(S,X,M) )
        & ! [X: vertex1] :
            ( shortest_path1(S,X,D)
           <= mem(vertex,t2tb1(X),t2tb(Current)) )
        & subset(vertex,t2tb(Current),t2tb(Visited)) ) ) ).

tff(union_sort1,axiom,
    ! [A: ty,X: uni,X1: uni] : sort1(set(A),union(A,X,X1)) ).

tff(match_bool_False,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z1)
     => ( match_bool1(A,false1,Z,Z1) = Z1 ) ) ).

tff(remove_def1,axiom,
    ! [A: ty,X: uni,Y: uni,S: uni] :
      ( sort1(A,X)
     => ( sort1(A,Y)
       => ( mem(A,X,remove(A,Y,S))
        <=> ( ( X != Y )
            & mem(A,X,S) ) ) ) ) ).

tff(add_def1,axiom,
    ! [A: ty,X: uni,Y: uni] :
      ( sort1(A,X)
     => ( sort1(A,Y)
       => ! [S: uni] :
            ( ( mem(A,X,S)
              | ( X = Y ) )
          <=> mem(A,X,add(A,Y,S)) ) ) ) ).

tff(remove_sort1,axiom,
    ! [A: ty,X: uni,X1: uni] : sort1(set(A),remove(A,X,X1)) ).

tff(subset_diff,axiom,
    ! [A: ty,S1: uni,S2: uni] : subset(A,diff(A,S1,S2),S1) ).

tff(bool_inversion,axiom,
    ! [U: bool1] :
      ( ( U = false1 )
      | ( U = true1 ) ) ).

tff(remove_add,axiom,
    ! [A: ty,X: uni,S: uni] : ( remove(A,X,add(A,X,S)) = remove(A,X,S) ) ).

tff(add_sort1,axiom,
    ! [A: ty,X: uni,X1: uni] : sort1(set(A),add(A,X,X1)) ).

tff(shortest_path_def,axiom,
    ! [V1: vertex1,V2: vertex1,N: $int] :
      ( ( ! [M: $int] :
            ( ~ path1(V1,V2,M)
           <= $less(M,N) )
        & path1(V1,V2,N) )
    <=> shortest_path1(V1,V2,N) ) ).

tff(subset_refl,axiom,
    ! [A: ty,S: uni] : subset(A,S,S) ).

tff(bridgeL1,axiom,
    ! [I: vertex1] : ( tb2t1(t2tb1(I)) = I ) ).

tff(empty_sort1,axiom,
    ! [A: ty] : sort1(set(A),empty(A)) ).

tff(cardinal_remove,axiom,
    ! [A: ty,X: uni,S: uni] :
      ( mem(A,X,S)
     => ( cardinal1(A,S) = $sum(1,cardinal1(A,remove(A,X,S))) ) ) ).

tff(path_closure,axiom,
    ! [S: set_vertex] :
      ( ! [V1: vertex1,V2: vertex1,N: $int] :
          ( path1(V1,V2,N)
         => ( mem(vertex,t2tb1(V1),t2tb(S))
           => mem(vertex,t2tb1(V2),t2tb(S)) ) )
     <= ! [X: vertex1] :
          ( ! [Y: vertex1] :
              ( mem(vertex,t2tb1(Y),t2tb(S))
             <= mem(vertex,t2tb1(Y),t2tb(succ1(X))) )
         <= mem(vertex,t2tb1(X),t2tb(S)) ) ) ).

tff(compatOrderMult,axiom,
    ! [X: $int,Y: $int,Z: $int] :
      ( $lesseq(X,Y)
     => ( $lesseq(0,Z)
       => $lesseq($product(X,Z),$product(Y,Z)) ) ) ).

tff(path_succ,axiom,
    ! [V1: vertex1,V2: vertex1,V3: vertex1,N: $int] :
      ( path1(V1,V2,N)
     => ( path1(V1,V3,$sum(N,1))
       <= mem(vertex,t2tb1(V3),t2tb(succ1(V2))) ) ) ).

tff(add_remove,axiom,
    ! [A: ty,X: uni,S: uni] :
      ( ( mem(A,X,S)
       => ( add(A,X,remove(A,X,S)) = S ) )
     <= sort1(set(A),S) ) ).

tff(ref_inversion1,axiom,
    ! [A: ty,U: uni] :
      ( ( U = mk_ref(A,contents(A,U)) )
     <= sort1(ref(A),U) ) ).

tff(mk_ref_sort1,axiom,
    ! [A: ty,X: uni] : sort1(ref(A),mk_ref(A,X)) ).

tff(cardinal_add,axiom,
    ! [A: ty,X: uni,S: uni] :
      ( ~ mem(A,X,S)
     => ( cardinal1(A,add(A,X,S)) = $sum(1,cardinal1(A,S)) ) ) ).

tff(subset_trans,axiom,
    ! [A: ty,S1: uni,S2: uni,S3: uni] :
      ( subset(A,S1,S2)
     => ( subset(A,S1,S3)
       <= subset(A,S2,S3) ) ) ).

tff(empty_def1,axiom,
    ! [A: ty] : is_empty(A,empty(A)) ).

tff(cardinal1,axiom,
    ! [A: ty,S: uni] :
      ( ( cardinal1(A,S) = 1 )
     => ! [X: uni] :
          ( ( ( X = choose(A,S) )
           <= mem(A,X,S) )
         <= sort1(A,X) ) ) ).

tff(bridgeL,axiom,
    ! [I: set_vertex] : ( tb2t(t2tb(I)) = I ) ).

tff(extensionality,axiom,
    ! [A: ty,S1: uni,S2: uni] :
      ( ( ( ( S1 = S2 )
         <= infix_eqeq(A,S1,S2) )
       <= sort1(set(A),S2) )
     <= sort1(set(A),S1) ) ).

tff(inter_sort1,axiom,
    ! [A: ty,X: uni,X1: uni] : sort1(set(A),inter(A,X,X1)) ).

tff(diff_def1,axiom,
    ! [A: ty,S1: uni,S2: uni,X: uni] :
      ( mem(A,X,diff(A,S1,S2))
    <=> ( ~ mem(A,X,S2)
        & mem(A,X,S1) ) ) ).

tff(match_bool_True,axiom,
    ! [A: ty,Z: uni,Z1: uni] :
      ( sort1(A,Z)
     => ( match_bool1(A,true1,Z,Z1) = Z ) ) ).

tff(choose_sort1,axiom,
    ! [A: ty,X: uni] : sort1(A,choose(A,X)) ).

tff(path_inversion1,axiom,
    ! [V1: vertex1,V3: vertex1,N: $int] :
      ( $lesseq(0,N)
     => ( path1(V1,V3,$sum(N,1))
       => ? [V2: vertex1] :
            ( path1(V1,V2,N)
            & mem(vertex,t2tb1(V3),t2tb(succ1(V2))) ) ) ) ).

tff(true_False,axiom,
    true1 != false1 ).

tff(infix_eqeq_def,axiom,
    ! [A: ty,S1: uni,S2: uni] :
      ( ( ! [X: uni] :
            ( mem(A,X,S2)
          <=> mem(A,X,S1) )
       <= infix_eqeq(A,S1,S2) )
      & ( ! [X: uni] :
            ( sort1(A,X)
           => ( mem(A,X,S2)
            <=> mem(A,X,S1) ) )
       => infix_eqeq(A,S1,S2) ) ) ).

tff(is_empty_def,axiom,
    ! [A: ty,S: uni] :
      ( ( is_empty(A,S)
       => ! [X: uni] : ~ mem(A,X,S) )
      & ( is_empty(A,S)
       <= ! [X: uni] :
            ( ~ mem(A,X,S)
           <= sort1(A,X) ) ) ) ).

tff(wP_parameter_bfs,conjecture,
    ! [S: vertex1,T: vertex1,D: $int,Next: set_vertex,Current: set_vertex,Visited: set_vertex] :
      ( ! [O: bool1] :
          ( ( ( O != true1 )
           => ( ! [Current1: set_vertex,V: vertex1] :
                  ( ( mem(vertex,t2tb1(V),t2tb(Current))
                    & ( Current1 = tb2t(remove(vertex,t2tb1(V),t2tb(Current))) ) )
                 => ( ( V != T )
                   => ( ( inv1(S,T,Visited,Current1,Next,D)
                        & shortest_path1(S,V,D)
                        & ! [X: vertex1] :
                            ( closure1(Visited,Current1,Next,X)
                           <= ( X != V ) ) )
                     => ! [Next1: set_vertex,Visited1: set_vertex] :
                          ( ( inv1(S,T,Visited1,Current1,Next1,D)
                            & ! [X: vertex1] : closure1(Visited1,Current1,Next1,X)
                            & subset(vertex,t2tb(succ1(V)),t2tb(Visited1)) )
                         => ! [Result: bool1] :
                              ( ( is_empty(vertex,t2tb(Current1))
                              <=> ( Result = true1 ) )
                             => ( ( Result = true1 )
                               => ! [Current2: set_vertex] :
                                    ( ( Current2 = Next1 )
                                   => ! [Next2: set_vertex] :
                                        ( ! [D1: $int] :
                                            ( ( D1 = $sum(D,1) )
                                           => ! [X: vertex1] : closure1(Visited1,Current2,Next2,X) )
                                       <= ( Next2 = tb2t(empty(vertex)) ) ) ) ) ) ) ) ) )
             <= ~ is_empty(vertex,t2tb(Current)) ) )
         <= ( is_empty(vertex,t2tb(Current))
          <=> ( O = true1 ) ) )
     <= ( ( is_empty(vertex,t2tb(Next))
         <= is_empty(vertex,t2tb(Current)) )
        & ! [X: vertex1] : closure1(Visited,Current,Next,X)
        & $lesseq(0,D)
        & inv1(S,T,Visited,Current,Next,D) ) ) ).

tff(inter_def1,axiom,
    ! [A: ty,S1: uni,S2: uni,X: uni] :
      ( ( mem(A,X,S1)
        & mem(A,X,S2) )
    <=> mem(A,X,inter(A,S1,S2)) ) ).

tff(witness_sort1,axiom,
    ! [A: ty] : sort1(A,witness1(A)) ).

tff(match_bool_sort1,axiom,
    ! [A: ty,X: bool1,X1: uni,X2: uni] : sort1(A,match_bool1(A,X,X1,X2)) ).

tff(mem_empty,axiom,
    ! [A: ty,X: uni] :
      ( $false
    <=> mem(A,X,empty(A)) ) ).

tff(cardinal_nonneg,axiom,
    ! [A: ty,S: uni] : $lesseq(0,cardinal1(A,S)) ).

tff(subset_remove,axiom,
    ! [A: ty,X: uni,S: uni] : subset(A,remove(A,X,S),S) ).

tff(bridgeR,axiom,
    ! [J: uni] :
      ( ( t2tb(tb2t(J)) = J )
     <= sort1(set(vertex),J) ) ).

tff(closure_def,axiom,
    ! [Visited: set_vertex,Current: set_vertex,Next: set_vertex,X: vertex1] :
      ( closure1(Visited,Current,Next,X)
    <=> ( ( ( ~ mem(vertex,t2tb1(X),t2tb(Next))
           => ! [Y: vertex1] :
                ( mem(vertex,t2tb1(Y),t2tb(Visited))
               <= mem(vertex,t2tb1(Y),t2tb(succ1(X))) ) )
         <= ~ mem(vertex,t2tb1(X),t2tb(Current)) )
       <= mem(vertex,t2tb1(X),t2tb(Visited)) ) ) ).

tff(subset_def,axiom,
    ! [A: ty,S1: uni,S2: uni] :
      ( ( subset(A,S1,S2)
       <= ! [X: uni] :
            ( sort1(A,X)
           => ( mem(A,X,S1)
             => mem(A,X,S2) ) ) )
      & ( ! [X: uni] :
            ( mem(A,X,S1)
           => mem(A,X,S2) )
       <= subset(A,S1,S2) ) ) ).

tff(tuple0_inversion,axiom,
    ! [U: tuple02] : ( U = tuple03 ) ).

tff(choose_def,axiom,
    ! [A: ty,S: uni] :
      ( mem(A,choose(A,S),S)
     <= ~ is_empty(A,S) ) ).

tff(contents_sort1,axiom,
    ! [A: ty,X: uni] : sort1(A,contents(A,X)) ).

tff(t2tb_sort,axiom,
    ! [X: set_vertex] : sort1(set(vertex),t2tb(X)) ).

tff(path_nonneg,axiom,
    ! [V1: vertex1,V2: vertex1,N: $int] :
      ( $lesseq(0,N)
     <= path1(V1,V2,N) ) ).

tff(contents_def1,axiom,
    ! [A: ty,U: uni] :
      ( sort1(A,U)
     => ( contents(A,mk_ref(A,U)) = U ) ) ).

tff(path_empty,axiom,
    ! [V: vertex1] : path1(V,V,0) ).

tff(bridgeR1,axiom,
    ! [J: uni] :
      ( ( t2tb1(tb2t1(J)) = J )
     <= sort1(vertex,J) ) ).

tff(t2tb_sort1,axiom,
    ! [X: vertex1] : sort1(vertex,t2tb1(X)) ).

tff(cardinal_empty,axiom,
    ! [A: ty,S: uni] :
      ( is_empty(A,S)
    <=> ( cardinal1(A,S) = 0 ) ) ).

tff(cardinal_subset,axiom,
    ! [A: ty,S1: uni,S2: uni] :
      ( subset(A,S1,S2)
     => $lesseq(cardinal1(A,S1),cardinal1(A,S2)) ) ).

